!> \file hui_gnedin_atomic_rates.F90

!> \brief Module that stores the rate fits from   
!! http://adsabs.harvard.edu/abs/1997MNRAS.292...27H
!!
!! Ferland3_1e9 are fits to the data from Ferland 1992 
!! and are accurate to 2% from 3K - 1e9K
!!
!! BurgessSeaton5e3_5e5 are fits to the data from Burgess
!! and Seaton 1960 and are accurate to 10% from 5e3K - 5e5K
!!
!! Lotz1e4_1e9 are fits to the data from Lotz 1967 
!! and are accurate to 3% from 1e4K to 1e9K
!!
!! AP3e4_1e6 are fits to the data from Aldrovandi and Pequignot 1973
!! and are accurate to 5% from 3e4K to 1e6K
!!
!! Black5e3_5e5 are from Black 1981 with the correction from Cen 1992
!! and are accurate to 10% from 5e3 to 5e5
!<
module hui_gnedin_atomic_rates_mod
use myf03_mod
implicit none

! contains
! HII   recomb case A, HII   recomb cool case A
! HeII  recomb case A, HeII  recomb cool case A
! HeIII recomb case A, HeIII recomb cool case A
! HII   recomb case B, HII   recomb cool case B
! HeII  recomb case B, HeII  recomb cool case B
! HeIII recomb case B, HeIII recomb cool case B
! He dielectronic recomb, He dielectronic recomb cool 

! HI   col ion, HI   col ion cool
! HeI  col ion, HeI  col ion cool
! HeII col ion, HeII col ion cool

! HI and HII col ext cool

  real(r8b), parameter, private :: h_erg_s = 6.626068d-27      !< Plank [ergs s]
  real(r8b), parameter, private :: h_eV_s = 4.1356668d-15      !< Plank [eV s]
  real(r8b), parameter, private :: k_erg_K = 1.3806503d-16     !< Boltzman [erg/K]
  real(r8b), parameter, private :: k_eV_K = 8.6173423d-5       !< Boltzman [eV/K]
  real(r8b), parameter, private :: nu_H = 13.6d0 / h_eV_s      !< HI   thresh [Hz]
  real(r8b), parameter, private :: nu_HeI = 24.587d0 / h_eV_s  !< HeI  thresh [Hz]
  real(r8b), parameter, private :: nu_HeII = 54.416d0 / h_eV_s !< HeII thresh [Hz] 
  real(r8b), parameter, private :: T_HI = 1.57807d5   !< HI   ion thresh in K
  real(r8b), parameter, private :: T_HeI = 2.85335d5  !< HeI  ion thresh in K
  real(r8b), parameter, private :: T_HeII = 6.31515d5 !< HeII ion thresh in K
 
contains

!--------------------------------------------------
!> HII recomb rate case A [cm^3/s] - Ferland3_1e9
  function Hui_HII_recombA(T) result(rate)
    real(r8b) :: T     !< input temperature (K)
    real(r8b) :: rate  !< output rate (cm^3/s)
    real(r8b) :: lambda

    lambda = 2.d0 * T_HI / T
    rate = 1.269d-13 * lambda**1.503d0 / &
         ( 1.d0 + (lambda/0.522d0)**0.470d0 )**1.923d0

  end function Hui_HII_recombA

!-------------------------------------------------------------
!> HII recomb cooling rate case A [erg cm^3/s] - Ferland3_1e9
  function Hui_HII_rec_coolA(T) result(rate)
    real(r8b) :: T     !< input temperature (K)
    real(r8b) :: rate  !< output rate (erg cm^3 / s)
    real(r8b) :: lambda

    lambda = 2.d0 * T_HI / T
    rate = 1.778d-29 * T * lambda**1.965d0 / &
         ( 1.d0 + (lambda/0.541d0)**0.502d0 )**2.697d0
  end function Hui_HII_rec_coolA

!-----------------------------------------------------------
!> HeII recomb rate case A [cm^3/s] - BurgessSeaton5e3_5e5
  function Hui_HeII_recombA(T) result(rate)
    real(r8b) :: T     !< input temperature (K)
    real(r8b) :: rate  !< output rate (cm^3/s)
    real(r8b) :: lambda

    lambda = 2.d0 * T_HeI / T
    rate = 3.0d-14 * lambda**0.654d0 
  end function Hui_HeII_recombA

!----------------------------------------------------------------------
!> HeII recomb cooling rate case A [erg cm^3/s] - BurgessSeaton5e3_5e5
  function Hui_HeII_rec_coolA(T) result(rate)
    real(r8b) :: T     !< input temperature (K)
    real(r8b) :: rate  !< output rate (erg cm^3 / s)
 
    rate = k_erg_K * T * Hui_HeII_recombA(T) 
  end function Hui_HeII_rec_coolA

!---------------------------------------------------
!> HeIII recomb rate case A [cm^3/s] - Ferland3_1e9
  function Hui_HeIII_recombA(T) result(rate)
    real(r8b) :: T     !< input temperature (K)
    real(r8b) :: rate  !< output rate (cm^3/s)
    real(r8b) :: lambda

    lambda = 2.d0 * T_HeII / T
    rate = 2.0d0 * 1.269d-13 * lambda**1.503d0 / & 
         ( 1.d0 + (lambda/0.522d0)**0.470d0 )**1.923d0
  end function Hui_HeIII_recombA

!---------------------------------------------------------------
!> HeIII recomb cooling rate case A [erg cm^3/s] - Ferland3_1e9
  function Hui_HeIII_rec_coolA(T) result(rate)
    real(r8b) :: T     !< input temperature (K)
    real(r8b) :: rate  !< output rate (erg cm^3 / s)
    real(r8b) :: lambda

    lambda = 2.d0 * T_HeII / T
    rate = 8.0d0 * 1.778d-29 * T * lambda**1.965d0 / & 
         ( 1.d0 + (lambda/0.541d0)**0.502d0 )**2.697d0
  end function Hui_HeIII_rec_coolA

!--------------------------------------------------
!> HII recomb rate case B [cm^3/s] - Ferland3_1e9
  function Hui_HII_recombB(T) result(rate)
    real(r8b) :: T     !< input temperature (K)
    real(r8b) :: rate  !< output rate (cm^3/s)
    real(r8b) :: lambda

    lambda = 2.d0 * T_HI / T
    rate = 2.753d-14 * lambda**1.500d0 / &
         ( 1.d0 + (lambda/2.740d0)**0.407d0 )**2.242d0

  end function Hui_HII_recombB

!-------------------------------------------------------------
!> HII recomb cooling rate case B [erg cm^3/s] - Ferland3_1e9
  function Hui_HII_rec_coolB(T) result(rate)
    real(r8b) :: T     !< input temperature (K)
    real(r8b) :: rate  !< output rate (erg cm^3 / s)
    real(r8b) :: lambda

    lambda = 2.d0 * T_HI / T
    rate = 3.435d-30 * T * lambda**1.970d0 / &
         ( 1.d0 + (lambda/2.250d0)**0.376d0 )**3.720d0
  end function Hui_HII_rec_coolB

!---------------------------------------------------------------
!> HeII recomb rate case B [cm^3 s^-1] - BurgessSeaton5e3_5e5
  function Hui_HeII_recombB(T) result(rate)
    real(r8b) :: T     !< input temperature (K)
    real(r8b) :: rate  !< output rate (cm^3/s)
    real(r8b) :: lambda

    lambda = 2.d0 * T_HeI / T
    rate = 1.26d-14 * lambda**0.750d0 
  end function Hui_HeII_recombB

!---------------------------------------------------------------------
!> HeII recomb cooling rate case B [erg cm^3/s] - BurgessSeaton5e3_5e5
  function Hui_HeII_rec_coolB(T) result(rate)
    real(r8b) :: T     !< input temperature (K)
    real(r8b) :: rate  !< output rate (erg cm^3 / s)
  
    rate = k_erg_K * T * Hui_HeII_recombB(T) 
  end function Hui_HeII_rec_coolB

!---------------------------------------------------
!> HeIII recomb rate case B [cm^3/s] - Ferland3_1e9
  function Hui_HeIII_recombB(T) result(rate)
    real(r8b) :: T     !< input temperature (K)
    real(r8b) :: rate  !< output rate (cm^3/s)
    real(r8b) :: lambda
 
    lambda = 2.d0 * T_HeII / T
    rate = 2.0d0 * 2.753d-14 * lambda**1.500d0 / & 
         ( 1.d0 + (lambda/2.740d0)**0.407d0 )**2.242d0
  end function Hui_HeIII_recombB

!---------------------------------------------------------------
!> HeIII recomb cooling rate case B [erg cm^3/s] - Ferland3_1e9
  function Hui_HeIII_rec_coolB(T) result(rate)
    real(r8b) :: T     !< input temperature (K)
    real(r8b) :: rate  !< output rate (cm^3/s)
    real(r8b) :: lambda

    lambda = 2.d0 * T_HeII / T
    rate = 8.0d0 * 3.435d-30 * T * lambda**1.970d0 / & 
        ( 1.d0 + (lambda/2.250d0)**0.376d0 )**3.720d0
  end function Hui_HeIII_rec_coolB


!---------------------------------------------------------------
!> HI collisional ionization rate [cm^3/s] - Lotz1e4_1e9
  function Hui_HI_col_ion(T) result(rate)
    real(r8b) :: T     !< input temperature (K)
    real(r8b) :: rate  !< output rate (cm^3/s)
    real(r8b) :: lambda

    lambda = 2.d0 * T_HI / T
    rate = 21.11d0 * T**(-1.5) * exp(-lambda*0.5) *  & 
        lambda**(-1.089) / ( 1.d0 + (lambda/0.354d0)**0.874d0 )**1.101d0
  end function Hui_HI_col_ion

!---------------------------------------------------------------
!> HI collisional ionization cooloing rate [erg cm^3/s] - Lotz1e4_1e9
  function Hui_HI_col_ion_cool(T) result(rate)
    real(r8b) :: T     !< input temperature (K)
    real(r8b) :: rate  !< output rate (erg cm^3 / s)

    rate = k_erg_K * T_HI * Hui_HI_col_ion(T) 
  end function Hui_HI_col_ion_cool


!---------------------------------------------------------------
!> HeI collisional ionization rate [cm^3/s] - Lotz1e4_1e9
  function Hui_HeI_col_ion(T) result(rate)
    real(r8b) :: T     !< input temperature (K)
    real(r8b) :: rate  !< output rate (cm^3/s)
    real(r8b) :: lambda

    lambda = 2.d0 * T_HeI / T
    rate = 32.28d0 * T**(-1.5) * exp(-lambda*0.5) * lambda**(-1.146) / &
         ( 1.d0 + (lambda/0.416d0)**0.987d0 )**1.056d0
  end function Hui_HeI_col_ion

!---------------------------------------------------------------
!> HeI collisional ionization cooloing rate [erg cm^3/s] - Lotz1e4_1e9
  function Hui_HeI_col_ion_cool(T) result(rate)
    real(r8b) :: T     !< input temperature (K)
    real(r8b) :: rate  !< output rate (erg cm^3 / s)
 
    rate = k_erg_K * T_HeI * Hui_HeI_col_ion(T) 
  end function Hui_HeI_col_ion_cool

!---------------------------------------------------------------
!> HeII collisional ionization rate [cm^3/s] - Lotz1e4_1e9
  function Hui_HeII_col_ion(T) result(rate)
    real(r8b) :: T     !< input temperature (K)
    real(r8b) :: rate  !< output rate (cm^3/s)
    real(r8b) :: lambda

    lambda = 2.d0 * T_HeII / T
    rate = 19.65d0 * T**(-1.5) * exp(-lambda*0.5) * lambda**(-1.089) / &
         ( 1.d0 + (lambda/0.553d0)**0.735d0 )**1.275d0
  end function Hui_HeII_col_ion

!---------------------------------------------------------------
!> HeII collisional ionization cooloing rate [erg cm^3/s] - Lotz1e4_1e9
  function Hui_HeII_col_ion_cool(T) result(rate)
    real(r8b) :: T     !< input temperature (K)
    real(r8b) :: rate  !< output rate (erg cm^3 / s)
  
    rate = k_erg_K * T_HeII * Hui_HeII_col_ion(T) 
  end function Hui_HeII_col_ion_cool


!----------------------------------------------
!> He dielectronic recombination [cm^3 s^-1] - AP3e4_1e6 
  function Hui_He_dielec_recomb(T) result(rate)
    real(r8b) :: T     !< input temperature (K)
    real(r8b) :: rate  !< output rate (cm^3/s)
    real(r8b) :: lambda

    lambda = 2.0d0 * T_HeII  / T
    rate = 1.90e-3 * T**(-1.5e0) * exp(-0.75*lambda*0.5) * &
         ( 1.0e0 + 0.3e0 * exp(-0.15 * lambda * 0.5) )
  end function Hui_He_dielec_recomb
    
!---------------------------------------------------------
!>  He dielectronic recombination cooling [erg cm^3 s^-1]
  function Hui_He_dielec_recomb_cool(T) result(rate)
    real(r8b) :: T     !< input temperature (K)
    real(r8b) :: rate  !< output rate (erg cm^3 / s)

    rate = 0.75 * k_erg_K * T_HeII * Hui_He_dielec_recomb(T)            
  end function Hui_He_dielec_recomb_cool


!----------------------------------------------------------------------------
!> HI collisional excitation cooling [erg cm^3 s^-1] - Black5e3_5e5  
  function Hui_HI_col_ext_cool(T)  result(rate)
    real(r8b) :: T     !< input temperature (K)
    real(r8b) :: rate  !< output rate (erg cm^3 / s)
    real(r8b) :: lambda

    lambda = 2.0d0 * T_HI  / T
    rate = 7.5e-19  * exp(-0.75*lambda*0.5) / (1.0 + sqrt(T*1.0e-5))
  end function Hui_HI_col_ext_cool


!----------------------------------------------------------------------------
!> HeII collisional excitation cooling [erg cm^3 s^-1] - Black5e3_5e5  
  function Hui_HeII_col_ext_cool(T) result(rate) 
    real(r8b) :: T     !< input temperature (K)
    real(r8b) :: rate  !< output rate (erg cm^3 / s)
    real(r8b) :: lambda

    lambda = 2.0d0 * T_HeII  / T
    rate = 5.54e-17 * (1.0d0/T)**(0.397) * &
         exp(-0.75*lambda*0.5) / (1.0 + sqrt(T*1.0e-5))
  end function Hui_HeII_col_ext_cool


end module hui_gnedin_atomic_rates_mod

!> \file atomic_rates.F90

!> \brief the module that handles atomic rates interpolation tables

module atomic_rates_mod
use myf03_mod
use hui_gnedin_atomic_rates_mod
use cen_atomic_rates_mod
implicit none

  character(14), parameter :: ratenames(25) = &
       (/ "LogT          ",                                                        &
          "HIci          ", "HeIci         ", "HeIIci        ",                    &
          "HIIrcA        ", "HeIIrcA       ", "HeIIIrcA      ",                    &
          "HIIrcB        ", "HeIIrcB       ", "HeIIIrcB      ", "HeDrc         ",  &
          "HIIrccA       ", "HeIIrccA      ", "HeIIIrccA     ",                    &
          "HIIrccB       ", "HeIIrccB      ", "HeIIIrccB     ", "HeDrcc        ",  &
          "HIcic         ", "HeIcic        ", "HeIIcic       ", "He23cic       ",  &
          "HIcec         ", "HeIcec        ", "HeIIcec       "                     /) !< rate names


  integer(i8b), private, parameter :: RateHeaderLines = 0 !< lines in header


!> atomic rates for all processes at a single temperature
!----------------------------------------------------------
type atomic_rates_type
   real(r4b) :: logT   !< log10 temperature

   real(r4b) :: HIci      !< HI   collisional ionization rate 
   real(r4b) :: HeIci     !< HeI  collisional ionization rate 
   real(r4b) :: HeIIci    !< HeII collisional ionization rate 

   real(r4b) :: HIIrcA    !< HII   recombination rate (case A)
   real(r4b) :: HeIIrcA   !< HeII  recombination rate (case A)
   real(r4b) :: HeIIIrcA  !< HeIII recombination rate (case A)

   real(r4b) :: HIIrcB    !< HII   recombination rate (case B)
   real(r4b) :: HeIIrcB   !< HeII  recombination rate (case B)
   real(r4b) :: HeIIIrcB  !< HeIII recombination rate (case B)
   real(r4b) :: HeDrc     !< dielectronic He recombination rate   

   real(r4b) :: HIIrccA   !< HII   recombination cooling rate (case A)
   real(r4b) :: HeIIrccA  !< HeII  recombination cooling rate (case A)
   real(r4b) :: HeIIIrccA !< HeIII recombination cooling rate (case A)

   real(r4b) :: HIIrccB   !< HII   recombination cooling rate (case B)
   real(r4b) :: HeIIrccB  !< HeII  recombination cooling rate (case B)
   real(r4b) :: HeIIIrccB !< HeIII recombination cooling rate (case B)
   real(r4b) :: HeDrcc    !< dielectronic He recombination cooling rate
   
   real(r4b) :: HIcic     !< HI   collisional ionization cooling rate
   real(r4b) :: HeIcic    !< HeI  collisional ionization cooling rate
   real(r4b) :: HeIIcic   !< HeII collisional ionization cooling rate
   real(r4b) :: He23cic   !< He23 collisional ionization cooling rate
   
   real(r4b) :: HIcec     !< HI   collisional excitation cooling rate
   real(r4b) :: HeIcec    !< HeI  collisional excitation cooling rate
   real(r4b) :: HeIIcec   !< HeII collisional excitation cooling rate
end type atomic_rates_type


!> atomic rates for a single process
!------------------------------------
type atomic_rate_type
   character(14) :: source             !< reference for the rate fit
   real(r4b), allocatable :: rate(:)   !< allocate to number of temperature bins
end type atomic_rate_type


!> atomic rates table
!---------------------------
type atomic_rates_table_type

   real(r4b) :: logT1
   real(r4b) :: logT2
   integer   :: Tbins
   real(r4b) :: dlogT

   real(r4b), allocatable :: logT(:)   !< log10 temperature

   type(atomic_rate_type) :: HIci      !< HI   collisional ionization rate 
   type(atomic_rate_type) :: HeIci     !< HeI  collisional ionization rate 
   type(atomic_rate_type) :: HeIIci    !< HeII collisional ionization rate 

   type(atomic_rate_type) :: HIIrcA    !< HII   recombination rate (case A)
   type(atomic_rate_type) :: HeIIrcA   !< HeII  recombination rate (case A)
   type(atomic_rate_type) :: HeIIIrcA  !< HeIII recombination rate (case A)

   type(atomic_rate_type) :: HIIrcB    !< HII   recombination rate (case B)
   type(atomic_rate_type) :: HeIIrcB   !< HeII  recombination rate (case B)
   type(atomic_rate_type) :: HeIIIrcB  !< HeIII recombination rate (case B)
   type(atomic_rate_type) :: HeDrc     !< dielectronic He recombination rate   

   type(atomic_rate_type) :: HIIrccA   !< HII   recombination cooling rate (case A)
   type(atomic_rate_type) :: HeIIrccA  !< HeII  recombination cooling rate (case A)
   type(atomic_rate_type) :: HeIIIrccA !< HeIII recombination cooling rate (case A)

   type(atomic_rate_type) :: HIIrccB   !< HII   recombination cooling rate (case B)
   type(atomic_rate_type) :: HeIIrccB  !< HeII  recombination cooling rate (case B)
   type(atomic_rate_type) :: HeIIIrccB !< HeIII recombination cooling rate (case B)
   type(atomic_rate_type) :: HeDrcc    !< dielectronic He recombination cooling rate
   
   type(atomic_rate_type) :: HIcic     !< HI   collisional ionization cooling rate
   type(atomic_rate_type) :: HeIcic    !< HeI  collisional ionization cooling rate
   type(atomic_rate_type) :: HeIIcic   !< HeII collisional ionization cooling rate
   type(atomic_rate_type) :: He23cic   !< He23 collisional ionization cooling rate
   
   type(atomic_rate_type) :: HIcec     !< HI   collisional excitation cooling rate
   type(atomic_rate_type) :: HeIcec    !< HeI  collisional excitation cooling rate
   type(atomic_rate_type) :: HeIIcec   !< HeII collisional excitation cooling rate
      
end type atomic_rates_table_type




  
contains



  !> allocates space for a table
  !---------------------------------------------
  subroutine allocate_atomic_rates_table( table, n_bins )
    type(atomic_rates_table_type) :: table
    integer :: n_bins

    allocate( table%logT(n_bins) )

    allocate( table%HIci%rate(n_bins) )
    allocate( table%HeIci%rate(n_bins) )
    allocate( table%HeIIci%rate(n_bins) )
    
    allocate( table%HIIrcA%rate(n_bins) )
    allocate( table%HeIIrcA%rate(n_bins) )
    allocate( table%HeIIIrcA%rate(n_bins) )
    
    allocate( table%HIIrcB%rate(n_bins) )
    allocate( table%HeIIrcB%rate(n_bins) )
    allocate( table%HeIIIrcB%rate(n_bins) )
    allocate( table%HeDrc%rate(n_bins) )
    
    allocate( table%HIIrccA%rate(n_bins) )
    allocate( table%HeIIrccA%rate(n_bins) )
    allocate( table%HeIIIrccA%rate(n_bins) )
    
    allocate( table%HIIrccB%rate(n_bins) )
    allocate( table%HeIIrccB%rate(n_bins) )
    allocate( table%HeIIIrccB%rate(n_bins) )
    allocate( table%HeDrcc%rate(n_bins) )
    
    allocate( table%HIcic%rate(n_bins) )
    allocate( table%HeIcic%rate(n_bins) )
    allocate( table%HeIIcic%rate(n_bins) )
    allocate( table%He23cic%rate(n_bins) )
    
    allocate( table%HIcec%rate(n_bins) )
    allocate( table%HeIcec%rate(n_bins) )
    allocate( table%HeIIcec%rate(n_bins) )
    
  end subroutine allocate_atomic_rates_table


  !> open and read in the atomic rate file
  !---------------------------------------------
  subroutine read_atomic_rates_file(table, AtomicRatesFile)
    type(atomic_rates_table_type) :: table
    character(clen) :: AtomicRatesFile

    character(clen), parameter :: myname = "read_atomic_rates_file"
    integer, parameter :: verb=1
    logical, parameter :: crash = .true.

    integer(i4b) :: lun,err,i
    logical :: fthere
    character(14) :: tags(25)
    character(14) :: srcs(24)
    character(clen) :: str



    write(str,'(A,T27,A)') 'using rates file: ', trim(AtomicRatesFile)
    call mywrite(str, verb) 
    call mywrite('', verb)

    inquire(file=AtomicRatesFile, exist=fthere)
    if (.not. fthere) call myerr('cant find atomic rates file',myname,crash)

    call open_formatted_file_r(AtomicRatesFile,lun)
    do i = 1,RateHeaderLines
       read(lun,*)
    end do

    read(lun,*) table%logT1, table%logT2, table%Tbins, table%dlogT
    read(lun,*) tags
    read(lun,*) srcs

    table%HIci%source = srcs(1)       
    table%HeIci%source = srcs(2)      
    table%HeIIci%source = srcs(3)     
    
    table%HIIrcA%source = srcs(4)     
    table%HeIIrcA%source = srcs(5)    
    table%HeIIIrcA%source = srcs(6)   
    
    table%HIIrcB%source = srcs(7)     
    table%HeIIrcB%source = srcs(8)    
    table%HeIIIrcB%source = srcs(9)     
    table%HeDrc%source = srcs(10)      
    
    table%HIIrccA%source = srcs(11)    
    table%HeIIrccA%source = srcs(12)    
    table%HeIIIrccA%source = srcs(13)  
    
    table%HIIrccB%source = srcs(14)    
    table%HeIIrccB%source = srcs(15)   
    table%HeIIIrccB%source = srcs(16)      
    table%HeDrcc%source = srcs(17) 
    
    table%HIcic%source = srcs(18)      
    table%HeIcic%source = srcs(19)     
    table%HeIIcic%source = srcs(20)    
    table%He23cic%source = srcs(21)    
    
    table%HIcec%source = srcs(22)      
    table%HeIcec%source = srcs(23)     
    table%HeIIcec%source = srcs(24)   
    

    call allocate_atomic_rates_table( table, table%Tbins )

    do i = 1, table%Tbins

     read(lun,*) &

          table%logT(i), & 
          
          table%HIci%rate(i), &       
          table%HeIci%rate(i), &      
          table%HeIIci%rate(i), &     
          
          table%HIIrcA%rate(i), &     
          table%HeIIrcA%rate(i), &    
          table%HeIIIrcA%rate(i), &   
          
          table%HIIrcB%rate(i), &     
          table%HeIIrcB%rate(i), &    
          table%HeIIIrcB%rate(i), &     
          table%HeDrc%rate(i), &      
          
          table%HIIrccA%rate(i), &    
          table%HeIIrccA%rate(i), &    
          table%HeIIIrccA%rate(i), &  
          
          table%HIIrccB%rate(i), &    
          table%HeIIrccB%rate(i), &   
          table%HeIIIrccB%rate(i), &      
          table%HeDrcc%rate(i), & 
          
          table%HIcic%rate(i), &      
          table%HeIcic%rate(i), &     
          table%HeIIcic%rate(i), &    
          table%He23cic%rate(i), &    
          
          table%HIcec%rate(i), &      
          table%HeIcec%rate(i), &     
          table%HeIIcec%rate(i)   

  end do

 

     
  end subroutine read_atomic_rates_file











  !-------------------------------------------------------------------------------
  !> Calculates collisional ionization equilibrium for all species 
  !! at given temperature using the rates table
  subroutine calc_colion_eq_table(table, Tin, caseA, xvec)
    type(atomic_rates_table_type), intent(in) :: table
    real(r8b), intent(in) :: Tin
    logical, intent(in) :: caseA(2)
    real(r4b), intent(out) :: xvec(5)
    
    type(atomic_rates_type) :: k
    real(r8b) :: GGHI, GGHeI, GGHeII
    real(r8b) :: RRHII, RRHeII, RRHeIII
    real(r8b) :: den
    
    call get_atomic_rates(Tin, table,  k)
    
    GGHI   = k%HIci 
    GGHeI  = k%HeIci
    GGHeII = k%HeIIci
    
    if (caseA(1)) then
       RRHII   = k%HIIrcA 
    else
       RRHII   = k%HIIrcB 
    end if
    
    if (caseA(2)) then
       RRHeII  = k%HeIIrcA 
       RRHeIII = k%HeIIIrcA 
    else
       RRHeII  = k%HeIIrcB 
       RRHeIII = k%HeIIIrcB 
    end if
    
    den = (RRHII + GGHI)
    xvec(1) = RRHII / den
    xvec(2) = GGHI / den
    
    den = (RRHeII * RRHeIII + RRHeIII * GGHeI + GGHeI * GGHeII)
    xvec(3) = RRHeII * RRHeIII / den
    xvec(4) = RRHeIII * GGHeI  / den 
    xvec(5) = GGHeI * GGHeII   / den
    
  end subroutine calc_colion_eq_table
  


  !> Calculates collisional ionization equilibrium for all species 
  !! at given temperature using the fits directly
  !-------------------------------------------------------------------------------
  subroutine calc_colion_eq_fits(fit, Tin, caseA, xvec)
    character(*), intent(in) :: fit
    real(r8b), intent(in) :: Tin
    logical, intent(in) :: caseA(2)
    real(r8b), intent(out) :: xvec(5)
    
    real(r8b) :: T
    real(r8b) :: GGHI, GGHeI, GGHeII
    real(r8b) :: RRHII, RRHeII, RRHeIII
    real(r8b) :: den


    T = Tin
    
    select case(trim(fit))

       case("cen")
          GGHI   = Cen_HI_col_ion(T)
          GGHeI  = Cen_HeI_col_ion(T)
          GGHeII = Cen_HeII_col_ion(T)

          if (caseA(1)) then
             RRHII   = Cen_HII_recombA(T)
          else
             write(*,*) "no case B rates from Cen"
             stop
          end if

          if (caseA(2)) then
             RRHeII  = Cen_HeII_recombA(T)
             RRHeIII = Cen_HeIII_recombA(T)
          else
             write(*,*) "no case B rates from Cen"
             stop
          end if


       case("hui")        
          GGHI   = Hui_HI_col_ion(T)
          GGHeI  = Hui_HeI_col_ion(T)
          GGHeII = Hui_HeII_col_ion(T)
    
          if (caseA(1)) then
             RRHII   = Hui_HII_recombA(T)
          else
             RRHII   = Hui_HII_recombB(T)
          end if
    
          if (caseA(2)) then
             RRHeII  = Hui_HeII_recombA(T)
             RRHeIII = Hui_HeIII_recombA(T)
          else
             RRHeII  = Hui_HeII_recombB(T)
             RRHeIII = Hui_HeIII_recombB(T)
          end if
    
       case default

          write(*,*) "fit type ", trim(fit), " not recognized"
          stop
    
    end select


    den = (RRHII + GGHI)
    xvec(1) = RRHII / den
    xvec(2) = GGHI / den
    
    den = (RRHeII * RRHeIII + RRHeIII * GGHeI + GGHeI * GGHeII)
    xvec(3) = RRHeII * RRHeIII / den
    xvec(4) = RRHeIII * GGHeI  / den 
    xvec(5) = GGHeI * GGHeII   / den
    
  end subroutine calc_colion_eq_fits



  !--------------------------------------------------------------------
  !> takes a temperature and calculates the atomic rate table index and
  !! how far the true temperature is past the table temperature
  subroutine get_Tindx_and_Tremain(table, T, Tindx, Tremain)
    type(atomic_rates_table_type), intent(in) :: table  
    real(r8b), intent(in) :: T         !< input temperature
    integer(i8b), intent(out) :: Tindx !< atomic rate table index
    real(r8b), intent(out) :: Tremain  !< rates%(T) + Tremain = T
    real(r8b) :: Tnum
    
    if (T < 0.0) stop "T < 0.0 in get_Tindx_and_Tremain"

    if (log10(T) < table%logT1) stop "log(T) < table%logT1"

    Tnum = ( log10(T) - table%logT1 ) / table%dlogT
    Tindx = ceiling(Tnum)
    
    if (Tindx == 0) then
       Tindx = 1
       Tremain = 0.0d0
    end if
    Tremain = Tnum - (Tindx-1)
    
    if(Tindx < 1)             stop "Tindx < 1 "
    if(Tindx > table%Tbins-1) stop "Tindx > Tbins - 1 "
    
  end subroutine get_Tindx_and_Tremain




  

  !=================================
  !> get atomic rates from table 
  subroutine get_atomic_rates(T, table, k)

    real(r8b), intent(in) :: T                             !< input temperature
    type(atomic_rates_table_type), intent(in) :: table     !< interpolation table
    type(atomic_rates_type), intent(out) :: k              !< returns rates
  
    integer(i8b) :: Tindx
    real(r8b) :: Tremain, rdif

    call get_Tindx_and_Tremain(table, T, Tindx, Tremain)

    ! Collisional Ionization

    rdif = ( table%HIci%rate(Tindx+1) - table%HIci%rate(Tindx) ) * Tremain
    k%HIci = table%HIci%rate(Tindx) + rdif 
    
    rdif = ( table%HeIci%rate(Tindx+1) - table%HeIci%rate(Tindx) ) * Tremain
    k%HeIci = table%HeIci%rate(Tindx) + rdif 

    rdif = ( table%HeIIci%rate(Tindx+1) - table%HeIIci%rate(Tindx) ) * Tremain
    k%HeIIci = table%HeIIci%rate(Tindx) + rdif 

        
    ! Recombination
    
    rdif = ( table%HIIrcA%rate(Tindx+1) - table%HIIrcA%rate(Tindx) ) * Tremain
    k%HIIrcA = table%HIIrcA%rate(Tindx) + rdif 

    rdif = ( table%HIIrcB%rate(Tindx+1) - table%HIIrcB%rate(Tindx) ) * Tremain
    k%HIIrcB = table%HIIrcB%rate(Tindx) + rdif 

    rdif = ( table%HeIIrcA%rate(Tindx+1) - table%HeIIrcA%rate(Tindx) ) * Tremain
    k%HeIIrcA = table%HeIIrcA%rate(Tindx) + rdif 

    rdif = ( table%HeIIrcB%rate(Tindx+1) - table%HeIIrcB%rate(Tindx) ) * Tremain
    k%HeIIrcB = table%HeIIrcB%rate(Tindx) + rdif 

    rdif = ( table%HeIIIrcA%rate(Tindx+1) - table%HeIIIrcA%rate(Tindx) ) * Tremain
    k%HeIIIrcA = table%HeIIIrcA%rate(Tindx) + rdif 

    rdif = ( table%HeIIIrcB%rate(Tindx+1) - table%HeIIIrcB%rate(Tindx) ) * Tremain
    k%HeIIIrcB = table%HeIIIrcB%rate(Tindx) + rdif 

    rdif = (table%HeDrc%rate(Tindx+1) - table%HeDrc%rate(Tindx)) * Tremain
    k%HeDrc = table%HeDrc%rate(Tindx) + rdif 


    
    ! Recombination Cooling
    
    rdif = ( table%HIIrccA%rate(Tindx+1) - table%HIIrccA%rate(Tindx) ) * Tremain
    k%HIIrccA = table%HIIrccA%rate(Tindx) + rdif 

    rdif = ( table%HIIrccB%rate(Tindx+1) - table%HIIrccB%rate(Tindx) ) * Tremain
    k%HIIrccB = table%HIIrccB%rate(Tindx) + rdif 

    rdif = ( table%HeIIrccA%rate(Tindx+1) - table%HeIIrccA%rate(Tindx) ) * Tremain
    k%HeIIrccA = table%HeIIrccA%rate(Tindx) + rdif 

    rdif = ( table%HeIIrccB%rate(Tindx+1) - table%HeIIrccB%rate(Tindx) ) * Tremain
    k%HeIIrccB = table%HeIIrccB%rate(Tindx) + rdif 

    rdif = ( table%HeIIIrccA%rate(Tindx+1) - table%HeIIIrccA%rate(Tindx) ) * Tremain
    k%HeIIIrccA = table%HeIIIrccA%rate(Tindx) + rdif 

    rdif = ( table%HeIIIrccB%rate(Tindx+1) - table%HeIIIrccB%rate(Tindx) ) * Tremain
    k%HeIIIrccB = table%HeIIIrccB%rate(Tindx) + rdif 

    rdif = ( table%HeDrcc%rate(Tindx+1) - table%HeDrcc%rate(Tindx) ) * Tremain
    k%HeDrcc = table%HeDrcc%rate(Tindx) + rdif 

    
    ! Collisional Ionization Cooling

    rdif = ( table%HIcic%rate(Tindx+1) - table%HIcic%rate(Tindx) ) * Tremain
    k%HIcic = table%HIcic%rate(Tindx) + rdif 
    
    rdif = ( table%HeIcic%rate(Tindx+1) - table%HeIcic%rate(Tindx) ) * Tremain
    k%HeIcic = table%HeIcic%rate(Tindx) + rdif 

    rdif = ( table%HeIIcic%rate(Tindx+1) - table%HeIIcic%rate(Tindx) ) * Tremain
    k%HeIIcic = table%HeIIcic%rate(Tindx) + rdif 
    
    rdif = ( table%He23cic%rate(Tindx+1) - table%He23cic%rate(Tindx) ) * Tremain
    k%He23cic = table%He23cic%rate(Tindx) + rdif 
    
    ! Collisional Excitation Cooling
    
    rdif = ( table%HIcec%rate(Tindx+1) - table%HIcec%rate(Tindx) ) * Tremain
    k%HIcec = table%HIcec%rate(Tindx) + rdif 
    
    rdif = ( table%HeIcec%rate(Tindx+1) - table%HeIcec%rate(Tindx) ) * Tremain
    k%HeIcec = table%HeIcec%rate(Tindx) + rdif 

    rdif = ( table%HeIIcec%rate(Tindx+1) - table%HeIIcec%rate(Tindx) ) * Tremain
    k%HeIIcec = table%HeIIcec%rate(Tindx) + rdif 
    
  end subroutine get_atomic_rates


  !> writes an atomic rates table to file
  !---------------------------------------------
  subroutine write_atomic_rates_table_to_file( table, file )
    type(atomic_rates_table_type) :: table
    character(*) :: file

    character(clen) :: fmt
    integer :: j

  
    open(unit=10,file=file)

    fmt = "(2ES12.5,I8,ES12.5)"
    write(10,fmt) table%logT1, table%logT2, table%Tbins, table%dlogT
    
    fmt = "(1X,25(A))"
    write(10,fmt) ratenames
    
    write(10,fmt) &
         "              ", & 
         
         table%HIci%source, &       
         table%HeIci%source, &      
         table%HeIIci%source, &     
         
         table%HIIrcA%source, &     
         table%HeIIrcA%source, &    
         table%HeIIIrcA%source, &   
         
         table%HIIrcB%source, &     
         table%HeIIrcB%source, &    
         table%HeIIIrcB%source, &     
         table%HeDrc%source, &      
         
         table%HIIrccA%source, &    
         table%HeIIrccA%source, &    
         table%HeIIIrccA%source, &  
         
         table%HIIrccB%source, &    
         table%HeIIrccB%source, &   
         table%HeIIIrccB%source, &      
         table%HeDrcc%source, & 
         
         table%HIcic%source, &      
         table%HeIcic%source, &     
         table%HeIIcic%source, &    
         table%He23cic%source, &    
         
         table%HIcec%source, &      
         table%HeIcec%source, &     
         table%HeIIcec%source   
    
    
    fmt = "(25(ES12.5,2X))"
    
    do j = 1, table%Tbins
       write(10,fmt) &
            
            table%logT(j), & 
            
            table%HIci%rate(j), &       
            table%HeIci%rate(j), &      
            table%HeIIci%rate(j), &     
            
            table%HIIrcA%rate(j), &     
            table%HeIIrcA%rate(j), &    
            table%HeIIIrcA%rate(j), &   
            
            table%HIIrcB%rate(j), &     
            table%HeIIrcB%rate(j), &    
            table%HeIIIrcB%rate(j), &     
            table%HeDrc%rate(j), &      
            
            table%HIIrccA%rate(j), &    
            table%HeIIrccA%rate(j), &    
            table%HeIIIrccA%rate(j), &  
            
            table%HIIrccB%rate(j), &    
            table%HeIIrccB%rate(j), &   
            table%HeIIIrccB%rate(j), &      
            table%HeDrcc%rate(j), & 
            
            table%HIcic%rate(j), &      
            table%HeIcic%rate(j), &     
            table%HeIIcic%rate(j), &    
            table%He23cic%rate(j), &    
            
            table%HIcec%rate(j), &      
            table%HeIcec%rate(j), &     
            table%HeIIcec%rate(j)   
       
    end do
    
  end subroutine write_atomic_rates_table_to_file



  !> writes some table values to log file
  !---------------------------------------------
  subroutine write_atomic_rates_to_log_file( table, OutputDir )
    type(atomic_rates_table_type) :: table
    character(*) :: OutputDir
    character(clen), parameter :: myname = "write_atomic_rates_to_log"
    integer, parameter :: verb=1
    logical, parameter :: crash = .true.

    character(clen) :: logfile
    integer(i4b) :: loglun
    type(atomic_rates_type) :: k

    real(r8b) :: Tdum
    real(r8b) :: GGHI, RRHII
    real(r8b) :: GGHeI, RRHeII
    real(r8b) :: GGHeII, RRHeIII
    real(r8b) :: xHI,xHII,xHeI,xHeII,xHeIII,den

    logfile = trim(OutputDir) // '/' // 'atomic_rates.log'
    call open_formatted_file_w(logfile,loglun)

    write(loglun,'(A)') 'atomic rates header'
    write(loglun,'(A,ES12.4)') "log10 of temperature floor   = ", table%logT1
    write(loglun,'(A,ES12.4)') "log10 of temperature ceiling = ", table%logT2
    write(loglun,'(A,I5)')     "rate file entries            = ", table%Tbins
    write(loglun,'(A,ES12.4)') "log10 spacing of temperature = ", table%dlogT
    write(loglun,*)    


    ! write out characteristic rates @ T = 10,000 K
    Tdum = 1.0E4
    call get_atomic_rates(Tdum, table, k)

    100 format(A,ES12.5,A)
    101 format(A,":",T32,ES12.5,A)
    102 format(A,T15,ES12.3)

    write(loglun,*) 
    write(loglun,*) "-----------------------------------------------------------"
    write(loglun,100) "Atomic Rates @ ", Tdum," K from rate tables"
    write(loglun,*) 
    write(loglun,101) "HI Col Ion", k%HIci,   " cm^3/s"

    write(loglun,101) "HeI Col Ion", k%HeIci,  " cm^3/s"
    write(loglun,101) "HeII Col Ion", k%HeIIci, " cm^3/s"

    write(loglun,*) 
    write(loglun,101) "HII Rec (A)", k%HIIrcA,   " cm^3/s"
    write(loglun,101) "HII Rec (B)", k%HIIrcB,   " cm^3/s"
    write(loglun,*) 
    write(loglun,101) "HeII Rec (A)", k%HeIIrcA,  " cm^3/s"
    write(loglun,101) "HeII Rec (B)", k%HeIIrcB,  " cm^3/s"
    write(loglun,*) 
    write(loglun,101) "HeIII Rec (A)", k%HeIIIrcA, " cm^3/s"
    write(loglun,101) "HeIII Rec (B)", k%HeIIIrcB, " cm^3/s"
    write(loglun,*) 
    write(loglun,101) "He D Rec", k%HeDrc, "cm^3/s"
    write(loglun,*) 

    write(loglun,101) "HII Rec Cool (A)", k%HIIrccA, " ergs cm^3/s"
    write(loglun,101) "HII Rec Cool (B)", k%HIIrccB, " ergs cm^3/s"
    write(loglun,*) 
    write(loglun,101) "HeII Rec Cool (A)", k%HeIIrccA,  " ergs cm^3/s"
    write(loglun,101) "HeII Rec Cool (B)", k%HeIIrccB,  " ergs cm^3/s"
    write(loglun,*) 
    write(loglun,101) "HeIII Rec Cool (A)", k%HeIIIrccA, " ergs cm^3/s"
    write(loglun,101) "HeIII Rec Cool (B)", k%HeIIIrccB, " ergs cm^3/s"
    write(loglun,*) 
    write(loglun,101) "He D Rec Cool", k%HeDrc, "cm^3/s"
    write(loglun,*) 

    write(loglun,101) "HI Col Ion Cool", k%HIcic, " ergs cm^3/s"
    write(loglun,101) "HeI Col Ion Cool", k%HeIcic, " ergs cm^3/s"
    write(loglun,101) "HeII Col Ion Cool", k%HeIIcic, " ergs cm^3/s"
    write(loglun,101) "He 23 Col Ion Cool", k%He23cic, " ergs cm^3/s"
    write(loglun,*) 


    write(loglun,101) "HI Col Ext Cool", k%HIcec, " ergs cm^3/s"
    write(loglun,101) "HeI Col Ext Cool", k%HeIcec, " ergs cm^6/s"
    write(loglun,101) "HeII Col Ext Cool", k%HeIIcec, " ergs cm^3/s"

    write(loglun,*) 

      
    write(loglun,'(A)') "Collisional Equilibrium"
    write(loglun,*) 
      
    GGHI   = k%HIci 
    GGHeI  = k%HeIci
    GGHeII = k%HeIIci
    
    RRHII   = k%HIIrcA
    RRHeII  = k%HeIIrcA
    RRHeIII = k%HeIIIrcA
    
    den = (RRHII + GGHI)
    xHI = RRHII / den
    xHII = GGHI / den
    
    den = (RRHeII * RRHeIII + RRHeIII * GGHeI + GGHeI * GGHeII)
    xHeI   = RRHeII * RRHeIII / den
    xHeII  = RRHeIII * GGHeI  / den 
    xHeIII = GGHeI * GGHeII   / den
    
    write(loglun,*)   " CASE A"
    write(loglun,102) "xHIeq    = ", xHI
    write(loglun,102) "xHIIeq   = ", xHII
    write(loglun,102) "xHeIeq   = ", xHeI
    write(loglun,102) "xHeIIeq  = ", xHeII
    write(loglun,102) "xHeIIIeq = ", xHeIII
    write(loglun,*) 
    
    RRHII   = k%HIIrcB
    RRHeII  = k%HeIIrcB
    RRHeIII = k%HeIIIrcB
    
    den = (RRHII + GGHI)
    xHI = RRHII / den
    xHII = GGHI / den
    
    den = (RRHeII * RRHeIII + RRHeIII * GGHeI + GGHeI * GGHeII)
    xHeI   = RRHeII * RRHeIII / den
    xHeII  = RRHeIII * GGHeI  / den 
    xHeIII = GGHeI * GGHeII   / den
    
    write(loglun,*)   " CASE B"
    write(loglun,102) "xHIeq    = ", xHI
    write(loglun,102) "xHIIeq   = ", xHII
    write(loglun,102) "xHeIeq   = ", xHeI
    write(loglun,102) "xHeIIeq  = ", xHeII
    write(loglun,102) "xHeIIIeq = ", xHeIII
    write(loglun,*) 



  end subroutine write_atomic_rates_to_log_file



end module atomic_rates_mod

!> \file viewer.F90

!> \brief SPHRAY OpenGL viewer routines. 
!! 
!<

module viewermod
use particle_system_mod
use ray_mod
use raylist_mod
use opengl_gl
use opengl_glu
use opengl_glut
implicit none

private
save
public :: initViewer
public :: reset_to_init      ! initialize viewer
public :: NormalKey
public :: Idlefunc
public :: MouseClick         ! public to allow application
public :: MouseClickMotion
public :: NormalKeyUp        ! to 'take over'
public :: freeflightQ
public :: leftbuttonQ
public :: rightbuttonQ
public :: slewQ
public :: outputtext   
                                                     
integer, parameter :: MouseMovementScale=200
integer, parameter :: MouseMirror=1
real, parameter :: minSpotDistance=.001

real(kind=gldouble), parameter :: curveScale=0.02
real(kind=gldouble), parameter :: freeFlightSpeed=0.005
real(kind=gldouble), parameter :: M_PI=3.14159265358979323846_gldouble
real(kind=gldouble), dimension(3), parameter :: zero=(/0.,0.,0./)

integer(kind=glcint), parameter :: RESET = 10
integer(kind=glcint), parameter :: QUIT = 11

real, dimension(2) :: mousexyzero
integer :: npart, leftbutton=1,rightbutton=1,free_flight=0
logical :: slew=.TRUE.

real(kind=gldouble) :: scaleFactor=1.
real(kind=gldouble), dimension(3) :: cam,spot,upvector=(/0.,0.,1./),up,ri,dummy

real(kind=gldouble) :: viewangle=45.,ratio,angle
real(kind=gldouble):: nearplane=0.01,farplane=10000.
real(kind=gldouble) :: mx,my
real(kind=gldouble) :: fi=0.,theta=0.,r=1.
real(kind=gldouble),dimension(3) :: da=(/0.,0.03, 0.1/) 



real, public, parameter :: kpcunit=1.0

 contains

! state query functions
integer function freeflightQ()
  freeflightQ=free_flight
end function freeflightQ

integer function leftbuttonQ()
  leftbuttonQ=leftbutton
end function leftbuttonQ

integer function rightbuttonQ()
  rightbuttonQ=rightbutton
end function rightbuttonQ

logical function slewQ()
  slewQ=slew
end function slewQ




subroutine rotate(moving,fixed,r,fi,theta)
  real(kind=gldouble), dimension(3), intent(inout) :: moving
  real(kind=gldouble), dimension(3), intent(in) :: fixed
  real(kind=gldouble), intent(in) :: r, fi, theta
 
  moving(1)=fixed(1)+r*sin(fi)*cos(theta)
  moving(2)=fixed(2)+r*cos(fi)*cos(theta)
  moving(3)=fixed(3)+r*sin(theta)
end subroutine rotate


subroutine translate(one,two,trans)
  real(kind=gldouble), dimension(3), intent(inout) :: one,two
  real(kind=gldouble), dimension(3), intent(in) :: trans
  
  one(1)=one(1)+trans(1);two(1)=two(1)+trans(1)
  one(2)=one(2)+trans(2);two(2)=two(2)+trans(2)
  one(3)=one(3)+trans(3);two(3)=two(3)+trans(3)
end subroutine translate


function distance2(o, t)
  real(kind=gldouble), dimension(3), intent(in) :: o,t
  real(kind=gldouble) :: distance2
  distance2=(o(1)-t(1))**2+(o(2)-t(2))**2+(o(3)-t(3))**2
  return 
end function distance2


subroutine pointCamera()
  call glMatrixMode(GL_MODELVIEW)
  call glLoadIdentity()
  call gluLookAt( cam(1),      cam(2),      cam(3),     &
                  spot(1),     spot(2),     spot(3),    &
                  upvector(1), upvector(2), upvector(3) )
end subroutine pointCamera


subroutine ReshapeWindow(width, height) bind(c,name="ReshapeWindow")
  integer(kind=glint), value :: width, height
 
  if(height.LT.1) height=1_glint
  ratio=width/real(height)
  call glViewPort(0,0,width,height)
  call glMatrixMode(GL_PROJECTION)
  call glLoadIdentity()
  call gluPerspective(viewangle, ratio, nearplane, farplane)
  call pointCamera()
 
end subroutine ReshapeWindow


subroutine MouseClick(button, state, x, y) bind(c)
  integer(kind=glcint), value :: button,state,x,y 
   
  if(button.EQ.GLUT_LEFT_BUTTON) then
     if(state.EQ.GLUT_DOWN) leftbutton=0
     if(state.EQ.GLUT_UP) leftbutton=1
     mousexyzero(1)=x;mousexyzero(2)=y
     mx=0.
     my=0.
  endif
  if(button.EQ.GLUT_RIGHT_BUTTON) then
     if(state.EQ.GLUT_DOWN) rightbutton=0
     if(state.EQ.GLUT_UP) rightbutton=1
     mousexyzero(1)=x;mousexyzero(2)=y
  endif
  
end subroutine MouseClick


subroutine MouseClickMotion(x,y) bind(c)
  integer(kind=glcint), value :: x,y 
  real(kind=gldouble) :: rscl
  real(kind=gldouble),dimension(3) :: trans=(/0.,0.,0./)

  if((.NOT.(leftbutton.EQ.0)).AND.(.NOT.(rightbutton.EQ.0))) return

  if((.NOT.(leftbutton.EQ.0)).AND.(rightbutton.EQ.0)) then
     if(.NOT.slew) then
        r=r*2**((y-mousexyzero(2))/MouseMovementScale)
        if(r.LT.minSpotDistance) r=minSpotDistance
        if(r.gt.1000*scaleFactor) r=1000*scaleFactor
        call rotate(cam, spot,r,fi,theta)
     endif
     if(slew) then
        call rotate(trans,zero, &
             scaleFactor*((y-mousexyzero(2))/MouseMovementScale/2),fi,theta)
        call translate(cam,spot,trans)
     endif
  endif

  if((leftbutton.EQ.0).AND.(.NOT.(rightbutton.EQ.0))) then
     if(free_flight.EQ.1) then
        mx=mx+(x-mousexyzero(1))/MouseMovementScale
        my=my+(y-mousexyzero(2))/MouseMovementScale
        if(abs(mx).LT.0.02) mx=0.
        if(abs(my).LT.0.02) my=0.  
     endif
     if(free_flight.EQ.0) then
        fi=fi+(x-mousexyzero(1))/MouseMovementScale
        theta=theta+(y-mousexyzero(2))/MouseMovementScale
        if(theta.GT.M_PI/2.) theta=M_PI/2.-0.001
        if(theta.LT.-M_PI/2.) theta=-M_PI/2.+0.001
        if(slew) then
           call rotate(spot, cam,r,fi+M_PI,-theta)
        else
           call rotate(cam, spot,r,fi,theta)
        endif
     endif
  endif
  
  if((leftbutton.EQ.0).AND.(rightbutton.EQ.0)) then
     viewangle=viewangle*(1+(y-mousexyzero(2))/MouseMovementScale)
     if(viewangle.LT.1) viewangle=1
     if(viewangle.GT.120) viewangle=120
     call glMatrixMode(GL_PROJECTION)
     call glLoadIdentity()
     call gluPerspective(viewangle, ratio, nearplane, farplane)
  endif
  mousexyzero(1)=x;mousexyzero(2)=y;
  call pointCamera
  call glutPostRedisplay
  
end subroutine MouseClickMotion


subroutine NormalKey( key, x, y) bind(c)
  integer(kind=glcint), value :: key
  integer(kind=glcint), value :: x,y
  mx=0.;my=0.
  if(key.EQ.32) then 
     free_flight=1 
     slew=.TRUE.
  endif
  if(key.eq.113) stop
  if(key.eq.99) then
     print*,'----- view parameters -----'
     write(*,'("spot: ",3f8.2)') spot  
     write(*,'("cam: ",3f8.2)') cam
     write(*,'("dir: ",3f8.2)') spot-cam  
  endif
end subroutine NormalKey


subroutine NormalKeyUp( key, x, y) bind(c)
  integer(kind=glint), value :: key
  integer(kind=glcint), value :: x,y
  mx=0.;my=0.
  if(key.EQ.32) free_flight=0 
end subroutine NormalKeyUp


subroutine Idlefunc() bind(c)
  real(kind=gldouble),dimension(3) :: trans=(/0.,0.,0./)
end subroutine Idlefunc


recursive subroutine frame(dummy) bind(c)
  integer(kind=glint), value :: dummy
  real(kind=gldouble),dimension(3) :: trans=(/0.,0.,0./)

  if(free_flight.EQ.1) then
     call rotate(trans,zero,-freeFlightSpeed*scaleFactor,fi,theta)
     call translate(cam,spot,trans)
     if(leftbutton.EQ.0) then
        fi=fi+mx*curveScale
        theta=theta+my*curveScale
        if(theta.GT.M_PI/2.) theta=M_PI/2.-0.001
        if(theta.LT.-M_PI/2.) theta=-M_PI/2.+0.001
        call rotate(spot,cam,r,fi+M_PI,-theta)
     endif
     call pointCamera
     call glutPostRedisplay
  endif
  call glutTimerFunc(50, frame, 0)
end subroutine frame


subroutine MouseMoves( x, y)
  integer(glint) :: x,y
  
  if(free_flight.EQ.1) then
     mx=mx+(x-mousexyzero(1))/MouseMovementScale
     my=my+(y-mousexyzero(2))/MouseMovementScale
     if(abs(mx).LT.0.02) mx=0.
     if(abs(my).LT.0.02) my=0.
  endif
end subroutine MouseMoves


subroutine menu_handler(value) bind(c)
  integer(kind=glcint), value :: value
  select case(value)
  case(RESET)
     call reset_to_init
  case(QUIT)
     stop
  end select
  return
end subroutine menu_handler


subroutine reset_to_init(scale,centre)
  real,optional :: scale,centre(3)

  if(present(scale)) scaleFactor=scale
  spot(1)=0.;spot(2)=0. ;spot(3)=0.
  if(present(centre)) spot=centre

  slew=.FALSE.
  r=scaleFactor;fi=0.57;theta=0.3
  call rotate( cam,spot,r,fi,theta);
  call pointCamera
  call glutPostRedisplay 
end subroutine reset_to_init


function initViewer(scale,centre) result(menuid)
  real,optional :: scale,centre(3)
  integer(kind=glcint) :: menuid
 
  menuid = glutCreateMenu(menu_handler)
  call glutAddMenuEntry("reset to initial view",RESET)
  call glutAddMenuEntry("quit",QUIT)  
  call glutReshapeFunc( ReshapeWindow)
  call glutMousefunc( MouseClick)
  call glutMotionFunc( MouseClickMotion)
  call glutIgnoreKeyRepeat(1)
  call glutKeyboardFunc( NormalKey )
  call glutKeyboardUpFunc( NormalKeyUp)
  call glutIdleFunc( Idlefunc )
  call glutTimerFunc(50, frame, 0)
  call reset_to_init(scale,centre)
end function initViewer


subroutine outputtext(x,y,s)
  real(kind=gldouble) :: x,y
  character :: s*(*)
  character :: c
  integer :: i,lenc
  
  call glrasterpos2d(x,y)
  lenc = len(s)
  do i=1,lenc
     c = s(i:i)
     call glutbitmapcharacter(GLUT_BITMAP_HELVETICA_18,ichar(c))
  end do
end subroutine outputtext


end module viewermod








module snap_viewer
use particle_system_mod
use ray_mod
use raylist_mod
use opengl_gl
use opengl_glut
use opengl_glu

save
private
public :: initnbody
public :: display
public :: attachmenu
public :: createsubmenus
public :: IdleFunc2
public :: NormalKey2
public :: starscale
public :: starcentre
public :: starreset
public :: visible
public :: da
 
integer :: current_frame
integer, parameter :: NMAX=3000000
integer, parameter :: GAS=1,STAR=2,RAY=3,AXES=4,BOX=5
integer :: ngas,nstar,nray
real(kind=gldouble) :: boxsize,kpcboxsize,snaptime
real(kind=glfloat),dimension(3) :: da=(/0.,0., 1./) 
real(kind=glfloat),dimension(3) :: no=(/1.,0., 0./) 
!  real(kind=glfloat),dimension(3) :: da=(/.15,.075, .026/) 
!  real(kind=glfloat),dimension(3) :: no=(/1.,0., .0/) 
  
logical :: show_gas=.TRUE.,show_stars=.TRUE.,SHOW_ray=.FALSE.
logical :: show_axes=.FALSE.,show_box=.TRUE.,show_data=.TRUE.
logical :: show_brightness=.FALSE.
integer(glint) :: update_flag=0 ! 1+2+4 for gas+src+ray
integer :: show_temp=1
    
integer(glint) :: framerate=5000;
  
integer(glint), parameter:: FASTUPDATE=50,SLOWUPDATE=5000
  
real(kind=gldouble) :: top(3),bot(3)
  
character(len=200) :: string
    
contains

  
subroutine visible(state) bind(c)
  integer(glcint), value :: state
  if (state == GLUT_VISIBLE) then
     !    if(update_flag.EQ.0) call starreset(0_glint)
  else
     update_flag=0 
  endif
end subroutine visible
  
  
subroutine gaslist
use global_mod, only: psys,GV

    
real(kind=glfloat) :: xt,yt,zt,temp,dT,Tmin,Tmax,Tmid
real(kind=glfloat) :: red,green,blue,alpha_c
integer :: i,step
    
ngas=0
if (.NOT. allocated(psys%par)) return
ngas=size(psys%par)
if(.not.show_gas) return

call glNewList(1,GL_COMPILE)	
call glPointSize( 0.5_glfloat)
call glBegin(GL_POINTS)
call glColor4f(5._glfloat, .3_glfloat, .3_glfloat, 0.1_glfloat)


Tmax = 6.0
Tmin = 4.0
Tmid = 4.0
dT = Tmax-Tmin

do i=1,size(psys%par)
   
   xt=psys%par(i)%pos(1)
   yt=psys%par(i)%pos(2)
   zt=psys%par(i)%pos(3)
   
   ! temperature
   !-------------------
   if(show_temp.EQ.2) then

      temp = log10(psys%par(i)%T)
      if (temp <= Tmin) then
         temp = 0.0
      else if (temp >= Tmax) then
         temp = 1.0
      else
         temp = (temp - Tmin) / dT
      end if

      red=temp
      blue=(1.0_glfloat - temp)
      green=0.00
      alpha_c=0.1

      call glColor4f(red, green, blue, alpha_c)
   end if

   ! ionization
   !---------------
   if(show_temp.EQ.3) then
      temp = psys%par(i)%xHI 
      green = temp
      red = 1.0-temp
      blue=0.05
      if (temp < 0.5) then
         alpha_c=0.8
      else
         alpha_c=0.1
      endif
      call glColor4f(red, green, blue, alpha_c)
   endif


   ! only neutral
   !---------------
   if(show_temp.EQ.4) then
      temp = psys%par(i)%xHII 
      if (temp <= 0.5) then
         red = 0.5
         green = 0.2
         blue=0.5
         alpha_c=0.1
      else
         cycle
      endif
      call glColor4f(red, green, blue, alpha_c)
   endif


   ! only ionized
   !---------------
   if(show_temp.EQ.5) then
      temp = psys%par(i)%xHI 
      if (temp <= 0.5) then
         red = 5.0
         green = 0.3
         blue=0.3
         alpha_c=0.1
      else
         cycle
      endif
      call glColor4f(red, green, blue, alpha_c)
   endif


   call glVertex3f(xt,yt,zt)

end do

call glEnd()
call glEndList()

end subroutine gaslist
  

subroutine srclist
use global_mod, only: psys
real(kind=glfloat) :: xt,yt,zt,temp,red,green,blue,alpha_c
integer :: i,step
    
nstar=0
if(.NOT.allocated(psys%src)) return
nstar=size(psys%src)
if(.not.show_stars) return
    
call glNewList(2,GL_COMPILE)
call glPointSize( 4.5_glfloat)
call glBegin(GL_POINTS)
call glColor4f(.6_glfloat, 1._glfloat, .6_glfloat,1._glfloat)
nstar=size(psys%src)
do i=1,size(psys%src)
   xt=psys%src(i)%pos(1)
   yt=psys%src(i)%pos(2)
   zt=psys%src(i)%pos(3)
   if(show_brightness) then
      !	call glColor4f(red, green, blue,.6_glfloat)
      !	call glPointSize( (1._glfloat+3._glfloat*temp))
   end if
   call glVertex3f(xt,yt,zt)	
end do
call glEnd()
call glEndList()
    
end subroutine srclist

  
subroutine rlist
use global_mod, only: psys,globalraylist
integer :: i,pi
real(kind=glfloat) :: xt,yt,zt
    
if(.not.show_ray) return
if(.NOT.allocated(psys%par)) return
if(.NOT.allocated(globalraylist%intersection)) return
if(globalraylist%searchcell.NE.0) return

nray=globalraylist%nnb
    
call glNewList(3,GL_COMPILE)
call glPointSize( 3._glfloat)
call glBegin(GL_POINTS)
call glColor4f(1._glfloat, 1._glfloat, .5_glfloat,.8_glfloat)
do i=1,globalraylist%nnb
   pi=globalraylist%intersection(i)%pindx
   if(pi.LE.0.OR.pi.GT.ngas) exit
   xt=psys%par(pi)%pos(1)
   yt=psys%par(pi)%pos(2)
   zt=psys%par(pi)%pos(3)
   call glVertex3f(xt,yt,zt)
end do
call glEnd()
call glEndList()

end subroutine rlist

  
subroutine boxlist
    
  call glNewList(BOX,GL_COMPILE)
  call glBegin(GL_LINES)
  call glColor4f(.4_glfloat, .5_glfloat, .9_glfloat,1._glfloat)
    
  call glvertex3d(top(1),top(2),top(3))
  call glvertex3d(top(1),top(2),bot(3))
    
  call glvertex3d(top(1),top(2),top(3))
  call glvertex3d(top(1),bot(2),top(3))
    
  call glvertex3d(top(1),top(2),top(3))
  call glvertex3d(bot(1),top(2),top(3))
    
  call glvertex3d(bot(1),top(2),top(3))
  call glvertex3d(bot(1),top(2),bot(3))
    
  call glvertex3d(bot(1),top(2),top(3))
  call glvertex3d(bot(1),bot(2),top(3))
    
  call glvertex3d(top(1),bot(2),top(3))
  call glvertex3d(top(1),bot(2),bot(3))
    
  call glvertex3d(top(1),bot(2),top(3))
  call glvertex3d(bot(1),bot(2),top(3))
    
  call glvertex3d(top(1),top(2),bot(3))
  call glvertex3d(top(1),bot(2),bot(3))
  
  call glvertex3d(top(1),top(2),bot(3))
  call glvertex3d(bot(1),top(2),bot(3))
  
  call glvertex3d(bot(1),bot(2),bot(3))
  call glvertex3d(top(1),bot(2),bot(3))
  
  call glvertex3d(bot(1),bot(2),bot(3))
  call glvertex3d(bot(1),top(2),bot(3))
  
  call glvertex3d(bot(1),bot(2),bot(3))
  call glvertex3d(bot(1),bot(2),top(3))
  
  call glEnd()
  call glEndList()
  
end subroutine boxlist
  
  
function starscale() result(scale_factor)
  use global_mod, only: psys
  real :: maxcor,maxcor1,maxcor2,scale_factor
  !  real :: top(3), bot(3)
  ! schaal:
  top=psys%box%tops
  bot=psys%box%bots
  maxcor1=maxval(top)	
  maxcor2=maxval(bot)	
  if(maxcor1.le.0) maxcor1=1.
  if(maxcor2.le.0) maxcor2=1.
  maxcor=max(maxcor1,maxcor2)
  scale_factor=2*maxcor
  return
end function starscale
  

function starcentre() result(centre)
  use global_mod, only: psys
  real :: centre(3)
  top=psys%box%tops
  bot=psys%box%bots
  centre=top/2+bot/2
  return
end function starcentre


recursive subroutine starreset(dummy) bind(c)
  use global_mod
  integer(glint), value :: dummy
  call prerender()
  call glutPostRedisplay
  if(update_flag.NE.0) call glutTimerFunc( framerate, starreset, 1_glint)
end subroutine starreset
  
  
subroutine show_menu(optie) bind(c)
  integer(kind=glint), value :: optie
    
  select case (optie)
  case(1)
     show_stars=.NOT.show_stars
  case(2)
     show_gas=.NOT.show_gas
  case(3)
     show_ray=.NOT.show_ray
  case(4)
     !       call glPointParameterfvARB(GL_POINT_DISTANCE_ATTENUATION_ARB,no)
  case(5) 
     !       call glPointParameterfvARB(GL_POINT_DISTANCE_ATTENUATION_ARB,da)
  case(6)
     show_data=.NOT.show_data
  case(7)
     show_axes=.NOT.show_axes 
  case default
  end select
    
  call glutPostRedisplay
    
end subroutine show_menu

  
subroutine prop_menu(optie) bind(c)
  integer(glcint), value :: optie
  integer(glint) :: dummy,flag
    
  select case (optie)
  case(1)
     show_temp=1
  case(2)
     show_temp=2
  case(3)
     show_temp=3
  case(4)
     show_temp=4
  case(5)
     show_temp=5
  case(6)
     show_brightness=.NOT.show_brightness
  case default
     
  end select
    
  flag=update_flag
  update_flag=0
  call starreset(flag)
  update_flag=flag
  
end subroutine prop_menu

  
subroutine update_menu(optie) bind(c)
  use viewermod
  integer(glcint), value :: optie
  integer(glint) :: dummy,flag
  real :: rsize
  
  select case(optie)
     
  case(0)
     update_flag=0
  case(1)
     flag=update_flag
     update_flag=0
     if(flag.EQ.0) call starreset(0_glint)
     update_flag=flag
  case(2)
     framerate=SLOWUPDATE
     if(update_flag.EQ.0) then 
        update_flag=7  
        call starreset(0_glint)
     endif
  case(3)
     framerate=FASTUPDATE
     if(update_flag.EQ.0) then 
        update_flag=7  
        call starreset(0_glint)
     endif
  case(4)
  case(5)
  case(6)
     rsize=starscale()
     call reset_to_init(rsize,starcentre())
     da(3)=1./rsize**2*16.
     da(2)=da(3)*rsize/2.
     
     ! i added this in the hopes that it would update the new box for a new psys
     boxsize=starscale()
     kpcboxsize=boxsize*kpcunit
     da(3)=1./boxsize**2*16.
     da(2)=da(3)*boxsize/2.
     
     flag=update_flag
     update_flag=0
     call starreset(0_glint)
     update_flag=flag
  case default 
     
  end select
  
end subroutine update_menu

  
subroutine createsubmenus(i,j,k)
  integer(glcint) :: i,j,k
  
  i=glutCreateMenu(update_menu)
  call glutaddmenuentry('update scale', 6)
  call glutaddmenuentry('no updates', 0)
  call glutaddmenuentry('refresh view', 1)
  call glutaddmenuentry('slow update', 2)
  call glutaddmenuentry('fast update', 3)
  call glutaddmenuentry('update rays', 4)
  call glutaddmenuentry('update all', 5)
  
  j=glutCreateMenu(show_menu)
  call glutaddmenuentry('toggle sources', 1)
  call glutaddmenuentry('toggle gas', 2)
  call glutaddmenuentry('toggle rays', 3)
  call glutaddmenuentry('normal points', 4)
  call glutaddmenuentry('EXT points', 5)
  call glutaddmenuentry('toggle data', 6)
  call glutaddmenuentry('toggle axes', 7)
  
  k=glutCreateMenu(prop_menu)
  call glutaddmenuentry('plain', 1)
  call glutaddmenuentry('show temperature', 2)
  call glutaddmenuentry('show ionization', 3)
  call glutaddmenuentry('show only neutral', 4)
  call glutaddmenuentry('show only ionized', 5)
  call glutaddmenuentry('show luminosity', 6)
  
end subroutine createsubmenus


subroutine attachmenu(i,j,k)
  integer(glcint), intent(in) :: i,j,k
  call glutaddsubmenu('update options', i)
  call glutaddsubmenu('view options', j)
  call glutaddsubmenu('show options',k)
end subroutine attachmenu


subroutine prerender()
  integer(glint) :: flag
  call gaslist
  call srclist
  call rlist
  call boxlist
  call axeslist
end subroutine prerender


subroutine NormalKey2( key, x, y) bind(c)
  use viewermod
  integer(kind=glcint), value :: key
  integer(kind=glcint), value :: x,y
  if(key.EQ.110) then 
     ! 'N'
  endif
  if(key.EQ.112) then
     ! 'P'
  endif
  call Normalkey( key,x,y)
end subroutine NormalKey2

subroutine display bind(c)  
  call glClear(ior(GL_COLOR_BUFFER_BIT,GL_DEPTH_BUFFER_BIT))
  call glBlendFunc(GL_SRC_ALPHA,GL_ONE)
  call glDepthFunc(GL_ALWAYS)
  if( show_stars) call renderstars
  if( show_ray) call renderray
  if( show_gas) call rendergas
  
  
  call glDepthFunc(GL_LESS)
  call glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA)
  call glCallList(BOX)
  
  call glDepthFunc(GL_GEQUAL)
  call glBlendFunc(GL_ONE_MINUS_DST_ALPHA,GL_ONE)
  call glCallList(BOX)
  
  call glDepthFunc(GL_LESS)
  call glBlendFunc(GL_ONE,GL_ZERO)
  call drawtext
  
  
  
  !  call glDepthFunc(GL_LESS)
  !  call glDepthMask(.TRUE.)
  !  call glBlendFunc(GL_ONE,GL_ONE_MINUS_SRC_ALPHA)
  !  if( show_axes) call glCallList(AXES)
  !  call glCallList(BOX)
  !  if( show_axes) call glCallList(AXES)
  
  !  call glDepthMask(.FALSE.)
  !  call glDepthFunc(GL_ALWAYS)
  !  call glBlendFunc(GL_SRC_ALPHA,GL_ONE)
  !  if( show_stars) call renderstars
  !  if( show_ray) call renderray
  !  if( show_gas) call rendergas
  
  !  call glDepthMask(.TRUE.)
  !  call glDepthFunc(GL_LESS)
  !  call glBlendFunc(GL_ONE,GL_ZERO)
  !  call drawtext
  call glutSwapBuffers();
end subroutine display

  
subroutine IdleFunc2  
end subroutine Idlefunc2
  

subroutine rendergas
  call glCallList(GAS)
end subroutine rendergas

  
subroutine renderstars
  call glCallList(STAR)
end subroutine renderstars

  
subroutine renderray
  call glCallList(RAY)
end subroutine renderray


subroutine axeslist
  
  call glNewList(AXES,GL_COMPILE)
  call glPushMatrix
  call glScaled(boxsize/3,boxsize/3,boxsize/3)
  call glColor4f(.2_glfloat, 1._glfloat, .2_glfloat,.8_glfloat)
  call glBegin(GL_LINES)
  call glVertex3f(-2.0_glfloat,0.0_glfloat,0.0_glfloat)
  call glVertex3f(2.0_glfloat,0.0_glfloat,0.0_glfloat)
  call glVertex3f(0.0_glfloat,-2.0_glfloat,0.0_glfloat)
  call glVertex3f(0.0_glfloat,2.0_glfloat,0.0_glfloat)
  call glVertex3f(0.0_glfloat,0.0_glfloat,-2.0_glfloat)
  call glVertex3f(0.0_glfloat,0.0_glfloat,2.0_glfloat)
  
  ! Draw crude x, y and z to label the axes
  
  call glVertex3f(2.1_glfloat,-0.1_glfloat,0.1_glfloat) ! X
  call glVertex3f(2.1_glfloat,0.1_glfloat,-0.1_glfloat)
  call glVertex3f(2.1_glfloat,-0.1_glfloat,-0.1_glfloat)
  call glVertex3f(2.1_glfloat,0.1_glfloat,0.1_glfloat)
  call glVertex3f(0.1_glfloat,2.1_glfloat,0.1_glfloat) ! Y
  call glVertex3f(0.0_glfloat,2.1_glfloat,0.0_glfloat)
  call glVertex3f(-0.1_glfloat,2.1_glfloat,0.1_glfloat)
  call glVertex3f(0.1_glfloat,2.1_glfloat,-0.1_glfloat)
  call glVertex3f(-0.1_glfloat,0.1_glfloat,2.1_glfloat) ! Z
  call glVertex3f(0.1_glfloat,0.1_glfloat,2.1_glfloat)
  call glVertex3f(0.1_glfloat,0.1_glfloat,2.1_glfloat)
  call glVertex3f(-0.1_glfloat,-0.1_glfloat,2.1_glfloat)
  call glVertex3f(-0.1_glfloat,-0.1_glfloat,2.1_glfloat)
  call glVertex3f(0.1_glfloat,-0.1_glfloat,2.1_glfloat)
  call glEnd
  
  call glPopMatrix
  
  call glEndList
  
end subroutine axeslist

  
subroutine itos(i,n,s)
  integer,intent(in) :: i,n
  character(len=n), intent(inout) :: s
  character(len=11) :: nstring
  data nstring/'0123456789X'/
  integer :: j,k,l
  
  if(i.LT.0.OR.i.GE.10**n) then
     do k=1,n
        s(k:k)=nstring(11:11)
     enddo
     return
  endif
  j=1
  do k=1,n
     l=1+mod(i,10*j)/j
     s(n-k+1:n-k+1)=nstring(l:l)
     j=j*10
  enddo
  
end subroutine itos


subroutine drawtext
  use global_mod, only: GV, PLAN
  use viewermod
  character*3 rs3
  character*8 rs
  character*10 rs10
  integer(kind=glint) :: viewport(4),rayn
  real(kind=gldouble) :: xp1,xp2,yp1,yp2
  
  if(.not.show_data) return
  call glGetIntegerv(GL_VIEWPORT,viewport)
  xp1=viewport(1)
  yp1=viewport(2)
  xp2=viewport(3)
  yp2=viewport(4) 
  call glmatrixmode(GL_PROJECTION)  
  call glPushMatrix
  call glLoadIdentity
  call glortho(xp1,xp2,yp1,yp2,-1._gldouble,1._gldouble) 
  call glmatrixmode(GL_MODELVIEW)
  call glPushMatrix
  call glLoadIdentity
  call glColor4f(0.0_glfloat,.5_glfloat,1.0_glfloat,0.5_glfloat)
  if(yp2-yp1.gt.120) then
     if(xp2-xp1.gt.320) then
        write(rs,'(f8.3)') GV%time_elapsed_myr
        call outputtext(xp1+3._gldouble,yp1+3._gldouble,'time elapsed (Myr):'//rs)
        
        write(rs,'(f8.2)') top(1)-bot(1)
        call outputtext(xp2-156._gldouble,yp1+3._gldouble,'box (Mpc):'//rs)
     endif
     
     if(xp2-xp1.gt.360) then
        !  write(rs,'(I10)') nbodies-nstar-nsph
        call itos(nray,8,rs)
        call outputtext(xp1+3._gldouble,yp2-20._gldouble,'in ray:')
        if(.not.show_ray) call glColor4f(0.4_glfloat,0.4_glfloat,0.4_glfloat,0.5_glfloat)
        call outputtext(xp1+70._gldouble,yp2-20._gldouble,rs)
        call glColor4f(0._glfloat,.6_glfloat,1.0_glfloat,0.8_glfloat)
        
        call itos(ngas,8,rs)
        call outputtext(xp1+3._gldouble,yp2-40._gldouble,'gas:')
        if(.not.show_gas) call glColor4f(0.4_glfloat,0.4_glfloat,0.4_glfloat,0.5_glfloat)
        call outputtext(xp1+70._gldouble,yp2-40._gldouble,rs)
        call glColor4f(0._glfloat,.6_glfloat,1.0_glfloat,0.8_glfloat)
        
        call itos(nstar,8,rs)
        call outputtext(xp1+3._gldouble,yp2-60._gldouble,'srcs:')
        if(.not.show_stars) call glColor4f(0.4_glfloat,.4_glfloat,.4_glfloat,0.5_glfloat)
        call outputtext(xp1+70._gldouble,yp2-60._gldouble,rs)
        
        rayn=GV%rayn
        call itos(rayn,10,rs10)
        !    write(rs10,'(i10)') GV%rayn
        call outputtext(xp2-204._gldouble,yp2-20._gldouble,rs10//' rays traced')
        !    call outputtext(xp1+108._gldouble,yp1-20._gldouble,rs10)
        write(rs3,'(i3)') int(100.*GV%rayn/real(PLAN%snap(GV%CurSnapNum)%SrcRays))
        call outputtext(xp2-54._gldouble,yp2-40._gldouble,rs3//'%')
        
        
     endif
  endif
  call glPopMatrix
  call glmatrixmode(GL_PROJECTION)
  call glPopMatrix
  call glmatrixmode(GL_MODELVIEW)
end subroutine drawtext


function initnbody()
  use global_mod, only: psys
  real :: initnbody
  real, parameter :: kpcunit=1.0
  
  ! while wait
  do while(.not.allocated(psys%par))
  enddo
  
  
  boxsize=starscale()
  kpcboxsize=boxsize*kpcunit
  initnbody=boxsize
  da(3)=1./initnbody**2*16.
  da(2)=da(3)*initnbody/2.
  
  call prerender()
  
end function initnbody

end module snap_viewer











subroutine pt_setup
end subroutine pt_setup



subroutine viewbodies
use ray_mod
use raylist_mod
  use viewermod
  use opengl_gl
  use opengl_glut
  use opengl_glu
  use snap_viewer
  implicit none
  
  real :: rsize
  integer(glcint) :: i,j,k,flag
  integer(glcint) :: win,menu
  character(len=200) :: string
  
  call glutInit()
  call glutInitDisplayMode(ior(GLUT_DEPTH,ior(GLUT_RGBA,GLUT_DOUBLE)))
  !  call glutInitDisplayMode(ior(GLUT_DOUBLE,ior(GLUT_RGB,GLUT_DEPTH)))
  
  call glutInitWindowPosition(100,100)
  call glutInitWindowSize(600,600)
  
  string="please, don't close me.."
  win=glutCreateWindow(string)
  
  
  call createsubmenus(i,j,k)
  
  rsize=initnbody()
  
  menu=initViewer(rsize,starcentre()) 
  ! NB
  call glutKeyboardFunc( NormalKey2 )
  ! NB (in initnbody?)
  call glutAttachMenu(GLUT_MIDDLE_BUTTON)
  call attachmenu(i,j,k)
  call glutDisplayFunc(display)
  
  call glEnable(GL_DEPTH_TEST)
  call glEnable(GL_BLEND)
  call glBlendFunc(GL_SRC_ALPHA,GL_ONE)
  call glEnable(GL_POINT_SMOOTH)
  call glEnable(GL_LINE_SMOOTH)
  call glHint(GL_LINE_SMOOTH_HINT, GL_NICEST)
  call glHint(GL_POINT_SMOOTH_HINT, GL_NICEST)
  call glLineWidth(1.55_glfloat)
  !  call glPointParameterfvARB(GL_POINT_DISTANCE_ATTENUATION_ARB,da)
  !  call glPointParameterfARB(GL_POINT_SIZE_MIN_ARB, 1._glfloat) 
  !  call glPointParameterfARB(GL_POINT_FADE_THRESHOLD_SIZE_ARB, 0._glfloat) 
  call glutVisibilityFunc(visible)
  
  call glutTimerFunc(100, starreset,0_glint)
  
  call glutMainLoop()
  
end subroutine viewbodies

!> \file initialize.F90 

!> \brief Initialization module
!! 
!! This Module Contains the subroutines to initialize all of the non  
!! particle system variables.     
!<
module initialize_mod
use myf03_mod
use gadget_general_class
use config_mod, only: read_config_file
use mt19937_mod, only: init_mersenne_twister
use b2cd_mod, only: read_b2cd_file
use spectra_mod, only: read_spectra_file
use atomic_rates_mod, only: read_atomic_rates_file, get_atomic_rates 
use atomic_rates_mod, only: write_atomic_rates_to_log_file
use iliev_comparison_project_mod, only: initialize_iliev_tests
use main_input_mod, only: get_planning_data
use global_mod, only: GV, PLAN, rtable, xHII_k, cmbT_k, isoT_k
use particle_system_mod, only: return_bytes_per_particle
use particle_system_mod, only: return_bytes_per_source
implicit none




  contains

!> Main initialization routine
!---------------------------------
subroutine initialize(config_file)

  character(clen), intent(in) :: config_file !< configuration file
  
  ! these subroutines are in other files 
  ! indicated in the use statements above

  call read_config_file(config_file)

  call init_mersenne_twister(GV%IntSeed)
  call read_b2cd_file(GV%b2cdFile)
  call read_spectra_file(GV%SpectraFile)

  call read_atomic_rates_file(rtable, GV%AtomicRatesFile)
  call write_atomic_rates_to_log_file(rtable, GV%OutputDir)

  call get_atomic_rates(1.0d4, rtable, xHII_k)
  if (GV%IsoTemp > 0.0) then
     call get_atomic_rates(GV%IsoTemp, rtable, isoT_k)
  end if

  call initialize_iliev_tests()

  call get_planning_data()

  call do_output_planning()

  call do_ray_planning()

  call initialize_global_variables()
          
end subroutine initialize






  
!-----------------------------------------------------------------------------
!> Plans output times.  For a single snapshot (static field) this 
!! amounts to setting the start time to the value in the particle header 
!! and the run time to the value in the config file.  
!! For multiple snapshots this amounts to using the times (or scale factors
!! for cosmological runs) in the headers to plan the raytracing such that
!! the time represented by the snapshot will be in the middle of the raytracing
!! block.  Note that this means that the time can start negative if the 
!! initial snapshot has t=0.  

subroutine do_output_planning()

  character(clen), parameter :: myname="do_output_planning"
  logical, parameter :: crash=.true.
  integer, parameter :: verb=2
  character(clen) :: str

  integer(i8b) :: i
  integer(i8b) :: Ni, Nf
  logical :: fthere
  integer(i4b) :: lun

  type(gadget_constants_type) :: gconst

  call mywrite("   doing output planning",verb) 
  
  Ni = GV%StartSnapNum
  Nf = GV%EndSnapNum

  GV%Nsnaps = Nf - Ni + 1
  
  ! At this point TimeAt, ScalefacAt, and SrcRays should have been readin.
  ! It is important that the times in the particle headers be correct.  
  ! * single snapshot runs  
  !   ** start time - particle header
  !   ** total time - config file 
  ! * multiple snapshot runs 
  !   ** cosmological (Comoving=true in config file)
  !       scale factors are used to calculate start time and sim time
  !   ** newtonian (Comoving=false in config file)
  !       time in particle headers are used to calculate start time and 
  !       sim time
  

  ! convert static field sim time to code time if need be
  !-------------------------------------------------------
  if ( trim(GV%StaticSimTimeUnit) == "myr" ) then
     GV%StaticFieldSimTime = GV%StaticFieldSimTime * gconst%sec_per_megayear ! [s]
     GV%StaticFieldSimTime = GV%StaticFieldSimTime * GV%LittleH              ! [s/h]
     GV%StaticFieldSimTime = GV%StaticFieldSimTime / GV%cgs_time             ! [code]
  end if
  

  ! for a single snapshot
  !-----------------------
  if (GV%Nsnaps==1) then          

     PLAN%snap(Ni)%RunTime   = GV%StaticFieldSimTime    ! from config
     PLAN%snap(Ni)%StartTime = PLAN%snap(Ni)%TimeAt     ! from header

     GV%TotalSimTime = GV%StaticFieldSimTime            ! from config

  ! for multiple snapshots
  !------------------------
  else if (GV%Nsnaps/=1) then    


     ! calculate code time between snapshots
     !----------------------------------------
     do i = Ni, Nf-1
        PLAN%snap(i)%TimeToNext = PLAN%snap(i+1)%TimeAt - PLAN%snap(i)%TimeAt
     end do

     ! figure out the amount of time each snapshot should be raytraced.
     !-----------------------------------------------------------------
     PLAN%snap(Ni)%RunTime = PLAN%snap(Ni)%TimeToNext   ! for 1st
     PLAN%snap(Nf)%RunTime = PLAN%snap(Nf-1)%TimeToNext ! and last
     do i = Ni+1, Nf-1
        PLAN%snap(i)%RunTime = 0.5 *(PLAN%snap(i-1)%TimeToNext + PLAN%snap(i)%TimeToNext)
     end do
     GV%TotalSimTime = sum(PLAN%snap(:)%RunTime)
     
     ! figure out starting times for each snap (different than TimeAt) 
     ! snap(i)%StartTime + 0.5 * snap(i)%RunTime = snap(i)%TimeAt
     !---------------------------------------------------------------------
     PLAN%snap(Ni)%StartTime = PLAN%snap(Ni)%TimeAt - (0.5 * PLAN%snap(Ni)%RunTime) 
     do i = Ni+1, Nf
        PLAN%snap(i)%StartTime = PLAN%snap(i-1)%StartTime + PLAN%snap(i-1)%RunTime
     end do
     
  end if


  ! output planning ! 
  !-----------------!
  GV%OutputIndx = 1 
  
  ! == for standard output == 
  if (trim(GV%OutputTiming)=="standard") then
     GV%NumTotOuts = GV%NumStdOuts
     allocate( PLAN%OutputTimes(1:GV%NumTotOuts) )
     do i = 1,GV%NumTotOuts
        PLAN%OutputTimes(i) = PLAN%snap(Ni)%StartTime + i * GV%TotalSimTime / GV%NumTotOuts
     end do
     PLAN%OutputTimes(GV%NumTotOuts) = PLAN%snap(Ni)%StartTime + GV%TotalSimTime

     
  ! == for forced output == 
  else if (trim(GV%OutputTiming)=="forced") then
     inquire(file=GV%ForcedOutFile,exist=fthere)
     if (.not. fthere) then
        str = "  cannot find forced output times file: " // trim(GV%ForcedOutFile)
        call myerr(str,myname,crash)
     end if
     call open_formatted_file_r(GV%ForcedOutFile,lun)
     read(lun,*) GV%NumTotOuts
     allocate( PLAN%OutputTimes(GV%NumTotOuts) )
     do i = 1,GV%NumTotOuts
        read(lun,*) PLAN%OutputTimes(i)
     end do
     close(lun)

     ! convert forced output times to code units if need be
     !------------------------------------------------------
     if ( trim(GV%ForcedUnits) == "myr" ) then
        PLAN%OutputTimes = PLAN%OutputTimes * gconst%sec_per_megayear  ! [s]
        PLAN%OutputTimes = PLAN%OutputTimes * GV%LittleH               ! [s/h]
        PLAN%OutputTimes = PLAN%OutputTimes / GV%cgs_time              ! [code]
     end if

  end if   


  GV%outplan_file = trim(GV%OutputDir) // "/" // "output_planning.log"
  call open_formatted_file_w(GV%outplan_file,lun)
  write(lun,'(A,A,A)') "planning output times (OutputTiming = ", trim(GV%OutputTiming), ")"
  
  write(lun,'(A,I3,A)') "SPHRAY will generate", GV%NumTotOuts, " full outputs"
  if (GV%DoInitialOutput) write(lun,'(A)') "plus one initial full output"
  write(lun,*) 

  write(lun,*) "start time [code]: ", PLAN%snap(Ni)%StartTime
  write(lun,*) "start time [Myr]:  ", PLAN%snap(Ni)%StartTime * GV%cgs_time / GV%LittleH / gconst%sec_per_megayear
  write(lun,*)

  105 format (T3,A,I3.3,A,T20,ES12.5,T40,ES12.5)    
  110 format(T20,A,T40,A)
  write(lun,110) "(code units)", "(Myrs)"
  do i = GV%OutputIndx,GV%NumTotOuts
     write(lun,105) "output ", i, " : ", PLAN%OutputTimes(i), &
                                            PLAN%OutputTimes(i) * GV%cgs_time / GV%LittleH / gconst%sec_per_megayear
  end do

  write(lun,*)
  write(lun,*) "total simulation time [code] = ", GV%TotalSimTime
  write(lun,*) "total simulation time [Myr]  = ", GV%TotalSimTime * GV%cgs_time / GV%LittleH / gconst%sec_per_megayear

  GV%outplanlun = lun
  close(lun)
    
end subroutine do_output_planning

!-------------------------------------------------------------
!> determine the number of rays to be traced in each snapshot. 
subroutine do_ray_planning()

  character(clen), parameter :: myname="do_ray_planning"
  logical, parameter :: crash=.true.
  integer, parameter :: verb=2

  integer(i8b) :: i
  real(r8b) :: code2Myr
  integer(i4b) :: lun

  type(gadget_constants_type) :: gconst

  call mywrite("   doing raytracing planning",verb) 


  code2Myr = GV%cgs_time / GV%LittleH / gconst%sec_per_megayear

  GV%rayplan_file = trim(GV%OutputDir) // "/" // "raytracing_planning.log"
  call open_formatted_file_w(GV%rayplan_file,lun)


  if (trim(GV%RayScheme)=="header") then
     ! this works for multiple snapshots.  the number of rays to trace
     ! has already been read from the source files
     write(lun,*) "RayScheme in cofig file = ", trim(GV%RayScheme)
     write(lun,*) "Using ray numbers in source file header(s)"
     PLAN%snap(:)%SrcRays = PLAN%snap(:)%RaysFromSrcHeader

  else if(trim(GV%RayScheme)=="raynum") then
     if (GV%StartSnapNum==GV%EndSnapNum) then ! static field simulation
        PLAN%snap(GV%StartSnapNum)%SrcRays = GV%ForcedRayNumber
     else if (GV%StartSnapNum/=GV%EndSnapNum) then ! multiple snapshots
        write(*,*) "ForcedRayNumber ray planning for multiple snapshot runs "
        write(*,*) "not supported yet.  Please specify the number of rays "
        write(*,*) "in the source file headers and set RayScheme = 'header' "
        write(*,*) "in the config file.  Ideally the number of rays should"
        write(*,*) "be proportional to the total luminosity of the snapshot"
        stop
        ! use physical snapshot times and total luminosities to distribute 
        ! the rays to the snapshots so that each ray will have roughly the
        ! same energy
     end if

  else
     write(*,*) "keyword RayScheme not specefied correctly"
     write(*,*) "RayScheme = ", trim(GV%RayScheme)
     write(*,*) "please edit the config file. "
     stop
  end if


  99 format(A,I3,4A,L5,A)
  write(lun,99) "ray planning: snapshots = ", GV%Nsnaps, &
                   " (RayScheme = ", trim(GV%RayScheme),")", &
                   " (Comoving =", GV%Comoving,")"

  write(lun,*) 
  write(lun,*) 



  100 format(A,  T8,A,      T22,A,      T36,A,      T50,A,      T64,A)
  101 format(I3, T8,ES13.6, T22,ES13.6, T36,ES13.6, T50,ES13.6, T64,ES13.6)

  write(lun,*) "ray plan in code units"
  write(lun,100) "snap", "t @ snap", "t start", "t end", "dt", "Src rays"
  do i = GV%StartSnapNum,GV%EndSnapNum
     write(lun,101) i, & 
                       PLAN%snap(i)%TimeAt, &
                       PLAN%snap(i)%StartTime, &
                       PLAN%snap(i)%StartTime + PLAN%snap(i)%RunTime, &
                       PLAN%snap(i)%RunTime, &
                       real(PLAN%snap(i)%SrcRays)
  end do


  write(lun,*) 
  write(lun,*) 

  write(lun,*) "ray plan in Myrs"
  write(lun,100) "snap", "t @ snap", "t start", "t end", "dt", "Src rays"
  do i = GV%StartSnapNum,GV%EndSnapNum
     write(lun,101) i, & 
                       PLAN%snap(i)%TimeAt * code2Myr, &
                       PLAN%snap(i)%StartTime * code2Myr, &
                       (PLAN%snap(i)%StartTime + PLAN%snap(i)%RunTime) * code2Myr, &
                       PLAN%snap(i)%RunTime * code2Myr, &
                       real(PLAN%snap(i)%SrcRays)
  end do


  write(lun,*)
  write(lun,*) "total simulation time [code] = ", GV%TotalSimTime
  write(lun,*) "total simulation time [Myr]  = ", GV%TotalSimTime * code2Myr

  GV%rayplanlun =  lun
  close(lun)

end subroutine do_ray_planning


!=======================================================================
!> when a new particle snapshot is read in, this routine should be called
!! to initialize some global variables.
subroutine initialize_global_variables()


  character(clen), parameter :: myname="initialize_global_variables"
  logical, parameter :: crash=.true.
  integer, parameter :: verb=2
  character(clen) :: str

  real, parameter :: zero = 0.0d0
  integer(i8b) :: nrays
  integer(i8b) :: i

  type(gadget_constants_type) :: gconst

  call mywrite("   initializing global variables",verb) 


  ! calculate total number of rays to be traced
  !----------------------------------------------------------------------
  nrays=0_i8b
  do i = GV%StartSnapNum, GV%EndSnapNum
     nrays = nrays + PLAN%snap(i)%SrcRays
  end do


  ! report ionization solver being used and particle/source mem footprint
  !----------------------------------------------------------------------
  if (GV%IonTempSolver == 1) then
     call mywrite("   using Implicit Euler ionization solver",verb)
  else if (GV%IonTempSolver == 2) then
     call mywrite("   using Backwards Difference ionization solver",verb)
  end if

  GV%bytesperpar = return_bytes_per_particle()
  GV%bytespersrc = return_bytes_per_source()

  write(str,'(A,I4)') "   bytes per particle = ", GV%bytesperpar
  call mywrite(str, verb)

  write(str,'(A,I4)') "   bytes per source = ", GV%bytespersrc
  call mywrite(str, verb)

  ! open log files
  !-----------------
  GV%ionfrac_file = trim(GV%OutputDir) // "/ionfrac.log"
  call open_formatted_file_w(GV%ionfrac_file,GV%ionlun)

  GV%pardata_file = trim(GV%OutputDir) // "/particle_data.log"
  call open_formatted_file_w(GV%pardata_file,GV%pardatalun)

  GV%srcdata_file = trim(GV%OutputDir) // "/source_data.log"
  call open_formatted_file_w(GV%srcdata_file,GV%srcdatalun)



                 
  ! initialize counters and timers
  !---------------------------------
  GV%CurSnapNum = GV%StartSnapNum
  GV%rayn = 0
  GV%src_rayn = 0
  GV%MB = zero
 
  GV%itime = 0_i8b
  GV%start_time_code = PLAN%snap(GV%StartSnapNum)%StartTime
  GV%start_time_s    = GV%start_time_code * GV%cgs_time / GV%LittleH
  GV%start_time_myr  = GV%start_time_s / gconst%sec_per_megayear

  GV%time_elapsed_code = zero
  GV%time_elapsed_s    = zero
  GV%time_elapsed_myr  = zero
      
  GV%TotalSourceRaysCast = zero
  GV%TotalDiffuseRaysCast = zero
  GV%IonizingPhotonsPerSec = zero
  GV%TotalPhotonsCast = zero
  GV%TotalPhotonsAbsorbed = zero
  GV%PhotonsLeavingBox = zero
  GV%TotalIonizations = zero
  GV%TotalRecombinations = zero
  
  GV%PeakUpdates = zero
  GV%AverageUpdatesPerPar = zero
  GV%ParticleCrossings = zero
  GV%TotalDerivativeCalls = zero
  


  call mywrite("",verb) 

end subroutine initialize_global_variables


end module initialize_mod

!> \file source_input.F90

!> \brief Handles readin of sourcefiles
!<

module source_input_mod
use myf03_mod
use particle_system_mod, only: particle_system_type
use particle_system_mod, only: source_type
use global_mod, only: psys, GV, PLAN
implicit none

!> source header type 
!-------------------------
type source_header_type 
   integer(i8b) :: NsrcSnap  !< number of sources in snapshot
   integer(i8b) :: NsrcFile  !< number of sources in file
   integer(i8b) :: NumFiles  !< number of files per snapshot
   real(r8b) :: TotalRays    !< sum of all rays to be cast this snap
   real(r8b) :: Lunit        !< Luminosities are photons/s * Lunit
end type source_header_type

contains

!> reads in a source header, prints the header to the screen if verbose
!========================================================================
subroutine read_source_header(snapfile, shead, lun, closefile)

  character(*), intent(in) :: snapfile  !< file containing source header
  type(source_header_type), intent(inout) :: shead  !< source header to read
  integer(i4b), intent(out) :: lun  !< output lun assigned to snapfile
  logical, optional, intent(in) :: closefile      !< close file when done?

  logical :: closef

  if (.not. present(closefile) ) then
     closef = .true.
  else
     closef = closefile
  end if

  call open_formatted_file_r(snapfile,lun)

  read(lun,*) shead%NsrcSnap
  read(lun,*) shead%NsrcFile
  read(lun,*) shead%NumFiles
  read(lun,*) shead%TotalRays
  read(lun,*) shead%Lunit
  read(lun,*)
  read(lun,*)
  if (closef) close(lun)
  
end subroutine read_source_header


subroutine get_planning_data_sources()

  character(clen), parameter :: myname = 'get_planning_data_sources'
  logical, parameter :: crash = .true.
  integer, parameter :: verb = 2

  integer(i4b) :: loglun
  type(source_header_type) :: shead
  character(clen) :: snapfile ! snapshot file name
  character(clen) :: logfile

  integer(i4b) :: iSnap, fSnap    ! initial and final snapshot numbers
  integer(i4b) :: sfiles          ! files/snap for sources   
  integer(i4b) :: i,j,lun


  ! these global variables are read from the config file
  !======================================================
  iSnap = GV%StartSnapNum
  fSnap = GV%EndSnapNum
    
  sfiles = GV%SourceFilesPerSnap


  ! open up the planning data log file
  !======================================================
  logfile = trim(GV%OutputDir) // "/" // "source_headers.log"
  call open_formatted_file_w(logfile,loglun)

  ! read all source headers and write to log file
  !===================================================
  write(loglun,*) 
  write(loglun,'(A)') "reading all source header(s) ... "
  do i = iSnap,fSnap
     do j = 1,sfiles
        call form_snapshot_file_name(GV%SourcePath,GV%SourceFileBase,i,j,snapfile)
        write(loglun,'(I3,"  ",A)') i,trim(snapfile)
        call mywrite('   srcfile = '//trim(snapfile) , verb)

        call read_source_header(snapfile,shead,lun,closefile=.true.)
        
        PLAN%snap(i)%RaysFromSrcHeader = shead%TotalRays
        GV%Lunit = shead%Lunit
        
        write(loglun,'(A,"  ",ES15.5)') '  Total Rays:', shead%TotalRays
        write(loglun,'(A,"  ",ES15.5)') '  L Unit:', shead%Lunit
        
     end do
  end do

  ! close headers log file
  !========================
  close(loglun)

  
end subroutine get_planning_data_sources


!> reads a source snapshot into arc array (src is allocated in this routine)
!=============================================================================
subroutine read_src_snapshot()

  character(clen), parameter :: myname="read_src_snapshot"
  logical, parameter :: crash=.true.
  integer, parameter :: verb=2
  character(clen) :: str, fmt

  character(clen) :: snapfile  
  type(source_header_type) :: shead
  integer(i4b) :: lun, err
  integer(i4b) :: i, N, Nall
  logical :: closefile
  integer(i4b) :: fn
  real(r4b) :: vel(3)
  real(r8b) :: MB

  fn=1
  call form_snapshot_file_name(GV%SourcePath,GV%SourceFileBase,GV%CurSnapNum,fn,snapfile)
      
  closefile = .false.
  call read_source_header(snapfile,shead,lun,closefile)

  Nall = shead%NsrcSnap        
  N    = shead%NsrcFile

  MB = GV%bytespersrc * real(Nall) / 2**20
  GV%MB = GV%MB + MB

  write(str,"(T4,A,F10.4,A,I10,A)") "allocating ", MB, " MB for ", Nall, " sources"
  call mywrite(str,verb)

  if (allocated(psys%src)) deallocate(psys%src)
  allocate (psys%src(Nall),stat=err)
  if (err /= 0) then
     call myerr("cant allocate sources in particle system", myname, crash)
  end if

  write(str,"(T4,A,A)") "reading source snapshot file: ", trim(snapfile) 
  call mywrite(str,verb)
     
  do i = 1,N 
     read(lun,*) psys%src(i)%pos(1), &
                 psys%src(i)%pos(2), &
                 psys%src(i)%pos(3), &
                 vel(1), &
                 vel(2), &
                 vel(3), &
                 psys%src(i)%L, &
                 psys%src(i)%SpcType, &
                 psys%src(i)%EmisPrf

#ifdef incVel
     psys%src(i)%vel = vel 
#endif

  end do

  close(lun)
 
  
end subroutine read_src_snapshot


!> Reorders the sources according to the array order. 
!! The array order is not preserved.
!========================================================
subroutine order_sources(srcs,order) 
  type(source_type), intent(inout) :: srcs(:)  !< sources to order
  integer(i8b), intent(inout) :: order(:)         !< desired order
  
  type(source_type) :: dumsrc
  integer(i8b) :: i,goal,nsrc
  
  if (size(srcs) /= size(order)) stop "size(srcs) /= size(order)"
  nsrc = size(srcs)

  do i = 1,nsrc
     dumsrc = srcs(i)
     goal = order(i)
     do while(goal < i)
        goal=order(goal)
        order(i)=goal
     end do
     srcs(i) = srcs(goal)
     srcs(goal)=dumsrc
  end do
  
end subroutine order_sources



!> Orders the sources from brightest to dimmest.  Also
!! sets the cumulative luminosity function entry for each source
!================================================================
subroutine order_sources_lum(src) 
  use m_mrgrnk, only: mrgrnk
  
  type(source_type), intent(inout) :: src(:) !< source array
  
  type(source_type), allocatable :: srclist(:)
  real(r8b), allocatable :: lumlist(:)
  integer(i8b), allocatable :: order(:)
  integer(i8b) :: i,N
  integer(i8b) :: err
  real(r8b) :: Ltot
  
  !      write(*,'(A)') "sorting the sources from brightest to dimmest ... "
  
  Ltot = 0.0
  N = size(src)

  allocate( srclist(N), stat=err )
  if(err/=0) stop "  order_sources_lum> cant allocate srclist"
      
  allocate( lumlist(N) , stat=err)
  if(err/=0) stop "  order_sources_lum> cant allocate lumlist"
    
  allocate( order(N) , stat=err)
  if(err/=0) stop "  order_sources_lum> cant allocate order"

  srclist = src(1:N)
  lumlist = src(1:N)%L
  call mrgrnk(-lumlist(1:N), order)
  
  ! sorting the negative of the luminosities puts the brightest first

  Ltot = 0.0d0
  do i = 1,N
     src(i) = srclist(order(i))
     Ltot = Ltot + src(i)%L
  end do
 
  lumlist = lumlist / Ltot
  
  do i = 1,N
     src(i)%Lcdf = lumlist(order(i))
  end do
  
  do i = 2,N
     src(i)%Lcdf = src(i-1)%Lcdf + src(i)%Lcdf 
  end do
  
  deallocate( srclist, lumlist, order )

end subroutine order_sources_lum


!> forms a snapshot name from a path, a file base, a snapshot number
!! and a file number.
!===================================================================
subroutine form_snapshot_file_name(Path,FileBase,SnapNum,FileNum,SnapFile)
  character(*), intent(in) :: Path       !< path to snapshot dir
  character(*), intent(in) :: FileBase   !< file base names
  integer(i4b), intent(in) :: SnapNum      !< snapshot number
  integer(i4b), intent(in) :: FileNum      !< file number in snapshot
  character(*), intent(out) :: SnapFile  !< file name to return
  
  character(10) :: FileNumChar
  
  write(FileNumChar,"(I6)") FileNum
  
  100 format(A,"/",A,"_",I3.3,".",A)
  write(SnapFile,100) trim(Path), trim(FileBase), SnapNum, &
                      trim(adjustl(FileNumChar))
  
end subroutine form_snapshot_file_name


!> outputs source snapshot header to the screen
!-----------------------------------------------
subroutine source_header_to_screen(shead)
  type(source_header_type), intent(in) :: shead !< source header to print

97 format(T2,"=",T58,"=")
98 format(T2,"= ",A,T58,"=")
99 format(T2,57("="))
100 format(T2,"=",T4,A,T30,I6,T58,"=")
200 format(T2,"=",T4,A,T30,ES12.5,T58,"=")
201 format(T2,"=",T4,A,T58,"=")
  
  write(*,99) 
  write(*,98) "source header data"
  write(*,99) 
  write(*,97) 
  write(*,100) "sources in snapshot:", shead%NsrcSnap
  write(*,100) "sources in file:", shead%NsrcFile
  write(*,100) "number of files in snap:", shead%NumFiles
  write(*,200) "rays for this snap:*", shead%TotalRays
  write(*,201) "*(only if RayScheme='header' in config file)"
  write(*,200) "luminosity unit (photons/s):", shead%Lunit
  write(*,97) 
  write(*,99) 
  
end subroutine source_header_to_screen


!> outputs source snapshot header to file
!-----------------------------------------------
subroutine source_header_to_file(shead,lun)
  type(source_header_type), intent(in) :: shead !< source header to print
  integer(i4b), intent(in) :: lun

97 format(T2,"=",T58,"=")
98 format(T2,"= ",A,T58,"=")
99 format(T2,57("="))
100 format(T2,"=",T4,A,T30,I6,T58,"=")
200 format(T2,"=",T4,A,T30,ES12.5,T58,"=")
201 format(T2,"=",T4,A,T58,"=")
  
  write(lun,99) 
  write(lun,98) "source header data"
  write(lun,99) 
  write(lun,97) 
  write(lun,100) "sources in snapshot:", shead%NsrcSnap
  write(lun,100) "sources in file:", shead%NsrcFile
  write(lun,100) "number of files in snap:", shead%NumFiles
  write(lun,200) "rays for this snap:*", shead%TotalRays
  write(lun,201) "*(only if RayScheme='header' in config file)"
  write(lun,200) "luminosity unit (photons/s):", shead%Lunit
  write(lun,97) 
  write(lun,99) 
  
end subroutine source_header_to_file

!> outputs the source data currently loaded in the particle system to screen
!! -------------------------------------------------------------------------
subroutine source_info_to_screen(psys,str,lun)

  type(particle_system_type), intent(in) :: psys     !< particle system
  character(*), optional, intent(in) :: str          !< arbitrary string
  integer(i4b), optional, intent(in) :: lun          !< if present goes to file
  integer(i4b) :: outlun

  integer(i8b), parameter :: srclimit = 20     !< max number of sources to screen
  integer(i8b) :: i
  
  outlun=stdout
  if (present(lun)) outlun=lun

  100 format(72("-"))
  110 format(T2,A,3ES10.3)
  111 format(T2,A,ES10.3)
  
  write(outlun,100)
  if (present(str)) write(outlun,"(A)") trim(str)
  write(outlun,"(A,I4,A,I13,A)") "source data for first ", srclimit, &
                                 " of ", size(psys%src), "  sources"
  write(outlun,*)   
  write(outlun,*) 
  120 format(T1,A, T15,A,     T37,A,     T51,A,     T65,A)
  121 format(T1,I2,T5,3ES10.3,T37,ES10.3,T51,ES10.3,T65,I3)
  write(outlun,120) "Src","Position","Luminosity","Spectrum","Emis Prf"
!  write(outlun,100)
  
  do i = 1, size(psys%src)
     write(outlun,121) i, psys%src(i)%pos, psys%src(i)%L, psys%src(i)%SpcType, &
          psys%src(i)%EmisPrf
     if (i==srclimit) exit
  end do
  
  write(outlun,100) 
  write(outlun,*)
  
  
end subroutine source_info_to_screen

end module source_input_mod

!> \file myf03.f90

!> \brief My Fortran 2003/8 module
!!
!! Makes use of the Fortran 2003 and 2008 standards.  The features I've 
!! included here are supported by version 4.5 of the GNU Fortran compiler. 
!! The module contains several useful variables and subroutines. 
!! 1. preconnected logical unit numbers (lun) for standard in, out and error.
!! 2. portable kind type parameters for 1/2/4/8 byte integers 
!! 3. portable kind type parameters for 4/8/16 byte reals. 
!! 4. default character length
!! 5. a verbosity variable to be used with write wrapper
!! 6. a command line type to standardize recieving arguments
!! portable precision definitions and subroutines for reading and 
!! parsing files 
!<

module myf03_mod
use iso_fortran_env
implicit none
private

public :: stderr, stdin, stdout
public :: i1b, i2b, i4b, i8b
public :: r4b, r8b
public :: clen 
public :: command_line_type

public :: myf03_verbosity  
public :: myf03_initialize_command_line
public :: get_free_lun
public :: get_env

public :: open_formatted_file_r
public :: open_unformatted_file_r
public :: open_unformatted_file_sr

public :: open_formatted_file_w
public :: open_unformatted_file_w
public :: open_unformatted_file_sw

public :: scanfile
public :: mywrite
public :: myerr

  interface scanfile
     module procedure scanfile_r4b, scanfile_r8b, scanfile_i4b, &
                      scanfile_i8b, scanfile_chr, scanfile_log
  end interface
  
! pre connected logical unit numbers
!------------------------------------------------------------------------
  integer, parameter :: stderr = error_unit  !< preconnected std error lun 
  integer, parameter :: stdin  = input_unit  !< preconnected std in lun
  integer, parameter :: stdout = output_unit !< preconnected std out lun
! selected_int_kind(r)     -10^r < n < 10^r
!------------------------------------------------------------------------

  integer, parameter :: i1b = selected_int_kind(2)  !< 1 byte integer type
  integer, parameter :: i2b = selected_int_kind(4)  !< 2 byte integer type
  integer, parameter :: i4b = selected_int_kind(9)  !< 4 byte integer type
  integer, parameter :: i8b = selected_int_kind(18) !< 8 byte integer type

! selected_real_kind(p,r)  p is decimal precision, r is exponent range
!------------------------------------------------------------------------
  integer, parameter :: r4b  = selected_real_kind(p=6,r=37)    !< 4 byte real type
  integer, parameter :: r8b  = selected_real_kind(p=15,r=307)  !< 8 byte real type





  integer, parameter :: clen  = 512 !< default character variable length

  integer :: myf03_verbosity=3        !< global verbosity threshold

!> command line type. 
!----------------------------
  type command_line_type
     integer :: nargs       !< number of arguments excluding executable
     integer :: len         !< number of chars in whole command line 
     character(clen) :: str !< the whole command line  
     character(clen), allocatable :: args(:)  !< individual command line args
     integer, allocatable :: arglens(:)       !< number of chars in each arg
  end type command_line_type


contains



!> fills in the command line variable
!-----------------------------------------------
  function myf03_initialize_command_line(verb) result(cmnd)
    type(command_line_type) :: cmnd
    integer :: verb 
    integer :: stat
    integer :: i
    character(clen) :: str

    character(clen), parameter :: myname="myf03_initialize_command_line"
    logical, parameter :: crash = .true.


    cmnd%nargs = command_argument_count()
    call get_command( command=cmnd%str, length=cmnd%len )

    call mywrite('', verb) 
    call mywrite('command string: ' // trim(cmnd%str), verb)
    write(str,'(A,I5)') 'command nargs :', cmnd%nargs
    call mywrite( str, verb) 
    
    allocate( cmnd%args( 0:cmnd%nargs ), cmnd%arglens( 0:cmnd%nargs ) )

    do i = 0,cmnd%nargs
       call get_command_argument( i, &
            value=cmnd%args(i), &
            length=cmnd%arglens(i) )

       if (i==0) then
          write(str,'(A,A)') 'exe: ', trim(cmnd%args(i))
       else
          write(str,'(A,I2,A,A)') 'arg ', i, ': ', trim(cmnd%args(i))
       endif
       call mywrite(str, verb)

       call mywrite('', verb)
    end do
    
  end function myf03_initialize_command_line



!> reports an error message and stops execution
!-----------------------------------------------
   subroutine myerr(str,routine,crash)
     character(len=*), intent(in) :: str
     character(len=*), intent(in) :: routine
     logical, intent(in) :: crash

     write(*,*) "*****************************"
     write(*,*) "error detected"
     write(*,*) "routine: ", trim(routine)
     write(*,*) trim(str)
     write(*,*) "*****************************"
     if (crash) stop

   end subroutine myerr



!> verbosity dependent write
!-----------------------------------------------
   subroutine mywrite( str, verb, lun, adv )
     character(len=*), intent(in) :: str
     integer, intent(in) :: verb
     integer, optional, intent(in) :: lun
     logical, optional, intent(in) :: adv
     character(3) :: sadv
     character(10) :: fmt

     character(clen), parameter :: myname='mywrite'
     logical, parameter :: crash=.true.

     if (present(adv)) then
        if (adv) then
           sadv = "yes"
        else
           sadv = "no "
        end if
     else
        sadv = "yes"
     end if

     fmt='(A)'

     if (present(lun)) then
        if (verb <= myf03_verbosity) write(lun,fmt,advance=sadv) trim(str) 
     else
        if (verb <= myf03_verbosity) write(stdout,fmt,advance=sadv) trim(str)
     endif

   end subroutine mywrite



!> returns a free logical unit number
!------------------------------------
   function get_free_lun() result(lun)

    integer(i4b) :: lun                        !< free lun
    integer(i4b) :: i                          !< loop counter
    integer(i4b), parameter :: minlun = 110    !< min lun to check
    integer(i4b), parameter :: maxlun = 1000   !< max lun to check
    logical :: badlun                          !< true if lun already connected

    character(clen), parameter :: myname="get_free_lun"
 
    do i = minlun,maxlun
      inquire(unit=i, opened=badlun)
      if (.not. badlun) then
         lun = i
         return
      end if
    end do

    write(*,*) '  checked luns from, ', minlun, ' to ', maxlun

    call myerr( str=" no free logical unit numbers", &
                routine=myname, &
                crash=.true. )

  end function get_free_lun



!> returns an environment variable
!----------------------------------------
  function get_env(env) result(var)
    character(len=*) :: env !< name of environment variable requested
    character(clen) :: var  !< value of environment variable requested

    call get_environment_variable(env,  value=var,  trim_name=.true.)

  end function get_env



!> opens a formatted file for reading and returns the lun
!--------------------------------------------------------
  subroutine open_formatted_file_r(filename,lun)
  
    character(len=*), intent(in) :: filename !< name of file to open
    integer(i4b), intent(out) :: lun     !< lun 

    lun = get_free_lun() 
    open(unit=lun, file=filename, action="read")

  end subroutine open_formatted_file_r



!> opens an unformatted file for reading and returns the lun
!-------------------------------------------------------------
  subroutine open_unformatted_file_r(filename,lun)
  
    character(len=*), intent(in) :: filename  !< name of file to open
    integer(i4b), intent(out)  :: lun     !< lun

    lun = get_free_lun()
    open(unit=lun, file=filename, form='unformatted', action="read")

  end subroutine open_unformatted_file_r

!> opens an unformatted file for stream reading and returns the lun
!--------------------------------------------------------------------
  subroutine open_unformatted_file_sr(filename,lun)
  
    character(len=*), intent(in) :: filename  !< name of file to open
    integer(i4b), intent(out)  :: lun     !< lun

    lun = get_free_lun()
    open(unit=lun, file=filename, form="unformatted", &
         action="read", access="stream", position="rewind")

  end subroutine open_unformatted_file_sr



!> opens a formatted file for writing and returns the lun
!--------------------------------------------------------
  subroutine open_formatted_file_w(filename,lun)
  
    character(len=*), intent(in) :: filename !< name of file to open
    integer(i4b), intent(out) :: lun     !< lun 

    lun = get_free_lun()
    open(unit=lun, file=filename, action="write")

  end subroutine open_formatted_file_w


!> opens an unformatted file for writing and returns the lun
!------------------------------------------------------------
  subroutine open_unformatted_file_w(filename,lun)
  
    character(len=*), intent(in) :: filename  !< name of file to open
    integer(i4b), intent(out)  :: lun             !< lun

    lun = get_free_lun()
    open(unit=lun, file=filename, form='unformatted', &
         action="write")
   
  end subroutine open_unformatted_file_w


!> opens an unformatted file for stream writing and returns the lun
!-------------------------------------------------------------------
  subroutine open_unformatted_file_sw(filename,lun)
  
    character(len=*), intent(in) :: filename  !< name of file to open
    integer(i4b), intent(out)  :: lun             !< lun

    lun = get_free_lun()
    open(unit=lun, file=filename, form='unformatted', &
         action="write", access="stream", position="rewind")

  end subroutine open_unformatted_file_sw



  ! scan file routines, one for each type
  !==================================================================
  subroutine scanfile_r4b(filename,keyword,var) 
    character(len=*), intent(in) :: filename
    character(len=*), intent(in) :: keyword
    real(r4b), intent(out) :: var

    integer :: keylen
    integer :: strlen
    integer :: keypos
    character(clen) :: string
    integer :: ierr
    integer :: lun
    integer :: count

    ierr=0
    count=0
    keylen = len(adjustl(trim(keyword)))
    call open_formatted_file_r(filename,lun)
    do while( ierr==0 ) 
       read(lun,'(A)',iostat=ierr) string
       strlen = len(adjustl(trim(string)))
       keypos = index( string, adjustl(trim(keyword)) )
       if (keypos == 1 .and. ierr==0) then
          count = count + 1
          read(string(keypos+keylen:strlen),*) var
       endif
    end do
    close(lun)

    if (count/=1) then
       write(*,'(A,A)') ' keyword ', trim(keyword)
       write(*,'(A,A)') ' file:   ', trim(filename)
       if (count==0) then
          write(*,*) ' *** keyword not found in file'
          stop
       else if (count>1) then
          write(*,*) ' *** keyword found ', count, ' times'
          stop
       endif
    endif

  end subroutine scanfile_r4b


  subroutine scanfile_r8b(filename,keyword,var) 
    character(len=*), intent(in) :: filename
    character(len=*), intent(in) :: keyword
    real(r8b), intent(out) :: var

    integer :: keylen
    integer :: strlen
    integer :: keypos
    character(clen) :: string
    integer :: ierr
    integer :: lun
    integer :: count

    ierr=0
    count=0
    keylen = len(adjustl(trim(keyword)))
    call open_formatted_file_r(filename,lun)
    do while( ierr==0 ) 
       read(lun,'(A)',iostat=ierr) string
       strlen = len(adjustl(trim(string)))
       keypos = index( string, adjustl(trim(keyword)) )
       if (keypos == 1 .and. ierr==0) then
          count = count + 1
          read(string(keypos+keylen:strlen),*) var
       endif
    end do
    close(lun)

    if (count/=1) then
       write(*,'(A,A)') ' keyword ', trim(keyword)
       write(*,'(A,A)') ' file:   ', trim(filename)
       if (count==0) then
          write(*,*) ' *** keyword not found in file'
          stop
       else if (count>1) then
          write(*,*) ' *** keyword found ', count, ' times'
          stop
       endif
    endif

  end subroutine scanfile_r8b


  subroutine scanfile_i4b(filename,keyword,var) 
    character(len=*), intent(in) :: filename
    character(len=*), intent(in) :: keyword
    integer(i4b), intent(out) :: var

    integer :: keylen
    integer :: strlen
    integer :: keypos
    character(clen) :: string
    integer :: ierr
    integer :: lun
    integer :: count

    ierr=0
    count=0
    keylen = len(adjustl(trim(keyword)))
    call open_formatted_file_r(filename,lun)
    do while( ierr==0 ) 
       read(lun,'(A)',iostat=ierr) string
       strlen = len(adjustl(trim(string)))
       keypos = index( string, adjustl(trim(keyword)) )
       if (keypos == 1 .and. ierr==0) then
          count = count + 1
          read(string(keypos+keylen:strlen),*) var
       endif
    end do
    close(lun)

    if (count/=1) then
       write(*,'(A,A)') ' keyword ', trim(keyword)
       write(*,'(A,A)') ' file:   ', trim(filename)
       if (count==0) then
          write(*,*) ' *** keyword not found in file'
          stop
       else if (count>1) then
          write(*,*) ' *** keyword found ', count, ' times'
          stop
       endif
    endif

  end subroutine scanfile_i4b



  subroutine scanfile_i8b(filename,keyword,var) 
    character(len=*), intent(in) :: filename
    character(len=*), intent(in) :: keyword
    integer(i8b), intent(out) :: var

    integer :: keylen
    integer :: strlen
    integer :: keypos
    character(clen) :: string
    integer :: ierr
    integer :: lun
    integer :: count

    ierr=0
    count=0
    keylen = len(adjustl(trim(keyword)))
    call open_formatted_file_r(filename,lun)
    do while( ierr==0 ) 
       read(lun,'(A)',iostat=ierr) string
       strlen = len(adjustl(trim(string)))
       keypos = index( string, adjustl(trim(keyword)) )
       if (keypos == 1 .and. ierr==0) then
          count = count + 1
          read(string(keypos+keylen:strlen),*) var
       endif
    end do
    close(lun)

    if (count/=1) then
       write(*,'(A,A)') ' keyword ', trim(keyword)
       write(*,'(A,A)') ' file:   ', trim(filename)
       if (count==0) then
          write(*,*) ' *** keyword not found in file'
          stop
       else if (count>1) then
          write(*,*) ' *** keyword found ', count, ' times'
          stop
       endif
    endif

  end subroutine scanfile_i8b



  subroutine scanfile_chr(filename,keyword,var)
    character(len=*), intent(in) :: filename
    character(len=*), intent(in) :: keyword
    character(clen), intent(out) :: var

    integer :: keylen
    integer :: strlen
    integer :: keypos
    character(clen) :: string
    integer :: ierr
    integer :: lun
    integer :: count

    ierr=0
    count=0
    keylen = len(adjustl(trim(keyword)))
    call open_formatted_file_r(filename,lun)
    do while( ierr==0 ) 
       read(lun,'(A)',iostat=ierr) string
       strlen = len(adjustl(trim(string)))
       keypos = index( string, adjustl(trim(keyword)) )
       if (keypos == 1 .and. ierr==0) then
          count = count + 1
          read(string(keypos+keylen:strlen),'(A)') var
          var = adjustl(trim(var))
       endif
    end do
    close(lun)

    if (count/=1) then
       write(*,'(A,A)') ' keyword ', trim(keyword)
       write(*,'(A,A)') ' file:   ', trim(filename)
       if (count==0) then
          write(*,*) ' *** keyword not found in file'
          stop
       else if (count>1) then
          write(*,*) ' *** keyword found ', count, ' times'
          stop
       endif
    endif
  end subroutine scanfile_chr



  subroutine scanfile_log(filename,keyword,var)
    character(len=*), intent(in) :: filename
    character(len=*), intent(in) :: keyword
    logical, intent(out) :: var

    integer :: keylen
    integer :: strlen
    integer :: keypos
    character(clen) :: string
    integer :: ierr
    integer :: lun
    integer :: count

    ierr=0
    count=0
    keylen = len(adjustl(trim(keyword)))
    call open_formatted_file_r(filename,lun)
    do while( ierr==0 ) 
       read(lun,'(A)',iostat=ierr) string
       strlen = len(adjustl(trim(string)))
       keypos = index( string, adjustl(trim(keyword)) )
       if (keypos == 1 .and. ierr==0) then
          count = count + 1
          read(string(keypos+keylen:strlen),*) var
       endif
    end do
    close(lun)

    if (count/=1) then
       write(*,'(A,A)') ' keyword ', trim(keyword)
       write(*,'(A,A)') ' file:   ', trim(filename)
       if (count==0) then
          write(*,*) ' *** keyword not found in file'
          stop
       else if (count>1) then
          write(*,*) ' *** keyword found ', count, ' times'
          stop
       endif
    endif

  end subroutine scanfile_log





end module myf03_mod

MODULE OpenGL_glut
USE OpenGL_kinds
IMPLICIT NONE
PRIVATE

!  Copyright (c) Mark J. Kilgard, 1994, 1995, 1996, 1998. 

!     provided without guarantee or warrantee expressed or  implied. This

!  Cut to provide just basic OpenGL interface by A. Donev 


!  Define GLUTAPIENTRY and GLUTCALLBACK to nothing if we aren't on Win32. 

!   GLUT API revision history:
!  
!   GLUT_API_VERSION is updated to reflect incompatible GLUT
!   API changes (interface changes, semantic changes, deletions,
!   or additions).
!  
!   GLUT_API_VERSION=1  First public release of GLUT.  11/29/94
!  
!   GLUT_API_VERSION=2  Added support for OpenGL/GLX multisampling,
!   extension.  Supports new input devices like tablet, dial and button
!   box, and Spaceball.  Easy to query OpenGL extensions.
!  
!   GLUT_API_VERSION=3  glutMenuStatus added.
!  
!   GLUT_API_VERSION=4  glutInitDisplayString, glutWarpPointer,
!   glutBitmapLength, glutStrokeLength, glutWindowStatusFunc, dynamic
!   video resize subAPI, glutPostWindowRedisplay, glutKeyboardUpFunc,
!   glutSpecialUpFunc, glutIgnoreKeyRepeat, glutSetKeyRepeat,
!   glutJoystickFunc, glutForceJoystickFunc (NOT FINALIZED!).
!  
!   GLUT_API_VERSION=5  glutGetProcAddress (added by BrianP)
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_API_VERSION = 5

!   GLUT implementation revision history:
!  
!   GLUT_XLIB_IMPLEMENTATION is updated to reflect both GLUT
!   API revisions and implementation revisions (ie, bug fixes).
!  
!   GLUT_XLIB_IMPLEMENTATION=1  mjk's first public release of
!   GLUT Xlib-based implementation.  11/29/94
!  
!   GLUT_XLIB_IMPLEMENTATION=2  mjk's second public release of
!   GLUT Xlib-based implementation providing GLUT version 2
!   interfaces.
!  
!   GLUT_XLIB_IMPLEMENTATION=3  mjk's GLUT 2.2 images. 4/17/95
!  
!   GLUT_XLIB_IMPLEMENTATION=4  mjk's GLUT 2.3 images. 6/?/95
!  
!   GLUT_XLIB_IMPLEMENTATION=5  mjk's GLUT 3.0 images. 10/?/95
!  
!   GLUT_XLIB_IMPLEMENTATION=7  mjk's GLUT 3.1+ with glutWarpPoitner.  7/24/96
!  
!   GLUT_XLIB_IMPLEMENTATION=8  mjk's GLUT 3.1+ with glutWarpPoitner
!   and video resize.  1/3/97
!  
!   GLUT_XLIB_IMPLEMENTATION=9 mjk's GLUT 3.4 release with early GLUT 4 routines.
!  
!   GLUT_XLIB_IMPLEMENTATION=11 Mesa 2.5's GLUT 3.6 release.
!  
!   GLUT_XLIB_IMPLEMENTATION=12 mjk's GLUT 3.6 release with early GLUT 4 routines + signal handling.
!  
!   GLUT_XLIB_IMPLEMENTATION=13 mjk's GLUT 3.7 beta with GameGLUT support.
!  
!   GLUT_XLIB_IMPLEMENTATION=14 mjk's GLUT 3.7 beta with f90gl friend interface.
!  
!   GLUT_XLIB_IMPLEMENTATION=15 mjk's GLUT 3.7 beta sync'ed with Mesa <GL/glut.h>
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_XLIB_IMPLEMENTATION = 15

!  Display mode bit masks. 
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_RGB = 0
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_RGBA = GLUT_RGB
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_INDEX = 1
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_SINGLE = 0
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_DOUBLE = 2
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_ACCUM = 4
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_ALPHA = 8
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_DEPTH = 16
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_STENCIL = 32
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_MULTISAMPLE = 128
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_STEREO = 256
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_LUMINANCE = 512

!  Mouse buttons. 
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_LEFT_BUTTON = 0
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_MIDDLE_BUTTON = 1
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_RIGHT_BUTTON = 2

!  Mouse button  state. 
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_DOWN = 0
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_UP = 1

!  function keys 
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_F1 = 1
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_F2 = 2
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_F3 = 3
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_F4 = 4
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_F5 = 5
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_F6 = 6
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_F7 = 7
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_F8 = 8
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_F9 = 9
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_F10 = 10
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_F11 = 11
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_F12 = 12
!  directional keys 
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_LEFT = 100
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_UP = 101
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_RIGHT = 102
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_DOWN = 103
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_PAGE_UP = 104
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_PAGE_DOWN = 105
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_HOME = 106
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_END = 107
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_INSERT = 108

!  Entry/exit  state. 
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_LEFT = 0
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_ENTERED = 1

!  Menu usage  state. 
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_MENU_NOT_IN_USE = 0
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_MENU_IN_USE = 1

!  Visibility  state. 
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_NOT_VISIBLE = 0
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_VISIBLE = 1

!  Window status  state. 
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_HIDDEN = 0
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_FULLY_RETAINED = 1
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_PARTIALLY_RETAINED = 2
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_FULLY_COVERED = 3

!  Color index component selection values. 
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_RED = 0
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_GREEN = 1
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_BLUE = 2

!  Layers for use. 
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_NORMAL = 0
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_OVERLAY = 1

!  Stroke font opaque addresses (use constants instead in source code). 

!  Stroke font constants (use these in GLUT program). 
! ???, , PUBLIC :: GLUT_STROKE_ROMAN=(&glutStrokeRoman)
! ???, , PUBLIC :: GLUT_STROKE_MONO_ROMAN=(&glutStrokeMonoRoman)

!  Bitmap font opaque addresses (use constants instead in source code). 

!  Bitmap font constants (use these in GLUT program). 
! ???, , PUBLIC :: GLUT_BITMAP_9_BY_15=(&glutBitmap9By15)
! ???, , PUBLIC :: GLUT_BITMAP_8_BY_13=(&glutBitmap8By13)
! ???, , PUBLIC :: GLUT_BITMAP_TIMES_ROMAN_10=(&glutBitmapTimesRoman10)
! ???, , PUBLIC :: GLUT_BITMAP_TIMES_ROMAN_24=(&glutBitmapTimesRoman24)
! ???, , PUBLIC :: GLUT_BITMAP_HELVETICA_10=(&glutBitmapHelvetica10)
! ???, , PUBLIC :: GLUT_BITMAP_HELVETICA_12=(&glutBitmapHelvetica12)
! ???, , PUBLIC :: GLUT_BITMAP_HELVETICA_18=(&glutBitmapHelvetica18)

!  glutGet parameters. 
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_X = 100
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_Y = 101
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_WIDTH = 102
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_HEIGHT = 103
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_BUFFER_SIZE = 104
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_STENCIL_SIZE = 105
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_DEPTH_SIZE = 106
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_RED_SIZE = 107
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_GREEN_SIZE = 108
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_BLUE_SIZE = 109
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_ALPHA_SIZE = 110
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_ACCUM_RED_SIZE = 111
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_ACCUM_GREEN_SIZE = 112
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_ACCUM_BLUE_SIZE = 113
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_ACCUM_ALPHA_SIZE = 114
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_DOUBLEBUFFER = 115
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_RGBA = 116
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_PARENT = 117
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_NUM_CHILDREN = 118
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_COLORMAP_SIZE = 119
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_NUM_SAMPLES = 120
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_STEREO = 121
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_CURSOR = 122
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_SCREEN_WIDTH = 200
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_SCREEN_HEIGHT = 201
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_SCREEN_WIDTH_MM = 202
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_SCREEN_HEIGHT_MM = 203
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_MENU_NUM_ITEMS = 300
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_DISPLAY_MODE_POSSIBLE = 400
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_INIT_WINDOW_X = 500
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_INIT_WINDOW_Y = 501
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_INIT_WINDOW_WIDTH = 502
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_INIT_WINDOW_HEIGHT = 503
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_INIT_DISPLAY_MODE = 504
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_ELAPSED_TIME = 700
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_FORMAT_ID = 123

!  glutDeviceGet parameters. 
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_HAS_KEYBOARD = 600
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_HAS_MOUSE = 601
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_HAS_SPACEBALL = 602
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_HAS_DIAL_AND_BUTTON_BOX = 603
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_HAS_TABLET = 604
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_NUM_MOUSE_BUTTONS = 605
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_NUM_SPACEBALL_BUTTONS = 606
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_NUM_BUTTON_BOX_BUTTONS = 607
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_NUM_DIALS = 608
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_NUM_TABLET_BUTTONS = 609
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_DEVICE_IGNORE_KEY_REPEAT = 610
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_DEVICE_KEY_REPEAT = 611
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_HAS_JOYSTICK = 612
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_OWNS_JOYSTICK = 613
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_JOYSTICK_BUTTONS = 614
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_JOYSTICK_AXES = 615
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_JOYSTICK_POLL_RATE = 616

!  glutLayerGet parameters. 
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_OVERLAY_POSSIBLE = 800
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_LAYER_IN_USE = 801
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_HAS_OVERLAY = 802
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_TRANSPARENT_INDEX = 803
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_NORMAL_DAMAGED = 804
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_OVERLAY_DAMAGED = 805

!  glutVideoResizeGet parameters. 
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_VIDEO_RESIZE_POSSIBLE = 900
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_VIDEO_RESIZE_IN_USE = 901
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_VIDEO_RESIZE_X_DELTA = 902
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_VIDEO_RESIZE_Y_DELTA = 903
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_VIDEO_RESIZE_WIDTH_DELTA = 904
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_VIDEO_RESIZE_HEIGHT_DELTA = 905
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_VIDEO_RESIZE_X = 906
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_VIDEO_RESIZE_Y = 907
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_VIDEO_RESIZE_WIDTH = 908
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_VIDEO_RESIZE_HEIGHT = 909

!  glutGetModifiers return mask. 
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_ACTIVE_SHIFT = 1
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_ACTIVE_CTRL = 2
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_ACTIVE_ALT = 4

!  glutSetCursor parameters. 
!  Basic arrows. 
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_RIGHT_ARROW = 0
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_LEFT_ARROW = 1
!  Symbolic cursor shapes. 
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_INFO = 2
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_DESTROY = 3
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_HELP = 4
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_CYCLE = 5
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_SPRAY = 6
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_WAIT = 7
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_TEXT = 8
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_CROSSHAIR = 9
!  Directional cursors. 
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_UP_DOWN = 10
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_LEFT_RIGHT = 11
!  Sizing cursors. 
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_TOP_SIDE = 12
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_BOTTOM_SIDE = 13
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_LEFT_SIDE = 14
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_RIGHT_SIDE = 15
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_TOP_LEFT_CORNER = 16
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_TOP_RIGHT_CORNER = 17
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_BOTTOM_RIGHT_CORNER = 18
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_BOTTOM_LEFT_CORNER = 19
!  Inherit from parent window. 
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_INHERIT = 100
!  Blank cursor. 
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_NONE = 101
!  Fullscreen crosshair (if available). 
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_FULL_CROSSHAIR = 102

!  GLUT initialization sub-API. 
!  void glutInit(int *argcp, char **argv)
PUBLIC glutInit
INTERFACE glutInit
MODULE PROCEDURE glutInit_f03
END INTERFACE glutInit
INTERFACE
SUBROUTINE glutInit_gl(argcp, argv) BIND(C,NAME="glutInit")
IMPORT
! INTEGER(GLint), DIMENSION(*) :: argcp
INTEGER(GLint) :: argcp
TYPE(C_PTR), INTENT(IN) :: argv
END SUBROUTINE glutInit_gl
END INTERFACE

!  void glutInitDisplayMode(unsigned int mode)
PUBLIC glutInitDisplayMode
INTERFACE
SUBROUTINE glutInitDisplayMode(mode) BIND(C,NAME="glutInitDisplayMode")
IMPORT
INTEGER(GLuint), VALUE :: mode
END SUBROUTINE glutInitDisplayMode
END INTERFACE

!  void glutInitDisplayString(const char *string)
PUBLIC glutInitDisplayString
INTERFACE
SUBROUTINE glutInitDisplayString(string) BIND(C,NAME="glutInitDisplayString")
IMPORT
! CHARACTER, INTENT(IN) :: string
CHARACTER, DIMENSION(*), INTENT(IN) :: string
END SUBROUTINE glutInitDisplayString
END INTERFACE

!  void glutInitWindowPosition(int x, int y)
PUBLIC glutInitWindowPosition
INTERFACE
SUBROUTINE glutInitWindowPosition(x, y) BIND(C,NAME="glutInitWindowPosition")
IMPORT
INTEGER(GLint), VALUE :: x, y
END SUBROUTINE glutInitWindowPosition
END INTERFACE

!  void glutInitWindowSize(int width, int height)
PUBLIC glutInitWindowSize
INTERFACE
SUBROUTINE glutInitWindowSize(width, height) BIND(C,NAME="glutInitWindowSize")
IMPORT
INTEGER(GLint), VALUE :: width, height
END SUBROUTINE glutInitWindowSize
END INTERFACE

!  void glutMainLoop(void)
PUBLIC glutMainLoop
INTERFACE
SUBROUTINE glutMainLoop() BIND(C,NAME="glutMainLoop")
IMPORT
END SUBROUTINE glutMainLoop
END INTERFACE


!  GLUT window sub-API. 
!  int glutCreateWindow(const char *title)
PUBLIC glutCreateWindow
INTERFACE
FUNCTION glutCreateWindow(title) BIND(C,NAME="glutCreateWindow")
IMPORT
INTEGER(GLint) :: glutCreateWindow
! CHARACTER, INTENT(IN) :: title
CHARACTER, DIMENSION(*), INTENT(IN) :: title
END FUNCTION glutCreateWindow
END INTERFACE

!  int glutCreateSubWindow(int win, int x, int y, int width, int height)
PUBLIC glutCreateSubWindow
INTERFACE
FUNCTION glutCreateSubWindow(win, x, y, width, height) BIND(C,NAME="glutCreateSubWindow")
IMPORT
INTEGER(GLint) :: glutCreateSubWindow
INTEGER(GLint), VALUE :: win, x, y, width, height
END FUNCTION glutCreateSubWindow
END INTERFACE

!  void glutDestroyWindow(int win)
PUBLIC glutDestroyWindow
INTERFACE
SUBROUTINE glutDestroyWindow(win) BIND(C,NAME="glutDestroyWindow")
IMPORT
INTEGER(GLint), VALUE :: win
END SUBROUTINE glutDestroyWindow
END INTERFACE

!  void glutPostRedisplay(void)
PUBLIC glutPostRedisplay
INTERFACE
SUBROUTINE glutPostRedisplay() BIND(C,NAME="glutPostRedisplay")
IMPORT
END SUBROUTINE glutPostRedisplay
END INTERFACE

!  void glutPostWindowRedisplay(int win)
PUBLIC glutPostWindowRedisplay
INTERFACE
SUBROUTINE glutPostWindowRedisplay(win) BIND(C,NAME="glutPostWindowRedisplay")
IMPORT
INTEGER(GLint), VALUE :: win
END SUBROUTINE glutPostWindowRedisplay
END INTERFACE

!  void glutSwapBuffers(void)
PUBLIC glutSwapBuffers
INTERFACE
SUBROUTINE glutSwapBuffers() BIND(C,NAME="glutSwapBuffers")
IMPORT
END SUBROUTINE glutSwapBuffers
END INTERFACE

!  int glutGetWindow(void)
PUBLIC glutGetWindow
INTERFACE
FUNCTION glutGetWindow() BIND(C,NAME="glutGetWindow")
IMPORT
INTEGER(GLint) :: glutGetWindow
END FUNCTION glutGetWindow
END INTERFACE

!  void glutSetWindow(int win)
PUBLIC glutSetWindow
INTERFACE
SUBROUTINE glutSetWindow(win) BIND(C,NAME="glutSetWindow")
IMPORT
INTEGER(GLint), VALUE :: win
END SUBROUTINE glutSetWindow
END INTERFACE

!  void glutSetWindowTitle(const char *title)
PUBLIC glutSetWindowTitle
INTERFACE
SUBROUTINE glutSetWindowTitle(title) BIND(C,NAME="glutSetWindowTitle")
IMPORT
! CHARACTER, INTENT(IN) :: title
CHARACTER, DIMENSION(*), INTENT(IN) :: title
END SUBROUTINE glutSetWindowTitle
END INTERFACE

!  void glutSetIconTitle(const char *title)
PUBLIC glutSetIconTitle
INTERFACE
SUBROUTINE glutSetIconTitle(title) BIND(C,NAME="glutSetIconTitle")
IMPORT
! CHARACTER, INTENT(IN) :: title
CHARACTER, DIMENSION(*), INTENT(IN) :: title
END SUBROUTINE glutSetIconTitle
END INTERFACE

!  void glutPositionWindow(int x, int y)
PUBLIC glutPositionWindow
INTERFACE
SUBROUTINE glutPositionWindow(x, y) BIND(C,NAME="glutPositionWindow")
IMPORT
INTEGER(GLint), VALUE :: x, y
END SUBROUTINE glutPositionWindow
END INTERFACE

!  void glutReshapeWindow(int width, int height)
PUBLIC glutReshapeWindow
INTERFACE
SUBROUTINE glutReshapeWindow(width, height) BIND(C,NAME="glutReshapeWindow")
IMPORT
INTEGER(GLint), VALUE :: width, height
END SUBROUTINE glutReshapeWindow
END INTERFACE

!  void glutPopWindow(void)
PUBLIC glutPopWindow
INTERFACE
SUBROUTINE glutPopWindow() BIND(C,NAME="glutPopWindow")
IMPORT
END SUBROUTINE glutPopWindow
END INTERFACE

!  void glutPushWindow(void)
PUBLIC glutPushWindow
INTERFACE
SUBROUTINE glutPushWindow() BIND(C,NAME="glutPushWindow")
IMPORT
END SUBROUTINE glutPushWindow
END INTERFACE

!  void glutIconifyWindow(void)
PUBLIC glutIconifyWindow
INTERFACE
SUBROUTINE glutIconifyWindow() BIND(C,NAME="glutIconifyWindow")
IMPORT
END SUBROUTINE glutIconifyWindow
END INTERFACE

!  void glutShowWindow(void)
PUBLIC glutShowWindow
INTERFACE
SUBROUTINE glutShowWindow() BIND(C,NAME="glutShowWindow")
IMPORT
END SUBROUTINE glutShowWindow
END INTERFACE

!  void glutHideWindow(void)
PUBLIC glutHideWindow
INTERFACE
SUBROUTINE glutHideWindow() BIND(C,NAME="glutHideWindow")
IMPORT
END SUBROUTINE glutHideWindow
END INTERFACE

!  void glutFullScreen(void)
PUBLIC glutFullScreen
INTERFACE
SUBROUTINE glutFullScreen() BIND(C,NAME="glutFullScreen")
IMPORT
END SUBROUTINE glutFullScreen
END INTERFACE

!  void glutSetCursor(int cursor)
PUBLIC glutSetCursor
INTERFACE
SUBROUTINE glutSetCursor(cursor) BIND(C,NAME="glutSetCursor")
IMPORT
INTEGER(GLint), VALUE :: cursor
END SUBROUTINE glutSetCursor
END INTERFACE

!  void glutWarpPointer(int x, int y)
PUBLIC glutWarpPointer
INTERFACE
SUBROUTINE glutWarpPointer(x, y) BIND(C,NAME="glutWarpPointer")
IMPORT
INTEGER(GLint), VALUE :: x, y
END SUBROUTINE glutWarpPointer
END INTERFACE


!  GLUT overlay sub-API. 
!  void glutEstablishOverlay(void)
PUBLIC glutEstablishOverlay
INTERFACE
SUBROUTINE glutEstablishOverlay() BIND(C,NAME="glutEstablishOverlay")
IMPORT
END SUBROUTINE glutEstablishOverlay
END INTERFACE

!  void glutRemoveOverlay(void)
PUBLIC glutRemoveOverlay
INTERFACE
SUBROUTINE glutRemoveOverlay() BIND(C,NAME="glutRemoveOverlay")
IMPORT
END SUBROUTINE glutRemoveOverlay
END INTERFACE

!  void glutUseLayer(GLenum layer)
PUBLIC glutUseLayer
INTERFACE
SUBROUTINE glutUseLayer(layer) BIND(C,NAME="glutUseLayer")
IMPORT
INTEGER(GLenum), VALUE :: layer
END SUBROUTINE glutUseLayer
END INTERFACE

!  void glutPostOverlayRedisplay(void)
PUBLIC glutPostOverlayRedisplay
INTERFACE
SUBROUTINE glutPostOverlayRedisplay() BIND(C,NAME="glutPostOverlayRedisplay")
IMPORT
END SUBROUTINE glutPostOverlayRedisplay
END INTERFACE

!  void glutPostWindowOverlayRedisplay(int win)
PUBLIC glutPostWindowOverlayRedisplay
INTERFACE
SUBROUTINE glutPostWindowOverlayRedisplay(win) BIND(C,NAME="glutPostWindowOverlayRedisplay")
IMPORT
INTEGER(GLint), VALUE :: win
END SUBROUTINE glutPostWindowOverlayRedisplay
END INTERFACE

!  void glutShowOverlay(void)
PUBLIC glutShowOverlay
INTERFACE
SUBROUTINE glutShowOverlay() BIND(C,NAME="glutShowOverlay")
IMPORT
END SUBROUTINE glutShowOverlay
END INTERFACE

!  void glutHideOverlay(void)
PUBLIC glutHideOverlay
INTERFACE
SUBROUTINE glutHideOverlay() BIND(C,NAME="glutHideOverlay")
IMPORT
END SUBROUTINE glutHideOverlay
END INTERFACE


!  GLUT menu sub-API. 
!  int glutCreateMenu(void (GLUTCALLBACK *func)(int item))
PUBLIC glutCreateMenu
INTERFACE
FUNCTION glutCreateMenu(func) BIND(C,NAME="glutCreateMenu")
IMPORT
INTEGER(GLint) :: glutCreateMenu
!  void func(int item)
INTERFACE
SUBROUTINE func(item) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: item
END SUBROUTINE func
END INTERFACE
END FUNCTION glutCreateMenu
END INTERFACE

!  void glutDestroyMenu(int menu)
PUBLIC glutDestroyMenu
INTERFACE
SUBROUTINE glutDestroyMenu(menu) BIND(C,NAME="glutDestroyMenu")
IMPORT
INTEGER(GLint), VALUE :: menu
END SUBROUTINE glutDestroyMenu
END INTERFACE

!  int glutGetMenu(void)
PUBLIC glutGetMenu
INTERFACE
FUNCTION glutGetMenu() BIND(C,NAME="glutGetMenu")
IMPORT
INTEGER(GLint) :: glutGetMenu
END FUNCTION glutGetMenu
END INTERFACE

!  void glutSetMenu(int menu)
PUBLIC glutSetMenu
INTERFACE
SUBROUTINE glutSetMenu(menu) BIND(C,NAME="glutSetMenu")
IMPORT
INTEGER(GLint), VALUE :: menu
END SUBROUTINE glutSetMenu
END INTERFACE

!  void glutAddMenuEntry(const char *label, int value)
PUBLIC glutAddMenuEntry
INTERFACE
SUBROUTINE glutAddMenuEntry(label, value) BIND(C,NAME="glutAddMenuEntry")
IMPORT
! CHARACTER, INTENT(IN) :: label
CHARACTER, DIMENSION(*), INTENT(IN) :: label
INTEGER(GLint), VALUE :: value
END SUBROUTINE glutAddMenuEntry
END INTERFACE

!  void glutAddSubMenu(const char *label, int submenu)
PUBLIC glutAddSubMenu
INTERFACE
SUBROUTINE glutAddSubMenu(label, submenu) BIND(C,NAME="glutAddSubMenu")
IMPORT
! CHARACTER, INTENT(IN) :: label
CHARACTER, DIMENSION(*), INTENT(IN) :: label
INTEGER(GLint), VALUE :: submenu
END SUBROUTINE glutAddSubMenu
END INTERFACE

!  void glutChangeToMenuEntry(int item, const char *label, int value)
PUBLIC glutChangeToMenuEntry
INTERFACE
SUBROUTINE glutChangeToMenuEntry(item, label, value) BIND(C,NAME="glutChangeToMenuEntry")
IMPORT
! CHARACTER, INTENT(IN) :: label
CHARACTER, DIMENSION(*), INTENT(IN) :: label
INTEGER(GLint), VALUE :: item, value
END SUBROUTINE glutChangeToMenuEntry
END INTERFACE

!  void glutChangeToSubMenu(int item, const char *label, int submenu)
PUBLIC glutChangeToSubMenu
INTERFACE
SUBROUTINE glutChangeToSubMenu(item, label, submenu) BIND(C,NAME="glutChangeToSubMenu")
IMPORT
! CHARACTER, INTENT(IN) :: label
CHARACTER, DIMENSION(*), INTENT(IN) :: label
INTEGER(GLint), VALUE :: item, submenu
END SUBROUTINE glutChangeToSubMenu
END INTERFACE

!  void glutRemoveMenuItem(int item)
PUBLIC glutRemoveMenuItem
INTERFACE
SUBROUTINE glutRemoveMenuItem(item) BIND(C,NAME="glutRemoveMenuItem")
IMPORT
INTEGER(GLint), VALUE :: item
END SUBROUTINE glutRemoveMenuItem
END INTERFACE

!  void glutAttachMenu(int button)
PUBLIC glutAttachMenu
INTERFACE
SUBROUTINE glutAttachMenu(button) BIND(C,NAME="glutAttachMenu")
IMPORT
INTEGER(GLint), VALUE :: button
END SUBROUTINE glutAttachMenu
END INTERFACE

!  void glutDetachMenu(int button)
PUBLIC glutDetachMenu
INTERFACE
SUBROUTINE glutDetachMenu(button) BIND(C,NAME="glutDetachMenu")
IMPORT
INTEGER(GLint), VALUE :: button
END SUBROUTINE glutDetachMenu
END INTERFACE


!  GLUT window callback sub-API. 
!  void glutDisplayFunc(void (GLUTCALLBACK *func)(void))
PUBLIC glutDisplayFunc
INTERFACE glutDisplayFunc
MODULE PROCEDURE glutDisplayFunc_f03
END INTERFACE glutDisplayFunc
INTERFACE
SUBROUTINE glutDisplayFunc_gl(func) BIND(C,NAME="glutDisplayFunc")
IMPORT
!  void func(void)
TYPE(C_FUNPTR), VALUE :: func
END SUBROUTINE glutDisplayFunc_gl
END INTERFACE

!  void glutReshapeFunc(void (GLUTCALLBACK *func)(int width, int height))
PUBLIC glutReshapeFunc
INTERFACE glutReshapeFunc
MODULE PROCEDURE glutReshapeFunc_f03
END INTERFACE glutReshapeFunc
INTERFACE
SUBROUTINE glutReshapeFunc_gl(func) BIND(C,NAME="glutReshapeFunc")
IMPORT
!  void func(int width, int height)
TYPE(C_FUNPTR), VALUE :: func
END SUBROUTINE glutReshapeFunc_gl
END INTERFACE

!  void glutKeyboardFunc(void (GLUTCALLBACK *func)(unsigned char key, int x, int y))
PUBLIC glutKeyboardFunc
INTERFACE glutKeyboardFunc
MODULE PROCEDURE glutKeyboardFunc_f03
END INTERFACE glutKeyboardFunc
INTERFACE
SUBROUTINE glutKeyboardFunc_gl(func) BIND(C,NAME="glutKeyboardFunc")
IMPORT
!  void func(unsigned char key, int x, int y)
TYPE(C_FUNPTR), VALUE :: func
END SUBROUTINE glutKeyboardFunc_gl
END INTERFACE

!  void glutMouseFunc(void (GLUTCALLBACK *func)(int button, int state, int x, int y))
PUBLIC glutMouseFunc
INTERFACE glutMouseFunc
MODULE PROCEDURE glutMouseFunc_f03
END INTERFACE glutMouseFunc
INTERFACE
SUBROUTINE glutMouseFunc_gl(func) BIND(C,NAME="glutMouseFunc")
IMPORT
!  void func(int button, int state, int x, int y)
TYPE(C_FUNPTR), VALUE :: func
END SUBROUTINE glutMouseFunc_gl
END INTERFACE

!  void glutMotionFunc(void (GLUTCALLBACK *func)(int x, int y))
PUBLIC glutMotionFunc
INTERFACE glutMotionFunc
MODULE PROCEDURE glutMotionFunc_f03
END INTERFACE glutMotionFunc
INTERFACE
SUBROUTINE glutMotionFunc_gl(func) BIND(C,NAME="glutMotionFunc")
IMPORT
!  void func(int x, int y)
TYPE(C_FUNPTR), VALUE :: func
END SUBROUTINE glutMotionFunc_gl
END INTERFACE

!  void glutPassiveMotionFunc(void (GLUTCALLBACK *func)(int x, int y))
PUBLIC glutPassiveMotionFunc
INTERFACE glutPassiveMotionFunc
MODULE PROCEDURE glutPassiveMotionFunc_f03
END INTERFACE glutPassiveMotionFunc
INTERFACE
SUBROUTINE glutPassiveMotionFunc_gl(func) BIND(C,NAME="glutPassiveMotionFunc")
IMPORT
!  void func(int x, int y)
TYPE(C_FUNPTR), VALUE :: func
END SUBROUTINE glutPassiveMotionFunc_gl
END INTERFACE

!  void glutEntryFunc(void (GLUTCALLBACK *func)(int state))
PUBLIC glutEntryFunc
INTERFACE glutEntryFunc
MODULE PROCEDURE glutEntryFunc_f03
END INTERFACE glutEntryFunc
INTERFACE
SUBROUTINE glutEntryFunc_gl(func) BIND(C,NAME="glutEntryFunc")
IMPORT
!  void func(int state)
TYPE(C_FUNPTR), VALUE :: func
END SUBROUTINE glutEntryFunc_gl
END INTERFACE

!  void glutVisibilityFunc(void (GLUTCALLBACK *func)(int state))
PUBLIC glutVisibilityFunc
INTERFACE glutVisibilityFunc
MODULE PROCEDURE glutVisibilityFunc_f03
END INTERFACE glutVisibilityFunc
INTERFACE
SUBROUTINE glutVisibilityFunc_gl(func) BIND(C,NAME="glutVisibilityFunc")
IMPORT
!  void func(int state)
TYPE(C_FUNPTR), VALUE :: func
END SUBROUTINE glutVisibilityFunc_gl
END INTERFACE

!  void glutIdleFunc(void (GLUTCALLBACK *func)(void))
PUBLIC glutIdleFunc
INTERFACE glutIdleFunc
MODULE PROCEDURE glutIdleFunc_f03
END INTERFACE glutIdleFunc
INTERFACE
SUBROUTINE glutIdleFunc_gl(func) BIND(C,NAME="glutIdleFunc")
IMPORT
!  void func(void)
TYPE(C_FUNPTR), VALUE :: func
END SUBROUTINE glutIdleFunc_gl
END INTERFACE

!  void glutTimerFunc(unsigned int millis, void (GLUTCALLBACK *func)(int value), int value)
PUBLIC glutTimerFunc
INTERFACE glutTimerFunc
MODULE PROCEDURE glutTimerFunc_f03
END INTERFACE glutTimerFunc
INTERFACE
SUBROUTINE glutTimerFunc_gl(millis, func, value) BIND(C,NAME="glutTimerFunc")
IMPORT
INTEGER(GLint), VALUE :: value
INTEGER(GLuint), VALUE :: millis
!  void func(int value)
TYPE(C_FUNPTR), VALUE :: func
END SUBROUTINE glutTimerFunc_gl
END INTERFACE

!  void glutMenuStateFunc(void (GLUTCALLBACK *func)(int state))
PUBLIC glutMenuStateFunc
INTERFACE glutMenuStateFunc
MODULE PROCEDURE glutMenuStateFunc_f03
END INTERFACE glutMenuStateFunc
INTERFACE
SUBROUTINE glutMenuStateFunc_gl(func) BIND(C,NAME="glutMenuStateFunc")
IMPORT
!  void func(int state)
TYPE(C_FUNPTR), VALUE :: func
END SUBROUTINE glutMenuStateFunc_gl
END INTERFACE

!  void glutSpecialFunc(void (GLUTCALLBACK *func)(int key, int x, int y))
PUBLIC glutSpecialFunc
INTERFACE glutSpecialFunc
MODULE PROCEDURE glutSpecialFunc_f03
END INTERFACE glutSpecialFunc
INTERFACE
SUBROUTINE glutSpecialFunc_gl(func) BIND(C,NAME="glutSpecialFunc")
IMPORT
!  void func(int key, int x, int y)
TYPE(C_FUNPTR), VALUE :: func
END SUBROUTINE glutSpecialFunc_gl
END INTERFACE

!  void glutSpaceballMotionFunc(void (GLUTCALLBACK *func)(int x, int y, int z))
PUBLIC glutSpaceballMotionFunc
INTERFACE glutSpaceballMotionFunc
MODULE PROCEDURE glutSpaceballMotionFunc_f03
END INTERFACE glutSpaceballMotionFunc
INTERFACE
SUBROUTINE glutSpaceballMotionFunc_gl(func) BIND(C,NAME="glutSpaceballMotionFunc")
IMPORT
!  void func(int x, int y, int z)
TYPE(C_FUNPTR), VALUE :: func
END SUBROUTINE glutSpaceballMotionFunc_gl
END INTERFACE

!  void glutSpaceballRotateFunc(void (GLUTCALLBACK *func)(int x, int y, int z))
PUBLIC glutSpaceballRotateFunc
INTERFACE glutSpaceballRotateFunc
MODULE PROCEDURE glutSpaceballRotateFunc_f03
END INTERFACE glutSpaceballRotateFunc
INTERFACE
SUBROUTINE glutSpaceballRotateFunc_gl(func) BIND(C,NAME="glutSpaceballRotateFunc")
IMPORT
!  void func(int x, int y, int z)
TYPE(C_FUNPTR), VALUE :: func
END SUBROUTINE glutSpaceballRotateFunc_gl
END INTERFACE

!  void glutSpaceballButtonFunc(void (GLUTCALLBACK *func)(int button, int state))
PUBLIC glutSpaceballButtonFunc
INTERFACE glutSpaceballButtonFunc
MODULE PROCEDURE glutSpaceballButtonFunc_f03
END INTERFACE glutSpaceballButtonFunc
INTERFACE
SUBROUTINE glutSpaceballButtonFunc_gl(func) BIND(C,NAME="glutSpaceballButtonFunc")
IMPORT
!  void func(int button, int state)
TYPE(C_FUNPTR), VALUE :: func
END SUBROUTINE glutSpaceballButtonFunc_gl
END INTERFACE

!  void glutButtonBoxFunc(void (GLUTCALLBACK *func)(int button, int state))
PUBLIC glutButtonBoxFunc
INTERFACE glutButtonBoxFunc
MODULE PROCEDURE glutButtonBoxFunc_f03
END INTERFACE glutButtonBoxFunc
INTERFACE
SUBROUTINE glutButtonBoxFunc_gl(func) BIND(C,NAME="glutButtonBoxFunc")
IMPORT
!  void func(int button, int state)
TYPE(C_FUNPTR), VALUE :: func
END SUBROUTINE glutButtonBoxFunc_gl
END INTERFACE

!  void glutDialsFunc(void (GLUTCALLBACK *func)(int dial, int value))
PUBLIC glutDialsFunc
INTERFACE glutDialsFunc
MODULE PROCEDURE glutDialsFunc_f03
END INTERFACE glutDialsFunc
INTERFACE
SUBROUTINE glutDialsFunc_gl(func) BIND(C,NAME="glutDialsFunc")
IMPORT
!  void func(int dial, int value)
TYPE(C_FUNPTR), VALUE :: func
END SUBROUTINE glutDialsFunc_gl
END INTERFACE

!  void glutTabletMotionFunc(void (GLUTCALLBACK *func)(int x, int y))
PUBLIC glutTabletMotionFunc
INTERFACE glutTabletMotionFunc
MODULE PROCEDURE glutTabletMotionFunc_f03
END INTERFACE glutTabletMotionFunc
INTERFACE
SUBROUTINE glutTabletMotionFunc_gl(func) BIND(C,NAME="glutTabletMotionFunc")
IMPORT
!  void func(int x, int y)
TYPE(C_FUNPTR), VALUE :: func
END SUBROUTINE glutTabletMotionFunc_gl
END INTERFACE

!  void glutTabletButtonFunc(void (GLUTCALLBACK *func)(int button, int state, int x, int y))
PUBLIC glutTabletButtonFunc
INTERFACE glutTabletButtonFunc
MODULE PROCEDURE glutTabletButtonFunc_f03
END INTERFACE glutTabletButtonFunc
INTERFACE
SUBROUTINE glutTabletButtonFunc_gl(func) BIND(C,NAME="glutTabletButtonFunc")
IMPORT
!  void func(int button, int state, int x, int y)
TYPE(C_FUNPTR), VALUE :: func
END SUBROUTINE glutTabletButtonFunc_gl
END INTERFACE

!  void glutMenuStatusFunc(void (GLUTCALLBACK *func)(int status, int x, int y))
PUBLIC glutMenuStatusFunc
INTERFACE glutMenuStatusFunc
MODULE PROCEDURE glutMenuStatusFunc_f03
END INTERFACE glutMenuStatusFunc
INTERFACE
SUBROUTINE glutMenuStatusFunc_gl(func) BIND(C,NAME="glutMenuStatusFunc")
IMPORT
!  void func(int status, int x, int y)
TYPE(C_FUNPTR), VALUE :: func
END SUBROUTINE glutMenuStatusFunc_gl
END INTERFACE

!  void glutOverlayDisplayFunc(void (GLUTCALLBACK *func)(void))
PUBLIC glutOverlayDisplayFunc
INTERFACE glutOverlayDisplayFunc
MODULE PROCEDURE glutOverlayDisplayFunc_f03
END INTERFACE glutOverlayDisplayFunc
INTERFACE
SUBROUTINE glutOverlayDisplayFunc_gl(func) BIND(C,NAME="glutOverlayDisplayFunc")
IMPORT
!  void func(void)
TYPE(C_FUNPTR), VALUE :: func
END SUBROUTINE glutOverlayDisplayFunc_gl
END INTERFACE

!  void glutWindowStatusFunc(void (GLUTCALLBACK *func)(int state))
PUBLIC glutWindowStatusFunc
INTERFACE glutWindowStatusFunc
MODULE PROCEDURE glutWindowStatusFunc_f03
END INTERFACE glutWindowStatusFunc
INTERFACE
SUBROUTINE glutWindowStatusFunc_gl(func) BIND(C,NAME="glutWindowStatusFunc")
IMPORT
!  void func(int state)
TYPE(C_FUNPTR), VALUE :: func
END SUBROUTINE glutWindowStatusFunc_gl
END INTERFACE

!  void glutKeyboardUpFunc(void (GLUTCALLBACK *func)(unsigned char key, int x, int y))
PUBLIC glutKeyboardUpFunc
INTERFACE glutKeyboardUpFunc
MODULE PROCEDURE glutKeyboardUpFunc_f03
END INTERFACE glutKeyboardUpFunc
INTERFACE
SUBROUTINE glutKeyboardUpFunc_gl(func) BIND(C,NAME="glutKeyboardUpFunc")
IMPORT
!  void func(unsigned char key, int x, int y)
TYPE(C_FUNPTR), VALUE :: func
END SUBROUTINE glutKeyboardUpFunc_gl
END INTERFACE

!  void glutSpecialUpFunc(void (GLUTCALLBACK *func)(int key, int x, int y))
PUBLIC glutSpecialUpFunc
INTERFACE glutSpecialUpFunc
MODULE PROCEDURE glutSpecialUpFunc_f03
END INTERFACE glutSpecialUpFunc
INTERFACE
SUBROUTINE glutSpecialUpFunc_gl(func) BIND(C,NAME="glutSpecialUpFunc")
IMPORT
!  void func(int key, int x, int y)
TYPE(C_FUNPTR), VALUE :: func
END SUBROUTINE glutSpecialUpFunc_gl
END INTERFACE

!  void glutJoystickFunc(void (GLUTCALLBACK *func)(unsigned int buttonMask, int x, int y, int z), int pollInterval)
PUBLIC glutJoystickFunc
INTERFACE glutJoystickFunc
MODULE PROCEDURE glutJoystickFunc_f03
END INTERFACE glutJoystickFunc
INTERFACE
SUBROUTINE glutJoystickFunc_gl(func, pollInterval) BIND(C,NAME="glutJoystickFunc")
IMPORT
INTEGER(GLint), VALUE :: pollInterval
!  void func(unsigned int buttonMask, int x, int y, int z)
TYPE(C_FUNPTR), VALUE :: func
END SUBROUTINE glutJoystickFunc_gl
END INTERFACE


!  GLUT color index sub-API. 
!  void glutSetColor(int ndx, GLfloat red, GLfloat green, GLfloat blue)
PUBLIC glutSetColor
INTERFACE
SUBROUTINE glutSetColor(ndx, red, green, blue) BIND(C,NAME="glutSetColor")
IMPORT
INTEGER(GLint), VALUE :: ndx
REAL(GLfloat), VALUE :: red, green, blue
END SUBROUTINE glutSetColor
END INTERFACE

!  GLfloat glutGetColor(int ndx, int component)
PUBLIC glutGetColor
INTERFACE
FUNCTION glutGetColor(ndx, component) BIND(C,NAME="glutGetColor")
IMPORT
REAL(GLfloat) :: glutGetColor
INTEGER(GLint), VALUE :: ndx, component
END FUNCTION glutGetColor
END INTERFACE

!  void glutCopyColormap(int win)
PUBLIC glutCopyColormap
INTERFACE
SUBROUTINE glutCopyColormap(win) BIND(C,NAME="glutCopyColormap")
IMPORT
INTEGER(GLint), VALUE :: win
END SUBROUTINE glutCopyColormap
END INTERFACE


!  GLUT state retrieval sub-API. 
!  int glutGet(GLenum type)
PUBLIC glutGet
INTERFACE
FUNCTION glutGet(type) BIND(C,NAME="glutGet")
IMPORT
INTEGER(GLint) :: glutGet
INTEGER(GLenum), VALUE :: type
END FUNCTION glutGet
END INTERFACE

!  int glutDeviceGet(GLenum type)
PUBLIC glutDeviceGet
INTERFACE
FUNCTION glutDeviceGet(type) BIND(C,NAME="glutDeviceGet")
IMPORT
INTEGER(GLint) :: glutDeviceGet
INTEGER(GLenum), VALUE :: type
END FUNCTION glutDeviceGet
END INTERFACE

!  GLUT extension support sub-API 
!  int glutExtensionSupported(const char *name)
PUBLIC glutExtensionSupported
INTERFACE
FUNCTION glutExtensionSupported(name) BIND(C,NAME="glutExtensionSupported")
IMPORT
INTEGER(GLint) :: glutExtensionSupported
! CHARACTER, INTENT(IN) :: name
CHARACTER, DIMENSION(*), INTENT(IN) :: name
END FUNCTION glutExtensionSupported
END INTERFACE

!  int glutGetModifiers(void)
PUBLIC glutGetModifiers
INTERFACE
FUNCTION glutGetModifiers() BIND(C,NAME="glutGetModifiers")
IMPORT
INTEGER(GLint) :: glutGetModifiers
END FUNCTION glutGetModifiers
END INTERFACE

!  int glutLayerGet(GLenum type)
PUBLIC glutLayerGet
INTERFACE
FUNCTION glutLayerGet(type) BIND(C,NAME="glutLayerGet")
IMPORT
INTEGER(GLint) :: glutLayerGet
INTEGER(GLenum), VALUE :: type
END FUNCTION glutLayerGet
END INTERFACE

!  void * glutGetProcAddress(const char *procName)
PUBLIC glutGetProcAddress
INTERFACE
FUNCTION glutGetProcAddress(procName) BIND(C,NAME="glutGetProcAddress")
IMPORT
TYPE(C_PTR) :: glutGetProcAddress
! CHARACTER, INTENT(IN) :: procName
CHARACTER, DIMENSION(*), INTENT(IN) :: procName
END FUNCTION glutGetProcAddress
END INTERFACE


!  GLUT font sub-API 
!  void glutBitmapCharacter(void *font, int character)
PUBLIC glutBitmapCharacter
INTERFACE
SUBROUTINE glutBitmapCharacter(font, character) BIND(C,NAME="glutBitmapCharacter")
IMPORT
INTEGER(GLint), VALUE :: character
TYPE(C_PTR), VALUE :: font
END SUBROUTINE glutBitmapCharacter
END INTERFACE

!  int glutBitmapWidth(void *font, int character)
PUBLIC glutBitmapWidth
INTERFACE
FUNCTION glutBitmapWidth(font, character) BIND(C,NAME="glutBitmapWidth")
IMPORT
INTEGER(GLint) :: glutBitmapWidth
INTEGER(GLint), VALUE :: character
TYPE(C_PTR), VALUE :: font
END FUNCTION glutBitmapWidth
END INTERFACE

!  void glutStrokeCharacter(void *font, int character)
PUBLIC glutStrokeCharacter
INTERFACE
SUBROUTINE glutStrokeCharacter(font, character) BIND(C,NAME="glutStrokeCharacter")
IMPORT
INTEGER(GLint), VALUE :: character
TYPE(C_PTR), VALUE :: font
END SUBROUTINE glutStrokeCharacter
END INTERFACE

!  int glutStrokeWidth(void *font, int character)
PUBLIC glutStrokeWidth
INTERFACE
FUNCTION glutStrokeWidth(font, character) BIND(C,NAME="glutStrokeWidth")
IMPORT
INTEGER(GLint) :: glutStrokeWidth
INTEGER(GLint), VALUE :: character
TYPE(C_PTR), VALUE :: font
END FUNCTION glutStrokeWidth
END INTERFACE

!  int glutBitmapLength(void *font, const unsigned char *string)
PUBLIC glutBitmapLength
INTERFACE
FUNCTION glutBitmapLength(font, string) BIND(C,NAME="glutBitmapLength")
IMPORT
INTEGER(GLint) :: glutBitmapLength
! CHARACTER, INTENT(IN) :: string
CHARACTER, DIMENSION(*), INTENT(IN) :: string
TYPE(C_PTR), VALUE :: font
END FUNCTION glutBitmapLength
END INTERFACE

!  int glutStrokeLength(void *font, const unsigned char *string)
PUBLIC glutStrokeLength
INTERFACE
FUNCTION glutStrokeLength(font, string) BIND(C,NAME="glutStrokeLength")
IMPORT
INTEGER(GLint) :: glutStrokeLength
! CHARACTER, INTENT(IN) :: string
CHARACTER, DIMENSION(*), INTENT(IN) :: string
TYPE(C_PTR), VALUE :: font
END FUNCTION glutStrokeLength
END INTERFACE


!  GLUT pre-built models sub-API 
!  void glutWireSphere(GLdouble radius, GLint slices, GLint stacks)
PUBLIC glutWireSphere
INTERFACE
SUBROUTINE glutWireSphere(radius, slices, stacks) BIND(C,NAME="glutWireSphere")
IMPORT
INTEGER(GLint), VALUE :: slices, stacks
REAL(GLdouble), VALUE :: radius
END SUBROUTINE glutWireSphere
END INTERFACE

!  void glutSolidSphere(GLdouble radius, GLint slices, GLint stacks)
PUBLIC glutSolidSphere
INTERFACE
SUBROUTINE glutSolidSphere(radius, slices, stacks) BIND(C,NAME="glutSolidSphere")
IMPORT
INTEGER(GLint), VALUE :: slices, stacks
REAL(GLdouble), VALUE :: radius
END SUBROUTINE glutSolidSphere
END INTERFACE

!  void glutWireCone(GLdouble base, GLdouble height, GLint slices, GLint stacks)
PUBLIC glutWireCone
INTERFACE
SUBROUTINE glutWireCone(base, height, slices, stacks) BIND(C,NAME="glutWireCone")
IMPORT
INTEGER(GLint), VALUE :: slices, stacks
REAL(GLdouble), VALUE :: base, height
END SUBROUTINE glutWireCone
END INTERFACE

!  void glutSolidCone(GLdouble base, GLdouble height, GLint slices, GLint stacks)
PUBLIC glutSolidCone
INTERFACE
SUBROUTINE glutSolidCone(base, height, slices, stacks) BIND(C,NAME="glutSolidCone")
IMPORT
INTEGER(GLint), VALUE :: slices, stacks
REAL(GLdouble), VALUE :: base, height
END SUBROUTINE glutSolidCone
END INTERFACE

!  void glutWireCube(GLdouble size)
PUBLIC glutWireCube
INTERFACE
SUBROUTINE glutWireCube(size) BIND(C,NAME="glutWireCube")
IMPORT
REAL(GLdouble), VALUE :: size
END SUBROUTINE glutWireCube
END INTERFACE

!  void glutSolidCube(GLdouble size)
PUBLIC glutSolidCube
INTERFACE
SUBROUTINE glutSolidCube(size) BIND(C,NAME="glutSolidCube")
IMPORT
REAL(GLdouble), VALUE :: size
END SUBROUTINE glutSolidCube
END INTERFACE

!  void glutWireTorus(GLdouble innerRadius, GLdouble outerRadius, GLint sides, GLint rings)
PUBLIC glutWireTorus
INTERFACE
SUBROUTINE glutWireTorus(innerRadius, outerRadius, sides, rings) BIND(C,NAME="glutWireTorus")
IMPORT
INTEGER(GLint), VALUE :: sides, rings
REAL(GLdouble), VALUE :: innerRadius, outerRadius
END SUBROUTINE glutWireTorus
END INTERFACE

!  void glutSolidTorus(GLdouble innerRadius, GLdouble outerRadius, GLint sides, GLint rings)
PUBLIC glutSolidTorus
INTERFACE
SUBROUTINE glutSolidTorus(innerRadius, outerRadius, sides, rings) BIND(C,NAME="glutSolidTorus")
IMPORT
INTEGER(GLint), VALUE :: sides, rings
REAL(GLdouble), VALUE :: innerRadius, outerRadius
END SUBROUTINE glutSolidTorus
END INTERFACE

!  void glutWireDodecahedron(void)
PUBLIC glutWireDodecahedron
INTERFACE
SUBROUTINE glutWireDodecahedron() BIND(C,NAME="glutWireDodecahedron")
IMPORT
END SUBROUTINE glutWireDodecahedron
END INTERFACE

!  void glutSolidDodecahedron(void)
PUBLIC glutSolidDodecahedron
INTERFACE
SUBROUTINE glutSolidDodecahedron() BIND(C,NAME="glutSolidDodecahedron")
IMPORT
END SUBROUTINE glutSolidDodecahedron
END INTERFACE

!  void glutWireTeapot(GLdouble size)
PUBLIC glutWireTeapot
INTERFACE
SUBROUTINE glutWireTeapot(size) BIND(C,NAME="glutWireTeapot")
IMPORT
REAL(GLdouble), VALUE :: size
END SUBROUTINE glutWireTeapot
END INTERFACE

!  void glutSolidTeapot(GLdouble size)
PUBLIC glutSolidTeapot
INTERFACE
SUBROUTINE glutSolidTeapot(size) BIND(C,NAME="glutSolidTeapot")
IMPORT
REAL(GLdouble), VALUE :: size
END SUBROUTINE glutSolidTeapot
END INTERFACE

!  void glutWireOctahedron(void)
PUBLIC glutWireOctahedron
INTERFACE
SUBROUTINE glutWireOctahedron() BIND(C,NAME="glutWireOctahedron")
IMPORT
END SUBROUTINE glutWireOctahedron
END INTERFACE

!  void glutSolidOctahedron(void)
PUBLIC glutSolidOctahedron
INTERFACE
SUBROUTINE glutSolidOctahedron() BIND(C,NAME="glutSolidOctahedron")
IMPORT
END SUBROUTINE glutSolidOctahedron
END INTERFACE

!  void glutWireTetrahedron(void)
PUBLIC glutWireTetrahedron
INTERFACE
SUBROUTINE glutWireTetrahedron() BIND(C,NAME="glutWireTetrahedron")
IMPORT
END SUBROUTINE glutWireTetrahedron
END INTERFACE

!  void glutSolidTetrahedron(void)
PUBLIC glutSolidTetrahedron
INTERFACE
SUBROUTINE glutSolidTetrahedron() BIND(C,NAME="glutSolidTetrahedron")
IMPORT
END SUBROUTINE glutSolidTetrahedron
END INTERFACE

!  void glutWireIcosahedron(void)
PUBLIC glutWireIcosahedron
INTERFACE
SUBROUTINE glutWireIcosahedron() BIND(C,NAME="glutWireIcosahedron")
IMPORT
END SUBROUTINE glutWireIcosahedron
END INTERFACE

!  void glutSolidIcosahedron(void)
PUBLIC glutSolidIcosahedron
INTERFACE
SUBROUTINE glutSolidIcosahedron() BIND(C,NAME="glutSolidIcosahedron")
IMPORT
END SUBROUTINE glutSolidIcosahedron
END INTERFACE


!  GLUT video resize sub-API. 
!  int glutVideoResizeGet(GLenum param)
PUBLIC glutVideoResizeGet
INTERFACE
FUNCTION glutVideoResizeGet(param) BIND(C,NAME="glutVideoResizeGet")
IMPORT
INTEGER(GLint) :: glutVideoResizeGet
INTEGER(GLenum), VALUE :: param
END FUNCTION glutVideoResizeGet
END INTERFACE

!  void glutSetupVideoResizing(void)
PUBLIC glutSetupVideoResizing
INTERFACE
SUBROUTINE glutSetupVideoResizing() BIND(C,NAME="glutSetupVideoResizing")
IMPORT
END SUBROUTINE glutSetupVideoResizing
END INTERFACE

!  void glutStopVideoResizing(void)
PUBLIC glutStopVideoResizing
INTERFACE
SUBROUTINE glutStopVideoResizing() BIND(C,NAME="glutStopVideoResizing")
IMPORT
END SUBROUTINE glutStopVideoResizing
END INTERFACE

!  void glutVideoResize(int x, int y, int width, int height)
PUBLIC glutVideoResize
INTERFACE
SUBROUTINE glutVideoResize(x, y, width, height) BIND(C,NAME="glutVideoResize")
IMPORT
INTEGER(GLint), VALUE :: x, y, width, height
END SUBROUTINE glutVideoResize
END INTERFACE

!  void glutVideoPan(int x, int y, int width, int height)
PUBLIC glutVideoPan
INTERFACE
SUBROUTINE glutVideoPan(x, y, width, height) BIND(C,NAME="glutVideoPan")
IMPORT
INTEGER(GLint), VALUE :: x, y, width, height
END SUBROUTINE glutVideoPan
END INTERFACE


!  GLUT debugging sub-API. 
!  void glutReportErrors(void)
PUBLIC glutReportErrors
INTERFACE
SUBROUTINE glutReportErrors() BIND(C,NAME="glutReportErrors")
IMPORT
END SUBROUTINE glutReportErrors
END INTERFACE


!  GLUT device control sub-API. 
!  glutSetKeyRepeat modes. 
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_REPEAT_OFF = 0
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_REPEAT_ON = 1
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_REPEAT_DEFAULT = 2

!  Joystick button masks. 
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_JOYSTICK_BUTTON_A = 1
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_JOYSTICK_BUTTON_B = 2
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_JOYSTICK_BUTTON_C = 4
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_JOYSTICK_BUTTON_D = 8

!  void glutIgnoreKeyRepeat(int ignore)
PUBLIC glutIgnoreKeyRepeat
INTERFACE
SUBROUTINE glutIgnoreKeyRepeat(ignore) BIND(C,NAME="glutIgnoreKeyRepeat")
IMPORT
INTEGER(GLint), VALUE :: ignore
END SUBROUTINE glutIgnoreKeyRepeat
END INTERFACE

!  void glutSetKeyRepeat(int repeatMode)
PUBLIC glutSetKeyRepeat
INTERFACE
SUBROUTINE glutSetKeyRepeat(repeatMode) BIND(C,NAME="glutSetKeyRepeat")
IMPORT
INTEGER(GLint), VALUE :: repeatMode
END SUBROUTINE glutSetKeyRepeat
END INTERFACE

!  void glutForceJoystickFunc(void)
PUBLIC glutForceJoystickFunc
INTERFACE
SUBROUTINE glutForceJoystickFunc() BIND(C,NAME="glutForceJoystickFunc")
IMPORT
END SUBROUTINE glutForceJoystickFunc
END INTERFACE


!  GLUT game mode sub-API. 
!  glutGameModeGet. 
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_GAME_MODE_ACTIVE = 0
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_GAME_MODE_POSSIBLE = 1
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_GAME_MODE_WIDTH = 2
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_GAME_MODE_HEIGHT = 3
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_GAME_MODE_PIXEL_DEPTH = 4
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_GAME_MODE_REFRESH_RATE = 5
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_GAME_MODE_DISPLAY_CHANGED = 6

!  void glutGameModeString(const char *string)
PUBLIC glutGameModeString
INTERFACE
SUBROUTINE glutGameModeString(string) BIND(C,NAME="glutGameModeString")
IMPORT
! CHARACTER, INTENT(IN) :: string
CHARACTER, DIMENSION(*), INTENT(IN) :: string
END SUBROUTINE glutGameModeString
END INTERFACE

!  int glutEnterGameMode(void)
PUBLIC glutEnterGameMode
INTERFACE
FUNCTION glutEnterGameMode() BIND(C,NAME="glutEnterGameMode")
IMPORT
INTEGER(GLint) :: glutEnterGameMode
END FUNCTION glutEnterGameMode
END INTERFACE

!  void glutLeaveGameMode(void)
PUBLIC glutLeaveGameMode
INTERFACE
SUBROUTINE glutLeaveGameMode() BIND(C,NAME="glutLeaveGameMode")
IMPORT
END SUBROUTINE glutLeaveGameMode
END INTERFACE

!  int glutGameModeGet(GLenum mode)
PUBLIC glutGameModeGet
INTERFACE
FUNCTION glutGameModeGet(mode) BIND(C,NAME="glutGameModeGet")
IMPORT
INTEGER(GLint) :: glutGameModeGet
INTEGER(GLenum), VALUE :: mode
END FUNCTION glutGameModeGet
END INTERFACE



! Font variables in GLUT_fonts.c
TYPE(C_PTR), BIND(C), PUBLIC, PROTECTED :: GLUT_STROKE_ROMAN,         &
    GLUT_STROKE_MONO_ROMAN, GLUT_BITMAP_9_BY_15, GLUT_BITMAP_8_BY_13, &
    GLUT_BITMAP_TIMES_ROMAN_10, GLUT_BITMAP_TIMES_ROMAN_24,           &
    GLUT_BITMAP_HELVETICA_10, GLUT_BITMAP_HELVETICA_12,               &
    GLUT_BITMAP_HELVETICA_18

! A special callback function for compatibility with f90gl
TYPE(C_FUNPTR), PUBLIC, SAVE, BIND(C) :: GLUT_NULL_FUNC=C_NULL_FUNPTR

CONTAINS

SUBROUTINE glutInit_f03()
  INTEGER(C_INT) :: argcp=1
  TYPE(C_PTR), DIMENSION(1), TARGET :: argv=C_NULL_PTR
  CHARACTER(C_CHAR), DIMENSION(1), TARGET :: empty_string=C_NULL_CHAR

  ! A hack
  INTERFACE
   SUBROUTINE SetNullFunc() BIND(C,NAME='SetNullFunc')
   END SUBROUTINE
  END INTERFACE  

  argv(1)=C_LOC(empty_string)
  CALL glutInit_gl(argcp, C_LOC(argv))
  
END SUBROUTINE

SUBROUTINE glutDisplayFunc_f03(func)
INTERFACE
SUBROUTINE func() BIND(C)
IMPORT
END SUBROUTINE func
END INTERFACE
OPTIONAL :: func
IF(PRESENT(func)) THEN
   CALL glutDisplayFunc_gl(C_FUNLOC(func))
ELSE
   CALL glutDisplayFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutDisplayFunc_f03
SUBROUTINE glutReshapeFunc_f03(func)
INTERFACE
SUBROUTINE func(width, height) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: width, height
END SUBROUTINE func
END INTERFACE
OPTIONAL :: func
IF(PRESENT(func)) THEN
   CALL glutReshapeFunc_gl(C_FUNLOC(func))
ELSE
   CALL glutReshapeFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutReshapeFunc_f03
SUBROUTINE glutKeyboardFunc_f03(func)
INTERFACE
SUBROUTINE func(key, x, y) BIND(C)
IMPORT
INTEGER(GLbyte), VALUE :: key
INTEGER(GLint), VALUE :: x, y
END SUBROUTINE func
END INTERFACE
OPTIONAL :: func
IF(PRESENT(func)) THEN
   CALL glutKeyboardFunc_gl(C_FUNLOC(func))
ELSE
   CALL glutKeyboardFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutKeyboardFunc_f03
SUBROUTINE glutMouseFunc_f03(func)
INTERFACE
SUBROUTINE func(button, state, x, y) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: button, state, x, y
END SUBROUTINE func
END INTERFACE
OPTIONAL :: func
IF(PRESENT(func)) THEN
   CALL glutMouseFunc_gl(C_FUNLOC(func))
ELSE
   CALL glutMouseFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutMouseFunc_f03
SUBROUTINE glutMotionFunc_f03(func)
INTERFACE
SUBROUTINE func(x, y) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: x, y
END SUBROUTINE func
END INTERFACE
OPTIONAL :: func
IF(PRESENT(func)) THEN
   CALL glutMotionFunc_gl(C_FUNLOC(func))
ELSE
   CALL glutMotionFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutMotionFunc_f03
SUBROUTINE glutPassiveMotionFunc_f03(func)
INTERFACE
SUBROUTINE func(x, y) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: x, y
END SUBROUTINE func
END INTERFACE
OPTIONAL :: func
IF(PRESENT(func)) THEN
   CALL glutPassiveMotionFunc_gl(C_FUNLOC(func))
ELSE
   CALL glutPassiveMotionFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutPassiveMotionFunc_f03
SUBROUTINE glutEntryFunc_f03(func)
INTERFACE
SUBROUTINE func(state) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: state
END SUBROUTINE func
END INTERFACE
OPTIONAL :: func
IF(PRESENT(func)) THEN
   CALL glutEntryFunc_gl(C_FUNLOC(func))
ELSE
   CALL glutEntryFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutEntryFunc_f03
SUBROUTINE glutVisibilityFunc_f03(func)
INTERFACE
SUBROUTINE func(state) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: state
END SUBROUTINE func
END INTERFACE
OPTIONAL :: func
IF(PRESENT(func)) THEN
   CALL glutVisibilityFunc_gl(C_FUNLOC(func))
ELSE
   CALL glutVisibilityFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutVisibilityFunc_f03
SUBROUTINE glutIdleFunc_f03(func)
INTERFACE
SUBROUTINE func() BIND(C)
IMPORT
END SUBROUTINE func
END INTERFACE
OPTIONAL :: func
IF(PRESENT(func)) THEN
   CALL glutIdleFunc_gl(C_FUNLOC(func))
ELSE
   CALL glutIdleFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutIdleFunc_f03
SUBROUTINE glutTimerFunc_f03(millis, func, value)
INTEGER(GLint), VALUE :: value
INTEGER(GLuint), VALUE :: millis
INTERFACE
SUBROUTINE func(value) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: value
END SUBROUTINE func
END INTERFACE
OPTIONAL :: func
IF(PRESENT(func)) THEN
   CALL glutTimerFunc_gl(millis, C_FUNLOC(func), value)
ELSE
   CALL glutTimerFunc_gl(millis, C_NULL_FUNPTR, value)
END IF
END SUBROUTINE glutTimerFunc_f03
SUBROUTINE glutMenuStateFunc_f03(func)
INTERFACE
SUBROUTINE func(state) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: state
END SUBROUTINE func
END INTERFACE
OPTIONAL :: func
IF(PRESENT(func)) THEN
   CALL glutMenuStateFunc_gl(C_FUNLOC(func))
ELSE
   CALL glutMenuStateFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutMenuStateFunc_f03
SUBROUTINE glutSpecialFunc_f03(func)
INTERFACE
SUBROUTINE func(key, x, y) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: key, x, y
END SUBROUTINE func
END INTERFACE
OPTIONAL :: func
IF(PRESENT(func)) THEN
   CALL glutSpecialFunc_gl(C_FUNLOC(func))
ELSE
   CALL glutSpecialFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutSpecialFunc_f03
SUBROUTINE glutSpaceballMotionFunc_f03(func)
INTERFACE
SUBROUTINE func(x, y, z) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: x, y, z
END SUBROUTINE func
END INTERFACE
OPTIONAL :: func
IF(PRESENT(func)) THEN
   CALL glutSpaceballMotionFunc_gl(C_FUNLOC(func))
ELSE
   CALL glutSpaceballMotionFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutSpaceballMotionFunc_f03
SUBROUTINE glutSpaceballRotateFunc_f03(func)
INTERFACE
SUBROUTINE func(x, y, z) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: x, y, z
END SUBROUTINE func
END INTERFACE
OPTIONAL :: func
IF(PRESENT(func)) THEN
   CALL glutSpaceballRotateFunc_gl(C_FUNLOC(func))
ELSE
   CALL glutSpaceballRotateFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutSpaceballRotateFunc_f03
SUBROUTINE glutSpaceballButtonFunc_f03(func)
INTERFACE
SUBROUTINE func(button, state) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: button, state
END SUBROUTINE func
END INTERFACE
OPTIONAL :: func
IF(PRESENT(func)) THEN
   CALL glutSpaceballButtonFunc_gl(C_FUNLOC(func))
ELSE
   CALL glutSpaceballButtonFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutSpaceballButtonFunc_f03
SUBROUTINE glutButtonBoxFunc_f03(func)
INTERFACE
SUBROUTINE func(button, state) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: button, state
END SUBROUTINE func
END INTERFACE
OPTIONAL :: func
IF(PRESENT(func)) THEN
   CALL glutButtonBoxFunc_gl(C_FUNLOC(func))
ELSE
   CALL glutButtonBoxFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutButtonBoxFunc_f03
SUBROUTINE glutDialsFunc_f03(func)
INTERFACE
SUBROUTINE func(dial, value) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: dial, value
END SUBROUTINE func
END INTERFACE
OPTIONAL :: func
IF(PRESENT(func)) THEN
   CALL glutDialsFunc_gl(C_FUNLOC(func))
ELSE
   CALL glutDialsFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutDialsFunc_f03
SUBROUTINE glutTabletMotionFunc_f03(func)
INTERFACE
SUBROUTINE func(x, y) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: x, y
END SUBROUTINE func
END INTERFACE
OPTIONAL :: func
IF(PRESENT(func)) THEN
   CALL glutTabletMotionFunc_gl(C_FUNLOC(func))
ELSE
   CALL glutTabletMotionFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutTabletMotionFunc_f03
SUBROUTINE glutTabletButtonFunc_f03(func)
INTERFACE
SUBROUTINE func(button, state, x, y) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: button, state, x, y
END SUBROUTINE func
END INTERFACE
OPTIONAL :: func
IF(PRESENT(func)) THEN
   CALL glutTabletButtonFunc_gl(C_FUNLOC(func))
ELSE
   CALL glutTabletButtonFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutTabletButtonFunc_f03
SUBROUTINE glutMenuStatusFunc_f03(func)
INTERFACE
SUBROUTINE func(status, x, y) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: status, x, y
END SUBROUTINE func
END INTERFACE
OPTIONAL :: func
IF(PRESENT(func)) THEN
   CALL glutMenuStatusFunc_gl(C_FUNLOC(func))
ELSE
   CALL glutMenuStatusFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutMenuStatusFunc_f03
SUBROUTINE glutOverlayDisplayFunc_f03(func)
INTERFACE
SUBROUTINE func() BIND(C)
IMPORT
END SUBROUTINE func
END INTERFACE
OPTIONAL :: func
IF(PRESENT(func)) THEN
   CALL glutOverlayDisplayFunc_gl(C_FUNLOC(func))
ELSE
   CALL glutOverlayDisplayFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutOverlayDisplayFunc_f03
SUBROUTINE glutWindowStatusFunc_f03(func)
INTERFACE
SUBROUTINE func(state) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: state
END SUBROUTINE func
END INTERFACE
OPTIONAL :: func
IF(PRESENT(func)) THEN
   CALL glutWindowStatusFunc_gl(C_FUNLOC(func))
ELSE
   CALL glutWindowStatusFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutWindowStatusFunc_f03
SUBROUTINE glutKeyboardUpFunc_f03(func)
INTERFACE
SUBROUTINE func(key, x, y) BIND(C)
IMPORT
INTEGER(GLbyte), VALUE :: key
INTEGER(GLint), VALUE :: x, y
END SUBROUTINE func
END INTERFACE
OPTIONAL :: func
IF(PRESENT(func)) THEN
   CALL glutKeyboardUpFunc_gl(C_FUNLOC(func))
ELSE
   CALL glutKeyboardUpFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutKeyboardUpFunc_f03
SUBROUTINE glutSpecialUpFunc_f03(func)
INTERFACE
SUBROUTINE func(key, x, y) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: key, x, y
END SUBROUTINE func
END INTERFACE
OPTIONAL :: func
IF(PRESENT(func)) THEN
   CALL glutSpecialUpFunc_gl(C_FUNLOC(func))
ELSE
   CALL glutSpecialUpFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutSpecialUpFunc_f03
SUBROUTINE glutJoystickFunc_f03(func, pollInterval)
INTEGER(GLint), VALUE :: pollInterval
INTERFACE
SUBROUTINE func(buttonMask, x, y, z) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: x, y, z
INTEGER(GLuint), VALUE :: buttonMask
END SUBROUTINE func
END INTERFACE
OPTIONAL :: func
IF(PRESENT(func)) THEN
   CALL glutJoystickFunc_gl(C_FUNLOC(func), pollInterval)
ELSE
   CALL glutJoystickFunc_gl(C_NULL_FUNPTR, pollInterval)
END IF
END SUBROUTINE glutJoystickFunc_f03


END MODULE OpenGL_glut

!> \file octtree3.F90

!> \brief the oct tree module 
!!
!<

!> oct-tree construction and types
module oct_tree_mod
use myf03_mod
use particle_system_mod
implicit none
 
 integer, private, parameter :: nsubcell = 2**3  !< number of daughter cells 
 integer, private, parameter :: bytespercell = 3 * 4 + 4 * 12 !< bytes per cell
 integer, private, parameter :: PartInCell = 12 !< dflt min particles in a leaf
 real, private :: tree_storage_factor !< guess at storage space for tree

 private check, error

!> oct-tree cell type
 type cell_type
    integer(i4b) :: start  !< index of head particle in the cell 
    integer(i4b) :: next   !< index of next cell on current or higher lvl  
    integer(i4b) :: daughter !< index of first daughter cell
    real(r4b) :: bot(1:3) !< oct-tree lower boundaries (fit particle positions)
    real(r4b) :: top(1:3) !< oct-tree upper boundaries (fit particle positions)
    real(r4b) :: botrange(1:3) !< AABB lower boundaries (fit smoothing lengths)
    real(r4b) :: toprange(1:3) !< AABB upper boundaries (fit smoothing lengths)
 end type cell_type
 
 !> oct-tree type
 type oct_tree_type
    integer(i8b) :: ppc    !< particles per cell
    integer(i8b) :: np     !< number of particles (rezero if theres a problem)
    integer(i8b) :: ncells     !< number of cells rezero if theres a problem
    integer(i8b) :: maxcells   !< maximum number of cells allowed
    integer(i8b) :: nplastcell !< work variable used to construct tree 
    integer(i4b), allocatable    :: partorder(:) !< ordered list of the pars
    integer(i4b), allocatable    :: cellorder(:) !< ordered list of the cells
    type(cell_type), allocatable :: cell(:)      !< the array of tree cells
 end type oct_tree_type


 contains



!> puts the particles in the particle system into the 
!! order described by the tree
!-----------------------------------------------------------------------------
subroutine setparticleorder(psys,tree)
  type(oct_tree_type) :: tree     !< the oct-tree
  type(particle_system_type) :: psys !< the particle system
  call check(psys,tree)
  call particle_system_order_particles(psys,tree%partorder)
end subroutine setparticleorder


!> makes sure the tree and the particle system know about the same number of 
!> particles
!-----------------------------------------------------------------------------
subroutine check(psys,tree)
  type(oct_tree_type), intent(in) :: tree  !< the oct-tree
  type(particle_system_type), intent(in) :: psys !< the particle system
  character(clen) :: string
  
  string = "N tree particles not equal to N psys particles"
  if(tree%np.NE.size(psys%par)) call error(string)
  
end subroutine check


!> constructs an oct-tree from the particle system with the minimum number of 
!> particles per leaf as an optional input (ppc)
!-----------------------------------------------------------------------------
 subroutine buildtree(psys, tree, MBalloc, ppc)

   character(clen), parameter :: myname="buildtree"
   logical, parameter :: crash=.true.
   integer, parameter :: verb=2
   character(clen) :: str,fmt

   type(particle_system_type), intent(in) :: psys !< input particle system
   type(oct_tree_type), intent(inout) :: tree     !< oct-tree
   real(r8b), intent(out) :: MBalloc              !< MB of memory allocated for tree
   integer(i4b), intent(in), optional :: ppc      !< optional minimum particles per leaf
   integer(i4b) :: err

   if (present(ppc)) then
      tree%ppc = ppc
   else
      tree%ppc = PartInCell  ! default
   end if

   fmt="(A,I4,A)"
   write(str,fmt) "attempting to build oct-tree with ", &
                        tree%ppc, " particles per cell:"
   call mywrite(str,verb-1) 
   call mywrite("",verb-1)

   tree_storage_factor = 2.5/tree%ppc

   tree_allocation: do 
      tree%maxcells = tree_storage_factor* size(psys%par)
      call maketree(psys,tree,MBalloc)
      call inittree(psys,tree)  
      call parttree(psys,tree,err)
      if(err /= 0) then
         call killtree(tree)
         call mywrite("   woops, guessed wrong for tree memory, increasing allocation",verb)
         tree_storage_factor = 1.414 * tree_storage_factor
      else
         exit tree_allocation
      end if
   end do tree_allocation

   call patchtree(tree)
   call makecellorder(tree)
   call shrinkcells2(psys,tree)

   fmt="(A,F8.4)"
   write(str,fmt) "   allocated tree cells / actual tree cells =  ", &
                          real(tree%maxcells)/tree%ncells
   call mywrite(str,verb) 
   call mywrite("",verb)
   
!  call adjustbox(psys%box, tree%cell(1)%bot, tree%cell(1)%top)
  
 end subroutine buildtree

!-----------------------------------------------
!> allocates the various parts of the oct-tree
subroutine maketree(psys,tree,MBalloc)

  character(clen), parameter :: myname="maketree"
  logical, parameter :: crash=.true.
  integer, parameter :: verb=2
  character(clen) :: str,fmt
  
  type(particle_system_type), intent(in) :: psys !< particle system
  type(oct_tree_type), intent(inout)   :: tree !< oct-tree
  real(r8b), intent(out) :: MBalloc !< MB of memory allocated for tree
  
  integer(i4b) :: err
  real(r8b) :: MB


  MBalloc = 0.0d0
  
  if (allocated(tree%partorder)) call killtree(tree)
  if (tree%maxcells == 0) call myerr(" maxcells=0",myname,crash)
  tree%np = size(psys%par)
    
  MB = tree%np * 4 / 2**20
  str = "cant allocate oct-tree%partorder [npar]"
  allocate(tree%partorder(1:tree%np),stat=err)
  if(err.ne.0) call myerr(str,myname,crash)     
  MBalloc = MBalloc + MB

  MB = max(tree%np,tree%maxcells) * 4 / 2**20
  str = "cant allocate oct-tree%cellorder max[npar,maxcells]"
  allocate(tree%cellorder(1:max(tree%np,tree%maxcells)),stat=err)
  if(err.ne.0) call myerr(str,myname,crash)
  MBalloc = MBalloc + MB     
  
  MB = (tree%maxcells+1) * bytespercell / 2**20
  str = "cant allocate oct-tree%cell [maxcells] "
  allocate(tree%cell(0:tree%maxcells),stat=err)
  if(err.ne.0) call myerr(str,myname,crash)     
  MBalloc = MBalloc + MB     

  fmt = "(A,F12.4,A)"
  write(str,fmt) "   allocated ", MBalloc, " MB for tree"
  call mywrite(str,verb) 
  
end subroutine maketree

!-----------------------------------------------
!> deallocates the various parts of the oct-tree
 subroutine killtree(tree)
   type(oct_tree_type) :: tree !< oct-tree
   integer(i4b) :: err !< deallocation error number
   character(clen) :: string  !< error string
     deallocate(tree%partorder, tree%cellorder, tree%cell, stat=err)
     string = "deallocation      "
     if(err.ne.0) call error(string,err)
     tree%np=0
 end subroutine

!--------------------------------------------------------------
!> determines which octant the vector ppos - pcell points into
function get_octant(pcell,ppos) result(octant)
  integer, parameter,dimension(3) :: nindex=(/ 1,2,4 /) 
  integer :: octant    !< 1-8 labeling the octant (ppos-pcell) points into.
  real :: pcell(3)     !< position of the center of the cell.
  real(r4b) :: ppos(3) !< an arbitrary point in space.
  integer :: k 
  octant = 1
  do k = 1, 3
     if (ppos(k).GT.pcell(k)) octant = octant + nindex(k)
  enddo
end function get_octant

!---------------------------------------------
!> dummy checks the particles per leaf number
subroutine setPPC(tree,ppc)
  integer ::ppc !< particles/leaf to this number if the current one is crazy
  type(oct_tree_type) :: tree !< oct-tree
  if(ppc.LT.1.OR.ppc.GT.100000) call error("ppc error")
  tree%ppc=ppc
end subroutine setPPC


  
!----------------------------------------------------------------------
!> initializes the tree variables for the zeroth, first, and last cells
 subroutine inittree(psys,tree)

   type(particle_system_type), intent(in) :: psys !< particle system
   type(oct_tree_type), intent(inout) :: tree !< oct-tree
   integer :: npar,i
   real :: bot(3),top(3),rsize

     npar = size(psys%par)

     if (npar <= 0) call error("no particles in psys   ")
     if (npar /= tree%np) call error("npar in psys /equal to npar in tree")  

     tree%cell(0)%start = npar+1
     tree%cell(1)%start = 1
     tree%cell(1)%next  = 0
     tree%cell(1)%daughter = 0
     tree%ncells=1
     tree%nplastcell=npar
 
     do i=1,3
        bot(i)=minval(psys%par(1:npar)%pos(i))
        top(i)=maxval(psys%par(1:npar)%pos(i))
     enddo
 
     rsize=maxval(top-bot)
     tree%cell(1)%bot(1:3)=0.5*(top+bot)-0.5*rsize
     tree%cell(1)%top(1:3)=tree%cell(1)%bot(1:3)+rsize
 
     do i=1,npar
        tree%partorder(i)=i
     enddo
     
 end subroutine inittree


!-------------------------------------------------------------------
!> recursive subroutine that constructs the rest of the tree cells
 recursive subroutine parttree(psys,tree,err)
 
   type(oct_tree_type) :: tree          !< oct-tree being built
   type(particle_system_type) :: psys   !< particle system
   integer(i4b) :: err                       !< error number
   integer, parameter :: off(24) = &
       (/ 0,0,0, 1,0,0, 0,1,0, 1,1,0, 0,0,1, 1,0,1, 0,1,1, 1,1,1 /)
   integer :: offset_factor(3,8)
                
   real :: ccpos(3),csize(3)
   integer :: j,subp(0:nsubcell+1),subind
   integer :: ccell,nppcell,newcell,sister
   
     err=0   
     offset_factor = reshape( off, (/3,8/) )
     ccell=tree%ncells
     nppcell=tree%nplastcell
     if(nppcell.GT.tree%ppc) then
        ccpos=(tree%cell(ccell)%top+tree%cell(ccell)%bot)/2
        csize=tree%cell(ccell)%top-tree%cell(ccell)%bot
        subp=0
        do j=tree%cell(ccell)%start,tree%cell(ccell)%start+nppcell-1
           subind=get_octant(ccpos,psys%par(tree%partorder(j))%pos)    
           subp(subind)=subp(subind)+1
        enddo
        subp(0)=0
        subp(nsubcell+1)=nppcell

        do j=nsubcell,1,-1
           subp(j)=subp(j+1)-subp(j) 
        enddo
        if(subp(1).NE.0) call error("subp count ")

        do j = tree%cell(ccell)%start, tree%cell(ccell)%start + nppcell - 1
           subind=get_octant(ccpos,psys%par(tree%partorder(j))%pos)
           subp(subind)=subp(subind)+1
           tree%cellorder(subp(subind))=tree%partorder(j)
        enddo

        do j=tree%cell(ccell)%start,tree%cell(ccell)%start+nppcell-1
           tree%partorder(j)=tree%cellorder(j-tree%cell(ccell)%start+1)
        enddo
        sister=0
        do j=1,nsubcell
           if(subp(j)-subp(j-1).GT.0) then 
              tree%ncells=tree%ncells+1
              newcell=tree%ncells

              if(newcell.GT.tree%maxcells) then
                err=1
                return
              end if

              tree%nplastcell=subp(j)-subp(j-1)

              if(tree%cell(ccell)%daughter.EQ.0) then
                 tree%cell(ccell)%daughter=newcell
              end if

              tree%cell(newcell)%start=subp(j-1)+tree%cell(ccell)%start
              tree%cell(newcell)%next=ccell
              tree%cell(newcell)%daughter=0
              tree%cell(newcell)%bot=tree%cell(ccell)%bot + &
                                     offset_factor(1:3,j)*csize/2
              tree%cell(newcell)%top=tree%cell(newcell)%bot+csize/2
              tree%cell(sister)%next=newcell
              sister=newcell
              call parttree(psys,tree,err)
              if(err.ne.0) return
           endif
        enddo
     endif
 end subroutine parttree

!------------------------------------------------------------------------------
!> fixes the cell pointers using the information from the fully built tree
 subroutine patchtree(tree)
   type(oct_tree_type) :: tree !> oct-tree being built
   integer ::i
     tree%cell(0)%next=0
     do i=1,tree%ncells
        if(tree%cell(i)%next < i) &
             tree%cell(i)%next=tree%cell(tree%cell(i)%next)%next
     enddo
 end subroutine patchtree


!----------------------------------
!> constructs the cell order array
 subroutine makecellorder(tree)
   type(oct_tree_type) :: tree !< oct-tree being built
   integer ::  ccount,dcell,i,up,pcell
   integer(i8b) :: low
   integer(i4b) :: err

     ccount=tree%ncells
     tree%cellorder(ccount)=1
     up=ccount+1
     low=ccount
     do while(up.GT.low)
        do i=up-1,low,-1
           pcell=tree%cellorder(i)
           dcell=tree%cell(pcell)%daughter
           if(dcell.NE.0) then
              ccount=ccount-1
              tree%cellorder(ccount)=dcell
              dcell=tree%cell(dcell)%next    
              do while(dcell.NE.tree%cell(pcell)%next)
                 ccount=ccount-1
                 tree%cellorder(ccount)=dcell
                 dcell=tree%cell(dcell)%next     
              enddo
           endif
        enddo
        up=low
        low=ccount
     enddo

     if(low.NE.1) then
        err=low
        call error("ordering ",err)
     endif

 end subroutine makecellorder

 !---------------------------------------------
 !> returns the number of particles in cell i
 function ppcell(tree,i) result (parincell)
   integer :: parincell  !< the number of particles in cell i 
   type(oct_tree_type) :: tree   !< the oct-tree 
   integer ::i !< the index of the cell to search
   parincell=tree%cell(tree%cell(i)%next)%start-tree%cell(i)%start
 end function

 !-----------------------------------------------------------
 !> makes the cell boundaries tight wrt to particle positions
 subroutine shrinkcells(psys,tree)
   type(particle_system_type), intent(in) :: psys !< particle system
   type(oct_tree_type), intent(out) :: tree   !< oct-tree being built
   integer :: i0,i,j,next
   real ::  x(3)
  
     do i0=1,tree%ncells
        i=tree%cellorder(i0)
        x=tree%cell(i)%top
        tree%cell(i)%top = tree%cell(i)%bot
        tree%cell(i)%bot = x
        next=tree%cell(i)%daughter

        if(next.EQ.0) then
           do j=tree%cell(i)%start,tree%cell(tree%cell(i)%next)%start-1
              x = psys%par(tree%partorder(j))%pos
              where( tree%cell(i)%bot .gt. x ) tree%cell(i)%bot=x
              where( tree%cell(i)%top .lt. x ) tree%cell(i)%top=x
           enddo
        else
           do while(next.NE.tree%cell(i)%next)
              x = tree%cell(next)%bot
              where( tree%cell(i)%bot .gt. x) tree%cell(i)%bot=x
              x = tree%cell(next)%top
              where( tree%cell(i)%top .lt. x) tree%cell(i)%top=x
              next = tree%cell(next)%next
           enddo
        endif
     enddo
 end subroutine shrinkcells

 !-----------------------------------------------------------
 !> makes the cell boundaries tight wrt to particle positions
 !! and the AABB boundaries tight wrt the smoothing lengths
 subroutine shrinkcells2(psys,tree)
   type(oct_tree_type) :: tree !< the oct-tree being built
   type(particle_system_type) :: psys !< particle system
   integer :: i0,i,j,next
   real(r4b) :: x(3),hsml
   character(clen) :: string
   
     do i0 = 1,tree%ncells
        i = tree%cellorder(i0)
        x = tree%cell(i)%top
        tree%cell(i)%top=tree%cell(i)%bot
        tree%cell(i)%bot=x
        tree%cell(i)%botrange=tree%cell(i)%bot
        tree%cell(i)%toprange=tree%cell(i)%top
        next=tree%cell(i)%daughter

        if(next.EQ.0) then
           if(tree%cell(tree%cell(i)%next)%start-tree%cell(i)%start.LT.1) then
              string = "zero part. cell?    "
              call error(string)
           end if
           do j=tree%cell(i)%start,tree%cell(tree%cell(i)%next)%start-1
              hsml=psys%par(tree%partorder(j))%hsml
              x(1:3)=psys%par(tree%partorder(j))%pos(1:3)

!             do these work correctly for each element of the array? yes
              tree%cell(i)%bot=min(tree%cell(i)%bot,x)
              tree%cell(i)%top=max(tree%cell(i)%top,x)
              tree%cell(i)%botrange=min(tree%cell(i)%botrange,x-hsml)
              tree%cell(i)%toprange=max(tree%cell(i)%toprange,x+hsml)
           enddo
        else
           do while(next.NE.tree%cell(i)%next)
              tree%cell(i)%bot=min(tree%cell(i)%bot,tree%cell(next)%bot)
              tree%cell(i)%top=max(tree%cell(i)%top,tree%cell(next)%top)
              tree%cell(i)%botrange= &
                   min(tree%cell(i)%botrange,tree%cell(next)%botrange)
              tree%cell(i)%toprange= &
                   max(tree%cell(i)%toprange,tree%cell(next)%toprange)
              next=tree%cell(next)%next
           enddo
        endif
     enddo
 end subroutine shrinkcells2


!--------------------------------------------------------------
!> returns the linear extent of the tree leaf that contains pos
 function getlocalscale(pos,tree) result(scale)

   real :: pos(3),scale
   type(oct_tree_type) :: tree
   integer :: next,this,daughter,old,end

   scale=sqrt(dist2cell(pos,tree%cell(1)))
   if(scale.GT.0) return
   old=1
   this=1
   next=1
   end=0
   do while(next.NE.end)
    this=next
    if(dist2cell(pos,tree%cell(this)).GT.0) then
     next=tree%cell(this)%next
!     print*,'a',next,dist2cell(pos,tree%cell(this))
    else
     daughter=tree%cell(this)%daughter
     if(daughter.EQ.0) exit
     old=this
     end=tree%cell(this)%next
!     print*,'b',daughter,dist2cell(pos,tree%cell(this))
     next=daughter
    endif       
   enddo

   scale=sum(tree%cell(old)%top-tree%cell(old)%bot)/3/2
   if(scale.LE.0) then
    call error('getlocalscale error')
   endif

!   print*,scale
!   print*,daughter,next,old
!   print*,tree%cell(old)%top,tree%cell(old)%bot
!   stop
 end function getlocalscale
 
!> calculates the distance squared from a point to the nearest of the 
!! cell walls.  returns zero for points inside the cell.
 function dist2cell(pos,cell) result(dist2)
  type(cell_type) :: cell
  real :: pos(3),lpos(3),upos(3),dist2
  integer :: k
  dist2=0
  lpos=cell%bot
  upos=cell%top
  do k=1,3
     if(pos(k).LT.lpos(k)) then
        dist2=dist2+(lpos(k)-pos(k))**2
     else
        if(pos(k).GT.upos(k)) then
           dist2=dist2+(upos(k)-pos(k))**2
        endif
     endif
  enddo

 end function dist2cell

!> a simple error handeling routine
 subroutine error(string,i)
   character(*) :: string !< error string
   integer(i4b), optional :: i !< optional error number
  
    print*,'error detected'

    if(present(i)) then
       print*,string,i
    else
       print*,string
    endif
    stop

 end subroutine error


end module oct_tree_mod

module amuse_sphrayMod
use myf03_mod
use global_mod, only: psys, PLAN,GV
use particle_system_mod, only: particle_type,source_type
implicit none
  
type(particle_type), allocatable :: par_buffer(:)
type(source_type), allocatable :: src_buffer(:)
  
integer(i8b) :: npar_buffer=0,nsrc_buffer=0
integer(i8b) :: nmaxpar_buffer=100000
integer(i8b) :: nmaxsrc_buffer=10000

integer(i8b) :: tot_id=0
integer(i8b) :: ngas=0,nsrc=0
integer, allocatable :: gid(:),sid(:)
logical :: gas_searcheable=.FALSE.
logical :: src_searcheable=.FALSE.

character(len=clen) :: data_directory='./'

!< [Config File] file containing spectra tables
character(len=clen) :: SpectraFile='./spectra/thermal1e5.cdf'
!< [Config File] file containing b2cd tables
character(len=clen) :: b2cdFile='./column_depth/latmon_b2cd_table.txt'
!< [Config File] file containnig atomic rates tables     
character(len=clen) :: AtomicRatesFile='./atomic_rates/atomic_rates_Hui.txt'
 
  real(r8b) :: RaysperUnitTime=1.e6

real(r8b) :: default_spectral_type = -1.


 contains

subroutine sphray_set_spectra_file(x)
  character(len=clen) :: x
  SpectraFile=x
end subroutine  

subroutine sphray_get_spectra_file(x)
  character(len=clen) :: x
  x=SpectraFile
end subroutine

subroutine sphray_set_data_directory(x)
  character(len=clen) :: x
  data_directory=x
end subroutine  

subroutine sphray_get_data_directory(x)
  character(len=clen) :: x
  x=data_directory
end subroutine  

subroutine sphray_set_output_directory(x)
  character(len=clen) :: x
  GV%OutputDir=x
end subroutine  

subroutine sphray_get_output_directory(x)
  character(len=clen) :: x
  x=GV%OutputDir
end subroutine  

function new_id()
  integer new_id
  tot_id=tot_id+1
  new_id=tot_id
end function

subroutine sphray_init
  use myf03_mod
  use mt19937_mod, only: init_mersenne_twister
  
  integer, parameter :: verb = 3    !< verbosity before config file is read

  myf03_verbosity = verb
  
  call set_default_parameters()
  
  call init_mersenne_twister(GV%IntSeed)
  
  call extend_par(par_buffer,nmaxpar_buffer)
  call extend_src(src_buffer,nmaxsrc_buffer)
    
end subroutine

function clean_gas(par) result(np)
  integer :: left,right,np
  type(particle_type), allocatable :: par(:)
  type(particle_type) :: tmp
  left=1
  if(.NOT.allocated(par)) then
    np = 0
    return
  endif
  right=size(par)
  if(right.EQ.0) then
    np=0
    return
  endif    
  do while(.TRUE.)
    do while(par(left)%mass.GE.0.AND.left.LT.right)
      left=left+1
    enddo
    do while(par(right)%mass.LT.0.AND.left.LT.right)
      right=right-1
    enddo
    if(left.LT.right) then
      tmp=par(left)
      par(left)=par(right)
      par(right)=tmp
    else
      exit
    endif  
  enddo  
  if(par(left)%mass.GE.0) left=left+1
  np=left-1
end function

function clean_src(par) result(np)
  integer :: left,right,np
  type(source_type), allocatable :: par(:)
  type(source_type) :: tmp
  left=1
  if(.NOT.allocated(par)) then
    np = 0
    return
  endif
  right=size(par)
  if(right.EQ.0) then
    np=0
    return
  endif    
  do while(.TRUE.)
    do while(par(left)%L.GE.0.AND.left.LT.right)
      left=left+1
    enddo
    do while(par(right)%L.LT.0.AND.left.LT.right)
      right=right-1
    enddo
    if(left<right) then
      tmp=par(left)
      par(left)=par(right)
      par(right)=tmp
    else
      exit
    endif  
  enddo  
  if(par(left)%L.GE.0) left=left+1
  np=left-1
end function

subroutine sphray_commit_particles
  integer :: n

 gas_searcheable=.FALSE.
 src_searcheable=.FALSE. 
 
 n=clean_gas(psys%par)
 if(npar_buffer.GT.0.OR.n.NE.size(psys%par)) then
   call extend_par(psys%par,n+npar_buffer)
   psys%par(n+1:n+npar_buffer)=par_buffer(1:npar_buffer)
   npar_buffer=0
 endif

 n=clean_src(psys%src)
 if(nsrc_buffer.GT.0.OR.n.NE.size(psys%src)) then
   call extend_src(psys%src,n+nsrc_buffer)
   psys%src(n+1:n+nsrc_buffer)=src_buffer(1:nsrc_buffer)
   nsrc_buffer=0
 endif

end subroutine

subroutine sphray_commit_parameters
  use global_mod, only: rtable,XHII_k,isoT_k
  use b2cd_mod, only: read_b2cd_file
  use spectra_mod, only: read_spectra_file
  use atomic_rates_mod, only: read_atomic_rates_file, get_atomic_rates
  use atomic_rates_mod, only: write_atomic_rates_to_log_file
  
  !< [Config File] file containing spectra tables
  GV%SpectraFile=trim(data_directory)//'/'//trim(SpectraFile) 
  !< [Config File] file containing b2cd tables
  GV%b2cdFile=trim(data_directory)//'/'//trim(b2cdFile)           
  !< [Config File] file containnig atomic rates tables
  GV%AtomicRatesFile=trim(data_directory)//'/'//trim(AtomicRatesFile) 
  
  call read_b2cd_file(GV%b2cdFile)
  call read_spectra_file(GV%SpectraFile)

  call read_atomic_rates_file(rtable, GV%AtomicRatesFile)
  call write_atomic_rates_to_log_file(rtable, GV%OutputDir)

  call get_atomic_rates(1.0d4, rtable, xHII_k)
  if (GV%IsoTemp > 0.0) then
    call get_atomic_rates(GV%IsoTemp, rtable, isoT_k)
  end if

  call amuse_planning_data
  call amuse_output_planning
  call amuse_ray_planning
  call amuse_initialize_global_variables

end subroutine

subroutine amuse_initialize_global_variables
  use gadget_General_class, only: gadget_constants_type
  use particle_system_mod, only: return_bytes_per_source
  use particle_system_mod, only: return_bytes_per_particle

  character(clen), parameter :: myname="initialize_global_variables"
  logical, parameter :: crash=.true.
  integer, parameter :: verb=2
  character(clen) :: str

  real, parameter :: zero = 0.0d0
  integer(i8b) :: nrays
  integer(i8b) :: i

  type(gadget_constants_type) :: gconst

  call mywrite("   initializing global variables",verb) 


  ! calculate total number of rays to be traced
  !----------------------------------------------------------------------
  nrays=GV%ForcedRayNumber

  ! report ionization solver being used and particle/source mem footprint
  !----------------------------------------------------------------------
  if (GV%IonTempSolver == 1) then
     call mywrite("   using Implicit Euler ionization solver",verb)
  else if (GV%IonTempSolver == 2) then
     call mywrite("   using Backwards Difference ionization solver",verb)
  end if

  GV%bytesperpar = return_bytes_per_particle()
  GV%bytespersrc = return_bytes_per_source()

  write(str,'(A,I4)') "   bytes per particle = ", GV%bytesperpar
  call mywrite(str, verb)

  write(str,'(A,I4)') "   bytes per source = ", GV%bytespersrc
  call mywrite(str, verb)

  ! open log files
  !-----------------
  GV%ionfrac_file = trim(GV%OutputDir) // "/ionfrac.log"
  call open_formatted_file_w(GV%ionfrac_file,GV%ionlun)

  GV%pardata_file = trim(GV%OutputDir) // "/particle_data.log"
  call open_formatted_file_w(GV%pardata_file,GV%pardatalun)

  GV%srcdata_file = trim(GV%OutputDir) // "/source_data.log"
  call open_formatted_file_w(GV%srcdata_file,GV%srcdatalun)


                 
  ! initialize counters and timers
  !---------------------------------
  GV%CurSnapNum = GV%StartSnapNum
  GV%rayn = 0
  GV%src_rayn = 0
  GV%MB = zero
 
  GV%itime = 0_i8b
  GV%start_time_code = 0.
  GV%start_time_s    = GV%start_time_code * GV%cgs_time / GV%LittleH
  GV%start_time_myr  = GV%start_time_s / gconst%sec_per_megayear

  GV%time_elapsed_code = zero
  GV%time_elapsed_s    = zero
  GV%time_elapsed_myr  = zero
      
  GV%TotalSourceRaysCast = zero
  GV%TotalDiffuseRaysCast = zero
  GV%IonizingPhotonsPerSec = zero
  GV%TotalPhotonsCast = zero
  GV%TotalPhotonsAbsorbed = zero
  GV%PhotonsLeavingBox = zero
  GV%TotalIonizations = zero
  GV%TotalRecombinations = zero
  
  GV%PeakUpdates = zero
  GV%AverageUpdatesPerPar = zero
  GV%ParticleCrossings = zero
  GV%TotalDerivativeCalls = zero
  
  call mywrite("",verb) 

end subroutine

subroutine amuse_planning_data()
  use gadget_general_class, only: gadget_units_type
  type(gadget_units_type) :: gunits

! one plan
  GV%Nsnaps = 1
  if (allocated(PLAN%snap)) deallocate(PLAN%snap)
  allocate( PLAN%snap(1) ) 
  
  PLAN%snap(1)%TimeAt=0.
  PLAN%snap(1)%ScaleFacAt=1.
  PLAN%snap(1)%StartTime=PLAN%snap(1)%TimeAt
  PLAN%snap(1)%SrcRays = 0 ! GV%ForcedRayNumber

! standard gadget units
  GV%cgs_len  = gunits%cgs_length
  GV%cgs_mass = gunits%cgs_mass
  GV%cgs_vel  = gunits%cgs_velocity
  GV%cgs_time = gunits%cgs_time
  GV%cgs_rho  = gunits%cgs_density
  GV%cgs_prs  = gunits%cgs_pressure
  GV%cgs_enrg = gunits%cgs_energy 

! inconsequential??
  GV%LenFac_cm=0.  !< code (input) length -> cm = cgs_len * a / h
  GV%MassFac_g=0.  !< code (input) mass -> g = cgs_mass / h
  GV%TimeFac_s=0.  !< code (input) time -> s = cgs_time / h
  GV%OmegaM=0.    !< matter / critical density z=0
  GV%OmegaB=0.    !< baryon / critical density z=0
  GV%OmegaL=0.    !< lambda / critical density z=0
  GV%LittleH=1.   !< Hubble parameter z=0 in units of 100 km/s/Mpc
! ----------------- 
 
  GV%Lunit=1.d50                  !< code source luminosity unit [photons/s]

end subroutine

subroutine amuse_output_planning
! equiv of do_output_planning
 allocate( PLAN%OutputTimes(0:1) )
 GV%NumTotOuts = GV%NumStdOuts  ! =-1
 PLAN%OutputTimes=1.d99   ! probably doesn't matter
! deferred to just before evolve 
end subroutine

subroutine amuse_ray_planning
! equiv of do_ray_planning
! I don;t think this has to do something
! deferred to just before evolve 
end subroutine

subroutine sphray_end

end subroutine 

function sphray_get_gas_particle_state(id,mass,hsml,x,y,z,rho,xe,u) result(ret)
  integer(i4b) :: id
  real(r4b) :: mass, hsml,x,y,z, &
    rho, u , xe 
  integer(i4b) :: i,index,ret

    index=find_gas(id)
    if(index.LT.0) then
      ret=index
      return
    endif  
        
    mass=psys%par(index)%mass
    x=psys%par(index)%pos(1)
    y=psys%par(index)%pos(2)
    z=psys%par(index)%pos(3)
    hsml=psys%par(index)%hsml
    rho=psys%par(index)%rho
    xe=psys%par(index)%xHII
    u=u_from_temp( real(psys%par(index)%T, r8b) , &
                   real(psys%par(index)%ye,r8b) , &
                   GV%H_mf ) 
    ret=0

end function


function sphray_set_gas_particle_state(ids,mass,hsml,x,y,z,rho,xe,u) result(ret)
  integer(i4b) ::  ids
  real(r4b) :: mass, hsml,x,y,z, &
    rho, u , xe 
  integer(i4b) :: i,index,ret

    index=find_gas(ids)
    if(index.LT.0) then
      ret=index
      return
    endif  
    psys%par(index)%mass=mass
    psys%par(index)%pos(1)=x
    psys%par(index)%pos(2)=y
    psys%par(index)%pos(3)=z
    psys%par(index)%hsml=hsml
    psys%par(index)%rho=rho
    psys%par(index)%ye=xe
    psys%par(index)%T=temp_from_u( real(u,r8b) , real(xe,r8b), GV%H_mf)  

    ret=0

end function


function sphray_set_gas_particle_pos(ids,x,y,z) result(ret)
  integer(i4b) ::  ids
  real(r4b) :: mass, hsml,x,y,z, &
    rho, u , xe 
  integer(i4b) :: i,index,ret

    index=find_gas(ids)
    if(index.LT.0) then
      ret=index
      return
    endif  
    psys%par(index)%pos(1)=x
    psys%par(index)%pos(2)=y
    psys%par(index)%pos(3)=z

    ret=0

end function


function sphray_set_gas_particle_rho(ids,rho) result(ret)
  integer(i4b) ::  ids
  real(r4b) :: mass, hsml,x,y,z, &
    rho, u , xe 
  integer(i4b) :: i,index,ret

    index=find_gas(ids)
    if(index.LT.0) then
      ret=index
      return
    endif  
    psys%par(index)%rho=rho

    ret=0

end function


function sphray_set_gas_particle_hsml(ids,hsml) result(ret)
  integer(i4b) ::  ids
  real(r4b) :: mass, hsml,x,y,z, &
    rho, u , xe 
  integer(i4b) :: i,index,ret

    index=find_gas(ids)
    if(index.LT.0) then
      ret=index
      return
    endif  
    psys%par(index)%hsml=hsml

    ret=0

end function


function sphray_set_gas_particle_u(ids,u) result(ret)
  integer(i4b) ::  ids
  real(r4b) :: u
  integer(i4b) :: i,index,ret

    index=find_gas(ids)
    if(index.LT.0) then
      ret=index
      return
    endif  
    psys%par(index)%T=temp_from_u( real(u,r8b) , real(psys%par(index)%ye,r8b), GV%H_mf)  

    ret=0

end function


function sphray_set_gas_particle_vel(ids,vx,vy,vz) result(ret)
  integer(i4b) ::  ids
  real(r4b) :: mass, hsml, vx, vy, vz, rho, u , xe 
  integer(i4b) :: i,index,ret

  ret=0
#ifdef incVel
    index=find_gas(ids)
    if(index.LT.0) then
      ret=index
      return
    endif  
    psys%par(index)%vel(1)=vx
    psys%par(index)%vel(2)=vy
    psys%par(index)%vel(3)=vz
    ret=0
#endif

end function


function sphray_get_gas_particle_vel(ids,vx,vy,vz) result(ret)
  integer(i4b) ::  ids
  real(r4b) :: mass, hsml,vx,vy,vz, rho, u , xe 
  integer(i4b) :: i,index,ret

  ret=0
  vx=0;vy=0;vz=0
#ifdef incVel
    index=find_gas(ids)
    if(index.LT.0) then
      ret=index
      return
    endif  
    vx=psys%par(index)%vel(1)
    vy=psys%par(index)%vel(2)
    vz=psys%par(index)%vel(3)
    ret=0
#endif

end function



function sphray_set_gas_particle_dudt(ids,dudt) result(ret)
  integer(i4b) ::  ids
  real(r4b) :: dudt 
  integer(i4b) :: i,index,ret

  ret=0
#ifdef incHeat
    index=find_gas(ids)
    if(index.LT.0) then
      ret=index
      return
    endif  
    psys%par(index)%dinternalEdt=dudt
    ret=0
#endif

end function


function sphray_get_gas_particle_dudt(ids,dudt) result(ret)
  integer(i4b) ::  ids
  real(r4b) :: dudt 
  integer(i4b) :: i,index,ret

  ret=0
  dudt=0
#ifdef incHeat
    index=find_gas(ids)
    if(index.LT.0) then
      ret=index
      return
    endif  
    dudt=psys%par(index)%dinternalEdt
    ret=0
#endif

end function


function sphray_get_src_particle_state(id,L,x,y,z,SpcType) result(ret)
  integer(i4b) :: id
  real(r4b) :: L,x,y,z,SpcType
  integer(i4b) :: i,index,ret

    index=find_src(id)
    if(index.LT.0) then
      ret=index
      return
    endif  
    
    L=psys%src(index)%L
    x=psys%src(index)%pos(1)
    y=psys%src(index)%pos(2)
    z=psys%src(index)%pos(3)
    SpcType=psys%src(index)%SpcType
    ret=0

end function

function sphray_set_src_particle_state(id,L,x,y,z,SpcType) result(ret)
  integer(i4b) ::  id
  real(r4b) :: L,x,y,z,SpcType
  integer(i4b) :: i,index,ret

    index=find_src(id)
    if(index.LT.0) then
      ret=index
      return
    endif  
        
    psys%src(index)%L=L
    psys%src(index)%pos(1)=x
    psys%src(index)%pos(2)=y
    psys%src(index)%pos(3)=z
    if(SpcType.NE.0) then
      psys%src(index)%SpcType=SpcType
    else
      psys%src(index)%SpcType=default_spectral_type
    endif
    ret=0
end function

function sphray_set_src_particle_luminosity(id,L) result(ret)
  integer(i4b) ::  id
  real(r4b) :: L
  integer(i4b) :: i,index,ret

    index=find_src(id)
    if(index.LT.0) then
      ret=index
      return
    endif  
        
    psys%src(index)%L=L
    ret=0
end function


subroutine sphray_add_gas_particle(id,mass,hsml,x,y,z,rho,xe,u,vx,vy,vz)
  use particle_system_mod, only: particle_set_ye, particle_set_ci_eq
  integer(i4b) ::  id
  real(r4b) :: mass, hsml, x, y, z, rho, u , xe, vx, vy, vz 
  integer(i4b) :: i
  logical :: DoH
  logical :: DoHe 
  logical :: caseA(2)

  gas_searcheable=.FALSE.
  
  do while(npar_buffer+1.GT.nmaxpar_buffer) 
    nmaxpar_buffer=2*nmaxpar_buffer
    call extend_par(par_buffer,nmaxpar_buffer)
  enddo
  
  ngas=ngas+1
  id=new_id()
  npar_buffer=npar_buffer+1
  par_buffer(npar_buffer)%mass=mass
  par_buffer(npar_buffer)%id=id
  par_buffer(npar_buffer)%pos(1)=x
  par_buffer(npar_buffer)%pos(2)=y
  par_buffer(npar_buffer)%pos(3)=z
#ifdef incVel
  par_buffer(npar_buffer)%vel(1)=vx
  par_buffer(npar_buffer)%vel(2)=vy
  par_buffer(npar_buffer)%vel(3)=vz
#endif
  par_buffer(npar_buffer)%hsml=hsml
  par_buffer(npar_buffer)%rho=rho
  par_buffer(npar_buffer)%T=temp_from_u( real(u,r8b) , real(xe,r8b), GV%H_mf)   
  par_buffer(npar_buffer)%ye=xe   
  par_buffer(npar_buffer)%xHI=1-xe   
  par_buffer(npar_buffer)%xHII=xe
#ifdef incHeat  
  par_buffer(npar_buffer)%dinternalEdt=0.
#endif

!  caseA = .false.
!  if (GV%HydrogenCaseA) caseA(1) = .true.
!  if (GV%HeliumCaseA)   caseA(2) = .true.

!  DoH = .true.
!#ifdef incHe
!  DoHe = .true.
!#else
!  DoHe = .false.
!#endif

!  call particle_set_ci_eq( par_buffer(npar_buffer), caseA, DoH, DoHe, fit='hui' )
!  call particle_set_ye( par_buffer(npar_buffer), GV%H_mf, GV%He_mf, GV%NeBackground )

end subroutine

subroutine sphray_add_src_particle(id,L,x,y,z,SpcType)
  integer(i4b) ::  id
  real(r4b) :: L,  x,y,z,SpcType
  integer(i4b) :: i

  src_searcheable=.FALSE. 
  
  do while(nsrc_buffer+1.GT.nmaxsrc_buffer)
    nmaxsrc_buffer=nmaxsrc_buffer*2 
    call extend_src(src_buffer,nmaxsrc_buffer)
  enddo 
    
    nsrc=nsrc+1
    id=new_id()
    nsrc_buffer=nsrc_buffer+1
    src_buffer(nsrc_buffer)%L=L
    src_buffer(nsrc_buffer)%id=id   
    src_buffer(nsrc_buffer)%pos(1)=x
    src_buffer(nsrc_buffer)%pos(2)=y
    src_buffer(nsrc_buffer)%pos(3)=z
#ifdef incVel
    src_buffer(nsrc_buffer)%vel(1)=0.
    src_buffer(nsrc_buffer)%vel(2)=0.
    src_buffer(nsrc_buffer)%vel(3)=0.
#endif
    if(SpcType.NE.0) then
      src_buffer(nsrc_buffer)%SpcType=SpcType
    else
      src_buffer(nsrc_buffer)%SpcType=default_spectral_type
    endif
    src_buffer(nsrc_buffer)%EmisPrf=0
    src_buffer(nsrc_buffer)%lastemit=GV%rayn
    
end subroutine









function sphray_get_wall_src_state(id,L,SpcType,EmisPrf) result(ret)
  integer(i4b) :: id
  real(r4b) :: L,SpcType
  integer(i4b) :: i,index,ret,EmisPrf

    index=find_src(id)
    if(index.LT.0) then
      ret=index
      return
    endif  
    
    L=psys%src(index)%L
    SpcType=psys%src(index)%SpcType
    EmisPrf=psys%src(index)%EmisPrf
    ret=0

end function


function sphray_set_wall_src_state(id,L,SpcType,EmisPrf) result(ret)
  integer(i4b) ::  id
  real(r4b) :: L,SpcType
  integer(i4b) :: i,index,ret,EmisPrf

    index=find_src(id)
    if(index.LT.0) then
      ret=index
      return
    endif  
        
    psys%src(index)%L=L
    if(SpcType.NE.0) then
      psys%src(index)%SpcType=SpcType
    else
      psys%src(index)%SpcType=default_spectral_type
    endif

    psys%src(index)%EmisPrf=EmisPrf

    ret=0
end function



subroutine sphray_add_wall_src(id,F,SpcType,EmisPrf)
  integer(i4b) ::  id
  real(r4b) :: F,L,SpcType
  integer(i4b) :: i
  integer(i4b) :: EmisPrf

  src_searcheable=.FALSE. 
  
  do while(nsrc_buffer+1.GT.nmaxsrc_buffer)
    nmaxsrc_buffer=nmaxsrc_buffer*2 
    call extend_src(src_buffer,nmaxsrc_buffer)
  enddo 

  nsrc=nsrc+1
  id=new_id()
  nsrc_buffer=nsrc_buffer+1
    
  ! for a wall source we take F = photons / cm^2 as input
  ! and convert it to L = photons / s using the wall size
  ! this assumes the box is square

  L = F * psys%box%lens_cm(1)**2

  src_buffer(nsrc_buffer)%L=L
  src_buffer(nsrc_buffer)%id=id   

  ! position should never be used for a wall source 

  src_buffer(nsrc_buffer)%pos(1) = 0.0d0
  src_buffer(nsrc_buffer)%pos(2) = 0.0d0
  src_buffer(nsrc_buffer)%pos(3) = 0.0d0

  if(SpcType.NE.0) then
     src_buffer(nsrc_buffer)%SpcType=SpcType
  else
      src_buffer(nsrc_buffer)%SpcType=default_spectral_type
   endif
   src_buffer(nsrc_buffer)%EmisPrf=EmisPrf
   src_buffer(nsrc_buffer)%lastemit=GV%rayn
    
end subroutine



function sphray_remove_gas_particle(id) result(ret)
  integer(i4b) :: id
  integer(i4b) :: index,ret

  index=find_gas(id)
  if(index.LT.0) then
    ret=index
    return
  endif  

  psys%par(index)%mass=-1
  ngas=ngas-1
  ret=0
end function

function sphray_remove_src_particle(id) result(ret)
  integer(i4b) :: id
  integer(i4b) :: index,ret

  index=find_src(id)
  if(index.LT.0) then
    ret=index
    return
  endif  

  psys%src(index)%L=-1
  nsrc=nsrc-1
  ret=0
end function

subroutine sphray_evolve(tend)
  use particle_system_mod, only: particle_system_set_ye
  use amuse_mainloop_mod
  real(r8b) :: tend

  if(tend.LE.PLAN%snap(1)%TimeAt) return 
  PLAN%snap(1)%TimeToNext=tend
  PLAN%snap(1)%RunTime=tend-PLAN%snap(1)%TimeAt
  
  GV%ForcedRayNumber=RaysperUnitTime*(tend-PLAN%snap(1)%TimeAt)
  if(GV%ForcedRayNumber.LE.0) call myerr("no rays to trace??","sphray_evolve",.true.)
  
  PLAN%snap(1)%StartTime=PLAN%snap(1)%TimeAt
  PLAN%snap(1)%SrcRays = GV%ForcedRayNumber

  call preparemain
  call mainloop

  call particle_system_set_ye(psys, GV%H_mf, GV%He_mf, GV%NeBackground)

  PLAN%snap(1)%TimeAt=tend
  gas_searcheable=.FALSE.
  src_searcheable=.FALSE. 
    
end subroutine

function sphray_model_time() result(time)
  use amuse_mainloop_mod
  real(r8b) :: time
  time=PLAN%snap(1)%TimeAt
end function

subroutine sphray_set_model_time(time) 
  use amuse_mainloop_mod
  real(r8b) :: time
  PLAN%snap(1)%TimeAt=time   ! is this safe? 
end subroutine


subroutine preparemain()
  use gadget_General_class, only: gadget_constants_type
  use atomic_rates_mod, only: read_atomic_rates_file, get_atomic_rates
  use global_mod, only: set_dt_from_dtcode,rtable,cmbT_k
  use particle_system_mod, only: particle_system_enforce_x_and_T_minmax
  use source_input_mod, only: order_sources_lum


  type(gadget_constants_type) :: gconst
  real(r8b) :: a=1.     !< scale factor
  real(r8b) :: h=1.     !< Hubble paraemter (little H)
  integer(i4b) :: i

! most of this stuff should go into (re)commit parameters/particles

  psys%box%tops = GV%BoxUprs
  psys%box%bots = GV%BoxLwrs

  psys%box%lens    = GV%BoxUprs - GV%BoxLwrs
  psys%box%lens_cm = psys%box%lens * GV%cgs_len

  psys%box%vol    = product( psys%box%lens )
  psys%box%vol_cm = product( psys%box%lens_cm )

  psys%box%tbound = GV%BndryCond
  psys%box%bbound = GV%BndryCond

  if(size(psys%src).GT.0) call order_sources_lum(psys%src)
!  psys%src%lastemit = GV%rayn
! to recommit parameter

!  psys%src%lastemit = 0

!from readin_snaps
#ifdef outGammaHI
  psys%par(:)%gammaHI = 0.0
  psys%par(:)%time = 0.0
#endif

  ! scale the data if we need to
  !=====================================================================

  ! convert number density to flux for planar sources
  !==========================================================

  ! set EOS particles to EOS temp if you want
  !=======================================================

  ! set SFR particles to EOS temp if you want
  !=======================================================


  ! set constant temperature if we have one
  !=======================================================
  if (GV%IsoTemp > 0.0) psys%par(:)%T = GV%IsoTemp

  ! cap the ionization fractions and temperatures if we have to
  !================================================================
  call particle_system_enforce_x_and_T_minmax( &
       psys, GV%xfloor, GV%xceiling, GV%Tfloor, GV%Tceiling )

  ! and the rest of the stuff
  !===============================================================
  GV%dt_code = PLAN%snap(GV%CurSnapNum)%RunTime / PLAN%snap(GV%CurSnapNum)%SrcRays
  call set_dt_from_dtcode( GV )
  
  GV%Tcmb_cur = gconst%t_cmb0 / a
  call get_atomic_rates(GV%Tcmb_cur, rtable, cmbT_k)

  GV%total_mass = 0.0d0
  do i = 1,size(psys%par)
     GV%total_mass = GV%total_mass + psys%par(i)%mass
  end do
  
  GV%total_lum = 0.0d0
  do i = 1,size(psys%src)
     GV%total_lum = GV%total_lum + psys%src(i)%L
  end do
  
  GV%total_atoms = GV%total_mass * GV%cgs_mass * &
       (GV%H_mf  / (gconst%protonmass) + &
       GV%He_mf / (4*gconst%protonmass) )


  GV%total_photons = (GV%TotalSimTime * GV%cgs_time / GV%LittleH) * (GV%total_lum * GV%Lunit)

end subroutine

subroutine sphray_set_isothermal(flag)
  logical :: flag
  GV%FixSnapTemp=flag
end subroutine

subroutine sphray_get_isothermal(flag)
  logical :: flag
  flag=GV%FixSnapTemp
end subroutine

subroutine sphray_set_momentum_kicks(flag)
  logical :: flag
  GV%DoMomentumKicks=flag
end subroutine

subroutine sphray_get_momentum_kicks(flag)
  logical :: flag
  flag=GV%DoMomentumKicks
end subroutine

subroutine sphray_set_H_caseA(flag)
  logical :: flag
  GV%HydrogenCaseA=flag
end subroutine

subroutine sphray_get_H_caseA(flag)
  logical :: flag
  flag=GV%HydrogenCaseA
end subroutine

subroutine sphray_set_He_caseA(flag)
  logical :: flag
  GV%HeliumCaseA=flag
end subroutine

subroutine sphray_get_He_caseA(flag)
  logical :: flag
  flag=GV%HeliumCaseA
end subroutine

subroutine sphray_set_raynumber(x)
  real(r8b) :: x
  RaysperUnitTime=x
end subroutine

subroutine sphray_get_raynumber(x)
  real(r8b) :: x
  x=RaysperUnitTime
end subroutine

subroutine sphray_set_iontempsolver(N)
  integer(i4b) :: N
  GV%IonTempSolver=N
end subroutine

subroutine sphray_get_iontempsolver(N)
  integer(i4b) :: N
  N=GV%IonTempSolver
end subroutine

subroutine sphray_set_boundary(N)
  integer(i4b) :: N
  GV%BndryCond=N
end subroutine

subroutine sphray_get_boundary(N)
  integer(i4b) :: N
  N=GV%BndryCond
end subroutine

subroutine sphray_set_boxsize(x)
  real(r8b) :: x
  GV%BoxUprs=x/2
  GV%BoxLwrs=-x/2
end subroutine

subroutine sphray_get_boxsize(x)
  real(r8b) :: x
  x=maxval(GV%BoxUprs-GV%BoxLwrs)
end subroutine

subroutine sphray_set_defaultspectype(x)
  real(r8b) :: x
  default_spectral_type=x
end subroutine

subroutine sphray_get_defaultspectype(x)
  real(r8b) :: x
  x=default_spectral_type
end subroutine

function sphray_set_he_mass_frac(hemf) result(ret)
  real(r8b) :: hemf
  integer :: ret  
  if(hemf.LT.0.OR.hemf.GT.1) then
    ret=-1
    return
  endif  
#ifdef incHe
  GV%He_mf=hemf
  GV%H_mf=1.-hemf
  ret=0.
#else
  ret=-2
#endif  

end function

function sphray_get_he_mass_frac(hemf) result(ret)
  real(r8b) :: hemf
  integer :: ret
  ret=0.
#ifdef incHe
  hemf=GV%He_mf
#else
  hemf=0.
  if(GV%He_mf.NE.0) ret=-1
#endif

end function


subroutine set_default_parameters
  GV%Verbosity=3              !< [Config File] 0=silent, 1=whisper, 2=talk, 3=debug

  GV%DoTestScenario=.false.      !< [Config File] set true if performing a test problem
  GV%TestScenario='none'         !< [Config File] one of {iliev_test1, iliev_test2, iliev_test3, iliev_test4}

  GV%JustInit=.false.             !< [Config File] set true to stop after initialization
  GV%Comoving=.false.            !< [Config File] set true if values to be read are in comoving coords

  GV%IsoTemp=0                !< [Config File] if > zero all pars fixed @ IsoTemp (FixSnapTemp must be F)
  GV%FixSnapTemp=.false.         !< [Config File] if T, fix temp at snapshot values (IsoTemp must be <= 0)

  GV%EOStemp=0             !< [Config File] if non-negative, initialize EOS particles w/ T = EOStemp 
  GV%InitxHI=-1             !< [Config File] if non-negative, all xHI initialized to this value
  GV%RayDepletion=.true.        !< [Config File] remove photons from rays as they travel?

  GV%IntSeed=0123456789        !< [Config File] seed for mersenne twister

  GV%StaticFieldSimTime=1  !< [Config File] sim time for single snapshot jobs
  GV%StaticSimTimeUnit="myr"   !< [Config File] one of {codetime,myr}


  GV%InputType=1           !< [Config File] one of Gadget {1: Public 2: CosmoBH 3: OWLS/GIMIC 4: V.Bromm 5: Public HDF5}
  GV%SnapPath='./'            !< [Config File] dir where particle snapshots are
  GV%SourcePath='./'          !< [Config File] dir where source snapshots are


  GV%SpectraFile=SpectraFile        !< [Config File] file containing spectra tables
  GV%b2cdFile=b2cdFile           !< [Config File] file containing b2cd tables
  GV%AtomicRatesFile=AtomicRatesFile    !< [Config File] file containnig atomic rates tables

  GV%ParFileBase='none'         !< [Config File] particle snapshot file base
  GV%SourceFileBase='none'      !< [Config File] source snapshot file base

  GV%StartSnapNum=1        !< [Config File] snapshot to start with
  GV%EndSnapNum=1          !< [Config File] snapshot to end with

  GV%ParFilesPerSnap=1     !< [Config File] files per particle snapshot
  GV%SourceFilesPerSnap=1  !< [Config File] files per source snapshot


  GV%RayScheme="raynum"           !< [Config File] one of {raynum, header}
  GV%ForcedRayNumber=30000     !< [Config File] number of rays to trace if RayScheme = raynum
  RaysperUnitTime=1.e6

  GV%RayStats=.false.            !< [Config File] T = massive output file on ray statistics in raystats.dat
  GV%BndryCond=0           !< [Config File] one of {-1:reflecting 0:vacuum 1:periodic}

  GV%RayPhotonTol=1.0d-10        !< [Config File] fractional ray depletion to stop ray
  GV%MaxRayDist=-1          !< [Config File] max ray distance in physical code units, negative=default

  GV%HydrogenCaseA=.true.       !< [Config File] T = use case A for Hydrogen Recombinations
  GV%HeliumCaseA=.true.         !< [Config File] T = use case A for Helium Recombinsations

  GV%IonTempSolver=2       !< [Config File] one of {1:euler, 2:bdf}

  GV%Tfloor=1              !< [Config File] minimum allowed temperature
  GV%Tceiling=1.d9            !< [Config File] maximum allowed temperature

  GV%xfloor=0.              !< [Config File] minimum allowed ionization fraction
  GV%xceiling=1.            !< [Config File] maximum allowed ionization fraction

  GV%NeBackground=1.e-8        !< [Config File] constant background electron number density from metals
  GV%NraysUpdateNoHits=0   !< [Config File] update all pars not hit by a ray in last NraysUpdateNoHits

  GV%H_mf=1.                !< [Config File] hydrogen mass fraction
  GV%He_mf=0.               !< [Config File] helium mass fraction

  GV%OutputDir='./'           !< [Config File] path to output directory
  GV%OutputFileBase='none'      !< [Config File] output file base

  GV%OutputType=1          !< [Config File] one of {1:Standard Binary Gadget 2:HDF5 Gadget}

  GV%OutputTiming='standard'        !< [Config File] one of {standard, forced}
  GV%NumStdOuts=-1          !< [Config File] if OutputTiming = "standard", # of outputs (maybe +1 initial)
  
  GV%DoInitialOutput=.false.     !< [Config File] produces output before any raytracing
  GV%IonFracOutRays=10000      !< [Config File] do mini output every IonFracOutRays src rays

  GV%ForcedOutFile='none'       !< [Config File] file with forced output times
  GV%ForcedUnits='myr'         !< [Config File] one of {codetime, myr, mwionfrac, vwionfrac}

  GV%PartPerCell=12         !< [Config File] minimum particles in a tree leaf

  GV%config_file='none'         !< name of the config file

  GV%BoxUprs=6.6
  GV%BoxLwrs=-6.6

  GV%DoMomentumKicks=.false.

end subroutine



function temp_from_u(u, ye, Hmf) result(T)
  use gadget_General_class, only: gadget_constants_type

  real(r8b), intent(in) :: u,ye,Hmf
  real(r8b) :: mu
  real(r8b) :: T,Tdum
  type(gadget_constants_type) :: gconst

  mu = 4.0d0 / (3.0d0 * Hmf + 1.0d0 + 4.0d0 * Hmf * ye)
  Tdum = mu * gconst%PROTONMASS / gconst%BOLTZMANN * (gconst%GAMMA - 1.0d0) * u
  T = Tdum * GV%cgs_enrg / GV%cgs_mass

end function

!> converts temperature K to internal energies / unit mass 
!=======================================================================================
function u_from_temp(T,ye,Hmf) result(U)
  use gadget_General_class, only: gadget_constants_type

  real(r8b), intent(in) :: T,ye,Hmf
  real(r8b) :: mu
  real(r8b) :: U,Udum
  type(gadget_constants_type) :: gconst

  mu = 4.0d0 / (3.0d0 * Hmf + 1.0d0 + 4.0d0 * Hmf * ye)
  Udum = gconst%BOLTZMANN * T /( (gconst%GAMMA - 1.0d0) * mu * gconst%PROTONMASS )
  U = Udum * GV%cgs_mass / GV%cgs_enrg

end function

subroutine extend_par(buf,n)
  type(particle_type), allocatable, intent (inout) :: buf(:)
  type(particle_type), allocatable :: tmpbuf(:)
  integer(i8b) :: n,m   

  m=0
  if(allocated(buf)) then
    m=min(n,size(buf))
    allocate(tmpbuf(m))
    tmpbuf(1:m)=buf(1:m)
    deallocate(buf)
  endif
  
  allocate(buf(n))
  
  
  if(m.GT.0 .and. allocated(tmpbuf)) then
    buf(1:m)=tmpbuf(1:m)
    deallocate(tmpbuf)
  endif
    
end subroutine

subroutine extend_src(buf,n)
  type(source_type), allocatable :: buf(:),tmpbuf(:)
  integer(i8b) :: n,m   

  m=0
  if(allocated(buf)) then
    m=min(n,size(buf))
    allocate(tmpbuf(m))
    tmpbuf(1:m)=buf(1:m)
    deallocate(buf)
  endif

  allocate(buf(n))
  
  if(m.GT.0) then
    buf(1:m)=tmpbuf(1:m)
    deallocate(tmpbuf)
  endif
    
end subroutine

function find_gas(id_) result(index)
  use hashMod
  type(hash_type),save ::  hash
  integer id_,index
  integer, save :: nbod=0
  
  if(.NOT.gas_searcheable) then
    nbod=size(psys%par)
    if(allocated(gid)) deallocate(gid)
    allocate(gid(nbod))
    gid(1:nbod)=psys%par(1:nbod)%id
    call initHash(nbod/2+1,nbod, gid,hash)
    gas_searcheable=.TRUE.
  endif
  
  index=find(id_,gid,hash)  

  if(index.LE.0) then
    index=-1
    return
  endif
  if(index.GT.nbod) then
    index=-2
    return
  endif
  if(gid(index).NE.id_) then
    index=-3
    return
  endif      
  
  if(psys%par(index)%mass<0) then
    index=-4
    return
  endif  
  
end function  


function find_src(id_) result(index)
  use hashMod
  type(hash_type), save :: hash
  integer id_,index
  integer, save :: nbod=0
  
  if(.NOT.src_searcheable) then
    nbod=size(psys%src)
    if(allocated(sid)) deallocate(sid)
    allocate(sid(nbod))
    sid(1:nbod)=psys%src(1:nbod)%id
    call initHash(nbod/2+1,nbod, sid,hash)
    src_searcheable=.TRUE.
  endif
  
  index=find(id_,sid,hash)  

  if(index.LE.0) then
    index=-1
    return
  endif
  if(index.GT.nbod) then
    index=-2
    return
  endif
  if(sid(index).NE.id_) then
    index=-3
    return
  endif      
   
  if(psys%src(index)%L<0) then
    index=-4
    return
  endif  

end function  


end module

!> \file b2cd.F90

!> \brief Handles the impact parameter to column depth table

module b2cd_mod
use myf03_mod
implicit none
private

public :: b2cdfac
public :: read_b2cd_file

integer(i4b) :: Nentries  !< table entries (from b=0 to b=1)
real(r8b) :: db           !< spacing in impact parameter
real(r8b), allocatable :: b2cd_table(:)  !< stores line integrations
                                         !< 0:Nentries-1


contains


!>  read in the impact parameter -> column depth file
!----------------------------------------------------
subroutine read_b2cd_file(b2cd_file)

  character(clen), intent(in) :: b2cd_file  ! impact parameter to CD table

  integer, parameter :: verb = 1
  character(clen) :: str
  integer(i4b) :: lun, err, i
  logical :: fthere

  character(clen), parameter :: myname = 'read_b2cd_file'
  logical, parameter :: crash = .true.

  write(str,'(A,T27,A)') 'using b2cd file: ', trim(b2cd_file)
  call mywrite(str, verb) 

  inquire(file=b2cd_file, exist=fthere)
  if (.not. fthere) then
     call myerr('cant find b2cd file: ' // trim(b2cd_file), myname, crash)
  end if

  call open_formatted_file_r(b2cd_file,lun)
  read(lun,*) Nentries
  write(str,'(A,I5)') '  b2cd table entries:    ', Nentries
  call mywrite('', verb+1)
  call mywrite(str, verb+1) 

  allocate ( b2cd_table(0:Nentries-1), stat=err )
  if(err/=0) call myerr('cant allocate b2cd_table', myname, crash)
     
  str = '  reading in SPH impact parameter -> column depth table'
  call mywrite(str, verb+1)

  do i = 0,Nentries-1
     read(lun,*) b2cd_table(i)
  end do
  db = 1.0d0 / (Nentries - 1)

  close(lun)
  call sum_b2cd_table()


end subroutine read_b2cd_file

!> Interpolates from the line integral table
!---------------------------------------------
function interpolate_b2cd(i,xfrac) result(b2cd)
  character(clen), parameter :: myname="interpolate_b2cd"
  logical, parameter :: crash=.true.
  integer(i4b) :: i   !< entry just below evaluation point
  real(r8b) :: xfrac  !< fraction of the way to the next entry
  real(r8b) :: b2cd   !< interpolated value
  real(r8b) :: dy     !< difference between adjacent table entries
  
  if (i >= Nentries-1) then
     write(*,*) "i = ", i
     call myerr(" out of bounds in interpolate b2cd",myname,crash)
  end if

  dy = b2cd_table(i+1) - b2cd_table(i)
  b2cd = b2cd_table(i) + xfrac * dy

end function interpolate_b2cd


!> checks normalization of impact parameter to column depth table
!----------------------------------------------------------------
subroutine sum_b2cd_table()
use physical_constants_mod, only: pi

  real(r8b) :: fac,sum,a,b,ab2,xfrac
  integer(i4b) :: i

  integer, parameter :: verb=2
  character(clen) :: str

  sum = 0.0d0
  xfrac = 0.5d0
  
  do i = 0,Nentries-2
     a = i * db
     b = (i+1) * db
     ab2 = (b+a)/2.0d0

     fac = db/6.0d0 * ( b2cd_table(i) + &
                        4.0d0 * interpolate_b2cd(i,xfrac) + &
                        b2cd_table(i+1) )

     sum = sum + 2.0d0 * pi * ab2 * fac 
  end do

  write(str,'(A,ES12.4)') &
       "  normalization of b2cd table (should be close to 1.0) = ", sum
  
  call mywrite(str, verb) 
  call mywrite('', verb)
  
end subroutine sum_b2cd_table

!> scales the table entry to the column depth factor using the 
!! smoothing length, the code cgs length, and the impact parameter
!! normalized to the smoothing length
function b2cdfac(b_norm,hsml,cgs_len) result(cdfac)

  real(r8b) :: b_norm  !< normalized impact parameter
  real(r8b) :: hsml    !< smoothing length
  real(r8b) :: cgs_len !< cgs length
  real(r8b) :: cdfac   !< output column depth factor

  integer :: b_indx
  real(r8b) :: xfrac
  real(r8b) :: b2cd

  b_indx = floor( (Nentries-1) * b_norm)  ! same as floor( b_norm / db )
  xfrac = b_norm / db - b_indx

  if (b_indx >= Nentries-1) then
     b_indx = Nentries-2
     xfrac = 1.0d0
  end if

  b2cd = interpolate_b2cd( b_indx, xfrac )
  
  cdfac = b2cd / ( hsml*hsml*cgs_len*cgs_len )

end function b2cdfac


end module b2cd_mod

!> \file gadget_public_input_hdf5.F90

!> \brief Handles readin of GADGET Public HDF5 formatted files
!<

module gadget_public_input_hdf5_mod
use myf03_mod
use gadget_general_class
use gadget_public_header_class
use gadget_public_header_hdf5_class
use gadget_sphray_header_class
use particle_system_mod
use gadget_public_input_mod, only: set_temp_from_u


use global_mod, only: psys, PLAN, GV
use global_mod, only: saved_gheads

#ifdef useHDF5
use hdf5_wrapper
#endif

implicit none
private

public :: get_planning_data_gadget_public_hdf5
public :: read_Gpubhdf5_particles


contains

#ifndef useHDF5

  ! these are dummy subroutines so that the calls outside this file
  ! dont have to be wrapped with pre processor macros.

  subroutine get_planning_data_gadget_public_hdf5()
    logical :: crash = .true.
    call myerr("this routine shuold not have been called","hdf5dummy",crash)
  end subroutine get_planning_data_gadget_public_hdf5
  
  subroutine read_Gpubhdf5_particles()
    logical :: crash = .true.
    call myerr("this routine shuold not have been called","hdf5dummy",crash)
  end subroutine read_Gpubhdf5_particles

#else



  !>   gets run planning data from Gadget Public HDF5 Headers
  !=============================================================
  subroutine get_planning_data_gadget_public_hdf5()
    
    character(clen), parameter :: myname = 'get_planning_data_gadget_public_hdf5'
    logical, parameter :: crash = .true.
    integer, parameter :: verb = 2
    
    type(gadget_public_header_type) :: ghead
    type(gadget_units_type) :: gunits
    type(gadget_constants_type) :: gconst
    
    integer(i4b) :: iSnap, fSnap    ! initial and final snapshot numbers
    integer(i4b) :: pfiles          ! files/snap for particles    
    integer(i4b) :: i,j             ! counters
    character(clen) :: snapfile     ! snapshot file name
    
    integer(i4b) :: loglun
    character(clen) :: logfile
    
    ! open up the planning data log file
    !======================================================
    logfile = trim(GV%OutputDir) // "/" // "particle_headers.log"
    call open_formatted_file_w(logfile,loglun)
    
    
    ! these global variables are read from the config file
    !======================================================
    iSnap  = GV%StartSnapNum
    fSnap  = GV%EndSnapNum    
    pfiles = GV%ParFilesPerSnap
    
    if ( allocated(saved_gheads) ) deallocate(saved_gheads)
    allocate( saved_gheads(iSnap:fSnap, 0:pfiles-1) )
    
    ! set global units
    !===================================================
    GV%cgs_len  = gunits%cgs_length
    GV%cgs_mass = gunits%cgs_mass
    GV%cgs_vel  = gunits%cgs_velocity
    GV%cgs_time = gunits%cgs_time
    GV%cgs_rho  = gunits%cgs_density
    GV%cgs_prs  = gunits%cgs_pressure
    GV%cgs_enrg = gunits%cgs_energy
    
    ! read all particle headers and write to log file
    !===================================================
    write(loglun,'(A)') "reading all GADGET Public HDF5 particle header(s) ... "
    do i = iSnap,fSnap
       do j = 0,pfiles-1
          
          call form_gadget_snapshot_file_name(GV%SnapPath,GV%ParFileBase,i,j,snapfile,hdf5bool=.true.)
          write(loglun,'(I3,"  ",A)') i,trim(snapfile)
          
          call gadget_public_header_hdf5_read_file(ghead, snapfile )
          call gadget_public_header_print_lun( ghead, loglun )
          call gadget_sphray_header_copy_public( saved_gheads(i,j), ghead )

!          call ghead%read_Gpublic_header_hdf5_file(snapfile)
!          call ghead%print_Gpublic_header_lun(loglun)
!          call saved_gheads(i,j)%copy_Gpublic_header(ghead)
          
          saved_gheads(i,j)%OmegaB = 0.045 ! this should be moved to the config file
          ! but its not used in the code now
          
          saved_gheads(i,j)%time_gyr = gadget_public_header_return_gyr(ghead)
          
          ! make sure there is gas in this snapshot
          !-------------------------------------------
          if (.not. ghead%npar_all(0) > 0) then
             write(*,*) "Gadget snapshot does not contain any gas particles"
             write(*,*) "Sphray cannot read dark matter particles directly, "
             write(*,*) "please calculate smoothing lengths for these particles"
             write(*,*) "and write them as gas particles. "
             stop
          end if
          
          if (GV%Comoving) then
             PLAN%snap(i)%ScalefacAt = ghead%a
             PLAN%snap(i)%TimeAt = gadget_public_header_return_gyr(ghead) * (gconst%SEC_PER_MEGAYEAR * 1.0d3) ! in seconds
             PLAN%snap(i)%TimeAt = PLAN%snap(i)%TimeAt * GV%LittleH / GV%cgs_time ! in code units
          else
             PLAN%snap(i)%ScalefacAt = 1.0d0 / (1.0d0 + ghead%z)
             PLAN%snap(i)%TimeAt = ghead%a
          end if
          
       end do
    end do
    
    ! close headers log file
    !========================
    close(loglun)
    
    ! use one header to set global variables
    !--------------------------------------------
    GV%BoxLwrs(:) = 0.0d0
    GV%BoxUprs(:) = saved_gheads(iSnap,0)%boxlen
    
    GV%OmegaM = saved_gheads(iSnap,0)%OmegaM
    GV%OmegaL = saved_gheads(iSnap,0)%OmegaL
    GV%OmegaB = saved_gheads(iSnap,0)%OmegaB 
    
    GV%LittleH = saved_gheads(iSnap,0)%h
    
    
    
    ! write units to log file
    !===================================================
    
    logfile = trim(GV%OutputDir) // "/" // "code_units.log"
    call open_formatted_file_w(logfile,loglun)
    call gadget_units_print_lun(gunits, loglun, saved_gheads(iSnap,0)%h)
    close(loglun)
    
    
  end subroutine get_planning_data_gadget_public_hdf5






  
  !> reads a Gadget Public HDF5 snapshot into a particle array  
  !========================================================================
  subroutine read_Gpubhdf5_particles()
    
    character(clen), parameter :: myname="read_Gpubhdf5_particles" 
    logical, parameter :: crash=.true.
    integer, parameter :: verb=2
    character(clen) :: str,fmt
    
    real(r4b), allocatable :: rblck(:)
    real(r4b), allocatable :: rblck3(:,:)
    integer(i4b), allocatable :: iblck(:)
    integer(i8b) :: ngasread
    
    type(gadget_public_header_type) :: ghead
    type(gadget_sphray_header_type) :: shead
    character(clen) :: snapfile, VarName, GroupName
    integer(i4b) :: fh
    integer(i8b) :: i
    integer(i4b) :: err
    
    integer(i8b) :: npar, ngas, nmass
    integer(i8b) :: npar1, ngas1, nmass1
    logical :: varmass(0:5)
    integer(i4b) :: fn
    
    real(r8b) :: meanweight
    logical :: caseA(2)
    real(r8b) :: MB 
    
    logical :: hdf5bool
    
    ! set hdf5 boolean
    !======================================================
    hdf5bool = .true.
    
    ! set local particle numbers
    !============================
    shead = saved_gheads( GV%CurSnapNum, 0 )
    varmass = (shead%npar_all > 0 .and. shead%mass == 0)
    npar = sum(shead%npar_all)
    ngas = shead%npar_all(0)
    nmass = sum(shead%npar_all, mask=varmass)
    
    ! do Gadget dummy checks
    !============================
    if (ngas == 0) call myerr("snapshot has no gas particles",myname,crash)
    
    ! calculate bytes per particle and allocate particle array
    !===========================================================
    MB = GV%bytesperpar * real(ngas) / 2.0d0**20
    GV%MB = GV%MB + MB
    
    fmt="(A,F10.4,A,I10,A)"
    write(str,fmt) "   allocating ", MB, " MB for ", ngas, " particles"
    call mywrite(str,verb) 
    
    allocate (psys%par(ngas), stat=err)
    if (err /= 0) call myerr("failed to allocate par",myname,crash)
    
    
    ! now read all snapshot files
    !==============================          
    ngasread = 0
    GroupName = 'PartType0/'
    files: do fn = 0, shead%nfiles-1
       
       
       ! recall the header info
       !-----------------------------------------------------------!  
       shead   = saved_gheads( GV%CurSnapNum, fn )
       varmass = (shead%npar_file > 0 .and. shead%mass == 0)
       npar1   = sum(shead%npar_file)
       ngas1   = shead%npar_file(0)
       nmass1  = sum(shead%npar_file, mask=varmass)
       if (ngas1 == 0) cycle
       
       
       ! begin read
       !-----------------------------------------------------------!  
       call form_gadget_snapshot_file_name(GV%SnapPath,GV%ParFileBase,GV%CurSnapNum,fn,snapfile,hdf5bool)
       call mywrite("   reading particle snapshot file: "//trim(snapfile), verb)
       call hdf5_open_file(fh, snapfile, readonly=.true.)
       call gadget_public_header_hdf5_read_lun(ghead,fh)

       
       ! read positions 
       !-----------------------------------------------------------!  
       allocate(rblck3(3,ngas1), stat=err)
       if(err/=0) call myerr("allocating rblck3 for pos",myname,crash)
       VarName = 'Coordinates'
       call hdf5_read_data(fh,trim(GroupName)//trim(VarName),rblck3)
       forall(i=1:ngas1) psys%par(ngasread+i)%pos(1) = rblck3(1,i)
       forall(i=1:ngas1) psys%par(ngasread+i)%pos(2) = rblck3(2,i)
       forall(i=1:ngas1) psys%par(ngasread+i)%pos(3) = rblck3(3,i)
       deallocate(rblck3)
       
       ! read velocities 
       !-----------------------------------------------------------!  
#ifdef incVel
       allocate(rblck3(3,ngas1), stat=err)
       if(err/=0) call myerr("allocating rblck3 for vel",myname,crash)
       VarName = 'Velocity'
       call hdf5_read_data(fh,trim(GroupName)//trim(VarName),rblck3)
       forall(i=1:ngas1) psys%par(ngasread+i)%vel(1) = rblck3(1,i)
       forall(i=1:ngas1) psys%par(ngasread+i)%vel(2) = rblck3(2,i)
       forall(i=1:ngas1) psys%par(ngasread+i)%vel(3) = rblck3(3,i)
       deallocate(rblck3)
#endif
       
       ! read id's 
       !-----------------------------------------------------------!  
       allocate(iblck(ngas1), stat=err )
       if(err/=0) call myerr("allocating iblck for ID",myname,crash)
       VarName = 'ParticleIDs'
       call hdf5_read_data(fh,trim(GroupName)//trim(VarName),iblck)
       forall(i=1:ngas1) psys%par(ngasread+i)%id = iblck(i)
       deallocate(iblck)
       
       ! read masses 
       !-----------------------------------------------------------!  
       
       ! if gas particles are variable mass
       if (varmass(0)) then  
          allocate(rblck(ngas1), stat=err)
          if(err/=0) call myerr("allocating rblck for mass",myname,crash)
          VarName = 'Mass'
          call hdf5_read_data(fh,trim(GroupName)//trim(VarName),rblck)
          forall(i=1:ngas1) psys%par(ngasread+i)%mass = rblck(i)
          deallocate(rblck)
          
          ! if gas particles are isomass
       else
          psys%par(ngasread+1:ngasread+ngas1)%mass = ghead%mass(0)       
       end if
       
       ! read temperature (internal energy / unit mass for now)
       !-----------------------------------------------------------!  
       allocate(rblck(ngas1), stat=err)
       if(err/=0) call myerr("allocating rblck for u",myname,crash)
       VarName = 'InternalEnergy'
       call hdf5_read_data(fh,trim(GroupName)//trim(VarName),rblck)
       forall(i=1:ngas1) psys%par(ngasread+i)%T = rblck(i)
       deallocate(rblck)
       
       
       ! read density 
       !-----------------------------------------------------------!  
       allocate(rblck(ngas1), stat=err)
       if(err/=0) call myerr("allocating rblck for rho",myname,crash)
       VarName = 'Density'
       call hdf5_read_data(fh,trim(GroupName)//trim(VarName),rblck)
       forall(i=1:ngas1) psys%par(ngasread+i)%rho = rblck(i)
       deallocate(rblck)
       
       
       ! read smoothing lengths 
       !-----------------------------------------------------------!  
       allocate(rblck(ngas1), stat=err)
       if(err/=0) call myerr("allocating rblck for hsml",myname,crash)
       VarName = 'SmoothingLength'
       call hdf5_read_data(fh,trim(GroupName)//trim(VarName),rblck)
       forall(i=1:ngas1) psys%par(ngasread+i)%hsml = rblck(i)
       deallocate(rblck)
       
       
       ngasread = ngasread + ngas1
       call hdf5_close_file(fh)
       
       
    end do files
    
    ! There is no cooling in the public version of Gadget-2 so we
    ! will make the same assumptions as were made in the routine
    ! show_hotgas.pro included in the source distribution when 
    ! calculating temperature from internal energy / unit mass. 
    ! Specifically mu = 1.0 * PROTONMASS or fully neutral gas. 
    !---------------------------------------------------------------
    psys%par(:)%xHI = 1.0d0
    psys%par(:)%xHII = 0.0d0
    psys%par(:)%ye = psys%par(:)%xHII
    call set_temp_from_u(psys, GV%H_mf, GV%cgs_enrg, GV%cgs_mass)
    

    ! now we have temperatures, we will set the ionization
    ! state to collisional equilibrium.
    !-----------------------------------------------------
    caseA = .false.
    if (GV%HydrogenCaseA) caseA(1) = .true.
    if (GV%HeliumCaseA)   caseA(2) = .true.
    
    call particle_system_set_ci_eq( psys, caseA, DoH=.true., DoHe=.true., fit="hui")
    call particle_system_set_ye(psys, GV%H_mf, GV%He_mf, GV%NeBackground)
        
  end subroutine read_Gpubhdf5_particles
  
  
#endif
  
  
end module gadget_public_input_hdf5_mod

!> \file octtree3p.F90

!> \brief The peano hilbert oct tree module 
!!
!<

module QuadTreeMod
 use particleMod
 implicit none
 
 private
 public :: quadtree_type,cell_type
 public :: setparticleorder,buildtree,dist2cell,getlocalscale

 integer, parameter :: nsubcell=2**ndim

 integer, parameter :: partInCell=12

 type cell_type
  integer :: start
  integer :: next
  integer :: daughter
  integer :: pshape
  real,dimension(ndim) :: bot
  real,dimension(ndim) :: top
 end type

 type quadtree_type
  integer :: np=0,ncells=0,maxcells,nplastcell
  integer, allocatable :: order(:)
  integer, allocatable :: cellorder(:)
  type(cell_type), allocatable :: cell(:) 
 end type

        INTEGER peanovalue(8,24)
        DATA peanovalue/                                                 &
     &    1,    8,    4,    5,    2,    7,    3,    6,                   &
     &    1,    2,    4,    3,    8,    7,    5,    6,                   &
     &    7,    8,    6,    5,    2,    1,    3,    4,                   &
     &    3,    6,    4,    5,    2,    7,    1,    8,                   &
     &    1,    4,    8,    5,    2,    3,    7,    6,                   &
     &    5,    8,    4,    1,    6,    7,    3,    2,                   &
     &    1,    2,    8,    7,    4,    3,    5,    6,                   &
     &    3,    2,    4,    1,    6,    7,    5,    8,                   &
     &    7,    2,    6,    3,    8,    1,    5,    4,                   &
     &    5,    6,    4,    3,    8,    7,    1,    2,                   &
     &    7,    8,    2,    1,    6,    5,    3,    4,                   &
     &    7,    6,    8,    5,    2,    3,    1,    4,                   &
     &    3,    4,    6,    5,    2,    1,    7,    8,                   &
     &    1,    4,    2,    3,    8,    5,    7,    6,                   &
     &    5,    4,    8,    1,    6,    3,    7,    2,                   &
     &    5,    8,    6,    7,    4,    1,    3,    2,                   &
     &    1,    8,    2,    7,    4,    5,    3,    6,                   &
     &    7,    2,    8,    1,    6,    3,    5,    4,                   &
     &    5,    6,    8,    7,    4,    3,    1,    2,                   &
     &    3,    2,    6,    7,    4,    1,    5,    8,                   &
     &    7,    6,    2,    3,    8,    5,    1,    4,                   &
     &    5,    4,    6,    3,    8,    1,    7,    2,                   &
     &    3,    4,    2,    1,    6,    5,    7,    8,                   &
     &    3,    6,    2,    7,    4,    5,    1,    8 /

        INTEGER pshapefromi(8,24)
        DATA pshapefromi/                                                &
     &     2,    3,    4,    4,    5,    6,    5,    6,                  &
     &     1,    7,    8,    7,    9,   10,    8,   10,                  &
     &    11,    1,   11,   12,   13,    9,   13,   12,                  &
     &    12,    8,    1,    1,   12,    8,   10,   13,                  &
     &    14,   13,   12,   13,    1,    1,   15,   15,                  &
     &    10,   16,   10,    8,    1,    1,   15,   15,                  &
     &    17,    2,   18,   19,   20,    2,   20,   19,                  &
     &    18,   18,    2,    6,    4,    4,    2,   20,                  &
     &    21,   20,   21,   20,    2,    3,   18,   18,                  &
     &     6,    2,    6,   19,   22,    2,    4,   19,                  &
     &     3,   17,   23,   18,    3,   21,   23,   21,                  &
     &    18,   18,    5,    3,    4,    4,   21,    3,                  &
     &     3,    5,   23,    5,    3,   22,   23,    4,                  &
     &     5,   23,   17,   17,   21,   23,   22,   22,                  &
     &    22,   22,   19,   23,    5,    6,    5,    6,                  &
     &    19,    6,   17,   17,   19,   20,   22,   22,                  &
     &     7,   11,   14,   16,   24,   24,   14,   16,                  &
     &    12,    8,    7,   11,   12,    8,    9,    9,                  &
     &    16,    7,   15,    7,   16,   10,   24,   10,                  &
     &     9,    9,   24,   24,    7,   16,    7,    8,                  &
     &     9,    9,   24,   24,   14,   11,   12,   11,                  &
     &    15,   15,   14,   16,   10,   13,   14,   16,                  &
     &    11,   14,   11,   15,   13,   14,   13,   24,                  &
     &    21,   20,   21,   20,   17,   17,   19,   23 /

        INTEGER pshapefromp(8,24)
        DATA pshapefromp/                                                &
     &     2,    5,    5,    4,    4,    6,    6,    3,                  &
     &     1,    7,    7,    8,    8,   10,   10,    9,                  &
     &     9,   13,   13,   12,   12,   11,   11,    1,                  &
     &    10,   12,   12,    1,    1,    8,    8,   13,                  &
     &    14,    1,    1,   13,   13,   15,   15,   12,                  &
     &     8,   15,   15,   10,   10,    1,    1,   16,                  &
     &    17,    2,    2,   20,   20,   19,   19,   18,                  &
     &     6,   18,   18,    2,    2,    4,    4,   20,                  &
     &     3,   20,   20,   18,   18,   21,   21,    2,                  &
     &     4,   19,   19,    6,    6,    2,    2,   22,                  &
     &    18,   23,   23,   21,   21,    3,    3,   17,                  &
     &    21,    4,    4,    3,    3,   18,   18,    5,                  &
     &    22,    3,    3,    5,    5,   23,   23,    4,                  &
     &     5,   17,   17,   23,   23,   22,   22,   21,                  &
     &    23,    6,    6,   22,   22,    5,    5,   19,                  &
     &    20,   22,   22,   19,   19,   17,   17,    6,                  &
     &     7,   14,   14,   24,   24,   16,   16,   11,                  &
     &    11,    8,    8,    9,    9,   12,   12,    7,                  &
     &    24,   10,   10,   16,   16,    7,    7,   15,                  &
     &    16,    9,    9,    7,    7,   24,   24,    8,                  &
     &    12,   24,   24,   11,   11,    9,    9,   14,                  &
     &    13,   16,   16,   15,   15,   14,   14,   10,                  &
     &    15,   11,   11,   14,   14,   13,   13,   24,                  &
     &    19,   21,   21,   17,   17,   20,   20,   23 /

         INTEGER indexfromp(8,24)
         DATA indexfromp/                                                &
     &    1,    5,    7,    3,    4,    8,    6,    2,                   &
     &    1,    2,    4,    3,    7,    8,    6,    5,                   &
     &    6,    5,    7,    8,    4,    3,    1,    2,                   &
     &    7,    5,    1,    3,    4,    2,    6,    8,                   &
     &    1,    5,    6,    2,    4,    8,    7,    3,                   &
     &    4,    8,    7,    3,    1,    5,    6,    2,                   &
     &    1,    2,    6,    5,    7,    8,    4,    3,                   &
     &    4,    2,    1,    3,    7,    5,    6,    8,                   &
     &    6,    2,    4,    8,    7,    3,    1,    5,                   &
     &    7,    8,    4,    3,    1,    2,    6,    5,                   &
     &    4,    3,    7,    8,    6,    5,    1,    2,                   &
     &    7,    5,    6,    8,    4,    2,    1,    3,                   &
     &    6,    5,    1,    2,    4,    3,    7,    8,                   &
     &    1,    3,    4,    2,    6,    8,    7,    5,                   &
     &    4,    8,    6,    2,    1,    5,    7,    3,                   &
     &    6,    8,    7,    5,    1,    3,    4,    2,                   &
     &    1,    3,    7,    5,    6,    8,    4,    2,                   &
     &    4,    2,    6,    8,    7,    5,    1,    3,                   &
     &    7,    8,    6,    5,    1,    2,    4,    3,                   &
     &    6,    2,    1,    5,    7,    3,    4,    8,                   &
     &    7,    3,    4,    8,    6,    2,    1,    5,                   &
     &    6,    8,    4,    2,    1,    3,    7,    5,                   &
     &    4,    3,    1,    2,    6,    5,    7,    8,                   &
     &    7,    3,    1,    5,    6,    2,    4,    8 / 





 contains

 subroutine setparticleorder(psys,tree)
 type(quadtree_type) :: tree
 type(particlesys_type) :: psys
 type(particle_type) :: part
 integer i,goal
  call check(psys,tree)
  call orderpsys(psys,tree%order) 
 end subroutine

 subroutine check(psys,tree)
 type(quadtree_type) :: tree
 type(particlesys_type) :: psys

  if(tree%np.NE.psys%npart) call error('tree, psys')
  
 end subroutine

 subroutine maketree(psys,tree)
 type(quadtree_type) :: tree
  type(particlesys_type) :: psys
 integer :: npart,ncells,err
  if(allocated(tree%order)) call killtree(tree)
  tree%maxcells=psys%npart/2+2*psys%npart/partInCell
  tree%np=psys%npart
  allocate(tree%order(1:tree%np), tree%cellorder(1:max(tree%np,tree%maxcells)),tree%cell(0:tree%maxcells),stat=err)
 if(err.ne.0) call error('allocation      ',err)
 end subroutine

 subroutine killtree(tree)
 type(quadtree_type) :: tree
 integer :: err
  deallocate(tree%order, tree%cellorder,tree%cell,stat=err)
  if(err.ne.0) call error('deallocation     ',err)
  tree%np=0
 end subroutine

 integer function subcellindex2(pcell,ppar)
 real, dimension(ndim) :: pcell,ppar
 integer, parameter,dimension(3) :: nindex=(/ 1,2,4 /)
 integer :: k 

 subcellindex2 = 1
 do k = 1, ndim
  if (ppar(k).GT.pcell(k)) subcellindex2 = subcellindex2 + nindex(k)
 enddo
 end function subcellindex2

 subroutine buildtree(psys,tree)
  type(quadtree_type) :: tree
  type(particlesys_type) :: psys

  call maketree(psys,tree)

  call inittree(psys,tree)  

  call parttree(psys,tree)

  call patchtree(tree)

  call makecellorder(tree)

  call shrinkcells2(psys,tree)

!  call adjustbox(psys,tree%cell(1)%bot,tree%cell(1)%top)
  
 end subroutine
  
 subroutine inittree(psys,tree)
  integer :: npart,i
  type(quadtree_type) :: tree
  type(particlesys_type) :: psys
  real :: bot(ndim),top(ndim),rsize
 
 if(psys%npart.LE.0) call error('no particles   ')
 if(psys%npart.NE.tree%np) call error('psys != tree   ')

 tree%cell(0)%start=psys%npart+1
 tree%cell(1)%start=1
 tree%cell(1)%next=0
 tree%cell(1)%pshape=1
 tree%ncells=1
 tree%nplastcell=psys%npart
 
 do i=1,ndim
  bot(i)=MINVAL(psys%part(1:psys%npart)%pos(i))
  top(i)=MAXVAL(psys%part(1:psys%npart)%pos(i))
 enddo
 
 rsize=MAXVAL(top-bot)
 tree%cell(1)%bot(1:ndim)=0.5*(top+bot)-0.5*rsize
 tree%cell(1)%top(1:ndim)=tree%cell(1)%bot(1:ndim)+rsize

! tree%cell(1)%bot=0
! tree%cell(1)%top=1
 
 do i=1,psys%npart
  tree%order(i)=i
 enddo

 end subroutine

 recursive subroutine parttree(psys,tree)
 type(quadtree_type) :: tree
 type(particlesys_type) :: psys
 integer, parameter :: offset_factor(3,8)=(/ 0,0,0,1,0,0,0,1,0,1,1,0,0,0,1,1,0,1,0,1,1,1,1,1 /)  
 real :: ccpos(ndim),csize(ndim)
 integer :: i,j,subp(0:nsubcell+1),subind
 integer :: ccell,nsub,nppcell,newcell,sister,pshape
  ccell=tree%ncells
  nppcell=tree%nplastcell
  if(nppcell.GT.partInCell) then
  ccpos=(tree%cell(ccell)%top+tree%cell(ccell)%bot)/2
  csize=tree%cell(ccell)%top-tree%cell(ccell)%bot
  pshape=tree%cell(ccell)%pshape
  subp=0
  do j=tree%cell(ccell)%start,tree%cell(ccell)%start+nppcell-1
   subind=subcellindex2(ccpos,psys%part(tree%order(j))%pos)    
   subind=peanovalue(subind,pshape)
   subp(subind)=subp(subind)+1
  enddo
  subp(0)=0
  subp(nsubcell+1)=nppcell
  do j=nsubcell,1,-1
   subp(j)=subp(j+1)-subp(j) 
  enddo
  if(subp(1).NE.0) call error('subp count  ')
  do j=tree%cell(ccell)%start,tree%cell(ccell)%start+nppcell-1
   subind=subcellindex2(ccpos,psys%part(tree%order(j))%pos)
   subind=peanovalue(subind,pshape)
   subp(subind)=subp(subind)+1
   tree%cellorder(subp(subind))=tree%order(j)
  enddo 
!  tree%order(tree%cell(ccell)%start:tree%cell(ccell)%start+nppcell-1)= &
!   tree%cellorder(1:nppcell)   
  do j=tree%cell(ccell)%start,tree%cell(ccell)%start+nppcell-1
   tree%order(j)=tree%cellorder(j-tree%cell(ccell)%start+1)
  enddo 
  sister=0
  do j=1,nsubcell
   if(subp(j)-subp(j-1).GT.0) then 
    tree%ncells=tree%ncells+1
    newcell=tree%ncells
    if(newcell.GT.tree%maxcells) call error('cell overflow  ',newcell)
    tree%nplastcell=subp(j)-subp(j-1)
    if(tree%cell(ccell)%daughter.EQ.0)tree%cell(ccell)%daughter=newcell
    tree%cell(newcell)%start=subp(j-1)+tree%cell(ccell)%start
    tree%cell(newcell)%next=ccell
    tree%cell(newcell)%daughter=0
!    tree%cell(newcell)%bot=tree%cell(ccell)%bot+offset_factor(1:ndim,j)*csize/2
    tree%cell(newcell)%bot=tree%cell(ccell)%bot+offset_factor(1:ndim,indexfromp(j,pshape))*csize/2    
    tree%cell(newcell)%top=tree%cell(newcell)%bot+csize/2
    tree%cell(newcell)%pshape=pshapefromp(j,pshape)
    tree%cell(sister)%next=newcell
    sister=newcell
    call parttree(psys,tree)
    endif
  enddo    
  endif
 end subroutine

 subroutine patchtree(tree)
 type(quadtree_type) :: tree
 integer ::i
  tree%cell(0)%next=0
  do i=1,tree%ncells
   if(tree%cell(i)%next.LT.i) tree%cell(i)%next=tree%cell(tree%cell(i)%next)%next
  enddo
 end subroutine 

 subroutine makecellorder(tree)
 type(quadtree_type) :: tree
 integer ccount,dcell,i,up,low,pcell
  ccount=tree%ncells
  tree%cellorder(ccount)=1
  up=ccount+1
  low=ccount
  do while(up.GT.low)
   do i=up-1,low,-1
    pcell=tree%cellorder(i)
    dcell=tree%cell(pcell)%daughter
    if(dcell.NE.0) then
      ccount=ccount-1
      tree%cellorder(ccount)=dcell
      dcell=tree%cell(dcell)%next    
      do while(dcell.NE.tree%cell(pcell)%next)
       ccount=ccount-1
       tree%cellorder(ccount)=dcell
       dcell=tree%cell(dcell)%next     
      enddo
    endif
   enddo
   up=low
   low=ccount
  enddo
  if(low.NE.1) call error('ordering    ',low) 
 end subroutine
 
 integer function ppcell(tree,i)
 type(quadtree_type) :: tree  
 integer ::i
  ppcell=tree%cell(tree%cell(i)%next)%start-tree%cell(i)%start
 end function

 subroutine shrinkcells(psys,tree)
 type(quadtree_type) :: tree
 type(particlesys_type) :: psys
  integer :: i0,i,j,k,n,next
  real x
  
  do i0=1,tree%ncells
   i=tree%cellorder(i0)
   do k=1,ndim
    x=tree%cell(i)%top(k)
    tree%cell(i)%top(k)=tree%cell(i)%bot(k)
    tree%cell(i)%bot(k)=x
   enddo
   next=tree%cell(i)%daughter
   if(next.EQ.0) then
    do j=tree%cell(i)%start,tree%cell(tree%cell(i)%next)%start-1
      do k=1,ndim
       x=psys%part(tree%order(j))%pos(k)
       if(tree%cell(i)%bot(k).gt.x)tree%cell(i)%bot(k)=x
       if(tree%cell(i)%top(k).lt.x)tree%cell(i)%top(k)=x
      enddo
    enddo
   else
    do while(next.NE.tree%cell(i)%next)
      do k=1,ndim
       x=tree%cell(next)%bot(k)
       if(tree%cell(i)%bot(k).gt.x)tree%cell(i)%bot(k)=x
       x=tree%cell(next)%top(k)
       if(tree%cell(i)%top(k).lt.x)tree%cell(i)%top(k)=x
      enddo
      next=tree%cell(next)%next
    enddo 
   endif   
  enddo
! print*,tree%cell(1)%top
! print*,tree%cell(1)%bot
 end subroutine

 subroutine shrinkcells2(psys,tree)
 type(quadtree_type) :: tree
 type(particlesys_type) :: psys
  integer :: i0,i,j,k,n,next
  real x,hsm
  
  do i0=1,tree%ncells
   i=tree%cellorder(i0)
   do k=1,ndim
    x=tree%cell(i)%top(k)
    tree%cell(i)%top(k)=tree%cell(i)%bot(k)
    tree%cell(i)%bot(k)=x
   enddo
   next=tree%cell(i)%daughter
   if(next.EQ.0) then
    do j=tree%cell(i)%start,tree%cell(tree%cell(i)%next)%start-1
      hsm=psys%part(tree%order(j))%hsm
      do k=1,ndim
       x=psys%part(tree%order(j))%pos(k)
       if(tree%cell(i)%bot(k).gt.x-hsm)tree%cell(i)%bot(k)=x-hsm
       if(tree%cell(i)%top(k).lt.x+hsm)tree%cell(i)%top(k)=x+hsm
      enddo
    enddo
   else
    do while(next.NE.tree%cell(i)%next)
      do k=1,ndim
       x=tree%cell(next)%bot(k)
       if(tree%cell(i)%bot(k).gt.x)tree%cell(i)%bot(k)=x
       x=tree%cell(next)%top(k)
       if(tree%cell(i)%top(k).lt.x)tree%cell(i)%top(k)=x
      enddo
      next=tree%cell(next)%next
    enddo 
   endif   
  enddo
! print*,tree%cell(1)%top
! print*,tree%cell(1)%bot
 end subroutine

 function getlocalscale(pos,tree) result(scale)
 real :: pos(ndim),scale,dist2
 type(quadtree_type) :: tree
 integer :: next,old
  
 next=1
 old=1
 do while(tree%cell(next)%daughter.NE.0)
  old=next
  next=tree%cell(next)%daughter
  do while(dist2cell(pos,tree%cell(next)).GT.0)
   next=tree%cell(next)%next
  enddo
 enddo 
 if(next.eq.0) call error('getlocalscale: noc')
 scale=sum(tree%cell(old)%top-tree%cell(old)%bot)/ndim
 end function
 
 function dist2cell(pos,cell) result(dist2)
  type(cell_type) :: cell
  real :: pos(ndim),lpos(ndim),upos(ndim),dist2
  integer :: k
  dist2=0
  lpos=cell%bot
  upos=cell%top
  do k=1,ndim
   if(pos(k).LT.lpos(k)) then
    dist2=dist2+(lpos(k)-pos(k))**2
   else
    if(pos(k).GT.upos(k)) then
      dist2=dist2+(upos(k)-pos(k))**2
    endif
   endif
  enddo
 end function


 subroutine error(string,i)
  character(*) :: string
  integer, optional :: i
  
  print*,'error detected'

  if(present(i)) then
   print*,string,i
  else
   print*,string
  endif
  stop
end subroutine


end module

!> \file sphray.F90

!> \brief SPHRAY basic operation program
!! 
!! This program calls mainloop without initializing the OpenGL viewer.
!<
program sphray
use myf03_mod
use initialize_mod, only: initialize
use mainloop_mod, only: mainloop
implicit none

   character(clen) :: config_file    !< configuration file
   type(command_line_type) :: cmnd   !< command line variable

   integer, parameter :: verb = 3    !< verbosity before config file is read
   logical, parameter :: crash = .true.             !< stop on error
   character(clen), parameter :: myname = "sphray"  !< routine name



   ! set initial myf90_verbosity (will be changed once config file is read)
   ! 3 lets any statement with verbosity 3 or less through
   !========================================================================
   myf03_verbosity = verb

   ! initialize command line variable
   !========================================================================
   cmnd = myf03_initialize_command_line(verb)

   ! check command line arguments
   !========================================================================
   if (cmnd%nargs /= 1 ) then 
      call myerr( 'usage: ./sphray config_file', myname, crash )
   end if

   ! clear terminal and print splash screen
   !========================================================================
   write(*,*) 
   write(*,*) "**************************************************************"
   write(*,*) "**************************************************************"
   write(*,*) "         Smoothed Particle Hydrodynamics Ray Tracer           "
   write(*,*) "                        SPHRAY 0.9                            "
   write(*,*)
   write(*,*) "  developed by,                                               "
   write(*,*)
   write(*,*) "  Gabriel Altay (gabriel.altay@gmail.com) and                 "
   write(*,*) "  Inti Pelupessy                                              "
   write(*,*) "**************************************************************"
   write(*,*) "**************************************************************"
   write(*,*) 
   write(*,*) 

   ! initialize and call mainloop()
   !========================================================================
   config_file = cmnd%args(1)
   call initialize(config_file)

   call mainloop()


!> \mainpage Reference documentation for SPHRAY
!!
!! \author Gabriel Altay \n
!!         gabriel.altay@gmail.com \n
!!
!! \n
!!
!! \section prelim Getting Started
!!
!! The <b>S</b>moothed <b>P</b>article <b>H</b>ydrodynamics 
!! <b>RAY</b>-tracer (SPHRAY) is a code written by Gabriel Altay and Inti  
!! Pelupessy designed to perform 3D, time dependent, radiative transfer  
!! calculations on precomputed SPH density fields. The source code is written  
!! in standard Fortran 2003 and is made publically available under the terms of 
!! the latest GNU General Public License 
!! (http://www.gnu.org/copyleft/gpl.html).
!!
!! The quickest way to get started is to have a look at the guide on the wiki 
!! page (http://code.google.com/p/sphray). 
!!
!!
!!
!!
!!
!!
!!
!!
!!
!!
!!
!!
!<


end program sphray

!> \file output.F90

!> \brief The module that handles output
!<

module output_mod
use myf03_mod
use gadget_general_class
use gadget_public_header_class
use gadget_owls_header_class
use gadget_public_input_hdf5_mod
use gadget_sphray_header_class
use particle_system_mod
use oct_tree_mod, only: oct_tree_type
use physical_constants_mod
use global_mod, only: PLAN, GV
use global_mod, only: saved_gheads
use config_mod, only: write_config_hdf5_lun

#ifdef useHDF5
use hdf5_wrapper
#endif

implicit none

contains
 
!=======================================================================
!=======================================================================
!
! OUTPUT ROUTINES
!
!=======================================================================
!=======================================================================


!> put the config choices in a sphray header for output.
! ==========================================================
 
  subroutine config_to_ghead(fnum, ghead)


    integer, intent(in) :: fnum                    !< which snapshot file
    type(gadget_sphray_header_type), intent(out) :: ghead !< gadget header

    ghead%npar_all = 0
    ghead%npar_all(0) = saved_gheads(GV%CurSnapNum,fnum)%npar_all(0)     

    ghead%npar_file = 0
    ghead%npar_file(0) = saved_gheads(GV%CurSnapNum,fnum)%npar_file(0)     

    ghead%mass = 0.0

    ghead%nfiles    = saved_gheads(GV%CurSnapNum,fnum)%nfiles

    ghead%a = PLAN%snap(GV%CurSnapNum)%ScalefacAt
    ghead%z = saved_gheads(GV%CurSnapNum,fnum)%z
    ghead%time_gyr = GV%time_elapsed_myr / 1.0d3

    ghead%boxlen   = saved_gheads(GV%CurSnapNum,fnum)%boxlen
    ghead%OmegaM   = saved_gheads(GV%CurSnapNum,fnum)%OmegaM
    ghead%OmegaL   = saved_gheads(GV%CurSnapNum,fnum)%OmegaL
    ghead%OmegaB   = saved_gheads(GV%CurSnapNum,fnum)%OmegaB
    ghead%h        = saved_gheads(GV%CurSnapNum,fnum)%h

    ghead%npar_hw = 0
    ghead%npar_hw(1) = saved_gheads(GV%CurSnapNum,fnum)%npar_hw(1)
       
    ghead%flag_sfr      = saved_gheads(GV%CurSnapNum,fnum)%flag_sfr
    ghead%flag_feedback = saved_gheads(GV%CurSnapNum,fnum)%flag_feedback
    ghead%flag_cooling  = saved_gheads(GV%CurSnapNum,fnum)%flag_cooling
    ghead%flag_age      = saved_gheads(GV%CurSnapNum,fnum)%flag_age
    ghead%flag_metals   = saved_gheads(GV%CurSnapNum,fnum)%flag_metals
    ghead%flag_entr_ics = saved_gheads(GV%CurSnapNum,fnum)%flag_entr_ics
    
    ghead%rays_traced = GV%src_rayn

#ifdef incHmf
    ghead%flag_Hmf = 1
#else
    ghead%flag_Hmf = 0
#endif
!-------------------------
#ifdef incHemf
    ghead%flag_Hemf = 1
#else
    ghead%flag_Hemf = 0
#endif
!-------------------------
#ifdef incHe
    ghead%flag_helium = 1
#else
    ghead%flag_helium = 0
#endif
!-------------------------
#ifdef outGammaHI
    ghead%flag_gammaHI = 1
#else
    ghead%flag_gammaHI = 0
#endif
!-------------------------
#ifdef incCloudy
    ghead%flag_cloudy = 1
#else
    ghead%flag_cloudy = 0
#endif
!-------------------------
#ifdef incEOS
    ghead%flag_eos = 1
#else
    ghead%flag_eos = 0
#endif
!-------------------------
#ifdef incSFR
    ghead%flag_incsfr = 1
#else
    ghead%flag_incsfr = 0
#endif
!-------------------------

    ghead%unused = 0

  end subroutine config_to_ghead

!> outputs the whole shebang to a file
!=======================================

  subroutine output_total_snap(psys)

     character(clen), parameter :: myname="output_total_snap"
     logical, parameter :: crash = .true.
     integer, parameter :: verb = 2

     type(particle_system_type), intent(inout) :: psys
     type(gadget_sphray_header_type) :: ghead
     type(gadget_constants_type) :: gconst
     type(gadget_units_type) :: gunits

     character(3) :: label
     character(4) :: ext
     character(clen) :: filename
     integer(i4b) :: lun
     integer(i8b) :: Nread, Nfile
     integer(i4b) :: ipar, ifile

     integer(i8b) :: i,j

     real(r8b) :: scale
     real(r8b) :: hub
     real(r8b) :: nHe_over_nH
     real(r8b) :: Hmf, Hemf
     real(r4b) :: mu
     real(r4b), allocatable :: uint(:)
     real(r4b), allocatable :: rblock3(:,:)

     character(clen) :: tag
     character(clen) :: group_name

     ! set defaults
     !==============
     nHe_over_nH = 0.0
     ipar=0
     group_name = 'PartType0/'

     scale = PLAN%snap(GV%CurSnapNum)%ScalefacAt
     hub   = GV%LittleH

     write(*,*) 'output number: ', GV%OutputIndx
     write(*,*) 'output type:   ', GV%OutputType
     write(*,*) "writing total state of system"
     write(*,*) "time (elapsed code) ", GV%time_elapsed_code
     write(*,*) "time (elapsed myr)  ", GV%time_elapsed_myr

     if (GV%Comoving) then
        call particle_system_scale_physical_to_comoving(psys, scale, hub)
     endif

     100 format(I3.3)
     write(label,100) GV%OutputIndx


     call particle_system_set_ye( psys, GV%H_mf, GV%He_mf, GV%NeBackground )


     !================================================================
     ! GADGET standard formatted output
     !================================================================
     !================================================================
     if (GV%OutputType == 1) then
        Nread = 0

        do ifile = 0, GV%ParFilesPerSnap-1

           call config_to_ghead( ifile, ghead )

           !    form file name
           write(ext,'(I3)') ifile

           filename = trim(GV%OutputDir) // "/" // trim(GV%OutputFileBase) // "_" // label 
           if (GV%ParFilesPerSnap > 1) then
              filename = trim(filename) // "." // trim(adjustl(ext))
           end if
           write(*,*) "writing snapshot state to ", trim(filename)
           write(*,*) 
           call open_unformatted_file_w(filename,lun)

           Nfile = ghead%npar_file(0)

           call gadget_sphray_header_write_lun(ghead,lun)

           allocate( rblock3(3,Nfile) )
           rblock3(1,:) = psys%par(Nread+1:Nread+Nfile)%pos(1) 
           rblock3(2,:) = psys%par(Nread+1:Nread+Nfile)%pos(2) 
           rblock3(3,:) = psys%par(Nread+1:Nread+Nfile)%pos(3) 
           write(lun) rblock3

#ifdef incVel
           rblock3(1,:) = psys%par(Nread+1:Nread+Nfile)%vel(1) 
           rblock3(2,:) = psys%par(Nread+1:Nread+Nfile)%vel(2) 
           rblock3(3,:) = psys%par(Nread+1:Nread+Nfile)%vel(3) 
#else
           rblock3 = 0.0e0
#endif

           write(lun) rblock3
           deallocate( rblock3 )

           write(lun) psys%par(Nread+1:Nread+Nfile)%id 
           write(lun) psys%par(Nread+1:Nread+Nfile)%mass


           ! do some conversions
           !------------------------
           allocate( uint(Nfile) )

           j=1
           do i = Nread+1, Nread+Nfile
!------------------------------
#ifdef incHmf
              Hmf=psys%par(i)%Hmf
#else
              Hmf=GV%H_mf
#endif     
!-------------------------------
              mu      = 4.0d0 / ( 3.0d0 * Hmf + 1.0d0 + 4.0d0 * Hmf * psys%par(i)%ye )
              uint(j) = ( gconst%BOLTZMANN * psys%par(i)%T ) / &
                        ( (gconst%GAMMA - 1.0d0) * mu * gconst%PROTONMASS  )
              uint(j) = uint(j) * GV%cgs_mass / GV%cgs_enrg

              j = j+1
           end do


           write(lun) uint(1:Nfile)
           deallocate( uint )

           write(lun) psys%par(Nread+1:Nread+Nfile)%rho         
           write(lun) psys%par(Nread+1:Nread+Nfile)%ye
           write(lun) psys%par(Nread+1:Nread+Nfile)%xHI
           write(lun) psys%par(Nread+1:Nread+Nfile)%hsml 

           write(lun) psys%par(Nread+1:Nread+Nfile)%T


#ifdef incHmf
           write(lun) psys%par(Nread+1:Nread+Nfile)%Hmf
#endif


#ifdef incHemf
           write(lun) psys%par(Nread+1:Nread+Nfile)%Hemf
#endif


#ifdef incHe
           write(lun) psys%par(Nread+1:Nread+Nfile)%xHeI
           write(lun) psys%par(Nread+1:Nread+Nfile)%xHeII
#endif


#ifdef outGammaHI
           do ipar = Nread+1, Nread+Nfile
              if (psys%par(ipar)%time > 0.0) then
                 psys%par(ipar)%gammaHI = psys%par(ipar)%gammaHI / psys%par(ipar)%time
              else
                 psys%par(ipar)%gammaHI = 0.0
              end if
           end do
           write(lun) psys%par(Nread+1:Nread+Nfile)%gammaHI

           psys%par(Nread+1:Nread+Nfile)%gammaHI = 0.0
           psys%par(Nread+1:Nread+Nfile)%time = 0.0
#endif

 
#ifdef incCloudy
           write(lun) psys%par(Nread+1:Nread+Nfile)%xHI_cloudy
#endif

#ifdef incEOS
           write(lun) psys%par(Nread+1:Nread+Nfile)%eos
#endif

#ifdef incSFR
           write(lun) psys%par(Nread+1:Nread+Nfile)%sfr
#endif

           write(lun) psys%par(Nread+1:Nread+Nfile)%lasthit


           close(lun)
           Nread = Nread + Nfile

        end do

     end if
 

     !================================================================     
     ! GADGET HDF5 formatted output
     !================================================================
     !================================================================
     if (GV%OutputType == 2) then

#ifdef useHDF5

        Nread = 0

        do ifile = 0, GV%ParFilesPerSnap-1

           call config_to_ghead( ifile, ghead )

           !    form file name
           write(ext,'(I3)') ifile

           filename = trim(GV%OutputDir) // "/" // trim(GV%OutputFileBase) // "_" // label 
           if (GV%ParFilesPerSnap > 1) then
              filename = trim(filename) // "." // trim(adjustl(ext))
           end if
           filename = trim(filename) // ".hdf5"
           call mywrite("writing snapshot state to "//trim(filename), verb)
           call mywrite('',verb) 

           Nfile = ghead%npar_file(0)

           call hdf5_create_file( lun, filename )


           !================================================================
           ! write Header
           !================================================================
           call hdf5_create_group( lun, 'Header/' )
           call gadget_sphray_header_write_lun( ghead, lun )
!           call ghead%write_Gsphray_header_hdf5_lun(lun) 

           !================================================================
           ! write Units
           !================================================================
           call hdf5_create_group( lun, 'Units/' )
           gunits%cgs_length   = GV%cgs_len
           gunits%cgs_mass     = GV%cgs_mass
           gunits%cgs_velocity = GV%cgs_vel
           gunits%cgs_density  = GV%cgs_rho
           gunits%cgs_energy   = GV%cgs_enrg
           gunits%cgs_pressure = GV%cgs_prs
           gunits%cgs_time     = GV%cgs_time
           call gadget_units_write_lun( gunits, lun )          
!           call gunits%write_Gowls_units_lun(lun) 

           call gadget_data_attributes_set(gunits)
                     
           !================================================================
           ! write config parameters
           !================================================================
           call hdf5_create_group( lun, 'Config/' )
           call write_config_hdf5_lun(lun)

           if (Nfile == 0) then
              call hdf5_close_file(lun)
              cycle
           endif
           
           !================================================================
           ! write data
           !================================================================
           allocate( rblock3(3,Nfile) )
           rblock3(1,:) = psys%par(Nread+1:Nread+Nfile)%pos(1) 
           rblock3(2,:) = psys%par(Nread+1:Nread+Nfile)%pos(2) 
           rblock3(3,:) = psys%par(Nread+1:Nread+Nfile)%pos(3) 
           tag = trim(group_name)//'Coordinates'
           call hdf5_write_data( lun, tag, rblock3 )
           call gadget_data_attributes_write_lun( pos_attrs, lun, group_name, 'Coordinates' )
!           call pos_attrs%write_lun( lun, group_name, 'Coordinates' )


#ifdef incVel
           rblock3(1,:) = psys%par(Nread+1:Nread+Nfile)%vel(1) 
           rblock3(2,:) = psys%par(Nread+1:Nread+Nfile)%vel(2) 
           rblock3(3,:) = psys%par(Nread+1:Nread+Nfile)%vel(3) 
#else
           rblock3 = 0.0e0
#endif
           tag = trim(group_name)//'Velocity'
           call hdf5_write_data( lun, tag, rblock3 )
           call gadget_data_attributes_write_lun( vel_attrs, lun, group_name, 'Coordinates' )
!           call vel_attrs%write_lun( lun, group_name, 'Velocity' )
           deallocate( rblock3 )



           tag = trim(group_name)//'ParticleIDs'
           call hdf5_write_data( lun, tag, psys%par(Nread+1:Nread+Nfile)%id )
           call gadget_data_attributes_write_lun( id_attrs, lun, group_name, 'Coordinates' )
!           call id_attrs%write_lun( lun, group_name, 'ParticleIDs' )

           tag = trim(group_name)//'Mass'
           call hdf5_write_data( lun, tag, psys%par(Nread+1:Nread+Nfile)%mass )
           call gadget_data_attributes_write_lun( mass_attrs, lun, group_name, 'Coordinates' )
!           call mass_attrs%write_lun( lun, group_name, 'Mass' )


           tag = trim(group_name)//'Density'
           call hdf5_write_data( lun, tag, psys%par(Nread+1:Nread+Nfile)%rho )
           call gadget_data_attributes_write_lun( rho_attrs, lun, group_name, 'Coordinates' )
!           call rho_attrs%write_lun( lun, group_name, 'Density' )


           tag = trim(group_name)//'ElectronFraction'
           call hdf5_write_data( lun, tag, psys%par(Nread+1:Nread+Nfile)%ye )
           call gadget_data_attributes_write_lun( ye_attrs, lun, group_name, 'Coordinates' )
!           call ye_attrs%write_lun( lun, group_name, 'ElectronFraction' )

 
           tag = trim(group_name)//'HydrogenOneFraction'
           call hdf5_write_data( lun, tag, psys%par(Nread+1:Nread+Nfile)%xHI )
           call gadget_data_attributes_write_lun( xHI_attrs, lun, group_name, 'Coordinates' )
!           call xHI_attrs%write_lun( lun, group_name, 'HydrogenOneFraction' )


           tag = trim(group_name)//'SmoothingLength'
           call hdf5_write_data( lun, tag, psys%par(Nread+1:Nread+Nfile)%hsml )
           call gadget_data_attributes_write_lun( hsml_attrs, lun, group_name, 'Coordinates' ) 
!           call hsml_attrs%write_lun( lun, group_name, 'SmoothingLength' )


           tag = trim(group_name)//'Temperature'
           call hdf5_write_data( lun, tag, psys%par(Nread+1:Nread+Nfile)%T )
           call gadget_data_attributes_write_lun( T_attrs, lun, group_name, 'Coordinates' )
!           call T_attrs%write_lun( lun, group_name, 'Temperature' )


          
#ifdef incHmf
           tag = trim(group_name)//'ElementAbundance/Hydrogen'
           call hdf5_write_data( lun, tag, psys%par(Nread+1:Nread+Nfile)%Hmf )
           call gadget_data_attributes_write_lun( Hmf_attrs, lun, group_name, 'Coordinates' )
!           call Hmf_attrs%write_lun( lun, group_name, 'ElementAbundance/Hydrogen' )
#endif


#ifdef incHemf
           tag = trim(group_name)//'ElementAbundance/Helium'
           call hdf5_write_data( lun, tag, psys%par(Nread+1:Nread+Nfile)%Hemf )
           call gadget_data_attributes_write_lun( Hemf_attrs, lun, group_name, 'Coordinates' )
!           call Hemf_attrs%write_lun( lun, group_name, 'ElementAbundance/Helium' )
#endif


#ifdef incHe
           tag = trim(group_name)//'HeliumOneFraction'
           call hdf5_write_data( lun, tag, psys%par(Nread+1:Nread+Nfile)%xHeI )
           call gadget_data_attributes_write_lun( xHeI_attrs, lun, group_name, 'Coordinates' )
!           call xHeI_attrs%write_lun( lun, group_name, 'HeliumOneFraction' )

           tag = trim(group_name)//'HeliumTwoFraction'
           call hdf5_write_data( lun, tag, psys%par(Nread+1:Nread+Nfile)%xHeII )
           call gadget_data_attributes_write_lun( xHeII_attrs, lun, group_name, 'Coordinates' )
!           call xHeII_attrs%write_lun( lun, group_name, 'HeliumTwoFraction' )
#endif



#ifdef outGammaHI
           tag = trim(group_name)//'HydrogenOneGamma'
           call hdf5_write_data( lun, tag, psys%par(Nread+1:Nread+Nfile)%gammaHI )
           call gadget_data_attributes_write_lun( gammaHI_attrs, lun, group_name, 'Coordinates' )
!           call gammaHI_attrs%write_lun( lun, group_name, 'HydrogenOneGamma' )
#endif


 
#ifdef incCloudy
           tag = trim(group_name)//'HydrogenOneFraction_Cloudy'
           call hdf5_write_data( lun, tag, psys%par(Nread+1:Nread+Nfile)%xHI_cloudy )
           call gadget_data_attributes_write_lun( xHI_cloudy_attrs, lun, group_name, 'Coordinates' )
!           call xHI_cloudy_attrs%write_lun( lun, group_name, 'HydrogenOneFraction_Cloudy' )
#endif



#ifdef incEOS
           tag = trim(group_name)//'OnEquationOfState'
           call hdf5_write_data( lun, tag, psys%par(Nread+1:Nread+Nfile)%eos )
           call gadget_data_attributes_write_lun( eos_attrs, lun, group_name, 'Coordinates' ) 
!           call eos_attrs%write_lun( lun, group_name, 'OnEquationOfState' )
#endif


#ifdef incSFR
           tag = trim(group_name)//'StarFormationRate'
           call hdf5_write_data( lun, tag, psys%par(Nread+1:Nread+Nfile)%sfr )
           call gadget_data_attributes_write_lun( sfr_attrs, lun, group_name, 'Coordinates' )
!           call sfr_attrs%write_lun( lun, group_name, 'StarFormationRate' )
#endif


#ifdef incH2
           tag = trim(group_name)//'MolecularHydrogenMassFraction'
           call hdf5_write_data( lun, tag, psys%par(Nread+1:Nread+Nfile)%fH2 )
           call gadget_data_attributes_write_lun( fh2_attrs, lun, group_name, 'Coordinates' )
!           call fh2_attrs%write_lun( lun, group_name, 'MolecularHydrogenMassFraction' )
#endif


           call hdf5_close_file(lun)
           Nread = Nread + Nfile

        end do

#else

        stop " *** want hdf5 output w/o defining useHDF5 macro *** "

#endif
        
    

     end if
 
     !================================================================
     !================================================================

     if (GV%Comoving) then
        call particle_system_scale_comoving_to_physical(psys, scale, hub)
     endif


  end subroutine output_total_snap



  
!> writes the global ionization state of the system to a file
!=============================================================
  subroutine ion_frac_out(psys,tree)
  use iliev_comparison_project_mod

     type(particle_system_type), intent(in) :: psys    !< particle system
     type(oct_tree_type), intent(in) :: tree

     real :: Nionfrac, Mionfrac, Vionfrac
     real :: CallsPerCross
     real :: minGHI, maxGHI, GHI
     integer :: i
     integer :: nothit

     100 format(A,T24,A,T44,A,T64,A)
     101 format(A,T44,A,T64,A)
     105 format(T21,ES12.3,T43,ES12.3,T63,ES12.3)
     106 format(T43,ES12.3,T63,ES12.3)
     110 format(T21,I15,T43,I15,T63,ES12.5)

     write(*,100) "time:", "code units", "Myrs", "seconds"
     write(*,105) GV%start_time_code + GV%itime * GV%dt_code, &
                  GV%start_time_myr  + GV%itime * GV%dt_myr, &
                  GV%start_time_s    + GV%itime * GV%dt_s
     write(*,*) 

     write(*,100) "time elapsed:", "code units", "Myrs", "seconds"
     write(*,105) GV%time_elapsed_code, &
                  GV%time_elapsed_myr, &
                  GV%time_elapsed_s
     write(*,*) 


!    calculate the ionized number, volume, and mass fractions
     Nionfrac = particle_system_mean_xHII_number_weight(psys)
     Mionfrac = particle_system_mean_xHII_mass_weight(psys, DfltH_mf=GV%H_mf) 
     Vionfrac = particle_system_mean_xHII_volume_weight(psys)

     GV%nwionfrac = Nionfrac
     GV%mwionfrac = Mionfrac
     GV%vwionfrac = Vionfrac


     write(*,100) "neutral fraction:", "number weighted", "mass weighted", "volume weighted"
     write(*,105) 1.0d0-Nionfrac, 1.d0-Mionfrac, 1.0d0-Vionfrac
     write(*,*) 

     150 format (6ES15.5)
     write(GV%ionlun,150) GV%start_time_myr, &
                          GV%time_elapsed_myr, &
                          1.0d0-Nionfrac, 1.0d0-Mionfrac, 1.0d0-Vionfrac

     write(*,100) "rays cast:", "source", "diffuse", "diffuse/source"
     write(*,105) GV%TotalSourceRaysCast, GV%TotalDiffuseRaysCast, &
                  GV%TotalDiffuseRaysCast/GV%TotalSourceRaysCast 
     write(*,*) 
     
     if (GV%TotalPhotonsCast > 0.) then
        write(*,100) "photons:", "total cast", "per second", "% leaving box"
        write(*,105) GV%TotalPhotonsCast, GV%IonizingPhotonsPerSec, &
                     100.0 * GV%PhotonsLeavingBox / GV%TotalPhotonsCast
     else
        write(*,*) "zero luminosity source test"
     end if
     write(*,*)

     if (GV%ParticleCrossings .GT. 0) then
        CallsPerCross = GV%TotalDerivativeCalls / GV%ParticleCrossings
     else
        CallsPerCross = 0.0
     end if
     write(*,101) "solver(since last screen output):", &
                  "par crossings", "evals/crossings"
     write(*,106) GV%ParticleCrossings, CallsPerCross
     GV%TotalDerivativeCalls = 0.0
     GV%ParticleCrossings = 0.0

                  
     write(*,*)
     write(*,*) "Peak Updates = ", GV%PeakUpdates
     write(*,*) 



     160 format(T1,A,T20,ES12.5,T34,ES12.5)
     161 format(T1,A,T20,ES12.5)
     162 format(T1,A,T20,I12,T34,I12)
     write(*,160) "Min/Max xHI      = ", minval(psys%par(:)%xHI), &
                                        maxval(psys%par(:)%xHI)

     write(*,160) "Min/Max xHII     = ", minval(psys%par(:)%xHII), &
                                        maxval(psys%par(:)%xHII)

#ifdef incHe
     write(*,160) "Min/Max xHeI     = ", minval(psys%par(:)%xHeI), &
                                        maxval(psys%par(:)%xHeI)
     write(*,160) "Min/Max xHeII    = ", minval(psys%par(:)%xHeII), &
                                        maxval(psys%par(:)%xHeII)
     write(*,160) "Min/Max xHeIII   = ", minval(psys%par(:)%xHeIII), &
                                        maxval(psys%par(:)%xHeIII)
#endif

     write(*,160) "Min/Max T        = ", minval(psys%par(:)%T), &
                                        maxval(psys%par(:)%T)

#ifdef outGammaHI
     minGHI = huge(1.0)
     maxGHI = tiny(1.0)
     do i = 1, size(psys%par(:))
        if (psys%par(i)%time > 0.0) then
           GHI = psys%par(i)%gammaHI / psys%par(i)%time
           if (GHI < minGHI) minGHI = GHI
           if (GHI > maxGHI) maxGHI = GHI
        endif
     enddo
     write(*,160) "Min/Max GHI      = ", minGHI, maxGHI
#endif

     write(*,162) "Min/Max LastHit  = ", minval(psys%par(:)%lasthit), &
                                        maxval(psys%par(:)%lasthit)


     nothit = 0
     do i = 1, size(psys%par)
        if (psys%par(i)%lasthit == 0) then
           nothit = nothit + 1
        endif
     end do
     write(*,161) "Fraction Not Hit = ", real(nothit) / size(psys%par)


! do test specific outputs
     if (GV%DoTestScenario) then
        if (GV%TestScenario=="iliev_test1") then
           call iliev_test1_screen_out(psys,tree,GV)
        else if (GV%TestScenario=="iliev_test2") then
           call iliev_test2_screen_out(psys,tree,GV)
        else if (GV%TestScenario=="iliev_test3") then
           call iliev_test3_screen_out(psys,GV)
        else if (GV%TestScenario=="iliev_test4") then
           call iliev_test4_screen_out(psys,GV)
        end if
     end if

     write(*,*) 

  end subroutine ion_frac_out




end module output_mod

MODULE OpenGL_GLU
USE, INTRINSIC :: ISO_C_BINDING
USE OpenGL_kinds
IMPLICIT NONE
PRIVATE
!  Boolean values
INTEGER(GLboolean), PARAMETER, PUBLIC :: GLU_FALSE                = 0 ! 0
INTEGER(GLboolean), PARAMETER, PUBLIC :: GLU_TRUE                 = 1 ! 1
!  Version values
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_VERSION_1_1          = 1 ! 1
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_VERSION_1_2          = 1 ! 1
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_VERSION_1_3          = 1 ! 1
!  StringName values
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_VERSION              = 100800 ! 100800
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_EXTENSIONS           = 100801 ! 100801
!  ErrorCode values
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_INVALID_ENUM         = 100900 ! 100900
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_INVALID_VALUE        = 100901 ! 100901
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_OUT_OF_MEMORY        = 100902 ! 100902
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_INVALID_OPERATION    = 100904 ! 100904
!  NurbsDisplay values
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_OUTLINE_POLYGON      = 100240 ! 100240
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_OUTLINE_PATCH        = 100241 ! 100241
!  NurbsCallback values
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR          = 100103 ! 100103
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_ERROR                = 100103 ! 100103
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_BEGIN          = 100164 ! 100164
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_BEGIN_EXT      = 100164 ! 100164
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_VERTEX         = 100165 ! 100165
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_VERTEX_EXT     = 100165 ! 100165
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_NORMAL         = 100166 ! 100166
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_NORMAL_EXT     = 100166 ! 100166
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_COLOR          = 100167 ! 100167
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_COLOR_EXT      = 100167 ! 100167
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_TEXTURE_COORD  = 100168 ! 100168
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_TEX_COORD_EXT  = 100168 ! 100168
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_END            = 100169 ! 100169
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_END_EXT        = 100169 ! 100169
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_BEGIN_DATA     = 100170 ! 100170
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_BEGIN_DATA_EXT = 100170 ! 100170
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_VERTEX_DATA    = 100171 ! 100171
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_VERTEX_DATA_EXT = 100171 ! 100171
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_NORMAL_DATA    = 100172 ! 100172
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_NORMAL_DATA_EXT = 100172 ! 100172
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_COLOR_DATA     = 100173 ! 100173
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_COLOR_DATA_EXT = 100173 ! 100173
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_TEXTURE_COORD_DATA = 100174 ! 100174
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_TEX_COORD_DATA_EXT = 100174 ! 100174
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_END_DATA       = 100175 ! 100175
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_END_DATA_EXT   = 100175 ! 100175
!  NurbsError values
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR1         = 100251 ! 100251
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR2         = 100252 ! 100252
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR3         = 100253 ! 100253
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR4         = 100254 ! 100254
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR5         = 100255 ! 100255
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR6         = 100256 ! 100256
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR7         = 100257 ! 100257
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR8         = 100258 ! 100258
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR9         = 100259 ! 100259
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR10        = 100260 ! 100260
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR11        = 100261 ! 100261
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR12        = 100262 ! 100262
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR13        = 100263 ! 100263
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR14        = 100264 ! 100264
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR15        = 100265 ! 100265
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR16        = 100266 ! 100266
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR17        = 100267 ! 100267
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR18        = 100268 ! 100268
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR19        = 100269 ! 100269
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR20        = 100270 ! 100270
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR21        = 100271 ! 100271
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR22        = 100272 ! 100272
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR23        = 100273 ! 100273
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR24        = 100274 ! 100274
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR25        = 100275 ! 100275
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR26        = 100276 ! 100276
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR27        = 100277 ! 100277
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR28        = 100278 ! 100278
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR29        = 100279 ! 100279
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR30        = 100280 ! 100280
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR31        = 100281 ! 100281
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR32        = 100282 ! 100282
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR33        = 100283 ! 100283
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR34        = 100284 ! 100284
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR35        = 100285 ! 100285
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR36        = 100286 ! 100286
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_ERROR37        = 100287 ! 100287
!  NurbsProperty values
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_AUTO_LOAD_MATRIX     = 100200 ! 100200
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_CULLING              = 100201 ! 100201
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_SAMPLING_TOLERANCE   = 100203 ! 100203
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_DISPLAY_MODE         = 100204 ! 100204
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_PARAMETRIC_TOLERANCE = 100202 ! 100202
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_SAMPLING_METHOD      = 100205 ! 100205
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_U_STEP               = 100206 ! 100206
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_V_STEP               = 100207 ! 100207
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_MODE           = 100160 ! 100160
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_MODE_EXT       = 100160 ! 100160
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_TESSELLATOR    = 100161 ! 100161
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_TESSELLATOR_EXT = 100161 ! 100161
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_RENDERER       = 100162 ! 100162
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NURBS_RENDERER_EXT   = 100162 ! 100162
!  NurbsSampling values
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_OBJECT_PARAMETRIC_ERROR = 100208 ! 100208
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_OBJECT_PARAMETRIC_ERROR_EXT = 100208 ! 100208
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_OBJECT_PATH_LENGTH   = 100209 ! 100209
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_OBJECT_PATH_LENGTH_EXT = 100209 ! 100209
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_PATH_LENGTH          = 100215 ! 100215
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_PARAMETRIC_ERROR     = 100216 ! 100216
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_DOMAIN_DISTANCE      = 100217 ! 100217
!  NurbsTrim values
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_MAP1_TRIM_2          = 100210 ! 100210
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_MAP1_TRIM_3          = 100211 ! 100211
!  QuadricDrawStyle values
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_POINT                = 100010 ! 100010
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_LINE                 = 100011 ! 100011
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_FILL                 = 100012 ! 100012
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_SILHOUETTE           = 100013 ! 100013
!  QuadricCallback values
!  QuadricNormal values
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_SMOOTH               = 100000 ! 100000
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_FLAT                 = 100001 ! 100001
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_NONE                 = 100002 ! 100002
!  QuadricOrientation values
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_OUTSIDE              = 100020 ! 100020
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_INSIDE               = 100021 ! 100021
!  TessCallback values
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_BEGIN           = 100100 ! 100100
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_BEGIN                = 100100 ! 100100
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_VERTEX          = 100101 ! 100101
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_VERTEX               = 100101 ! 100101
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_END             = 100102 ! 100102
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_END                  = 100102 ! 100102
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_ERROR           = 100103 ! 100103
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_EDGE_FLAG       = 100104 ! 100104
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_EDGE_FLAG            = 100104 ! 100104
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_COMBINE         = 100105 ! 100105
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_BEGIN_DATA      = 100106 ! 100106
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_VERTEX_DATA     = 100107 ! 100107
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_END_DATA        = 100108 ! 100108
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_ERROR_DATA      = 100109 ! 100109
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_EDGE_FLAG_DATA  = 100110 ! 100110
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_COMBINE_DATA    = 100111 ! 100111
!  TessContour values
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_CW                   = 100120 ! 100120
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_CCW                  = 100121 ! 100121
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_INTERIOR             = 100122 ! 100122
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_EXTERIOR             = 100123 ! 100123
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_UNKNOWN              = 100124 ! 100124
!  TessProperty values
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_WINDING_RULE    = 100140 ! 100140
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_BOUNDARY_ONLY   = 100141 ! 100141
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_TOLERANCE       = 100142 ! 100142
!  TessError values
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_ERROR1          = 100151 ! 100151
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_ERROR2          = 100152 ! 100152
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_ERROR3          = 100153 ! 100153
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_ERROR4          = 100154 ! 100154
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_ERROR5          = 100155 ! 100155
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_ERROR6          = 100156 ! 100156
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_ERROR7          = 100157 ! 100157
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_ERROR8          = 100158 ! 100158
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_MISSING_BEGIN_POLYGON = 100151 ! 100151
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_MISSING_BEGIN_CONTOUR = 100152 ! 100152
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_MISSING_END_POLYGON = 100153 ! 100153
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_MISSING_END_CONTOUR = 100154 ! 100154
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_COORD_TOO_LARGE = 100155 ! 100155
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_NEED_COMBINE_CALLBACK = 100156 ! 100156
!  TessWinding values
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_WINDING_ODD     = 100130 ! 100130
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_WINDING_NONZERO = 100131 ! 100131
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_WINDING_POSITIVE = 100132 ! 100132
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_WINDING_NEGATIVE = 100133 ! 100133
INTEGER(GLenum), PARAMETER, PUBLIC :: GLU_TESS_WINDING_ABS_GEQ_TWO = 100134 ! 100134


!  GLU  commands

!  BeginCurve(nurb)
!  return  void
!  param   nurb		NurbsObj in value
PUBLIC :: gluBeginCurve
INTERFACE
SUBROUTINE gluBeginCurve(nurb) BIND(C,NAME="gluBeginCurve")
IMPORT
TYPE(C_PTR), VALUE :: nurb
END SUBROUTINE gluBeginCurve

END INTERFACE

!  BeginPolygon(tess)
!  return  void
!  param   tess		TesselatorObj in value
PUBLIC :: gluBeginPolygon
INTERFACE
SUBROUTINE gluBeginPolygon(tess) BIND(C,NAME="gluBeginPolygon")
IMPORT
TYPE(C_PTR), VALUE :: tess
END SUBROUTINE gluBeginPolygon

END INTERFACE

!  BeginSurface(nurb)
!  return  void
!  param   nurb		NurbsObj in value
PUBLIC :: gluBeginSurface
INTERFACE
SUBROUTINE gluBeginSurface(nurb) BIND(C,NAME="gluBeginSurface")
IMPORT
TYPE(C_PTR), VALUE :: nurb
END SUBROUTINE gluBeginSurface

END INTERFACE

!  BeginTrim(nurb)
!  return  void
!  param   nurb		NurbsObj in value
PUBLIC :: gluBeginTrim
INTERFACE
SUBROUTINE gluBeginTrim(nurb) BIND(C,NAME="gluBeginTrim")
IMPORT
TYPE(C_PTR), VALUE :: nurb
END SUBROUTINE gluBeginTrim

END INTERFACE

!  Build1DMipmapLevels(target, internalFormat, width, format, type, level, base, max, data)
!  return  Int32
!  param   target		TextureTarget in value
!  param   internalFormat	Int32 in value
!  param   width		SizeI in value
!  param   format		PixelFormat in value
!  param   type		PixelType in value
!  param   level		Int32 in value
!  param   base		Int32 in value
!  param   max		Int32 in value
!  param   data		void in reference
PUBLIC :: gluBuild1DMipmapLevels
INTERFACE
FUNCTION gluBuild1DMipmapLevels(target, internalFormat, width, format, type,  &
    level, base, max, data) BIND(C,NAME="gluBuild1DMipmapLevels")
IMPORT
INTEGER(GLint) :: gluBuild1DMipmapLevels
INTEGER(GLenum), VALUE :: target, format, type
INTEGER(GLint), VALUE :: internalFormat, level, base, max
INTEGER(GLsizei), VALUE :: width
TYPE(C_PTR), VALUE :: data
END FUNCTION gluBuild1DMipmapLevels

END INTERFACE

!  Build1DMipmaps(target, internalFormat, width, format, type, data)
!  return  Int32
!  param   target		TextureTarget in value
!  param   internalFormat	Int32 in value
!  param   width		SizeI in value
!  param   format		PixelFormat in value
!  param   type		PixelType in value
!  param   data		void in reference
PUBLIC :: gluBuild1DMipmaps
INTERFACE
FUNCTION gluBuild1DMipmaps(target, internalFormat, width, format, type,       &
    data) BIND(C,NAME="gluBuild1DMipmaps")
IMPORT
INTEGER(GLint) :: gluBuild1DMipmaps
INTEGER(GLenum), VALUE :: target, format, type
INTEGER(GLint), VALUE :: internalFormat
INTEGER(GLsizei), VALUE :: width
TYPE(C_PTR), VALUE :: data
END FUNCTION gluBuild1DMipmaps

END INTERFACE

!  Build2DMipmapLevels(target, internalFormat, width, height, format, type, level, base, max, data)
!  return  Int32
!  param   target		TextureTarget in value
!  param   internalFormat	Int32 in value
!  param   width		SizeI in value
!  param   height		SizeI in value
!  param   format		PixelFormat in value
!  param   type		PixelType in value
!  param   level		Int32 in value
!  param   base		Int32 in value
!  param   max		Int32 in value
!  param   data		void in reference
PUBLIC :: gluBuild2DMipmapLevels
INTERFACE
FUNCTION gluBuild2DMipmapLevels(target, internalFormat, width, height,        &
    format, type, level, base, max, data)                                         &
    BIND(C,NAME="gluBuild2DMipmapLevels")
IMPORT
INTEGER(GLint) :: gluBuild2DMipmapLevels
INTEGER(GLenum), VALUE :: target, format, type
INTEGER(GLint), VALUE :: internalFormat, level, base, max
INTEGER(GLsizei), VALUE :: width, height
TYPE(C_PTR), VALUE :: data
END FUNCTION gluBuild2DMipmapLevels

END INTERFACE

!  Build2DMipmaps(target, internalFormat, width, height, format, type, data)
!  return  Int32
!  param   target		TextureTarget in value
!  param   internalFormat	Int32 in value
!  param   width		SizeI in value
!  param   height		SizeI in value
!  param   format		PixelFormat in value
!  param   type		PixelType in value
!  param   data		void in reference
PUBLIC :: gluBuild2DMipmaps
INTERFACE
FUNCTION gluBuild2DMipmaps(target, internalFormat, width, height, format,     &
    type, data) BIND(C,NAME="gluBuild2DMipmaps")
IMPORT
INTEGER(GLint) :: gluBuild2DMipmaps
INTEGER(GLenum), VALUE :: target, format, type
INTEGER(GLint), VALUE :: internalFormat
INTEGER(GLsizei), VALUE :: width, height
TYPE(C_PTR), VALUE :: data
END FUNCTION gluBuild2DMipmaps

END INTERFACE

!  Build3DMipmapLevels(target, internalFormat, width, height, depth, format, type, level, base, max, data)
!  return  Int32
!  param   target		TextureTarget in value
!  param   internalFormat	Int32 in value
!  param   width		SizeI in value
!  param   height		SizeI in value
!  param   depth		SizeI in value
!  param   format		PixelFormat in value
!  param   type		PixelType in value
!  param   level		Int32 in value
!  param   base		Int32 in value
!  param   max		Int32 in value
!  param   data		void in reference
PUBLIC :: gluBuild3DMipmapLevels
INTERFACE
FUNCTION gluBuild3DMipmapLevels(target, internalFormat, width, height,        &
    depth, format, type, level, base, max, data)                                  &
    BIND(C,NAME="gluBuild3DMipmapLevels")
IMPORT
INTEGER(GLint) :: gluBuild3DMipmapLevels
INTEGER(GLenum), VALUE :: target, format, type
INTEGER(GLint), VALUE :: internalFormat, level, base, max
INTEGER(GLsizei), VALUE :: width, height, depth
TYPE(C_PTR), VALUE :: data
END FUNCTION gluBuild3DMipmapLevels

END INTERFACE

!  Build3DMipmaps(target, internalFormat, width, height, depth, format, type, data)
!  return  Int32
!  param   target		TextureTarget in value
!  param   internalFormat	Int32 in value
!  param   width		SizeI in value
!  param   height		SizeI in value
!  param   depth		SizeI in value
!  param   format		PixelFormat in value
!  param   type		PixelType in value
!  param   data		void in reference
PUBLIC :: gluBuild3DMipmaps
INTERFACE
FUNCTION gluBuild3DMipmaps(target, internalFormat, width, height, depth,      &
    format, type, data) BIND(C,NAME="gluBuild3DMipmaps")
IMPORT
INTEGER(GLint) :: gluBuild3DMipmaps
INTEGER(GLenum), VALUE :: target, format, type
INTEGER(GLint), VALUE :: internalFormat
INTEGER(GLsizei), VALUE :: width, height, depth
TYPE(C_PTR), VALUE :: data
END FUNCTION gluBuild3DMipmaps

END INTERFACE

!  CheckExtension(extName, extString)
!  return  Boolean
!  param   extName		UInt8 in array [COMPSIZE()]
!  param   extString	UInt8 in array [COMPSIZE()]
PUBLIC :: gluCheckExtension
INTERFACE
FUNCTION gluCheckExtension(extName, extString)                                &
    BIND(C,NAME="gluCheckExtension")
IMPORT
INTEGER(GLboolean) :: gluCheckExtension
INTEGER(GLbyte), DIMENSION(*), INTENT(IN) :: extName, extString
END FUNCTION gluCheckExtension

END INTERFACE

!  Cylinder(quad, base, top, height, slices, stacks)
!  return  void
!  param   quad		QuadricObj in value
!  param   base		Float64 in value
!  param   top		Float64 in value
!  param   height		Float64 in value
!  param   slices		Int32 in value
!  param   stacks		Int32 in value
PUBLIC :: gluCylinder
INTERFACE
SUBROUTINE gluCylinder(quad, base, top, height, slices, stacks)               &
    BIND(C,NAME="gluCylinder")
IMPORT
INTEGER(GLint), VALUE :: slices, stacks
REAL(GLdouble), VALUE :: base, top, height
TYPE(C_PTR), VALUE :: quad
END SUBROUTINE gluCylinder

END INTERFACE

!  DeleteNurbsRenderer(nurb)
!  return  void
!  param   nurb		NurbsObj in value
PUBLIC :: gluDeleteNurbsRenderer
INTERFACE
SUBROUTINE gluDeleteNurbsRenderer(nurb)                                       &
    BIND(C,NAME="gluDeleteNurbsRenderer")
IMPORT
TYPE(C_PTR), VALUE :: nurb
END SUBROUTINE gluDeleteNurbsRenderer

END INTERFACE

!  DeleteQuadric(quad)
!  return  void
!  param   quad		QuadricObj in value
PUBLIC :: gluDeleteQuadric
INTERFACE
SUBROUTINE gluDeleteQuadric(quad) BIND(C,NAME="gluDeleteQuadric")
IMPORT
TYPE(C_PTR), VALUE :: quad
END SUBROUTINE gluDeleteQuadric

END INTERFACE

!  DeleteTess(tess)
!  return  void
!  param   tess		TesselatorObj in value
PUBLIC :: gluDeleteTess
INTERFACE
SUBROUTINE gluDeleteTess(tess) BIND(C,NAME="gluDeleteTess")
IMPORT
TYPE(C_PTR), VALUE :: tess
END SUBROUTINE gluDeleteTess

END INTERFACE

!  Disk(quad, inner, outer, slices, loops)
!  return  void
!  param   quad		QuadricObj in value
!  param   inner		Float64 in value
!  param   outer		Float64 in value
!  param   slices		Int32 in value
!  param   loops		Int32 in value
PUBLIC :: gluDisk
INTERFACE
SUBROUTINE gluDisk(quad, inner, outer, slices, loops)                         &
    BIND(C,NAME="gluDisk")
IMPORT
INTEGER(GLint), VALUE :: slices, loops
REAL(GLdouble), VALUE :: inner, outer
TYPE(C_PTR), VALUE :: quad
END SUBROUTINE gluDisk

END INTERFACE

!  EndCurve(nurb)
!  return  void
!  param   nurb		NurbsObj in value
PUBLIC :: gluEndCurve
INTERFACE
SUBROUTINE gluEndCurve(nurb) BIND(C,NAME="gluEndCurve")
IMPORT
TYPE(C_PTR), VALUE :: nurb
END SUBROUTINE gluEndCurve

END INTERFACE

!  EndPolygon(tess)
!  return  void
!  param   tess		TesselatorObj in value
PUBLIC :: gluEndPolygon
INTERFACE
SUBROUTINE gluEndPolygon(tess) BIND(C,NAME="gluEndPolygon")
IMPORT
TYPE(C_PTR), VALUE :: tess
END SUBROUTINE gluEndPolygon

END INTERFACE

!  EndSurface(nurb)
!  return  void
!  param   nurb		NurbsObj in value
PUBLIC :: gluEndSurface
INTERFACE
SUBROUTINE gluEndSurface(nurb) BIND(C,NAME="gluEndSurface")
IMPORT
TYPE(C_PTR), VALUE :: nurb
END SUBROUTINE gluEndSurface

END INTERFACE

!  EndTrim(nurb)
!  return  void
!  param   nurb		NurbsObj in value
PUBLIC :: gluEndTrim
INTERFACE
SUBROUTINE gluEndTrim(nurb) BIND(C,NAME="gluEndTrim")
IMPORT
TYPE(C_PTR), VALUE :: nurb
END SUBROUTINE gluEndTrim

END INTERFACE

!  ErrorString(error)
!  return  String
!  param   error		ErrorCode in value
PUBLIC :: gluErrorString
INTERFACE
FUNCTION gluErrorString(error) BIND(C,NAME="gluErrorString")
IMPORT
TYPE(C_PTR) :: gluErrorString
INTEGER(GLenum), VALUE :: error
END FUNCTION gluErrorString

END INTERFACE

!  GetString(name)
!  return  String
!  param   name		StringName in value
PUBLIC :: gluGetString
INTERFACE
FUNCTION gluGetString(name) BIND(C,NAME="gluGetString")
IMPORT
TYPE(C_PTR) :: gluGetString
INTEGER(GLenum), VALUE :: name
END FUNCTION gluGetString

END INTERFACE

!  GetNurbsProperty(nurb, property, data)
!  return  void
!  param   nurb		NurbsObj in value
!  param   property	NurbsProperty in value
!  param   data		Float32Pointer out value
PUBLIC :: gluGetNurbsProperty
INTERFACE
SUBROUTINE gluGetNurbsProperty(nurb, property, data)                          &
    BIND(C,NAME="gluGetNurbsProperty")
IMPORT
INTEGER(GLenum), VALUE :: property
TYPE(C_PTR), VALUE :: nurb
REAL(GLfloat), DIMENSION(*), INTENT(OUT) :: data
END SUBROUTINE gluGetNurbsProperty

END INTERFACE

!  GetTessProperty(tess, which, data)
!  return  void
!  param   tess		TesselatorObj in value
!  param   which		TessProperty in value
!  param   data		Float64Pointer out value
PUBLIC :: gluGetTessProperty
INTERFACE
SUBROUTINE gluGetTessProperty(tess, which, data)                              &
    BIND(C,NAME="gluGetTessProperty")
IMPORT
INTEGER(GLenum), VALUE :: which
TYPE(C_PTR), VALUE :: tess
REAL(GLdouble), DIMENSION(*), INTENT(OUT) :: data
END SUBROUTINE gluGetTessProperty

END INTERFACE

!  LoadSamplingMatrices(nurb, model, perspective, view)
!  return  void
!  param   nurb		NurbsObj in value
!  param   model		Float32 in array [16]
!  param   perspective	Float32 in array [16]
!  param   view		Int32 in array [4]
PUBLIC :: gluLoadSamplingMatrices
INTERFACE
SUBROUTINE gluLoadSamplingMatrices(nurb, model, perspective, view)            &
    BIND(C,NAME="gluLoadSamplingMatrices")
IMPORT
TYPE(C_PTR), VALUE :: nurb
INTEGER(GLint), DIMENSION(4), INTENT(IN) :: view
REAL(GLfloat), DIMENSION(16), INTENT(IN) :: model, perspective
END SUBROUTINE gluLoadSamplingMatrices

END INTERFACE

!  LookAt(eyeX, eyeY, eyeZ, centerX, centerY, centerZ, upX, upY, upZ)
!  return  void
!  param   eyeX		Float64 in value
!  param   eyeY		Float64 in value
!  param   eyeZ		Float64 in value
!  param   centerX		Float64 in value
!  param   centerY		Float64 in value
!  param   centerZ		Float64 in value
!  param   upX		Float64 in value
!  param   upY		Float64 in value
!  param   upZ		Float64 in value
PUBLIC :: gluLookAt
INTERFACE
SUBROUTINE gluLookAt(eyeX, eyeY, eyeZ, centerX, centerY, centerZ, upX, upY,   &
    upZ) BIND(C,NAME="gluLookAt")
IMPORT
REAL(GLdouble), VALUE :: eyeX, eyeY, eyeZ, centerX, centerY, centerZ, upX, upY, upZ
END SUBROUTINE gluLookAt

END INTERFACE

!  NewNurbsRenderer()
!  return  NurbsObj
PUBLIC :: gluNewNurbsRenderer
INTERFACE
FUNCTION gluNewNurbsRenderer() BIND(C,NAME="gluNewNurbsRenderer")
IMPORT
TYPE(C_PTR) :: gluNewNurbsRenderer
END FUNCTION gluNewNurbsRenderer

END INTERFACE

!  NewQuadric()
!  return  QuadricObj
PUBLIC :: gluNewQuadric
INTERFACE
FUNCTION gluNewQuadric() BIND(C,NAME="gluNewQuadric")
IMPORT
TYPE(C_PTR) :: gluNewQuadric
END FUNCTION gluNewQuadric

END INTERFACE

!  NewTess()
!  return  TesselatorObj
PUBLIC :: gluNewTess
INTERFACE
FUNCTION gluNewTess() BIND(C,NAME="gluNewTess")
IMPORT
TYPE(C_PTR) :: gluNewTess
END FUNCTION gluNewTess

END INTERFACE

!  NextContour(tess, type)
!  return  void
!  param   tess		TesselatorObj in value
!  param   type		TessContour in value
PUBLIC :: gluNextContour
INTERFACE
SUBROUTINE gluNextContour(tess, type) BIND(C,NAME="gluNextContour")
IMPORT
INTEGER(GLenum), VALUE :: type
TYPE(C_PTR), VALUE :: tess
END SUBROUTINE gluNextContour

END INTERFACE

!  NurbsCallback(nurb, which, CallBackFunc)
!  return  void
!  param   nurb		NurbsObj in value
!  param   which		NurbsCallback in value
!  param   CallBackFunc	FunctionPointer in value
PUBLIC :: gluNurbsCallback
INTERFACE
SUBROUTINE gluNurbsCallback(nurb, which, CallBackFunc)                        &
    BIND(C,NAME="gluNurbsCallback")
IMPORT
INTEGER(GLenum), VALUE :: which
TYPE(C_FUNPTR), VALUE :: CallBackFunc
TYPE(C_PTR), VALUE :: nurb
END SUBROUTINE gluNurbsCallback

END INTERFACE

!  NurbsCallbackData(nurb, userData)
!  return  void
!  param   nurb		NurbsObj in value
!  param   userData	VoidPointer in value
PUBLIC :: gluNurbsCallbackData
INTERFACE
SUBROUTINE gluNurbsCallbackData(nurb, userData)                               &
    BIND(C,NAME="gluNurbsCallbackData")
IMPORT
TYPE(C_PTR), VALUE :: nurb, userData
END SUBROUTINE gluNurbsCallbackData

END INTERFACE

!  NurbsCallbackDataEXT(nurb, userData)
!  return  void
!  param   nurb		NurbsObj in value
!  param   userData	VoidPointer in value
PUBLIC :: gluNurbsCallbackDataEXT
INTERFACE
SUBROUTINE gluNurbsCallbackDataEXT(nurb, userData)                            &
    BIND(C,NAME="gluNurbsCallbackDataEXT")
IMPORT
TYPE(C_PTR), VALUE :: nurb, userData
END SUBROUTINE gluNurbsCallbackDataEXT

END INTERFACE

!  NurbsCurve(nurb, knotCount, knots, stride, control, order, type)
!  return  void
!  param   nurb		NurbsObj in value
!  param   knotCount	Int32 in value
!  param   knots		Float32 out reference
!  param   stride		Int32 in value
!  param   control		Float32 out reference
!  param   order		Int32 in value
!  param   type		MapTarget in value
PUBLIC :: gluNurbsCurve
INTERFACE
SUBROUTINE gluNurbsCurve(nurb, knotCount, knots, stride, control, order,      &
    type) BIND(C,NAME="gluNurbsCurve")
IMPORT
INTEGER(GLenum), VALUE :: type
INTEGER(GLint), VALUE :: knotCount, stride, order
TYPE(C_PTR), VALUE :: nurb
REAL(GLfloat), DIMENSION(*), INTENT(OUT) :: knots, control
END SUBROUTINE gluNurbsCurve

END INTERFACE

!  NurbsProperty(nurb, property, value)
!  return  void
!  param   nurb		NurbsObj in value
!  param   property	NurbsProperty in value
!  param   value		Float32 in value
PUBLIC :: gluNurbsProperty
INTERFACE
SUBROUTINE gluNurbsProperty(nurb, property, value)                            &
    BIND(C,NAME="gluNurbsProperty")
IMPORT
INTEGER(GLenum), VALUE :: property
REAL(GLfloat), VALUE :: value
TYPE(C_PTR), VALUE :: nurb
END SUBROUTINE gluNurbsProperty

END INTERFACE

!  NurbsSurface(nurb, sKnotCount, sKnots, tKnotCount, tKnots, sStride, tStride, control, sOrder, tOrder, type)
!  return  void
!  param   nurb		NurbsObj in value
!  param   sKnotCount	Int32 in value
!  param   sKnots		Float32Pointer in value
!  param   tKnotCount	Int32 in value
!  param   tKnots		Float32Pointer in value
!  param   sStride		Int32 in value
!  param   tStride		Int32 in value
!  param   control		Float32Pointer in value
!  param   sOrder		Int32 in value
!  param   tOrder		Int32 in value
!  param   type		MapTarget in value
PUBLIC :: gluNurbsSurface
INTERFACE
SUBROUTINE gluNurbsSurface(nurb, sKnotCount, sKnots, tKnotCount, tKnots,      &
    sStride, tStride, control, sOrder, tOrder, type)                              &
    BIND(C,NAME="gluNurbsSurface")
IMPORT
INTEGER(GLenum), VALUE :: type
INTEGER(GLint), VALUE :: sKnotCount, tKnotCount, sStride, tStride, sOrder, tOrder
TYPE(C_PTR), VALUE :: nurb
REAL(GLfloat), DIMENSION(*), INTENT(IN) :: sKnots, tKnots, control
END SUBROUTINE gluNurbsSurface

END INTERFACE

!  Ortho2D(left, right, bottom, top)
!  return  void
!  param   left		Float64 in value
!  param   right		Float64 in value
!  param   bottom		Float64 in value
!  param   top		Float64 in value
PUBLIC :: gluOrtho2D
INTERFACE
SUBROUTINE gluOrtho2D(left, right, bottom, top) BIND(C,NAME="gluOrtho2D")
IMPORT
REAL(GLdouble), VALUE :: left, right, bottom, top
END SUBROUTINE gluOrtho2D

END INTERFACE

!  PartialDisk(quad, inner, outer, slices, loops, start, sweep)
!  return  void
!  param   quad		QuadricObj in value
!  param   inner		Float64 in value
!  param   outer		Float64 in value
!  param   slices		Int32 in value
!  param   loops		Int32 in value
!  param   start		Float64 in value
!  param   sweep		Float64 in value
PUBLIC :: gluPartialDisk
INTERFACE
SUBROUTINE gluPartialDisk(quad, inner, outer, slices, loops, start, sweep)    &
    BIND(C,NAME="gluPartialDisk")
IMPORT
INTEGER(GLint), VALUE :: slices, loops
REAL(GLdouble), VALUE :: inner, outer, start, sweep
TYPE(C_PTR), VALUE :: quad
END SUBROUTINE gluPartialDisk

END INTERFACE

!  Perspective(fovy, aspect, zNear, zFar)
!  return  void
!  param   fovy		Float64 in value
!  param   aspect		Float64 in value
!  param   zNear		Float64 in value
!  param   zFar		Float64 in value
PUBLIC :: gluPerspective
INTERFACE
SUBROUTINE gluPerspective(fovy, aspect, zNear, zFar)                          &
    BIND(C,NAME="gluPerspective")
IMPORT
REAL(GLdouble), VALUE :: fovy, aspect, zNear, zFar
END SUBROUTINE gluPerspective

END INTERFACE

!  PickMatrix(x, y, delX, delY, viewport)
!  return  void
!  param   x		Float64 in value
!  param   y		Float64 in value
!  param   delX		Float64 in value
!  param   delY		Float64 in value
!  param   viewport	Int32 out array [4]
PUBLIC :: gluPickMatrix
INTERFACE
SUBROUTINE gluPickMatrix(x, y, delX, delY, viewport)                          &
    BIND(C,NAME="gluPickMatrix")
IMPORT
REAL(GLdouble), VALUE :: x, y, delX, delY
INTEGER(GLint), DIMENSION(4), INTENT(OUT) :: viewport
END SUBROUTINE gluPickMatrix

END INTERFACE

!  Project(objX, objY, objZ, model, proj, view, winX, winY, winZ)
!  return  Int32
!  param   objX		Float64 in value
!  param   objY		Float64 in value
!  param   objZ		Float64 in value
!  param   model		Float64 in array [16]
!  param   proj		Float64 in array [16]
!  param   view		Int32 in array [4]
!  param   winX		Float64Pointer in value
!  param   winY		Float64Pointer in value
!  param   winZ		Float64Pointer in value
PUBLIC :: gluProject
INTERFACE
FUNCTION gluProject(objX, objY, objZ, model, proj, view, winX, winY, winZ)    &
    BIND(C,NAME="gluProject")
IMPORT
INTEGER(GLint) :: gluProject
REAL(GLdouble), VALUE :: objX, objY, objZ
INTEGER(GLint), DIMENSION(4), INTENT(IN) :: view
REAL(GLdouble), DIMENSION(*), INTENT(IN) :: winX, winY, winZ
REAL(GLdouble), DIMENSION(16), INTENT(IN) :: model, proj
END FUNCTION gluProject

END INTERFACE

!  PwlCurve(nurb, count, data, stride, type)
!  return  void
!  param   nurb		NurbsObj in value
!  param   count		Int32 in value
!  param   data		Float32Pointer in value
!  param   stride		Int32 in value
!  param   type		NurbsTrim in value
PUBLIC :: gluPwlCurve
INTERFACE
SUBROUTINE gluPwlCurve(nurb, count, data, stride, type)                       &
    BIND(C,NAME="gluPwlCurve")
IMPORT
INTEGER(GLenum), VALUE :: type
INTEGER(GLint), VALUE :: count, stride
TYPE(C_PTR), VALUE :: nurb
REAL(GLfloat), DIMENSION(*), INTENT(IN) :: data
END SUBROUTINE gluPwlCurve

END INTERFACE

!  QuadricCallback(quad, which, CallBackFunc)
!  return  void
!  param   quad		QuadricObj in value
!  param   which		QuadricCallback in value
!  param   CallBackFunc	FunctionPointer in value
PUBLIC :: gluQuadricCallback
INTERFACE
SUBROUTINE gluQuadricCallback(quad, which, CallBackFunc)                      &
    BIND(C,NAME="gluQuadricCallback")
IMPORT
INTEGER(GLenum), VALUE :: which
TYPE(C_FUNPTR), VALUE :: CallBackFunc
TYPE(C_PTR), VALUE :: quad
END SUBROUTINE gluQuadricCallback

END INTERFACE

!  QuadricDrawStyle(quad, draw)
!  return  void
!  param   quad		QuadricObj in value
!  param   draw		QuadricDrawStyle in value
PUBLIC :: gluQuadricDrawStyle
INTERFACE
SUBROUTINE gluQuadricDrawStyle(quad, draw)                                    &
    BIND(C,NAME="gluQuadricDrawStyle")
IMPORT
INTEGER(GLenum), VALUE :: draw
TYPE(C_PTR), VALUE :: quad
END SUBROUTINE gluQuadricDrawStyle

END INTERFACE

!  QuadricNormals(quad, normal)
!  return  void
!  param   quad		QuadricObj in value
!  param   normal		QuadricNormal in value
PUBLIC :: gluQuadricNormals
INTERFACE
SUBROUTINE gluQuadricNormals(quad, normal) BIND(C,NAME="gluQuadricNormals")
IMPORT
INTEGER(GLenum), VALUE :: normal
TYPE(C_PTR), VALUE :: quad
END SUBROUTINE gluQuadricNormals

END INTERFACE

!  QuadricOrientation(quad, orientation)
!  return  void
!  param   quad		QuadricObj in value
!  param   orientation	QuadricOrientation in value
PUBLIC :: gluQuadricOrientation
INTERFACE
SUBROUTINE gluQuadricOrientation(quad, orientation)                           &
    BIND(C,NAME="gluQuadricOrientation")
IMPORT
INTEGER(GLenum), VALUE :: orientation
TYPE(C_PTR), VALUE :: quad
END SUBROUTINE gluQuadricOrientation

END INTERFACE

!  QuadricTexture(quad, texture)
!  return  void
!  param   quad		QuadricObj in value
!  param   texture		Boolean in value
PUBLIC :: gluQuadricTexture
INTERFACE
SUBROUTINE gluQuadricTexture(quad, texture)                                   &
    BIND(C,NAME="gluQuadricTexture")
IMPORT
INTEGER(GLboolean), VALUE :: texture
TYPE(C_PTR), VALUE :: quad
END SUBROUTINE gluQuadricTexture

END INTERFACE

!  ScaleImage(format, wIn, hIn, typeIn, dataIn, wOut, hOut, typeOut, dataOut)
!  return  Int32
!  param   format		PixelFormat in value
!  param   wIn		SizeI in value
!  param   hIn		SizeI in value
!  param   typeIn		PixelType in value
!  param   dataIn		void in reference
!  param   wOut		SizeI in value
!  param   hOut		SizeI in value
!  param   typeOut		PixelType in value
!  param   dataOut		VoidPointer out value
PUBLIC :: gluScaleImage
INTERFACE
FUNCTION gluScaleImage(format, wIn, hIn, typeIn, dataIn, wOut, hOut,          &
    typeOut, dataOut) BIND(C,NAME="gluScaleImage")
IMPORT
INTEGER(GLint) :: gluScaleImage
INTEGER(GLenum), VALUE :: format, typeIn, typeOut
INTEGER(GLsizei), VALUE :: wIn, hIn, wOut, hOut
TYPE(C_PTR), VALUE :: dataIn, dataOut
END FUNCTION gluScaleImage

END INTERFACE

!  Sphere(quad, radius, slices, stacks)
!  return  void
!  param   quad		QuadricObj in value
!  param   radius		Float64 in value
!  param   slices		Int32 in value
!  param   stacks		Int32 in value
PUBLIC :: gluSphere
INTERFACE
SUBROUTINE gluSphere(quad, radius, slices, stacks) BIND(C,NAME="gluSphere")
IMPORT
INTEGER(GLint), VALUE :: slices, stacks
REAL(GLdouble), VALUE :: radius
TYPE(C_PTR), VALUE :: quad
END SUBROUTINE gluSphere

END INTERFACE

!  TessBeginContour(tess)
!  return  void
!  param   tess		TesselatorObj in value
PUBLIC :: gluTessBeginContour
INTERFACE
SUBROUTINE gluTessBeginContour(tess) BIND(C,NAME="gluTessBeginContour")
IMPORT
TYPE(C_PTR), VALUE :: tess
END SUBROUTINE gluTessBeginContour

END INTERFACE

!  TessBeginPolygon(tess, data)
!  return  void
!  param   tess		TesselatorObj in value
!  param   data		VoidPointer in value
PUBLIC :: gluTessBeginPolygon
INTERFACE
SUBROUTINE gluTessBeginPolygon(tess, data)                                    &
    BIND(C,NAME="gluTessBeginPolygon")
IMPORT
TYPE(C_PTR), VALUE :: tess, data
END SUBROUTINE gluTessBeginPolygon

END INTERFACE

!  TessCallback(tess, which, CallBackFunc)
!  return  void
!  param   tess		TesselatorObj in value
!  param   which		TessCallback in value
!  param   CallBackFunc	FunctionPointer in value
PUBLIC :: gluTessCallback
INTERFACE
SUBROUTINE gluTessCallback(tess, which, CallBackFunc)                         &
    BIND(C,NAME="gluTessCallback")
IMPORT
INTEGER(GLenum), VALUE :: which
TYPE(C_FUNPTR), VALUE :: CallBackFunc
TYPE(C_PTR), VALUE :: tess
END SUBROUTINE gluTessCallback

END INTERFACE

!  TessEndContour(tess)
!  return  void
!  param   tess		TesselatorObj in value
PUBLIC :: gluTessEndContour
INTERFACE
SUBROUTINE gluTessEndContour(tess) BIND(C,NAME="gluTessEndContour")
IMPORT
TYPE(C_PTR), VALUE :: tess
END SUBROUTINE gluTessEndContour

END INTERFACE

!  TessEndPolygon(tess)
!  return  void
!  param   tess		TesselatorObj in value
PUBLIC :: gluTessEndPolygon
INTERFACE
SUBROUTINE gluTessEndPolygon(tess) BIND(C,NAME="gluTessEndPolygon")
IMPORT
TYPE(C_PTR), VALUE :: tess
END SUBROUTINE gluTessEndPolygon

END INTERFACE

!  TessNormal(tess, valueX, valueY, valueZ)
!  return  void
!  param   tess		TesselatorObj in value
!  param   valueX		Float64 in value
!  param   valueY		Float64 in value
!  param   valueZ		Float64 in value
PUBLIC :: gluTessNormal
INTERFACE
SUBROUTINE gluTessNormal(tess, valueX, valueY, valueZ)                        &
    BIND(C,NAME="gluTessNormal")
IMPORT
REAL(GLdouble), VALUE :: valueX, valueY, valueZ
TYPE(C_PTR), VALUE :: tess
END SUBROUTINE gluTessNormal

END INTERFACE

!  TessProperty(tess, which, data)
!  return  void
!  param   tess		TesselatorObj in value
!  param   which		TessProperty in value
!  param   data		Float64 in value
PUBLIC :: gluTessProperty
INTERFACE
SUBROUTINE gluTessProperty(tess, which, data)                                 &
    BIND(C,NAME="gluTessProperty")
IMPORT
INTEGER(GLenum), VALUE :: which
REAL(GLdouble), VALUE :: data
TYPE(C_PTR), VALUE :: tess
END SUBROUTINE gluTessProperty

END INTERFACE

!  TessVertex(tess, location, data)
!  return  void
!  param   tess		TesselatorObj in value
!  param   location	Float64 out array [3]
!  param   data		VoidPointer in value
PUBLIC :: gluTessVertex
INTERFACE
SUBROUTINE gluTessVertex(tess, location, data) BIND(C,NAME="gluTessVertex")
IMPORT
TYPE(C_PTR), VALUE :: tess, data
REAL(GLdouble), DIMENSION(3), INTENT(OUT) :: location
END SUBROUTINE gluTessVertex

END INTERFACE

!  UnProject(winX, winY, winZ, model, proj, view, objX, objY, objZ)
!  return  Int32
!  param   winX		Float64 in value
!  param   winY		Float64 in value
!  param   winZ		Float64 in value
!  param   model		Float64 in array [16]
!  param   proj		Float64 in array [16]
!  param   view		Int32 in array [4]
!  param   objX		Float64Pointer in value
!  param   objY		Float64Pointer in value
!  param   objZ		Float64Pointer in value
PUBLIC :: gluUnProject
INTERFACE
FUNCTION gluUnProject(winX, winY, winZ, model, proj, view, objX, objY, objZ)  &
    BIND(C,NAME="gluUnProject")
IMPORT
INTEGER(GLint) :: gluUnProject
REAL(GLdouble), VALUE :: winX, winY, winZ
INTEGER(GLint), DIMENSION(4), INTENT(IN) :: view
REAL(GLdouble), DIMENSION(*), INTENT(IN) :: objX, objY, objZ
REAL(GLdouble), DIMENSION(16), INTENT(IN) :: model, proj
END FUNCTION gluUnProject

END INTERFACE

!  UnProject4(winX, winY, winZ, clipW, model, proj, view, near, far, objX, objY, objZ, objW)
!  return  Int32
!  param   winX		Float64 in value
!  param   winY		Float64 in value
!  param   winZ		Float64 in value
!  param   clipW		Float64 in value
!  param   model		Float64 in array [16]
!  param   proj		Float64 in array [16]
!  param   view		Int32 in array [4]
!  param   near		Float64 in value
!  param   far		Float64 in value
!  param   objX		Float64Pointer in value
!  param   objY		Float64Pointer in value
!  param   objZ		Float64Pointer in value
PUBLIC :: gluUnProject4
INTERFACE
FUNCTION gluUnProject4(winX, winY, winZ, clipW, model, proj, view, near,      &
    far, objX, objY, objZ, objW) BIND(C,NAME="gluUnProject4")
IMPORT
INTEGER(GLint) :: gluUnProject4
REAL(GLdouble), VALUE :: winX, winY, winZ, clipW, near, far
INTEGER(GLint), DIMENSION(4), INTENT(IN) :: view
REAL(GLdouble), DIMENSION(*), INTENT(IN) :: objX, objY, objZ, objW
REAL(GLdouble), DIMENSION(16), INTENT(IN) :: model, proj
END FUNCTION gluUnProject4

END INTERFACE


END MODULE  OpenGL_glu

!> \file ray.F90

!> \brief the ray module 
!!
!<

module ray_mod
use myf03_mod
use particle_system_mod
use oct_tree_mod
use mt19937_mod, only: genrand_real1
use spectra_mod, only: rn2freq
use physical_constants_mod, only: HI_th_erg, M_H, M_He
implicit none

private

public :: src_ray_type
public :: src_ray_make
public :: src_ray_transform

public :: src_ray_class_from_dir
public :: src_ray_dist2pt
public :: src_ray_part_intersection
public :: src_ray_cell_intersection
public :: src_ray_pluecker


real(r8b), parameter :: zero = 0.0d0
real(r8b), parameter :: one = 1.0d0

  

!> basic ray type
!-----------------------------------------------------------------------
type src_ray_type
   real(r8b) :: start(3)  !< starting position
   real(r8b) :: dir(3)    !< unit vector direction
   real(r8b) :: length    !< length (determines when to stop tracing)
   integer(i4b) :: class  !< based on direction signs (MMM, PMM, ...)
   
   real(r8b) :: freq      !< freq in HI ionizing units
   real(r8b) :: enrg      !< enrg of a single photon in ergs
   real(r8b) :: pcnt      !< photon count (changes as the ray is depleted)
   real(r8b) :: pini      !< initial photons
   real(r8b) :: dt_s      !< time step associated with ray [s]
end type src_ray_type






contains




!> creates a source ray 
!-----------------------------------------------------------------------  
  subroutine src_ray_make(ray, src, rayn, dtray_s, Lunit, box, length)

    type(src_ray_type), intent(out) :: ray    !< ray to make
    type(source_type), intent(inout) :: src   !< source
    integer(i8b), intent(in) :: rayn          !< ray indx
    real(r8b), intent(in) :: dtray_s          !< time between rays [s]   
    real(r8b), intent(in) :: Lunit            !< converts src%lum -> photons/s
    type(box_type), intent(in) :: box         !< simulation box

    real(r8b), intent(in), optional :: length !< optional length (default=huge)

    real(r8b) :: xx,yy,zz,r
    real(r8b) :: rn1, rn2
    real(r8b) :: prate
    integer :: i

  
!  set the direction of the ray from the emmission profile (src%EmisPrf)
!     0  = isotropic
!    -1  = low z wall, towards +z
!    -2  = high z wall, towards -z
!
!  note that for all point sources the luminosity is interpreted as a Flux 
!  [photons/s].  

    select case (src%EmisPrf)
       
    ! this makes rays go in -z direction from the high z wall  
    !-----------------------------------------------------------------------  
    case(-2)

       ray%start(1) = box%bots(1) + &
            genrand_real1() * (box%tops(1) - box%bots(1))

       ray%start(2) = box%bots(2) + &
            genrand_real1() * (box%tops(2) - box%bots(2))

       ray%start(3) = box%tops(3) 

       ray%dir(1) = 0.0
       ray%dir(2) = 0.0
       ray%dir(3) = -1.0       
       
    ! this makes rays go in +z direction from the low z wall 
    !-----------------------------------------------------------------------  
    case(-1)

       ray%start(1) = box%bots(1) + &
            genrand_real1() * (box%tops(1) - box%bots(1))

       ray%start(2) = box%bots(2) + &
            genrand_real1() * (box%tops(2) - box%bots(2))

       ray%start(3) = box%bots(3) 

       ray%dir(1) = 0.0
       ray%dir(2) = 0.0
       ray%dir(3) = 1.0
                 
    ! random direction on the unit sphere
    !-----------------------------------------------------------------------  
    case(0)

       ray%start = src%pos

       r=2.0d0 
       do while ( r > 1.0d0 .and. r /= 0.0d0 )
          xx=(2.0d0 * genrand_real1()-1.0d0)   
          yy=(2.0d0 * genrand_real1()-1.0d0)   
          zz=(2.0d0 * genrand_real1()-1.0d0)   
          r=xx*xx+yy*yy+zz*zz
       enddo
       r = sqrt(r)
       ray%dir(1) = xx/r  ! it is important that ray%dir be a unit vector
       ray%dir(2) = yy/r
       ray%dir(3) = zz/r          
       
    case default

       write(*,*) "emission profile not recognized"
       write(*,*) "profile = ", src%EmisPrf
       stop          
       
    end select
    !-----------------------------------------------------------------------  

    if ( present(length) ) then
       ray%length = length
    else
       ray%length = huge(1.0d0) * 0.1d0
    endif

  
!   set the class of the ray (what octant is it going into)
    call src_ray_class_from_dir(ray)


!   set the frequency and energy / photon of the ray
    ray%freq = rn2freq(src%SpcType)
    ray%enrg = ray%freq * HI_th_erg  


!   set the number of photons in the ray
    if (ray%enrg > 0.) then
       prate = src%L * Lunit ! photons per sec
    else 
       prate = 0.
    end if
    if (rayn > src%lastemit) then
       ray%dt_s = dtray_s * (rayn - src%lastemit) 
       ray%pini = prate * ray%dt_s
    else
       write(*,*) "make_source_ray> rayn .LT. src%lastemit in ray.f90"
       stop
    end if
    ray%pcnt = ray%pini
    src%lastemit = rayn

  end subroutine src_ray_make


!> returns a transformed ray while preserving the initial ray
!--------------------------------------------------------------
  subroutine src_ray_transform(inray, outray, trans)
    type(src_ray_type) :: inray       !< input ray
    type(src_ray_type) :: outray       !< output ray
    type(transformation_type) :: trans !< transformation
    
    outray%start  = inray%start * trans%fac + trans%shift
    outray%dir    = inray%dir   
    outray%length = inray%length  
    outray%class  = inray%class

    outray%freq = inray%freq
    outray%enrg = inray%enrg
    outray%pcnt = inray%pcnt
    outray%pini = inray%pini
    outray%dt_s = inray%dt_s

  end subroutine src_ray_transform



! pre computes the class of the ray for the Pluecker test
! ray label    class
!   MMM          0
!   PMM          1
!   MPM          2
!   PPM          3
!   MMP          4
!   PMP          5
!   MPP          6
!   PPP          7
!-----------------------------------------------------------
subroutine src_ray_class_from_dir( src_ray ) 
  type(src_ray_type), intent(inout) :: src_ray
  integer(i4b) :: i

  src_ray%class = 0
  do i = 1, 3
     if ( src_ray%dir(i) >= zero ) src_ray%class = src_ray%class + 2**(i-1)
  end do
  
end subroutine src_ray_class_from_dir






!> returns the perpendicular distance between a point and a ray
!--------------------------------------------------------------  
function src_ray_dist2pt(src_ray, pt, proj) result(perp)
  type(src_ray_type), intent(in) :: src_ray
  real(r4b), intent(in) :: pt(3)     !< point
  real(r8b), optional :: proj        !< distance along ray 
  real(r8b) :: perp                  !< distance perp. to ray
  
  real(r8b) :: dotp
  real(r8b) :: diff(3)
  real(r8b) :: perp2
  real(r8b) :: vec1(3)
  real(r8b) :: vec2(3)
  
  vec1 = pt - src_ray%start
  vec2 = src_ray%dir
  
  dotp  = dot_product( vec1, vec2 )
  diff  = vec1 - dotp * src_ray%dir 
  perp2 = dot_product( diff, diff )
  perp = sqrt(perp2)
  
  if( present(proj) ) proj = dotp
  
end function src_ray_dist2pt



!> tests for ray / particle intersection.  
!----------------------------------------------  
function src_ray_part_intersection(src_ray, part) result(hit)
  type(src_ray_type), intent(in) :: src_ray
  type(particle_type), intent(in) :: part       !< particle
  logical :: hit                    !< true or false result
  
  real(r8b) :: start2cen       !< distance^2 from ray start to part position
  real(r8b) :: end2cen         !< distance^2 from ray end to part position
  real(r8b) :: perp            !< perpendicular distance to particle 
  real(r8b) :: proj            !< projected distance along ray
  real(r8b) :: diff(3)         !< vector from ray start to part center
  
  ! if the perpendicular distance to the point is larger than hsml exit
  !---------------------------------------------------------------------
  perp = src_ray_dist2pt( src_ray, part%pos, proj ) 
  if (perp >= part%hsml) then
     hit = .false.
     return
  endif
  
  ! now our only concern is the position of the particle
  ! along the ray.  


  ! first we reject particles that cannot possibly be intersections
  !
  if ( proj < -part%hsml ) then
     hit = .false. 
     return
  endif

  if ( proj > src_ray%length + part%hsml ) then
     hit = .false. 
     return
  endif


  ! if the particle smoothing volume could contain the origin of 
  ! the ray, test for that.
  !---------------------------------------------------------------------
  if ( abs(proj) < part%hsml ) then
     diff = part%pos - src_ray%start
     start2cen = sum( diff*diff ) 
     if (start2cen < part%hsml*part%hsml) then
        hit = .true.
        return
     endif
  endif

  ! if the particle smoothing volume could contain the terminus of 
  ! the ray, test for that.
  !---------------------------------------------------------------------
  if ( abs(proj - src_ray%length) < part%hsml ) then
     diff = part%pos - (src_ray%start + src_ray%length * src_ray%dir)
     end2cen = sum( diff*diff )
     if (end2cen < part%hsml*part%hsml) then
        hit = .true.
        return
     endif
  endif

  ! at this point we must have a hit
  hit = .true.
  return

  
end function src_ray_part_intersection


!> tests for ray - AABB intersection. 
!----------------------------------------------  
function src_ray_cell_intersection(src_ray,cell) result(hit)
  type(src_ray_type), intent(in) :: src_ray  !< ray
  type(cell_type), intent(in) :: cell        !< cell
  logical :: hit                 !< true or false result
  real(r8b) :: bot(3)
  real(r8b) :: top(3)
  bot = cell%botrange - src_ray%start
  top = cell%toprange - src_ray%start
  hit = src_ray_pluecker(src_ray, bot, top)
end function src_ray_cell_intersection



!> pluecker test for line segment / cell intersection
!-----------------------------------------------------    
function src_ray_pluecker(src_ray, s2b, s2t) result( hit )

  type(src_ray_type), intent(in) :: src_ray

  real(r8b) :: s2b(3)         !< vector from ray start to lower cell corner
  real(r8b) :: s2t(3)         !< vector from ray start to upper cell corner
  logical :: hit              !< true or false result
  
  real(r8b) :: dir(3)
  real(r8b) :: dist

  real(r8b) :: e2b(3)       !< vector from ray end to lower cell corner
  real(r8b) :: e2t(3)       !< vector from ray end to upper cell corner

  dir  = src_ray%dir  
  dist = src_ray%length

  e2b = s2b - dir * dist
  e2t = s2t - dir * dist

  hit = .false.

  ! branch on ray direction
  !---------------------------
  select case( src_ray%class )

     ! MMM
     !-----------
  case(0)

     if(s2b(1) > zero .or. s2b(2) > zero .or. s2b(3) > zero) return ! on negative part of ray 
     if(e2t(1) < zero .or. e2t(2) < zero .or. e2t(3) < zero) return ! past length of ray      

     if ( dir(1)*s2b(2) - dir(2)*s2t(1) < zero .or.  &
          dir(1)*s2t(2) - dir(2)*s2b(1) > zero .or.  &
          dir(1)*s2t(3) - dir(3)*s2b(1) > zero .or.  &
          dir(1)*s2b(3) - dir(3)*s2t(1) < zero .or.  &
          dir(2)*s2b(3) - dir(3)*s2t(2) < zero .or.  &
          dir(2)*s2t(3) - dir(3)*s2b(2) > zero       ) return
     
     ! PMM
     !-----------
  case(1)
     
     if(s2t(1) < zero .or. s2b(2) > zero .or. s2b(3) > zero) return ! on negative part of ray 
     if(e2b(1) > zero .or. e2t(2) < zero .or. e2t(3) < zero) return ! past length of ray      
     
     if ( dir(1)*s2t(2) - dir(2)*s2t(1) < zero .or.  &
          dir(1)*s2b(2) - dir(2)*s2b(1) > zero .or.  &
          dir(1)*s2b(3) - dir(3)*s2b(1) > zero .or.  &
          dir(1)*s2t(3) - dir(3)*s2t(1) < zero .or.  &
          dir(2)*s2b(3) - dir(3)*s2t(2) < zero .or.  &
          dir(2)*s2t(3) - dir(3)*s2b(2) > zero       ) return
     
     ! MPM
     !-----------
  case(2)
     
     if(s2b(1) > zero .or. s2t(2) < zero .or. s2b(3) > zero) return ! on negative part of ray 
     if(e2t(1) < zero .or. e2b(2) > zero .or. e2t(3) < zero) return ! past length of ray      
     
     if ( dir(1)*s2b(2) - dir(2)*s2b(1) < zero .or.  &
          dir(1)*s2t(2) - dir(2)*s2t(1) > zero .or.  &
          dir(1)*s2t(3) - dir(3)*s2b(1) > zero .or.  &
          dir(1)*s2b(3) - dir(3)*s2t(1) < zero .or.  &
          dir(2)*s2t(3) - dir(3)*s2t(2) < zero .or.  &
          dir(2)*s2b(3) - dir(3)*s2b(2) > zero       ) return
     
     ! PPM
     !-----------
  case(3)
     
     if(s2t(1) < zero .or. s2t(2) < zero .or. s2b(3) > zero) return ! on negative part of ray 
     if(e2b(1) > zero .or. e2b(2) > zero .or. e2t(3) < zero) return ! past length of ray      
     
     if ( dir(1)*s2t(2) - dir(2)*s2b(1) < zero .or.  &
          dir(1)*s2b(2) - dir(2)*s2t(1) > zero .or.  &
          dir(1)*s2b(3) - dir(3)*s2b(1) > zero .or.  &
          dir(1)*s2t(3) - dir(3)*s2t(1) < zero .or.  &
          dir(2)*s2t(3) - dir(3)*s2t(2) < zero .or.  &
          dir(2)*s2b(3) - dir(3)*s2b(2) > zero       ) return
     
     ! MMP
     !-----------
  case(4)
     
     if(s2b(1) > zero .or. s2b(2) > zero .or. s2t(3) < zero) return ! on negative part of ray 
     if(e2t(1) < zero .or. e2t(2) < zero .or. e2b(3) > zero) return ! past length of ray      
     
     if ( dir(1)*s2b(2) - dir(2)*s2t(1) < zero .or.  &
          dir(1)*s2t(2) - dir(2)*s2b(1) > zero .or.  &
          dir(1)*s2t(3) - dir(3)*s2t(1) > zero .or.  &
          dir(1)*s2b(3) - dir(3)*s2b(1) < zero .or.  &
          dir(2)*s2b(3) - dir(3)*s2b(2) < zero .or.  &
          dir(2)*s2t(3) - dir(3)*s2t(2) > zero       ) return
     
     
     ! PMP
     !-----------
  case(5)
     
     if(s2t(1) < zero .or. s2b(2) > zero .or. s2t(3) < zero) return ! on negative part of ray 
     if(e2b(1) > zero .or. e2t(2) < zero .or. e2b(3) > zero) return ! past length of ray      
     
     if ( dir(1)*s2t(2) - dir(2)*s2t(1) < zero .or.  &
          dir(1)*s2b(2) - dir(2)*s2b(1) > zero .or.  &
          dir(1)*s2b(3) - dir(3)*s2t(1) > zero .or.  &
          dir(1)*s2t(3) - dir(3)*s2b(1) < zero .or.  &
          dir(2)*s2b(3) - dir(3)*s2b(2) < zero .or.  &
          dir(2)*s2t(3) - dir(3)*s2t(2) > zero       ) return
     
     
     ! MPP
     !-----------
  case(6)
     
     if(s2b(1) > zero .or. s2t(2) < zero .or. s2t(3) < zero) return ! on negative part of ray 
     if(e2t(1) < zero .or. e2b(2) > zero .or. e2b(3) > zero) return ! past length of ray      
     
     if ( dir(1)*s2b(2) - dir(2)*s2b(1) < zero .or.  &
          dir(1)*s2t(2) - dir(2)*s2t(1) > zero .or.  &
          dir(1)*s2t(3) - dir(3)*s2t(1) > zero .or.  &
          dir(1)*s2b(3) - dir(3)*s2b(1) < zero .or.  &
          dir(2)*s2t(3) - dir(3)*s2b(2) < zero .or.  &
          dir(2)*s2b(3) - dir(3)*s2t(2) > zero       ) return
     
     ! PPP
     !-----------
  case(7)
     
     if(s2t(1) < zero .or. s2t(2) < zero .or. s2t(3) < zero) return ! on negative part of ray 
     if(e2b(1) > zero .or. e2b(2) > zero .or. e2b(3) > zero) return ! past length of ray      
     
     if ( dir(1)*s2t(2) - dir(2)*s2b(1) < zero .or.  &
          dir(1)*s2b(2) - dir(2)*s2t(1) > zero .or.  &
          dir(1)*s2b(3) - dir(3)*s2t(1) > zero .or.  &
          dir(1)*s2t(3) - dir(3)*s2b(1) < zero .or.  &
          dir(2)*s2t(3) - dir(3)*s2b(2) < zero .or.  &
          dir(2)*s2b(3) - dir(3)*s2t(2) > zero       ) return
     
  case default
     call rayError('ray class.')
     
  end select
  
  hit=.true.
  
end function src_ray_pluecker



!> error handling
!-----------------------------      
  subroutine rayError(string,i)
    character(*) :: string  !< error string
    integer, optional :: i  !< error number
    
    print*,' Error detected:'
    
    if(present(i)) then
       print*,string,i
    else
       print*,string
    endif
    
    stop
  end subroutine rayError

  
end module ray_mod

!> \file iliev_comparison_project.F90

!> \brief Module that does special output for the 
!! Iliev Comparison Project (ICP) tests
!<
module iliev_comparison_project_mod
use myf03_mod
use ray_mod
use raylist_mod
use particle_system_mod
use oct_tree_mod, only: oct_tree_type
use global_mod, only: global_variables_type
use physical_constants_mod
implicit none

private

public :: initialize_iliev_tests
public :: iliev_test1_screen_out
public :: iliev_test2_screen_out
public :: iliev_test3_screen_out
public :: iliev_test4_screen_out

! some variables from astro-ph/0603199 the Cosmological RT Comparison 
! Static Density Field Tests
!---------------------------------------------------------------------

    real(r8b), parameter :: rtcpRecRate = 2.59d-13                    !< ICP RR rate (B) [cm^3/s]
    real(r8b), parameter :: rtcpColRate = 3.16d-16                    !< ICP CI rate [cm^3/s]
    real(r8b), parameter :: rtcpT1xHII = 1.2d-3                       !< xHII(t=0) for T1
    real(r8b), parameter :: rtcpT2xHII = 0.0                          !< xHII(t=0) for T2
    real(r8b), parameter :: rtcpT1Dens = 1.0d-3                       !< nH for T1 [cm^-3]
    real(r8b), parameter :: rtcpT2Dens = 1.0d-3                       !< nH for T2 [cm^-3]
    real(r8b), parameter :: rtcpT3OutDens = 2.0d-4                    !< nH_out for T3 [cm^-3]
    real(r8b), parameter :: rtcpT3InDens  = 200 * rtcpT3OutDens       !< nH_in for T3 [cm^-3] 
    real(r8b), parameter :: rtcpT1Flux = 5.0d48                       !< T1 photons / s
    real(r8b), parameter :: rtcpT2Flux = 5.0d48                       !< T2 photons / s
    real(r8b), parameter :: rtcpT3Flux = 1.0d6                        !< T3 photons / s / cm^2
    real(r8b), parameter :: rtcpT1Temp = 1.0d4                        !< T(t=0) for T1[K]
    real(r8b), parameter :: rtcpT2Temp = 1.0d2                        !< T(t=0) for test 2 [K]
    real(r8b), parameter :: rtcpT3OutTemp = 8.0d3                     !< T_out(t=0) test 3 [K]
    real(r8b), parameter :: rtcpT3InTemp = 4.0d1                      !< T_in(t=0) test 3 [K]

    real(r8b), parameter :: rtcpRecTime_s = 1.0 / (rtcpRecRate * rtcpT1Dens)  !< T1 rec time [s]
    real(r8b), parameter :: rtcpColTime_s = 1.0 / (rtcpColRate * rtcpT1Dens)  !< T1 col ion time [s]
    real(r8b), parameter :: rtcpRecTime_yrs = rtcpRecTime_s / year2sec        !< T1 rec time [yrs]
    real(r8b), parameter :: rtcpColTime_yrs = rtcpColTime_s / year2sec        !< T1 col ion time [yrs]
    real(r8b), parameter :: rtcpEqxHII = rtcpColRate / (rtcpRecRate + rtcpColRate) !< T1 col ion eq.

    
    real(r8b), save :: rtcpStromRad3      !< T1 Strom. Radius Cubed [cm^3]
    real(r8b), save :: rtcpStromRad_cm    !< T1 Strom. Radius [cm]
    real(r8b), save :: rtcpStromRad_kpc   !< T1 Strom. Radius [kpc]


contains

!------------------------------------------------
!> initialize iliev comparison project variables
  subroutine initialize_iliev_tests()
   
    rtcpStromRad3    = (3 * rtcpT1Flux) / (4 * pi * rtcpRecRate * rtcpT1Dens**2)  
    rtcpStromRad_cm  = exp( 1./3. * log(rtcpStromRad3) ) 
    rtcpStromRad_kpc = rtcpStromRad_cm / kpc2cm                

  end subroutine initialize_iliev_tests



!> iliev T1screen output
!-------------------------------
  subroutine iliev_test1_screen_out(psys,searchtree,GV)

    type(particle_system_type), intent(in) :: psys  !< input particle system  
    type(oct_tree_type), intent(in) :: searchtree !< oct-tree to search
    type(global_variables_type), intent(in) :: GV  !< global variables

    type(src_ray_type) :: ray
    type(raylist_type) :: raylist

    real(r8b) :: VWionfrac, time_ratio
    real(r8b) :: ionRa, ionRn, ionVn
    real(r8b) :: pos(3), dir(3)
    real(r8b) :: d,d1,d2,d3,d4
    integer :: i,pindx
    
!   compute analytic Stromgren radius
    time_ratio = GV%time_elapsed_s / rtcpRecTime_s
    ionRa = rtcpStromRad_kpc * (1.0d0 - exp(-time_ratio) )**(1.0/3.0)
 
!   compute numerical Stromgren radius (Volume method)
    VWionfrac = particle_system_mean_xHII_volume_weight(psys)
    ionVn = (VWionfrac - rtcpT1xHII) * psys%box%vol
    ionRn = (3.0 * ionVn / (4 * pi) )**(1.0/3.0)

!   compute numerical Stromgren radius (Ray probe method)
    call prepare_raysearch(psys,raylist)
    pos = psys%box%bots + psys%box%lens / 2.0d0
    dir = (/1.0,0.0,0.0/)
    ray%start = pos
    ray%dir = dir
    ray%length = 10.0d0
    call src_ray_class_from_dir( ray )
    call trace_ray(ray,raylist,psys,searchtree) 
    do i = 1,raylist%nnb
       pindx = raylist%intersection(i)%pindx
       d = raylist%intersection(i)%d
       if (psys%par(pindx)%xHII < 0.5) exit
    end do
    d1 = raylist%intersection(i-1)%d + &
        (raylist%intersection(i)%d - raylist%intersection(i-1)%d)/2 
         
    d = d1

    call  kill_raylist(raylist)

    write(*,*) "=============================================================="
    write(*,*) " Iliev Test 1 Specific Monitoring "
    write(*,*) "=============================================================="
    write(*,*) "Stromgren Radii (kpc)"
    write(*,*) "Analytic                    = ", ionRa
    write(*,*) "Numerical (Volume Method)   = ", ionRn
    write(*,*) "Numerical (X-axis)          = ", d
    write(*,*) "numerical/analytic (Volume) = ", ionRn / ionRa
    write(*,*) "numerical/analytic (X-axis) = ", d / ionRa
    write(*,*) "=============================================================="
   
  end subroutine iliev_test1_screen_out



!> iliev test 2 screen output
!-------------------------------
  subroutine iliev_test2_screen_out(psys,searchtree,GV)  
    type(particle_system_type), intent(in) :: psys !< input particle system  
    type(oct_tree_type), intent(in) :: searchtree !< oct-tree to search
    type(global_variables_type), intent(in) :: GV  !< global variables

    type(src_ray_type) :: ray
    type(raylist_type) :: raylist

    real(r8b) :: VWionfrac, time_ratio
    real(r8b) :: ionRa, ionRn, ionVn
    real(r8b) :: pos(3), dir(3)
    real(r8b) :: d,d1,d2,d3,d4
    integer :: i,pindx

!   compute analytic Stromgren radius
    time_ratio = GV%time_elapsed_s / rtcpRecTime_s
    ionRa = rtcpStromRad_kpc * (1.0d0 - exp(-time_ratio) )**(1.0/3.0)
 
!   compute numerical Stromgren radius
    VWionfrac = particle_system_mean_xHII_volume_weight(psys)
    ionVn = (VWionfrac - rtcpT2xHII) * psys%box%vol
    ionRn = (3.0 * ionVn / (4 * pi) )**(1.0/3.0)

!   compute numerical Stromgren radius (Ray probe method)
    call prepare_raysearch(psys,raylist)
    pos = psys%box%bots + psys%box%lens / 2.0d0
    dir = (/1.0,0.0,0.0/)
    ray%start = pos
    ray%dir = dir
    ray%length = 10.0d0
    call src_ray_class_from_dir( ray )
    call trace_ray(ray,raylist,psys,searchtree) 
    do i = 1,raylist%nnb
       pindx = raylist%intersection(i)%pindx
       d = raylist%intersection(i)%d
       if (psys%par(pindx)%xHII < 0.5) exit
    end do
    d1 = raylist%intersection(i-1)%d + &
        (raylist%intersection(i)%d - raylist%intersection(i-1)%d)/2 
         
    d = d1

    call  kill_raylist(raylist)

    write(*,*) "=============================================================="
    write(*,*) " Iliev Test 2 Specific Monitoring "
    write(*,*) "=============================================================="
    write(*,*) "Stromgren Radii (kpc)"
    write(*,*) "Analytic                    = ", ionRa
    write(*,*) "Numerical (Volume Method)   = ", ionRn
    write(*,*) "Numerical (X-axis)          = ", d
    write(*,*) "numerical/analytic (Volume) = ", ionRn / ionRa
    write(*,*) "numerical/analytic (X-axis) = ", d / ionRa
    write(*,*) "=============================================================="


  end subroutine iliev_test2_screen_out



!> iliev test 3 screen output
!-------------------------------
  subroutine iliev_test3_screen_out(psys,GV)
 
    type(particle_system_type), intent(in) :: psys !< input particle system  
    type(global_variables_type), intent(in) :: GV  !< global variables

    real(r8b), parameter :: cpos(3) = (/5.0,3.3,3.3/)
    integer :: i, incount, outcount
    real(r8b) :: d, cionsum, oionsum, Tinsum, Toutsum

    ! real(r8b) :: pos(3)

    
    ! ionization fraction of the clump
    cionsum = 0.0
    Tinsum = 0.0
    incount = 0
    oionsum = 0.0
    Toutsum = 0.0
    outcount = 0
    do i = 1,size(psys%par)
       d = sqrt( sum( (cpos - psys%par(i)%pos)**2 ) )
       if (d < 0.8) then
          incount = incount + 1
          cionsum = cionsum + psys%par(i)%xHII
#ifdef incT
            Tinsum = Tinsum + psys%par(i)%T
#endif
       else 
          outcount = outcount + 1
          oionsum = oionsum + psys%par(i)%xHII
#ifdef incT
            Toutsum = Toutsum + psys%par(i)%T
#endif
       end if
    end do
    oionsum = oionsum / outcount 
    Toutsum = Toutsum / outcount
    cionsum = cionsum / incount 
    Tinsum = Tinsum / incount

    100 format(A,T40,2ES12.5)
    write(*,*) "=============================================================="
    write(*,*) GV%TestScenario, " Specific Monitoring "
    write(*,*) "=============================================================="
    write(*,100) "Ionization fraction in/outside clump: ", cionsum, oionsum
    write(*,100) "Temperature in/outisde clump:         ", Tinsum, Toutsum
    write(*,*) "=============================================================="

  end subroutine iliev_test3_screen_out



!> iliev test 4 screen output
!-------------------------------
  subroutine iliev_test4_screen_out(psys,GV)  
    type(particle_system_type), intent(in) :: psys !< input particle system  
    type(global_variables_type), intent(in) :: GV  !< global variables

    real(r8b) :: NWionfrac

    NWionfrac = particle_system_mean_xHII_number_weight(psys)

    write(*,*) "=============================================================="
    write(*,*) GV%TestScenario, " Specific Monitoring "
    write(*,*) "=============================================================="

  end subroutine iliev_test4_screen_out






end module iliev_comparison_project_mod

!> \file main_input.F90

!> \brief The module that calls the specific input routines
!<

module main_input_mod
use myf03_mod
use gadget_general_class
use gadget_public_input_mod
use gadget_cosmoBH_input_mod
use gadget_owls_input_mod
use gadget_vbromm_input_mod
use gadget_public_input_hdf5_mod

use update_particles_mod
use source_input_mod
use particle_system_mod

use atomic_rates_mod, only: get_atomic_rates
use global_mod, only: PLAN, GV, rtable, cmbT_k
use global_mod, only: psys, saved_gheads
use global_mod, only: set_dt_from_dtcode
implicit none

contains


!> Read in planning data from the header of all snapshots 
!========================================================
subroutine get_planning_data()  
  character(clen), parameter :: myname="get_planning_data"
  logical, parameter :: crash=.true.
  integer, parameter :: verb=1

  call mywrite("getting planning data:", verb)
  call mywrite("",verb) 


  GV%Nsnaps = GV%EndSnapNum - GV%StartSnapNum + 1
  if (allocated(PLAN%snap)) deallocate(PLAN%snap)
  allocate( PLAN%snap(GV%StartSnapNum : GV%EndSnapNum) )

  ! branch on input type 
  !-------------------------------------------------------------------
  select case (GV%InputType)
  case(1)
     call get_planning_data_gadget_public()
  case(2)
     call get_planning_data_gadget_cosmoBH()
  case(3)
     call get_planning_data_gadget_owls()
  case(4)
     call get_planning_data_gadget_vbromm()
  case(5)
     call get_planning_data_gadget_public_hdf5()
  end select

  call get_planning_data_sources()

end subroutine get_planning_data


!> read in particle, box, and source data 
!============================================
subroutine readin_snapshot()
  character(clen), parameter :: myname="readin_snapshot"
  logical, parameter :: crash=.true.
  integer, parameter :: verb=2
  character(clen) :: str,fmt

  
  logical :: first
  real(r8b) :: MB
  integer(i8b) :: i
  real(r8b) :: a     !< scale factor
  real(r8b) :: h     !< Hubble paraemter (little H)
  real(r8b) :: Flux  !< photons / s from planar sources
  character(clen) :: snpbase
  character(clen) :: srcbase
  type(gadget_constants_type) :: gconst
  
  call mywrite("reading in particle and source snapshots:", verb-1)
  call mywrite("",verb-1) 

  ! set local variables
  !======================
  a = PLAN%snap(GV%CurSnapNum)%ScalefacAt 
  h = GV%LittleH

  ! report readin type
  !======================
  call mywrite('   input type = ', verb, adv=.false.)
  if (GV%InputType==1) then
     call mywrite(" Gadget-2 Public (SnapFormat=1)", verb)
  else if (GV%InputType==2) then
     call mywrite(" Gadget CosmoBH w/ ye and xHI (SnapFormat=1)", verb)
  else if (GV%InputType==3) then
     call mywrite(" Gadget OWLS/GIMIC HDF5", verb)
  else if (GV%InputType==4) then
     call mywrite(" Gadget Volker Bromm", verb)
  else if (GV%InputType==5) then
     call mywrite(" Gadget-2 Public HDF5", verb)
  end if
 
  ! read in the particle data
  !=============================
  first = .false.
  if (GV%CurSnapNum == GV%StartSnapNum) then
     first = .true.
  else
     GV%CurSnapNum = GV%CurSnapNum + 1
  end if

  ! gadget public (no ionization fractions)
  !---------------------------------------------------------------
  if (GV%InputType == 1) then

     if (first) then
        call read_Gpublic_particles()
        psys%par(:)%lasthit = 0
     else
        call update_particles()
     end if

  ! gadget cosmoBH w/ cooling (i.e. ye and xHI)
  !---------------------------------------------------------------
  else if (GV%InputType == 2) then

     if (first) then
        call read_GcosmoBH_particles()
        psys%par(:)%lasthit = 0
     else
        call update_particles()
     end if
     
  ! gadget OWLS/GIMIC HDF5
  !---------------------------------------------------------------
  else if (GV%InputType == 3) then 
     
     if (first) then
        call read_Gowls_particles()
        psys%par(:)%lasthit = 0
     else
        call update_particles()
     end if
     
  ! gadget w/ ions from Volker Bromm's group 
  !---------------------------------------------------------------
  else if (GV%InputType == 4) then

     if (first) then
        call read_Gvbromm_particles()
        psys%par(:)%lasthit = 0
     else
        call update_particles()
     end if

  ! gadget public HDF5 (no ionization fractions)
  !---------------------------------------------------------------
  else if (GV%InputType == 5) then

     if (first) then
        call read_Gpubhdf5_particles()
        psys%par(:)%lasthit = 0
     else
        call update_particles()
     end if

  ! not recognized
  !---------------------------------------------------------------
  else
     write(str,*) "input type, ", GV%InputType, "not recognized" 
     call myerr(str,myname,crash)
  end if


  ! copy over box properties
  !==================================================
  psys%box%tops = GV%BoxUprs
  psys%box%bots = GV%BoxLwrs

  psys%box%lens    = GV%BoxUprs - GV%BoxLwrs
  psys%box%lens_cm = psys%box%lens * GV%cgs_len

  psys%box%vol    = product( psys%box%lens )
  psys%box%vol_cm = product( psys%box%lens_cm )

  psys%box%tbound = GV%BndryCond
  psys%box%bbound = GV%BndryCond


  ! read in the source data
  !============================================
  call read_src_snapshot()
  call order_sources_lum(psys%src)
  psys%src%lastemit = GV%rayn

  
  ! these quantities track the photoionization rate.  they are 
  ! rezeroed at inputs (because new source files are loaded) and 
  ! outputs (for time dependence)
  !===============================================================
#ifdef outGammaHI
  psys%par(:)%gammaHI = 0.0
  psys%par(:)%time = 0.0
#endif


  ! set par and src file bases for output to logfiles
  !====================================================
  fmt = "(A,'/',A,'_',I3.3)"
  write(snpbase,fmt) trim(GV%SnapPath),   trim(GV%ParFileBase),    GV%CurSnapNum
  write(srcbase,fmt) trim(GV%SourcePath), trim(GV%SourceFileBase), GV%CurSnapNum


  ! write fresh reads to the particle_data.log and source_data.log files
  !========================================================================  
  fmt = "(A,A)"
  write(str,fmt) "Fresh read from ", trim(snpbase)
  call particle_system_print_lun(psys, str, GV%pardatalun )
!  call psys%print_particle_info_lun(str,GV%pardatalun)
  write(GV%pardatalun,*)
  write(GV%pardatalun,*)
  flush(GV%pardatalun)



#ifdef useHDF5
  write(GV%srcdatalun,*) "================================================================="
  write(GV%srcdatalun,*) " HM01 G+C gammaHI for z = ", saved_gheads(GV%CurSnapNum,0)%z, ": ", &
       GV%UVB_gammaHI_cloudy
  write(GV%srcdatalun,*) "================================================================="
  write(GV%srcdatalun,*) 
#endif

  write(str,fmt) "Fresh read from ", trim(srcbase)
  call source_info_to_screen(psys,str,GV%srcdatalun)
  write(GV%srcdatalun,*)
  write(GV%srcdatalun,*)
  flush(GV%srcdatalun)
  



  ! scale the data if we need to
  !=====================================================================
  if(GV%Comoving) then
     call particle_system_scale_comoving_to_physical(psys, a, h)
!     call psys%scale_comoving_to_physical(a, h)
  endif

  ! write data after rescaling to the particle_data.log file
  !=====================================================================
  fmt = "(A,F5.3,A,F5.3,A,A)"
  write(str,fmt) "After rescaling (a=",a,",h=",h,") from ", trim(snpbase)
  call particle_system_print_lun(psys, str, GV%pardatalun ) 
!  call psys%print_particle_info_lun(str,GV%pardatalun)
  write(GV%pardatalun,*)
  write(GV%pardatalun,*)
  flush(GV%pardatalun)


  write(str,fmt) "After rescaling (a=",a,",h=",h,") from ", trim(srcbase)
  call source_info_to_screen(psys,str,GV%srcdatalun)
  write(GV%srcdatalun,*)
  write(GV%srcdatalun,*)
  flush(GV%srcdatalun)




  ! convert number density to flux for planar sources
  !==========================================================
  do i = 1,size(psys%src)
     
     if (psys%src(i)%EmisPrf == -3 .or. &
         psys%src(i)%EmisPrf == -2 .or. &
         psys%src(i)%EmisPrf == -1) then 

        ! if this is true the input luminosity is a number density 
        ! [photons/cm^3].  we want the flux that would produce this 
        ! number density in an optically thin volume
        
        write(*,*) 
        write(*,*) "  converting a photon number density to a flux"
        write(*,*) "  n_photon/cm^3                = ", psys%src(i)%L
        
        Flux = psys%src(i)%L * gconst%c * psys%box%lens_cm(1)**2
        Flux = Flux / GV%Lunit
        psys%src(i)%L = Flux
        
        write(*,*) "  photons/s from walls [1.e50] = ",  psys%src(i)%L
        write(*,*)            
        
     end if
     
  end do


  ! check test conditionals 
  !==========================================================
  if (GV%DoTestScenario) then

     if ( trim(GV%TestScenario) == "iliev_test1") then
        psys%par(:)%xHII = 1.2d-3
        psys%par(:)%xHI = 1.0d0 - psys%par(:)%xHII
        psys%par(:)%T = 1.0d4

     else if ( trim(GV%TestScenario) == "iliev_test2" ) then
        psys%par(:)%xHII = 0.0d0
        psys%par(:)%xHI = 1.0d0 - psys%par(:)%xHII
        psys%par(:)%T = 1.0d2

     else if ( trim(GV%TestScenario) == "iliev_test1He" ) then
        psys%par(:)%xHI = 1.0d0
        psys%par(:)%xHII = 0.0d0
#ifdef incHe
        psys%par(:)%xHeI = 1.0d0
        psys%par(:)%xHeII = 0.0d0
        psys%par(:)%xHeIII = 0.0d0
#endif
        psys%par(:)%T = 1.0d4

     end if
  end if



  ! set EOS particles to EOS temp if you want
  !=======================================================
#ifdef incEOS
  if (first) then
     do i = 1, size(psys%par(:))
        if (GV%EOStemp > 0.0) then
           if (psys%par(i)%eos > 0.0) then
              psys%par(i)%T = GV%EOStemp
           endif
        endif
     enddo
  endif
#endif


  ! set SFR particles to EOS temp if you want
  !=======================================================
#ifdef incSFR
  if (first) then
     do i = 1, size(psys%par(:))
        if (GV%EOStemp > 0.0) then
           if (psys%par(i)%sfr > 0.0) then
              psys%par(i)%T = GV%EOStemp
           endif
        endif
     enddo
  endif
#endif




  ! set neutral or ionized if we need to
  !=======================================================
if (first) then
   if (GV%InitxHI > 0.0) then
      psys%par(:)%xHI  = GV%InitxHI
      psys%par(:)%xHII = 1.0d0 - GV%InitxHI
      call particle_system_set_ye( psys, GV%H_mf, GV%He_mf, GV%NeBackground )
   endif
endif



  ! set constant temperature if we have one
  !=======================================================
  if (GV%IsoTemp > 0.0) psys%par(:)%T = GV%IsoTemp



  ! cap the ionization fractions and temperatures if we have to
  !================================================================
  call particle_system_enforce_x_and_T_minmax( &
       psys, GV%xfloor, GV%xceiling, GV%Tfloor, GV%Tceiling )


  ! write data after above conditionals to the particle and source log files
  !==========================================================================
  fmt = "(A,A)"
  write(str,fmt) "After test conditionals from ", trim(snpbase)
  call particle_system_print_lun(psys, str, GV%pardatalun )
  write(GV%pardatalun,*)
  write(GV%pardatalun,*)
  flush(GV%pardatalun)
 

  write(str,fmt) "After test conditionals from ", trim(srcbase)
  call source_info_to_screen(psys,str,GV%srcdatalun)
  write(GV%srcdatalun,*)
  write(GV%srcdatalun,*)
  flush(GV%srcdatalun)
  

  ! and the rest of the stuff
  !===============================================================
  GV%dt_code = PLAN%snap(GV%CurSnapNum)%RunTime / PLAN%snap(GV%CurSnapNum)%SrcRays
  call set_dt_from_dtcode( GV )
  
  GV%Tcmb_cur = gconst%t_cmb0 / a
  call get_atomic_rates(GV%Tcmb_cur, rtable, cmbT_k)

  GV%total_mass = 0.0d0
  do i = 1,size(psys%par)
     GV%total_mass = GV%total_mass + psys%par(i)%mass
  end do
  
  GV%total_lum = 0.0d0
  do i = 1,size(psys%src)
     GV%total_lum = GV%total_lum + psys%src(i)%L
  end do
  
  GV%total_atoms = GV%total_mass * GV%cgs_mass * &
       (GV%H_mf  / (gconst%protonmass) + &
       GV%He_mf / (4*gconst%protonmass) )


  GV%total_photons = (GV%TotalSimTime * GV%cgs_time / GV%LittleH) * (GV%total_lum * GV%Lunit)

  
  ! write some final data to the source log file
  !=====================================================================
  fmt = "(A,A)"
  100 format(72("-"))
  
  write(GV%srcdatalun,100)
  write(GV%srcdatalun,fmt) "Ray / Luminosity info from ", trim(srcbase)
  write(GV%srcdatalun,*) 
  write(GV%srcdatalun,'(A,ES12.5)') "dt  [code] = ", GV%dt_code
  write(GV%srcdatalun,'(A,ES12.5)') "dt  [s]    = ", GV%dt_s
  write(GV%srcdatalun,'(A,ES12.5)') "dt  [Myr]  = ", GV%dt_myr
  write(GV%srcdatalun,*)
  write(GV%srcdatalun,'(A,ES12.5)') "total photons = ", GV%total_photons
  write(GV%srcdatalun,'(A,ES12.5)') "total atoms   = ", GV%total_atoms
  write(GV%srcdatalun,'(A,ES12.5)') "photons / atoms = ", GV%total_photons / GV%total_atoms
  write(GV%srcdatalun,*)
  write(GV%srcdatalun,100)
  flush(GV%srcdatalun)
  

  call mywrite("",verb)


 

end subroutine readin_snapshot





end module main_input_mod

!> \file gadget_owls_header_class.F90

!> \brief Handles HDF5 GADGET 3.0 OWLS/GIMIC style headers.  
!!
!! Contains the means to read/write headers from a file.  
!< 

module gadget_owls_header_class
use myf03_mod
use gadget_general_class
use gadget_public_header_class

#ifdef useHDF5
use hdf5_wrapper
#endif

implicit none
private

public :: gadget_owls_header_type

public :: gadget_owls_header_read_lun
public :: gadget_owls_header_read_file
public :: gadget_owls_header_write_lun
public :: gadget_owls_header_print_lun


!> Header type
!-----------------------------------------
type gadget_owls_header_type
   character(200) :: run_label      !< name of OWLS/GIMIC run
   integer(i4b)   :: npar_file(0:5) !< number of particles in snapshot file
   integer(i4b)   :: npar_all(0:5)  !< number of particles in whole snapshot
   integer(i4b)   :: npar_hw(0:5)   !< 64 bit part of npar 
   real(r8b)      :: mass(0:5)      !< mass of each particle type if constant
   real(r8b)      :: a              !< scale factor or time
   real(r8b)      :: time_gyr       !< time in Gyr
   real(r8b)      :: z              !< redshift
   real(r8b)      :: boxlen         !< box length
   integer(i4b)   :: nfiles         !< number of files in a this snapshot
   real(r8b)      :: OmegaM         !< omega matter
   real(r8b)      :: OmegaB         !< omega baryon
   real(r8b)      :: OmegaL         !< omega lambda
   real(r8b)      :: h              !< little hubble
   integer(i4b)   :: flag_sfr       !< flag for star formation
   integer(i4b)   :: flag_cooling   !< flag for radiative cooling
   integer(i4b)   :: flag_age       !< flag for stellar age
   integer(i4b)   :: flag_metals    !< flag for metallicity
   integer(i4b)   :: flag_feedback  !< flag for feedback
end type gadget_owls_header_type



contains
  



!> reads an OWLS/GIMIC gadget header from an open hdf5 file
!--------------------------------------------------------------
subroutine gadget_owls_header_read_lun(this, fh)
  type(gadget_owls_header_type) :: this
  integer, intent(in) :: fh

#ifdef useHDF5
  call hdf5_read_attribute(fh,'Header/RunLabel',this%run_label)
  call hdf5_read_attribute(fh,'Header/NumPart_ThisFile',this%npar_file)
  call hdf5_read_attribute(fh,'Header/NumPart_Total',this%npar_all)
  call hdf5_read_attribute(fh,'Header/NumPart_Total_HighWord',this%npar_hw)
  call hdf5_read_attribute(fh,'Header/MassTable',this%mass)
  call hdf5_read_attribute(fh,'Header/ExpansionFactor',this%a)

  call hdf5_read_attribute(fh,'Header/Time_GYR',this%time_gyr)
  call hdf5_read_attribute(fh,'Header/Redshift',this%z)
  call hdf5_read_attribute(fh,'Header/BoxSize',this%boxlen)
  call hdf5_read_attribute(fh,'Header/NumFilesPerSnapshot',this%nfiles)
  call hdf5_read_attribute(fh,'Header/Omega0',this%OmegaM)
  call hdf5_read_attribute(fh,'Header/OmegaBaryon',this%OmegaB)

  call hdf5_read_attribute(fh,'Header/OmegaLambda',this%OmegaL)
  call hdf5_read_attribute(fh,'Header/HubbleParam',this%h)
  call hdf5_read_attribute(fh,'Header/Flag_Sfr',this%flag_sfr)
  call hdf5_read_attribute(fh,'Header/Flag_Cooling',this%flag_cooling)
  call hdf5_read_attribute(fh,'Header/Flag_StellarAge',this%flag_age)
  call hdf5_read_attribute(fh,'Header/Flag_Metals',this%flag_metals)
  call hdf5_read_attribute(fh,'Header/Flag_Feedback',this%flag_feedback)
#else 
  write(*,*) 'useHDF5 macro not defined in Makefile' 
  stop
#endif

end subroutine gadget_owls_header_read_lun



!> reads an OWLS/GIMIC gadget header from an hdf5 file
!--------------------------------------------------------------
subroutine gadget_owls_header_read_file(this, snapfile)
  type(gadget_owls_header_type) :: this
  character(*), intent(in) :: snapfile
  integer :: fh

#ifdef useHDF5
  call hdf5_open_file( fh, snapfile, readonly=.true. )
  call gadget_owls_header_read_lun(this, fh)
  call hdf5_close_file( fh )
#else 
  write(*,*) 'useHDF5 macro not defined in Makefile' 
  stop
#endif

end subroutine gadget_owls_header_read_file


!> writes a gadget header from an open hdf5 file
!--------------------------------------------------------------
subroutine gadget_owls_header_write_lun(this, fh)
  type(gadget_owls_header_type), intent(in) :: this
  integer, intent(in) :: fh

#ifdef useHDF5
  call hdf5_write_attribute(fh,'Header/RunLabel',this%run_label)
  call hdf5_write_attribute(fh,'Header/NumPart_ThisFile',this%npar_file)
  call hdf5_write_attribute(fh,'Header/NumPart_Total',this%npar_all)
  call hdf5_write_attribute(fh,'Header/NumPart_Total_HW',this%npar_hw)
  call hdf5_write_attribute(fh,'Header/MassTable',this%mass)
  call hdf5_write_attribute(fh,'Header/ExpansionFactor',this%a)

  call hdf5_write_attribute(fh,'Header/Time_GYR',this%time_gyr)
  call hdf5_write_attribute(fh,'Header/Redshift',this%z)
  call hdf5_write_attribute(fh,'Header/BoxSize',this%boxlen)
  call hdf5_write_attribute(fh,'Header/NumFilesPerSnapshot',this%nfiles)
  call hdf5_write_attribute(fh,'Header/Omega0',this%OmegaM)
  call hdf5_write_attribute(fh,'Header/OmegaBaryon',this%OmegaB)

  call hdf5_write_attribute(fh,'Header/OmegaLambda',this%OmegaL)
  call hdf5_write_attribute(fh,'Header/HubbleParam',this%h)
  call hdf5_write_attribute(fh,'Header/Flag_Sfr',this%flag_sfr)
  call hdf5_write_attribute(fh,'Header/Flag_Cooling',this%flag_cooling)
  call hdf5_write_attribute(fh,'Header/Flag_StellarAge',this%flag_age)
  call hdf5_write_attribute(fh,'Header/Flag_Metals',this%flag_metals)
  call hdf5_write_attribute(fh,'Header/Flag_Feedback',this%flag_feedback)
#else 
  write(*,*) 'useHDF5 macro not defined in Makefile' 
  stop
#endif

end subroutine gadget_owls_header_write_lun




!> formatted print of header to lun (including standard out)
!---------------------------------------------------------------
subroutine gadget_owls_header_print_lun(this, lun)
  type(gadget_owls_header_type), intent(in) :: this 
  integer(i4b), intent(in) :: lun
  integer(i8b) :: i

  character(clen) :: n1,n2,n3
  character(clen) :: clmn_fmt
  character(clen) :: type_fmt
  character(clen) :: totl_fmt
  character(clen) :: scal_fmt
  character(clen) :: flag_fmt
  character(clen) :: star_fmt
  character(clen) :: line_fmt

  clmn_fmt = "(T17,A,T32,A,T47,A)"
  type_fmt = "(A,I1,A,A,A,T17,A,T32,A,T47,A)"
  totl_fmt = "(A,T17,A,T47,A)"
  scal_fmt = "(A,A,T25,A,A,T45,A,A)"
  flag_fmt = "(A,5(A,I1))"
  star_fmt = "(78('='))"
  line_fmt = "(78('-'))"

  write(lun,*)
  write(lun,star_fmt)
  write(lun,clmn_fmt) "n_all", "mass", "n_file"
  write(lun,line_fmt)
  do i = 0,5
     write(n1,'(I20)') this%npar_all(i)
     write(n2,'(E12.5)') this%mass(i)
     write(n3,'(I20)') this%npar_file(i)
     write(lun,type_fmt) "type",i,"(",gadget_ptype_names(i),")",&
          trim(adjustl(n1)), trim(adjustl(n2)), trim(adjustl(n3))
  end do
  write(lun,line_fmt)
  write(n1,'(I20)') sum(this%npar_all)
  write(n2,'(I20)') sum(this%npar_file)
  write(lun,totl_fmt) "total:", trim(adjustl(n1)), trim(adjustl(n2)) 
  write(lun,*)

  write(n1,'(F12.5)') this%a
  write(n2,'(F12.5)') this%z
  write(n3,'(F12.5)') this%h

  write(lun,scal_fmt) "a = ", trim(adjustl(n1)), &
       "z = ", trim(adjustl(n2)), &
       "h = ", trim(adjustl(n3))

  write(n1,'(F12.5)') this%OmegaM
  write(n2,'(F12.5)') this%OmegaL
  write(n3,'(F12.5)') this%boxlen

  write(lun,scal_fmt) "OmegaM = ", trim(adjustl(n1)), &
       "OmegaL = ", trim(adjustl(n2)), &
       "BoxSize = ", trim(adjustl(n3))
  write(lun,*)

  write(n1,'(I20)') this%nfiles
  write(lun,'(A,A)') "nfiles = ", trim(adjustl(n1))
  write(lun,flag_fmt) "/flags/ ",&
       "  sfr=",this%flag_sfr, &
       ", feedback=",this%flag_feedback, &
       ", cooling=",this%flag_cooling, &
       ", age=",this%flag_age, &
       ", metals=",this%flag_metals
  write(lun,*) 
  write(lun,star_fmt)

end subroutine gadget_owls_header_print_lun





end module gadget_owls_header_class

!> \file ion_table_class.F90

!> \brief Handles the CLOUDY ionization rate table used in some 
!! versions of Gadget simulations.
!<

module ion_table_class
use myf03_mod

#ifdef useHDF5
use hdf5_wrapper
#endif

#ifdef useMPI
use mpi
#endif

implicit none
private

real(r8b), parameter :: zero= 0.0d0
real(r8b), parameter :: half= 0.5d0
real(r8b), parameter :: one= 1.0d0
real(r8b), parameter :: two = 2.0d0
real(r8b), parameter :: four = 4.0d0

real(r8b), parameter :: pi = 3.14159265358979323846264338327950288
real(r8b), parameter :: four_pi= four * pi
real(r8b), parameter :: HIth_nu= 3.2899d15    ! [Hz]
real(r8b), parameter :: PLANCK= 6.626068d-27  ! [erg s]

 
public :: ion_table_type
public :: ion_header_type
public :: ion_spectrum_type
public :: mini_spec_type
public :: read_ion_table_file
public :: set_mini_spectrum
public :: return_gammaHI_at_z
public :: return_logflux_at_z
public :: integrate_flux_at_z
public :: interpolate_ion_table
public :: gammaHI_from_mini_spec_thin
public :: gammaHI_from_mini_spec_shield
public :: broadcast_ion_table


type ion_spectrum_type
   integer :: s_gammaHI
   integer :: s_z
   integer :: s_logryd
   integer :: s_logflux
   real(r8b), allocatable :: gammaHI(:)
   real(r8b), allocatable :: z(:)
   real(r8b), allocatable :: logryd(:)    ! [Rydbergs]
   real(r8b), allocatable :: logflux(:,:) ! [ergs/s/Hz/cm^2/sr]
   character(clen) :: model_name
end type ion_spectrum_type

type ion_header_type
   character(clen) :: cloudy_version
   type(ion_spectrum_type) :: ispec
end type ion_header_type


type ion_table_type
   type(ion_header_type) :: ihead
   integer :: s_ibal
   integer :: s_z
   integer :: s_logt
   integer :: s_logd
   real(r8b) :: logd_max
   real(r8b) :: logt_max
   real(r8b), allocatable :: ibal(:,:,:)  ! ibal( iz, it, id )
   real(r8b), allocatable :: z(:)
   real(r8b), allocatable :: logt(:)
   real(r8b), allocatable :: logd(:)
end type ion_table_type


!> stores a piece of the spectrum at a specific (interpolated) z
!-----------------------------------------------------------------
type mini_spec_type
   real(r8b) :: min_logryd                  !< lowest requested energy
   real(r8b) :: max_logryd                  !< highest requested energy
   real(r8b) :: z                           !< redshift
   real(r8b) :: gammaHI                     !< interpolated gammaHI from table
   real(r8b), allocatable :: logryd(:)      !< log energy samples
   real(r8b), allocatable :: ryd(:)         !< energy samples
   real(r8b), allocatable :: logflux(:)     !< interpolated log flux from nu1-nu2
   real(r8b), allocatable :: flux(:)        !< interpolated flux from nu1-nu2
   real(r8b), allocatable :: sigmaHI(:)     !< HI photoionization cs @ logryd
   real(r8b), allocatable :: sigma_ratio(:) !< sigma(nu) / sigma(nu_th)
end type mini_spec_type



contains


  !> sets up a mini spectrum
  !------------------------------------------------------------------------
  subroutine set_mini_spectrum( min_logryd, max_logryd, z, itab, mini_spec )
    real(r8b), intent(in) :: min_logryd
    real(r8b), intent(in) :: max_logryd
    real(r8b), intent(in) :: z
    type(ion_table_type), intent(in) :: itab
    type(mini_spec_type), intent(out) :: mini_spec

    real(r8b), allocatable :: logflux_all(:) !< interp logflux @ all energy
                                             
    integer(i4b) :: nall, n
    integer(i4b) :: ilwr, iupr
    integer(i4b) :: i

    mini_spec%min_logryd = min_logryd
    mini_spec%max_logryd = max_logryd
    mini_spec%z          = z

    mini_spec%gammaHI = return_gammaHI_at_z( itab, z )

    ! first get interplated (in redshift) logflux at all energies
    !-------------------------------------------------------------
    nall = size(itab%ihead%ispec%logryd)
    allocate( logflux_all( nall ) )
    logflux_all = return_logflux_at_z( itab, z )

    ! now find indices that bracket requested energies
    !---------------------------------------------------
    do i = 1,nall
       if ( itab%ihead%ispec%logryd(i) > min_logryd ) then
          ilwr = i-1
          exit
       endif
    end do

    do i = 1,nall
       if ( itab%ihead%ispec%logryd(i) > max_logryd ) then
          iupr = i
          exit
       endif
    end do

    n = iupr - ilwr + 1
    allocate( mini_spec%logryd(n), mini_spec%ryd(n), mini_spec%logflux(n),      &
              mini_spec%flux(n), mini_spec%sigmaHI(n), mini_spec%sigma_ratio(n) )

    mini_spec%logryd  = itab%ihead%ispec%logryd(ilwr:iupr)
    mini_spec%logflux = logflux_all(ilwr:iupr)
    mini_spec%flux    = 10**mini_spec%logflux
    mini_spec%ryd     = 10**mini_spec%logryd
    do i = 1,n
       mini_spec%sigmaHI(i)     = HI_photo_cs_verner( mini_spec%ryd(i) )
       mini_spec%sigma_ratio(i) = HI_photo_cs_verner( mini_spec%ryd(i) ) / HI_photo_cs_verner( 1.0d0 ) 
    end do




  end subroutine set_mini_spectrum


  !> calculates gammaHI from mini spectrum in optically thin limit
  !-------------------------------------------------------------------------
  function gammaHI_from_mini_spec_thin( mini_spec ) result( gammaHI )
    type(mini_spec_type), intent(in) :: mini_spec
    real(r8b) :: gammaHI

    gammaHI = int_tabulated_trap_rule( mini_spec%logryd, &
         four_pi * log(10.d0) * mini_spec%flux * mini_spec%sigmaHI / PLANCK )   

  end function gammaHI_from_mini_spec_thin



  !> calculates gammaHI from mini spectrum in optically w/ shielding
  !-------------------------------------------------------------------------
  function gammaHI_from_mini_spec_shield( mini_spec, tauHI) result( gammaHI )
    type(mini_spec_type), intent(in) :: mini_spec
    real(r8b), intent(in) :: tauHI
    real(r8b) :: gammaHI

    gammaHI = int_tabulated_trap_rule( mini_spec%logryd, &
         four_pi * log(10.d0) * mini_spec%flux * mini_spec%sigmaHI / PLANCK * &
         exp(-tauHI * mini_spec%sigma_ratio) )   

  end function gammaHI_from_mini_spec_shield





  !> HI photo ionization x-section (Analytic) [cm^2]
  !-------------------------------------------------------------------------
  function HI_photo_cs_analytic( Ry ) result( sigma )
    real(r8b), intent(in) :: Ry  !< energy [Rydbergs]
    real(r8b) :: sigma           !< cross section [cm^2]
    real(r8b), parameter :: A0 = 6.30d-18


    real(r8b) :: eps 
    real(r8b) :: ieps
    real(r8b) :: efac
    real(r8b) :: num
    real(r8b) :: den

    eps = sqrt( Ry - one )
    ieps = one/eps
    efac = four - ( four * atan(eps) ) * ieps
    num = exp(efac)
    den = one - exp(-two * pi * ieps)
  
    sigma = A0 * (Ry)**(-4) * num / den


  end function HI_photo_cs_analytic



  !> HI photo ionization x-section at 1 Rydberg (Verner) [cm^2]
  !-------------------------------------------------------------------------
  function HIth_photo_cs_verner() result( sigma )
    real(r8b) :: sigma
    sigma = HI_photo_cs_verner( one )
  end function HIth_photo_cs_verner

 
  !> HI photo ionization x-section (Verner) [cm^2]
  !-------------------------------------------------------------------------
  function HI_photo_cs_verner( Ry ) result( sigma )
    real(r8b), intent(in) :: Ry  !< energy [Rydbergs]
    real(r8b) :: sigma           !< cross section [cm^2]
    real(r8b), parameter :: Eth = 13.6d0
    real(r8b), parameter :: Emax = 5.0d4
    real(r8b), parameter :: E0 = 4.298d-1
    real(r8b), parameter :: sig0 = 5.475d4
    real(r8b), parameter :: ya = 3.288d1
    real(r8b), parameter :: P = 2.963d0

    real(r8b) :: eV
    real(r8b) :: x
    real(r8b) :: y

    eV = Ry * 13.6d0
    x = eV / E0
    y = x
  
    sigma = sig0 * (x-1)**2 * y**(0.5d0 * P - 5.5d0) * (1 + sqrt(y/ya))**(-P)
    sigma = sigma * 1.0d-18

  end function HI_photo_cs_verner


  !> HI photo ionization x-section (Osterbrok) [cm^2]
  !----------------------------------------------------------------------------
  function HI_photo_cs_osterbrok( Ry ) result( sigma )    
    real(r8b), intent(in) :: Ry    !< energy [Rydbergs]
    real(r8b) :: sigma             !< cross section 
    real(r8b), parameter :: sigma0 = 6.3d-18

    if (Ry < one) then
       sigma = zero
    else
       sigma = sigma0 * ( Ry )**(-3)
    endif

  end function HI_photo_cs_osterbrok




  ! integrates a tabulated function using the trap. rule
  !-------------------------------------------------------------------------
  function int_tabulated_trap_rule( xarr, yarr ) result(sum)
    real(r8b), intent(in) :: xarr(:)
    real(r8b), intent(in) :: yarr(:)
    real(r8b) :: sum
    real(r8b) :: h
    integer :: n
    integer :: i

    n = size(xarr)
    if ( size(yarr) /= n ) then
       write(*,*) 'size mismatch in int_tabulated_trap_rule'
       stop
    endif

    sum = zero    
    do i = 1, n-1
       h = xarr(i+1) - xarr(i)
       sum = sum + h * half * (yarr(i+1) + yarr(i))
    end do

  end function int_tabulated_trap_rule



  ! integrate flux
  !---------------------------------------------
  function integrate_flux_at_z( itab, z ) result(sum)
    type(ion_table_type) :: itab
    real(r8b) :: z
    real(r8b) :: sum

    real(r8b), allocatable :: logfluxall(:) 
    real(r8b), allocatable :: ryd(:)
    real(r8b), allocatable :: sigma(:)
    real(r8b), allocatable :: nu(:)
    real(r8b), allocatable :: logflux(:)
    real(r8b), allocatable :: xarr(:)
    real(r8b), allocatable :: yarr(:)

    integer :: n
    integer :: i
    integer :: icnt
    integer :: nabove
    real(r8b) :: GHI


    n = size(itab%ihead%ispec%logryd)
    allocate( logfluxall(n) )
    logfluxall = return_logflux_at_z( itab, z )
    

    icnt = 0
    do i = 1,n
       if ( itab%ihead%ispec%logryd(i) > zero ) then
          icnt = i-1
          exit
       end if
    end do

    nabove = size( itab%ihead%ispec%logryd(icnt:icnt+49) )


    allocate( ryd(nabove), sigma(nabove), nu(nabove), logflux(nabove) )
    allocate( xarr(nabove), yarr(nabove) )

    xarr = itab%ihead%ispec%logryd(icnt:icnt+49)
    logflux = logfluxall(icnt:icnt+49)
    ryd = 10**xarr
    ryd(1) = 1.0d0
    do i = 1,size(ryd) 
       sigma(i) = HI_photo_cs_verner( ryd(i) )
    end do
    nu = ryd * HIth_nu
        
    yarr = four_pi * log(10.d0) * 10**logflux * sigma / PLANCK
    
    sum = int_tabulated_trap_rule( xarr, yarr )

    GHI = return_gammaHI_at_z( itab, z )


  end function integrate_flux_at_z





  ! returns the HI photoionization rate at z
  !---------------------------------------------
  function return_gammaHI_at_z( itab, z ) result(GHI)
    type(ion_table_type) :: itab
    real(r8b) :: z
    real(r8b) :: GHI

    real(r8b) :: zsearch, zlow, zhigh
    real(r8b) :: dz1, dz2, z1, z2
    real(r8b) :: frac1, frac2, dGHI
    integer :: n, i, iz1, iz2

    zsearch = z
    n = size(itab%ihead%ispec%z)

    zlow  = itab%ihead%ispec%z(1)
    zhigh = itab%ihead%ispec%z(n)
    
    if (z <= zlow) then
       GHI = itab%ihead%ispec%gammaHI(1)
       return
    endif
    if (z >= zhigh) then
       GHI = itab%ihead%ispec%gammaHI(n)
       return
    endif

    ! bracket the redshift
    do i = 2, n
       if (itab%ihead%ispec%z(i) > z) then
          iz2 = i
          iz1 = iz2-1
          exit
       end if
    end do

    z1 = itab%ihead%ispec%z(iz1)
    z2 = itab%ihead%ispec%z(iz2)

    dz1 = z  - z1
    dz2 = z2 - z

    frac1 = dz1 / (z2-z1)
    frac2 = dz2 / (z2-z1)

    dGHI = itab%ihead%ispec%gammaHI(iz2) - itab%ihead%ispec%gammaHI(iz1)
    GHI = itab%ihead%ispec%gammaHI(iz1) + frac1 * dGHI

  end function return_gammaHI_at_z



  ! returns logryd and logflux at z
  !---------------------------------------------
  function return_logflux_at_z( itab, z ) result(logflux)
    type(ion_table_type) :: itab
    real(r8b) :: z
    real(r8b) :: logflux(size(itab%ihead%ispec%logryd))

    real(r8b) :: zsearch, zlow, zhigh
    real(r8b) :: dz1, dz2, z1, z2
    real(r8b) :: frac1, frac2, dflux
    integer :: n, i, iz1, iz2

    zsearch = z
    n = size(itab%ihead%ispec%z)

    zlow  = itab%ihead%ispec%z(1)
    zhigh = itab%ihead%ispec%z(n)
    
    if (z <= zlow) then
       logflux = itab%ihead%ispec%logflux(1,:)
       return
    endif
    if (z >= zhigh) then
       logflux = itab%ihead%ispec%logflux(n,:)
       return
    endif

    ! bracket the redshift
    do i = 2, n
       if (itab%ihead%ispec%z(i) > z) then
          iz2 = i
          iz1 = iz2-1
          exit
       end if
    end do

    z1 = itab%ihead%ispec%z(iz1)
    z2 = itab%ihead%ispec%z(iz2)

    dz1 = z  - z1
    dz2 = z2 - z

    frac1 = dz1 / (z2-z1)
    frac2 = dz2 / (z2-z1)

    do i = 1, size(itab%ihead%ispec%logryd)
       dflux = itab%ihead%ispec%logflux(iz2,i) - itab%ihead%ispec%logflux(iz1,i)
       logflux(i) = itab%ihead%ispec%logflux(iz1,i) + frac1 * dflux
    enddo



  end function return_logflux_at_z








  subroutine read_ion_table_file( file, itab )
    character(clen), parameter :: myname="read_ion_table_file" 
    logical, parameter :: crash=.true.
    integer, parameter :: verb=2
    character(clen) :: str

    character(*) :: file
    type(ion_table_type) :: itab
    integer :: fh

#ifdef useHDF5    
    integer :: rank
    integer :: dims(3)
    character(clen) :: fmt

    integer :: nz, nt, nd

    fmt = "(T7, A, 4I8)"
   
    call hdf5_open_file( fh, file, readonly=.true. )

    call hdf5_read_attribute(fh, 'header/cloudy_version', itab%ihead%cloudy_version)
    call hdf5_read_attribute(fh, 'header/spectrum/model_name', itab%ihead%ispec%model_name)

!    call mywrite('',verb) 
    call mywrite("      cloudy version = "//trim(itab%ihead%cloudy_version), verb)
    call mywrite("      model name     = "//trim(itab%ihead%ispec%model_name), verb)
    call mywrite('',verb) 

    dims=0
    call hdf5_get_dimensions(fh, 'header/spectrum/gammahi', rank, dims)
    allocate( itab%ihead%ispec%gammaHI( dims(1) ) )
    call hdf5_read_data(fh, 'header/spectrum/gammahi', itab%ihead%ispec%gammaHI )
    write(str,fmt) "rank and dims of gammaHI:       ", rank, dims 
    call mywrite(str,verb)
    itab%ihead%ispec%s_gammaHI = dims(1) 

    dims=0
    call hdf5_get_dimensions(fh, 'header/spectrum/logenergy_ryd', rank, dims)
    allocate( itab%ihead%ispec%logryd( dims(1) ) )
    call hdf5_read_data(fh, 'header/spectrum/logenergy_ryd', itab%ihead%ispec%logryd )
    write(str,fmt) "rank and dims of logenergy_ryd: ", rank, dims
    call mywrite(str,verb) 
    itab%ihead%ispec%s_logryd = dims(1)

    dims=0
    call hdf5_get_dimensions(fh, 'header/spectrum/logflux', rank, dims)
    allocate( itab%ihead%ispec%logflux( dims(1), dims(2) ) )
    call hdf5_read_data(fh, 'header/spectrum/logflux', itab%ihead%ispec%logflux )
    write(str,fmt) "rank and dims of logflux:       ", rank, dims
    call mywrite(str,verb) 
    itab%ihead%ispec%s_logflux = product( dims(1:2) )

    dims=0
    call hdf5_get_dimensions(fh, 'header/spectrum/redshift', rank, dims)
    allocate( itab%ihead%ispec%z( dims(1) ) )
    call hdf5_read_data(fh, 'header/spectrum/redshift', itab%ihead%ispec%z )
    write(str,fmt) "rank and dims of redshift:      ", rank, dims 
    call mywrite(str,verb) 
    itab%ihead%ispec%s_z = dims(1)

    dims=0
    call hdf5_get_dimensions(fh, 'ionbal', rank, dims)
    allocate( itab%ibal( dims(1), dims(2), dims(3) ) )
    call hdf5_read_data(fh, 'ionbal', itab%ibal )
    write(str,fmt) "rank and dims of ionbal:        ", rank, dims
    call mywrite(str,verb) 
    itab%s_ibal = product( dims(1:3) )

    dims=0
    call hdf5_get_dimensions(fh, 'logd', rank, dims)
    allocate( itab%logd( dims(1) ) )
    call hdf5_read_data(fh, 'logd', itab%logd )
    write(str,fmt) "rank and dims of logd:          ", rank, dims
    call mywrite(str,verb) 
    nd = dims(1)
    itab%s_logd = dims(1) 

    dims=0
    call hdf5_get_dimensions(fh, 'logt', rank, dims)
    allocate( itab%logt( dims(1) ) )
    call hdf5_read_data(fh, 'logt', itab%logt )
    write(str,fmt) "rank and dims of logt:          ", rank, dims 
    call mywrite(str,verb) 
    nt = dims(1)
    itab%s_logt = dims(1) 

    dims=0
    call hdf5_get_dimensions(fh, 'redshift', rank, dims)
    allocate( itab%z( dims(1) ) )
    call hdf5_read_data(fh, 'redshift', itab%z )
    write(str,fmt) "rank and dims of z:             ", rank, dims
    call mywrite(str,verb) 
    nz = dims(1)
    itab%s_z = dims(1) 

    call hdf5_close_file( fh )

    itab%ibal = log10( itab%ibal )

    itab%logd_max = itab%logd(nd)
    itab%logt_max = itab%logt(nt)


    fmt = "(T7, A, 2ES15.5)"

    call mywrite('',verb) 
    call mywrite("     spectrum:",verb)

    write(str,fmt) "min/max G_HI    = ", minval(itab%ihead%ispec%gammaHI), maxval(itab%ihead%ispec%gammaHI)
    call mywrite(str,verb)

    write(str,fmt) "min/max logryd  = ", minval(itab%ihead%ispec%logryd), maxval(itab%ihead%ispec%logryd)
    call mywrite(str,verb)

    write(str,fmt) "min/max logflux = ", minval(itab%ihead%ispec%logflux), maxval(itab%ihead%ispec%logflux)
    call mywrite(str,verb)

    write(str,fmt) "min/max z       = ", minval(itab%ihead%ispec%z), maxval(itab%ihead%ispec%z)
    call mywrite(str,verb)

    call mywrite('',verb)
    call mywrite("     ionization balance:",verb)
    write(str,fmt) "min/max log10(ionbal)  = ", minval(itab%ibal), maxval(itab%ibal)
    call mywrite(str,verb)
 
    write(str,fmt) "min/max logd           = ", minval(itab%logd), maxval(itab%logd)
    call mywrite(str,verb)

    write(str,fmt) "min/max logt           = ", minval(itab%logt), maxval(itab%logt)
    call mywrite(str,verb)

    write(str,fmt) "min/max z              = ", minval(itab%z), maxval(itab%z)
    call mywrite(str,verb)
    call mywrite('',verb) 

#else

    stop "trying to read hdf5 ion table, but haven't defined hdf5 macro in Makefile"

#endif

  end subroutine read_ion_table_file




  function interpolate_ion_table( itab, z, logt, logd ) result (ioneq)
    type(ion_table_type) :: itab
    real(r8b) :: z      !< input redshift
    real(r8b) :: logt   !< input log temperature
    real(r8b) :: logd   !< input log density
    real(r8b) :: ioneq  !< returned ionization equilibrium

    integer :: nz, nt, nd !< size of interpolation grid
    integer :: iz, it, id !< lower bracketing index
    integer :: fz, ft, fd !< upper bracketing index
    real(r8b)    :: rz, rt, rd !< real index (between bracketing index)

    real(r8b) :: wiz, wfz, wit, wft, wid, wfd  !< fractional distances between bracketing indices
    real(r8b) :: w111, w211, w121, w221, w112, w212, w122, w222  !< weights
    real(r8b) :: dz, dt, dd                    !< difference between bracketing indices

    integer :: i !< general loop index

    ! get sizes of interpolation grid
    !----------------------------------
    nz = size(itab%z)
    nt = size(itab%logt)
    nd = size(itab%logd)

    ! do some checks
    !-------------------    
    if ( z < itab%z(1) )  then
       write(*,*) "warning z below limit in table"
       stop
    endif

    if ( z > itab%z(nz) ) then
       write(*,*) "warning z above limit in table"
       stop
    endif

    if ( logt < itab%logt(1) )  then
!       write(*,*) "warning logt below limit in table"
       logt = itab%logt(1)
    endif

    if ( logt > itab%logt(nt) ) then
!       write(*,*) "warning logt above limit in table"
       logt = itab%logt(nt)
    endif

    if ( logd < itab%logd(1) )  then
!       write(*,*) "warning logd below limit in table"
       logd = itab%logd(1)
    endif

    if ( logd > itab%logd(nd) ) then
!       write(*,*) "warning logd above limit in table"
       logd = itab%logd(nd)
    endif

    
    

    ! find bracketing indices
    !--------------------------
    do i = 1, nz
       if (itab%z(i) > z) then
          fz = i
          iz = fz-1
          exit
       end if
    end do

    do i = 1, nt
       if (itab%logt(i) > logt) then
          ft = i
          it = ft-1
          exit
       end if
    end do

    do i = 1, nd
       if (itab%logd(i) > logd) then
          fd = i
          id = fd-1
          exit
       end if
    end do


    if (z==itab%z(1)) then
       iz = 1
       fz = 2
    else if (z==itab%z(nz)) then
       fz = nz
       iz = nz-1
    endif

    if (logt==itab%logt(1)) then
       it = 1
       ft = 2
    else if (logt==itab%logt(nt)) then
       ft = nt
       it = nt-1
    endif

    if (logd==itab%logd(1)) then
       id = 1
       fd = 2
    else if (logd==itab%logd(nd)) then
       fd = nd
       id = nd-1
    endif


    dz = itab%z(fz) - itab%z(iz)
    wiz = ( z - itab%z(iz) ) / dz
    wfz = ( itab%z(fz) - z ) / dz

    dt = itab%logt(ft) - itab%logt(it)
    wit = ( logt - itab%logt(it) ) / dt
    wft = ( itab%logt(ft) - logt ) / dt

    dd = itab%logd(fd) - itab%logd(id)
    wid = ( logd - itab%logd(id) ) / dd
    wfd = ( itab%logd(fd) - logd ) / dd

    rz = iz + wiz
    rt = it + wit
    rd = id + wid

 
    w111 = wfz * wft * wfd
    w211 = wiz * wft * wfd
    w121 = wfz * wit * wfd
    w221 = wiz * wit * wfd
    w112 = wfz * wft * wid
    w212 = wiz * wft * wid
    w122 = wfz * wit * wid
    w222 = wiz * wit * wid


    ioneq = &
         w111 * itab%ibal( iz, it, id ) + &
         w211 * itab%ibal( fz, it, id ) + &
         w121 * itab%ibal( iz, ft, id ) + &
         w221 * itab%ibal( fz, ft, id ) + &
         w112 * itab%ibal( iz, it, fd ) + &
         w212 * itab%ibal( fz, it, fd ) + &
         w122 * itab%ibal( iz, ft, fd ) + &
         w222 * itab%ibal( fz, ft, fd ) 

    
    ioneq = 10**ioneq



   
  end function interpolate_ion_table



  !> broadcasts the ionization table to all processing elements
  !--------------------------------------------------------------
  subroutine broadcast_ion_table( MyPE, itab )
    integer, intent(in) :: MyPE
    type(ion_table_type) :: itab
    integer :: count
    integer :: root
    integer :: ierr
    
    root = 0

#ifdef useMPI

    count = 1
    call mpi_bcast( itab%logd_max, count, mpi_double_precision, root, mpi_comm_world, ierr )
    call mpi_bcast( itab%logt_max, count, mpi_double_precision, root, mpi_comm_world, ierr )

    call mpi_bcast( itab%s_logd,    count, mpi_integer, root, mpi_comm_world, ierr )
    call mpi_bcast( itab%s_logt,    count, mpi_integer, root, mpi_comm_world, ierr )
    call mpi_bcast( itab%s_z,       count, mpi_integer, root, mpi_comm_world, ierr )
    call mpi_bcast( itab%s_ibal,    count, mpi_integer, root, mpi_comm_world, ierr )

    call mpi_bcast( itab%ihead%ispec%s_logflux, count, mpi_integer, root, mpi_comm_world, ierr )
    call mpi_bcast( itab%ihead%ispec%s_logryd,  count, mpi_integer, root, mpi_comm_world, ierr )
    call mpi_bcast( itab%ihead%ispec%s_z,       count, mpi_integer, root, mpi_comm_world, ierr )
    call mpi_bcast( itab%ihead%ispec%s_gammaHI, count, mpi_integer, root, mpi_comm_world, ierr )


    call mpi_barrier(mpi_comm_world, ierr)
    if (MyPE /= root) then
       allocate( itab%logd( itab%s_logd ) )
       allocate( itab%logt( itab%s_logt ) )
       allocate( itab%z   ( itab%s_z    ) )
       allocate( itab%ibal( itab%s_z, itab%s_logt, itab%s_logd ) )

       allocate( itab%ihead%ispec%logflux ( itab%ihead%ispec%s_z, itab%ihead%ispec%s_logryd  ) )
       allocate( itab%ihead%ispec%logryd  ( itab%ihead%ispec%s_logryd  ) )
       allocate( itab%ihead%ispec%z       ( itab%ihead%ispec%s_z       ) )
       allocate( itab%ihead%ispec%gammaHI ( itab%ihead%ispec%s_gammaHI ) )
    endif
    call mpi_barrier(mpi_comm_world, ierr)


    count = itab%s_logd  
    call mpi_bcast( itab%logd, count, mpi_double_precision, root, mpi_comm_world, ierr )

    count = itab%s_logt  
    call mpi_bcast( itab%logt, count, mpi_double_precision, root, mpi_comm_world, ierr )

    count = itab%s_z 
    call mpi_bcast( itab%z, count, mpi_double_precision, root, mpi_comm_world, ierr )

    count = itab%s_ibal 
    call mpi_bcast( itab%ibal, count, mpi_double_precision, root, mpi_comm_world, ierr )


    count = clen
    call mpi_bcast( itab%ihead%cloudy_version,   count, mpi_character, root, mpi_comm_world, ierr )
    call mpi_bcast( itab%ihead%ispec%model_name, count, mpi_character, root, mpi_comm_world, ierr )

    count = itab%ihead%ispec%s_logflux
    call mpi_bcast( itab%ihead%ispec%logflux(1,1), count, mpi_double_precision, root, mpi_comm_world, ierr )

    count = itab%ihead%ispec%s_logryd 
    call mpi_bcast( itab%ihead%ispec%logryd, count, mpi_double_precision, root, mpi_comm_world, ierr )

    count = itab%ihead%ispec%s_z 
    call mpi_bcast( itab%ihead%ispec%z, count, mpi_double_precision, root, mpi_comm_world, ierr )

    count = itab%ihead%ispec%s_gammaHI 
    call mpi_bcast( itab%ihead%ispec%gammaHI, count, mpi_double_precision, root, mpi_comm_world, ierr )



#endif


  end subroutine broadcast_ion_table


end module ion_table_class

!> \file gadget_public_header_class.f90

!> \brief Handles GADGET 2.0 Public version style headers.  
!!
!! Contains the means to read/write headers from a file or open lun.  
!! In addition, provides types to handle units and constants in a 
!! standard way.  Note that where 6 element arrays are needed that
!! correspond to particle types, we have indexed them from 0-5 as 
!! opposed to the default Fortran 1-6. 
!< 

module gadget_public_header_class
use myf03_mod
use gadget_general_class

#ifdef useMPI
  use mpi
#endif

implicit none
private

public :: gadget_public_header_type
public :: gadget_public_header_read_lun
public :: gadget_public_header_read_file
public :: gadget_public_header_write_lun
public :: gadget_public_header_print_lun
public :: gadget_public_header_return_gyr
public :: gadget_public_header_broadcast



!> Header type
!-----------------------------------------
type gadget_public_header_type
   integer(i4b) :: npar_file(0:5)   !< number of particles in snapshot file
   real(r8b)    :: mass(0:5)        !< mass of each particle type if constant
   real(r8b)    :: a                !< scale factor or time
   real(r8b)    :: z                !< redshift
   integer(i4b) :: flag_sfr         !< flag for star formation
   integer(i4b) :: flag_feedback    !< flag for feedback
   integer(i4b) :: npar_all(0:5)    !< number of particles in whole snapshot
   integer(i4b) :: flag_cooling     !< flag for radiative cooling
   integer(i4b) :: nfiles           !< number of files in a this snapshot
   real(r8b)    :: boxlen           !< box length
   real(r8b)    :: OmegaM           !< omega matter
   real(r8b)    :: OmegaL           !< omega lambda
   real(r8b)    :: h                !< little hubble
   integer(i4b) :: flag_age         !< flag for stellar age
   integer(i4b) :: flag_metals      !< flag for metallicity
   integer(i4b) :: npar_hw(0:5)     !< 64 bit part of npar 
   integer(i4b) :: flag_entr_ics    !< ICs contain entropy instead of energy
   integer(i4b) :: unused(15)       !< padding to make 256 bytes
end type gadget_public_header_type



contains


!> uses the scale factor and OmegaM+OmegaL to 
!! calculate the time in Gyr since the Big Bang
!----------------------------------------------------
function gadget_public_header_return_gyr(this) result(t_gyr)
  type(gadget_public_header_type) :: this
  type(gadget_constants_type) :: const
  real(r8b) :: t_gyr
  real(r8b) :: aeq, pre, arg, H0, km_per_Mpc, sec_per_Gyr

  if (this%OmegaL == 0.0) then
     t_gyr = 1.0d0
     return
  endif

  km_per_Mpc = const%CM_PER_MPC / 1.0d5 
  sec_per_Gyr = const%SEC_PER_MEGAYEAR * 1.0d3 

  H0 = this%h * 100.0d0 / km_per_Mpc  ! 1/s
  aeq = ( this%OmegaM/this%OmegaL )**(1.0d0/3.0d0)
  pre = 2.0d0 / ( 3.0d0 * sqrt(this%OmegaL) )
  arg = (this%a/aeq)**(3.0d0/2.0d0) + sqrt(1 + (this%a/aeq)**3 )
  t_gyr = pre * log(arg) / H0  ! in s
  t_gyr = t_gyr / sec_per_Gyr 

end function gadget_public_header_return_gyr


!> reads a gadget header from an open raw binary file 
!--------------------------------------------------------------
subroutine gadget_public_header_read_lun(this, lun)
  type(gadget_public_header_type) :: this
  integer(i4b), intent(in) :: lun

  read(lun) this%npar_file(:), this%mass(:), this%a, this%z, &              
       this%flag_sfr, this%flag_feedback, this%npar_all(:), &    
       this%flag_cooling, this%nfiles, this%boxlen, this%OmegaM, &         
       this%OmegaL, this%h, this%flag_age, this%flag_metals, &    
       this%npar_hw(:), this%flag_entr_ics, this%unused(:)      

end subroutine gadget_public_header_read_lun



!> reads a gadget header from snapfile and closes it afterwards
!--------------------------------------------------------------
subroutine gadget_public_header_read_file(this, snapfile)
  type(gadget_public_header_type) :: this
  character(*), intent(in) :: snapfile
  integer(i4b) :: lun    

  call open_unformatted_file_r( snapfile, lun )
  call gadget_public_header_read_lun(this, lun)
  close(lun)

end subroutine gadget_public_header_read_file


!> writes a gadget header to an open file
!--------------------------------------------------------------
subroutine gadget_public_header_write_lun(this, lun)
  type(gadget_public_header_type) :: this
  integer(i4b), intent(in) :: lun

  write(lun) this%npar_file(:), this%mass(:), this%a, this%z, &              
       this%flag_sfr, this%flag_feedback, this%npar_all(:), &    
       this%flag_cooling, this%nfiles, this%boxlen, this%OmegaM, &         
       this%OmegaL, this%h, this%flag_age, this%flag_metals, &    
       this%npar_hw(:), this%flag_entr_ics, this%unused(:)      

end subroutine gadget_public_header_write_lun




!> formatted print of header to lun (including standard out)
!---------------------------------------------------------------
subroutine gadget_public_header_print_lun(this, lun)
  type(gadget_public_header_type), intent(in) :: this 
  integer(i4b), intent(in) :: lun
  integer(i8b) :: i

  character(clen) :: n1,n2,n3
  character(clen) :: clmn_fmt
  character(clen) :: type_fmt
  character(clen) :: totl_fmt
  character(clen) :: scal_fmt
  character(clen) :: flag_fmt
  character(clen) :: star_fmt
  character(clen) :: line_fmt

  clmn_fmt = "(T17,A,T32,A,T47,A)"
  type_fmt = "(A,I1,A,A,A,T17,A,T32,A,T47,A)"
  totl_fmt = "(A,T17,A,T47,A)"
  scal_fmt = "(A,A,T25,A,A,T45,A,A)"
  flag_fmt = "(A,6(A,I1))"
  star_fmt = "(78('='))"
  line_fmt = "(78('-'))"

  write(lun,*)
  write(lun,star_fmt)
  write(lun,clmn_fmt) "n_all", "mass", "n_file"
  write(lun,line_fmt)
  do i = 0,5
     write(n1,'(I20)') this%npar_all(i)
     write(n2,'(E12.5)') this%mass(i)
     write(n3,'(I20)') this%npar_file(i)
     write(lun,type_fmt) "type",i,"(",gadget_ptype_names(i),")",&
          trim(adjustl(n1)), trim(adjustl(n2)), trim(adjustl(n3))
  end do
  write(lun,line_fmt)
  write(n1,'(I20)') sum(this%npar_all)
  write(n2,'(I20)') sum(this%npar_file)
  write(lun,totl_fmt) "total:", trim(adjustl(n1)), trim(adjustl(n2)) 
  write(lun,*)

  write(n1,'(F12.5)') this%a
  write(n2,'(F12.5)') this%z
  write(n3,'(F12.5)') this%h

  write(lun,scal_fmt) "a = ", trim(adjustl(n1)), &
       "z = ", trim(adjustl(n2)), &
       "h = ", trim(adjustl(n3))

  write(n1,'(F12.5)') this%OmegaM
  write(n2,'(F12.5)') this%OmegaL
  write(n3,'(F12.5)') this%boxlen

  write(lun,scal_fmt) "OmegaM = ", trim(adjustl(n1)), &
       "OmegaL = ", trim(adjustl(n2)), &
       "BoxSize = ", trim(adjustl(n3))
  write(lun,*)

  write(n1,'(I20)') this%nfiles
  write(lun,'(A,A)') "nfiles = ", trim(adjustl(n1))
  write(lun,flag_fmt) "/flags/ ",&
       "  sfr=",this%flag_sfr, &
       ", feedback=",this%flag_feedback, &
       ", cooling=",this%flag_cooling, &
       ", age=",this%flag_age, &
       ", metals=",this%flag_metals, &
       ", entr_ics=", this%flag_entr_ics
  write(lun,*) 
  write(lun,star_fmt)

end subroutine gadget_public_header_print_lun






!> broadcasts header
!-----------------------------------------
subroutine gadget_public_header_broadcast( this )
  type(gadget_public_header_type) :: this
  integer :: count
  integer :: root
  integer :: ierr

  root = 0

#ifdef useMPI
  count = 6
  call mpi_bcast( this%npar_file, count, mpi_integer, root, mpi_comm_world, ierr )
  call mpi_bcast( this%npar_all, count, mpi_integer, root, mpi_comm_world, ierr )
  call mpi_bcast( this%npar_hw, count, mpi_integer, root, mpi_comm_world, ierr )
  call mpi_bcast( this%mass, count, mpi_double_precision, root, mpi_comm_world, ierr )

  count = 1
  call mpi_bcast( this%a, count, mpi_double_precision, root, mpi_comm_world, ierr )
  call mpi_bcast( this%z, count, mpi_double_precision, root, mpi_comm_world, ierr )
  call mpi_bcast( this%flag_sfr, count, mpi_integer, root, mpi_comm_world, ierr )
  call mpi_bcast( this%flag_feedback, count, mpi_integer, root, mpi_comm_world, ierr )
  call mpi_bcast( this%flag_cooling, count, mpi_integer, root, mpi_comm_world, ierr )
  call mpi_bcast( this%nfiles, count, mpi_integer, root, mpi_comm_world, ierr )
  call mpi_bcast( this%boxlen, count, mpi_double_precision, root, mpi_comm_world, ierr )
  call mpi_bcast( this%OmegaM, count, mpi_double_precision, root, mpi_comm_world, ierr )
  call mpi_bcast( this%OmegaL, count, mpi_double_precision, root, mpi_comm_world, ierr )
  call mpi_bcast( this%h, count, mpi_double_precision, root, mpi_comm_world, ierr )
  call mpi_bcast( this%flag_age, count, mpi_integer, root, mpi_comm_world, ierr )
  call mpi_bcast( this%flag_metals, count, mpi_integer, root, mpi_comm_world, ierr )
  call mpi_bcast( this%flag_entr_ics, count, mpi_integer, root, mpi_comm_world, ierr )
#endif

end subroutine gadget_public_header_broadcast




end module gadget_public_header_class

!> \file update_particles.F90

!> \brief matches particles from one snapshot to the next
!<

module update_particles_mod
use myf03_mod
use gadget_public_input_mod
use gadget_cosmoBH_input_mod
use gadget_owls_input_mod
use gadget_vbromm_input_mod
use gadget_public_input_hdf5_mod
use global_mod, only: psys, GV
implicit none
private

public :: update_particles

contains

!> Reads in an update snapshot.  The idea is to keep the ionization fractions
!! and temperature from the already loaded snapshot while updating the 
!! positions, velocities, smoothing lengths ... from the snapshot on disk.
!! The particles are reordered during the raytracing so when a new snapshot
!! is readin they must be matched
!===========================================================================
subroutine update_particles()

  character(clen), parameter :: myname="update_particles" 
  logical, parameter :: crash=.true.

  integer(i4b), allocatable :: idold(:)
  real(r4b), allocatable :: Told(:)
  real(r4b), allocatable :: yeold(:)
  real(r4b), allocatable :: xHIold(:)
  real(r4b), allocatable :: xHIIold(:)

  real(r4b), allocatable :: xHeIold(:)
  real(r4b), allocatable :: xHeIIold(:)
  real(r4b), allocatable :: xHeIIIold(:)

  integer(i8b), allocatable :: lasthitold(:)
  integer(i8b), allocatable :: orderold(:)  

  integer(i8b) :: minIDold, minIDnew
  integer(i8b) :: maxIDold, maxIDnew

  integer(i8b) :: i, idnew, indx, err




  ! store carry over variables
  !==============================

  allocate( idold(size(psys%par)), stat=err)
  if (err /= 0) call myerr("failed to allocate IDold",myname,crash)     
  idold = psys%par%id
  minIDold = minval(idold)
  maxIDold = maxval(idold)

  allocate( Told(size(psys%par)), stat=err)
  if (err /= 0) call myerr("failed to allocate Told",myname,crash)     
  Told = psys%par%T

  allocate( yeold(size(psys%par)), stat=err)
  if (err /= 0) call myerr("failed to allocate yeold",myname,crash)     
  yeold = psys%par%ye

  allocate( xHIold(size(psys%par)), stat=err)
  if (err /= 0) call myerr("failed to allocate xHIold",myname,crash)     
  xHIold = psys%par%xHI

  allocate( xHIIold(size(psys%par)), stat=err)
  if (err /= 0) call myerr("failed to allocate xHIIold",myname,crash)     
  xHIIold = psys%par%xHII

#ifdef incHe
  allocate( xHeIold(size(psys%par)), stat=err)
  if (err /= 0) call myerr("failed to allocate xHeIold",myname,crash)     
  xHeIold = psys%par%xHeI

  allocate( xHeIIold(size(psys%par)), stat=err)
  if (err /= 0) call myerr("failed to allocate xHeIIold",myname,crash)     
  xHeIIold = psys%par%xHeII

  allocate( xHeIIIold(size(psys%par)), stat=err)
  if (err /= 0) call myerr("failed to allocate xHeIIIold",myname,crash)     
  xHeIIIold = psys%par%xHeIII
#else
  allocate( xHeIold(1), xHeIIold(1), xHeIIIold(1) )
#endif



  allocate( lasthitold(size(psys%par)), stat=err)
  if (err /= 0) call myerr("failed to allocate lasthitold",myname,crash)     
  lasthitold = psys%par%lasthit


  ! deallocate the current particle array and read new particle data
  !==================================================================
  deallocate( psys%par )
  if (GV%InputType == 1) then
     call read_Gpublic_particles()
  else if (GV%InputType == 2) then
     call read_GcosmoBH_particles()
  else if (GV%InputType == 3) then
     call read_Gowls_particles()
  else if (GV%InputType == 4) then
     call read_Gvbromm_particles()
  else if (GV%InputType == 5) then
     call read_Gpubhdf5_particles()
  end if
  minIDnew = minval(psys%par%id)
  maxIDnew = maxval(psys%par%id)


  ! match id's from new snapshot data to the old IDs
  !===================================================


  ! create an indexing array for the old particle array ID's
  ! ID's that are no longer present will be indexed with minIDold - 1
  !--------------------------------------------------------------------
  write(*,*) "creating indexing array for current particle system..."
  write(*,*) "min/max ID (old snap) = ", minIDold, maxIDold

  allocate( orderold(minIDold:maxIDold), stat=err)
  if (err/=0) call myerr("allocating orderold array",myname,crash)

  orderold = minIDold - 1
  do i = 1,size(idold)
     orderold(idold(i)) = i
  end do

  ! transfer all carryover variables
  !-----------------------------------
  do i = 1,size(psys%par)

     idnew = psys%par(i)%id   
     indx  = orderold(idnew)

     if ( idnew /= idold(indx) ) then
        write(*,*) "i,idnew,idold", i, idnew, idold(indx)
        if (err/=0) call myerr("reordering id error",myname,crash)
     end if

     if (.not. GV%FixSnapTemp) then
        psys%par(i)%T = Told(indx)
     end if

     psys%par(i)%ye   = yeold(indx) 
     psys%par(i)%xHI  = xHIold(indx)
     psys%par(i)%xHII = xHIIold(indx)

#ifdef incHe
     psys%par(i)%xHeI   = xHeIold(indx)
     psys%par(i)%xHeII  = xHeIIold(indx)
     psys%par(i)%xHeIII = xHeIIIold(indx)
#endif

     psys%par(i)%lasthit = lasthitold(indx)

  end do

  deallocate (idold, Told, yeold, xHIold, xHIIold, lasthitold, orderold)

  deallocate (xHeIold, xHeIIold, xHeIIIold)



end subroutine update_particles


end module update_particles_mod

!> \file bdf.F90

!> \brief the module for the photo backward difference solver.
!! this file contains the subroutines for updating particles
!! from photo ionizations, collisional ionizations, recombinations,
!! photo heating and atomic cooling.
!! the file bdf_np describes the routines to do the updates
!! without photo ionizations/heating.  
!<
module bdf_mod
use ionpar_mod
use cen_atomic_rates_mod
use atomic_rates_mod
use physical_constants_mod
use global_mod, only: rtable, isoT_k
implicit none

  integer(i8b), parameter :: MaxSteps = 50000000  !< maximum number of steps
  real(r8b), parameter :: ION_FAC = 0.01          !< ionization time factor
  real(r8b), parameter :: COOL_FAC = 0.01         !< cooling time factor
  real(r8b), parameter :: TIME_TOL = 0.001        !< fraction of time step to leave undone
 
  real(r8b), parameter :: zero = 0.0d0
  real(r8b), parameter :: one = 1.0d0
  real(r8b), parameter :: two = 2.0d0
  real(r8b), parameter :: three = 3.0d0

contains

!> this routine takes in the initial values in ipar 
!! {xHII,xHeII,xHeIII,T,pdep} and evolves the ionization particle
!! for a timestep ip%dt.  The final values are in the variables
!! ip%xHII, ip%xHeII, ip%xHeIII, ip%T, ip%pdeps
!========================================================================
subroutine bdfint(ip,scalls,photo,caseA,He,isoT,fixT)

  type(ionpart_type), intent(inout) :: ip !< ionization particle
  integer(i8b), intent(out) :: scalls !< number of runs through the solver
  logical, intent(in) :: photo   !< consider photo ionization / heating ?
  logical, intent(in) :: caseA(2)!< H/He case A recombinations ?
  logical, intent(in) :: He      !< consider Helium ?
  logical, intent(in) :: isoT    !< evolving temperature ? 
  logical, intent(in) :: fixT    !< fixed seperate temperature for each particle?

  type(atomic_rates_type) :: k
  real(r8b) :: t_tot
  real(r8b) :: dt2
  real(r8b) :: dt_i
  real(r8b) :: t_min
  integer(i8b) :: i
 
  ! check logicals
  !-------------------------------------------------------------------
  if (isoT .and. fixT) stop "isoT and fixT cant both be true"
  if (ip%dt_code <= zero) return


  ! initialize call counters and time variables
  !-------------------------------------------------------------------
  scalls = 0   
  t_tot = zero
  dt2 = ip%dt_s / two


  ! if constant temperature run, set constant atomic rates
  !-------------------------------------------------------------------
  if (isoT) then
     k = isoT_k
  end if

  if (fixT) then
     call get_atomic_rates(ip%T,rtable,k)
  end if


  ! do first round of calculations (only have xHI,xHeI,xHeII,nH,nHe)
  !-------------------------------------------------------------------
  ip%nHI  = ip%nH * ip%xHI
  ip%nHII = ip%nH * ip%xHII
  ip%ne = ip%nHII + ip%NeBckgnd

  if (He) then
     ip%nHeI   = ip%nHe * ip%xHeI
     ip%nHeII  = ip%nHe * ip%xHeII     
     ip%nHeIII = ip%nHe * ip%xHeIII
     ip%ne = ip%nHII + ip%nHeII + two * ip%nHeIII + ip%NeBckgnd
  else
      ip%nHeI = zero
      ip%nHeII = zero
      ip%nHeIII = zero
  end if

  if (photo) then
     call set_gammas(ip,He)
  else
     ip%gammaHI = zero
     ip%gammaHeI = zero
     ip%gammaHeII = zero
  end if


  ! begin sub-cycling steps
  !-------------------------------------------------------------------
  do i = 1,MaxSteps

     ip%iter = i


     ! calculate the cooling function
     !-------------------------------------------------------------------
     if (.not. isoT .and. .not. fixT) then
        ip%u = 1.5 * (ip%nH + ip%nHe + ip%ne) * k_erg_K * ip%T 
        call get_atomic_rates(ip%T,rtable,k)
        call set_cooling_func(ip,k,photo,caseA,He)
        if (photo) then
           ip%dudt = ip%COOLp
        else
           ip%dudt = ip%COOL
        end if
        ip%dTdt = two * ip%dudt / (three * (ip%nH + ip%nHe + ip%ne) * k_erg_K)
        if (abs(ip%dudt) > 0.0) then
           ip%tcool = abs(ip%u / ip%dudt)
        else
           ip%tcool = dt2
        endif
     end if


     ! calculate the time rate of change of the electron density
     !-------------------------------------------------------------------
     call set_ionization_func(ip,k,photo,caseA,He)
 
     call set_dnedt(ip,photo,caseA,He)
     if (abs(ip%dnedt) > 0.0) then
        ip%tion = abs(ip%ne / ip%dnedt)
     else
        ip%tion = dt2
     endif


     ! calculate the time step
     !-------------------------------------------------------------------
     if (isoT .or. fixT) then
        dt_i = ION_FAC * ip%tion
     else
        dt_i = min(ION_FAC * ip%tion, COOL_FAC * ip%tcool)
     end if
     
     if (dt_i > ip%dt_s - t_tot) dt_i = ip%dt_s - t_tot
     if (dt_i > dt2) dt_i = dt2


     ! take the time step
     !-------------------------------------------------------------------
     call take_bdf_ion_step(ip,k,dt_i,He)
     
     ip%strtag = "just after bdf_ion_step"
     call check_x(ip)


     if (.not. isoT .and. .not. fixT) then
        ip%T = ip%T + ip%dTdt * dt_i
        if (ip%T > 1.0d9) ip%T = 1.0d9
        if (ip%T < 1.0d0) ip%T = 1.0d0
        if ( .not. ip%T < 10.d0 .and. .not. ip%T >= 10.0d0 ) then
           call ionpar2screen(ip) 
           stop
        endif
     end if
        
     ! track photons, recombinations and update total time
     !-------------------------------------------------------------------

     !! photo ionizations

     if (photo) then
        ip%pdeps = ip%pdeps + ip%gammaHI * ip%HIcnt * dt_i
        if (He) then
           ip%pdeps = ip%pdeps + ip%gammaHeI  * ip%HeIcnt  * dt_i
           ip%pdeps = ip%pdeps + ip%gammaHeII * ip%HeIIcnt * dt_i
        end if
     end if


     !! time step

     t_tot = t_tot + dt_i
     t_min = huge(one)
     if (t_tot < t_min) t_min = t_tot
     if (abs(ip%dt_s - t_min) < TIME_TOL * ip%dt_s) exit
    
     if (i == MaxSteps) then
        write(*,*) " ************* BDF ERROR ************* "
        write(*,*) "finished ", MaxSteps, " little steps before "
        write(*,*) "completing large timestep.  "
        write(*,*) "t/dt = ", t_tot/dt_i, "rayn = ", ip%rayn
        write(*,*) "ipar = "
        call ionpar2screen(ip)
        write(*,*) " *************  bdf.f90  *************"
        stop
     end if

     scalls = scalls + 1
     if(photo) call set_gammas(ip,He)

  end do


  
end subroutine bdfint
 

!> this routine evolves the ionization fractions and possibly the 
!! temperature of the ionization particle forward in time by dt
!================================================================
subroutine take_bdf_ion_step(ip,k,dt,He)
use physical_constants_mod, only: k_erg_K

  type(ionpart_type), intent(inout) :: ip   !< ionization particle  
  type(atomic_rates_type), intent(in) :: k  !< rates
  real(r8b), intent(inout) :: dt                 !< time step
  logical, intent(in) :: He

  real(r8b) :: CC, DD
  real(r8b) :: nHIp, nHIIp, nep
  real(r8b) :: nHeIp, nHeIIp, nHeIIIp  
  real(r8b) :: mfac

  
  ! HI
  CC = ip%nHII * ip%ne * k%HIIrcB
  DD = ip%ne * k%HIci 
  DD = DD + ip%gammaHI
  nHIp = ( CC * dt + ip%nHI ) / (1.0d0 + DD * dt)

  ! HII
  CC = nHIp * ip%ne * k%HIci
  CC = CC + nHIp * ip%gammaHI
  DD = ip%ne * k%HIIrccB
  nHIIp = ( CC * dt + ip%nHII ) / (1.0d0 + DD * dt)


  if (He) then
    
     ! HeI
     CC = ip%nHeII * ip%ne * k%HeIIrcB
     DD = ip%ne * k%HeIci 
     DD = DD + ip%gammaHeI 
     nHeIp = ( CC * dt + ip%nHeI ) / (1.0d0 + DD * dt)
     
     ! HeII
     CC = (nHeIp * k%HeIci + ip%nHeIII * k%HeIIIrcB) * ip%ne
     DD = ip%ne * (k%HeIIrcB + k%HeIIci) 
     CC = CC + nHeIp * ip%gammaHeI
     DD = DD + ip%gammaHeII
     nHeIIp = ( CC * dt + ip%nHeII ) / (1.0d0 + DD * dt)
     
     ! HeIII
     CC = nHeIIp * ip%ne * k%HeIIci
     CC = CC + nHeIIp * ip%gammaHeII
     DD = ip%ne * k%HeIIIrcB
     nHeIIIp = ( CC * dt + ip%nHeIII ) / (1.0d0 + DD * dt)
     
  end if

  ! electrons
  CC = ip%gammaHI * nHIp    
  DD = k%HIIrcB   * nHIIp - k%HIci   * nHIp    

  if (He) then
     CC = CC &
          + ip%gammaHeI  * nHeIp   &
          + ip%gammaHeII * nHeIIp
     DD = DD &
          + k%HeIIrcB  * nHeIIp  - k%HeIci  * nHeIp   &
          + k%HeIIIrcB * nHeIIIp - k%HeIIci * nHeIIp
  end if

  nep   = ( CC * dt + ip%ne) / (1.0d0 + DD * dt)


  ! mass corrections

  mfac = ip%nH / (nHIp + nHIIp)
  ip%nHI  = nHIp  * mfac
  ip%nHII = nHIIp * mfac
  ip%xHI  = ip%nHI  / ip%nH
  ip%xHII = ip%nHII / ip%nH
  ip%ne = ip%nHII

  if (He) then
     mfac = ip%nHe / (nHeIp + nHeIIp + nHeIIIp)
     ip%nHeI   = nHeIp   * mfac
     ip%nHeII  = nHeIIp  * mfac
     ip%nHeIII = nHeIIIp * mfac
     ip%xHeI   = ip%nHeI   / ip%nHe
     ip%xHeII  = ip%nHeII  / ip%nHe
     ip%xHeIII = ip%nHeIII / ip%nHe
     ip%ne = ip%ne + ip%nHeII + 2.0d0 * ip%nHeIII
  end if

  ip%ne = ip%ne + ip%NeBckgnd

 
end subroutine take_bdf_ion_step

end module bdf_mod

!> \file euler.F90
 
!> \brief The module for the implicit euler solver.
!!
!<

module euler_mod
use ionpar_mod
use atomic_rates_mod
use physical_constants_mod
use global_mod, only: isoT_k, rtable

implicit none

  integer(i8b), parameter :: MaxSteps = 50000000 !< maximum number of steps
  real(r8b), parameter :: ION_FAC  = 1.0d-3      !< ionization time factor
  real(r8b), parameter :: COOL_FAC = 1.0d-3      !< cooling time factor
  real(r8b), parameter :: TIME_TOL = 1.0d-6      !< max frac. of step undone

  real(r8b), parameter :: zero = 0.0d0
  real(r8b), parameter :: one = 1.0d0
  real(r8b), parameter :: two = 2.0d0
  real(r8b), parameter :: three = 3.0d0
 
contains

!> this routine takes in the initial values in ipar 
!! {xHII,xHeII,xHeIII,T,pdep} and evolves the ionization particle
!! for a timestep ip%dt.  The final values are in the variables
!! ip%xHII, ip%xHeII, ip%xHeIII, ip%T, ip%pdeps
!========================================================================
subroutine eulerint(ip,scalls,photo,caseA,He,isoT,fixT)

  type(ionpart_type), intent(inout) :: ip !< ionization particle
  integer(i8b), intent(out) :: scalls !< number of runs through the solver
  logical, intent(in) :: photo   !< consider photo ionization / heating ?
  logical, intent(in) :: caseA(2)!< H/He case A recombinations ?
  logical, intent(in) :: He      !< consider Helium ?
  logical, intent(in) :: isoT    !< evolving temperature ? 
  logical, intent(in) :: fixT    !< fixed seperate temperature for each particle?

  real(r8b) :: xH(2)
  real(r8b) :: xHe(3)
  real(r8b) :: t_tot
  real(r8b) :: dt2
  real(r8b) :: dt_i
  real(r8b) :: t_min
  integer(i8b) :: i
  real(r8b) :: mfac
  type(atomic_rates_type) :: k

  ! initialize solver calls counter and time step
  !------------------------------------------------
  scalls = 0   
  t_tot  = zero
  dt2    = ip%dt_s / two

  ! if constant temperature run, set constant atomic rates
  !---------------------------------------------------------
  if (isoT .and. fixT) stop "isoT and fixT can't both be true"

  if (ip%dt_code.LE.0) return

  if (isoT) then
     k = isoT_k
  end if

  if (fixT) then
     call get_atomic_rates(ip%T,rtable,k)
  end if

  ! do first round of calculations (only have xHI,xHeI,xHeII,nH,nHe)
  !-------------------------------------------------------------------
  ip%nHI  = ip%nH * ip%xHI
  ip%nHII = ip%nH * ip%xHII
  ip%ne   = ip%nHII + ip%NeBckgnd

  if (He) then
     ip%nHeI   = ip%nHe * ip%xHeI
     ip%nHeII  = ip%nHe * ip%xHeII     
     ip%nHeIII = ip%nHe * ip%xHeIII
     ip%ne = ip%nHII + ip%nHeII + two * ip%nHeIII + ip%NeBckgnd
  else
     ip%nHeI = zero
     ip%nHeII = zero
     ip%nHeIII = zero
  end if

  if (photo) then
     call set_gammas(ip,He)
  else
     ip%gammaHI   = zero
     ip%gammaHeI  = zero
     ip%gammaHeII = zero
  end if

!---------------------------------------------------------  
  
  do i = 1,MaxSteps

     ip%iter = i

     !----------------------------------------------------------  
     ! calculate the cooling function
     if (.not. isoT .and. .not. fixT) then
        ip%u = 1.5 * (ip%nH + ip%nHe + ip%ne) * k_erg_K * ip%T 
        call get_atomic_rates(ip%T,rtable,k)
        call set_cooling_func(ip,k,photo,caseA,He)
        if (photo) then
           ip%dudt = ip%COOLp
        else
           ip%dudt = ip%COOL
        end if
        ip%dTdt = two * ip%dudt / (three * (ip%nH + ip%nHe + ip%ne) * k_erg_K)
        if (abs(ip%dudt) > 0.0) then
           ip%tcool = abs(ip%u / ip%dudt)
        else
           ip%tcool = dt2
        endif
     end if


     !----------------------------------------------------------  
     ! calculate the time rate of change of the electron density
     call set_ionization_func(ip,k,photo,caseA,He)
     call setDH(ip,photo,caseA(1))
     if (He) call setDHe(ip,photo,caseA(2))
     call set_dnedt(ip,photo,caseA,He)
     if (abs(ip%dnedt) > 0.0) then
        ip%tion = abs(ip%ne / ip%dnedt)
     else
        ip%tion = dt2
     endif


     !----------------------------------------------------------  
     ! calculate the time step
     if (isoT .or. fixT) then
        dt_i = ION_FAC * ip%tion
     else
        dt_i = min(ION_FAC * ip%tion, COOL_FAC * ip%tcool)
     end if
     
     if (dt_i > ip%dt_s - t_tot) dt_i = ip%dt_s - t_tot
     if (dt_i > dt2) dt_i = dt2

     !----------------------------------------------------------  
     ! take the time step

     xH(1) = ip%xHI
     xH(2) = ip%xHII
     xHe(1) = ip%xHeI
     xHe(2) = ip%xHeII
     xHe(3) = ip%xHeIII

     if (He) then
        call take_euler_ion_step(xH,ip%DH,dt_i,xHe,ip%DHe)
     else
        call take_euler_ion_step(xH,ip%DH,dt_i)
     end if

     ip%xHI  = xH(1)
     ip%xHII = xH(2)
     ip%xHeI   = xHe(1)
     ip%xHeII  = xHe(2)
     ip%xHeIII = xHe(3)

!     ip%strtag = "just after euler_ion_step"
!     call check_x(ip)

     !----------------------------------------------------------  
     ! do mass conservation

     mfac = one / (ip%xHI + ip%xHII)
     ip%xHI = ip%xHI * mfac
     ip%xHII = ip%xHII * mfac

     if (He) then
        mfac = one / (ip%xHeI + ip%xHeII + ip%xHeIII)
        ip%xHeI   = ip%xHeI   * mfac
        ip%xHeII  = ip%xHeII  * mfac
        ip%xHeIII = ip%xHeIII * mfac
     end if

     ip%strtag = "just after mass correction"
     call check_x(ip)


     ip%nHI  = ip%nH * ip%xHI
     ip%nHII = ip%nH * ip%xHII
     ip%ne   = ip%nHII + ip%NeBckgnd
 
     if (He) then
        ip%nHeI   = ip%nHe * ip%xHeI
        ip%nHeII  = ip%nHe * ip%xHeII
        ip%nHeIII = ip%nHe * ip%xHeIII
        ip%ne = ip%nHII + ip%nHeII + two * ip%nHeIII + ip%NeBckgnd
     end if


     if (.not. isoT .and. .not. fixT) then
        ip%T = ip%T + ip%dTdt * dt_i
        if (ip%T > 1.0d9) ip%T = 1.0d9
        if (ip%T < 1.0d0) ip%T = 1.0d0
!        write(*,*) "isoT,fixT", isoT,fixT
!        write(*,*) "no one is supposed to be here"
!        stop
!        ip%u = 1.5d0 * (ip%nH + ip%nHe + ip%ne) * k_erg_K * ip%T
!        call take_euler_temp_step(ip,dt_i)
     end if


     !----------------------------------------------------------  
     ! track photons, recombinations and update total time

     ! photo ionizations

     if (photo) then
        ip%pdeps = ip%pdeps + ip%gammaHI * ip%HIcnt * dt_i
        if (He) then
           ip%pdeps = ip%pdeps + ip%gammaHeI  * ip%HeIcnt  * dt_i
           ip%pdeps = ip%pdeps + ip%gammaHeII * ip%HeIIcnt * dt_i
        end if
     end if


     ! time step

     t_tot = t_tot + dt_i
     t_min = huge(one)
     if (t_tot < t_min) t_min = t_tot
     if (abs(ip%dt_s - t_min) < TIME_TOL * ip%dt_s) exit
    
     if (i == MaxSteps) then
        write(*,*) " ************* EULER ERROR ************* "
        write(*,*) "finished ", MaxSteps, " little steps before "
        write(*,*) "completing large timestep.  "
        write(*,*) "t/dt = ", t_tot/dt_i, "rayn = ", ip%rayn
        write(*,*) "ipar = "
        call ionpar2screen(ip)
        write(*,*) " *************  euler.f90  *************"
        stop
     end if

     scalls = scalls + 1
     if(photo) call set_gammas(ip,He)

  end do

  
end subroutine eulerint
 

!> this routine takes in the initial values in ipar 
!! {xHII,xHeII,xHeIII,T,pdep} and simply deposits recombination 
!! photons based on the optical depth.  The final values are in the variables
!! ip%xHII, ip%xHeII, ip%xHeIII, ip%T, ip%pdeps
!========================================================================
subroutine recombeulerint(ip,scalls)


  real(r8b), parameter :: TAU_TOL = 1.0e-4

  type(ionpart_type), intent(inout) :: ip !< ionization particle
  integer(i8b), intent(out) :: scalls !< number of runs through the solver
 
  scalls = 0   

! warning about the following:
  if (ip%dt_code.LE.0) return

!---------------------------------------------------------
! set initial number and ionization fractions

  ip%nHII = ip%nH * ip%xHII
  ip%nHI  = ip%nH - ip%nHII
  ip%xHI  = ip%nHI / ip%nH
  ip%ne = ip%nHII + ip%NeBckgnd
#ifdef incHe
  ip%nHeIII = ip%nHe * ip%xHeIII
  ip%nHeII  = ip%nHe * ip%xHeII
  ip%nHeI   = ip%nHe - ip%nHeIII - ip%nHeII
  ip%xHeI  = ip%nHeI / ip%nHe
  ip%ne = ip%nHII + ip%nHeII + 2.0 * ip%nHeIII + ip%NeBckgnd
#endif  

!---------------------------------------------------------
! simlple count of atoms that are absorbing photons

  ip%HIcnt = ip%Hcnt * ( ip%nHI / ip%nH )       ! N HI atoms
  ip%Allcnt = ip%HIcnt
#ifdef incHe
  ip%HeIcnt = ip%Hecnt * ( ip%nHeI / ip%nHe )   ! N HeI atoms
  ip%HeIIcnt = ip%Hecnt * ( ip%nHeII / ip%nHe ) ! N HeII atoms
  if (ip%penrg .GE. HeI_th_erg) then
     ip%Allcnt = ip%HIcnt + ip%HeIcnt
  else if (ip%penrg .GE. HeII_th_erg) then
     ip%Allcnt = ip%HIcnt + ip%HeIcnt + ip%HeIIcnt
  end if
#endif  

!---------------------------------------------------------
! optical depths

  ip%tauHI = ip%cdfac * ip%HIcnt * ip%sigmaHI
  ip%tausum = ip%tauHI
  if (ip%tauHI .LT. TAU_TOL) then
     ip%HItaufac = ip%tauHI
  else
     ip%HItaufac = 1.0 - exp(-ip%tauHI)
  end if
  ip%taufacsum = ip%HItaufac  

#ifdef incHe
  ip%tauHeI = ip%cdfac * ip%HeIcnt * ip%sigmaHeI
  ip%tauHeII = ip%cdfac * ip%HeIIcnt * ip%sigmaHeII
  ip%tausum = ip%tauHI + ip%tauHeI + ip%tauHeII 
  if (ip%tauHeI .LT. TAU_TOL) then
     ip%HeItaufac = ip%tauHeI
  else
     ip%HeItaufac = 1.0 - exp(-ip%tauHeI)
  end if
  if (ip%tauHeII .LT. TAU_TOL) then
     ip%HeIItaufac = ip%tauHeII
  else
     ip%HeIItaufac = 1.0 - exp(-ip%tauHeII)
  end if
  ip%taufacsum = ip%HItaufac + ip%HeItaufac + ip%HeIItaufac
#endif 

!---------------------------------------------------------
! deposit photons

  ip%fracabsorb = 1.0d0 - exp(-ip%tausum)

  ip%pdeps = ip%pflux * ip%fracabsorb


  ! if more photons going in then absorbers
  if (ip%pdeps >= ip%HIcnt) then
     ip%pdeps = ip%HIcnt
     ip%xHII = 1.0d0
     ip%xHI = 0.0d0
  else
     ip%xHII = ip%xHII + ip%pdeps / ip%Hcnt
     ip%xHI = 1.0d0 - ip%xHII
  end if

  scalls = scalls + 1
     
  
end subroutine recombeulerint




!> construct derivative matrices
!================================



!> this routine evolves the ionization fractions forward in time by dt
!======================================================================
subroutine take_euler_ion_step(xH,DH,dt,xHe,DHe)

  real(r8b), intent(inout) :: xH(2)
  real(r8b), intent(in) :: DH(2,2)
  real(r8b), intent(in) :: dt
  real(r8b), intent(inout), optional :: xHe(3)
  real(r8b), intent(in), optional :: DHe(3,3)

  real(r8b) :: MH(2,2)
  real(r8b) :: MHe(3,3)

  MH = invertDH(DH,dt)
  xH = matmul(MH,xH)

  if ( present(xHe) .and. present(DHe) ) then

     MHe = invertDHe(DHe,dt)
     xHe = matmul(MHe,xHe)

  end if
  
end subroutine take_euler_ion_step


!> inverts the Hydrogen derivative matrix (actually 1 + DH*dt)
!======================================================================
function invertDH(DH,dt) result(MH)

  real(r8b), parameter :: one = 1.0d0
  real(r8b) :: DH(2,2)
  real(r8b) :: dt
  real(r8b) :: MH(2,2)

  real(r8b) :: GG,RR,detH

  GG = DH(2,1)
  RR = DH(1,2)

  detH = one + ( RR + GG ) * dt

  MH(1,1) = one + RR * dt
  MH(2,1) = GG * dt
  MH(1,2) = RR * dt
  MH(2,2) = one + GG * dt

  MH = MH / detH

end function invertDH

!> inverts the Helium derivative matrix (actually 1 + DHe*dt)
!======================================================================
function invertDHe(DHe,dt) result(MHe)

  real(r8b), parameter :: one = 1.0d0
  real(r8b) :: DHe(3,3)
  real(r8b) :: dt
  real(r8b) :: MHe(3,3)

  real(r8b) :: GGI,GGII,RRII,RRIII,detHe

  GGI   = DHe(2,1)
  GGII  = DHe(3,2)
  RRII  = DHe(1,2)
  RRIII = DHe(2,3)

  detHe = one + (GGI + GGII + RRII + RRIII) * dt + &
          (GGI * GGII + GGI * RRIII + RRII * RRIII) * (dt*dt)

  MHe(1,1) = one + dt * (GGII + RRII + RRIII + dt * RRII * RRIII)  
  MHe(2,1) = dt * GGI * (one + dt * RRIII)
  MHe(3,1) = dt * dt * GGI * GGII
  
  MHe(1,2) = dt * RRII * (one + dt * RRIII)
  MHe(2,2) = (one + GGI * dt) * (one + dt * RRIII)
  MHe(3,2) = dt * (one + dt * GGI) * GGII

  MHe(1,3) = dt * dt * RRII * RRIII
  MHe(2,3) = dt * (one + dt * GGI) * RRIII
  MHe(3,3) = one + dt * (GGI + GGII + (dt * GGI * GGII) + RRII)

  MHe = MHe / detHe

end function invertDHe



end module euler_mod

!> \file sphpar.F90

!> \brief module for determining smoothing lengths of particles
!<

module sphpar_mod
use myf03_mod
use particle_system_mod, only: particle_type
use particle_system_mod, only: transformation_type

!---------------------------------
!> local particle type. 
  type sphpar_type

     real(r4b)    :: pos(3)     !< x,y,z coordinates

#ifdef incVel
     real(r4b)    :: vel(3)
#endif

     integer(i4b) :: id         !< particle id
     real(r4b)    :: mass       !< particle mass
     real(r4b)    :: T          !< temperature in K       
     real(r4b)    :: rho        !< density 
     real(r4b)    :: ye         !< electron fraction
     real(r4b)    :: xHI        !< nHI/nH 
     real(r4b)    :: xHII       !< * nHII/nH
     real(r4b)    :: hsml       !< smoothing length
     
#ifdef incCloudy
     real(r4b)    :: xHI_cloudy !< cloudy eq solutions
#endif
     
#ifdef incHmf   
     real(r4b)    :: Hmf        !< Hydrogen mass fraction
#endif

#ifdef incHe
     real(r4b)    :: xHeI
     real(r4b)    :: xHeII
     real(r4b)    :: xHeIII
#endif
     
#ifdef incHemf
     real(r4b)    :: Hemf       !< Helium mass fraction
#endif
     
#ifdef outGammaHI
     real(r4b)    :: gammaHI    !< * time averaged HI photoionization rate
     real(r4b)    :: time       !< * elapsed time in seconds - reset at outputs
#endif
     
     integer(i8b) :: lasthit    !< * indx of last ray to cross this particle
     
     integer(i4b) :: nnb     !< number of SPH neighbors
     real(r4b)    :: gradrho(3) !< vector gradient of the density
     real(r4b)    :: drhodh     !< derivative of rho wrt to h
     real(r4b)    :: fi         !< used for finding smoothing length
     real(r4b)    :: dfi        !< used for finding smoothing length

 end type sphpar_type

contains

!-----------------------------------------------------------------------
!> creates a transormed sph particle from an input particle
  subroutine par2sphpar(sphpar,par,pt)
    type(sphpar_type) :: sphpar  !< output sphpar
    type(particle_type) :: par   !< input particle
    type(transformation_type),optional :: pt  !< possible transformation

    sphpar%pos = par%pos

#ifdef incVel
    sphpar%vel = par%vel
#endif

    sphpar%id = par%id
    sphpar%mass = par%mass
    sphpar%T = par%T 
    sphpar%rho = par%rho
    sphpar%ye = par%ye
    sphpar%xHI = par%xHI
    sphpar%xHII = par%xHII
    sphpar%hsml = par%hsml

#ifdef incCloudy
    sphpar%xHI_cloudy = par%xHI_cloudy
#endif

#ifdef incHmf
    sphpar%Hmf = par%Hmf
#endif

#ifdef incHe
    sphpar%xHeI = par%xHeI
    sphpar%xHeII = par%xHeII
    sphpar%xHeIII = par%xHeIII
#endif

#ifdef incHemf
    sphpar%Hemf = par%Hemf
#endif

#ifdef outGammaHI
    sphpar%gammaHI = par%gammaHI
    sphpar%time = par%time
#endif

    sphpar%lasthit = par%lasthit

    if(present(pt)) sphpar%pos=pt%fac*(par%pos-pt%shift)

  end subroutine par2sphpar


end module sphpar_mod

!> \file global.F90

!> \brief the module that handles global variables
!<
module global_mod
use myf03_mod 
use gadget_general_class
use gadget_sphray_header_class
use ray_mod
use raylist_mod
use particle_system_mod, only: particle_system_type
use oct_tree_mod, only: oct_tree_type
use atomic_rates_mod, only: atomic_rates_table_type
use atomic_rates_mod, only: atomic_rates_type
implicit none


!> snapshot information type. 
!==============================
type snap_info_type
   real(r8b)    :: TimeAt            !< t at snapshot
   real(r8b)    :: ScalefacAt        !< scale factor at snapshot
   real(r8b)    :: TimeToNext        !< TimeAt(n+1) - TimeAt(n)
   real(r8b)    :: RunTime           !< duration to trace snapshot
   real(r8b)    :: StartTime         !< t0 for tracing snapshot 
   integer(i8b) :: RaysFromSrcHeader !< rays listed in source header
   integer(i8b) :: SrcRays           !< rays to trace for snapshot
end type snap_info_type


!> run planning type.
!======================
type run_planning_type  
   type(snap_info_type), allocatable :: snap(:) !< snap information
   real(r8b), allocatable :: OutputTimes(:)     !< times to make outputs 
end type run_planning_type


! global variables
!=====================
type(particle_system_type) :: psys        !< particles + sources + box
type(raylist_type) :: globalraylist       !< ray/particle intersections
type(oct_tree_type) :: tree               !< octree

type(atomic_rates_table_type) :: rtable   !< rates read in from file
type(atomic_rates_type) :: isoT_k         !< static rates for iso-temperature run
type(atomic_rates_type) :: cmbT_k         !< static rates for cmb-temperature
type(atomic_rates_type) :: xHII_k         !< static rates for xHII-temperature 

type(run_planning_type) :: PLAN           !< run plan

type(gadget_sphray_header_type), allocatable :: saved_gheads(:,:) !< all headers (nsnaps,nfiles)


 
!> global variables type. 
!=========================
type global_variables_type


  ! these are read in directly from the config file
  !-------------------------------------------------

   integer(i4b)    :: Verbosity           !< [Config File] 0=silent, 1=whisper, 2=talk, 3=debug

   logical         :: DoTestScenario      !< [Config File] set true if performing a test problem
   character(clen) :: TestScenario        !< [Config File] one of {iliev_test1, iliev_test2, iliev_test3, iliev_test4}

   logical         :: JustInit            !< [Config File] set true to stop after initialization
   logical         :: Comoving            !< [Config File] set true if values to be read are in comoving coords

   real(r8b)       :: IsoTemp             !< [Config File] if > zero all pars fixed @ IsoTemp (FixSnapTemp must be F)
   logical         :: FixSnapTemp         !< [Config File] if T, fix temp at snapshot values (IsoTemp must be <= 0)

   real(r8b)       :: EOStemp             !< [Config File] if non-negative, initialize EOS particles w/ T = EOStemp 
   real(r8b)       :: InitxHI             !< [Config File] if non-negative, all xHI initialized to this value
   logical         :: RayDepletion        !< [Config File] remove photons from rays as they travel?

   integer(i8b)    :: IntSeed             !< [Config File] seed for mersenne twister

   real(r8b)       :: StaticFieldSimTime  !< [Config File] sim time for single snapshot jobs
   character(clen) :: StaticSimTimeUnit   !< [Config File] one of {codetime,myr}


   integer(i4b)    :: InputType           !< [Config File] one of Gadget {1: Public 2: CosmoBH 3: OWLS/GIMIC 4: V.Bromm 5: Public HDF5}
   character(clen) :: SnapPath            !< [Config File] dir where particle snapshots are
   character(clen) :: SourcePath          !< [Config File] dir where source snapshots are


   character(clen) :: SpectraFile         !< [Config File] file containing spectra tables
   character(clen) :: b2cdFile            !< [Config File] file containing b2cd tables
   character(clen) :: AtomicRatesFile     !< [Config File] file containnig atomic rates tables

   character(clen) :: ParFileBase         !< [Config File] particle snapshot file base
   character(clen) :: SourceFileBase      !< [Config File] source snapshot file base

   integer(i4b)    :: StartSnapNum        !< [Config File] snapshot to start with
   integer(i4b)    :: EndSnapNum          !< [Config File] snapshot to end with

   integer(i4b)    :: ParFilesPerSnap     !< [Config File] files per particle snapshot
   integer(i4b)    :: SourceFilesPerSnap  !< [Config File] files per source snapshot


   character(clen) :: RayScheme           !< [Config File] one of {raynum, header}
   real(r8b)       :: ForcedRayNumber     !< [Config File] number of rays to trace if RayScheme = raynum

   logical         :: RayStats            !< [Config File] T = massive output file on ray statistics in raystats.dat
   integer(i4b)    :: BndryCond           !< [Config File] one of {-1:reflecting 0:vacuum 1:periodic}

   real(r8b)       :: RayPhotonTol        !< [Config File] fractional ray depletion to stop ray
   real(r8b)       :: MaxRayDist          !< [Config File] max ray distance in physical code units, negative=default
   
   logical         :: HydrogenCaseA       !< [Config File] T = use case A for Hydrogen Recombinations
   logical         :: HeliumCaseA         !< [Config File] T = use case A for Helium Recombinsations

   integer(i4b)    :: IonTempSolver       !< [Config File] one of {1:euler, 2:bdf}

   real(r8b)       :: Tfloor              !< [Config File] minimum allowed temperature
   real(r8b)       :: Tceiling            !< [Config File] maximum allowed temperature

   real(r8b)       :: xfloor              !< [Config File] minimum allowed ionization fraction
   real(r8b)       :: xceiling            !< [Config File] maximum allowed ionization fraction

   real(r8b)       :: NeBackground        !< [Config File] constant background electron number density from metals
   integer(i8b)    :: NraysUpdateNoHits   !< [Config File] update all pars not hit by a ray in last NraysUpdateNoHits

   real(r8b)       :: H_mf                !< [Config File] hydrogen mass fraction
   real(r8b)       :: He_mf               !< [Config File] helium mass fraction

   character(clen) :: OutputDir           !< [Config File] path to output directory
   character(clen) :: OutputFileBase      !< [Config File] output file base

   integer(i4b)    :: OutputType          !< [Config File] one of {1:Standard Binary Gadget 2:HDF5 Gadget}

   character(clen) :: OutputTiming        !< [Config File] one of {standard, forced}
   integer(i4b)    :: NumStdOuts          !< [Config File] if OutputTiming = "standard", # of outputs (maybe +1 initial)

   logical         :: DoInitialOutput     !< [Config File] produces output before any raytracing
   integer(i8b)    :: IonFracOutRays      !< [Config File] do mini output every IonFracOutRays src rays

   character(clen) :: ForcedOutFile       !< [Config File] file with forced output times
   character(clen) :: ForcedUnits         !< [Config File] one of {codetime, myr, mwionfrac, vwionfrac}

   integer(i4b)    :: PartPerCell         !< [Config File] minimum particles in a tree leaf

   character(clen) :: config_file         !< name of the config file

   logical         :: DoMomentumKicks         !< [Config File] if T, calc momentum kicks - update vel if present

   ! particle and source sizes
   !-----------------------------------------------------------
   integer(i4b) :: bytesperpar  !< bytes per particle
   integer(i4b) :: bytespersrc  !< bytes per source
   real(r8b) :: MB              !< tracks memory consumption


   ! these are all set in get_planning_data in main_input.f90
   !-----------------------------------------------------------
   integer(i4b) :: Nsnaps !< snap count (particle=source)

   real(r8b) :: cgs_len   !< code length [cm/h]
   real(r8b) :: cgs_mass  !< code mass [g/h]
   real(r8b) :: cgs_vel   !< code velocity [cm/s] 

   real(r8b) :: cgs_time  !< code time [s/h]
   real(r8b) :: cgs_rho   !< code density [g/cm^3 h^2]
   real(r8b) :: cgs_prs   !< code pressure [dyne/cm^2 h^2]
   real(r8b) :: cgs_enrg  !< code energy [ergs/h]
   real(r8b) :: Lunit     !< code source luminosity unit [photons/s]

   real(r8b) :: LenFac_cm  !< code (input) length -> cm = cgs_len * a / h
   real(r8b) :: MassFac_g  !< code (input) mass -> g = cgs_mass / h
   real(r8b) :: TimeFac_s  !< code (input) time -> s = cgs_time / h

   real(r8b) :: OmegaM    !< matter / critical density z=0
   real(r8b) :: OmegaB    !< baryon / critical density z=0
   real(r8b) :: OmegaL    !< lambda / critical density z=0
   real(r8b) :: LittleH   !< Hubble parameter z=0 in units of 100 km/s/Mpc

   ! these are set in do_output_planning and do_ray_planning in intialize.f90
   !--------------------------------------------------------------------------
   integer(i4b) :: OutputIndx                     !< keeps track of outputs   
   real(r8b)    :: TotalSimTime                   !< total time to ray trace
   integer(i4b) :: NumTotOuts                     !< total outputs to do
 

   ! these should be reset each time a new snapshot is read in
   !------------------------------------------------------------
   integer(i8b) :: itime           !< integer time. measures ticks from start time

   real(r8b) :: start_time_code    !< starting time in code units
   real(r8b) :: start_time_s       !< starting time in seconds
   real(r8b) :: start_time_myr     !< starting time in Myr

   real(r8b) :: time_elapsed_code  !< elapsed time in code units
   real(r8b) :: time_elapsed_s     !< elapsed time in seconds
   real(r8b) :: time_elapsed_myr   !< elapsed time in Myr 

   real(r8b) :: dt_code            !< one tick in code units
   real(r8b) :: dt_s               !< one tick in seconds
   real(r8b) :: dt_myr             !< one tick in Myr

   real(r8b) :: BoxLwrs(3)         !< input coords [code] of lower x,y,z corner
   real(r8b) :: BoxUprs(3)         !< input coords [code] of upper x,y,z corner

   real(r8b) :: total_mass         !< summed mass of all particles in a snapshot
   real(r8b) :: total_lum          !< summed luminosity of sources in a snapshot
   real(r8b) :: total_atoms        !< sum of all atoms in computational volume
   real(r8b) :: total_photons      !< sum of all photons to be released
   real(r8b) :: Tcmb_cur           !< CMB temperature for the current snapshot

   real(r8b) :: sf_gamma_eos       !< index for polytropic equation of state for star forming gas.

   real(r8b) :: UVB_gammaHI_cloudy !< magnitude of UVB from cloudy ionization table
   
   ! these are updated continuosly while the code runs 
   ! and most are initialized in initialize.f90
   !----------------------------------------------------
   character(clen) :: ionfrac_file !< file where mini outputs are put 
   integer(i4b) :: ionlun          !< lun for ionfrac log file

   character(clen) :: raystat_file !< file where ray stats are put
   integer(i4b) :: raystatlun      !< lun for ray stat log file

   character(clen) :: pardata_file !< file with particle data summaries
   integer(i4b) :: pardatalun      !< lun for particle data log file
   
   character(clen) :: srcdata_file !< file with source data summaries
   integer(i4b) :: srcdatalun      !< lun for source data log file

   character(clen) :: rayplan_file  !< file for ray planning
   integer(i4b) :: rayplanlun      !< lun for ray planning file

   character(clen) :: outplan_file  !< file for out planning
   integer(i4b) :: outplanlun      !< lun for out planning file

   integer(i4b) :: CurSnapNum      !< current snapshot number
   integer(i8b) :: rayn            !< current ray number (src + recomb)
   integer(i8b) :: src_rayn        !< current source ray number

   real(r8b) :: nwionfrac          !< number weighted ionization fraction
   real(r8b) :: mwionfrac          !< mass weighted ionization fraction
   real(r8b) :: vwionfrac          !< volume weighted ionization fraction

   real(r8b) :: TotalSourceRaysCast    !< total rays traced from user def. sources
   real(r8b) :: TotalDiffuseRaysCast   !< total recombination rays traced
   real(r8b) :: IonizingPhotonsPerSec  !< ionizing photons emitted per second
   real(r8b) :: TotalPhotonsCast       !< total number of photons emitted
   real(r8b) :: TotalPhotonsAbsorbed   !< total number of photons absorbed
   real(r8b) :: PhotonsLeavingBox      !< total photons leaving the box
   real(r8b) :: TotalIonizations       !< total number of photoionizations
   real(r8b) :: TotalRecombinations    !< total number of recombinations
   
   real(r8b) :: PeakUpdates            !< max updates for a single particle
   real(r8b) :: AverageUpdatesPerPar   !< average number of updates per particle
   real(r8b) :: ParticleCrossings      !< number of ray / particle intersections
   real(r8b) :: TotalDerivativeCalls   !< times the solver being used has run
   
end type global_variables_type
 

type(global_variables_type) :: GV           !< global variables          



contains


subroutine set_dt_from_dtcode( GV )
  type(global_variables_type), intent(inout) :: GV
  type(gadget_constants_type) :: gconst

  GV%dt_s    = GV%dt_code * GV%cgs_time / GV%LittleH 
  GV%dt_myr  = GV%dt_s / gconst%sec_per_megayear

  print*,'********'
  print*,GV%dt_code
  print*,GV%dt_s
  print*,GV%dt_myr
  print*,'********'

end subroutine set_dt_from_dtcode



subroutine set_time_elapsed_from_itime( GV )
  type(global_variables_type), intent(inout) :: GV

  GV%time_elapsed_code = GV%itime * GV%dt_code
  GV%time_elapsed_s    = GV%itime * GV%dt_s
  GV%time_elapsed_myr  = GV%itime * GV%dt_myr

end subroutine set_time_elapsed_from_itime




end module global_mod

!> \file gadget_owls_input.F90

!> \brief Handles readin of GADGET OWLS/GIMIC HDF5 formatted files
!<

module gadget_owls_input_mod
use myf03_mod
use gadget_general_class
use gadget_public_header_class
use gadget_owls_header_class
use gadget_sphray_header_class
use particle_system_mod
use ion_table_class

use atomic_rates_mod, only: calc_colion_eq_fits
use global_mod, only: psys, PLAN, GV
use global_mod, only: saved_gheads

#ifdef useHDF5
use hdf5_wrapper
#endif

implicit none
private


public :: get_planning_data_gadget_owls
public :: read_Gowls_particles


contains

#ifndef useHDF5

! these are dummy subroutines so that the calls outside this file
! dont have to be wrapped with pre processor macros.

subroutine get_planning_data_gadget_owls()
  logical :: crash = .true.
  call myerr("this routine shuold not have been called","hdf5dummy",crash)
end subroutine get_planning_data_gadget_owls

subroutine read_Gowls_particles()
  logical :: crash = .true.
  call myerr("this routine shuold not have been called","hdf5dummy",crash)
end subroutine read_Gowls_particles



#else



!>   gets run planning data from Gadget OWLS/GIMIC Headers
!============================================================
subroutine get_planning_data_gadget_owls()

  character(clen), parameter :: myname = 'get_planning_data_gadget_owls_hdf5'
  logical, parameter :: crash = .true.
  integer, parameter :: verb = 2

  type(gadget_owls_header_type) :: ghead
  type(gadget_units_type) :: gunits
  type(gadget_constants_type) :: gconst

  integer(i4b) :: iSnap, fSnap    ! initial and final snapshot numbers
  integer(i4b) :: pfiles          ! files/snap for particles    
  integer(i4b) :: i,j             ! counters
  character(clen) :: snapfile     ! snapshot file name

  integer(i4b) :: loglun
  character(clen) :: logfile
 
  ! open up the planning data log file
  !======================================================
  logfile = trim(GV%OutputDir) // "/" // "particle_headers.log"
  call open_formatted_file_w(logfile,loglun)

  
  ! these global variables are read from the config file
  !======================================================
  iSnap  = GV%StartSnapNum
  fSnap  = GV%EndSnapNum    
  pfiles = GV%ParFilesPerSnap

  if ( allocated(saved_gheads) ) deallocate(saved_gheads)
  allocate( saved_gheads(iSnap:fSnap, 0:pfiles-1) )

  ! set global units and read constants
  !===================================================
  call form_gadget_snapshot_file_name(GV%SnapPath,GV%ParFileBase,iSnap,0,snapfile,hdf5bool=.true.)
  call gadget_constants_read_file( gconst, snapfile )
  call gadget_units_read_file( gunits, snapfile )
!  call gconst%read_Gowls_constants_file(snapfile)
!  call gunits%read_Gowls_units_file(snapfile)
  GV%cgs_len  = gunits%cgs_length
  GV%cgs_mass = gunits%cgs_mass
  GV%cgs_vel  = gunits%cgs_velocity
  GV%cgs_time = gunits%cgs_time
  GV%cgs_rho  = gunits%cgs_density
  GV%cgs_prs  = gunits%cgs_pressure
  GV%cgs_enrg = gunits%cgs_energy

  ! read all particle headers and write to log file
  !===================================================
  write(loglun,'(A)') "reading all GADGET OWLS/GIMIC particle header(s) ... "
  do i = iSnap,fSnap
     do j = 0,pfiles-1

        call form_gadget_snapshot_file_name(GV%SnapPath,GV%ParFileBase,i,j,snapfile,hdf5bool=.true.)
        write(loglun,'(I3,"  ",A)') i,trim(snapfile)

        call gadget_owls_header_read_file( ghead, snapfile )
        call gadget_owls_header_print_lun( ghead, loglun )
        call gadget_sphray_header_copy_owls( saved_gheads(i,j), ghead )

!        call ghead%read_Gowls_header_file(snapfile)
!        call ghead%print_Gowls_header_lun(loglun)
!        call saved_gheads(i,j)%copy_Gowls_header(ghead)

        ! make sure there is gas in this snapshot
        if (.not. ghead%npar_all(0) > 0) then
           write(*,*) "Gadget snapshot does not contain any gas particles"
           write(*,*) "Sphray cannot read dark matter particles directly, "
           write(*,*) "please calculate smoothing lengths for these particles"
           write(*,*) "and write them as gas particles. "
           stop
        end if
        
        PLAN%snap(i)%ScalefacAt = ghead%a
        PLAN%snap(i)%TimeAt = ghead%time_gyr * (gconst%SEC_PER_MEGAYEAR * 1.0d3) ! in seconds
        PLAN%snap(i)%TimeAt = PLAN%snap(i)%TimeAt * GV%LittleH / GV%cgs_time ! in code units
        
     end do
  end do

  ! close headers log file
  !========================
  close(loglun)

  ! use one header to set global variables
  !--------------------------------------------
  GV%BoxLwrs(:) = 0.0d0
  GV%BoxUprs(:) = saved_gheads(iSnap,0)%boxlen
  
  GV%OmegaM = saved_gheads(iSnap,0)%OmegaM
  GV%OmegaL = saved_gheads(iSnap,0)%OmegaL
  GV%OmegaB = saved_gheads(iSnap,0)%OmegaB 
  
  GV%LittleH = saved_gheads(iSnap,0)%h
  
  ! write units to log file
  !===================================================

  logfile = trim(GV%OutputDir) // "/" // "code_units.log"
  call open_formatted_file_w(logfile,loglun)
  call gadget_units_print_lun( gunits, loglun, saved_gheads(iSnap,0)%h ) 
  close(loglun)

end subroutine get_planning_data_gadget_owls







!> reads a Gadget OWLS/GIMIC HDF5 snapshot into a particle array  
!========================================================================
subroutine read_Gowls_particles()

  character(clen), parameter :: myname="read_Gowls_particles" 
  logical, parameter :: crash=.true.
  integer, parameter :: verb=2
  character(clen) :: str,fmt
  
  real(r4b), allocatable :: rblck(:)
  real(r4b), allocatable :: rblck3(:,:)
  integer(i4b), allocatable :: iblck(:)
  integer(i8b) :: ngasread

  type(gadget_owls_header_type) :: ghead
  type(gadget_sphray_header_type) :: shead
  character(clen) :: snapfile, VarName, GroupName
  integer(i4b) :: fh
  integer(i8b) :: i
  integer(i4b) :: err

  integer(i8b) :: npar, ngas, nmass
  integer(i8b) :: npar1, ngas1, nmass1
  logical :: varmass(0:5)
  integer(i4b) :: fn

  real(r8b) :: meanweight
  logical :: caseA(2)
  real(r8b) :: MB

  real(r8b) :: Tdum
  real(r8b) :: Hmf
  real(r8b) :: nH8
  real(r8b) :: T8
  real(r8b) :: xvec(5)

  type(gadget_constants_type) :: gconst
  type(ion_table_type) :: itab
  real(r8b) :: redshift

  logical :: hdf5bool

  ! set hdf5 boolean
  !======================================================
  hdf5bool = .true.

  ! set local particle numbers
  !============================
  shead = saved_gheads( GV%CurSnapNum, 0 )
  varmass = (shead%npar_all > 0 .and. shead%mass == 0)
  npar = sum(shead%npar_all)
  ngas = shead%npar_all(0)
  nmass = sum(shead%npar_all, mask=varmass)


  ! do Gadget dummy checks
  !============================
  if (ngas == 0) call myerr("snapshot has no gas particles",myname,crash)

  ! calculate bytes per particle and allocate particle array
  !===========================================================
  MB = GV%bytesperpar * real(ngas) / 2.0d0**20
  GV%MB = GV%MB + MB

  fmt="(A,F10.4,A,I10,A)"
  write(str,fmt) "   allocating ", MB, " MB for ", ngas, " particles"
  call mywrite(str,verb) 

  allocate (psys%par(ngas), stat=err)
  if (err /= 0) call myerr("failed to allocate par",myname,crash)


  ! now read all snapshot files
  !==============================          
  ngasread = 0
  GroupName = 'PartType0/'
  files: do fn = 0, shead%nfiles-1


     ! recall the header info
     !-----------------------------------------------------------!  
     shead   = saved_gheads( GV%CurSnapNum, fn )
     varmass = (shead%npar_file > 0 .and. shead%mass == 0)
     npar1   = sum(shead%npar_file)
     ngas1   = shead%npar_file(0)
     nmass1  = sum(shead%npar_file, mask=varmass)
     if (ngas1 == 0) cycle


     ! begin read
     !-----------------------------------------------------------!  
     call form_gadget_snapshot_file_name(GV%SnapPath,GV%ParFileBase,GV%CurSnapNum,fn,snapfile,hdf5bool)
     call mywrite("   reading particle snapshot file: "//trim(snapfile), verb)
     call hdf5_open_file(fh, snapfile, readonly=.true.)
     call gadget_owls_header_read_lun(ghead,fh)



     ! read positions 
     !-----------------------------------------------------------!  
     allocate(rblck3(3,ngas1), stat=err)
     if(err/=0) call myerr("allocating rblck3 for pos",myname,crash)
     VarName = 'Coordinates'
     call hdf5_read_data(fh,trim(GroupName)//trim(VarName),rblck3)
     forall(i=1:ngas1) psys%par(ngasread+i)%pos(1) = rblck3(1,i)
     forall(i=1:ngas1) psys%par(ngasread+i)%pos(2) = rblck3(2,i)
     forall(i=1:ngas1) psys%par(ngasread+i)%pos(3) = rblck3(3,i)
     deallocate(rblck3)
     call gadget_data_attributes_read_lun( pos_attrs, fh, GroupName, VarName )



     ! read velocities 
     !-----------------------------------------------------------!  
#ifdef incVel
     allocate(rblck3(3,ngas1), stat=err)
     if(err/=0) call myerr("allocating rblck3 for vel",myname,crash)
     VarName = 'Velocity'
     call hdf5_read_data(fh,trim(GroupName)//trim(VarName),rblck3)
     forall(i=1:ngas1) psys%par(ngasread+i)%vel(1) = rblck3(1,i)
     forall(i=1:ngas1) psys%par(ngasread+i)%vel(2) = rblck3(2,i)
     forall(i=1:ngas1) psys%par(ngasread+i)%vel(3) = rblck3(3,i)
     deallocate(rblck3)
     call gadget_data_attributes_read_lun( vel_attrs, fh, GroupName, VarName )
!     call vel_attrs%read_lun( fh, GroupName, VarName )
#endif

     ! read id's 
     !-----------------------------------------------------------!  
     allocate(iblck(ngas1), stat=err )
     if(err/=0) call myerr("allocating iblck for ID",myname,crash)
     VarName = 'ParticleIDs'
     call hdf5_read_data(fh,trim(GroupName)//trim(VarName),iblck)
     forall(i=1:ngas1) psys%par(ngasread+i)%id = iblck(i)
     deallocate(iblck)
     call gadget_data_attributes_read_lun( id_attrs, fh, GroupName, VarName ) 
!    call id_attrs%read_lun( fh, GroupName, VarName )

     ! read masses 
     !-----------------------------------------------------------!  

     ! if gas particles are variable mass
     if (varmass(0)) then  
        allocate(rblck(ngas1), stat=err)
        if(err/=0) call myerr("allocating rblck for mass",myname,crash)
        VarName = 'Mass'
        call hdf5_read_data(fh,trim(GroupName)//trim(VarName),rblck)
        forall(i=1:ngas1) psys%par(ngasread+i)%mass = rblck(i)
        deallocate(rblck)
        call gadget_data_attributes_read_lun( mass_attrs, fh, GroupName, VarName ) 
!       call mass_attrs%read_lun( fh, GroupName, VarName )

     ! if gas particles are isomass
     else
        psys%par(ngasread+1:ngasread+ngas1)%mass = ghead%mass(0)       
     end if


     ! read temperature
     !-----------------------------------------------------------!  
     allocate(rblck(ngas1), stat=err)
     if(err/=0) call myerr("allocating rblck for T",myname,crash)
     VarName = 'Temperature'
     call hdf5_read_data(fh,trim(GroupName)//trim(VarName),rblck)
     forall(i=1:ngas1) psys%par(ngasread+i)%T = rblck(i)
     deallocate(rblck)
     call gadget_data_attributes_read_lun( T_attrs, fh, GroupName, VarName )
!     call T_attrs%read_lun( fh, GroupName, VarName ) 

     ! read EOS
     !-----------------------------------------------------------!  
#ifdef incEOS
     allocate(rblck(ngas1), stat=err)
     if(err/=0) call myerr("allocating rblck for EOS",myname,crash)
     VarName = 'OnEquationOfState'
     call hdf5_read_data(fh,trim(GroupName)//trim(VarName),rblck)
     forall(i=1:ngas1) psys%par(ngasread+i)%eos = rblck(i)
     deallocate(rblck)
     call gadget_data_attributes_read_lun( eos_attrs, fh, GroupName, VarName )
!     call eos_attrs%read_lun( fh, GroupName, VarName )
#endif

     ! read density 
     !-----------------------------------------------------------!  
     allocate(rblck(ngas1), stat=err)
     if(err/=0) call myerr("allocating rblck for rho",myname,crash)
     VarName = 'Density'
     call hdf5_read_data(fh,trim(GroupName)//trim(VarName),rblck)
     forall(i=1:ngas1) psys%par(ngasread+i)%rho = rblck(i)
     deallocate(rblck)
     call gadget_data_attributes_read_lun( rho_attrs, fh, GroupName, VarName ) 
!    call rho_attrs%read_lun( fh, GroupName, VarName )

     ! read smoothing lengths 
     !-----------------------------------------------------------!  
     allocate(rblck(ngas1), stat=err)
     if(err/=0) call myerr("allocating rblck for hsml",myname,crash)
     VarName = 'SmoothingLength'
     call hdf5_read_data(fh,trim(GroupName)//trim(VarName),rblck)
     forall(i=1:ngas1) psys%par(ngasread+i)%hsml = rblck(i)
     deallocate(rblck)
     call gadget_data_attributes_read_lun( hsml_attrs, fh, GroupName, VarName )
!     call hsml_attrs%read_lun( fh, GroupName, VarName )

     ! read Hydrogen mass fractions
     !-----------------------------------------------------------!  
#ifdef incHmf
     allocate(rblck(ngas1), stat=err)
     if(err/=0) call myerr("allocating rblck for Hmf",myname,crash)
     VarName = 'ElementAbundance/Hydrogen'
     call hdf5_read_data(fh,trim(GroupName)//trim(VarName),rblck)
     forall(i=1:ngas1) psys%par(ngasread+i)%Hmf = rblck(i)
     deallocate(rblck)
     call gadget_data_attributes_read_lun( Hmf_attrs, fh, GroupName, VarName )
!     call Hmf_attrs%read_lun( fh, GroupName, VarName )
#endif


     ! read Helium mass fractions
     !-----------------------------------------------------------!  
#ifdef incHemf
     allocate(rblck(ngas1), stat=err)
     if(err/=0) call myerr("allocating rblck for Hemf",myname,crash)
     VarName = 'ElementAbundance/Helium'
     call hdf5_read_data(fh,trim(GroupName)//trim(VarName),rblck)
     forall(i=1:ngas1) psys%par(ngasread+i)%Hemf = rblck(i)
     deallocate(rblck)
     call gadget_data_attributes_read_lun( Hemf_attrs, fh, GroupName, VarName )
!     call Hemf_attrs%read_lun( fh, GroupName, VarName )
#endif


     ngasread = ngasread + ngas1
     call hdf5_close_file(fh)


  end do files


  ! set caseA true or false for collisional equilibrium
  !-----------------------------------------------------
  caseA = .false.
  if (GV%HydrogenCaseA) caseA(1) = .true.
  if (GV%HeliumCaseA)   caseA(2) = .true.


  ! calculate xHI from CLOUDY iontables
  !-----------------------------------------------------------!  
  call mywrite('',verb) 
  call mywrite("   calculating input xHI from CLOUDY tables",verb)

  call read_ion_table_file( "../data/ionization_tables/h1.hdf5", itab )
  redshift = ghead%z

  ! first get the gammaHI from the uniform UVB at this redshift
  GV%UVB_gammaHI_cloudy = return_gammaHI_at_z( itab, redshift )

 
  ! loop through the gas particles and interpolate from the table
  !---------------------------------------------------------------
  do i = 1,ngas

     ! set individual Hydrogen mass fractions if we have them
#ifdef incHmf
     Hmf = psys%par(i)%Hmf
#else
     Hmf = GV%H_mf
#endif


     ! get Hydrogen number density and temperature
     nH8 = psys%par(i)%rho * GV%cgs_rho * ghead%h**2 / ghead%a**3 * &
           Hmf / gconst%PROTONMASS
     T8 = psys%par(i)%T

     ! if we have EOS particles set their temperature if we need to
#ifdef incEOS
     if (psys%par(i)%eos > 0.0) then
        if (GV%EOStemp > 0.0) then
           T8 = GV%EOStemp
           psys%par(i)%T = T8
        endif
     endif
#endif

     psys%par(i)%xHI = &
          interpolate_ion_table( itab, redshift, log10(T8), log10(nH8) )
     
  end do



#ifdef incCloudy
  psys%par(:)%xHI_cloudy = psys%par(:)%xHI
  fmt = "(T7, A, 2ES15.5)"
  write(str,fmt) "min/max xHI_cloudy = ", minval( psys%par%xHI_cloudy ), maxval( psys%par%xHI_cloudy )
  call mywrite(str,verb) 
#endif
  call mywrite('',verb)

  

  ! set xHII from xHI 
  !-----------------------------------------------------------!  
  psys%par%xHII = 1.0d0 - psys%par%xHI



  ! if Helium, initialize ionization fractions to collisional equilibrium
  !------------------------------------------------------------------------
#ifdef incHe
  call psys%set_ci_eq(caseA, DoH=.false., DoHe=.true., fit="hui")
#endif


  ! set the electron fractions from the ionization fractions
  !----------------------------------------------------------
  call particle_system_set_ye( psys, GV%H_mf, GV%He_mf, GV%NeBackground )



end subroutine read_Gowls_particles




#endif


end module gadget_owls_input_mod

!> \file particle_system.F90

!> \brief Particles, sources, and box, types and subroutines.
!! 
!<

module particle_system_mod
use myf03_mod
use atomic_rates_mod, only: calc_colion_eq_fits
use mt19937_mod, only: genrand_real1
use m_mrgrnk, only: mrgrnk
implicit none
private

public :: particle_type
public :: particle_copy
public :: particle_transform
public :: particle_set_ye
public :: particle_set_ci_eq

public :: box_type
public :: box_adjust

public :: source_type

public :: particle_system_type
public :: particle_system_scale_comoving_to_physical
public :: particle_system_scale_physical_to_comoving
public :: particle_system_create_particle_random_access_list
public :: particle_system_create_particle_density_access_list
public :: particle_system_order_particles
public :: particle_system_mean_xHII_number_weight
public :: particle_system_mean_xHII_mass_weight
public :: particle_system_mean_xHII_volume_weight
public :: particle_system_set_ye
public :: particle_system_set_ci_eq
public :: particle_system_enforce_x_and_T_minmax
public :: particle_system_print_lun

public :: transformation_type
public :: return_bytes_per_particle
public :: return_bytes_per_source


!> Particle type. 
!=========================
type particle_type

   real(r4b)    :: pos(3)     !< x,y,z coordinates
   integer(i4b) :: id         !< particle id
   real(r4b)    :: mass       !< particle mass
   real(r4b)    :: T          !< temperature in K       
   real(r4b)    :: rho        !< density 
   real(r4b)    :: ye         !< electron fraction
   real(r4b)    :: xHI        !< nHI/nH 
   real(r4b)    :: xHII       !< nHII/nH
   real(r4b)    :: hsml       !< smoothing length
   integer(i8b) :: lasthit    !< indx of last ray to cross this particle

#ifdef incHeat
   real(r4b)   ::  dinternalEdt  !< !< constant external heating rate (per unit mass - units cgs_vel**2/t)
#endif

#ifdef incVel
   real(r4b)    :: vel(3)     !< x,y,z velocities
#endif

#ifdef incCloudy
   real(r4b)    :: xHI_cloudy !< cloudy eq solutions
#endif

#ifdef incHmf   
   real(r4b)    :: Hmf        !< Hydrogen mass fraction
#endif

#ifdef incHe
   real(r4b)    :: xHeI       !< nHeI/nHe 
   real(r4b)    :: xHeII      !< nHeII/nHe
   real(r4b)    :: xHeIII     !< nHeIII/nHe
#endif

#ifdef incHemf
   real(r4b)    :: Hemf       !< Helium mass fraction
#endif

#ifdef outGammaHI
   real(r4b)    :: gammaHI    !< time averaged HI photoionization rate
   real(r4b)    :: time       !< elapsed time in seconds - reset at outputs
#endif

#ifdef incEOS
   real(r4b)    :: eos        !< equation of state variable 
#endif

#ifdef incSFR
   real(r4b)    :: sfr        !< star formation rate
#endif

end type particle_type



!> source type
!================
type source_type

   integer(i4b) :: id        !< id added for AMUSE
   
   real(r4b)    :: pos(3)    !< x,y,z coordinates

#ifdef incVel
   real(r4b)    :: vel(3)    !< x,y,z velocities
#endif

   real(r4b)    :: L         !< luminosity
   real(r4b)    :: SpcType   !< spectral type
   integer(i4b) :: EmisPrf   !< emission profile
   real(r4b)    :: Lcdf      !< relates this luminosity to the other sources
   integer(i8b) :: lastemit  !< last ray emitted from this source
end type source_type



!> simulation box and boundary conditions
!==========================================
type box_type
   real(r8b)    :: tops(1:3)    !< upper x,y,z coordinates [code]
   real(r8b)    :: bots(1:3)    !< lower x,y,z coordinates [code]
   real(r8b)    :: lens(1:3)    !< side lengths [code] (xf-xi,yf-yi,zf-zi)
   real(r8b)    :: lens_cm(1:3) !< side lengths [cm] (xf-xi,yf-yi,zf-zi)
   real(r8b)    :: vol          !< box volume [code] (xlen*ylen*zlen)
   real(r8b)    :: vol_cm       !< box volume [cm^3] (xlen*ylen*zlen) 

   integer(i8b) :: bbound(1:3)  !< BCs for upper faces (0:vac 1:per -1:ref) 
   integer(i8b) :: tbound(1:3)  !< BCs for lower faces (0:vac 1:per -1:ref) 
end type box_type



!> particles, sources, and box
!=========================================
  type particle_system_type
     type(box_type) :: box                          !< the simulation box     
     type(particle_type), allocatable :: par(:)     !< all particles
     type(source_type), allocatable :: src(:)       !< all sources
     integer(i4b), allocatable :: acc_list(:)       !< access list
  end type particle_system_type


!> transformation type
!=======================
type transformation_type
   integer(i8b) :: fac(1:3)  !< newpos = fac * (oldpos - shift)
   real(i8b) :: shift(1:3)   !< newpos = fac * (oldpos - shift)
end type transformation_type





contains



!!============================================
!!
!!    BOX
!!
!!============================================

!> resets the box limits where the BCs are vacuum
!==================================================================
subroutine box_adjust(box,bot,top)
  type(box_type), intent(inout) :: box !< input box
  real(r4b), intent(in) :: bot(3)       !< new bottoms
  real(r4b), intent(in) :: top(3)       !< new tops
  where (box%bbound==0) box%bots = bot
  where (box%tbound==0) box%tops = top
end subroutine box_adjust




!!============================================
!!
!!    PARTICLE
!!
!!============================================


!> creates a copy of a particle
!============================================================
function particle_copy(this) result(copy)
  type(particle_type), intent(in) :: this  !< input particle
  type(particle_type) :: copy               !< particle copy
  copy = this
end function particle_copy


!> transforms a  particle 
!============================================================
subroutine particle_transform(this, transform)
  type(particle_type), intent(inout) :: this        !< input particle
  type(transformation_type), intent(in) :: transform !< transformation
  this%pos = transform%fac * (this%pos - transform%shift)
end subroutine particle_transform


!> set electron fraction, ye=ne/nH from ionization fractions
!==============================================================
subroutine particle_set_ye(par, dfltH_mf, dfltHe_mf, ne_bckgnd)

  type(particle_type) :: par
  real(r8b), intent(in) :: dfltH_mf
  real(r8b), intent(in) :: dfltHe_mf
  real(r8b), intent(in) :: ne_bckgnd
  integer(i8b) :: i
  real(r8b) :: Hmf
  real(r8b) :: Hemf
  real(r8b) :: nHe_over_nH
  
  par%ye = par%xHII + ne_bckgnd
  
#ifdef incHe
  
#ifdef incHmf
  Hmf = par%Hmf
#else
  Hmf = dfltH_mf
#endif
  
#ifdef incHemf
  Hemf = par%Hemf
#else
  Hemf = dfltHe_mf
#endif
  
  nHe_over_nH = 0.25d0 * Hemf / Hmf
  par%ye = par%ye + ( par%xHeII + 2.0d0 * par%xHeIII ) * nHe_over_nH
  
#endif
  
  
end subroutine particle_set_ye


!> sets ionization fractions to their collisional equilibrium values
!======================================================================
subroutine particle_set_ci_eq(par, caseA, DoH, DoHe, fit)

  type(particle_type) :: par
  logical, intent(in) :: caseA(2)   !< 1st slot for H, 2nd for He  
  logical, intent(in) :: DoH        !< set Hydrogen?
  logical, intent(in) :: DoHe       !< set Helium?
  character(*), intent(in) :: fit   !< one of ['hui','cen']
  real(r8b) :: T                    !< 8 byte temperature
  real(r8b) :: xvec(5)              !< [xHI,xHII,xHeI,xHeII,xHeIII]

  T = par%T
  call calc_colion_eq_fits(fit, T, caseA, xvec)

  if (DoH) then
     par%xHI = xvec(1)
     par%xHII = xvec(2)
  endif
  if (DoHe) then
#ifdef incHe
     par%xHeI = xvec(3)
     par%xHeII = xvec(4)
     par%xHeIII = xvec(5)
#else
     write(*,*) 
     write(*,*) 'In particle_set_ci_eq'
     write(*,*) 'DoHe = .true. but incHe macro not defined in Makefile'
     stop
#endif
  endif

end subroutine particle_set_ci_eq








!> figures out how many bytes of RAM are needed per particle
!========================================================================
function return_bytes_per_particle() result(bpp)
  integer(i4b)  :: bpp   !< bytes per particle

  bpp = 12       ! positions
  bpp = bpp + 4  ! ID
  bpp = bpp + 4  ! mass
  bpp = bpp + 4  ! temperature
  bpp = bpp + 4  ! rho
  bpp = bpp + 4  ! ye
  bpp = bpp + 8  ! H ionization fractions
  bpp = bpp + 4  ! hsml
  bpp = bpp + 8  ! last hit index

#ifdef incHeat
  bpp = bpp + 4 ! heating  
#endif


#ifdef incVel
  bpp = bpp + 12 ! velocities  
#endif

#ifdef incCloudy
  bpp = bpp + 4  ! cloudy table xHI
#endif

#ifdef incHmf
  bpp = bpp + 4  ! H mass fraction
#endif

#ifdef incHe
  bpp = bpp + 12 ! He ionization fractions
#endif

#ifdef incHemf
  bpp = bpp + 4  ! He mass fraction
#endif

#ifdef outGammaHI
  bpp = bpp + 4  ! GammaHI tracking
  bpp = bpp + 4  ! time var
#endif

#ifdef incEOS
  bpp = bpp + 4  ! Equation of State variable
#endif

#ifdef incSFR
  bpp = bpp + 4  ! Star formation rate
#endif

end function return_bytes_per_particle



!> figures out how many bytes of RAM are needed per source
!========================================================================
function return_bytes_per_source() result(bps)
  integer(i4b)  :: bps   !< bytes per source

  bps = 12       ! positions
  bps = bps + 4  ! luminosity
  bps = bps + 4  ! spectral type
  bps = bps + 4  ! emission profile
  bps = bps + 4  ! luminosity cumulative distribution function
  bps = bps + 8  ! last emit index

#ifdef incVel
  bps = bps + 12 ! velocities  
#endif

end function return_bytes_per_source








!!============================================
!!
!!    PARTICLE SYSTEM
!!
!!============================================

!> scales particles, sources, and the box from comoving to physical values.
! velocity is taken from Gadget code value to peculiar. 
!==========================================================================
subroutine particle_system_scale_comoving_to_physical(this, a, h)

  character(clen), parameter :: myname="scale_comoving_to_physical"
  integer, parameter :: verb=2
  character(clen) :: str,fmt

  type(particle_system_type) :: this
  real(r8b), intent(in) :: a    !< scale factor
  real(r8b), intent(in) :: h    !< hubble parameter (little h)

  call mywrite("   scaling comoving to physical coordinates", verb)
  fmt = "(A,F12.5,T22,A,T25,F12.5)"
  write(str,fmt) "   a = ", a, "h = ", h
  call mywrite(str,verb)

  ! particles
  !------------------------------------------------
  this%par%pos(1) = this%par%pos(1) * a / h
  this%par%pos(2) = this%par%pos(2) * a / h
  this%par%pos(3) = this%par%pos(3) * a / h

! heating ignored atm (fip 20120829)

#ifdef incVel
  this%par%vel(1) = this%par%vel(1) * sqrt(a) 
  this%par%vel(2) = this%par%vel(2) * sqrt(a) 
  this%par%vel(3) = this%par%vel(3) * sqrt(a) 
#endif

  this%par%mass = this%par%mass / h
  this%par%hsml = this%par%hsml * a / h
  this%par%rho  = ( this%par%rho / (a*a*a) ) * (h*h)

  ! sources
  !------------------------------------------------
  this%src%pos(1) = this%src%pos(1) * a / h
  this%src%pos(2) = this%src%pos(2) * a / h
  this%src%pos(3) = this%src%pos(3) * a / h

#ifdef incVel
  this%src%vel(1) = this%src%vel(1) * sqrt(a) 
  this%src%vel(2) = this%src%vel(2) * sqrt(a)
  this%src%vel(3) = this%src%vel(3) * sqrt(a)
#endif

  ! box
  !------------------------------------------------
  this%box%tops = this%box%tops * a / h
  this%box%bots = this%box%bots * a / h
  
  this%box%lens    = this%box%lens * a / h
  this%box%lens_cm = this%box%lens_cm * a / h
  
  this%box%vol    = product( this%box%lens )
  this%box%vol_cm = product( this%box%lens_cm )
  

end subroutine particle_system_scale_comoving_to_physical


!> scales particles, sources, and the box from physical to comoving values.
! velocity is taken from peculiar to Gadget code value. 
!==========================================================================
subroutine particle_system_scale_physical_to_comoving(this, a, h)

  character(clen), parameter :: myname="scale_physical_to_comoving"
  integer, parameter :: verb=2
  character(clen) :: str,fmt

  type(particle_system_type) :: this
  real(r8b), intent(in) :: a   !< scale factor 
  real(r8b), intent(in) :: h   !< hubble parameter (little h)

  call mywrite("   scaling physical to comoving coordinates", verb)
  fmt = "(A,F12.5,T22,A,T25,F12.5)"
  write(str,fmt) "   a = ", a, "h = ", h
  call mywrite(str,verb)

  ! particles
  !------------------------------------------------
  this%par%pos(1) = this%par%pos(1) / a * h
  this%par%pos(2) = this%par%pos(2) / a * h
  this%par%pos(3) = this%par%pos(3) / a * h

! heating ignored atm (fip 20120829)

#ifdef incVel
  this%par%vel(1) = this%par%vel(1) / sqrt(a)
  this%par%vel(2) = this%par%vel(2) / sqrt(a)
  this%par%vel(3) = this%par%vel(3) / sqrt(a)
#endif

  this%par%mass = this%par%mass * h
  this%par%hsml = this%par%hsml / a * h
  this%par%rho = this%par%rho * (a*a*a) / (h*h)

  ! sources
  !------------------------------------------------
  this%src%pos(1) = this%src%pos(1) / a * h
  this%src%pos(2) = this%src%pos(2) / a * h
  this%src%pos(3) = this%src%pos(3) / a * h

#ifdef incVel
  this%src%vel(1) = this%src%vel(1) / sqrt(a)
  this%src%vel(2) = this%src%vel(2) / sqrt(a)
  this%src%vel(3) = this%src%vel(3) / sqrt(a)
#endif

  ! box
  !------------------------------------------------
  this%box%tops = this%box%tops / a * h
  this%box%bots = this%box%bots / a * h
  
  this%box%lens    = this%box%lens / a * h
  this%box%lens_cm = this%box%lens_cm / a * h
  
  this%box%vol    = product( this%box%lens )
  this%box%vol_cm = product( this%box%lens_cm )


end subroutine particle_system_scale_physical_to_comoving



!> allows for accessing the particles in a random order
!------------------------------------------------------
subroutine particle_system_create_particle_random_access_list( psys )
  type(particle_system_type) :: psys

  integer(i4b) :: i
  integer(i4b) :: n
  real(r4b), allocatable :: randoms(:)

  n = size( psys%par )
  if (.not. allocated(psys%acc_list) ) allocate( psys%acc_list(n) )
  allocate( randoms(n) )

  do i = 1, size(randoms)
     randoms(i) = genrand_real1()
  end do
  
  call mrgrnk( randoms, psys%acc_list )

  deallocate( randoms )


end subroutine particle_system_create_particle_random_access_list



!> allows for accessing the particles from least to most dense
!--------------------------------------------------------------
subroutine particle_system_create_particle_density_access_list( psys )
  type(particle_system_type) :: psys

  integer(i4b) :: i
  integer(i4b) :: n
  real(r4b), allocatable :: rhos(:)

  n = size( psys%par )
  if (.not. allocated(psys%acc_list) ) allocate( psys%acc_list(n) )
  allocate( rhos(n) )

  do i = 1,n     
     rhos(i) = psys%par(i)%rho
  end do
  call mrgrnk( rhos, psys%acc_list )
  
  deallocate( rhos )

end subroutine particle_system_create_particle_density_access_list


! this routine rearranges the particles in the particle system so that 
! they are stored in the sequence given by the array order.  For example
! order = [3,1,2] takes the third particle to the first position, the first 
! particle to the second position, and the second particle to the third 
! position.  the array order is not preserved during the routine

!> reorders the particles according to the array order
!===========================================================================
subroutine particle_system_order_particles(this, order)
  type(particle_system_type), intent(inout) :: this !< input particle system
  integer(i4b), intent(inout) :: order(:)  !< desired order

  type(particle_type) :: par
  integer(i8b) :: i
  integer(i8b) :: goal
  integer(i8b) :: npar
  
  if (size(this%par) /= size(order)) stop "size(this%par) /= size(order)"
  npar = size(this%par)
  
  do i=1,npar 
     par=this%par(i)
     goal=order(i)
     do while(goal < i)
        goal=order(goal)
        order(i)=goal
     enddo
     this%par(i)=this%par(goal)
     this%par(goal)=par 
  enddo
  do i=1,npar
     order(i)=i
  enddo

end subroutine particle_system_order_particles


!> calculates the number weighted mean value of xHII
!========================================================================
function particle_system_mean_xHII_number_weight(this) result(numionfrac)
  type(particle_system_type), intent(in) :: this !< input particle system  
  real(r8b) :: numionfrac !< number weighted global ionization fraction
  integer :: i
     
  numionfrac = 0.0d0
  do i = 1,size(this%par)
     numionfrac = numionfrac + this%par(i)%xHII
  end do
  numionfrac = numionfrac / size(this%par)
  
end function particle_system_mean_xHII_number_weight
   
   
!> calculates the mass weighted mean value of xHII
!========================================================
function particle_system_mean_xHII_mass_weight(this, DfltH_mf) result(massionfrac)
  type(particle_system_type), intent(in) :: this !< input particle system  
  real(r8b) :: DfltH_mf     !< H_mf if we dont have a value for each par     
  real(r8b) :: massionfrac  !< ion fraction m weighted
  real(r8b) :: masstot      !< total volume
  real(r8b) :: Hmf          !< Hydrogen mass fraction
  integer :: i
  
  massionfrac = 0.0d0
  masstot = 0.0d0
  do i = 1,size(this%par)
#ifdef incHmf
     Hmf = this%par(i)%Hmf
#else
     Hmf = dfltH_mf
#endif
     massionfrac = massionfrac + this%par(i)%mass * Hmf * this%par(i)%xHII
     masstot = masstot + this%par(i)%mass * Hmf
  end do
  massionfrac = massionfrac / masstot
  
end function particle_system_mean_xHII_mass_weight

  
!> calculates the volume weighted mean of xHII
!========================================================
function particle_system_mean_xHII_volume_weight(this) result(volionfrac)
  type(particle_system_type), intent(in) :: this !< input particle system  
  real(r8b) :: volionfrac                    !< ion fraction v weighted
  real(r8b) :: voltot                        !< total volume
  real(r8b) :: h3                            !< hsml^3
  integer :: i
  
  volionfrac = 0.0d0
  voltot = 0.0d0
  do i = 1,size(this%par)
     h3 = this%par(i)%hsml * this%par(i)%hsml * this%par(i)%hsml
     volionfrac = volionfrac + h3 * this%par(i)%xHII
     voltot = voltot + h3
  end do
  volionfrac = volionfrac / voltot
  
end function particle_system_mean_xHII_volume_weight


!> set electron fraction, ye=ne/nH from ionization fractions
!==============================================================
subroutine particle_system_set_ye(psys, dfltH_mf, dfltHe_mf, ne_bckgnd)

  type(particle_system_type) :: psys
  real(r8b), intent(in) :: dfltH_mf
  real(r8b), intent(in) :: dfltHe_mf
  real(r8b), intent(in) :: ne_bckgnd
  integer(i8b) :: i

  do i = 1,size(psys%par)
     call particle_set_ye( psys%par(i), dfltH_mf, dfltHe_mf, ne_bckgnd)
  end do

end subroutine particle_system_set_ye


!> sets ionization fractions to their collisional equilibrium values
!======================================================================
subroutine particle_system_set_ci_eq(psys, caseA, DoH, DoHe, fit)

  type(particle_system_type) :: psys
  logical, intent(in) :: caseA(2)   !<  1st slot for H, 2nd for He  
  logical, intent(in) :: DoH        !<  set Hydrogen?
  logical, intent(in) :: DoHe       !<  set Helium?
  character(*), intent(in) :: fit   !< one of ['hui','cen']
  real(r8b) :: T                    !< 8 byte temperature
  real(r8b) :: xvec(5)              !< [xHI,xHII,xHeI,xHeII,xHeIII]
  integer(i8b) :: i
  
  do i = 1, size(psys%par)
     call particle_set_ci_eq( psys%par(i), caseA, DoH, DoHe, fit )
  end do

end subroutine particle_system_set_ci_eq



!> enforces a minimum and maximum value on the ionization fractions 
!! and temperatures
!=============================================================================
subroutine particle_system_enforce_x_and_T_minmax(psys,xmin,xmax,tmin,tmax)

  type(particle_system_type), intent(inout) :: psys !< inout particle system
  real(r8b), intent(in) :: xmin, xmax, tmin, tmax
  integer(i8b) :: i

  do i = 1,size(psys%par)
     if (psys%par(i)%xHI < xmin) psys%par(i)%xHI = xmin
     if (psys%par(i)%xHI > xmax) psys%par(i)%xHI = xmax
     if (psys%par(i)%xHII < xmin) psys%par(i)%xHII = xmin
     if (psys%par(i)%xHII > xmax) psys%par(i)%xHII = xmax
#ifdef incHe
     if (psys%par(i)%xHeI < xmin) psys%par(i)%xHeI = xmin
     if (psys%par(i)%xHeII < xmin) psys%par(i)%xHeII = xmin
     if (psys%par(i)%xHeIII < xmin) psys%par(i)%xHeIII = xmin
     if (psys%par(i)%xHeI > xmax) psys%par(i)%xHeI = xmax
     if (psys%par(i)%xHeII > xmax) psys%par(i)%xHeII = xmax
     if (psys%par(i)%xHeIII > xmax) psys%par(i)%xHeIII = xmax
#endif

     if (psys%par(i)%T < tmin) psys%par(i)%T = tmin
     if (psys%par(i)%T > tmax) psys%par(i)%T = tmax
  end do

end subroutine particle_system_enforce_x_and_T_minmax





!> outputs currently loaded particle data to the screen
!=================================================================
subroutine particle_system_print_lun(psys,str,lun)

  type(particle_system_type), intent(in) :: psys    !< particle system
  character(*), optional, intent(in) :: str          !< arbitrary string
  integer(i4b), optional, intent(in) :: lun          !< if present goes to file
  integer(i4b) :: outlun
  
  
  outlun=stdout
  if (present(lun)) outlun=lun


  99  format(72("-"))  
  100 format(A,T10,3ES15.5)
  101 format(A,T10,2I15,ES15.5)
  102 format(A,T10,2I15)
  103 format(A,T10,3I15)


  write(outlun,99) 
  if (present(str)) write(outlun,"(A)") trim(str)
  write(outlun,"(A,I15,A)") "particle data for ", size(psys%par), "  particles"

  write(outlun,*) 


  write(outlun,100) "xpos", minval(psys%par%pos(1)), &
       maxval(psys%par%pos(1)), meanval_real(psys%par%pos(1))

  write(outlun,100) "ypos", minval(psys%par%pos(2)), &
       maxval(psys%par%pos(2)), meanval_real(psys%par%pos(2))
  
  write(outlun,100) "zpos", minval(psys%par%pos(3)), &
       maxval(psys%par%pos(3)), meanval_real(psys%par%pos(3))   
    
  write(outlun,102) "id",   minval(psys%par%id), &
       maxval(psys%par%id)
  
  write(outlun,100) "mass", minval(psys%par%mass), &
       maxval(psys%par%mass), meanval_real(psys%par%mass)
  
  write(outlun,100) "T",    minval(psys%par(:)%T), &
       maxval(psys%par(:)%T), meanval_real(psys%par%T)
  
  write(outlun,100) "rho",  minval(psys%par%rho), &
       maxval(psys%par%rho), meanval_real(psys%par%rho)
  
  write(outlun,100) "ye",   minval(psys%par%ye), &
       maxval(psys%par%ye), meanval_real(psys%par%ye)
  
  write(outlun,100) "xHI",  minval(psys%par%xHI), &
       maxval(psys%par%xHI), meanval_real(psys%par%xHI)

  write(outlun,100) "xHII",  minval(psys%par%xHII), &
       maxval(psys%par%xHII), meanval_real(psys%par%xHII)

  write(outlun,100) "hsml", minval(psys%par%hsml), &
       maxval(psys%par%hsml), meanval_real(psys%par%hsml)

  write(outlun,101) "lasthit", minval(psys%par%lasthit), &
       maxval(psys%par%lasthit)

#ifdef incHeat
  write(outlun,100) "dinternalEdt", minval(psys%par%dinternalEdt), &
       maxval(psys%par%dinternalEdt), meanval_real(psys%par%dinternalEdt)
#endif

#ifdef incVel
  write(outlun,100) "xvel", minval(psys%par%vel(1)), &
       maxval(psys%par%vel(1)), meanval_real(psys%par%vel(1))
  
  write(outlun,100) "yvel", minval(psys%par%vel(2)), &
       maxval(psys%par%vel(2)), meanval_real(psys%par%vel(2))
  
  write(outlun,100) "zvel", minval(psys%par%vel(3)), &
       maxval(psys%par%vel(3)), meanval_real(psys%par%vel(3))
#endif

#ifdef incCloudy
  write(outlun,100) "xHI_cld", minval(psys%par%xHI_cloudy), &
       maxval(psys%par%xHI_cloudy), meanval_real(psys%par%xHI_cloudy)
#endif
  
#ifdef incHmf  
  write(outlun,100) "Hmf",    minval(psys%par%Hmf), &
       maxval(psys%par%Hmf), meanval_real(psys%par%Hmf)
#endif

#ifdef incHe
  write(outlun,100) "xHeI",   minval(psys%par%xHeI), &
       maxval(psys%par%xHeI), meanval_real(psys%par%xHeI)
  
  write(outlun,100) "xHeII",  minval(psys%par%xHeII), &
       maxval(psys%par%xHeII), meanval_real(psys%par%xHeII)
  
  write(outlun,100) "xHeIII", minval(psys%par%xHeIII), &
       maxval(psys%par%xHeIII), meanval_real(psys%par%xHeIII)
#endif

#ifdef incHemf  
  write(outlun,100) "Hemf",    minval(psys%par%Hemf), &
       maxval(psys%par%Hemf), meanval_real(psys%par%Hemf)
#endif

#ifdef outGammaHI
  write(outlun,100) "gammaHI",   minval(psys%par%gammaHI), &
       maxval(psys%par%gammaHI), meanval_real(psys%par%gammaHI)
  
  write(outlun,100) "time(s)",   minval(psys%par%time), &
       maxval(psys%par%time), meanval_real(psys%par%time)
#endif

#ifdef incEOS
  write(outlun,100) "eos",   minval(psys%par%eos), &
       maxval(psys%par%eos), meanval_real(psys%par%eos)  
#endif

#ifdef incSFR
  write(outlun,100) "sfr",   minval(psys%par%sfr), &
       maxval(psys%par%sfr), meanval_real(psys%par%sfr)  
#endif

  write(outlun,*)
  
  write(outlun,100) "Box Uppers = ", psys%box%tops
  write(outlun,100) "Box Lowers = ", psys%box%bots
  write(outlun,103) "Upr BCs    = ", psys%box%tbound
  write(outlun,103) "Lwr BCs    = ", psys%box%bbound
  
  write(outlun,99) 
  
end subroutine particle_system_print_lun


!> calculates the mean value w/o using the intrinsics
!=================================================================
function meanval_real(arr) result (mean)
  real(r4b), dimension(:), intent(in) :: arr  !< array to average
  real(r8b) :: mean                           !< mean value to return
  integer(i8b) :: i
  mean = 0.0d0
  do i = 1,size(arr)
     mean = mean + arr(i)
  end do
  mean = mean / size(arr)
end function meanval_real





end module particle_system_mod

!> \file gadget_sphray_header_class.F90

!> \brief Handles Gadget style headers with extra SPHRAY info.  
!!
!!
!< 

module gadget_sphray_header_class
use myf03_mod
use gadget_general_class
use gadget_public_header_class
use gadget_owls_header_class

#ifdef useHDF5
use hdf5_wrapper
#endif

implicit none
private

public :: gadget_sphray_header_type
public :: gadget_sphray_header_copy_public
public :: gadget_sphray_header_copy_owls
public :: gadget_sphray_header_write_lun
public :: gadget_sphray_header_hdf5_write_lun



!> Gadget header type
!-----------------------------------------
type gadget_sphray_header_type
   integer(i4b) :: npar_file(0:5)  !< number of particles in snapshot file
   real(r8b)    :: mass(0:5)       !< mass of each particle type if constant
   real(r8b)    :: a               !< scale factor or time
   real(r8b)    :: z               !< redshift
   integer(i4b) :: flag_sfr        !< flag for star formation
   integer(i4b) :: flag_feedback   !< flag for feedback
   integer(i4b) :: npar_all(0:5)   !< number of particles in whole snapshot
   integer(i4b) :: flag_cooling    !< flag for radiative cooling
   integer(i4b) :: nfiles          !< number of files in a this snapshot
   real(r8b)    :: boxlen          !< box length
   real(r8b)    :: OmegaM          !< omega matter
   real(r8b)    :: OmegaL          !< omega lambda
   real(r8b)    :: h               !< little hubble
   integer(i4b) :: flag_age        !< flag for stellar age
   integer(i4b) :: flag_metals     !< flag for metallicity
   integer(i4b) :: npar_hw(0:5)    !< 64 bit part of npar 
   integer(i4b) :: flag_entr_ics   !< ICs contain entropy instead of energy

   real(r8b)    :: OmegaB          !< omega baryon 
   integer(i8b) :: rays_traced     !< number of rays traced
   integer(i4b) :: flag_Hmf        !< output has Hydorgen mass fraction? 
   integer(i4b) :: flag_Hemf       !< output has Helium mass fraction? 
   integer(i4b) :: flag_helium     !< output has xHeI and xHeII?
   integer(i4b) :: flag_gammaHI    !< output has HI photoionization rate? 
   integer(i4b) :: flag_cloudy     !< output has Cloudy xHIeq? 
   integer(i4b) :: flag_eos        !< output has EOS info?
   integer(i4b) :: flag_incsfr     !< output has SFR info?
   real(r8b)    :: time_gyr        !< time since BB from cosmo variables [Gyr]
   integer(i4b) :: unused(2)       !< spacer
end type gadget_sphray_header_type


contains


!> writes a gadget header to an open file
!--------------------------------------------------------------
subroutine gadget_sphray_header_write_lun(this, lun)
  type(gadget_sphray_header_type), intent(in) :: this
  integer(i4b), intent(in) :: lun

  write(lun) this%npar_file(:), this%mass(:), this%a, this%z, &              
       this%flag_sfr, this%flag_feedback, this%npar_all(:), &    
       this%flag_cooling, this%nfiles, this%boxlen, this%OmegaM, &         
       this%OmegaL, this%h, this%flag_age, this%flag_metals, &    
       this%npar_hw(:), this%flag_entr_ics, this%OmegaB, &
       this%rays_traced, this%flag_Hmf, this%flag_Hemf, this%flag_helium, &
       this%flag_gammaHI, this%flag_cloudy, this%flag_eos, this%flag_incsfr, &
       this%time_gyr, this%unused(:)      

end subroutine gadget_sphray_header_write_lun


!> writes a gadget header to an open HDF5 file
!--------------------------------------------------------------
subroutine gadget_sphray_header_hdf5_write_lun(this, fh)
  type(gadget_sphray_header_type), intent(in) :: this
  integer(i4b), intent(in) :: fh

#ifdef useHDF5
  call hdf5_write_attribute(fh,'Header/NumPart_ThisFile',this%npar_file)
  call hdf5_write_attribute(fh,'Header/NumPart_Total',this%npar_all)
  call hdf5_write_attribute(fh,'Header/NumPart_Total_HighWord',this%npar_hw)
  call hdf5_write_attribute(fh,'Header/MassTable',this%mass)
  call hdf5_write_attribute(fh,'Header/ExpansionFactor',this%a)
  call hdf5_write_attribute(fh,'Header/Time_GYR',this%time_gyr)

  call hdf5_write_attribute(fh,'Header/Redshift',this%z)
  call hdf5_write_attribute(fh,'Header/BoxSize',this%boxlen)
  call hdf5_write_attribute(fh,'Header/NumFilesPerSnapshot',this%nfiles)
  call hdf5_write_attribute(fh,'Header/Omega0',this%OmegaM)
  call hdf5_write_attribute(fh,'Header/OmegaBaryon',this%OmegaB)
  call hdf5_write_attribute(fh,'Header/OmegaLambda',this%OmegaL)
  call hdf5_write_attribute(fh,'Header/HubbleParam',this%h)

  call hdf5_write_attribute(fh,'Header/Flag_Sfr',this%flag_sfr)
  call hdf5_write_attribute(fh,'Header/Flag_Cooling',this%flag_cooling)
  call hdf5_write_attribute(fh,'Header/Flag_StellarAge',this%flag_age)
  call hdf5_write_attribute(fh,'Header/Flag_Metals',this%flag_metals)
  call hdf5_write_attribute(fh,'Header/Flag_Feedback',this%flag_feedback)
  call hdf5_write_attribute(fh,'Header/Flag_Entropy_In_ICs',this%flag_entr_ics)
  call hdf5_write_attribute(fh,'Header/RaysTraced',this%rays_traced)

  call hdf5_write_attribute(fh,'Header/Flag_Hmf',this%flag_Hmf)
  call hdf5_write_attribute(fh,'Header/Flag_Hemf',this%flag_Hemf)
  call hdf5_write_attribute(fh,'Header/Flag_Helium',this%flag_helium)
  call hdf5_write_attribute(fh,'Header/Flag_GammaHI',this%flag_gammaHI)
  call hdf5_write_attribute(fh,'Header/Flag_Cloudy',this%flag_cloudy)
  call hdf5_write_attribute(fh,'Header/Flag_EoS',this%flag_eos)
  call hdf5_write_attribute(fh,'Header/Flag_IncSFR',this%flag_incsfr)
#endif


end subroutine gadget_sphray_header_hdf5_write_lun


!> copies an OWLS/GIMIC header into the sphray style header
!--------------------------------------------------------------
subroutine gadget_sphray_header_copy_owls( this, owlshead )
  type(gadget_sphray_header_type) :: this
  type(gadget_owls_header_type) :: owlshead

  this%npar_file(0:5)   = owlshead%npar_file(0:5)   
  this%mass(0:5)        = owlshead%mass(0:5)        
  this%a                = owlshead%a                
  this%z                = owlshead%z                
  this%flag_sfr         = owlshead%flag_sfr         
  this%flag_feedback    = owlshead%flag_feedback    
  this%npar_all(0:5)    = owlshead%npar_all(0:5)    
  this%flag_cooling     = owlshead%flag_cooling     
  this%nfiles           = owlshead%nfiles           
  this%boxlen           = owlshead%boxlen           
  this%OmegaM           = owlshead%OmegaM           
  this%OmegaL           = owlshead%OmegaL           
  this%h                = owlshead%h                
  this%flag_age         = owlshead%flag_age         
  this%flag_metals      = owlshead%flag_metals      
  this%npar_hw(0:5)     = owlshead%npar_hw(0:5)     

  this%OmegaB           = owlshead%OmegaB
  this%time_gyr         = owlshead%time_gyr

end subroutine gadget_sphray_header_copy_owls


!> copies a Public header into the sphray style header
!--------------------------------------------------------------
subroutine gadget_sphray_header_copy_public( this, pubhead )
  type(gadget_sphray_header_type) :: this
  type(gadget_public_header_type) :: pubhead

  this%npar_file(0:5)   = pubhead%npar_file(0:5)   
  this%mass(0:5)        = pubhead%mass(0:5)        
  this%a                = pubhead%a                
  this%z                = pubhead%z                
  this%flag_sfr         = pubhead%flag_sfr         
  this%flag_feedback    = pubhead%flag_feedback    
  this%npar_all(0:5)    = pubhead%npar_all(0:5)    
  this%flag_cooling     = pubhead%flag_cooling     
  this%nfiles           = pubhead%nfiles           
  this%boxlen           = pubhead%boxlen           
  this%OmegaM           = pubhead%OmegaM           
  this%OmegaL           = pubhead%OmegaL           
  this%h                = pubhead%h                
  this%flag_age         = pubhead%flag_age         
  this%flag_metals      = pubhead%flag_metals      
  this%npar_hw(0:5)     = pubhead%npar_hw(0:5)     
  this%flag_entr_ics    = pubhead%flag_entr_ics    

end subroutine gadget_sphray_header_copy_public


end module gadget_sphray_header_class

!> \file amuse_mainloop.F90

!> \brief the main program loop
!! 
!! Updates one snapshot
!<

module amuse_mainloop_mod
  use myf03_mod

  ! routines
  use gadget_general_class, only: gadget_constants_type
  use main_input_mod, only: readin_snapshot
  use oct_tree_mod, only: buildtree, setparticleorder
  use ray_mod, only: src_ray_make
  use raylist_mod, only: trace_ray, kill_raylist, prepare_raysearch
  use ion_temperature_update, only: update_raylist, non_photo_update_all
  use mt19937_mod, only: genrand_real1
  use output_mod, only: output_total_snap, ion_frac_out
  use global_mod, only: set_dt_from_dtcode, set_time_elapsed_from_itime

  ! types
  use ray_mod, only: src_ray_type
  
  ! variables
  use global_mod, only: psys
  use global_mod, only: globalraylist
  use global_mod, only: tree
  use global_mod, only: GV
  use global_mod, only: PLAN

  implicit none
  

contains
  
  !> this is the main driver of SPHRAY
  !======================================
  subroutine mainloop()
    implicit none
    
    character(clen), parameter :: myname="mainloop"
    logical, parameter :: crash=.true.
    integer, parameter :: verb=1
    character(clen) :: str,fmt

    type(gadget_constants_type) :: gconst

    !  local counters 
    !-----------------
    
    integer(i8b) :: snapn !< snapshot index
    integer(i8b) :: rayn  !< ray counter
    integer(i8b) :: srcn  !< source counter
    
    real(r8b) :: rn       !< random number
    real(r8b) :: MB       !< MBs for memory consumption tracking
    
    ! work variables
    !-----------------
    logical :: srcray
    type(src_ray_type) :: ray
        
#ifdef incHrec
    integer(i8b) :: rindx
    integer(i8b) :: pindx
    integer(i8b) :: lasthitcheck
#endif
        

    snapn = GV%StartSnapNum

    
    ! if there are no sources, update the gas cooling and
    ! ionization state with zero photoionizations and using
    ! the same time step for each particle
    !----------------------------------------------------------------
    if (size(psys%src).EQ.0) then
       
       GV%itime = GV%itime + PLAN%snap(snapn)%SrcRays
       call set_time_elapsed_from_itime( GV )
       write(*,*) PLAN%snap(snapn)%SrcRays, &
                  PLAN%snap(snapn)%SrcRays, &
                  GV%time_elapsed_myr



       
    ! if there are sources, calculate the photoionization rate
    ! at each particle using ray tracing and update on individual
    ! time steps.  
    !----------------------------------------------------------------
    else   

                       
       !  build oct tree.  only need to do this once per snap (for now)
       !----------------------------------------------------------------
       call buildtree(psys,tree,MB,GV%PartPerCell)
       call setparticleorder(psys, tree)             
       call prepare_raysearch(psys, globalraylist)
       
              
       ! begin ray tracing 
       !----------------------------------------------------------------
       src_rays: do rayn = 1, PLAN%snap(snapn)%SrcRays
          
          GV%rayn                = GV%rayn + 1
          GV%src_rayn            = GV%src_rayn + 1
          GV%TotalSourceRaysCast = GV%TotalSourceRaysCast + 1                
          
          !  select a source randomly (weighted by their luminosity)
          !----------------------------------------------------------------
          rn = genrand_real1() * psys%src(size(psys%src))%Lcdf
          srcn=1
          do while( psys%src(srcn)%Lcdf < rn )
             srcn = srcn + 1
             if( srcn > size(psys%src) ) then
                stop "src num > number of sources in mainloop.f90"
             endif
          enddo
          
          !  create a source ray and calc the impacts
          !----------------------------------------------------------------
          call src_ray_make( ray, &
                             psys%src(srcn), &
                             GV%rayn, &
                             GV%dt_s, &
                             GV%Lunit, &
                             psys%box )
          
          GV%itime = GV%itime + 1
          call set_time_elapsed_from_itime( GV )
          GV%IonizingPhotonsPerSec = GV%TotalPhotonsCast / GV%time_elapsed_s
          
          if ( mod(rayn,PLAN%snap(snapn)%SrcRays/100) == 0 ) &
               write(*,*) rayn, PLAN%snap(snapn)%SrcRays, GV%time_elapsed_myr
                    
          globalraylist%ray = ray
          call trace_ray(globalraylist%ray, globalraylist, psys, tree) 
          
          GV%TotalPhotonsCast = GV%TotalPhotonsCast + globalraylist%ray%pini
          
          srcray = .true.
          call update_raylist(globalraylist, psys%par, psys%box, srcray)
          
                    
       end do src_rays
       
       ! free up the memory from the globalraylist.
       call kill_raylist(globalraylist)
       
    endif


    ! at this point particles are synchronized.  if there are sources, 
    ! particles are evolved with GHI=0 for a dt equal to the last time
    ! they were hit by a ray to the final time.  if there are no sources
    ! each particle is updated over the whole time
    call non_photo_update_all(psys%par)
    
   
    close(GV%ionlun)
    
    
    if (GV%raystats) then
       close(GV%raystatlun)
    end if
    
  end subroutine mainloop
  
end module amuse_mainloop_mod

!> \file config.F90

!> \brief the module that handles the config file
!<
module config_mod
use myf03_mod
use gadget_general_class
use global_mod, only: GV
#ifdef useHDF5
use hdf5_wrapper
#endif
implicit none
private

public :: read_config_file
public :: write_config_hdf5_lun
public :: dummy_check_config_variables
public :: config_info_to_file

contains


!> writes the config file 
!==============================
subroutine write_config_hdf5_lun(lun)
  integer :: lun
  type(gadget_constants_type) :: gconst

#ifdef useHDF5
  call hdf5_write_attribute( lun, 'Config/Verbosity',          GV%Verbosity )

  if (GV%DoTestScenario) then
     call hdf5_write_attribute( lun, 'Config/DoTestScenario',  1)           
  else
     call hdf5_write_attribute( lun, 'Config/DoTestScenario',  0)           
  endif
  
  call hdf5_write_attribute( lun, 'Config/TestScenario',       GV%TestScenario )
  
  if (GV%JustInit) then
     call hdf5_write_attribute( lun, 'Config/JustInit',        1)           
  else
     call hdf5_write_attribute( lun, 'Config/JustInit',        0)           
  endif
  
  if (GV%Comoving) then
     call hdf5_write_attribute( lun, 'Config/Comoving',        1)         
  else
     call hdf5_write_attribute( lun, 'Config/Comoving',        0)         
  endif
  
  call hdf5_write_attribute( lun, 'Config/IsoTemp',            GV%IsoTemp)            
  
  if (GV%FixSnapTemp) then
     call hdf5_write_attribute( lun, 'Config/FixSnapTemp',     1)         
  else
     call hdf5_write_attribute( lun, 'Config/FixSnapTemp',     0)         
  endif
  
  call hdf5_write_attribute( lun, 'Config/EOStemp',            GV%EOStemp)            
  
  call hdf5_write_attribute( lun, 'Config/InitxHI',            GV%InitxHI)            
  
  if (GV%RayDepletion) then
     call hdf5_write_attribute( lun, 'Config/RayDepletion',    1)         
  else
     call hdf5_write_attribute( lun, 'Config/RayDepletion',    0)         
  endif
  
  call hdf5_write_attribute( lun, 'Config/IntSeed',            GV%IntSeed)            

  call hdf5_write_attribute( lun, 'Config/StaticFieldSimTime', &
       GV%StaticFieldSimTime / gconst%sec_per_megayear / GV%LittleH * GV%cgs_time) 
  call hdf5_write_attribute( lun, 'Config/StaticSimTimeUnit',  'myr') 
  
  call hdf5_write_attribute( lun, 'Config/InputType',          GV%InputType)          
  call hdf5_write_attribute( lun, 'Config/SnapPath',           GV%SnapPath)           
  call hdf5_write_attribute( lun, 'Config/SourcePath',         GV%SourcePath)           
  
  call hdf5_write_attribute( lun, 'Config/SpectraFile',        GV%SpectraFile)           
  call hdf5_write_attribute( lun, 'Config/b2cdFile',           GV%b2cdFile)           
  call hdf5_write_attribute( lun, 'Config/AtomicRatesFile',    GV%AtomicRatesFile)    
  
  call hdf5_write_attribute( lun, 'Config/ParFileBase',        GV%ParFileBase)        
  call hdf5_write_attribute( lun, 'Config/SourceFileBase',     GV%SourceFileBase)        
  
  call hdf5_write_attribute( lun, 'Config/StartSnapNum',       GV%StartSnapNum)            
  call hdf5_write_attribute( lun, 'Config/EndSnapNum',         GV%EndSnapNum)            
  
  call hdf5_write_attribute( lun, 'Config/ParFilesPerSnap',    GV%ParFilesPerSnap)    
  call hdf5_write_attribute( lun, 'Config/SourceFilesPerSnap', GV%SourceFilesPerSnap)    
  
  call hdf5_write_attribute( lun, 'Config/RayScheme',          GV%RayScheme)
  call hdf5_write_attribute( lun, 'Config/ForcedRayNumber',    GV%ForcedRayNumber)
  
  if (GV%RayStats) then
     call hdf5_write_attribute( lun, 'Config/RayStats',        1)
  else
     call hdf5_write_attribute( lun, 'Config/RayStats',        0)
  endif
  
  call hdf5_write_attribute( lun, 'Config/BndryCond',          GV%BndryCond)          
  call hdf5_write_attribute( lun, 'Config/RayPhotonTol',       GV%RayPhotonTol)         
  
  if (GV%HydrogenCaseA) then
     call hdf5_write_attribute( lun, 'Config/HydrogenCaseA',   1)
  else
     call hdf5_write_attribute( lun, 'Config/HydrogenCaseA',   0)
  endif
  
  if (GV%HeliumCaseA) then
     call hdf5_write_attribute( lun, 'Config/HeliumCaseA',     1)
  else
     call hdf5_write_attribute( lun, 'Config/HeliumCaseA',     0)
  endif
  
  call hdf5_write_attribute( lun, 'Config/IonTempSolver',      GV%IonTempSolver)         
  
  call hdf5_write_attribute( lun, 'Config/Tfloor',             GV%Tfloor)             
  call hdf5_write_attribute( lun, 'Config/Tceiling',           GV%Tceiling)           
  
  call hdf5_write_attribute( lun, 'Config/xfloor',             GV%xfloor)             
  call hdf5_write_attribute( lun, 'Config/xceiling',           GV%xceiling)           
  
  call hdf5_write_attribute( lun, 'Config/NeBackground',       GV%NeBackground)       
  
  call hdf5_write_attribute( lun, 'Config/NraysUpdateNoHits',  GV%NraysUpdateNoHits)                 
  
  call hdf5_write_attribute( lun, 'Config/H_mf',               GV%H_mf)               
  call hdf5_write_attribute( lun, 'Config/He_mf',              GV%He_mf)              
  
  call hdf5_write_attribute( lun, 'Config/OutputDir',          GV%OutputDir)          
  call hdf5_write_attribute( lun, 'Config/OutputFileBase',     GV%OutputFileBase)     
  call hdf5_write_attribute( lun, 'Config/OutputType',         GV%OutputType)         
  
  call hdf5_write_attribute( lun, 'Config/OutputTiming',       GV%OutputTiming)         
  call hdf5_write_attribute( lun, 'Config/NumStdOuts',         GV%NumStdOuts)         
  
  if (GV%DoInitialOutput) then
     call hdf5_write_attribute( lun, 'Config/DoInitialOutput', 1)         
  else
     call hdf5_write_attribute( lun, 'Config/DoInitialOutput', 0)         
  endif
  
  call hdf5_write_attribute( lun, 'Config/IonFracOutRays',     GV%IonFracOutRays)         
  call hdf5_write_attribute( lun, 'Config/ForcedOutFile',      GV%ForcedOutFile)         
  call hdf5_write_attribute( lun, 'Config/ForcedUnits',        GV%ForcedUnits)         
  
  call hdf5_write_attribute( lun, 'Config/PartPerCell',        GV%PartPerCell)        
#endif

  
end subroutine write_config_hdf5_lun


!> reads the config file 
!==============================
subroutine read_config_file(config_file)

  character(clen), intent(in) :: config_file  !< file to read config vars from
  character(clen) :: keyword
  character(clen) :: str
  logical :: file_exists
  integer :: verb

  character(clen), parameter :: myname="read_config_file"
  logical, parameter :: crash = .true.

    write(str,'(A,A)') 'using configuration file: ', trim(config_file)
    verb = 0
    call mywrite(str,verb) 

    inquire( file=config_file, exist=file_exists )
    if (.not. file_exists) then
       call myerr("config file does not exist",myname,crash)
    end if


    keyword = "Verbosity:"
    call scanfile(config_file,keyword,GV%Verbosity)
    myf03_verbosity = GV%verbosity

    keyword = "DoTestScenario:"
    call scanfile(config_file,keyword,GV%DoTestScenario)

    keyword = "TestScenario:"
    call scanfile(config_file,keyword,GV%TestScenario)
!-----------------------

    keyword = "JustInit:"
    call scanfile(config_file,keyword,GV%JustInit)

    keyword = "Comoving:"
    call scanfile(config_file,keyword,GV%Comoving)

    keyword = "IsoTemp:"
    call scanfile(config_file,keyword,GV%IsoTemp)

    keyword = "FixSnapTemp:"
    call scanfile(config_file,keyword,GV%FixSnapTemp)

    keyword = "EOStemp:"
    call scanfile(config_file,keyword,GV%EOStemp)

    keyword = "InitxHI:"
    call scanfile(config_file,keyword,GV%InitxHI)

    keyword = "RayDepletion:"
    call scanfile(config_file,keyword,GV%RayDepletion)

    keyword = "IntSeed:"
    call scanfile(config_file,keyword,GV%IntSeed)

    keyword = "StaticFieldSimTime:"
    call scanfile(config_file,keyword,GV%StaticFieldSimTime)

    keyword = "StaticSimTimeUnit:"
    call scanfile(config_file,keyword,GV%StaticSimTimeUnit)    

    !   input snapshot information
    !------------------------------
    keyword = "InputType:"
    call scanfile(config_file,keyword,GV%InputType)

    keyword = "SnapPath:"
    call scanfile(config_file,keyword,GV%SnapPath)

    keyword = "SourcePath:"
    call scanfile(config_file,keyword,GV%SourcePath)

    keyword = "SpectraFile:"
    call scanfile(config_file,keyword,GV%SpectraFile)

    keyword = "b2cdFile:"
    call scanfile(config_file,keyword,GV%b2cdFile)

    keyword = "AtomicRatesFile:"
    call scanfile(config_file,keyword,GV%AtomicRatesFile)

    keyword = "ParFileBase:"
    call scanfile(config_file,keyword,GV%ParFileBase)

    keyword = "SourceFileBase:"
    call scanfile(config_file,keyword,GV%SourceFileBase)

    keyword = "StartSnapNum:"
    call scanfile(config_file,keyword,GV%StartSnapNum)

    keyword = "EndSnapNum:"
    call scanfile(config_file,keyword,GV%EndSnapNum)

    keyword = "ParFilesPerSnap:"
    call scanfile(config_file,keyword,GV%ParFilesPerSnap)

    keyword = "SourceFilesPerSnap:"
    call scanfile(config_file,keyword,GV%SourceFilesPerSnap)


    !   ray tracing
    !----------------------------
    keyword = "RayScheme:"
    call scanfile(config_file,keyword,GV%RayScheme)

    keyword = "ForcedRayNumber:"
    call scanfile(config_file,keyword,GV%ForcedRayNumber)
 
    keyword = "RayStats:"
    call scanfile(config_file,keyword,GV%RayStats)

    keyword = "BndryCond:"
    call scanfile(config_file,keyword,GV%BndryCond)

    keyword = "RayPhotonTol:"
    call scanfile(config_file,keyword,GV%RayPhotonTol)


    !   ion/temp solving
    !----------------------------
    keyword = "HydrogenCaseA:"
    call scanfile(config_file,keyword,GV%HydrogenCaseA)

    keyword = "HeliumCaseA:"
    call scanfile(config_file,keyword,GV%HeliumCaseA)

    keyword = "IonTempSolver:"
    call scanfile(config_file,keyword,GV%IonTempSolver)

    keyword = "Tfloor:"
    call scanfile(config_file,keyword,GV%Tfloor)

    keyword = "Tceiling:"
    call scanfile(config_file,keyword,GV%Tceiling)

    keyword = "xfloor:"
    call scanfile(config_file,keyword,GV%xfloor)

    keyword = "xceiling:"
    call scanfile(config_file,keyword,GV%xceiling)

    keyword = "NeBackground:"
    call scanfile(config_file,keyword,GV%NeBackground)

    keyword = "NraysUpdateNoHits:"
    call scanfile(config_file,keyword,GV%NraysUpdateNoHits)

    keyword = "H_mf:"
    call scanfile(config_file,keyword,GV%H_mf)

    keyword = "He_mf:"
    call scanfile(config_file,keyword,GV%He_mf)

    !   output
    !-------------
    keyword = "OutputDir:"
    call scanfile(config_file,keyword,GV%OutputDir)

    keyword = "OutputFileBase:"
    call scanfile(config_file,keyword,GV%OutputFileBase)

    keyword = "OutputType:"
    call scanfile(config_file,keyword,GV%OutputType)

    keyword = "OutputTiming:"
    call scanfile(config_file,keyword,GV%OutputTiming)

    keyword = "NumStdOuts:"
    call scanfile(config_file,keyword,GV%NumStdOuts)

    keyword = "DoInitialOutput:"
    call scanfile(config_file,keyword,GV%DoInitialOutput)

    keyword = "IonFracOutRays:"
    call scanfile(config_file,keyword,GV%IonFracOutRays)

    keyword = "ForcedOutFile:"
    call scanfile(config_file,keyword,GV%ForcedOutFile)

    keyword = "ForcedUnits:"
    call scanfile(config_file,keyword,GV%ForcedUnits)
 
!--------------------
    keyword = "PartPerCell:"
    call scanfile(config_file,keyword,GV%PartPerCell)

    keyword = "DoMomentumKicks:"
    call scanfile(config_file,keyword,GV%DoMomentumKicks)
    
    GV%config_file = config_file

    call dummy_check_config_variables()
    call config_info_to_file()

end subroutine read_config_file


!> run dummy checks on config variables
!========================================
subroutine dummy_check_config_variables()

  character(clen) :: Cwarning, Mwarning
  logical :: config_good
  logical :: charmatch

  Cwarning = "please edit " // trim(GV%config_file)
  Mwarning = "please edit Makefile"
  config_good = .true. 

  if ( GV%InputType /= 1 .and. GV%InputType /= 2 .and. &
       GV%InputType /= 3 .and. GV%InputType /= 4) then
     write(*,*) "Input Type ", GV%InputType, " not recognized"
     write(*,*) "must be 1 (Gadget2 Public Standard), &
          2 (Gadget CosmoBH), 3 (Gadget OWLS/GIMIC HDF5), &
          4 (Gadget V. Bromm), or 5 (Gadget Public HDF5)"
     config_good = .false. 
  end if

  if (GV%OutputType /= 1 .and. GV%OutputType /= 2) then
     write(*,*) "Output Type ", GV%OutputType, " not recognized"
     write(*,*) "must be 1 (Standard Binary Gadget) or 2 (HDF5)"
     config_good = .false. 
  end if


  if (GV%Tfloor < 0.0 .or. GV%Tceiling < 0.0) then
     write(*,*) "Tfloor and Tceiling must be greater than or equal to 0.0"
     config_good = .false. 
  end if

  if (GV%Tfloor > 1.0e9 .or. GV%Tceiling > 1.0e9) then
     write(*,*) "Tfloor and Tceiling must be less than or equal to 1.0e9"
     config_good = .false. 
  end if

  if (GV%Tfloor > GV%Tceiling) then
     write(*,*) "Tceiling must be greater than Tfloor"
     config_good = .false. 
  end if

  if (GV%IsoTemp > 0.0) then
  
     if (GV%IsoTemp < GV%Tfloor) then
        write(*,*) "IsoTemp cannot be set lower than Tfloor"
        config_good = .false. 
     end if
     
     if (GV%IsoTemp > GV%Tceiling) then
        write(*,*) "IsoTemp cannot be set higher than Tceiling"
        config_good = .false. 
     end if

     if (GV%FixSnapTemp) then 
        write(*,*) "Only one of the following can be true:"
        write(*,*) "FixSnapTemp = T (then IsoTemp must be < 0)"
        write(*,*) "IsoTemp > 0     (then FixSnapTemp must = F)"
        config_good = .false.
     endif

  end if

  if (GV%StartSnapNum < 0 .or. GV%EndSnapNum < 0) then
     write(*,*) "Starting and Ending snapshot numbers must be > 0"
     config_good = .false. 
  end if

  if (GV%StartSnapNum > GV%EndSnapNum) then
     write(*,*) "Starting snapshot number cannot be > Ending snapshot number"
     config_good = .false. 
  end if


  if ( GV%IonTempSolver /= 1 .and. GV%IonTempSolver /= 2) then
     config_good = .false.
     write(*,*) "IonTempSolver: ", GV%IonTempSolver, " not recognized"
     write(*,*) "must be '1'=euler or '2'=bdf "
  end if


  charmatch = .false.
  if ( trim(GV%StaticSimTimeUnit) == "codetime" ) charmatch = .true.
  if ( trim(GV%StaticSimTimeUnit) == "myr"      ) charmatch = .true.
  if (.not. charmatch) then
     write(*,*) "StaticSimTimeUnit: ", trim(GV%StaticSimTimeUnit), " not recognized"
     write(*,*) "must be 'codetime' or 'myr' "
     config_good = .false.
  end if

  charmatch = .false.
  if ( trim(GV%RayScheme) == "raynum" ) charmatch = .true.
  if ( trim(GV%RayScheme) == "header"   ) charmatch = .true.
  if (.not. charmatch) then
     write(*,*) "RayScheme: ", trim(GV%RayScheme), " not recognized"
     write(*,*) "must be 'raynum' or 'header' "
     config_good = .false.
  end if

  charmatch = .false.
  if ( trim(GV%OutputTiming) == "standard" ) charmatch = .true.
  if ( trim(GV%OutputTiming) == "forced"   ) charmatch = .true.
  if (.not. charmatch) then
     write(*,*) "OutputTiming: ", trim(GV%OutputTiming), " not recognized"
     write(*,*) "must be 'standard' or 'forced' "
     config_good = .false.
  end if

  charmatch = .false.
  if ( trim(GV%ForcedUnits) == "codetime" ) charmatch = .true.
  if ( trim(GV%ForcedUnits) == "myr"      ) charmatch = .true.
  if ( trim(GV%ForcedUnits) == "mwionfrac") charmatch = .true.
  if (.not. charmatch) then
     write(*,*) "ForcedUnits: ", trim(GV%ForcedUnits), " not recognized"
     write(*,*) "must be 'codetime', 'myr', or 'mwionfrac' "
     config_good = .false.
  end if

#ifdef incHe
  if (GV%He_mf == 0.0) then
     write(*,*) "You have defined the incHe macro in the Makefile, but"
     write(*,*) "the Helium mass fraction is set to 0.0 in the config file."
     write(*,*) "Please comment out incHe in the Makefile or set the Helium"
     write(*,*) "mass fraction to something greater than zero in the config file."
     config_good = .false.
  end if
#else
  if (GV%He_mf /= 0.0) then
     write(*,*) "You have not defined the incHe macro in the Makefile, but"
     write(*,*) "the Helium mass fraction is non-zero in the config file."
     write(*,*) "Please uncomment the incHe line in the Makefile or set the"
     write(*,*) "Helium mass fraction to zero in the config file."
     config_good = .false.
  end if
#endif




  if (GV%DoTestScenario) then  
     charmatch = .false.

     if ( trim(GV%TestScenario) == "iliev_test1" ) then
        charmatch = .true.
        if (GV%IsoTemp /= 1.0d4) then
           config_good = .false.
           write(*,*) "iliev test 1 must have IsoTemp = 1.0e4"
        end if
     end if

     if ( trim(GV%TestScenario) == "iliev_test1He" ) then
        charmatch = .true.
        if (GV%IsoTemp /= 1.0d4) then
           config_good = .false.
           write(*,*) "iliev test 1 He must have IsoTemp = 1.0e4"
        end if
     end if

     if ( trim(GV%TestScenario) == "iliev_test2" ) then
        charmatch = .true.
        if (GV%IsoTemp > 0.0) then
           config_good = .false.
           write(*,*) "iliev test 2 must have IsoTemp <= 0.0"
        end if
     end if

     if ( trim(GV%TestScenario) == "iliev_test3" ) then
        charmatch = .true.
        if (GV%IsoTemp > 0.0) then
           config_good = .false.
           write(*,*) "iliev test 3 must have IsoTemp <= 0.0"
        end if
     end if

     if ( trim(GV%TestScenario) == "iliev_test4" ) then
        charmatch = .true.
        if (GV%IsoTemp > 0.0) then
           config_good = .false.
           write(*,*) "iliev test 4 must have IsoTemp <= 0.0"
        end if
     end if


     if (.not. charmatch) then
        write(*,*) "TestScenario: ", trim(GV%TestScenario), " not recognized"
        write(*,*) "must be 'iliev_test1(He)', 'iliev_test2', 'iliev_test3' or 'iliev_test4' "
        config_good = .false.
     end if
  end if

  if (.not. config_good) then
     write(*,*) Cwarning
     stop
  end if


end subroutine dummy_check_config_variables




!> writes the configuration file information to the output directory
!====================================================================
subroutine config_info_to_file()

  character(200) :: config_log_file
  integer(i4b) :: lun

  config_log_file = trim(GV%OutputDir) // "/config_values_used.log"
  
  call open_formatted_file_w(config_log_file,lun)

  105 format(T2,A,I3.3)
  111 format(T2,A,I10)
  120 format(T2,A,ES10.3)

  write(lun,*)"============================================"
  write(lun,*)"The SPHRAY configuration file has been read "
  write(lun,*)"The SPHRAY configuration file variables are "
  write(lun,*)"============================================"
  write(lun,*)"Verbosity " , GV%Verbosity
  write(lun,*)
  write(lun,*)"Do a test scenario? " , GV%DoTestScenario
  write(lun,*)
  write(lun,*)"Which test scenario? " , trim(GV%TestScenario)
  write(lun,*)
  write(lun,*)"Just initialize? " , GV%JustInit
  write(lun,*)
  write(lun,*)"Input is in comoving coords? " , GV%Comoving
  write(lun,*)
  write(lun,*)"Iso temperature (if > 0.0 fixed single temperature): ", GV%IsoTemp
  write(lun,*) 
  write(lun,*)"Fix temperature at snapshot values?: ", GV%FixSnapTemp
  write(lun,*) 
  write(lun,*)"EOS temperature (negative = snapshot temperature): ", GV%EOStemp
  write(lun,*) 
  write(lun,*)"Initial xHI (negative = snapshot or collisional equil.): ", GV%InitxHI
  write(lun,*) 
  write(lun,*)"Rremove photons from ray as it travels?: ", GV%RayDepletion
  write(lun,*) 
  write(lun,*)"Integer Seed for RNG ", GV%IntSeed
  write(lun,*) 
  write(lun,*)"Static field simulation time: ", GV%StaticFieldSimTime
  write(lun,*) 
  write(lun,*)"Static field time unit: ", trim(GV%StaticSimTimeUnit)
  write(lun,*) 

  write(lun,*)

  write(lun,*)"Input Type (1=Gadget Public, 2=Gadget Cooling, 3=Gadget HDF5, 4=Gadget Bromm)", GV%InputType
  write(lun,*)
  write(lun,*)"Path to Snapshot File(s):"
  write(lun,*)trim(GV%SnapPath)
  write(lun,*)
  write(lun,*)"Path to Source File(s):"
  write(lun,*)trim(GV%SourcePath)
  write(lun,*) 
  write(lun,*)"Path to the Spectra file:"
  write(lun,*)trim(GV%SpectraFile)
  write(lun,*) 
  write(lun,*)"Path to the impact parameter -> column depth file:"
  write(lun,*)trim(GV%b2cdFile)
  write(lun,*) 
  write(lun,*)"Path to the atomic rates file:"
  write(lun,*)trim(GV%AtomicRatesFile)

  write(lun,*)
  write(lun,*)"Particle file base: ", trim(GV%ParFileBase)
  write(lun,*)"Source file base:   ", trim(GV%SourceFileBase)
  write(lun,*)
  write(lun,"(A,I3.3)") "Starting snapshot number:", GV%StartSnapNum
  write(lun,"(A,I3.3)") "Ending snapshot number:  ", GV%EndSnapNum
  write(lun,"(A,I3)") "Par Files per snapshot:    ", GV%ParFilesPerSnap
  write(lun,"(A,I10)") "Source Files per snapshot:", GV%SourceFilesPerSnap

  write(lun,*)
  write(lun,*)
  write(lun,*)  "Ray Scheme : ", trim(GV%RayScheme)
  write(lun,120) "Forced Ray Number : ", real(GV%ForcedRayNumber)

  write(lun,*) "Report ray statistics in raystats.dat?", GV%RayStats

  if(GV%BndryCond==-1) then
  write(lun,*)  "Boundry Conditions : ", "reflecting"
  else if(GV%BndryCond==0) then
  write(lun,*)  "Boundry Conditions : ", "vacuum"
  else if(GV%BndryCond==1) then  
  write(lun,*)  "Boundry Conditions : ", "periodic"
  end if

  write(lun,*)  "Ray Photon Tol     : ", GV%RayPhotonTol
  write(lun,*)  "Maximum Distance to trace a ray [physical code units], negative = default", GV%MaxRayDist

  write(lun,*)  "Use Case A recombination rates for Hydrogen? :", GV%HydrogenCaseA
  write(lun,*)  "Use Case A recombination rates for Helium?   :", GV%HeliumCaseA

  write(lun,*)  "Ionization and temperature solver :", GV%IonTempSolver

  write(lun,*)  "Temperature floor   : ", GV%Tfloor
  write(lun,*)  "Temperature ceiling : ", GV%Tceiling
  write(lun,*)  "Ionization floor    : ", GV%xfloor
  write(lun,*)  "Ionization ceiling  : ", GV%xceiling


  write(lun,*)  "ne background      : ", GV%NeBackground
  write(lun,*)  "Rays between all particle update:  ", GV%NraysUpdateNoHits

  write(lun,*) 
  write(lun,*) 
  write(lun,*)  "Hydrogen Mass Fraction: ", GV%H_mf
  write(lun,*)  "Helium Mass Fraction: ", GV%He_mf
  
  write(lun,*)
  write(lun,*)
  write(lun,*)  "Output Dir         : ", trim(GV%OutputDir)
  write(lun,*)  "Output File Base   : ", trim(GV%OutputFileBase)
  write(lun,*)  "Output Type (1=Std. Gadget, 2=HDF5 Gadget) : ", GV%OutputType

  write(lun,*)  "Output timing plan : ", trim(GV%OutputTiming)

  write(lun,*)  "Number Std Outs    : ", GV%NumStdOuts
  write(lun,*)  "Do Initial Output  : ", GV%DoInitialOutput

  write(lun,*)  "Ion Frac Out Rays  : ", GV%IonFracOutRays

  write(lun,*)  "ForcedOutFile      : ", trim(GV%ForcedOutFile)
  write(lun,*)  "ForcedUnits        : ", trim(GV%ForcedUnits)

  write(lun,*)  "Particles Per Tree Cell: ", GV%PartPerCell


  write(lun,*)"====================================="
  write(lun,*)"   End SPHRAY Configuration Output   "
  write(lun,*)"====================================="
  write(lun,*)
  write(lun,*)

  if (GV%FixSnapTemp) then
     write(lun,*) "***********************************************************"
     write(lun,*) "you are running a constant temperature simulation."
     write(lun,*) "the temperatures are fixed at the readin snapshot values"
     write(lun,*) "***********************************************************"
  else
     if (GV%IsoTemp > 0.0) then
        write(lun,*) "***********************************************************"
        write(lun,*) "you are running a constant temperature simulation."
        write(lun,*) "the temperature is fixed at T (K) = ", GV%IsoTemp
        write(lun,*) "***********************************************************"
     end if
  end if

 
  close(lun)

end subroutine config_info_to_file


end module config_mod

MODULE OpenGL_glut
USE OpenGL_kinds
IMPLICIT NONE
PRIVATE

!  Portions copyright (C) 2004, the OpenGLUT project contributors.
!  OpenGLUT branched from freeglut in February, 2004.
!  


!  openglut.h
!  
!  The openglut library include file
!  
!  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
!  OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
!  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
!  PAWEL W. OLSZTA BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
!  IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
!  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

!  openglut_std.h
!  
!  The GLUT-compatible part of the OpenGLUT library include file
!  
!  Portions copyright (c) 2004, the OpenGLUT project contributors.
!  OpenGLUT branched from freeglut in Feburary, 2004.
!  
!  Copyright (c) 1999-2000 Pawel W. Olszta. All Rights Reserved.
!  Written by Pawel W. Olszta, <olszta@sourceforge.net>
!  Creation date: Thu Dec 2 1999
!  
!  Permission is hereby granted, free of charge, to any person obtaining a
!  copy of this software and associated documentation files (the "Software"),
!  to deal in the Software without restriction, including without limitation
!  the rights to use, copy, modify, merge, publish, distribute, sublicense,
!  and/or sell copies of the Software, and to permit persons to whom the
!  Software is furnished to do so, subject to the following conditions:
!  
!  The above copyright notice and this permission notice shall be included
!  in all copies or substantial portions of the Software.
!  
!  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
!  OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
!  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
!  PAWEL W. OLSZTA BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
!  IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
!  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

!  The OpenGLUT, freeglut, and GLUT API versions
!  
!  FREEGLUT and FREEGLUT_VERSION are commented out.  Unless
!  OpenGLUT is going to ensure very good freeglut compatibility,
!  providing freeglut API level symbols is probably more harmful than helpful.
!  Let the application programmer use the OpenGLUT version to determine
!  features, not our pseudo-freeglut version compatibility.
!  
!  If this is an issue, we can re-enable it later.
!  
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_API_VERSION = 4

!  GLUT API macro definitions -- the special key codes:
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_F1 = z'0001'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_F2 = z'0002'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_F3 = z'0003'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_F4 = z'0004'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_F5 = z'0005'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_F6 = z'0006'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_F7 = z'0007'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_F8 = z'0008'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_F9 = z'0009'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_F10 = z'000A'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_F11 = z'000B'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_F12 = z'000C'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_LEFT = z'0064'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_UP = z'0065'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_RIGHT = z'0066'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_DOWN = z'0067'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_PAGE_UP = z'0068'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_PAGE_DOWN = z'0069'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_HOME = z'006A'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_END = z'006B'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_INSERT = z'006C'

!  GLUT API macro definitions -- mouse state definitions
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_LEFT_BUTTON = z'0000'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_MIDDLE_BUTTON = z'0001'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_RIGHT_BUTTON = z'0002'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_DOWN = z'0000'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_UP = z'0001'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_LEFT = z'0000'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_ENTERED = z'0001'

!  GLUT API macro definitions -- the display mode definitions
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_RGB = z'0000'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_RGBA = z'0000'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_INDEX = z'0001'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_SINGLE = z'0000'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_DOUBLE = z'0002'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_ACCUM = z'0004'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_ALPHA = z'0008'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_DEPTH = z'0010'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_STENCIL = z'0020'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_MULTISAMPLE = z'0080'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_STEREO = z'0100'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_LUMINANCE = z'0200'

!  GLUT API macro definitions -- windows and menu related definitions
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_MENU_NOT_IN_USE = z'0000'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_MENU_IN_USE = z'0001'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_NOT_VISIBLE = z'0000'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_VISIBLE = z'0001'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_HIDDEN = z'0000'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_FULLY_RETAINED = z'0001'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_PARTIALLY_RETAINED = z'0002'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_FULLY_COVERED = z'0003'

!  GLUT API macro definitions -- fonts definitions
! ???, , PUBLIC :: GLUT_STROKE_ROMAN=((void *)0x0000)
! ???, , PUBLIC :: GLUT_STROKE_MONO_ROMAN=((void *)0x0001)
! ???, , PUBLIC :: GLUT_BITMAP_9_BY_15=((void *)0x0002)
! ???, , PUBLIC :: GLUT_BITMAP_8_BY_13=((void *)0x0003)
! ???, , PUBLIC :: GLUT_BITMAP_TIMES_ROMAN_10=((void *)0x0004)
! ???, , PUBLIC :: GLUT_BITMAP_TIMES_ROMAN_24=((void *)0x0005)
! ???, , PUBLIC :: GLUT_BITMAP_HELVETICA_10=((void *)0x0006)
! ???, , PUBLIC :: GLUT_BITMAP_HELVETICA_12=((void *)0x0007)
! ???, , PUBLIC :: GLUT_BITMAP_HELVETICA_18=((void *)0x0008)

!  GLUT API macro definitions -- the glutGet parameters
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_X = z'0064'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_Y = z'0065'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_WIDTH = z'0066'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_HEIGHT = z'0067'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_BUFFER_SIZE = z'0068'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_STENCIL_SIZE = z'0069'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_DEPTH_SIZE = z'006A'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_RED_SIZE = z'006B'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_GREEN_SIZE = z'006C'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_BLUE_SIZE = z'006D'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_ALPHA_SIZE = z'006E'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_ACCUM_RED_SIZE = z'006F'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_ACCUM_GREEN_SIZE = z'0070'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_ACCUM_BLUE_SIZE = z'0071'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_ACCUM_ALPHA_SIZE = z'0072'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_DOUBLEBUFFER = z'0073'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_RGBA = z'0074'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_PARENT = z'0075'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_NUM_CHILDREN = z'0076'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_COLORMAP_SIZE = z'0077'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_NUM_SAMPLES = z'0078'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_STEREO = z'0079'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_CURSOR = z'007A'

INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_SCREEN_WIDTH = z'00C8'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_SCREEN_HEIGHT = z'00C9'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_SCREEN_WIDTH_MM = z'00CA'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_SCREEN_HEIGHT_MM = z'00CB'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_MENU_NUM_ITEMS = z'012C'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_DISPLAY_MODE_POSSIBLE = z'0190'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_INIT_WINDOW_X = z'01F4'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_INIT_WINDOW_Y = z'01F5'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_INIT_WINDOW_WIDTH = z'01F6'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_INIT_WINDOW_HEIGHT = z'01F7'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_INIT_DISPLAY_MODE = z'01F8'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_ELAPSED_TIME = z'02BC'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_FORMAT_ID = z'007B'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_INIT_STATE = z'007C'

!  GLUT API macro definitions -- the glutDeviceGet parameters
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_HAS_KEYBOARD = z'0258'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_HAS_MOUSE = z'0259'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_HAS_SPACEBALL = z'025A'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_HAS_DIAL_AND_BUTTON_BOX = z'025B'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_HAS_TABLET = z'025C'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_NUM_MOUSE_BUTTONS = z'025D'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_NUM_SPACEBALL_BUTTONS = z'025E'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_NUM_BUTTON_BOX_BUTTONS = z'025F'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_NUM_DIALS = z'0260'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_NUM_TABLET_BUTTONS = z'0261'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_DEVICE_IGNORE_KEY_REPEAT = z'0262'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_DEVICE_KEY_REPEAT = z'0263'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_HAS_JOYSTICK = z'0264'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_OWNS_JOYSTICK = z'0265'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_JOYSTICK_BUTTONS = z'0266'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_JOYSTICK_AXES = z'0267'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_JOYSTICK_POLL_RATE = z'0268'

!  GLUT API macro definitions -- the glutLayerGet parameters
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_OVERLAY_POSSIBLE = z'0320'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_LAYER_IN_USE = z'0321'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_HAS_OVERLAY = z'0322'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_TRANSPARENT_INDEX = z'0323'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_NORMAL_DAMAGED = z'0324'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_OVERLAY_DAMAGED = z'0325'

!  GLUT API macro definitions -- the glutVideoResizeGet parameters
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_VIDEO_RESIZE_POSSIBLE = z'0384'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_VIDEO_RESIZE_IN_USE = z'0385'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_VIDEO_RESIZE_X_DELTA = z'0386'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_VIDEO_RESIZE_Y_DELTA = z'0387'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_VIDEO_RESIZE_WIDTH_DELTA = z'0388'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_VIDEO_RESIZE_HEIGHT_DELTA = z'0389'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_VIDEO_RESIZE_X = z'038A'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_VIDEO_RESIZE_Y = z'038B'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_VIDEO_RESIZE_WIDTH = z'038C'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_VIDEO_RESIZE_HEIGHT = z'038D'

!  GLUT API macro definitions -- the glutUseLayer parameters
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_NORMAL = z'0000'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_OVERLAY = z'0001'

!  GLUT API macro definitions -- the glutGetModifiers parameters
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_ACTIVE_SHIFT = z'0001'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_ACTIVE_CTRL = z'0002'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_ACTIVE_ALT = z'0004'

!  GLUT API macro definitions -- the glutSetCursor parameters
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_RIGHT_ARROW = z'0000'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_LEFT_ARROW = z'0001'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_INFO = z'0002'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_DESTROY = z'0003'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_HELP = z'0004'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_CYCLE = z'0005'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_SPRAY = z'0006'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_WAIT = z'0007'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_TEXT = z'0008'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_CROSSHAIR = z'0009'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_UP_DOWN = z'000A'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_LEFT_RIGHT = z'000B'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_TOP_SIDE = z'000C'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_BOTTOM_SIDE = z'000D'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_LEFT_SIDE = z'000E'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_RIGHT_SIDE = z'000F'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_TOP_LEFT_CORNER = z'0010'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_TOP_RIGHT_CORNER = z'0011'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_BOTTOM_RIGHT_CORNER = z'0012'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_BOTTOM_LEFT_CORNER = z'0013'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_INHERIT = z'0064'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_NONE = z'0065'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CURSOR_FULL_CROSSHAIR = z'0066'

!  GLUT API macro definitions -- RGB color component specification definitions
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_RED = z'0000'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_GREEN = z'0001'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_BLUE = z'0002'

!  GLUT API macro definitions -- additional keyboard and joystick definitions
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_REPEAT_OFF = z'0000'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_REPEAT_ON = z'0001'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_KEY_REPEAT_DEFAULT = z'0002'

INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_JOYSTICK_BUTTON_A = z'0001'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_JOYSTICK_BUTTON_B = z'0002'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_JOYSTICK_BUTTON_C = z'0004'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_JOYSTICK_BUTTON_D = z'0008'

!  GLUT API macro definitions -- game mode definitions
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_GAME_MODE_ACTIVE = z'0000'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_GAME_MODE_POSSIBLE = z'0001'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_GAME_MODE_WIDTH = z'0002'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_GAME_MODE_HEIGHT = z'0003'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_GAME_MODE_PIXEL_DEPTH = z'0004'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_GAME_MODE_REFRESH_RATE = z'0005'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_GAME_MODE_DISPLAY_CHANGED = z'0006'

!  Initialization functions, see og_init.c
!  void    glutInit( int* pargc, char** argv )
PUBLIC glutInit
INTERFACE glutInit
MODULE PROCEDURE glutInit_f03
END INTERFACE glutInit
INTERFACE
SUBROUTINE glutInit_gl(pargc, argv) BIND(C,NAME="glutInit")
IMPORT
! INTEGER(GLint), DIMENSION(*) :: pargc
INTEGER(GLint) :: pargc
TYPE(C_PTR), INTENT(IN) :: argv
END SUBROUTINE glutInit_gl
END INTERFACE

!  void    glutInitWindowPosition( int x, int y )
PUBLIC glutInitWindowPosition
INTERFACE
SUBROUTINE glutInitWindowPosition(x, y) BIND(C,NAME="glutInitWindowPosition")
IMPORT
INTEGER(GLint), VALUE :: x, y
END SUBROUTINE glutInitWindowPosition
END INTERFACE

!  void    glutInitWindowSize( int width, int height )
PUBLIC glutInitWindowSize
INTERFACE
SUBROUTINE glutInitWindowSize(width, height) BIND(C,NAME="glutInitWindowSize")
IMPORT
INTEGER(GLint), VALUE :: width, height
END SUBROUTINE glutInitWindowSize
END INTERFACE

!  void    glutInitDisplayMode( unsigned int displayMode )
PUBLIC glutInitDisplayMode
INTERFACE
SUBROUTINE glutInitDisplayMode(displayMode) BIND(C,NAME="glutInitDisplayMode")
IMPORT
INTEGER(GLuint), VALUE :: displayMode
END SUBROUTINE glutInitDisplayMode
END INTERFACE

!  void    glutInitDisplayString( const char* displayMode )
PUBLIC glutInitDisplayString
INTERFACE
SUBROUTINE glutInitDisplayString(displayMode) BIND(C,NAME="glutInitDisplayString")
IMPORT
! CHARACTER, INTENT(IN) :: displayMode
CHARACTER(C_CHAR), DIMENSION(*), INTENT(IN) :: displayMode
END SUBROUTINE glutInitDisplayString
END INTERFACE


!  Process loop function, see og_main.c
!  void    glutMainLoop( void )
PUBLIC glutMainLoop
INTERFACE
SUBROUTINE glutMainLoop() BIND(C,NAME="glutMainLoop")
IMPORT
END SUBROUTINE glutMainLoop
END INTERFACE


!  Window management functions, see og_window.c
!  int     glutCreateWindow( const char* title )
PUBLIC glutCreateWindow
INTERFACE
FUNCTION glutCreateWindow(title) BIND(C,NAME="glutCreateWindow")
IMPORT
INTEGER(GLint) :: glutCreateWindow
! CHARACTER, INTENT(IN) :: title
CHARACTER(C_CHAR), DIMENSION(*), INTENT(IN) :: title
END FUNCTION glutCreateWindow
END INTERFACE

!  int     glutCreateSubWindow(    int window, int x, int y, int width, int height)
PUBLIC glutCreateSubWindow
INTERFACE
FUNCTION glutCreateSubWindow(window, x, y, width, height) BIND(C,NAME="glutCreateSubWindow")
IMPORT
INTEGER(GLint) :: glutCreateSubWindow
INTEGER(GLint), VALUE :: window, x, y, width, height
END FUNCTION glutCreateSubWindow
END INTERFACE

!  void    glutDestroyWindow( int window )
PUBLIC glutDestroyWindow
INTERFACE
SUBROUTINE glutDestroyWindow(window) BIND(C,NAME="glutDestroyWindow")
IMPORT
INTEGER(GLint), VALUE :: window
END SUBROUTINE glutDestroyWindow
END INTERFACE

!  void    glutSetWindow( int window )
PUBLIC glutSetWindow
INTERFACE
SUBROUTINE glutSetWindow(window) BIND(C,NAME="glutSetWindow")
IMPORT
INTEGER(GLint), VALUE :: window
END SUBROUTINE glutSetWindow
END INTERFACE

!  int     glutGetWindow( void )
PUBLIC glutGetWindow
INTERFACE
FUNCTION glutGetWindow() BIND(C,NAME="glutGetWindow")
IMPORT
INTEGER(GLint) :: glutGetWindow
END FUNCTION glutGetWindow
END INTERFACE

!  void    glutSetWindowTitle( const char* title )
PUBLIC glutSetWindowTitle
INTERFACE
SUBROUTINE glutSetWindowTitle(title) BIND(C,NAME="glutSetWindowTitle")
IMPORT
! CHARACTER, INTENT(IN) :: title
CHARACTER(C_CHAR), DIMENSION(*), INTENT(IN) :: title
END SUBROUTINE glutSetWindowTitle
END INTERFACE

!  void    glutSetIconTitle( const char* title )
PUBLIC glutSetIconTitle
INTERFACE
SUBROUTINE glutSetIconTitle(title) BIND(C,NAME="glutSetIconTitle")
IMPORT
! CHARACTER, INTENT(IN) :: title
CHARACTER(C_CHAR), DIMENSION(*), INTENT(IN) :: title
END SUBROUTINE glutSetIconTitle
END INTERFACE

!  void    glutReshapeWindow( int width, int height )
PUBLIC glutReshapeWindow
INTERFACE
SUBROUTINE glutReshapeWindow(width, height) BIND(C,NAME="glutReshapeWindow")
IMPORT
INTEGER(GLint), VALUE :: width, height
END SUBROUTINE glutReshapeWindow
END INTERFACE

!  void    glutPositionWindow( int x, int y )
PUBLIC glutPositionWindow
INTERFACE
SUBROUTINE glutPositionWindow(x, y) BIND(C,NAME="glutPositionWindow")
IMPORT
INTEGER(GLint), VALUE :: x, y
END SUBROUTINE glutPositionWindow
END INTERFACE

!  void    glutShowWindow( void )
PUBLIC glutShowWindow
INTERFACE
SUBROUTINE glutShowWindow() BIND(C,NAME="glutShowWindow")
IMPORT
END SUBROUTINE glutShowWindow
END INTERFACE

!  void    glutHideWindow( void )
PUBLIC glutHideWindow
INTERFACE
SUBROUTINE glutHideWindow() BIND(C,NAME="glutHideWindow")
IMPORT
END SUBROUTINE glutHideWindow
END INTERFACE

!  void    glutIconifyWindow( void )
PUBLIC glutIconifyWindow
INTERFACE
SUBROUTINE glutIconifyWindow() BIND(C,NAME="glutIconifyWindow")
IMPORT
END SUBROUTINE glutIconifyWindow
END INTERFACE

!  void    glutPushWindow( void )
PUBLIC glutPushWindow
INTERFACE
SUBROUTINE glutPushWindow() BIND(C,NAME="glutPushWindow")
IMPORT
END SUBROUTINE glutPushWindow
END INTERFACE

!  void    glutPopWindow( void )
PUBLIC glutPopWindow
INTERFACE
SUBROUTINE glutPopWindow() BIND(C,NAME="glutPopWindow")
IMPORT
END SUBROUTINE glutPopWindow
END INTERFACE

!  void    glutFullScreen( void )
PUBLIC glutFullScreen
INTERFACE
SUBROUTINE glutFullScreen() BIND(C,NAME="glutFullScreen")
IMPORT
END SUBROUTINE glutFullScreen
END INTERFACE


!  Display-connected functions, see og_display.c
!  void    glutPostWindowRedisplay( int window )
PUBLIC glutPostWindowRedisplay
INTERFACE
SUBROUTINE glutPostWindowRedisplay(window) BIND(C,NAME="glutPostWindowRedisplay")
IMPORT
INTEGER(GLint), VALUE :: window
END SUBROUTINE glutPostWindowRedisplay
END INTERFACE

!  void    glutPostRedisplay( void )
PUBLIC glutPostRedisplay
INTERFACE
SUBROUTINE glutPostRedisplay() BIND(C,NAME="glutPostRedisplay")
IMPORT
END SUBROUTINE glutPostRedisplay
END INTERFACE

!  void    glutSwapBuffers( void )
PUBLIC glutSwapBuffers
INTERFACE
SUBROUTINE glutSwapBuffers() BIND(C,NAME="glutSwapBuffers")
IMPORT
END SUBROUTINE glutSwapBuffers
END INTERFACE


!  Mouse cursor functions, see og_cursor.c
!  void    glutWarpPointer( int x, int y )
PUBLIC glutWarpPointer
INTERFACE
SUBROUTINE glutWarpPointer(x, y) BIND(C,NAME="glutWarpPointer")
IMPORT
INTEGER(GLint), VALUE :: x, y
END SUBROUTINE glutWarpPointer
END INTERFACE

!  void    glutSetCursor( int cursor )
PUBLIC glutSetCursor
INTERFACE
SUBROUTINE glutSetCursor(cursor) BIND(C,NAME="glutSetCursor")
IMPORT
INTEGER(GLint), VALUE :: cursor
END SUBROUTINE glutSetCursor
END INTERFACE


!  Overlay stuff, see og_overlay.c
!  void    glutEstablishOverlay( void )
PUBLIC glutEstablishOverlay
INTERFACE
SUBROUTINE glutEstablishOverlay() BIND(C,NAME="glutEstablishOverlay")
IMPORT
END SUBROUTINE glutEstablishOverlay
END INTERFACE

!  void    glutRemoveOverlay( void )
PUBLIC glutRemoveOverlay
INTERFACE
SUBROUTINE glutRemoveOverlay() BIND(C,NAME="glutRemoveOverlay")
IMPORT
END SUBROUTINE glutRemoveOverlay
END INTERFACE

!  void    glutUseLayer( GLenum layer )
PUBLIC glutUseLayer
INTERFACE
SUBROUTINE glutUseLayer(layer) BIND(C,NAME="glutUseLayer")
IMPORT
INTEGER(GLenum), VALUE :: layer
END SUBROUTINE glutUseLayer
END INTERFACE

!  void    glutPostOverlayRedisplay( void )
PUBLIC glutPostOverlayRedisplay
INTERFACE
SUBROUTINE glutPostOverlayRedisplay() BIND(C,NAME="glutPostOverlayRedisplay")
IMPORT
END SUBROUTINE glutPostOverlayRedisplay
END INTERFACE

!  void    glutPostWindowOverlayRedisplay( int window )
PUBLIC glutPostWindowOverlayRedisplay
INTERFACE
SUBROUTINE glutPostWindowOverlayRedisplay(window) BIND(C,NAME="glutPostWindowOverlayRedisplay")
IMPORT
INTEGER(GLint), VALUE :: window
END SUBROUTINE glutPostWindowOverlayRedisplay
END INTERFACE

!  void    glutShowOverlay( void )
PUBLIC glutShowOverlay
INTERFACE
SUBROUTINE glutShowOverlay() BIND(C,NAME="glutShowOverlay")
IMPORT
END SUBROUTINE glutShowOverlay
END INTERFACE

!  void    glutHideOverlay( void )
PUBLIC glutHideOverlay
INTERFACE
SUBROUTINE glutHideOverlay() BIND(C,NAME="glutHideOverlay")
IMPORT
END SUBROUTINE glutHideOverlay
END INTERFACE


!  Menu stuff, see og_menu.c
!  int     glutCreateMenu( void (* callback)( int menu ) )
PUBLIC glutCreateMenu
INTERFACE
FUNCTION glutCreateMenu(proc) BIND(C,NAME="glutCreateMenu")
IMPORT
INTEGER(GLint) :: glutCreateMenu
!  void proc( int menu )
INTERFACE
SUBROUTINE proc(menu) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: menu
END SUBROUTINE proc
END INTERFACE
END FUNCTION glutCreateMenu
END INTERFACE

!  void    glutDestroyMenu( int menu )
PUBLIC glutDestroyMenu
INTERFACE
SUBROUTINE glutDestroyMenu(menu) BIND(C,NAME="glutDestroyMenu")
IMPORT
INTEGER(GLint), VALUE :: menu
END SUBROUTINE glutDestroyMenu
END INTERFACE

!  int     glutGetMenu( void )
PUBLIC glutGetMenu
INTERFACE
FUNCTION glutGetMenu() BIND(C,NAME="glutGetMenu")
IMPORT
INTEGER(GLint) :: glutGetMenu
END FUNCTION glutGetMenu
END INTERFACE

!  void    glutSetMenu( int menu )
PUBLIC glutSetMenu
INTERFACE
SUBROUTINE glutSetMenu(menu) BIND(C,NAME="glutSetMenu")
IMPORT
INTEGER(GLint), VALUE :: menu
END SUBROUTINE glutSetMenu
END INTERFACE

!  void    glutAddMenuEntry( const char* label, int value )
PUBLIC glutAddMenuEntry
INTERFACE
SUBROUTINE glutAddMenuEntry(label, value) BIND(C,NAME="glutAddMenuEntry")
IMPORT
! CHARACTER, INTENT(IN) :: label
CHARACTER(C_CHAR), DIMENSION(*), INTENT(IN) :: label
INTEGER(GLint), VALUE :: value
END SUBROUTINE glutAddMenuEntry
END INTERFACE

!  void    glutAddSubMenu( const char* label, int subMenu )
PUBLIC glutAddSubMenu
INTERFACE
SUBROUTINE glutAddSubMenu(label, subMenu) BIND(C,NAME="glutAddSubMenu")
IMPORT
! CHARACTER, INTENT(IN) :: label
CHARACTER(C_CHAR), DIMENSION(*), INTENT(IN) :: label
INTEGER(GLint), VALUE :: subMenu
END SUBROUTINE glutAddSubMenu
END INTERFACE

!  void    glutChangeToMenuEntry(    int item, const char* label, int value)
PUBLIC glutChangeToMenuEntry
INTERFACE
SUBROUTINE glutChangeToMenuEntry(item, label, value) BIND(C,NAME="glutChangeToMenuEntry")
IMPORT
! CHARACTER, INTENT(IN) :: label
CHARACTER(C_CHAR), DIMENSION(*), INTENT(IN) :: label
INTEGER(GLint), VALUE :: item, value
END SUBROUTINE glutChangeToMenuEntry
END INTERFACE

!  void    glutChangeToSubMenu(    int item, const char* label, int value)
PUBLIC glutChangeToSubMenu
INTERFACE
SUBROUTINE glutChangeToSubMenu(item, label, value) BIND(C,NAME="glutChangeToSubMenu")
IMPORT
! CHARACTER, INTENT(IN) :: label
CHARACTER(C_CHAR), DIMENSION(*), INTENT(IN) :: label
INTEGER(GLint), VALUE :: item, value
END SUBROUTINE glutChangeToSubMenu
END INTERFACE

!  void    glutRemoveMenuItem( int item )
PUBLIC glutRemoveMenuItem
INTERFACE
SUBROUTINE glutRemoveMenuItem(item) BIND(C,NAME="glutRemoveMenuItem")
IMPORT
INTEGER(GLint), VALUE :: item
END SUBROUTINE glutRemoveMenuItem
END INTERFACE

!  void    glutAttachMenu( int button )
PUBLIC glutAttachMenu
INTERFACE
SUBROUTINE glutAttachMenu(button) BIND(C,NAME="glutAttachMenu")
IMPORT
INTEGER(GLint), VALUE :: button
END SUBROUTINE glutAttachMenu
END INTERFACE

!  void    glutDetachMenu( int button )
PUBLIC glutDetachMenu
INTERFACE
SUBROUTINE glutDetachMenu(button) BIND(C,NAME="glutDetachMenu")
IMPORT
INTEGER(GLint), VALUE :: button
END SUBROUTINE glutDetachMenu
END INTERFACE


!  Global callback functions, see og_callbacks.c
!  void    glutTimerFunc(    unsigned int time, void (* callback)( int value), int value)
PUBLIC glutTimerFunc
INTERFACE glutTimerFunc
MODULE PROCEDURE glutTimerFunc_f03
END INTERFACE glutTimerFunc
INTERFACE
SUBROUTINE glutTimerFunc_gl(time, proc, value) BIND(C,NAME="glutTimerFunc")
IMPORT
INTEGER(GLint), VALUE :: value
INTEGER(GLuint), VALUE :: time
!  void proc( int value)
TYPE(C_FUNPTR), VALUE :: proc
END SUBROUTINE glutTimerFunc_gl
END INTERFACE

!  void    glutIdleFunc( void (* callback)( void ) )
PUBLIC glutIdleFunc
INTERFACE glutIdleFunc
MODULE PROCEDURE glutIdleFunc_f03
END INTERFACE glutIdleFunc
INTERFACE
SUBROUTINE glutIdleFunc_gl(proc) BIND(C,NAME="glutIdleFunc")
IMPORT
!  void proc( void )
TYPE(C_FUNPTR), VALUE :: proc
END SUBROUTINE glutIdleFunc_gl
END INTERFACE


!  Window-specific callback functions, see og_callbacks.c
!  void    glutKeyboardFunc(    void (* callback)( unsigned char key, int x, int y))
PUBLIC glutKeyboardFunc
INTERFACE glutKeyboardFunc
MODULE PROCEDURE glutKeyboardFunc_f03
END INTERFACE glutKeyboardFunc
INTERFACE
SUBROUTINE glutKeyboardFunc_gl(proc) BIND(C,NAME="glutKeyboardFunc")
IMPORT
!  void proc( unsigned char key, int x, int y)
TYPE(C_FUNPTR), VALUE :: proc
END SUBROUTINE glutKeyboardFunc_gl
END INTERFACE

!  void    glutSpecialFunc( void (* callback)( int key, int x, int y ) )
PUBLIC glutSpecialFunc
INTERFACE glutSpecialFunc
MODULE PROCEDURE glutSpecialFunc_f03
END INTERFACE glutSpecialFunc
INTERFACE
SUBROUTINE glutSpecialFunc_gl(proc) BIND(C,NAME="glutSpecialFunc")
IMPORT
!  void proc( int key, int x, int y )
TYPE(C_FUNPTR), VALUE :: proc
END SUBROUTINE glutSpecialFunc_gl
END INTERFACE

!  void    glutReshapeFunc( void (* callback)( int h, int w) )
PUBLIC glutReshapeFunc
INTERFACE glutReshapeFunc
MODULE PROCEDURE glutReshapeFunc_f03
END INTERFACE glutReshapeFunc
INTERFACE
SUBROUTINE glutReshapeFunc_gl(proc) BIND(C,NAME="glutReshapeFunc")
IMPORT
!  void proc( int h, int w)
TYPE(C_FUNPTR), VALUE :: proc
END SUBROUTINE glutReshapeFunc_gl
END INTERFACE

!  void    glutVisibilityFunc( void (* callback)( int visible) )
PUBLIC glutVisibilityFunc
INTERFACE glutVisibilityFunc
MODULE PROCEDURE glutVisibilityFunc_f03
END INTERFACE glutVisibilityFunc
INTERFACE
SUBROUTINE glutVisibilityFunc_gl(proc) BIND(C,NAME="glutVisibilityFunc")
IMPORT
!  void proc( int visible)
TYPE(C_FUNPTR), VALUE :: proc
END SUBROUTINE glutVisibilityFunc_gl
END INTERFACE

!  void    glutDisplayFunc( void (* callback)( void ) )
PUBLIC glutDisplayFunc
INTERFACE glutDisplayFunc
MODULE PROCEDURE glutDisplayFunc_f03
END INTERFACE glutDisplayFunc
INTERFACE
SUBROUTINE glutDisplayFunc_gl(proc) BIND(C,NAME="glutDisplayFunc")
IMPORT
!  void proc( void )
TYPE(C_FUNPTR), VALUE :: proc
END SUBROUTINE glutDisplayFunc_gl
END INTERFACE

!  void    glutMouseFunc(    void (* callback)( int button, int state, int x, int y ))
PUBLIC glutMouseFunc
INTERFACE glutMouseFunc
MODULE PROCEDURE glutMouseFunc_f03
END INTERFACE glutMouseFunc
INTERFACE
SUBROUTINE glutMouseFunc_gl(proc) BIND(C,NAME="glutMouseFunc")
IMPORT
!  void proc( int button, int state, int x, int y )
TYPE(C_FUNPTR), VALUE :: proc
END SUBROUTINE glutMouseFunc_gl
END INTERFACE

!  void    glutMotionFunc( void (* callback)( int x, int y) )
PUBLIC glutMotionFunc
INTERFACE glutMotionFunc
MODULE PROCEDURE glutMotionFunc_f03
END INTERFACE glutMotionFunc
INTERFACE
SUBROUTINE glutMotionFunc_gl(proc) BIND(C,NAME="glutMotionFunc")
IMPORT
!  void proc( int x, int y)
TYPE(C_FUNPTR), VALUE :: proc
END SUBROUTINE glutMotionFunc_gl
END INTERFACE

!  void    glutPassiveMotionFunc(    void (* callback)( int x, int y))
PUBLIC glutPassiveMotionFunc
INTERFACE glutPassiveMotionFunc
MODULE PROCEDURE glutPassiveMotionFunc_f03
END INTERFACE glutPassiveMotionFunc
INTERFACE
SUBROUTINE glutPassiveMotionFunc_gl(proc) BIND(C,NAME="glutPassiveMotionFunc")
IMPORT
!  void proc( int x, int y)
TYPE(C_FUNPTR), VALUE :: proc
END SUBROUTINE glutPassiveMotionFunc_gl
END INTERFACE

!  void    glutEntryFunc( void (* callback)( int value) )
PUBLIC glutEntryFunc
INTERFACE glutEntryFunc
MODULE PROCEDURE glutEntryFunc_f03
END INTERFACE glutEntryFunc
INTERFACE
SUBROUTINE glutEntryFunc_gl(proc) BIND(C,NAME="glutEntryFunc")
IMPORT
!  void proc( int value)
TYPE(C_FUNPTR), VALUE :: proc
END SUBROUTINE glutEntryFunc_gl
END INTERFACE


!  void    glutKeyboardUpFunc(    void (* callback)( unsigned char key, int x, int y))
PUBLIC glutKeyboardUpFunc
INTERFACE glutKeyboardUpFunc
MODULE PROCEDURE glutKeyboardUpFunc_f03
END INTERFACE glutKeyboardUpFunc
INTERFACE
SUBROUTINE glutKeyboardUpFunc_gl(proc) BIND(C,NAME="glutKeyboardUpFunc")
IMPORT
!  void proc( unsigned char key, int x, int y)
TYPE(C_FUNPTR), VALUE :: proc
END SUBROUTINE glutKeyboardUpFunc_gl
END INTERFACE

!  void    glutSpecialUpFunc(    void (* callback)( int key, int x, int y))
PUBLIC glutSpecialUpFunc
INTERFACE glutSpecialUpFunc
MODULE PROCEDURE glutSpecialUpFunc_f03
END INTERFACE glutSpecialUpFunc
INTERFACE
SUBROUTINE glutSpecialUpFunc_gl(proc) BIND(C,NAME="glutSpecialUpFunc")
IMPORT
!  void proc( int key, int x, int y)
TYPE(C_FUNPTR), VALUE :: proc
END SUBROUTINE glutSpecialUpFunc_gl
END INTERFACE

!  void    glutJoystickFunc(    void (* callback)( unsigned int buttonMask, int x, int y, int z ), int pollInterval)
PUBLIC glutJoystickFunc
INTERFACE glutJoystickFunc
MODULE PROCEDURE glutJoystickFunc_f03
END INTERFACE glutJoystickFunc
INTERFACE
SUBROUTINE glutJoystickFunc_gl(proc, pollInterval) BIND(C,NAME="glutJoystickFunc")
IMPORT
INTEGER(GLint), VALUE :: pollInterval
!  void proc( unsigned int buttonMask, int x, int y, int z )
TYPE(C_FUNPTR), VALUE :: proc
END SUBROUTINE glutJoystickFunc_gl
END INTERFACE

!  void    glutMenuStateFunc( void (* callback)( int menu ) )
PUBLIC glutMenuStateFunc
INTERFACE glutMenuStateFunc
MODULE PROCEDURE glutMenuStateFunc_f03
END INTERFACE glutMenuStateFunc
INTERFACE
SUBROUTINE glutMenuStateFunc_gl(proc) BIND(C,NAME="glutMenuStateFunc")
IMPORT
!  void proc( int menu )
TYPE(C_FUNPTR), VALUE :: proc
END SUBROUTINE glutMenuStateFunc_gl
END INTERFACE

!  void    glutMenuStatusFunc(    void (* callback)( int status, int x, int y))
PUBLIC glutMenuStatusFunc
INTERFACE glutMenuStatusFunc
MODULE PROCEDURE glutMenuStatusFunc_f03
END INTERFACE glutMenuStatusFunc
INTERFACE
SUBROUTINE glutMenuStatusFunc_gl(proc) BIND(C,NAME="glutMenuStatusFunc")
IMPORT
!  void proc( int status, int x, int y)
TYPE(C_FUNPTR), VALUE :: proc
END SUBROUTINE glutMenuStatusFunc_gl
END INTERFACE

!  void    glutOverlayDisplayFunc( void (* callback)( void ) )
PUBLIC glutOverlayDisplayFunc
INTERFACE glutOverlayDisplayFunc
MODULE PROCEDURE glutOverlayDisplayFunc_f03
END INTERFACE glutOverlayDisplayFunc
INTERFACE
SUBROUTINE glutOverlayDisplayFunc_gl(proc) BIND(C,NAME="glutOverlayDisplayFunc")
IMPORT
!  void proc( void )
TYPE(C_FUNPTR), VALUE :: proc
END SUBROUTINE glutOverlayDisplayFunc_gl
END INTERFACE

!  void    glutWindowStatusFunc( void (* callback)( int status) )
PUBLIC glutWindowStatusFunc
INTERFACE glutWindowStatusFunc
MODULE PROCEDURE glutWindowStatusFunc_f03
END INTERFACE glutWindowStatusFunc
INTERFACE
SUBROUTINE glutWindowStatusFunc_gl(proc) BIND(C,NAME="glutWindowStatusFunc")
IMPORT
!  void proc( int status)
TYPE(C_FUNPTR), VALUE :: proc
END SUBROUTINE glutWindowStatusFunc_gl
END INTERFACE


!  void    glutSpaceballMotionFunc(    void (* callback)( int key, int x, int y ))
PUBLIC glutSpaceballMotionFunc
INTERFACE glutSpaceballMotionFunc
MODULE PROCEDURE glutSpaceballMotionFunc_f03
END INTERFACE glutSpaceballMotionFunc
INTERFACE
SUBROUTINE glutSpaceballMotionFunc_gl(proc) BIND(C,NAME="glutSpaceballMotionFunc")
IMPORT
!  void proc( int key, int x, int y )
TYPE(C_FUNPTR), VALUE :: proc
END SUBROUTINE glutSpaceballMotionFunc_gl
END INTERFACE

!  void    glutSpaceballRotateFunc(    void (* callback)( int key, int x, int y ))
PUBLIC glutSpaceballRotateFunc
INTERFACE glutSpaceballRotateFunc
MODULE PROCEDURE glutSpaceballRotateFunc_f03
END INTERFACE glutSpaceballRotateFunc
INTERFACE
SUBROUTINE glutSpaceballRotateFunc_gl(proc) BIND(C,NAME="glutSpaceballRotateFunc")
IMPORT
!  void proc( int key, int x, int y )
TYPE(C_FUNPTR), VALUE :: proc
END SUBROUTINE glutSpaceballRotateFunc_gl
END INTERFACE

!  void    glutSpaceballButtonFunc(    void (* callback)( int x, int y))
PUBLIC glutSpaceballButtonFunc
INTERFACE glutSpaceballButtonFunc
MODULE PROCEDURE glutSpaceballButtonFunc_f03
END INTERFACE glutSpaceballButtonFunc
INTERFACE
SUBROUTINE glutSpaceballButtonFunc_gl(proc) BIND(C,NAME="glutSpaceballButtonFunc")
IMPORT
!  void proc( int x, int y)
TYPE(C_FUNPTR), VALUE :: proc
END SUBROUTINE glutSpaceballButtonFunc_gl
END INTERFACE

!  void    glutButtonBoxFunc( void (* callback)( int x, int y ) )
PUBLIC glutButtonBoxFunc
INTERFACE glutButtonBoxFunc
MODULE PROCEDURE glutButtonBoxFunc_f03
END INTERFACE glutButtonBoxFunc
INTERFACE
SUBROUTINE glutButtonBoxFunc_gl(proc) BIND(C,NAME="glutButtonBoxFunc")
IMPORT
!  void proc( int x, int y )
TYPE(C_FUNPTR), VALUE :: proc
END SUBROUTINE glutButtonBoxFunc_gl
END INTERFACE

!  void    glutDialsFunc( void (* callback)( int x, int y ) )
PUBLIC glutDialsFunc
INTERFACE glutDialsFunc
MODULE PROCEDURE glutDialsFunc_f03
END INTERFACE glutDialsFunc
INTERFACE
SUBROUTINE glutDialsFunc_gl(proc) BIND(C,NAME="glutDialsFunc")
IMPORT
!  void proc( int x, int y )
TYPE(C_FUNPTR), VALUE :: proc
END SUBROUTINE glutDialsFunc_gl
END INTERFACE

!  void    glutTabletMotionFunc( void (* callback)( int x, int y ) )
PUBLIC glutTabletMotionFunc
INTERFACE glutTabletMotionFunc
MODULE PROCEDURE glutTabletMotionFunc_f03
END INTERFACE glutTabletMotionFunc
INTERFACE
SUBROUTINE glutTabletMotionFunc_gl(proc) BIND(C,NAME="glutTabletMotionFunc")
IMPORT
!  void proc( int x, int y )
TYPE(C_FUNPTR), VALUE :: proc
END SUBROUTINE glutTabletMotionFunc_gl
END INTERFACE

!  void    glutTabletButtonFunc(    void (* callback)( int button, int state, int x, int y ))
PUBLIC glutTabletButtonFunc
INTERFACE glutTabletButtonFunc
MODULE PROCEDURE glutTabletButtonFunc_f03
END INTERFACE glutTabletButtonFunc
INTERFACE
SUBROUTINE glutTabletButtonFunc_gl(proc) BIND(C,NAME="glutTabletButtonFunc")
IMPORT
!  void proc( int button, int state, int x, int y )
TYPE(C_FUNPTR), VALUE :: proc
END SUBROUTINE glutTabletButtonFunc_gl
END INTERFACE


!  State setting and retrieval functions, see og_state.c
!  int     glutGet( GLenum query )
PUBLIC glutGet
INTERFACE
FUNCTION glutGet(query) BIND(C,NAME="glutGet")
IMPORT
INTEGER(GLint) :: glutGet
INTEGER(GLenum), VALUE :: query
END FUNCTION glutGet
END INTERFACE

!  int     glutDeviceGet( GLenum query )
PUBLIC glutDeviceGet
INTERFACE
FUNCTION glutDeviceGet(query) BIND(C,NAME="glutDeviceGet")
IMPORT
INTEGER(GLint) :: glutDeviceGet
INTEGER(GLenum), VALUE :: query
END FUNCTION glutDeviceGet
END INTERFACE

!  int     glutGetModifiers( void )
PUBLIC glutGetModifiers
INTERFACE
FUNCTION glutGetModifiers() BIND(C,NAME="glutGetModifiers")
IMPORT
INTEGER(GLint) :: glutGetModifiers
END FUNCTION glutGetModifiers
END INTERFACE

!  int     glutLayerGet( GLenum query )
PUBLIC glutLayerGet
INTERFACE
FUNCTION glutLayerGet(query) BIND(C,NAME="glutLayerGet")
IMPORT
INTEGER(GLint) :: glutLayerGet
INTEGER(GLenum), VALUE :: query
END FUNCTION glutLayerGet
END INTERFACE


!  Font stuff, see og_font.c
!  void  glutBitmapCharacter( void* font, int character )
PUBLIC glutBitmapCharacter
INTERFACE
SUBROUTINE glutBitmapCharacter(font, character) BIND(C,NAME="glutBitmapCharacter")
IMPORT
INTEGER(GLint), VALUE :: character
TYPE(C_PTR), VALUE :: font
END SUBROUTINE glutBitmapCharacter
END INTERFACE

!  int   glutBitmapWidth( void* font, int character )
PUBLIC glutBitmapWidth
INTERFACE
FUNCTION glutBitmapWidth(font, character) BIND(C,NAME="glutBitmapWidth")
IMPORT
INTEGER(GLint) :: glutBitmapWidth
INTEGER(GLint), VALUE :: character
TYPE(C_PTR), VALUE :: font
END FUNCTION glutBitmapWidth
END INTERFACE

!  void  glutStrokeCharacter( void* font, int character )
PUBLIC glutStrokeCharacter
INTERFACE
SUBROUTINE glutStrokeCharacter(font, character) BIND(C,NAME="glutStrokeCharacter")
IMPORT
INTEGER(GLint), VALUE :: character
TYPE(C_PTR), VALUE :: font
END SUBROUTINE glutStrokeCharacter
END INTERFACE

!  float glutStrokeWidth( void* font, int character )
PUBLIC glutStrokeWidth
INTERFACE
FUNCTION glutStrokeWidth(font, character) BIND(C,NAME="glutStrokeWidth")
IMPORT
REAL(C_FLOAT) :: glutStrokeWidth
INTEGER(GLint), VALUE :: character
TYPE(C_PTR), VALUE :: font
END FUNCTION glutStrokeWidth
END INTERFACE

!  int   glutBitmapLength( void* font, const unsigned char* string )
PUBLIC glutBitmapLength
INTERFACE
FUNCTION glutBitmapLength(font, string) BIND(C,NAME="glutBitmapLength")
IMPORT
INTEGER(GLint) :: glutBitmapLength
! CHARACTER, INTENT(IN) :: string
CHARACTER(C_CHAR), DIMENSION(*), INTENT(IN) :: string
TYPE(C_PTR), VALUE :: font
END FUNCTION glutBitmapLength
END INTERFACE

!  float glutStrokeLength( void* font, const unsigned char* string )
PUBLIC glutStrokeLength
INTERFACE
FUNCTION glutStrokeLength(font, string) BIND(C,NAME="glutStrokeLength")
IMPORT
REAL(C_FLOAT) :: glutStrokeLength
! CHARACTER, INTENT(IN) :: string
CHARACTER(C_CHAR), DIMENSION(*), INTENT(IN) :: string
TYPE(C_PTR), VALUE :: font
END FUNCTION glutStrokeLength
END INTERFACE


!  Geometry functions, see og_geometry.c
!  void    glutWireCube( GLdouble size )
PUBLIC glutWireCube
INTERFACE
SUBROUTINE glutWireCube(size) BIND(C,NAME="glutWireCube")
IMPORT
REAL(GLdouble), VALUE :: size
END SUBROUTINE glutWireCube
END INTERFACE

!  void    glutSolidCube( GLdouble size )
PUBLIC glutSolidCube
INTERFACE
SUBROUTINE glutSolidCube(size) BIND(C,NAME="glutSolidCube")
IMPORT
REAL(GLdouble), VALUE :: size
END SUBROUTINE glutSolidCube
END INTERFACE

!  void    glutWireSphere(    GLdouble radius, GLint slices, GLint stacks)
PUBLIC glutWireSphere
INTERFACE
SUBROUTINE glutWireSphere(radius, slices, stacks) BIND(C,NAME="glutWireSphere")
IMPORT
INTEGER(GLint), VALUE :: slices, stacks
REAL(GLdouble), VALUE :: radius
END SUBROUTINE glutWireSphere
END INTERFACE

!  void    glutSolidSphere(    GLdouble radius, GLint slices, GLint stacks)
PUBLIC glutSolidSphere
INTERFACE
SUBROUTINE glutSolidSphere(radius, slices, stacks) BIND(C,NAME="glutSolidSphere")
IMPORT
INTEGER(GLint), VALUE :: slices, stacks
REAL(GLdouble), VALUE :: radius
END SUBROUTINE glutSolidSphere
END INTERFACE

!  void    glutWireCone(    GLdouble base, GLdouble height, GLint slices, GLint stacks)
PUBLIC glutWireCone
INTERFACE
SUBROUTINE glutWireCone(base, height, slices, stacks) BIND(C,NAME="glutWireCone")
IMPORT
INTEGER(GLint), VALUE :: slices, stacks
REAL(GLdouble), VALUE :: base, height
END SUBROUTINE glutWireCone
END INTERFACE

!  void    glutSolidCone(    GLdouble base, GLdouble height, GLint slices, GLint stacks)
PUBLIC glutSolidCone
INTERFACE
SUBROUTINE glutSolidCone(base, height, slices, stacks) BIND(C,NAME="glutSolidCone")
IMPORT
INTEGER(GLint), VALUE :: slices, stacks
REAL(GLdouble), VALUE :: base, height
END SUBROUTINE glutSolidCone
END INTERFACE


!  void    glutWireTorus(    GLdouble innerRadius, GLdouble outerRadius, GLint sides, GLint rings)
PUBLIC glutWireTorus
INTERFACE
SUBROUTINE glutWireTorus(innerRadius, outerRadius, sides, rings) BIND(C,NAME="glutWireTorus")
IMPORT
INTEGER(GLint), VALUE :: sides, rings
REAL(GLdouble), VALUE :: innerRadius, outerRadius
END SUBROUTINE glutWireTorus
END INTERFACE

!  void    glutSolidTorus(    GLdouble innerRadius, GLdouble outerRadius, GLint sides, GLint rings)
PUBLIC glutSolidTorus
INTERFACE
SUBROUTINE glutSolidTorus(innerRadius, outerRadius, sides, rings) BIND(C,NAME="glutSolidTorus")
IMPORT
INTEGER(GLint), VALUE :: sides, rings
REAL(GLdouble), VALUE :: innerRadius, outerRadius
END SUBROUTINE glutSolidTorus
END INTERFACE

!  void    glutWireDodecahedron( void )
PUBLIC glutWireDodecahedron
INTERFACE
SUBROUTINE glutWireDodecahedron() BIND(C,NAME="glutWireDodecahedron")
IMPORT
END SUBROUTINE glutWireDodecahedron
END INTERFACE

!  void    glutSolidDodecahedron( void )
PUBLIC glutSolidDodecahedron
INTERFACE
SUBROUTINE glutSolidDodecahedron() BIND(C,NAME="glutSolidDodecahedron")
IMPORT
END SUBROUTINE glutSolidDodecahedron
END INTERFACE

!  void    glutWireOctahedron( void )
PUBLIC glutWireOctahedron
INTERFACE
SUBROUTINE glutWireOctahedron() BIND(C,NAME="glutWireOctahedron")
IMPORT
END SUBROUTINE glutWireOctahedron
END INTERFACE

!  void    glutSolidOctahedron( void )
PUBLIC glutSolidOctahedron
INTERFACE
SUBROUTINE glutSolidOctahedron() BIND(C,NAME="glutSolidOctahedron")
IMPORT
END SUBROUTINE glutSolidOctahedron
END INTERFACE

!  void    glutWireTetrahedron( void )
PUBLIC glutWireTetrahedron
INTERFACE
SUBROUTINE glutWireTetrahedron() BIND(C,NAME="glutWireTetrahedron")
IMPORT
END SUBROUTINE glutWireTetrahedron
END INTERFACE

!  void    glutSolidTetrahedron( void )
PUBLIC glutSolidTetrahedron
INTERFACE
SUBROUTINE glutSolidTetrahedron() BIND(C,NAME="glutSolidTetrahedron")
IMPORT
END SUBROUTINE glutSolidTetrahedron
END INTERFACE

!  void    glutWireIcosahedron( void )
PUBLIC glutWireIcosahedron
INTERFACE
SUBROUTINE glutWireIcosahedron() BIND(C,NAME="glutWireIcosahedron")
IMPORT
END SUBROUTINE glutWireIcosahedron
END INTERFACE

!  void    glutSolidIcosahedron( void )
PUBLIC glutSolidIcosahedron
INTERFACE
SUBROUTINE glutSolidIcosahedron() BIND(C,NAME="glutSolidIcosahedron")
IMPORT
END SUBROUTINE glutSolidIcosahedron
END INTERFACE


!  Teapot rendering functions, found in og_teapot.c
!  void    glutWireTeapot( GLdouble size )
PUBLIC glutWireTeapot
INTERFACE
SUBROUTINE glutWireTeapot(size) BIND(C,NAME="glutWireTeapot")
IMPORT
REAL(GLdouble), VALUE :: size
END SUBROUTINE glutWireTeapot
END INTERFACE

!  void    glutSolidTeapot( GLdouble size )
PUBLIC glutSolidTeapot
INTERFACE
SUBROUTINE glutSolidTeapot(size) BIND(C,NAME="glutSolidTeapot")
IMPORT
REAL(GLdouble), VALUE :: size
END SUBROUTINE glutSolidTeapot
END INTERFACE


!  Game mode functions, see og_gamemode.c
!  void    glutGameModeString( const char* string )
PUBLIC glutGameModeString
INTERFACE
SUBROUTINE glutGameModeString(string) BIND(C,NAME="glutGameModeString")
IMPORT
! CHARACTER, INTENT(IN) :: string
CHARACTER(C_CHAR), DIMENSION(*), INTENT(IN) :: string
END SUBROUTINE glutGameModeString
END INTERFACE

!  int     glutEnterGameMode( void )
PUBLIC glutEnterGameMode
INTERFACE
FUNCTION glutEnterGameMode() BIND(C,NAME="glutEnterGameMode")
IMPORT
INTEGER(GLint) :: glutEnterGameMode
END FUNCTION glutEnterGameMode
END INTERFACE

!  void    glutLeaveGameMode( void )
PUBLIC glutLeaveGameMode
INTERFACE
SUBROUTINE glutLeaveGameMode() BIND(C,NAME="glutLeaveGameMode")
IMPORT
END SUBROUTINE glutLeaveGameMode
END INTERFACE

!  int     glutGameModeGet( GLenum query )
PUBLIC glutGameModeGet
INTERFACE
FUNCTION glutGameModeGet(query) BIND(C,NAME="glutGameModeGet")
IMPORT
INTEGER(GLint) :: glutGameModeGet
INTEGER(GLenum), VALUE :: query
END FUNCTION glutGameModeGet
END INTERFACE


!  Video resize functions, see og_videoresize.c
!  int     glutVideoResizeGet( GLenum query )
PUBLIC glutVideoResizeGet
INTERFACE
FUNCTION glutVideoResizeGet(query) BIND(C,NAME="glutVideoResizeGet")
IMPORT
INTEGER(GLint) :: glutVideoResizeGet
INTEGER(GLenum), VALUE :: query
END FUNCTION glutVideoResizeGet
END INTERFACE

!  void    glutSetupVideoResizing( void )
PUBLIC glutSetupVideoResizing
INTERFACE
SUBROUTINE glutSetupVideoResizing() BIND(C,NAME="glutSetupVideoResizing")
IMPORT
END SUBROUTINE glutSetupVideoResizing
END INTERFACE

!  void    glutStopVideoResizing( void )
PUBLIC glutStopVideoResizing
INTERFACE
SUBROUTINE glutStopVideoResizing() BIND(C,NAME="glutStopVideoResizing")
IMPORT
END SUBROUTINE glutStopVideoResizing
END INTERFACE

!  void    glutVideoResize(    int x, int y, int width, int height)
PUBLIC glutVideoResize
INTERFACE
SUBROUTINE glutVideoResize(x, y, width, height) BIND(C,NAME="glutVideoResize")
IMPORT
INTEGER(GLint), VALUE :: x, y, width, height
END SUBROUTINE glutVideoResize
END INTERFACE

!  void    glutVideoPan( int x, int y, int width, int height )
PUBLIC glutVideoPan
INTERFACE
SUBROUTINE glutVideoPan(x, y, width, height) BIND(C,NAME="glutVideoPan")
IMPORT
INTEGER(GLint), VALUE :: x, y, width, height
END SUBROUTINE glutVideoPan
END INTERFACE


!  Colormap functions, see og_misc.c
!  void    glutSetColor(    int color, GLfloat red, GLfloat green, GLfloat blue)
PUBLIC glutSetColor
INTERFACE
SUBROUTINE glutSetColor(color, red, green, blue) BIND(C,NAME="glutSetColor")
IMPORT
INTEGER(GLint), VALUE :: color
REAL(GLfloat), VALUE :: red, green, blue
END SUBROUTINE glutSetColor
END INTERFACE

!  GLfloat glutGetColor( int color, int component )
PUBLIC glutGetColor
INTERFACE
FUNCTION glutGetColor(color, component) BIND(C,NAME="glutGetColor")
IMPORT
REAL(GLfloat) :: glutGetColor
INTEGER(GLint), VALUE :: color, component
END FUNCTION glutGetColor
END INTERFACE

!  void    glutCopyColormap( int window )
PUBLIC glutCopyColormap
INTERFACE
SUBROUTINE glutCopyColormap(window) BIND(C,NAME="glutCopyColormap")
IMPORT
INTEGER(GLint), VALUE :: window
END SUBROUTINE glutCopyColormap
END INTERFACE


!  Misc keyboard and joystick functions, see og_misc.c
!  void    glutIgnoreKeyRepeat( int ignore )
PUBLIC glutIgnoreKeyRepeat
INTERFACE
SUBROUTINE glutIgnoreKeyRepeat(ignore) BIND(C,NAME="glutIgnoreKeyRepeat")
IMPORT
INTEGER(GLint), VALUE :: ignore
END SUBROUTINE glutIgnoreKeyRepeat
END INTERFACE

!  void    glutSetKeyRepeat( int repeatMode )
PUBLIC glutSetKeyRepeat
INTERFACE
SUBROUTINE glutSetKeyRepeat(repeatMode) BIND(C,NAME="glutSetKeyRepeat")
IMPORT
INTEGER(GLint), VALUE :: repeatMode
END SUBROUTINE glutSetKeyRepeat
END INTERFACE

!  void    glutForceJoystickFunc( void )
PUBLIC glutForceJoystickFunc
INTERFACE
SUBROUTINE glutForceJoystickFunc() BIND(C,NAME="glutForceJoystickFunc")
IMPORT
END SUBROUTINE glutForceJoystickFunc
END INTERFACE


!  Misc functions, see og_misc.c
!  int     glutExtensionSupported( const char* extension )
PUBLIC glutExtensionSupported
INTERFACE
FUNCTION glutExtensionSupported(extension) BIND(C,NAME="glutExtensionSupported")
IMPORT
INTEGER(GLint) :: glutExtensionSupported
! CHARACTER, INTENT(IN) :: extension
CHARACTER(C_CHAR), DIMENSION(*), INTENT(IN) :: extension
END FUNCTION glutExtensionSupported
END INTERFACE

!  void    glutReportErrors( void )
PUBLIC glutReportErrors
INTERFACE
SUBROUTINE glutReportErrors() BIND(C,NAME="glutReportErrors")
IMPORT
END SUBROUTINE glutReportErrors
END INTERFACE


!  _______________________________________  
!  OpenGLUT EXTENSIONS
!  _______________________________________  


!  GLUT API Extension macro definitions -- behavior when the user clicks
!  on the window-close/program-quit widget box.
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_ACTION_EXIT = 0
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_ACTION_GLUTMAINLOOP_RETURNS = 1
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_ACTION_CONTINUE_EXECUTION = 2

!  Create a new rendering context when the user opens a new window?
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_CREATE_NEW_CONTEXT = 0
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_USE_CURRENT_CONTEXT = 1

!  GLUT API Extension macro definitions -- display mode
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_OFFSCREEN = z'0400'

!  GLUT API Extension macro definitions -- the glutGet parameters
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_ACTION_ON_WINDOW_CLOSE = z'01F9'

INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_BORDER_WIDTH = z'01FA'
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_WINDOW_HEADER_HEIGHT = z'01FB'

INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_VERSION = z'01FC'

INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_RENDERING_CONTEXT = z'01FD'

!  Process loop function, see freeglut_main.c
!  void    glutMainLoopEvent( void )
PUBLIC glutMainLoopEvent
INTERFACE
SUBROUTINE glutMainLoopEvent() BIND(C,NAME="glutMainLoopEvent")
IMPORT
END SUBROUTINE glutMainLoopEvent
END INTERFACE

!  void    glutLeaveMainLoop( void )
PUBLIC glutLeaveMainLoop
INTERFACE
SUBROUTINE glutLeaveMainLoop() BIND(C,NAME="glutLeaveMainLoop")
IMPORT
END SUBROUTINE glutLeaveMainLoop
END INTERFACE


!  Window-specific callback functions, see freeglut_callbacks.c
!  void    glutMouseWheelFunc(    void (* callback)( int button, int state, int x, int y ))
PUBLIC glutMouseWheelFunc
INTERFACE glutMouseWheelFunc
MODULE PROCEDURE glutMouseWheelFunc_f03
END INTERFACE glutMouseWheelFunc
INTERFACE
SUBROUTINE glutMouseWheelFunc_gl(proc) BIND(C,NAME="glutMouseWheelFunc")
IMPORT
!  void proc( int button, int state, int x, int y )
TYPE(C_FUNPTR), VALUE :: proc
END SUBROUTINE glutMouseWheelFunc_gl
END INTERFACE

!  void    glutCloseFunc( void (* callback)( void ) )
PUBLIC glutCloseFunc
INTERFACE glutCloseFunc
MODULE PROCEDURE glutCloseFunc_f03
END INTERFACE glutCloseFunc
INTERFACE
SUBROUTINE glutCloseFunc_gl(proc) BIND(C,NAME="glutCloseFunc")
IMPORT
!  void proc( void )
TYPE(C_FUNPTR), VALUE :: proc
END SUBROUTINE glutCloseFunc_gl
END INTERFACE

!  void    glutWMCloseFunc( void (* callback)( void ) )
PUBLIC glutWMCloseFunc
INTERFACE glutWMCloseFunc
MODULE PROCEDURE glutWMCloseFunc_f03
END INTERFACE glutWMCloseFunc
INTERFACE
SUBROUTINE glutWMCloseFunc_gl(proc) BIND(C,NAME="glutWMCloseFunc")
IMPORT
!  void proc( void )
TYPE(C_FUNPTR), VALUE :: proc
END SUBROUTINE glutWMCloseFunc_gl
END INTERFACE

!  A. Donev: Also a destruction callback for menus 
!  void    glutMenuDestroyFunc( void (* callback)( void ) )
PUBLIC glutMenuDestroyFunc
INTERFACE glutMenuDestroyFunc
MODULE PROCEDURE glutMenuDestroyFunc_f03
END INTERFACE glutMenuDestroyFunc
INTERFACE
SUBROUTINE glutMenuDestroyFunc_gl(proc) BIND(C,NAME="glutMenuDestroyFunc")
IMPORT
!  void proc( void )
TYPE(C_FUNPTR), VALUE :: proc
END SUBROUTINE glutMenuDestroyFunc_gl
END INTERFACE


!  State setting and retrieval functions, see freeglut_state.c
!  void    glutSetOption ( GLenum option_flag, int value )
PUBLIC glutSetOption
INTERFACE
SUBROUTINE glutSetOption(option_flag, value) BIND(C,NAME="glutSetOption")
IMPORT
INTEGER(GLenum), VALUE :: option_flag
INTEGER(GLint), VALUE :: value
END SUBROUTINE glutSetOption
END INTERFACE

!  A.Donev: User-data manipulation 
!  void*   glutGetWindowData( void )
PUBLIC glutGetWindowData
INTERFACE
FUNCTION glutGetWindowData() BIND(C,NAME="glutGetWindowData")
IMPORT
TYPE(C_PTR) :: glutGetWindowData
END FUNCTION glutGetWindowData
END INTERFACE

!  void    glutSetWindowData(void* data)
PUBLIC glutSetWindowData
INTERFACE
SUBROUTINE glutSetWindowData(data) BIND(C,NAME="glutSetWindowData")
IMPORT
TYPE(C_PTR), VALUE :: data
END SUBROUTINE glutSetWindowData
END INTERFACE

!  void*   glutGetMenuData( void )
PUBLIC glutGetMenuData
INTERFACE
FUNCTION glutGetMenuData() BIND(C,NAME="glutGetMenuData")
IMPORT
TYPE(C_PTR) :: glutGetMenuData
END FUNCTION glutGetMenuData
END INTERFACE

!  void    glutSetMenuData(void* data)
PUBLIC glutSetMenuData
INTERFACE
SUBROUTINE glutSetMenuData(data) BIND(C,NAME="glutSetMenuData")
IMPORT
TYPE(C_PTR), VALUE :: data
END SUBROUTINE glutSetMenuData
END INTERFACE


!  Font stuff, see freeglut_font.c
!  int     glutBitmapHeight( void* font )
PUBLIC glutBitmapHeight
INTERFACE
FUNCTION glutBitmapHeight(font) BIND(C,NAME="glutBitmapHeight")
IMPORT
INTEGER(GLint) :: glutBitmapHeight
TYPE(C_PTR), VALUE :: font
END FUNCTION glutBitmapHeight
END INTERFACE

!  GLfloat glutStrokeHeight( void* font )
PUBLIC glutStrokeHeight
INTERFACE
FUNCTION glutStrokeHeight(font) BIND(C,NAME="glutStrokeHeight")
IMPORT
REAL(GLfloat) :: glutStrokeHeight
TYPE(C_PTR), VALUE :: font
END FUNCTION glutStrokeHeight
END INTERFACE

!  void    glutBitmapString(    void* font, const unsigned char *string)
PUBLIC glutBitmapString
INTERFACE
SUBROUTINE glutBitmapString(font, string) BIND(C,NAME="glutBitmapString")
IMPORT
! CHARACTER, INTENT(IN) :: string
CHARACTER(C_CHAR), DIMENSION(*), INTENT(IN) :: string
TYPE(C_PTR), VALUE :: font
END SUBROUTINE glutBitmapString
END INTERFACE

!  void    glutStrokeString(    void* font, const unsigned char *string)
PUBLIC glutStrokeString
INTERFACE
SUBROUTINE glutStrokeString(font, string) BIND(C,NAME="glutStrokeString")
IMPORT
! CHARACTER, INTENT(IN) :: string
CHARACTER(C_CHAR), DIMENSION(*), INTENT(IN) :: string
TYPE(C_PTR), VALUE :: font
END SUBROUTINE glutStrokeString
END INTERFACE


!  Geometry functions, see freeglut_geometry.c
!  void    glutWireRhombicDodecahedron( void )
PUBLIC glutWireRhombicDodecahedron
INTERFACE
SUBROUTINE glutWireRhombicDodecahedron() BIND(C,NAME="glutWireRhombicDodecahedron")
IMPORT
END SUBROUTINE glutWireRhombicDodecahedron
END INTERFACE

!  void    glutSolidRhombicDodecahedron( void )
PUBLIC glutSolidRhombicDodecahedron
INTERFACE
SUBROUTINE glutSolidRhombicDodecahedron() BIND(C,NAME="glutSolidRhombicDodecahedron")
IMPORT
END SUBROUTINE glutSolidRhombicDodecahedron
END INTERFACE

!  void    glutWireSierpinskiSponge(    int num_levels, const GLdouble offset[3], GLdouble scale)
PUBLIC glutWireSierpinskiSponge
INTERFACE
SUBROUTINE glutWireSierpinskiSponge(num_levels, offset, scale) BIND(C,NAME="glutWireSierpinskiSponge")
IMPORT
INTEGER(GLint), VALUE :: num_levels
REAL(GLdouble), DIMENSION(3), INTENT(IN) :: offset
REAL(GLdouble), VALUE :: scale
END SUBROUTINE glutWireSierpinskiSponge
END INTERFACE

!  void    glutSolidSierpinskiSponge(    int num_levels, const GLdouble offset[3], GLdouble scale)
PUBLIC glutSolidSierpinskiSponge
INTERFACE
SUBROUTINE glutSolidSierpinskiSponge(num_levels, offset, scale) BIND(C,NAME="glutSolidSierpinskiSponge")
IMPORT
INTEGER(GLint), VALUE :: num_levels
REAL(GLdouble), DIMENSION(3), INTENT(IN) :: offset
REAL(GLdouble), VALUE :: scale
END SUBROUTINE glutSolidSierpinskiSponge
END INTERFACE

!  void    glutWireCylinder(    GLdouble radius, GLdouble height, GLint slices, GLint stacks)
PUBLIC glutWireCylinder
INTERFACE
SUBROUTINE glutWireCylinder(radius, height, slices, stacks) BIND(C,NAME="glutWireCylinder")
IMPORT
INTEGER(GLint), VALUE :: slices, stacks
REAL(GLdouble), VALUE :: radius, height
END SUBROUTINE glutWireCylinder
END INTERFACE

!  void    glutSolidCylinder(    GLdouble radius, GLdouble height, GLint slices, GLint stacks)
PUBLIC glutSolidCylinder
INTERFACE
SUBROUTINE glutSolidCylinder(radius, height, slices, stacks) BIND(C,NAME="glutSolidCylinder")
IMPORT
INTEGER(GLint), VALUE :: slices, stacks
REAL(GLdouble), VALUE :: radius, height
END SUBROUTINE glutSolidCylinder
END INTERFACE


!  Extension functions, see freeglut_ext.c
!  void *glutGetProcAddress( const char *procName )
PUBLIC glutGetProcAddress
INTERFACE
FUNCTION glutGetProcAddress(procName) BIND(C,NAME="glutGetProcAddress")
IMPORT
TYPE(C_PTR) :: glutGetProcAddress
! CHARACTER, INTENT(IN) :: procName
CHARACTER(C_CHAR), DIMENSION(*), INTENT(IN) :: procName
END FUNCTION glutGetProcAddress
END INTERFACE



!  GLUT API Extension macro definitions -- display mode
INTEGER(GLenum), PARAMETER, PUBLIC :: GLUT_BORDERLESS = z'0800'

!  OpenGLUT experimental functions.


!  Allow for conditional compilation of experimental features.



! Font variables in GLUT_fonts.c
TYPE(C_PTR), BIND(C), PUBLIC, PROTECTED :: GLUT_STROKE_ROMAN,         &
    GLUT_STROKE_MONO_ROMAN, GLUT_BITMAP_9_BY_15, GLUT_BITMAP_8_BY_13, &
    GLUT_BITMAP_TIMES_ROMAN_10, GLUT_BITMAP_TIMES_ROMAN_24,           &
    GLUT_BITMAP_HELVETICA_10, GLUT_BITMAP_HELVETICA_12,               &
    GLUT_BITMAP_HELVETICA_18

! A special callback function for compatibility with f90gl
TYPE(C_FUNPTR), PUBLIC, SAVE, BIND(C) :: GLUT_NULL_FUNC=C_NULL_FUNPTR

CONTAINS

SUBROUTINE glutInit_f03()
  INTEGER(C_INT) :: argcp=1
  TYPE(C_PTR), DIMENSION(1), TARGET :: argv=C_NULL_PTR
  CHARACTER(C_CHAR), DIMENSION(1), TARGET :: empty_string=C_NULL_CHAR

  ! A hack
  INTERFACE
   SUBROUTINE SetNullFunc() BIND(C,NAME='SetNullFunc')
   END SUBROUTINE
  END INTERFACE  

  argv(1)=C_LOC(empty_string)
  CALL glutInit_gl(argcp, C_LOC(argv))
  
END SUBROUTINE

SUBROUTINE glutTimerFunc_f03(time, proc, value)
INTEGER(GLint), VALUE :: value
INTEGER(GLuint), VALUE :: time
INTERFACE
SUBROUTINE proc(value) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: value
END SUBROUTINE proc
END INTERFACE
OPTIONAL :: proc
IF(PRESENT(proc)) THEN
   CALL glutTimerFunc_gl(time, C_FUNLOC(proc), value)
ELSE
   CALL glutTimerFunc_gl(time, C_NULL_FUNPTR, value)
END IF
END SUBROUTINE glutTimerFunc_f03
SUBROUTINE glutIdleFunc_f03(proc)
INTERFACE
SUBROUTINE proc() BIND(C)
IMPORT
END SUBROUTINE proc
END INTERFACE
OPTIONAL :: proc
IF(PRESENT(proc)) THEN
   CALL glutIdleFunc_gl(C_FUNLOC(proc))
ELSE
   CALL glutIdleFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutIdleFunc_f03
SUBROUTINE glutKeyboardFunc_f03(proc)
INTERFACE
SUBROUTINE proc(key, x, y) BIND(C)
IMPORT
INTEGER(GLbyte), VALUE :: key
INTEGER(GLint), VALUE :: x, y
END SUBROUTINE proc
END INTERFACE
OPTIONAL :: proc
IF(PRESENT(proc)) THEN
   CALL glutKeyboardFunc_gl(C_FUNLOC(proc))
ELSE
   CALL glutKeyboardFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutKeyboardFunc_f03
SUBROUTINE glutSpecialFunc_f03(proc)
INTERFACE
SUBROUTINE proc(key, x, y) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: key, x, y
END SUBROUTINE proc
END INTERFACE
OPTIONAL :: proc
IF(PRESENT(proc)) THEN
   CALL glutSpecialFunc_gl(C_FUNLOC(proc))
ELSE
   CALL glutSpecialFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutSpecialFunc_f03
SUBROUTINE glutReshapeFunc_f03(proc)
INTERFACE
SUBROUTINE proc(h, w) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: h, w
END SUBROUTINE proc
END INTERFACE
OPTIONAL :: proc
IF(PRESENT(proc)) THEN
   CALL glutReshapeFunc_gl(C_FUNLOC(proc))
ELSE
   CALL glutReshapeFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutReshapeFunc_f03
SUBROUTINE glutVisibilityFunc_f03(proc)
INTERFACE
SUBROUTINE proc(visible) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: visible
END SUBROUTINE proc
END INTERFACE
OPTIONAL :: proc
IF(PRESENT(proc)) THEN
   CALL glutVisibilityFunc_gl(C_FUNLOC(proc))
ELSE
   CALL glutVisibilityFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutVisibilityFunc_f03
SUBROUTINE glutDisplayFunc_f03(proc)
INTERFACE
SUBROUTINE proc() BIND(C)
IMPORT
END SUBROUTINE proc
END INTERFACE
OPTIONAL :: proc
IF(PRESENT(proc)) THEN
   CALL glutDisplayFunc_gl(C_FUNLOC(proc))
ELSE
   CALL glutDisplayFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutDisplayFunc_f03
SUBROUTINE glutMouseFunc_f03(proc)
INTERFACE
SUBROUTINE proc(button, state, x, y) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: button, state, x, y
END SUBROUTINE proc
END INTERFACE
OPTIONAL :: proc
IF(PRESENT(proc)) THEN
   CALL glutMouseFunc_gl(C_FUNLOC(proc))
ELSE
   CALL glutMouseFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutMouseFunc_f03
SUBROUTINE glutMotionFunc_f03(proc)
INTERFACE
SUBROUTINE proc(x, y) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: x, y
END SUBROUTINE proc
END INTERFACE
OPTIONAL :: proc
IF(PRESENT(proc)) THEN
   CALL glutMotionFunc_gl(C_FUNLOC(proc))
ELSE
   CALL glutMotionFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutMotionFunc_f03
SUBROUTINE glutPassiveMotionFunc_f03(proc)
INTERFACE
SUBROUTINE proc(x, y) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: x, y
END SUBROUTINE proc
END INTERFACE
OPTIONAL :: proc
IF(PRESENT(proc)) THEN
   CALL glutPassiveMotionFunc_gl(C_FUNLOC(proc))
ELSE
   CALL glutPassiveMotionFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutPassiveMotionFunc_f03
SUBROUTINE glutEntryFunc_f03(proc)
INTERFACE
SUBROUTINE proc(value) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: value
END SUBROUTINE proc
END INTERFACE
OPTIONAL :: proc
IF(PRESENT(proc)) THEN
   CALL glutEntryFunc_gl(C_FUNLOC(proc))
ELSE
   CALL glutEntryFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutEntryFunc_f03
SUBROUTINE glutKeyboardUpFunc_f03(proc)
INTERFACE
SUBROUTINE proc(key, x, y) BIND(C)
IMPORT
INTEGER(GLbyte), VALUE :: key
INTEGER(GLint), VALUE :: x, y
END SUBROUTINE proc
END INTERFACE
OPTIONAL :: proc
IF(PRESENT(proc)) THEN
   CALL glutKeyboardUpFunc_gl(C_FUNLOC(proc))
ELSE
   CALL glutKeyboardUpFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutKeyboardUpFunc_f03
SUBROUTINE glutSpecialUpFunc_f03(proc)
INTERFACE
SUBROUTINE proc(key, x, y) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: key, x, y
END SUBROUTINE proc
END INTERFACE
OPTIONAL :: proc
IF(PRESENT(proc)) THEN
   CALL glutSpecialUpFunc_gl(C_FUNLOC(proc))
ELSE
   CALL glutSpecialUpFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutSpecialUpFunc_f03
SUBROUTINE glutJoystickFunc_f03(proc, pollInterval)
INTEGER(GLint), VALUE :: pollInterval
INTERFACE
SUBROUTINE proc(buttonMask, x, y, z) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: x, y, z
INTEGER(GLuint), VALUE :: buttonMask
END SUBROUTINE proc
END INTERFACE
OPTIONAL :: proc
IF(PRESENT(proc)) THEN
   CALL glutJoystickFunc_gl(C_FUNLOC(proc), pollInterval)
ELSE
   CALL glutJoystickFunc_gl(C_NULL_FUNPTR, pollInterval)
END IF
END SUBROUTINE glutJoystickFunc_f03
SUBROUTINE glutMenuStateFunc_f03(proc)
INTERFACE
SUBROUTINE proc(menu) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: menu
END SUBROUTINE proc
END INTERFACE
OPTIONAL :: proc
IF(PRESENT(proc)) THEN
   CALL glutMenuStateFunc_gl(C_FUNLOC(proc))
ELSE
   CALL glutMenuStateFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutMenuStateFunc_f03
SUBROUTINE glutMenuStatusFunc_f03(proc)
INTERFACE
SUBROUTINE proc(status, x, y) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: status, x, y
END SUBROUTINE proc
END INTERFACE
OPTIONAL :: proc
IF(PRESENT(proc)) THEN
   CALL glutMenuStatusFunc_gl(C_FUNLOC(proc))
ELSE
   CALL glutMenuStatusFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutMenuStatusFunc_f03
SUBROUTINE glutOverlayDisplayFunc_f03(proc)
INTERFACE
SUBROUTINE proc() BIND(C)
IMPORT
END SUBROUTINE proc
END INTERFACE
OPTIONAL :: proc
IF(PRESENT(proc)) THEN
   CALL glutOverlayDisplayFunc_gl(C_FUNLOC(proc))
ELSE
   CALL glutOverlayDisplayFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutOverlayDisplayFunc_f03
SUBROUTINE glutWindowStatusFunc_f03(proc)
INTERFACE
SUBROUTINE proc(status) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: status
END SUBROUTINE proc
END INTERFACE
OPTIONAL :: proc
IF(PRESENT(proc)) THEN
   CALL glutWindowStatusFunc_gl(C_FUNLOC(proc))
ELSE
   CALL glutWindowStatusFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutWindowStatusFunc_f03
SUBROUTINE glutSpaceballMotionFunc_f03(proc)
INTERFACE
SUBROUTINE proc(key, x, y) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: key, x, y
END SUBROUTINE proc
END INTERFACE
OPTIONAL :: proc
IF(PRESENT(proc)) THEN
   CALL glutSpaceballMotionFunc_gl(C_FUNLOC(proc))
ELSE
   CALL glutSpaceballMotionFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutSpaceballMotionFunc_f03
SUBROUTINE glutSpaceballRotateFunc_f03(proc)
INTERFACE
SUBROUTINE proc(key, x, y) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: key, x, y
END SUBROUTINE proc
END INTERFACE
OPTIONAL :: proc
IF(PRESENT(proc)) THEN
   CALL glutSpaceballRotateFunc_gl(C_FUNLOC(proc))
ELSE
   CALL glutSpaceballRotateFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutSpaceballRotateFunc_f03
SUBROUTINE glutSpaceballButtonFunc_f03(proc)
INTERFACE
SUBROUTINE proc(x, y) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: x, y
END SUBROUTINE proc
END INTERFACE
OPTIONAL :: proc
IF(PRESENT(proc)) THEN
   CALL glutSpaceballButtonFunc_gl(C_FUNLOC(proc))
ELSE
   CALL glutSpaceballButtonFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutSpaceballButtonFunc_f03
SUBROUTINE glutButtonBoxFunc_f03(proc)
INTERFACE
SUBROUTINE proc(x, y) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: x, y
END SUBROUTINE proc
END INTERFACE
OPTIONAL :: proc
IF(PRESENT(proc)) THEN
   CALL glutButtonBoxFunc_gl(C_FUNLOC(proc))
ELSE
   CALL glutButtonBoxFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutButtonBoxFunc_f03
SUBROUTINE glutDialsFunc_f03(proc)
INTERFACE
SUBROUTINE proc(x, y) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: x, y
END SUBROUTINE proc
END INTERFACE
OPTIONAL :: proc
IF(PRESENT(proc)) THEN
   CALL glutDialsFunc_gl(C_FUNLOC(proc))
ELSE
   CALL glutDialsFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutDialsFunc_f03
SUBROUTINE glutTabletMotionFunc_f03(proc)
INTERFACE
SUBROUTINE proc(x, y) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: x, y
END SUBROUTINE proc
END INTERFACE
OPTIONAL :: proc
IF(PRESENT(proc)) THEN
   CALL glutTabletMotionFunc_gl(C_FUNLOC(proc))
ELSE
   CALL glutTabletMotionFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutTabletMotionFunc_f03
SUBROUTINE glutTabletButtonFunc_f03(proc)
INTERFACE
SUBROUTINE proc(button, state, x, y) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: button, state, x, y
END SUBROUTINE proc
END INTERFACE
OPTIONAL :: proc
IF(PRESENT(proc)) THEN
   CALL glutTabletButtonFunc_gl(C_FUNLOC(proc))
ELSE
   CALL glutTabletButtonFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutTabletButtonFunc_f03
SUBROUTINE glutMouseWheelFunc_f03(proc)
INTERFACE
SUBROUTINE proc(button, state, x, y) BIND(C)
IMPORT
INTEGER(GLint), VALUE :: button, state, x, y
END SUBROUTINE proc
END INTERFACE
OPTIONAL :: proc
IF(PRESENT(proc)) THEN
   CALL glutMouseWheelFunc_gl(C_FUNLOC(proc))
ELSE
   CALL glutMouseWheelFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutMouseWheelFunc_f03
SUBROUTINE glutCloseFunc_f03(proc)
INTERFACE
SUBROUTINE proc() BIND(C)
IMPORT
END SUBROUTINE proc
END INTERFACE
OPTIONAL :: proc
IF(PRESENT(proc)) THEN
   CALL glutCloseFunc_gl(C_FUNLOC(proc))
ELSE
   CALL glutCloseFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutCloseFunc_f03
SUBROUTINE glutWMCloseFunc_f03(proc)
INTERFACE
SUBROUTINE proc() BIND(C)
IMPORT
END SUBROUTINE proc
END INTERFACE
OPTIONAL :: proc
IF(PRESENT(proc)) THEN
   CALL glutWMCloseFunc_gl(C_FUNLOC(proc))
ELSE
   CALL glutWMCloseFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutWMCloseFunc_f03
SUBROUTINE glutMenuDestroyFunc_f03(proc)
INTERFACE
SUBROUTINE proc() BIND(C)
IMPORT
END SUBROUTINE proc
END INTERFACE
OPTIONAL :: proc
IF(PRESENT(proc)) THEN
   CALL glutMenuDestroyFunc_gl(C_FUNLOC(proc))
ELSE
   CALL glutMenuDestroyFunc_gl(C_NULL_FUNPTR)
END IF
END SUBROUTINE glutMenuDestroyFunc_f03


END MODULE OpenGL_glut

!> \file glsphray.F90

!> \brief SPHRAY basic operation program + OpenGL viewer
!! 
!! this program does the same thing as sphray.f90 but contains an 
!! extra subroutine to launch a thread that calls the OpenGL viewer.  
!<
program glsphray
use myf03_mod
use initialize_mod, only: initialize
use mainloop_mod, only: mainloop
use viewermod
implicit none

   character(clen) :: config_file    !< configuration file
   type(command_line_type) :: cmnd   !< command line variable

   integer, parameter :: verb = 3    !< verbosity before config file is read
   logical, parameter :: crash = .true.               !< stop on error
   character(clen), parameter :: myname = "glsphray"  !< routine name

   ! set initial myf90_verbosity (will be changed once config file is read)
   ! 3 lets any statement with verbosity 3 or less through
   !========================================================================
   myf03_verbosity = verb



   ! initialize command line variable
   !========================================================================
   cmnd = myf03_initialize_command_line(verb)

   ! check command line arguments
   !========================================================================
   if (cmnd%nargs /= 1 ) then 
      call myerr( 'usage: ./glsphray config_file', myname, crash )
   end if

   ! clear terminal and print splash screen
   !========================================================================
   call system("clear")


   write(*,*) "**************************************************************"
   write(*,*) "**************************************************************"
   write(*,*) "         Smoothed Particle Hydrodynamics Ray Tracer           "
   write(*,*) "                        SPHRAY 0.9                            "
   write(*,*) "                  (with OpenGL Viewer)                        "
   write(*,*) 
   write(*,*) "  developed by,                                               "
   write(*,*)
   write(*,*) "  Gabriel Altay (gabriel.altay@gmail.com) and                 "
   write(*,*) "  Inti Pelupessy                                              "
   write(*,*) "**************************************************************"
   write(*,*) "**************************************************************"
   write(*,*) 
   write(*,*) 
   write(*,*) 

   ! initialize and call viewer and mainloop()
   !========================================================================
   config_file = cmnd%args(1)
   call initialize(config_file)
      
   call viewer()

   call mainloop()

   write(*,*) " *** GAME OVER ***"
   write(*,*) "you can close the viewer safely now.."

   call viewer()


end program glsphray

Module m_mrgrnk

private
public :: mrgrnk

Integer, parameter :: krf = selected_real_kind(6)  ! 4 byte 
Integer, Parameter :: krd = selected_real_kind(15) ! 8 byte 
Integer, parameter :: kii = selected_int_kind(9)   ! 4 byte 
Integer, Parameter :: kil = selected_int_kind(18)  ! 8 byte 

interface mrgrnk
  module procedure RI_mrgrnk, DL_mrgrnk, II_mrgrnk
end interface mrgrnk

contains

Subroutine RI_mrgrnk (XDONT, IRNGT)
! __________________________________________________________
!   MRGRNK = Merge-sort ranking of an array
!   For performance reasons, the first 2 passes are taken
!   out of the standard loop, and use dedicated coding.
! __________________________________________________________
! __________________________________________________________
      Real(krf), Dimension (:), Intent (In) :: XDONT
      Integer(kii), Dimension (:), Intent (Out) :: IRNGT
! __________________________________________________________
      Real (krf) :: XVALA, XVALB
!
      Integer(kii), Dimension (SIZE(IRNGT)) :: JWRKT
      Integer(kii) :: LMTNA, LMTNC, IRNG1, IRNG2
      Integer(kii) :: NVAL, IIND, IWRKD, IWRK, IWRKF, JINDA, IINDA, IINDB
!
      NVAL = Min (SIZE(XDONT), SIZE(IRNGT))
      Select Case (NVAL)
      Case (:0)
         Return
      Case (1)
         IRNGT (1) = 1
         Return
      Case Default
         Continue
      End Select
!
!  Fill-in the index array, creating ordered couples
!
      Do IIND = 2, NVAL, 2
         If (XDONT(IIND-1) <= XDONT(IIND)) Then
            IRNGT (IIND-1) = IIND - 1
            IRNGT (IIND) = IIND
         Else
            IRNGT (IIND-1) = IIND
            IRNGT (IIND) = IIND - 1
         End If
      End Do
      If (Modulo(NVAL, 2) /= 0) Then
         IRNGT (NVAL) = NVAL
      End If
!
!  We will now have ordered subsets A - B - A - B - ...
!  and merge A and B couples into     C   -   C   - ...
!
      LMTNA = 2
      LMTNC = 4
!
!  First iteration. The length of the ordered subsets goes from 2 to 4
!
      Do
         If (NVAL <= 2) Exit
!
!   Loop on merges of A and B into C
!
         Do IWRKD = 0, NVAL - 1, 4
            If ((IWRKD+4) > NVAL) Then
               If ((IWRKD+2) >= NVAL) Exit
!
!   1 2 3
!
               If (XDONT(IRNGT(IWRKD+2)) <= XDONT(IRNGT(IWRKD+3))) Exit
!
!   1 3 2
!
               If (XDONT(IRNGT(IWRKD+1)) <= XDONT(IRNGT(IWRKD+3))) Then
                  IRNG2 = IRNGT (IWRKD+2)
                  IRNGT (IWRKD+2) = IRNGT (IWRKD+3)
                  IRNGT (IWRKD+3) = IRNG2
!
!   3 1 2
!
               Else
                  IRNG1 = IRNGT (IWRKD+1)
                  IRNGT (IWRKD+1) = IRNGT (IWRKD+3)
                  IRNGT (IWRKD+3) = IRNGT (IWRKD+2)
                  IRNGT (IWRKD+2) = IRNG1
               End If
               Exit
            End If
!
!   1 2 3 4
!
            If (XDONT(IRNGT(IWRKD+2)) <= XDONT(IRNGT(IWRKD+3))) Cycle
!
!   1 3 x x
!
            If (XDONT(IRNGT(IWRKD+1)) <= XDONT(IRNGT(IWRKD+3))) Then
               IRNG2 = IRNGT (IWRKD+2)
               IRNGT (IWRKD+2) = IRNGT (IWRKD+3)
               If (XDONT(IRNG2) <= XDONT(IRNGT(IWRKD+4))) Then
!   1 3 2 4
                  IRNGT (IWRKD+3) = IRNG2
               Else
!   1 3 4 2
                  IRNGT (IWRKD+3) = IRNGT (IWRKD+4)
                  IRNGT (IWRKD+4) = IRNG2
               End If
!
!   3 x x x
!
            Else
               IRNG1 = IRNGT (IWRKD+1)
               IRNG2 = IRNGT (IWRKD+2)
               IRNGT (IWRKD+1) = IRNGT (IWRKD+3)
               If (XDONT(IRNG1) <= XDONT(IRNGT(IWRKD+4))) Then
                  IRNGT (IWRKD+2) = IRNG1
                  If (XDONT(IRNG2) <= XDONT(IRNGT(IWRKD+4))) Then
!   3 1 2 4
                     IRNGT (IWRKD+3) = IRNG2
                  Else
!   3 1 4 2
                     IRNGT (IWRKD+3) = IRNGT (IWRKD+4)
                     IRNGT (IWRKD+4) = IRNG2
                  End If
               Else
!   3 4 1 2
                  IRNGT (IWRKD+2) = IRNGT (IWRKD+4)
                  IRNGT (IWRKD+3) = IRNG1
                  IRNGT (IWRKD+4) = IRNG2
               End If
            End If
         End Do
!
!  The Cs become As and Bs
!
         LMTNA = 4
         Exit
      End Do
!
!  Iteration loop. Each time, the length of the ordered subsets
!  is doubled.
!
      Do
         If (LMTNA >= NVAL) Exit
         IWRKF = 0
         LMTNC = 2 * LMTNC
!
!   Loop on merges of A and B into C
!
         Do
            IWRK = IWRKF
            IWRKD = IWRKF + 1
            JINDA = IWRKF + LMTNA
            IWRKF = IWRKF + LMTNC
            If (IWRKF >= NVAL) Then
               If (JINDA >= NVAL) Exit
               IWRKF = NVAL
            End If
            IINDA = 1
            IINDB = JINDA + 1
!
!   Shortcut for the case when the max of A is smaller
!   than the min of B. This line may be activated when the
!   initial set is already close to sorted.
!
!          IF (XDONT(IRNGT(JINDA)) <= XDONT(IRNGT(IINDB))) CYCLE
!
!  One steps in the C subset, that we build in the final rank array
!
!  Make a copy of the rank array for the merge iteration
!
            JWRKT (1:LMTNA) = IRNGT (IWRKD:JINDA)
!
            XVALA = XDONT (JWRKT(IINDA))
            XVALB = XDONT (IRNGT(IINDB))
!
            Do
               IWRK = IWRK + 1
!
!  We still have unprocessed values in both A and B
!
               If (XVALA > XVALB) Then
                  IRNGT (IWRK) = IRNGT (IINDB)
                  IINDB = IINDB + 1
                  If (IINDB > IWRKF) Then
!  Only A still with unprocessed values
                     IRNGT (IWRK+1:IWRKF) = JWRKT (IINDA:LMTNA)
                     Exit
                  End If
                  XVALB = XDONT (IRNGT(IINDB))
               Else
                  IRNGT (IWRK) = JWRKT (IINDA)
                  IINDA = IINDA + 1
                  If (IINDA > LMTNA) Exit! Only B still with unprocessed values
                  XVALA = XDONT (JWRKT(IINDA))
               End If
!
            End Do
         End Do
!
!  The Cs become As and Bs
!
         LMTNA = 2 * LMTNA
      End Do
!
      Return
!
End Subroutine RI_mrgrnk


Subroutine DL_mrgrnk (XDONT, IRNGT)
! __________________________________________________________
!   MRGRNK = Merge-sort ranking of an array
!   For performance reasons, the first 2 passes are taken
!   out of the standard loop, and use dedicated coding.
! __________________________________________________________
! __________________________________________________________
      Real(krd), Dimension (:), Intent (In) :: XDONT
      Integer(kil), Dimension (:), Intent (Out) :: IRNGT
! __________________________________________________________
      Real (krd) :: XVALA, XVALB
!
      Integer(kil), Dimension (SIZE(IRNGT)) :: JWRKT
      Integer(kil) :: LMTNA, LMTNC, IRNG1, IRNG2
      Integer(kil) :: NVAL, IIND, IWRKD, IWRK, IWRKF, JINDA, IINDA, IINDB
!
      NVAL = Min (SIZE(XDONT), SIZE(IRNGT))
      Select Case (NVAL)
      Case (:0_kil)
         Return
      Case (1_kil)
         IRNGT (1) = 1
         Return
      Case Default
         Continue
      End Select
!
!  Fill-in the index array, creating ordered couples
!
      Do IIND = 2, NVAL, 2
         If (XDONT(IIND-1) <= XDONT(IIND)) Then
            IRNGT (IIND-1) = IIND - 1
            IRNGT (IIND) = IIND
         Else
            IRNGT (IIND-1) = IIND
            IRNGT (IIND) = IIND - 1
         End If
      End Do
      If (Modulo(NVAL, 2_kil) /= 0) Then
         IRNGT (NVAL) = NVAL
      End If
!
!  We will now have ordered subsets A - B - A - B - ...
!  and merge A and B couples into     C   -   C   - ...
!
      LMTNA = 2
      LMTNC = 4
!
!  First iteration. The length of the ordered subsets goes from 2 to 4
!
      Do
         If (NVAL <= 2) Exit
!
!   Loop on merges of A and B into C
!
         Do IWRKD = 0, NVAL - 1, 4
            If ((IWRKD+4) > NVAL) Then
               If ((IWRKD+2) >= NVAL) Exit
!
!   1 2 3
!
               If (XDONT(IRNGT(IWRKD+2)) <= XDONT(IRNGT(IWRKD+3))) Exit
!
!   1 3 2
!
               If (XDONT(IRNGT(IWRKD+1)) <= XDONT(IRNGT(IWRKD+3))) Then
                  IRNG2 = IRNGT (IWRKD+2)
                  IRNGT (IWRKD+2) = IRNGT (IWRKD+3)
                  IRNGT (IWRKD+3) = IRNG2
!
!   3 1 2
!
               Else
                  IRNG1 = IRNGT (IWRKD+1)
                  IRNGT (IWRKD+1) = IRNGT (IWRKD+3)
                  IRNGT (IWRKD+3) = IRNGT (IWRKD+2)
                  IRNGT (IWRKD+2) = IRNG1
               End If
               Exit
            End If
!
!   1 2 3 4
!
            If (XDONT(IRNGT(IWRKD+2)) <= XDONT(IRNGT(IWRKD+3))) Cycle
!
!   1 3 x x
!
            If (XDONT(IRNGT(IWRKD+1)) <= XDONT(IRNGT(IWRKD+3))) Then
               IRNG2 = IRNGT (IWRKD+2)
               IRNGT (IWRKD+2) = IRNGT (IWRKD+3)
               If (XDONT(IRNG2) <= XDONT(IRNGT(IWRKD+4))) Then
!   1 3 2 4
                  IRNGT (IWRKD+3) = IRNG2
               Else
!   1 3 4 2
                  IRNGT (IWRKD+3) = IRNGT (IWRKD+4)
                  IRNGT (IWRKD+4) = IRNG2
               End If
!
!   3 x x x
!
            Else
               IRNG1 = IRNGT (IWRKD+1)
               IRNG2 = IRNGT (IWRKD+2)
               IRNGT (IWRKD+1) = IRNGT (IWRKD+3)
               If (XDONT(IRNG1) <= XDONT(IRNGT(IWRKD+4))) Then
                  IRNGT (IWRKD+2) = IRNG1
                  If (XDONT(IRNG2) <= XDONT(IRNGT(IWRKD+4))) Then
!   3 1 2 4
                     IRNGT (IWRKD+3) = IRNG2
                  Else
!   3 1 4 2
                     IRNGT (IWRKD+3) = IRNGT (IWRKD+4)
                     IRNGT (IWRKD+4) = IRNG2
                  End If
               Else
!   3 4 1 2
                  IRNGT (IWRKD+2) = IRNGT (IWRKD+4)
                  IRNGT (IWRKD+3) = IRNG1
                  IRNGT (IWRKD+4) = IRNG2
               End If
            End If
         End Do
!
!  The Cs become As and Bs
!
         LMTNA = 4
         Exit
      End Do
!
!  Iteration loop. Each time, the length of the ordered subsets
!  is doubled.
!
      Do
         If (LMTNA >= NVAL) Exit
         IWRKF = 0
         LMTNC = 2 * LMTNC
!
!   Loop on merges of A and B into C
!
         Do
            IWRK = IWRKF
            IWRKD = IWRKF + 1
            JINDA = IWRKF + LMTNA
            IWRKF = IWRKF + LMTNC
            If (IWRKF >= NVAL) Then
               If (JINDA >= NVAL) Exit
               IWRKF = NVAL
            End If
            IINDA = 1
            IINDB = JINDA + 1
!
!   Shortcut for the case when the max of A is smaller
!   than the min of B. This line may be activated when the
!   initial set is already close to sorted.
!
!          IF (XDONT(IRNGT(JINDA)) <= XDONT(IRNGT(IINDB))) CYCLE
!
!  One steps in the C subset, that we build in the final rank array
!
!  Make a copy of the rank array for the merge iteration
!
            JWRKT (1:LMTNA) = IRNGT (IWRKD:JINDA)
!
            XVALA = XDONT (JWRKT(IINDA))
            XVALB = XDONT (IRNGT(IINDB))
!
            Do
               IWRK = IWRK + 1
!
!  We still have unprocessed values in both A and B
!
               If (XVALA > XVALB) Then
                  IRNGT (IWRK) = IRNGT (IINDB)
                  IINDB = IINDB + 1
                  If (IINDB > IWRKF) Then
!  Only A still with unprocessed values
                     IRNGT (IWRK+1:IWRKF) = JWRKT (IINDA:LMTNA)
                     Exit
                  End If
                  XVALB = XDONT (IRNGT(IINDB))
               Else
                  IRNGT (IWRK) = JWRKT (IINDA)
                  IINDA = IINDA + 1
                  If (IINDA > LMTNA) Exit! Only B still with unprocessed values
                  XVALA = XDONT (JWRKT(IINDA))
               End If
!
            End Do
         End Do
!
!  The Cs become As and Bs
!
         LMTNA = 2 * LMTNA
      End Do
!
      Return
!
End Subroutine DL_mrgrnk


Subroutine II_mrgrnk (XDONT, IRNGT)
! __________________________________________________________
!   MRGRNK = Merge-sort ranking of an array
!   For performance reasons, the first 2 passes are taken
!   out of the standard loop, and use dedicated coding.
! __________________________________________________________
! _________________________________________________________
      Integer(kii), Dimension (:), Intent (In) :: XDONT
      Integer(kii), Dimension (:), Intent (Out) :: IRNGT
! __________________________________________________________
      Integer(kii) :: XVALA, XVALB
!
      Integer(kii), Dimension (SIZE(IRNGT)) :: JWRKT
      Integer(kii) :: LMTNA, LMTNC, IRNG1, IRNG2
      Integer(kii) :: NVAL, IIND, IWRKD, IWRK, IWRKF, JINDA, IINDA, IINDB
!
      NVAL = Min (SIZE(XDONT), SIZE(IRNGT))
      Select Case (NVAL)
      Case (:0)
         Return
      Case (1)
         IRNGT (1) = 1
         Return
      Case Default
         Continue
      End Select
!
!  Fill-in the index array, creating ordered couples
!
      Do IIND = 2, NVAL, 2
         If (XDONT(IIND-1) <= XDONT(IIND)) Then
            IRNGT (IIND-1) = IIND - 1
            IRNGT (IIND) = IIND
         Else
            IRNGT (IIND-1) = IIND
            IRNGT (IIND) = IIND - 1
         End If
      End Do
      If (Modulo(NVAL, 2) /= 0) Then
         IRNGT (NVAL) = NVAL
      End If
!
!  We will now have ordered subsets A - B - A - B - ...
!  and merge A and B couples into     C   -   C   - ...
!
      LMTNA = 2
      LMTNC = 4
!
!  First iteration. The length of the ordered subsets goes from 2 to 4
!
      Do
         If (NVAL <= 2) Exit
!
!   Loop on merges of A and B into C
!
         Do IWRKD = 0, NVAL - 1, 4
            If ((IWRKD+4) > NVAL) Then
               If ((IWRKD+2) >= NVAL) Exit
!
!   1 2 3
!
               If (XDONT(IRNGT(IWRKD+2)) <= XDONT(IRNGT(IWRKD+3))) Exit
!
!   1 3 2
!
               If (XDONT(IRNGT(IWRKD+1)) <= XDONT(IRNGT(IWRKD+3))) Then
                  IRNG2 = IRNGT (IWRKD+2)
                  IRNGT (IWRKD+2) = IRNGT (IWRKD+3)
                  IRNGT (IWRKD+3) = IRNG2
!
!   3 1 2
!
               Else
                  IRNG1 = IRNGT (IWRKD+1)
                  IRNGT (IWRKD+1) = IRNGT (IWRKD+3)
                  IRNGT (IWRKD+3) = IRNGT (IWRKD+2)
                  IRNGT (IWRKD+2) = IRNG1
               End If
               Exit
            End If
!
!   1 2 3 4
!
            If (XDONT(IRNGT(IWRKD+2)) <= XDONT(IRNGT(IWRKD+3))) Cycle
!
!   1 3 x x
!
            If (XDONT(IRNGT(IWRKD+1)) <= XDONT(IRNGT(IWRKD+3))) Then
               IRNG2 = IRNGT (IWRKD+2)
               IRNGT (IWRKD+2) = IRNGT (IWRKD+3)
               If (XDONT(IRNG2) <= XDONT(IRNGT(IWRKD+4))) Then
!   1 3 2 4
                  IRNGT (IWRKD+3) = IRNG2
               Else
!   1 3 4 2
                  IRNGT (IWRKD+3) = IRNGT (IWRKD+4)
                  IRNGT (IWRKD+4) = IRNG2
               End If
!
!   3 x x x
!
            Else
               IRNG1 = IRNGT (IWRKD+1)
               IRNG2 = IRNGT (IWRKD+2)
               IRNGT (IWRKD+1) = IRNGT (IWRKD+3)
               If (XDONT(IRNG1) <= XDONT(IRNGT(IWRKD+4))) Then
                  IRNGT (IWRKD+2) = IRNG1
                  If (XDONT(IRNG2) <= XDONT(IRNGT(IWRKD+4))) Then
!   3 1 2 4
                     IRNGT (IWRKD+3) = IRNG2
                  Else
!   3 1 4 2
                     IRNGT (IWRKD+3) = IRNGT (IWRKD+4)
                     IRNGT (IWRKD+4) = IRNG2
                  End If
               Else
!   3 4 1 2
                  IRNGT (IWRKD+2) = IRNGT (IWRKD+4)
                  IRNGT (IWRKD+3) = IRNG1
                  IRNGT (IWRKD+4) = IRNG2
               End If
            End If
         End Do
!
!  The Cs become As and Bs
!
         LMTNA = 4
         Exit
      End Do
!
!  Iteration loop. Each time, the length of the ordered subsets
!  is doubled.
!
      Do
         If (LMTNA >= NVAL) Exit
         IWRKF = 0
         LMTNC = 2 * LMTNC
!
!   Loop on merges of A and B into C
!
         Do
            IWRK = IWRKF
            IWRKD = IWRKF + 1
            JINDA = IWRKF + LMTNA
            IWRKF = IWRKF + LMTNC
            If (IWRKF >= NVAL) Then
               If (JINDA >= NVAL) Exit
               IWRKF = NVAL
            End If
            IINDA = 1
            IINDB = JINDA + 1
!
!   Shortcut for the case when the max of A is smaller
!   than the min of B. This line may be activated when the
!   initial set is already close to sorted.
!
!          IF (XDONT(IRNGT(JINDA)) <= XDONT(IRNGT(IINDB))) CYCLE
!
!  One steps in the C subset, that we build in the final rank array
!
!  Make a copy of the rank array for the merge iteration
!
            JWRKT (1:LMTNA) = IRNGT (IWRKD:JINDA)
!
            XVALA = XDONT (JWRKT(IINDA))
            XVALB = XDONT (IRNGT(IINDB))
!
            Do
               IWRK = IWRK + 1
!
!  We still have unprocessed values in both A and B
!
               If (XVALA > XVALB) Then
                  IRNGT (IWRK) = IRNGT (IINDB)
                  IINDB = IINDB + 1
                  If (IINDB > IWRKF) Then
!  Only A still with unprocessed values
                     IRNGT (IWRK+1:IWRKF) = JWRKT (IINDA:LMTNA)
                     Exit
                  End If
                  XVALB = XDONT (IRNGT(IINDB))
               Else
                  IRNGT (IWRK) = JWRKT (IINDA)
                  IINDA = IINDA + 1
                  If (IINDA > LMTNA) Exit! Only B still with unprocessed values
                  XVALA = XDONT (JWRKT(IINDA))
               End If
!
            End Do
         End Do
!
!  The Cs become As and Bs
!
         LMTNA = 2 * LMTNA
      End Do
!
      Return
!
End Subroutine II_mrgrnk


end module m_mrgrnk

!> \file kerneldensity.F90

!> \brief Module for calculating the kernel density.
!<

module kernel_density_mod
use particle_system_mod, only: particle_system_type, particle_type
use sphpar_mod, only: sphpar_type 
use nblist_mod
implicit none

 private 
! public :: localpart_type
 public :: initdensity,gradrho,density,hsmdens,fromsphpar

 public :: massres,rhomin,spherevol

 integer,parameter :: ndim=3

 real :: massres
 real :: rhomin
 integer, parameter :: TARGETNN=32
 integer, parameter :: Ninterpolation=1000
 integer, parameter :: HSM_NEWTON_MAX_ITERATION=10
 real,    parameter :: HSM_NEWTON_PREC=0.0001 
 integer, parameter :: HSM_BISECTION_MAX_ITERATION=50
 real,    parameter :: HSM_BISECTION_PREC=0.001 
 integer, parameter :: HSM_BRACKET_TRY=50
 real,    parameter :: HSM_BRACKET_FAC=2. 
 real,    parameter :: Pi=3.141592653589793238
 real,    parameter :: kfac(3)=(/ 2.6666666666666666667,   &
                                  1.8189136353359466945,   &
                                  2.5464790894703253723 /)
 real :: spherevol,dspherevol

 real :: wsmooth(0:Ninterpolation+1),dwsmooth(0:Ninterpolation+1) 
 real, parameter :: deldr2=1./Ninterpolation

 integer :: nnewton=0,nbisect=0

 contains

 subroutine initdensity(mass)
   real :: mass
     massres=TARGETNN*mass
     rhomin=0.0
     call initkernel
     spherevol=UnitSphereVolume(ndim)
     dspherevol=spherevol*ndim
 end subroutine initdensity


 subroutine initkernel
   integer :: i
   real :: xw2,xw
     do i=0,1+Ninterpolation
        xw2=i*deldr2*4.
        xw=SQRT(xw2)
        if(xw2.LE.1.) then
           wsmooth(i)=1.-1.5*xw2+0.75*xw*xw2
           dwsmooth(i)=-3.+2.25*xw
        else
           wsmooth(i)=0.25*(2.-xw)**3
           dwsmooth(i)=-0.75*(2.-xw)**2/xw
        endif
        if(xw2.GE.4.) then
           wsmooth(i)=0.
           dwsmooth(i)=0.
        endif
        dwsmooth(i)=dwsmooth(i)*4 ! geloofik
     enddo
 end subroutine initkernel


 subroutine hsmdens(sphpar,psys,nblist)
 use oct_tree_mod, only: getlocalscale
   type(particle_system_type) :: psys
   type(sphpar_type) :: sphpar
   type(nblist_type) :: nblist
!    try if part%hsmooth=0.0 then get local scale
     if (sphpar%hsmooth==0.0) then
        sphpar%hsmooth = getlocalscale(sphpar%pos,nblist%stree)
     end if
     call resetnblist(nblist,sphpar%hsmooth,sphpar%pos)
     call hnewton(sphpar,psys,nblist)
     call hfunc(sphpar,psys,nblist)
 end subroutine hsmdens


 subroutine hnewton(sphpar,psys,nblist)
   type(particle_system_type) :: psys
   type(sphpar_type) :: sphpar
   type(nblist_type) :: nblist
   real :: hsmold,hmin,hmax
   integer :: i
     hmin=0.5*sphpar%hsmooth
     hmax=2*sphpar%hsmooth	 
     hsmold=sphpar%hsmooth
     nnewton=nnewton+1
     i=0
10   if(sphpar%hsmooth.LT.hmax .AND. & 
        sphpar%hsmooth.GT.hmin .AND. & 
        i.LT.HSM_NEWTON_MAX_ITERATION) then
        i=i+1
        call hfunc(sphpar,psys,nblist)
        if(sphpar%dfi.NE.0) then
           sphpar%hsmooth=sphpar%hsmooth-sphpar%fi/sphpar%dfi
!   print*,'nw',sphpar%hsmooth
        else
           sphpar%hsmooth=0
        endif
        if(ABS(sphpar%fi).LT.ABS(sphpar%hsmooth*HSM_NEWTON_PREC*sphpar%dfi)) then
           return
        endif
        goto 10
     else
        sphpar%hsmooth=hsmold
        call bisect(sphpar,psys,nblist)
     endif
 end subroutine hnewton



 subroutine hfunc(sphpar,psys,nblist)
   type(particle_system_type) :: psys
   type(sphpar_type) :: sphpar
   type(nblist_type) :: nblist
   
     if(nblist%nnb.LE.0.OR. &
        sphpar%hsmooth.GT.nblist%searchrange.OR. &
        sphpar%hsmooth.LT.0.5*nblist%searchrange) then
        call resetnblist(nblist,range=sphpar%hsmooth)
     endif
     call fidfi(sphpar,psys,nblist)
     return
 end subroutine hfunc

 subroutine do_nbsum(sphpar,psys,nblist,sumroutine)
   type(sphpar_type) :: sphpar
   type(particle_system_type) :: psys
   type(nblist_type) :: nblist

   interface
      subroutine sumroutine(pa,nb)
        use sphpar_mod, only: sphpar_type
        use nblist_mod, only: nblist_type
        type(sphpar_type) :: pa
        type(nblist_type) :: nb
      end subroutine sumroutine
   end interface
   
   if(nblist%reuseable) then
      call sumroutine(sphpar,nblist)  
      return
   endif
   call resetnblist(nblist)
   do while(nblist%searchcell.NE.0)
      nblist%nnb=0
      call fullsearch(psys,nblist)
      call sumroutine(sphpar,nblist)
   enddo
 end subroutine do_nbsum
 
subroutine gradrhosum(sphpar,nblist)
  type(sphpar_type) :: sphpar
  type(nblist_type)  :: nblist
  integer iwsm,i
  real :: dx(ndim),hinv,dknorm,dist2norm,dr2p,dist2,drw
  real :: dkernel
  real :: particle_mass
  hinv=1./sphpar%hsmooth
  dknorm=kfac(ndim)*hinv**(ndim+2)
  dist2norm=hinv**2/deldr2
  do i=1,nblist%nnb
   dx=sphpar%pos-nblist%sphpar(i)%pos
   dist2=sum(dx**2)
   dr2p=dist2*dist2norm
   if(Ninterpolation.GE.dr2p) then
    iwsm=INT(dr2p)                 
    drw=dr2p-iwsm
    dkernel=(1.-drw)*dwsmooth(iwsm)+drw*dwsmooth(1+iwsm)
    dkernel=dknorm*dkernel

    particle_mass = nblist%sphpar(i)%mass

    sphpar%gradrho=sphpar%gradrho+dx*particle_mass*dkernel                 
   endif
  enddo
end subroutine gradrhosum


 subroutine gradrho(sphpar,nblist)
  type(sphpar_type) :: sphpar
  type(nblist_type) :: nblist

  type(particle_system_type) psys

  sphpar%gradrho=0
  call do_nbsum(sphpar,psys,nblist,gradrhosum)
 end subroutine gradrho


 subroutine densitysum(sphpar,nblist)

  type(sphpar_type) sphpar
  type(nblist_type) nblist
  integer iwsm, i
  real :: dx(ndim), hinv, knorm, dknorm, dist2norm, dr2p, dist2, drw
  real :: kernel
  real :: particle_mass

!  real :: dkernel

  hinv=1./sphpar%hsmooth
  knorm=kfac(ndim)*hinv**ndim
  dknorm=kfac(ndim)*hinv**(ndim+2)
  dist2norm=hinv**2/deldr2
  do i=1,nblist%nnb
     dx=sphpar%pos-nblist%sphpar(i)%pos
     dist2=sum(dx**2)
     dr2p=dist2*dist2norm
     if(Ninterpolation.GE.dr2p) then
        sphpar%nnb=sphpar%nnb+1
        iwsm=INT(dr2p)                 
        drw=dr2p-iwsm
        kernel=(1.-drw)*wsmooth(iwsm)+drw*wsmooth(1+iwsm)
        kernel=knorm*kernel
        
        particle_mass = nblist%sphpar(i)%mass
    
        sphpar%rho=sphpar%rho+particle_mass*kernel
        sphpar%xHII = sphpar%xHII + particle_mass * nblist%sphpar(i)%xHII * kernel
        sphpar%T    = sphpar%T    + particle_mass * nblist%sphpar(i)%T    * kernel

     endif
  enddo

 end subroutine densitysum

 subroutine density(sphpar,psys,nblist)
  type(particle_system_type) psys
  type(sphpar_type) sphpar
  type(nblist_type) nblist
  sphpar%nnb=0
  sphpar%rho=0
  call do_nbsum(sphpar,psys,nblist,densitysum)  
  if(sphpar%rho.NE.0) sphpar%xHII = sphpar%xHII / sphpar%rho
  if(sphpar%rho.NE.0) sphpar%T    = sphpar%T    / sphpar%rho

  ! I added this to see about the vertical stripes
!  if(sphpar%rho.LT.rhomin) then
!     sphpar%rho = rhomin
!     sphpar%xHII = 1.00
!     sphpar%T = 1.0e4
!  end if


 end subroutine density


 subroutine fidfisum(sphpar,nblist)
  type(sphpar_type) sphpar
  type(nblist_type) nblist
  integer iwsm,i
  real :: dx(ndim),hinv, knorm,dknorm,dist2norm,dr2p,dist2,drw
  real :: kernel,dkernel
  real :: particle_mass
  hinv=1./sphpar%hsmooth
  knorm=kfac(ndim)*hinv**ndim
  dknorm=kfac(ndim)*hinv**(ndim+2)
  dist2norm=hinv**2/deldr2
  do i=1,nblist%nnb
     dx=sphpar%pos-nblist%sphpar(i)%pos
     dist2=sum(dx**2)
     dr2p=dist2*dist2norm
     if(dr2p.LT.0) then
        print*,'!!!!',dr2p
        stop
     endif
     if(Ninterpolation.GE.dr2p) then
        sphpar%nnb=sphpar%nnb+1
        iwsm=INT(dr2p)                 
        drw=dr2p-iwsm
        kernel=(1.-drw)*wsmooth(iwsm)+drw*wsmooth(1+iwsm)
        dkernel=(1.-drw)*dwsmooth(iwsm)+drw*dwsmooth(1+iwsm)
        kernel=knorm*kernel
        dkernel=dknorm*dkernel
        
        particle_mass = nblist%sphpar(i)%mass

        sphpar%rho=sphpar%rho+particle_mass*kernel
        sphpar%drhodh=sphpar%drhodh-ndim*hinv*particle_mass*kernel
        sphpar%drhodh=sphpar%drhodh-dist2*hinv*particle_mass*dkernel 
     endif
  enddo
 end subroutine fidfisum

 subroutine fidfi(sphpar,psys,nblist)
   type(particle_system_type) psys
   type(sphpar_type) sphpar
   type(nblist_type) nblist
     sphpar%nnb=0
     sphpar%rho=0
     sphpar%drhodh=0
     call do_nbsum(sphpar,psys,nblist,fidfisum)
     sphpar%fi=spherevol*sphpar%hsmooth**ndim*(sphpar%rho+rhomin)-massres
     sphpar%dfi=spherevol*ndim*sphpar%hsmooth**(ndim-1)*(sphpar%rho+rhomin)+ &
              spherevol*sphpar%hsmooth**ndim*sphpar%drhodh
 end subroutine fidfi



 subroutine bisect(sphpar,psys,nblist)
   type(particle_system_type) :: psys
   type(sphpar_type) :: sphpar
   type(nblist_type) :: nblist
   real :: hmin,hmax
  
     nbisect=nbisect+1
     call bracketh(sphpar,psys,nblist,hmin,hmax)
     call hsafe(sphpar,psys,nblist,hmin,hmax)  
     call hfunc(sphpar,psys,nblist)
 end subroutine bisect

 subroutine hsafe(sphpar,psys,nblist,hmin,hmax)
  type(particle_system_type) :: psys
  type(sphpar_type) :: sphpar
  type(nblist_type) :: nblist
  integer :: j
  real :: hmin, hmax
  real :: dx, dxold, fh, fl, temp, xl, xh  

!  integer :: p, maxit, nneigh
!  real :: prec, hneigh

  sphpar%hsmooth=hmax
  call hfunc(sphpar,psys,nblist)
  fh=sphpar%fi
  sphpar%hsmooth=hmin
  call hfunc(sphpar,psys,nblist)
  fl=sphpar%fi
  if(hmin.GE.hmax.OR.fl.GE.fh) call kernelError('hsafe error')
  if(fl.eq.0) then
   sphpar%hsmooth=hmin
   return
   if(fh.eq.0) then
    sphpar%hsmooth=hmax
   return
   endif
  endif 
  xl=hmin
  xh=hmax	 
  sphpar%hsmooth=.5*(xl+xh)
  dxold=(xh-xl)
  dx=dxold
  call hfunc(sphpar,psys,nblist)
  do j=1,HSM_BISECTION_MAX_ITERATION
   if( ((sphpar%hsmooth-xh)*sphpar%dfi - sphpar%fi) * &
       ((sphpar%hsmooth-xl)*sphpar%dfi - sphpar%fi) .GT. 0 .OR. &
       abs(2*sphpar%fi) .GT. ABS(dxold*sphpar%dfi) ) then
	    dxold=dx
	    dx=0.5*(xh-xl)
	    sphpar%hsmooth=xl+dx
	    if(xl.EQ.sphpar%hsmooth)return
   else
	    dxold=dx
	    dx=sphpar%fi/sphpar%dfi
	    temp=sphpar%hsmooth
	    sphpar%hsmooth=temp-dx
	    if(temp.EQ.sphpar%hsmooth)return
   endif
   if(abs(dx).LT.HSM_BISECTION_PREC*hmax) return
   call hfunc(sphpar,psys,nblist)
   if(sphpar%fi.lt.0) then 
    xl=sphpar%hsmooth
   else    
    xh=sphpar%hsmooth
   endif
  enddo
  return	 
 end subroutine hsafe
	 
 subroutine bracketh(sphpar,psys,nblist,hmin,hmax)
 type(particle_system_type) psys
 type(sphpar_type) sphpar
 type(nblist_type) nblist
 integer j
 real hmin,hmax,f1,f2
  hmax=sphpar%hsmooth
  hmin=hmax/HSM_BRACKET_FAC
  call hfunc(sphpar,psys,nblist)
  f2=sphpar%fi
  sphpar%hsmooth=hmin
  call hfunc(sphpar,psys,nblist)
  f1=sphpar%fi
  do j=1,HSM_BRACKET_TRY
   if(f1*f2.LT.0) return
   if(abs(f1).lt.abs(f2)) then
    hmin=hmin/HSM_BRACKET_FAC
    sphpar%hsmooth=hmin
    call hfunc(sphpar,psys,nblist)
    f1=sphpar%fi    
   else
    hmax=hmax*HSM_BRACKET_FAC
    sphpar%hsmooth=hmax
    call hfunc(sphpar,psys,nblist)
    f2=sphpar%fi
   endif
  enddo 
  print*,sphpar,hmin,hmax
  call kernelError('hsm bracketing')
  return
 end subroutine bracketh
  
 subroutine kernelError(string,i)
  character(len=*) :: string
  integer, optional :: i
  
  print*,'error detected'

  if(present(i)) then
   print*,string,i
  else
   print*,string
  endif
  stop
 end subroutine kernelError

 function UnitSphereVolume(m) result(vol)
 real :: vol
 integer,intent(in) :: m
  if(mod(m,2).eq.0) then
   vol=Pi**(m/2)/fac(m/2)
  else
   vol=2**((m+1)/2)*Pi**((m-1)/2)/fac2(m) 
  endif
 end function UnitSphereVolume

 function fac(n)
 integer :: fac
 integer,intent(in) :: n
 integer :: i
 fac=1
 do i=1,n
    fac=fac*i
 enddo
 end function fac
 
 recursive function fac2(n) result(f2)
   integer :: f2
   integer,intent(in) :: n
     f2=1
     if(n.le.0) return
     if(mod(n,2).eq.0) then 
        f2=fac(n/2)*2**(n/2) 
     else 
        f2=fac(n)/(fac2(n-1))
     endif
 end function fac2

 function fromsphpar(part)
   type(particle_type) :: part
   type(sphpar_type) :: fromsphpar
     fromsphpar%pos=part%pos
     fromsphpar%rho=massres/spherevol/part%hsml**ndim-rhomin
     fromsphpar%nnb=0
     fromsphpar%gradrho=0.
     fromsphpar%drhodh=0.
     fromsphpar%hsmooth=part%hsml
     fromsphpar%fi=0.
     fromsphpar%dfi=0.
 end function fromsphpar



end module kernel_density_mod

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2010 Krzysztof M. Gorski, Eric Hivon, 
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.jpl.nasa.gov
!
!-----------------------------------------------------------------------------
module pix_tools
use healpix_types
implicit none

INTEGER(KIND=i4b), private, PARAMETER :: ns_max=8192 ! 2^13 : largest nside available


interface fatal_error
   module procedure fatal_error_womsg, fatal_error_msg
end interface


contains


  subroutine fatal_error_msg (msg)
    character(len=*), intent(in) :: msg
    print *,'Fatal error: ', trim(msg)
    stop
  end subroutine fatal_error_msg
  
  subroutine fatal_error_womsg
    print *,'Fatal error'
    stop
  end subroutine fatal_error_womsg
  


  !=======================================================================
  subroutine pix2ang_ring(nside, ipix, theta, phi)
    !=======================================================================
    !     renders theta and phi coordinates of the nominal pixel center
    !     for the pixel number ipix (RING scheme)
    !     given the map resolution parameter nside
    !=======================================================================
    INTEGER(KIND=I4B), INTENT(IN) :: ipix, nside
    REAL(KIND=DP), INTENT(OUT) ::  theta, phi

    INTEGER(KIND=I4B) ::  nl2, nl4, npix, ncap, iring, iphi, ip, ipix1
    REAL(KIND=DP) ::  fodd, hip, fihip
    !-----------------------------------------------------------------------
    if (nside<1 .or. nside>ns_max) call fatal_error ("nside out of range")
    npix = 12*nside**2       ! total number of points
    if (ipix <0 .or. ipix>npix-1) call fatal_error ("ipix out of range")

    ipix1 = ipix + 1 ! in {1, npix}
    nl2 = 2*nside
    ncap = 2*nside*(nside-1) ! points in each polar cap, =0 for nside =1

    if (ipix1 <= ncap) then ! North Polar cap -------------

       hip   = ipix1*0.5_dp
       fihip = AINT ( hip , kind=DP)
       iring = INT( SQRT( hip - SQRT(fihip) ) ) + 1 ! counted from North pole
       iphi  = ipix1 - 2*iring*(iring - 1)

       theta = ACOS( 1.0_dp - iring**2 / (3.0_dp*nside**2) )
       phi   = (real(iphi,kind=dp) - 0.5_dp) * PI/(2.0_dp*iring)

    elseif (ipix1 <= nl2*(5*nside+1)) then ! Equatorial region ------

       ip    = ipix1 - ncap - 1
       nl4   = 4*nside
       iring = INT( ip / nl4 ) + nside ! counted from North pole
       iphi  = MODULO(ip,nl4) + 1

       fodd  = 0.5_dp * (1 + MODULO(iring+nside,2))  ! 1 if iring+nside is odd, 1/2 otherwise
       theta = ACOS( (nl2 - iring) / (1.5_dp*nside) )
       phi   = (real(iphi,kind=dp) - fodd) * PI /(2.0_dp*nside)

    else ! South Polar cap -----------------------------------

       ip    = npix - ipix1 + 1
       hip   = ip*0.5_dp
       fihip = AINT ( hip , kind=DP)
       iring = INT( SQRT( hip - SQRT(fihip) ) ) + 1     ! counted from South pole
       iphi  = 4*iring + 1 - (ip - 2*iring*(iring-1))

       theta = ACOS( -1.0_dp + iring**2 / (3.0_dp*nside**2) )
       phi   = (real(iphi,kind=dp) - 0.5_dp) * PI/(2.0_dp*iring)

    endif

    return
  end subroutine pix2ang_ring



  subroutine pix2vec_ring(nside, ipix, vector, vertex)
    !=======================================================================
    !     renders vector (x,y,z) coordinates of the nominal pixel center
    !     for the pixel number ipix (RING scheme)
    !     given the map resolution parameter nside
    !     also returns the (x,y,z) position of the 4 pixel vertices (=corners)
    !     in the order N,W,S,E
    !=======================================================================
    INTEGER(KIND=I4B), INTENT(IN)                             :: ipix, nside
    REAL(KIND=DP),     INTENT(OUT),dimension(1:)              :: vector
    REAL(KIND=DP),     INTENT(OUT),dimension(1:,1:), optional :: vertex

    INTEGER(KIND=I4B) :: nl2, nl4, npix, ncap, iring, iphi, ip, ipix1
    REAL(KIND=DP) ::  fact1, fact2, fodd, hip, fihip, z, sth, phi

    real(kind=DP) :: phi_nv, phi_wv, phi_sv, phi_ev
    real(kind=DP) :: z_nv, z_sv, sth_nv, sth_sv
    real(kind=DP) :: hdelta_phi
    integer(kind=I4B) :: iphi_mod, iphi_rat
    logical(kind=LGT) :: do_vertex
    !-----------------------------------------------------------------------
    if (nside<1 .or. nside>ns_max) call fatal_error("nside out of range")
    npix = 12*nside**2       ! total number of points
    if (ipix <0 .or. ipix>npix-1) call fatal_error("ipix out of range")

    ipix1 = ipix + 1 ! in {1, npix}
    nl2 = 2*nside
    nl4 = 4*nside
    ncap = 2*nside*(nside-1) ! points in each polar cap, =0 for nside =1
    fact1 = 1.5_dp*nside
    fact2 = 3.0_dp*nside**2

    do_vertex = .false.
    if (present(vertex)) then
       if (size(vertex,dim=1) >= 3 .and. size(vertex,dim=2) >= 4) then
          do_vertex = .true.
       else
          call fatal_error(" pix2vec_ring : vertex array has wrong size ")
       endif
    endif

    phi_nv = 0.0_dp
    phi_sv = 0.0_dp
    if (ipix1 <= ncap) then ! North Polar cap -------------

       hip   = ipix1/2.0_dp
       fihip = AINT ( hip ,kind=DP)
       iring = INT( SQRT( hip - SQRT(fihip) ) ) + 1 ! counted from North pole
       iphi  = ipix1 - 2*iring*(iring - 1)

       z =  1.0_dp - iring**2 / fact2
       phi   = (real(iphi,kind=dp) - 0.5_dp) * PI/(2.0_dp*iring)

       if (do_vertex) then
          hdelta_phi = PI/(4.0_dp*iring)   ! half pixel width
          z_nv = 1.0_dp - (iring-1)**2 / fact2
          z_sv = 1.0_dp - (iring+1)**2 / fact2
          iphi_mod = MODULO(iphi-1, iring) ! in {0,1,... iring-1}
          iphi_rat = (iphi-1) / iring      ! in {0,1,2,3}
          if (iring > 1) phi_nv = HALFPI * (iphi_rat +  iphi_mod   /real(iring-1,kind=dp))
          phi_sv                = HALFPI * (iphi_rat + (iphi_mod+1)/real(iring+1,kind=dp))
       endif


    elseif (ipix1 <= nl2*(5*nside+1)) then ! Equatorial region ------

       ip    = ipix1 - ncap - 1
       iring = INT( ip / nl4 ) + nside ! counted from North pole
       iphi  = MODULO(ip,nl4) + 1

       fodd  = 0.5_dp * (1 + MODULO(iring+nside,2))  ! 1 if iring+nside is odd, 1/2 otherwise
       z = (nl2 - iring) / fact1
       phi   = (real(iphi,kind=dp) - fodd) * PI /(2.0_dp*nside)

       if (do_vertex) then
          hdelta_phi = PI/(4.0_dp*nside)   ! half pixel width
          phi_nv = phi
          phi_sv = phi
          z_nv = (nl2 - iring +1) / fact1
          z_sv = (nl2 - iring -1) / fact1
          if (iring == nside) then ! northern transition
             z_nv = 1.0_dp - (nside-1)**2 / fact2
             iphi_mod = MODULO(iphi-1, nside) ! in {0,1,... nside-1}
             iphi_rat = (iphi-1) / nside      ! in {0,1,2,3}
             if (nside > 1) phi_nv = HALFPI * (iphi_rat +  iphi_mod   /real(nside-1,kind=dp))
          elseif (iring == 3*nside) then ! southern transition
             z_sv = -1.0_dp + (nside-1)**2 / fact2
             iphi_mod = MODULO(iphi-1, nside) ! in {0,1,... iring-1}
             iphi_rat = (iphi-1) / nside      ! in {0,1,2,3}
             if (nside > 1) phi_sv = HALFPI * (iphi_rat +  iphi_mod   /real(nside-1,kind=dp))
          endif
       endif

    else ! South Polar cap -----------------------------------

       ip    = npix - ipix1 + 1
       hip   = ip/2.0_dp
       fihip = AINT ( hip ,kind=DP)
       iring = INT( SQRT( hip - SQRT(fihip) ) ) + 1     ! counted from South pole
       iphi  = 4*iring + 1 - (ip - 2*iring*(iring-1))

       z = -1.0_dp + iring**2 / fact2
       phi   = (real(iphi,kind=dp) - 0.5_dp) * PI/(2.0_dp*iring)

       if (do_vertex) then
          hdelta_phi = PI/(4.0_dp*iring)   ! half pixel width
          z_nv = -1.0_dp + (iring+1)**2 / fact2
          z_sv = -1.0_dp + (iring-1)**2 / fact2
          iphi_mod = MODULO(iphi-1, iring) ! in {0,1,... iring-1}
          iphi_rat = (iphi-1) / iring      ! in {0,1,2,3}
          phi_nv                = HALFPI * (iphi_rat + (iphi_mod+1)/real(iring+1,kind=dp))
          if (iring > 1) phi_sv = HALFPI * (iphi_rat +  iphi_mod   /real(iring-1,kind=dp))
       endif

    endif

    ! pixel center
    sth = SQRT((1.0_dp-z)*(1.0_dp+z))
    vector(1) = sth * COS(phi)
    vector(2) = sth * SIN(phi)
    vector(3) = z

    if (do_vertex) then
       ! west vertex
       phi_wv      = phi - hdelta_phi
       vertex(1,2) = sth * COS(phi_wv)
       vertex(2,2) = sth * SIN(phi_wv)
       vertex(3,2) = z

       ! east vertex
       phi_ev      = phi + hdelta_phi
       vertex(1,4) = sth * COS(phi_ev)
       vertex(2,4) = sth * SIN(phi_ev)
       vertex(3,4) = z

       ! north vertex
       sth_nv = SQRT((1.0_dp-z_nv)*(1.0_dp+z_nv))
       vertex(1,1) = sth_nv * COS(phi_nv)
       vertex(2,1) = sth_nv * SIN(phi_nv)
       vertex(3,1) = z_nv

       ! south vertex
       sth_sv = SQRT((1.0_dp-z_sv)*(1.0_dp+z_sv))
       vertex(1,3) = sth_sv * COS(phi_sv)
       vertex(2,3) = sth_sv * SIN(phi_sv)
       vertex(3,3) = z_sv
    endif


    return
  end subroutine pix2vec_ring



end module pix_tools

module hashMod
! simple integer hash

private
public :: initHash, find, endHash, hash_type

type hash_type
  integer,  allocatable :: nextkey(:)
  integer :: nkey
end type

 contains
 
function hashfunc(nkey,dat)
 integer :: dat,nkey,hashfunc
 hashfunc=ABS(mod(dat,nkey))+1
end function
 
subroutine initHash(nk,n,dat,hash)
 integer :: nk,n,dat(n)
 type(hash_type) :: hash
 hash%nkey=nk
 if(allocated(hash%nextkey)) call endHash(hash) 
 allocate(hash%nextkey(hash%nkey+n))
 call insert(n,dat,hash)
end subroutine

subroutine insert(n,dat,hash)
 integer :: i,n,next,dat(n)
 type(hash_type) :: hash
 hash%nextkey(1:hash%nkey)=0
 do i=1,n
   next=hashfunc(hash%nkey,dat(i))
   do while(hash%nextkey(next).NE.0)
      next=hash%nextkey(next)
   enddo
   hash%nextkey(next)=hash%nkey+i
   hash%nextkey(hash%nkey+i)=0
 enddo
end subroutine

function find(item,dat,hash) result(next)
 integer :: item,dat(*)
 integer :: next
 type(hash_type) :: hash
 next=hashfunc(hash%nkey,item)
 next=hash%nextkey(next)
 do
   if(next.EQ.0) exit
   if(dat(next-hash%nkey).EQ.item) exit
   next=hash%nextkey(next)
 enddo
 if(next.NE.0) next=next-hash%nkey  
end function

subroutine endHash(hash)
  type(hash_type) :: hash
  deallocate(hash%nextkey)
end subroutine

end module


subroutine test
 use hashMod
 type(hash_type) :: hash
 integer :: n,i,dat(13)
 
 n=13
 dat=(/12,2,3,4,5,5,6,12,13,16,-6,0,-8383/)
 
 call inithash(5,13,dat(1:n),hash)
 
10 read*,i
  if(i.eq.-999) stop
  i=find(i,dat(1:n),hash)
  if(i.NE.0) print*,i,dat(i)  
  goto 10
 
 call endHash(hash)

end subroutine

!> \file physical_constants.F90

!> \brief stores physical constants 
!!
!<

!> physical constants module
module physical_constants_mod
use myf03_mod
implicit none

! famous numbers
!-------------------

    real(r8b), parameter :: ex = 2.71828182846d0    !< base of the natural log
    real(r8b), parameter :: pi = 3.141592653589793238462643383279502884197d0 !< pi


! physical constants in cgs units (set to be compatible with Gadget)
!-------------------------------------------------------------------

    real(r8b), parameter :: h_erg_s = 6.6262d-27    !< Plank's const. (erg*s)
    real(r8b), parameter :: h_eV_s  = 4.1357d-15    !< Plank's const. (eV*s)
    real(r8b), parameter :: k_erg_K = 1.3806d-16    !< Boltzman's (erg/K)
    real(r8b), parameter :: k_eV_K  = 8.6173d-5     !< Boltzman's (eV/K)    
    real(r8b), parameter :: c = 2.9979d10           !< speed of light (cm/s)
    real(r8b), parameter :: G = 6.672d-8            !< grav const. (cm^3 g^-1 s^-2)

! usefull physical scales
!-------------------------

    real(r8b), parameter :: M_H  = 1.6737d-24       !< Hydrogen mass (g)
    real(r8b), parameter :: M_He = 6.6465d-24       !< Helium mass (g)  
    real(r8b), parameter :: M_p  = 1.6726d-24       !< proton mass (g) 
    real(r8b), parameter :: M_e  = 9.10953d-28      !< electron mass (g) 
    real(r8b), parameter :: M_solar = 1.989d33      !< solar mass (g)
    real(r8b), parameter :: L_solar = 3.826d33      !< solar luminosity (ergs/s) 
    real(r8b), parameter :: Rydberg = 1.36d1        !< ionization energy of HI (eV)
    real(r8b), parameter :: CMBtempNow = 2.728d0    !< CMB temperature now (K)
    
! convenient conversion factors
!------------------------------

    real(r8b), parameter :: Mpc2cm       = 3.085678d24         !< Mpc to cm
    real(r8b), parameter :: kpc2cm       = 3.085678d21         !< kpc to cm
    real(r8b), parameter :: pc2cm        = 3.085678d18         !< pc to cm
    real(r8b), parameter :: km2cm        = 1.0d5               !< km to cm

    real(r8b), parameter :: kpc2cm3      = kpc2cm**3           !< kpc^3 to cm^3
    real(r8b), parameter :: cm2kpc       = 3.24077649d-22      !< cm to kpc
    real(r8b), parameter :: cm2kpc3      = cm2kpc**3           !< cm^3 to kpc^3

    real(r8b), parameter :: Mpc2km       = 3.08568025d19       !< Mpc to km
    real(r8b), parameter :: km2Mpc       = 3.24077649d-20      !< km to Mpc
    real(r8b), parameter :: erg2eV       = 6.24150974d11       !< ergs to eV
    real(r8b), parameter :: eV2erg       = 1.60217646d-12      !< eV to ergs
    real(r8b), parameter :: erg2solar    = 1.0d0/L_solar       !< cgs 2 solar 
    real(r8b), parameter :: year2sec     = 3.1556926d7         !< years to seconds
    real(r8b), parameter :: Myr2sec      = 3.1556926d13        !< Myrs to seconds
    real(r8b), parameter :: Gyr2sec      = 3.1556926d16        !< Gyrs to seconds
    real(r8b), parameter :: sec2year     = 1.0d0 / year2sec    !< seconds to years
    real(r8b), parameter :: s2Myr        = 1.0d0 / Myr2sec     !< seconds to Myrs
    real(r8b), parameter :: g2solar      = 1.0d0 / M_solar     !< grams 2 solar masses
    real(r8b), parameter :: solarLMyrs   = L_solar * Myr2sec   !< cgs to ergs / Myrs
    real(r8b), parameter :: fourthirdspi = 4.188790204786391d0 !< four thirds * pi

! hydrogen and helium lines expressed in various ways
!---------------------------------------------------------------------

    real(r8b), parameter :: HI_th_eV   = 13.606d0  !< HI ionization threshold (eV)
    real(r8b), parameter :: HeI_th_eV  = 24.587d0  !< HeI ionization threshold (eV)
    real(r8b), parameter :: HeII_th_eV = 54.416d0  !< HeII ionization threshold (eV)
    
    real(r8b), parameter :: HI_th_erg   = HI_th_eV * eV2erg    !< HI ionization threshold (ergs)
    real(r8b), parameter :: HeI_th_erg  = HeI_th_eV * eV2erg   !< HeI ionization threshold (ergs)
    real(r8b), parameter :: HeII_th_erg = HeII_th_eV * eV2erg  !< HeII ionization threshold (ergs)

    real(r8b), parameter :: HI_th_Hz   = HI_th_eV   / h_eV_s  !< HI ionization threshold (Hz)
    real(r8b), parameter :: HeI_th_Hz  = HeI_th_eV  / h_eV_s  !< HeI ionization threshold (Hz)
    real(r8b), parameter :: HeII_th_Hz = HeII_th_eV / h_eV_s  !< HeII ionization threshold (Hz)
    
    real(r8b), parameter :: HI_th_cm   = h_eV_s * c / HI_th_eV    !< HI ionization threshold (cm)
    real(r8b), parameter :: HeI_th_cm  = h_eV_s * c / HeI_th_eV   !< HeI ionization threshold (cm)
    real(r8b), parameter :: HeII_th_cm = h_eV_s * c / HeII_th_eV  !< HeII ionization threshold (cm)

    real(r8b), parameter :: HI_th_nm   = HI_th_cm * 1.0d7    !< HI ionization threshold (nm)
    real(r8b), parameter :: HeI_th_nm  = HeI_th_cm * 1.0d7   !< HeI ionization threshold (nm)
    real(r8b), parameter :: HeII_th_nm = HeII_th_cm * 1.0d7  !< HeII ionization threshold (nm)

    real(r8b), parameter :: HI_th_A   = HI_th_cm * 1.0d8    !< HI ionization threshold (A)
    real(r8b), parameter :: HeI_th_A  = HeI_th_cm * 1.0d8   !< HeI ionization threshold (A)
    real(r8b), parameter :: HeII_th_A = HeII_th_cm * 1.0d8  !< HeII ionization threshold (A)

    real(r8b), parameter :: H_LyA_eV = HI_th_eV - HI_th_eV / 4.0d0  !< H Lyman Alpha (eV)
    real(r8b), parameter :: H_LyA_cm = h_eV_s * c / H_LyA_eV        !< H Lyman Alpha (cm)
    real(r8b), parameter :: H_LyA_nm = H_LyA_cm * 1.0d7             !< H Lyman Alpha (nm)
    real(r8b), parameter :: H_LyA_A  = H_LyA_cm * 1.0d8             !< H Lyman Alpha (A)
    real(r8b), parameter :: H_LyA_Hz = c / H_LyA_cm                 !< H Lyman Alpha (Hz)




end module physical_constants_mod

!> \file density_test.F90

!> \brief Module contains calls to the density test (in development)
!<

! this program illustrates the use of the density routines..
program densitytest
  use particle_system_mod, only: particle_system_type
  use snapshot_mod, only: particle_header_type
  use snapshot_mod, only: read_particle_header
  use input_mod, only: read_initial_snapshot
  use nblist_mod, only: nblist_type, prepare_neighbor_search
  use kernel_density_mod, only: initdensity, hsmdens, density
  use global_mod, only: global_variables_type
  use config_mod, only: config_variables_type
  use sphpar_mod, only: sphpar_type
  use physical_constants_mod
  use myf90, only: clen
  implicit none

  
  type(particle_system_type) :: psys
  type(particle_header_type) :: phead
  type(nblist_type) :: nblist
  type(sphpar_type) :: lpart
  type(global_variables_type) :: gvars
  type(config_variables_type) :: cvars

  real :: small
  real :: cellsize(3)
  integer :: cells1d(3)
  real :: zonesize(3),halfzone(3),quarzone(3)  

  character(clen) :: snapfile,rhofile,ionfile,tempfile
  character(clen) :: buffer
  integer :: i,j,k

  real :: lpos(3)
  real :: DfltHsml, DfltMass, DfltTemp
  real :: zcoord
  real, allocatable :: rho(:,:), xHII(:,:), T(:,:)

  real :: rhomin, rhomax
  real :: xHIImin, xHIImax
  real :: maxmass
  logical :: verbose,closefile
  integer :: lun
  real :: MBalloc
  real :: hh

    call getarg(1,snapfile)
    call getarg(2,rhofile)
    call getarg(3,ionfile)
    call getarg(4,tempfile)
    call getarg(5,buffer)
    read(buffer,*) zonesize(1)
    call getarg(5,buffer)
    read(buffer,*) zonesize(2)
    call getarg(5,buffer)
    read(buffer,*) zonesize(3)

    cells1D(1) = 256
    cells1D(2) = 256
    cells1D(3) = 256

!    zonesize(3) = zonesize(3)/2
!    cells1D(3) = cells1D(3)/2

    allocate( rho(cells1d(1),cells1d(3)) )
    allocate( xHII(cells1d(1),cells1d(3)) )
    allocate( T(cells1d(1),cells1d(3)) )

    halfzone = zonesize / 2.0
    quarzone = zonesize / 4.0
    cellsize = zonesize / cells1d
    write(*,*) "cellsize = ", cellsize
    write(*,*) "zonesize = ", zonesize
    
    verbose = .false. 
    closefile = .true.
    call read_particle_header(snapfile,verbose,closefile,phead,lun)
    call set_necessary_globals()
    call read_initial_snapshot(gvars,snapfile,verbose,psys,MBalloc)

    rhomin = minval(psys%par(:)%rho)
    rhomax = maxval(psys%par(:)%rho)
    
    xHIImin = minval(psys%par(:)%xHII)
    xHIImax = maxval(psys%par(:)%xHII)

  

! everything up to this point just reads in a particle system, assigns
! global variables, and changes the boundry conditions to periodic.

! intiialize kernel density routines  
#ifdef incmass
  maxmass = maxval(psys%par(:)%mass)
  call initdensity(maxmass)
#else
  call initdensity(gvars%iso_mass)
#endif

! initialize nblist search 
  call prepare_neighbor_search(psys,nblist,DfltMass,DfltTemp)
  write(*,*) 

! this calculates the density at the particle positions
! (and outputs) note that the actual density calculation uses a 
! 'local' particle type, which is a particle with some special 
!  members exclusive for density calculation 
! (this also allows the density to be probed at any point, because lpart
! need not be initialized from real particles!!)





  write(*,*) "default smoothing length = ", DfltHsml
  write(*,*) "npar = ", psys%npar
  write(*,*) "min/max readin rho", rhomin, rhomax
  write(*,*) "min/max readin xHII", xHIImin, xHIImax
#ifdef incT
  write(*,*) "min/max T", minval(psys%par(:)%T), maxval(psys%par(:)%T)
#endif
  write(*,*) "zonesize = ", zonesize

  write(*,*) "tops = ", psys%box%top
  write(*,*) "bots = ", psys%box%bot


10 format (A,3I4,3ES10.2)
100 format(A,I5,A,3F8.2)

  hh=DfltHsml
  do i = 1,cells1d(1)

     if (mod(i,64)==0) write(*,'(A,F10.2)') "% done ", real(i)/cells1d(1) 

     do j = 1,cells1d(3)
!        do k = 1,cells1d

        lpart%pos(1) = -halfzone(1) + (i-0.5) * cellsize(1) 
        lpart%pos(2) = -halfzone(3) + (j-0.5) * cellsize(3)
        lpart%pos(3) = 0.0

 
        ! if we are outside the computational volume just set to 0.0
        
        small = 0.0        
        if (lpart%pos(1).lt.psys%box%bot(1)+small .or. &
            lpart%pos(2).lt.psys%box%bot(2)+small .or. & 
            lpart%pos(3).lt.psys%box%bot(3)+small .or. &
            lpart%pos(1).gt.psys%box%top(1)-small .or. &
            lpart%pos(2).gt.psys%box%top(2)-small .or. & 
            lpart%pos(3).gt.psys%box%top(3)-small ) then
            rho(i,j) = 0.0
            xHII(i,j) = 0.0
            T(i,j) = 0.0
            cycle
         end if

        lpart%rho=1.0
        lpart%xHII=0.0
        lpart%T =0.0
        lpart%nnb=0
        lpart%gradrho=0.
        lpart%drhodh=0.
        lpart%hsmooth=hh
        lpart%fi=0.
        lpart%dfi=0.

        call hsmdens(lpart,psys,nblist)
        call density(lpart,psys,nblist)

!        if (lpart%xHII==1.00) lpart%xHII = xHIImax

        ! stop execution if averaged value is below particle extremes
        if (lpart%rho.le.0.0) stop "rho .le. 0.0"

!        if (lpart%rho.lt.rhomin-small) then
!           write(*,*) "***************************"
!           write(*,*) "rho below min", lpart%rho
!           write(*,*) "pos = ", lpart%pos
!           write(*,*) "nnb = ", lpart%nnb
!           write(*,*) "***************************"
!           stop
!           lpart%rho = rhomin
!        end if

        if (lpart%rho.gt.rhomax+small) then
           write(*,*) "***************************"
           write(*,*) "rho above max", lpart%rho
           write(*,*) "pos = ", lpart%pos
           write(*,*) "nnb = ", lpart%nnb
           write(*,*) "***************************"
           stop
           lpart%rho = rhomax
        end if
        

        if (lpart%xHII.lt. xHIImin) then
           write(*,*) "***************************"
           write(*,*) "xHII below min", lpart%xHII
           write(*,*) "pos = ", lpart%pos
           write(*,*) "nnb = ", lpart%nnb
           write(*,*) "***************************"
           stop
           lpart%xHII = xHIImin
        else if (lpart%xHII.gt.xHIImax) then
           write(*,*) "***************************"
           write(*,*) "xHII above max", lpart%xHII
           write(*,*) "pos = ", lpart%pos
           write(*,*) "nnb = ", lpart%nnb
           write(*,*) "***************************"
           stop
           lpart%xHII = xHIImax
        end if

        rho(i,j)  = lpart%rho
        xHII(i,j) = lpart%xHII
        T(i,j)    = lpart%T
        hh= lpart%hsmooth

!        write(*,*) "rho = ", rho(i,j)
!        write(*,*) "xHII = ", xHII(i,j)
!        write(*,*) "T    = ", T(i,j)

     end do
  end do

  write(*,*) "min/max rho", minval( rho ), maxval( rho )
  write(*,*) "min/max xHII", minval( xHII ), maxval( xHII )
  write(*,*) "min/max T", minval(T), maxval(T)
  write(*,*) 
  write(*,*) "==========================================================="

  open(unit=10,file=rhofile,status="UNKNOWN",form="unformatted")  
  open(unit=20,file=ionfile,status="UNKNOWN",form="unformatted")  
  open(unit=30,file=tempfile,status="UNKNOWN",form="unformatted")  
  write(10) rho
  write(20) xHII
  write(30) T
  close(10)
  close(20)
  close(30)

contains

 subroutine set_necessary_globals()
 
   integer :: NsphNnb, Npar
   real :: BoxVol, VperPar

   DfltMass = phead%real(2)%var
   DfltTemp = phead%real(3)%var
   NsphNnb = phead%int(4)%var

   Npar = phead%int(1)%var
   gvars%iso_mass = DfltMass
   cvars%IsoMass = DfltMass
   cvars%NsphNnb = NsphNnb

   psys%box%bbound=0
   psys%box%tbound=0
   psys%box%bot = minval(phead%real(5:7)%var)
   psys%box%top = maxval(phead%real(8:10)%var)
 
   DfltHsml = 0.0
   
 end subroutine set_necessary_globals

end program densitytest

!> \file cosmology.F90

!> \brief Module contains simple analytic cosmological functions
!<
module cosmology_mod
use myf03_mod
implicit none

  contains

!-------------------------------------------------------------------
!> returns the time since the big bang in a flat LCDM Universe
!! the units of time are seconds.  
  function tsinceBB(a,OmegaM,h) result (t)
  use physical_constants_mod, only: km2Mpc
    real(r8b) :: a      !< scale factor
    real(r8b) :: OmegaM !< Omega Matter
    real(r8b) :: h      !< little hubble
    real(r8b) :: t      !< time since big bang in seconds
    real(r8b) :: OmegaL,aeq
    real(r8b) :: pre,arg,H0

    H0 = h * 100.0d0 * km2Mpc ! Hubble parameter in inverse seconds
    OmegaL = 1.0 - OmegaM
    aeq = (OmegaM/OmegaL)**(1./3.)

    pre = 2./( 3. * sqrt(OmegaL) )
    arg = (a/aeq)**(3./2.) + sqrt(1 + (a/aeq)**3)
    t = pre * log(arg) / H0

  end function tsinceBB


!-------------------------------------------------------------------
!> returns the physical time between two scale factors (seconds)
!! in a flat LCDM Universe.
  subroutine da2dt(a1,a2,OmegaM,h,dt) 
  use physical_constants_mod, only: km2Mpc

    real(r8b), intent(in) :: a1     !< initial scale factor
    real(r8b), intent(in) :: a2     !< final scale factor
    real(r8b), intent(in) :: OmegaM !< Omega Matter
    real(r8b), intent(in) :: h      !< little Hubble
    real(r8b), intent(out) :: dt     !< 
    
    real(r8b) :: t1,t2
    
    if (OmegaM <= 0.0) stop "cosmology.f90>> OmegaMatter must be >= 0.0"
    if (a1 <= 0.0 .or. a1 > 1.0) then
       write(*,*) "cosmology.f90>> da2dt - a1 out of range "
       write(*,*) "a1 = ", a1
       stop
    end if

    if (a2 <= 0.0 .or. a2 > 1.0) then
       write(*,*) "cosmology.f90>> da2dt - a2 out of range "
       write(*,*) "a2 = ", a2
       stop
    end if

    if (a1 <= 0.0 .or. a1 > 1.0) then
       write(*,*) "cosmology.f90>> da2dt - a1 out of range "
       write(*,*) "a1 = ", a1
       stop
    end if

    if (a2 < a1) then
       write(*,*) "cosmology.f90>> da2dt -  a2 must be > a1"
       write(*,*) "a1,a2 = ", a1, a2
       stop
    end if

    t1 = tsinceBB(a1,OmegaM,h)
    t2 = tsinceBB(a2,OmegaM,h)
    dt = t2-t1
 
  end subroutine da2dt



end module cosmology_mod

!> \file cen_atomic_rates.F90

!> \brief Module that stores the rate fits from  
!! http://adsabs.harvard.edu/abs/1992ApJS...78..341C
!<
module cen_atomic_rates_mod
use myf03_mod
implicit none

  real(r8b), parameter, private :: h_erg_s = 6.626068e-27 !< plank [erg s]
  real(r8b), parameter, private :: h_eV_s = 4.1356668e-15 !< plank [eV s]
  real(r8b), parameter, private :: k_erg_K = 1.3806503e-16 !< Boltzman [erg/K]
  real(r8b), parameter, private :: k_eV_K = 8.6173423e-5 !< Boltzman [eV/K]
  real(r8b), parameter, private :: nu_H = 13.6 / h_eV_s !< HI threshold [Hz] 
  real(r8b), parameter, private :: nu_HeI = 24.587 / h_eV_s !< HeI threshold [Hz]
  real(r8b), parameter, private :: nu_HeII = 54.416 / h_eV_s !< HeII threshold [Hz]
 
contains

! random stuff
!**************
! Osterbrok 1989
! HyRecA(5000)=6.82e-13 ; HyRecA(10000)=4.18e-13 ; HyRecA(20000)=2.51e-13
! HyRecB(5000)=4.54e-13 ; HyRecB(10000)=2.59e-13 ; HyRecB(20000)=2.52e-13
!

!#########################################!
! Heating and Cooling functions           !
!#########################################!


! collisional ionization cooling 
!================================
  
!----------------------------------------------------
!>  HI collisional ionization cooling [erg cm^3 s^-1]
    function Cen_HI_col_ion_cool(T)  
        real(r8b)  :: Cen_HI_col_ion_cool !< rate
        real(r8b)  :: T !< temperature [K]
        Cen_HI_col_ion_cool = 1.27e-21 * T**(1./2.) * &
                     (1 + (T/1.0e+5)**(1./2.))**(-1) * exp(-1.578091e+5/T)
    end function Cen_HI_col_ion_cool

!-----------------------------------------------------
!>  HeI collisional ionization cooling [erg cm^3 s^-1]
    function Cen_HeI_col_ion_cool(T)
        real(r8b)  :: Cen_HeI_col_ion_cool !< rate
        real(r8b)  :: T !< temperature [K]
        Cen_HeI_col_ion_cool = 9.38e-22 * T**(1./2.) * &
                     (1 + (T/1.0e+5)**(1./2.))**(-1) * exp(-2.853354e+5/T)
    end function Cen_HeI_col_ion_cool

!-----------------------------------------------------
!> HeII collisional ionization cooling [erg cm^3 s^-1]
    function Cen_HeII_col_ion_cool(T) 
        real(r8b)  :: Cen_HeII_col_ion_cool !< rate
        real(r8b)  :: T !< temperature [K]
        Cen_HeII_col_ion_cool = 4.95e-22 * T**(1./2.) * &
                     (1 + (T/1.0e+5)**(1./2.))**(-1) * exp(-6.31515e+5/T)
    end function Cen_HeII_col_ion_cool

!------------------------------------------------------
!> He(2^3S) collisional ionization cooling [cm^6 s^-1]
    function Cen_He23s_col_ion_cool(T)
        real(r8b)  :: Cen_He23s_col_ion_cool !< rate
        real(r8b)  :: T !< temperature [K]
        Cen_He23s_col_ion_cool = 5.01e-27 * T**(-1.687e-1) * &
                     (1 + (T/1.0e+5)**(1./2.))**(-1) * exp(-5.5338e+4/T)
    end function Cen_He23s_col_ion_cool


! Recombination cooling 
!=========================

!--------------------------------------------
!> HII recombination cooling [erg cm^3 s^-1] 
    function Cen_HII_recomb_coolA(T)
        real(r8b)  :: Cen_HII_recomb_coolA !< rate
        real(r8b)  :: T !< temperature [K]
        Cen_HII_recomb_coolA = 8.70e-27 * T**(1./2.) * (T/1.0e+3)**(-0.2) * &
                     (1 + (T/1.0e+6)**(0.7))**(-1) 
    end function Cen_HII_recomb_coolA

!----------------------------------------------
!>   HeII recombination cooling [erg cm^3 s^-1]
    function Cen_HeII_recomb_coolA(T)
        real(r8b)  :: Cen_HeII_recomb_coolA !< rate
        real(r8b)  :: T !< temperature [K]
        Cen_HeII_recomb_coolA = 1.55e-26 * T**(0.3647e0)
    end function Cen_HeII_recomb_coolA

!-----------------------------------------------
!>   HeIII recombination cooling [erg cm^3 s^-1]
    function Cen_HeIII_recomb_coolA(T)
        real(r8b)  :: Cen_HeIII_recomb_coolA !< rate
        real(r8b)  :: T !< temperature [K]
        Cen_HeIII_recomb_coolA = 3.48e-26 * T**(1./2.) * (T/1.0e+3)**(-0.2) * &
                     (1 + (T/1.0e+6)**(0.7))**(-1) 
    end function Cen_HeIII_recomb_coolA

!---------------------------------------------------------
!>  He dielectronic recombination cooling [erg cm^3 s^-1]
    function Cen_He_dielec_recomb_cool(T)
        real(r8b)  :: Cen_He_dielec_recomb_cool !< rate
        real(r8b)  :: T !< temperature [K]
        Cen_He_dielec_recomb_cool = 1.24e-13 * T**(-1.5e0) * &
                     exp(-4.7e5/T) * ( 1.0e0 + 0.3e0 * exp(-9.4e4/T) )
    end function Cen_He_dielec_recomb_cool


! Collisional excitation cooling 
!==================================

!-----------------------------------------------------------
!> HI collisional excitation cooling (all n) [erg cm^3 s^-1]
    function Cen_HI_col_ext_cool(T) 
        real(r8b)  :: Cen_HI_col_ext_cool !< rate
        real(r8b)  :: T !< temperature [K]
        Cen_HI_col_ext_cool = 7.50e-19 * &
                     (1 + (T/1.0e+5)**(1./2.))**(-1) * exp(-118348.e0/T)
    end function Cen_HI_col_ext_cool 

!-------------------------------------------------------------------------
!> HeI collisional excitation cooling (n = 2,3,4 triplets) [erg cm^6 s^-1]
    function Cen_HeI_col_ext_cool(T)
        real(r8b)  :: Cen_HeI_col_ext_cool !< rate
        real(r8b)  :: T !< temperature [K]
        Cen_HeI_col_ext_cool = 9.10e-27 * T**(-0.1687e0) * &
                     (1 + (T/1.0e+5)**(1./2.))**(-1) * exp(-13179.e0/T)
    end function Cen_HeI_col_ext_cool 

!---------------------------------------------------------------
!> HeII collisional excitation cooling (n = 2) [erg cm^3 s^-1]
    function Cen_HeII_col_ext_cool(T)
        real(r8b)  :: Cen_HeII_col_ext_cool !< rate
        real(r8b)  :: T !< temperature [K]
        Cen_HeII_col_ext_cool = 5.54e-17 * T**(-0.397e0) * &
                     (1 + (T/1.0e+5)**(1./2.))**(-1) * exp(-473638.e0/T)
    end function Cen_HeII_col_ext_cool 

!-----------------------------------------
!>  bremsstrahlung cooling [erg cm^3 s^-1]
    function Cen_Bremss_cool(T,nHII,nHeII,nHeIII,ne)
        real(r8b)  :: Cen_Bremss_cool !< rate
        real(r8b)  :: T !< temperature [K]
        real(r8b)  :: ne !< electron number density
        real(r8b)  :: nHII   !< HII number density
        real(r8b)  :: nHeII  !< HeII number density
        real(r8b) ::  nHeIII !< HeIII number density
        real(r8b)  :: gff !< gaunt factor
        gff = 1.5e0
        Cen_Bremss_cool = 1.42e-27 * sqrt(T) * gff * &
                          (nHII + nHeII + 4*nHeIII) * ne
    end function Cen_Bremss_cool

!-------------------------------------------------
!>  Haiman bremsstrahlung cooling [erg cm^3 s^-1]
    function Haiman_Bremss_cool_He(T,nHII,nHeII,nHeIII,ne)
        real(r8b)  :: Haiman_Bremss_cool_He !< rate
        real(r8b)  :: T !< temperature [K]
        real(r8b)  :: ne !< electron number density
        real(r8b)  :: nHII   !< HII number density
        real(r8b)  :: nHeII  !< HeII number density
        real(r8b) ::  nHeIII !< HeIII number density
        real(r8b)  :: gff !< gaunt factor
        gff = 1.10e0 + 0.34e0 * exp( -(5.50e0 - log10(T))**2/3.0e0 )
        Haiman_Bremss_cool_He = 1.42e-27 * T**(1./2.) * gff * &
                          (nHII + nHeII + 4*nHeIII) * ne
    end function Haiman_Bremss_cool_He

!-------------------------------------------------
!>  Haiman bremsstrahlung cooling [erg cm^3 s^-1]
    function Haiman_Bremss_cool_H(T,nHII,ne)
        real(r8b)  :: Haiman_Bremss_cool_H !< rate
        real(r8b)  :: T !< temperature [K]
        real(r8b)  :: ne !< electron number density
        real(r8b)  :: nHII   !< HII number density
        real(r8b)  :: gff !< gaunt factor
        gff = 1.10e0 + 0.34e0 * exp( -(5.50e0 - log10(T))**2/3.0e0 )
        Haiman_Bremss_cool_H = 1.42e-27 * T**(1./2.) * gff * &
                          (nHII) * ne
    end function Haiman_Bremss_cool_H

!---------------------------------------------------    
!> Haiman compton heating / cooling [erg cm^3 s^-1]
    function Haiman_Comp_heol(T,Tcmb,ne)
        real(r8b)  :: Haiman_Comp_heol !< rate
        real(r8b)  :: T     !< temperature [K]
        real(r8b)  :: Tcmb  !< background radiation temperature [K]
        real(r8b)  :: ne    !< electron number density
        Haiman_Comp_heol = 1.017e-37 * ne * Tcmb**4 * (T - Tcmb)  
    end function Haiman_Comp_heol


!#############################################!
! functions pertaining to the ionization state!
!#############################################!


! Collisional Ionization rates 
!==============================

!----------------------------------------
!> HI collisional ionization [cm^3 s^-1]   
    function Cen_HI_col_ion(T)
        real(r8b)  :: Cen_HI_col_ion !< rate
        real(r8b)  :: T !< temperature [K]
        Cen_HI_col_ion = 5.85e-11 * T**(1./2.) * &
                     (1.0 + (T/1.0e+5)**(1./2.))**(-1) * exp(-157809.1/T)
    end function Cen_HI_col_ion 

!----------------------------------------
!> HeI collisional ionization [cm^3 s^-1]  
    function Cen_HeI_col_ion(T)
        real(r8b)  :: Cen_HeI_col_ion !< rate
        real(r8b)  :: T !< temperature [K]
        Cen_HeI_col_ion = 2.38e-11 * T**(1./2.) * &
                     (1.0e+0 + (T/1.0e+5)**(1./2.))**(-1) * exp(-285335.4e0/T)
    end function Cen_HeI_col_ion 

!-----------------------------------------
!> HeII collisional ionization [cm^3 s^-1]  
    function Cen_HeII_col_ion(T)
        real(r8b)  :: Cen_HeII_col_ion !< rate
        real(r8b)  :: T !< temperature [K]
        Cen_HeII_col_ion = 5.68e-12 * T**(1./2.) * &
                     (1.0e+0 + (T/1.0e+5)**(1./2.))**(-1) * exp(-631515.e0/T)
    end function Cen_HeII_col_ion 


! Recombination rates, all from Cen 1992 except the one Spitzer
!===========================================================================

!---------------------------------------
!> HII recombination case A [cm^3 s^-1] 
    function Cen_HII_recombA(T)
        real(r8b)  :: Cen_HII_recombA !< rate
        real(r8b)  :: T !< temperature [K]
        Cen_HII_recombA = 8.40e-11 * T**(-1./2.) * (T/1.0e+3)**(-0.2) * &
                     (1 + (T/1.0e+6)**(0.7))**(-1)      
    end function Cen_HII_recombA


!---------------------------------------------------------------------
!> HII recombination case B (Power Law from Spitzer Table) [cm^3 s^-1] 
    function Spitzer_HII_recombB(T)
        real(r8b)  :: Spitzer_HII_recombB !< rate
        real(r8b)  :: T !< temperature [K]
        Spitzer_HII_recombB = 10**(-9.66286) / T**(0.739505)
    end function Spitzer_HII_recombB

!----------------------------------------
!> HeII recombination case A [cm^3 s^-1] 
    function Cen_HeII_recombA(T)
        real(r8b)  :: Cen_HeII_recombA !< rate
        real(r8b)  :: T !< temperature [K]
        Cen_HeII_recombA = 1.50e-10 * T**(-0.6353e0)
    end function Cen_HeII_recombA

!-----------------------------------------
!> HeIII recombination case A [cm^3 s^-1]  
    function Cen_HeIII_recombA(T)
      real(r8b)  :: Cen_HeIII_recombA !< rate
      real(r8b)  :: T !< temperature [K]
      Cen_HeIII_recombA =  3.36e-10 * T**(-1./2.) * (T/1.0e+3)**(-0.2) * &
           ( 1 + (T/1.0e+6)**(0.7) )**(-1) 
    end function Cen_HeIII_recombA
    
!----------------------------------------------
!> He dielectronic recombination [cm^3 s^-1] 
    function Cen_He_dielec_recomb(T)
        real(r8b)  :: Cen_He_dielec_recomb !< rate
        real(r8b)  :: T !< temperature [K]
        Cen_He_dielec_recomb =  1.90e-3 * T**(-1.5e0) * &
                   exp(-470000.e0/T) * ( 1.0e0 + 0.3e0 * exp(-94000.e0/T) )
    end function Cen_He_dielec_recomb


! photoionization cross-sections from Verner
!===========================================================

  !> HI photo ionization x-section (Verner) [cm^2]
  !-------------------------------------------------------------------------
  function Verner_HI_photo_cs( Ry ) result( sigma )
    real(r8b), intent(in) :: Ry  !< energy [Rydbergs]
    real(r8b) :: sigma           !< cross section [cm^2]
    real(r8b), parameter :: Eth = 13.6d0
    real(r8b), parameter :: Emax = 5.0d4
    real(r8b), parameter :: E0 = 4.298d-1
    real(r8b), parameter :: sig0 = 5.475d4
    real(r8b), parameter :: ya = 3.288d1
    real(r8b), parameter :: P = 2.963d0

    real(r8b) :: eV
    real(r8b) :: x
    real(r8b) :: y

    if (Ry < 1.d0) then
      sigma = 0.d0
      return
    end if
    
    eV = Ry * 13.6d0
    x = eV / E0
    y = x
  
    sigma = sig0 * (x-1)**2 * y**(0.5d0 * P - 5.5d0) * (1 + sqrt(y/ya))**(-P)
    sigma = sigma * 1.0d-18

  end function Verner_HI_photo_cs


! photoionization cross-sections from Osterbrok 1989
!===========================================================


!-----------------------------------------
!> HI photo ionization (Osterbrok) [cm^2]
    function Osterbrok_HI_photo_cs(freq) result(sigma)    
        real(r8b) :: freq  !< frequency [Hz]
        real(r8b) :: sigma !< cross section 
        if (freq < nu_H) then
           sigma = 0.0e0
           return
        end if
        sigma = 6.3e-18 * ( freq / nu_H ) ** (-3)
    end function Osterbrok_HI_photo_cs

!------------------------------------------
!> HeI photo ionization (Osterbrok)  [cm^2]
    function Osterbrok_HeI_photo_cs(freq) result(sigma)    
        real(r8b) :: freq  !< frequency [Hz]
        real(r8b) :: sigma !< cross section
        real(r8b) :: scaled_freq
        if (freq < nu_HeI) then
           sigma = 0.0e0
           return
        end if
        scaled_freq = freq / nu_HeI
        sigma = 7.2e-18 * & 
                ( 1.66e0 * ( scaled_freq )**(-2.05e0) + &
                  0.66e0 * ( scaled_freq )**(-3.05e0) )
    end function Osterbrok_HeI_photo_cs

!------------------------------------------
!> HeII photo ionization (Osterbrok)  [cm^2]
    function Osterbrok_HeII_photo_cs(freq) result(sigma)    
        real(r8b) :: freq  !< frequency
        real(r8b) :: sigma !< cross section
        if (freq < nu_HeII) then
           sigma = 0.0e0
           return
        end if
        sigma = 1.58e-18 * ( freq / nu_HeII ) ** (-3)
    end function Osterbrok_HeII_photo_cs


end module cen_atomic_rates_mod

!> \file gadget_public_header_hdf5_class.F90

!> \brief Handles HDF5 GADGET 2.0 Public version style headers.  
!!
!! Contains the means to read/write headers from a file.  
!< 

module gadget_public_header_hdf5_class
use myf03_mod
use gadget_general_class
use gadget_public_header_class

#ifdef useHDF5
use hdf5_wrapper
#endif

implicit none
private
 
public :: gadget_public_header_hdf5_read_lun
public :: gadget_public_header_hdf5_read_file
public :: gadget_public_header_hdf5_write_lun


contains


!> reads a gadget header from an hdf5 file
!--------------------------------------------------------------
subroutine gadget_public_header_hdf5_read_lun(this, fh)
  type(gadget_public_header_type) :: this
  integer, intent(in) :: fh

#ifdef useHDF5
  call hdf5_read_attribute(fh,'Header/NumPart_ThisFile',this%npar_file)
  call hdf5_read_attribute(fh,'Header/NumPart_Total',this%npar_all)
  call hdf5_read_attribute(fh,'Header/NumPart_Total_HW',this%npar_hw)
  call hdf5_read_attribute(fh,'Header/MassTable',this%mass)
  call hdf5_read_attribute(fh,'Header/Time',this%a)

  call hdf5_read_attribute(fh,'Header/Redshift',this%z)
  call hdf5_read_attribute(fh,'Header/BoxSize',this%boxlen)
  call hdf5_read_attribute(fh,'Header/NumFilesPerSnapshot',this%nfiles)
  call hdf5_read_attribute(fh,'Header/Omega0',this%OmegaM)
  call hdf5_read_attribute(fh,'Header/OmegaLambda',this%OmegaL)
  call hdf5_read_attribute(fh,'Header/HubbleParam',this%h)

  call hdf5_read_attribute(fh,'Header/Flag_Sfr',this%flag_sfr)
  call hdf5_read_attribute(fh,'Header/Flag_Cooling',this%flag_cooling)
  call hdf5_read_attribute(fh,'Header/Flag_StellarAge',this%flag_age)
  call hdf5_read_attribute(fh,'Header/Flag_Metals',this%flag_metals)
  call hdf5_read_attribute(fh,'Header/Flag_Feedback',this%flag_feedback)
  call hdf5_read_attribute(fh,'Header/Flag_Entropy_ICs',this%flag_entr_ics)
#else 
  write(*,*) 'useHDF5 macro not defined in Makefile' 
  stop
#endif

end subroutine gadget_public_header_hdf5_read_lun


!> reads a gadget header from an hdf5 file
!--------------------------------------------------------------
subroutine gadget_public_header_hdf5_read_file(this, snapfile)
  type(gadget_public_header_type) :: this
  character(*), intent(in) :: snapfile
  integer :: fh

#ifdef useHDF5
  call hdf5_open_file( fh, snapfile, readonly=.true. )
  call gadget_public_header_hdf5_read_lun(this, fh)
  call hdf5_close_file( fh )
#else 
  write(*,*) 'useHDF5 macro not defined in Makefile' 
  stop
#endif

end subroutine gadget_public_header_hdf5_read_file



!> writes a gadget header to an hdf5 file
!--------------------------------------------------------------
subroutine gadget_public_header_hdf5_write_lun(this, fh)
  type(gadget_public_header_type), intent(in) :: this
  integer, intent(in) :: fh

#ifdef useHDF5
  call hdf5_write_attribute(fh,'Header/NumPart_ThisFile',this%npar_file)
  call hdf5_write_attribute(fh,'Header/NumPart_Total',this%npar_all)
  call hdf5_write_attribute(fh,'Header/NumPart_Total_HW',this%npar_hw)
  call hdf5_write_attribute(fh,'Header/MassTable',this%mass)
  call hdf5_write_attribute(fh,'Header/Time',this%a)

  call hdf5_write_attribute(fh,'Header/Redshift',this%z)
  call hdf5_write_attribute(fh,'Header/BoxSize',this%boxlen)
  call hdf5_write_attribute(fh,'Header/NumFilesPerSnapshot',this%nfiles)
  call hdf5_write_attribute(fh,'Header/Omega0',this%OmegaM)
  call hdf5_write_attribute(fh,'Header/OmegaLambda',this%OmegaL)
  call hdf5_write_attribute(fh,'Header/HubbleParam',this%h)

  call hdf5_write_attribute(fh,'Header/Flag_Sfr',this%flag_sfr)
  call hdf5_write_attribute(fh,'Header/Flag_Cooling',this%flag_cooling)
  call hdf5_write_attribute(fh,'Header/Flag_StellarAge',this%flag_age)
  call hdf5_write_attribute(fh,'Header/Flag_Metals',this%flag_metals)
  call hdf5_write_attribute(fh,'Header/Flag_Feedback',this%flag_feedback)
  call hdf5_write_attribute(fh,'Header/Flag_Entropy_ICs',this%flag_entr_ics)
#else 
  write(*,*) 'useHDF5 macro not defined in Makefile' 
  stop
#endif

end subroutine gadget_public_header_hdf5_write_lun



end module gadget_public_header_hdf5_class

!> \file raylist.F90

!> \brief The raylist module 
!!
!<

module raylist_mod
use myf03_mod
use ray_mod
use particle_system_mod, only: particle_system_type
use particle_system_mod, only: particle_type
use particle_system_mod, only: transformation_type
use oct_tree_mod, only: oct_tree_type

implicit none

 private
 public :: intersection_type
 public :: trace_ray
 public :: raylist_type
 public :: prepare_raysearch
 public :: kill_raylist

 real, parameter :: zero = 0.0d0
 real, parameter :: half = 0.5d0

 integer,parameter :: MAX_RAYLIST_LENGTH = 1000000  !< default maximum
 integer,parameter :: ndim = 3                      !< number of dimensions
 integer,parameter :: nimages = 3**ndim             !< number of search images


!> holds a particle index, an impact parameter, and a distance along a ray
!! usefull for the ionization and temperature updating
! -----------------------------------------------------------------------
   type intersection_type
      integer(i8b) :: pindx   !< particle index
      real :: b          !< impact parameter
      real :: d          !< distance along ray
      real :: dl         !< path length
   end type intersection_type
 
!> grouping of all things ray + impacts
!--------------------------------------- 
   type raylist_type
      integer :: nnb              !< number of intersections
      integer :: maxnnb           !< maximum number of intersections
      integer :: lastnnb          !< intersection where we stopped
      integer(i8b) :: searchcell  !< index of cell being searched
      logical :: reuseable        !< is this ray reusable?
      integer :: searchimage      !< which transformation of the particles?
      integer :: nsearchimages    !< how many images to search
      type(src_ray_type) :: ray   !< ray 
      type(transformation_type) :: trafo(nimages)  !< transformations  
      type(intersection_type), allocatable :: intersection(:) !< ray/par 
   end type raylist_type



contains


 
!> set intersection values
!-----------------------------------------
 function set_intersection(ray, part, i) result(t)
   type(intersection_type) :: t  !< the intersection
   type(src_ray_type) :: ray         !< the ray
   type(particle_type) :: part   !< the particle
   integer(i8b)  :: i            !< the particle index
   real(r8b) :: d
   
     t%pindx = i
     t%b = src_ray_dist2pt(ray, part%pos, d)
     t%d = d

 end function set_intersection

 
!> initialize raylist variables and set search images
!------------------------------------------------------
 subroutine prepare_raysearch(psys, raylist)

   type(particle_system_type) psys !< particle system
   type(raylist_type) raylist      !< ray list
  
   call make_raylist(MAX_RAYLIST_LENGTH, raylist)
   call setsearchimages(psys,raylist)

 end subroutine prepare_raysearch


!> check all of the search images for intersection
!---------------------------------------------------
 subroutine fullsearch(psys, searchtree, raylist)

   type(particle_system_type) :: psys  !< particle system
   type(oct_tree_type) :: searchtree   !< oct-tree to search
   type(raylist_type) raylist          !< raylist

   if(raylist%searchimage == 0) call raylistError('raylist init.')
   do while (raylist%searchimage <= raylist%nsearchimages)   
      call raysearch(psys, searchtree, raylist)
      if (raylist%searchcell /= 0) return 
      raylist%searchimage = raylist%searchimage + 1
      raylist%searchcell = 1
   enddo
   raylist%searchcell = 0

 end subroutine fullsearch


!> checks a single search image for intersection
!-----------------------------------------------
 subroutine raysearch(psys, searchtree, raylist)

   type(particle_system_type), intent(in) :: psys         !< particle system
   type(oct_tree_type), intent(in), target :: searchtree  !< oct-tree to search
   type(raylist_type) :: raylist                          !< raylist


   type(oct_tree_type), pointer :: tree      !< pointer to tree
   type(src_ray_type) :: curay               !< transformed ray
   integer(i8b) :: this, daughter, next      !< octree indices
   integer(i8b) :: par_in_cell               !< number of particles in current search cell
   logical :: par_hit                        !< ray / particle intersection test
   logical :: cell_hit                       !< ray / cell intersection test
   logical :: long                           !< past max distance? 
   integer(i8b) :: i, si, orderindx

   tree => searchtree
   si = raylist%searchimage

   ! curay%start = ray%start * fac + shift
   call src_ray_transform( raylist%ray, curay, raylist%trafo(si) )
   next = raylist%searchcell

   do while (next /= 0)

      this     = next
      daughter = tree%cell(this)%daughter
      next     = tree%cell(this)%next
           
      ! if we've reached a leaf
      !----------------------------
      if (daughter == 0) then

         ! return if we go over max intersections
         !--------------------------------------------
         par_in_cell = tree%cell(next)%start - tree%cell(this)%start
         if (raylist%nnb + par_in_cell > raylist%maxnnb) then             
            write(*,*) ' *** reached max intersections *** '
            raylist%reuseable  = .false.
            raylist%searchcell = this
            return            
         endif
         
         ! add intersected particles to list
         !----------------------------------------------
         do i = tree%cell(this)%start, tree%cell(next)%start - 1
            orderindx = tree%partorder(i)
            par_hit = src_ray_part_intersection( curay, psys%par(orderindx) ) 
            if (par_hit) then
               raylist%nnb = raylist%nnb + 1
               raylist%intersection(raylist%nnb) = &
                    set_intersection(curay, psys%par(orderindx), orderindx)
            endif
         enddo


      ! if we need to descend further
      !--------------------------------
      else

         cell_hit = src_ray_cell_intersection( curay, tree%cell(this) )
         if ( cell_hit ) next = daughter  

      endif

   enddo
   
   raylist%searchcell = next
   
 end subroutine raysearch


!> initializes values in the raylist
!-------------------------------------------
 subroutine make_raylist(maxnnb, raylist, ray)

   integer, intent(in) :: maxnnb       !< maximum number of intersections
   type(raylist_type)      :: raylist  !< the raylist
   type(src_ray_type),optional :: ray  !< the ray
   real(r8b) :: start(ndim)
   real(r8b) :: dir(ndim)
  
     raylist%nnb            = 0
     raylist%maxnnb         = maxnnb
     raylist%searchcell     = 1
     raylist%reuseable      = .false.
     raylist%searchimage    = 1
     raylist%nsearchimages  = 1
     raylist%trafo(1)%fac   = 1
     raylist%trafo(1)%shift = zero 

     allocate(raylist%intersection(maxnnb))

     if (present(ray)) then
        raylist%ray = ray
     endif

 end subroutine make_raylist

!> reset an already initialized raylist
!---------------------------------------
 subroutine reset_raylist(raylist,ray)

   type(raylist_type) :: raylist       !< the raylist
   type(src_ray_type), optional :: ray !< the ray
  
     raylist%nnb         = 0
     raylist%searchcell  = 1
     raylist%searchimage = 1
     raylist%reuseable   = .false.
     if (present(ray)) then
        raylist%ray = ray
     endif

 end subroutine reset_raylist

!> kill a raylist
!---------------------------------
 subroutine kill_raylist(raylist)

   type(raylist_type) :: raylist !< the raylist to kill
   real(r8b) :: start(ndim)
   real(r8b) :: dir(ndim) 
  
     raylist%nnb=0
     raylist%maxnnb=MAX_RAYLIST_LENGTH
     raylist%searchcell=0
     deallocate(raylist%intersection)

 end subroutine kill_raylist


!> create the transformations for the searchimages
!-------------------------------------------------
 subroutine setsearchimages(psys,raylist)

   type(particle_system_type), intent(in) :: psys
   type(raylist_type) :: raylist
   
   real :: top(ndim)        !< top box corner
   real :: bot(ndim)        !< bottom box corner
   integer :: bbound(ndim)  !< bottom BCs
   integer :: tbound(ndim)  !< top BCs
   integer :: nsearchimages !< number of valid periodic images

   integer :: i_image       !< loop over images counter
   integer :: i_dim         !< loop over dimensions counter
  
   integer :: vec(ndim)     !< vector from origin of base box to origin of image box
   integer :: fac           !< tmp storage transformation factor for each dimension
   real    :: shift         !< tmp storage transformation shift for each dimension

   integer :: l
   real :: lx(ndim),hx(ndim)
   logical :: boxexists

   top    = psys%box%tops
   bot    = psys%box%bots
   bbound = psys%box%bbound
   tbound = psys%box%tbound
   
   nsearchimages = 0
   
   do i_image = 0, nimages - 1
      l = i_image
      
      do i_dim = 1, ndim
         vec(i_dim)=mod(l,3)-1 
         l=l/3
      enddo
      
      boxexists = .true.
      
      do i_dim = 1, ndim
         lx(i_dim) = bot(i_dim) + vec(i_dim) * ( top(i_dim) - bot(i_dim) )
         hx(i_dim) = top(i_dim) + vec(i_dim) * ( top(i_dim) - bot(i_dim) )
         if( vec(i_dim) == -1 .and. bbound(i_dim) == 0) boxexists = .false.  
         if( vec(i_dim) ==  1 .and. tbound(i_dim) == 0) boxexists = .false.  
      enddo
            
      if (boxexists) then
         nsearchimages = nsearchimages + 1
         
         do i_dim = 1, ndim
            
            fac   = 1
            shift = zero
            
            if( vec(i_dim) == -1 ) then
               fac   = bbound(i_dim)
               shift = (-3 * fac + 1) * half * bot(i_dim) + &
                       (     fac + 1) * half * top(i_dim)
            endif
            
            if( vec(i_dim) == 1 ) then
               fac   = tbound(i_dim)
               shift = (-3 * fac + 1) * half * top(i_dim) + &
                       (     fac + 1) * half * bot(i_dim)
            endif

            raylist%trafo(nsearchimages)%fac(i_dim)   = fac
            raylist%trafo(nsearchimages)%shift(i_dim) = shift

         enddo
         
      endif ! boxexists
      
      
   enddo
   
   raylist%nsearchimages = nsearchimages


 end subroutine setsearchimages


!> error handling
!---------------------------------
 subroutine raylistError(string,i)
   character(*) :: string  !< error message
   integer, optional :: i  !< error number

     print*,' Error detected:'
  
     if(present(i)) then
        print*,string,i
     else
        print*,string
     endif
  
     stop

 end subroutine raylistError

!> sorts a raylist according to the distance along the ray with the particles 
!! closest to the origin of the ray first in the list.   The corresponding 
!! changes are made to pindx and b
!---------------------------------------------------------------------------
 subroutine sort3_raylist(raylist)
 use m_mrgrnk, only: mrgrnk
 implicit none

   type(raylist_type) :: raylist     !< raylist to sort

   integer(i8b) :: N 
   integer(i8b) :: indexx(raylist%nnb)
   real(r8b) :: darr(raylist%nnb)

   N = raylist%nnb
   darr(1:N)=raylist%intersection(1:N)%d
   call mrgrnk(darr,indexx)

   raylist%intersection(1:N)%d=raylist%intersection(indexx(1:N))%d  
   raylist%intersection(1:N)%b=raylist%intersection(indexx(1:N))%b 
   raylist%intersection(1:N)%pindx=raylist%intersection(indexx(1:N))%pindx  

 end subroutine sort3_raylist





!> given a ray creates a raylist with intersections
!------------------------------------------------------
 subroutine trace_ray(ray, raylist, psys, searchtree, dosort) 
   type(src_ray_type), intent(in) :: ray           !< the ray to trace
   type(raylist_type), intent(inout) :: raylist    !< the returned raylist
   type(particle_system_type), intent(in) :: psys  !< the particle system
   type(oct_tree_type), intent(in) :: searchtree   !< the oct-tree to search
   logical, intent(in), optional :: dosort         !< default is true

   logical :: wantsort

   wantsort = .true.
   if (present(dosort)) then
      if (.not. dosort) wantsort = .false.
   endif

   if (raylist%maxnnb /= MAX_RAYLIST_LENGTH) then      
      call prepare_raysearch(psys, raylist)
   end if

   call reset_raylist(raylist, ray)
   call fullsearch(psys, searchtree, raylist)

   if (wantsort) call sort3_raylist(raylist)

 end subroutine trace_ray




end module raylist_mod

!> \file nblist.F90

!> \brief The neighbor list module.
!! 
!<
module nblist_mod
use myf90_mod
use particle_system_mod, only: particle_system_type
use particle_system_mod, only: transformation_type
use sphpar_mod, only: sphpar_type, par2sphpar
use oct_tree_mod, only: oct_tree_type
use global_mod
implicit none

 private
 public :: nblist_type
! public :: search,fullsearch,prepare_neighbor_search,getnbscale,resetnblist
 public :: fullsearch,prepare_neighbor_search,getnbscale,resetnblist

 integer,parameter :: MAX_NBLIST_LENGTH=10000
 integer,parameter :: ndim=3

 type nblist_type
  integer :: nnb
  integer :: maxnnb
  integer(i8b) :: searchcell
  logical :: reuseable
  integer :: searchimage
  integer :: nsearchimages
  real :: searchrange
  real :: searchpos(ndim)
  real :: DfltMass
  real :: DfltTemp
  type(transformation_type) :: searchtrafos(3**ndim)
  type(sphpar_type), allocatable :: sphpar(:)
  type(oct_tree_type) :: stree 
 end type nblist_type
 
 contains

 subroutine prepare_neighbor_search(psys,nblist,DfltMass,DfltTemp)
 use oct_tree_mod, only: buildtree
 use oct_tree_mod, only: setparticleorder
 type(particle_system_type) psys
 type(nblist_type) nblist
 real, intent(in) :: DfltMass
 real, intent(in) :: DfltTemp
 real :: MB
  call makenblist(nblist,MAX_NBLIST_LENGTH)
  call buildtree(psys,nblist%stree,MB)
  call setparticleorder(psys,nblist%stree)  
  call setsearchimages(psys,nblist)
  nblist%DfltMass = DfltMass
  nblist%DfltTemp = DfltTemp
 end subroutine prepare_neighbor_search

 subroutine fullsearch(psys,nblist)
 type(particle_system_type) :: psys
 type(nblist_type) nblist
 if(nblist%searchimage.EQ.0) call nbError('nblist uninit.')
  do while(nblist%searchimage.LE.nblist%nsearchimages)
   call dosearchtree(psys,nblist)
   if(nblist%searchcell.NE.0) return 
   nblist%searchimage=nblist%searchimage+1
   nblist%searchcell=1
  enddo 
  nblist%searchcell=0
 end subroutine fullsearch

 subroutine dosearchtree(psys,nblist)
 use oct_tree_mod, only: dist2cell

 type(particle_system_type) :: psys
 type(nblist_type) :: nblist
 integer :: i, si
 integer(i8b) :: ip, this, next, daughter
 real :: dist2
 real :: dx(ndim), searchpos(ndim)

! integer :: k

  si = nblist%searchimage
  searchpos = nblist%searchpos * nblist%searchtrafos(si)%fac + & 
              nblist%searchtrafos(si)%shift
  next=nblist%searchcell
  do while(next.ne.0)
  this=next
  daughter=nblist%stree%cell(this)%daughter
  next=nblist%stree%cell(this)%next
  if(daughter.EQ.0) then
   if(nblist%nnb+nblist%stree%cell(next)%start- &
      nblist%stree%cell(this)%start .GT. nblist%maxnnb) then 
    nblist%reuseable=.FALSE.
    nblist%searchcell=this
    return
   endif
   do i=nblist%stree%cell(this)%start,nblist%stree%cell(next)%start-1
    ip=nblist%stree%partorder(i)
    dx=searchpos-psys%par(ip)%pos
    dist2=sum(dx**2)
    if(dist2.LE.nblist%searchrange**2) then
      nblist%nnb=nblist%nnb+1
      call par2sphpar(nblist%sphpar(nblist%nnb), &
               psys%par(ip), nblist%DfltMass, nblist%DfltTemp, nblist%searchtrafos(si))
    endif
   enddo
  else
   dist2=dist2cell(searchpos,nblist%stree%cell(this))
   if(dist2.LE.nblist%searchrange**2) next=daughter  
  endif
  enddo
  nblist%searchcell=next
 end subroutine dosearchtree

 function getnbscale(pos,nblist)
 use oct_tree_mod, only: getlocalscale
 real :: getnbscale
 type(nblist_type) :: nblist
 real :: pos(ndim)
  getnbscale=getlocalscale(pos,nblist%stree)
 end function getnbscale

 subroutine makenblist(nblist,maxnnb)
 type(nblist_type) :: nblist
 integer :: maxnnb
  nblist%nnb=0
  nblist%maxnnb=maxnnb
  nblist%searchpos=0
  nblist%searchrange=0
  nblist%searchcell=1
  nblist%reuseable=.FALSE.
  nblist%searchimage=1
  nblist%searchtrafos(1)%fac=1
  nblist%searchtrafos(1)%shift=0  
  allocate(nblist%sphpar(maxnnb))
 end subroutine makenblist

 subroutine resetnblist(nblist,range,pos)
   type(nblist_type) :: nblist
   real, optional :: range,pos(ndim)

!   integer ::maxnnb

     nblist%nnb=0
     nblist%searchcell=1
     nblist%searchimage=1
     nblist%reuseable=.FALSE.
     if(present(pos)) then
        nblist%searchpos=pos
     else 
     endif
     if(present(range)) then
        nblist%searchrange=range
     else 
     endif
 end subroutine resetnblist

 subroutine killnblist(nblist,maxnnb)
 type(nblist_type) :: nblist
 integer :: maxnnb
  nblist%nnb=0
  nblist%maxnnb=maxnnb
  nblist%searchpos=0
  nblist%searchrange=0
  nblist%searchcell=0
  deallocate(nblist%sphpar)
 end subroutine killnblist

 subroutine setsearchimages(psys,nblist)
 type(nblist_type) nblist
 type(particle_system_type) psys
 integer i,j,k(ndim)
 real top(ndim),bot(ndim)
 integer bbound(ndim),tbound(ndim),l,nsearchimages
 real lx(ndim),hx(ndim)
 logical boxexists

  top=psys%box%top
  bot=psys%box%bot
  bbound=psys%box%bbound
  tbound=psys%box%tbound
 
  nsearchimages=0

  do i=0,3**ndim-1
  l=i
  do j=1,ndim
   k(j)=mod(l,3)-1 
   l=l/3
  enddo 
  boxexists=.TRUE.
  do j=1,ndim
   lx(j)=bot(j)+k(j)*(top(j)-bot(j))
   hx(j)=top(j)+k(j)*(top(j)-bot(j))
   if(k(j).eq.-1.AND.bbound(j).EQ.0) boxexists=.FALSE.  
   if(k(j).eq.1.AND.tbound(j).EQ.0) boxexists=.FALSE.  
  enddo
  if(boxexists) then
   nsearchimages=nsearchimages+1
   do j=1,ndim    
    nblist%searchtrafos(nsearchimages)%fac(j)=1
    nblist%searchtrafos(nsearchimages)%shift(j)=0.
    if(k(j).eq.-1) then
    nblist%searchtrafos(nsearchimages)%fac(j)=bbound(j)
    nblist%searchtrafos(nsearchimages)%shift(j)=(-3*nblist%searchtrafos(nsearchimages)%fac(j)+1)*bot(j)/2+&
      (1+nblist%searchtrafos(nsearchimages)%fac(j))*top(j)/2
    endif  
    if(k(j).eq.1) then
    nblist%searchtrafos(nsearchimages)%fac(j)=tbound(j)
    nblist%searchtrafos(nsearchimages)%shift(j)=(-3*nblist%searchtrafos(nsearchimages)%fac(j)+1)*top(j)/2+&
      (1+nblist%searchtrafos(nsearchimages)%fac(j))*bot(j)/2
    endif  
   enddo
  endif
  enddo
  nblist%nsearchimages=nsearchimages
 end subroutine setsearchimages

 subroutine nbError(string,i)
  character*(*) :: string
  integer, optional :: i
  
  print*,'error detected'

  if(present(i)) then
   print*,string,i
  else
   print*,string
  endif
  stop
 end subroutine nbError

end module nblist_mod

!   dist2=0
!   do k=1,ndim
!    if(nblist%searchpos(k).LT.tree%cell(this)%bot(k)) then
!      dist2=dist2+(nblist%searchpos(k)-tree%cell(this)%bot(k))**2
!    else
!      if(nblist%searchpos(k).GT.tree%cell(this)%top(k)) then
!       dist2=dist2+(tree%cell(this)%top(k)-nblist%searchpos(k))**2
!      endif
!    endif
!   enddo

!> \file mainloop.F90

!> \brief the main program loop
!! 
!! Loops through the snapshots calling the raytracing and output routines 
!<

module mainloop_mod
  use myf03_mod

  ! routines
  use gadget_general_class, only: gadget_constants_type
  use main_input_mod, only: readin_snapshot
  use oct_tree_mod, only: buildtree, setparticleorder
  use ray_mod
  use raylist_mod
  use ion_temperature_update, only: update_raylist
  use mt19937_mod, only: genrand_real1
  use output_mod, only: output_total_snap, ion_frac_out
  use global_mod, only: set_dt_from_dtcode, set_time_elapsed_from_itime
  
  ! variables
  use global_mod, only: psys
  use global_mod, only: globalraylist
  use global_mod, only: tree
  use global_mod, only: GV
  use global_mod, only: PLAN


  
  implicit none
  
  integer(i8b), parameter :: one = 1

  integer(i4b), parameter :: rays_per_leaf = 2
  integer(i4b), parameter :: rays_per_dt = 1
  
contains
  
  !> this is the main driver of SPHRAY
  !======================================
  subroutine mainloop()
    implicit none
    
    character(clen), parameter :: myname="mainloop"
    logical, parameter :: crash=.true.
    integer, parameter :: verb=1
    character(clen) :: str,fmt

    type(gadget_constants_type) :: gconst

    !  local counters 
    !-----------------
    
    integer(i8b) :: snapn !< snapshot counter
    integer(i8b) :: rayn  !< ray counter
    integer(i8b) :: srcn  !< source counter
    
    real(r8b) :: rn       !< random number
    real(r8b) :: MB       !< MBs for memory consumption tracking
    
    ! work variables
    !-----------------
    logical :: srcray
    type(src_ray_type) :: ray
    real(r8b) :: outmark
    
#ifdef incHrec
    integer(i8b) :: rindx
    integer(i8b) :: pindx
    integer(i8b) :: lasthitcheck
#endif
    
    
    ! loop over the snapshots 
    !=========================
    snaps: do snapn = GV%StartSnapNum, GV%EndSnapNum

       !  read in particle and source snapshot
       !----------------------------------------------------------------      
       call readin_snapshot()
              
       !  build oct tree.  only need to do this once per snap (for now)
       !----------------------------------------------------------------
       call buildtree(psys,tree,MB,GV%PartPerCell)
       GV%MB = GV%MB + MB
       call setparticleorder(psys, tree)             
       call prepare_raysearch(psys, globalraylist)
       
             
       if(GV%JustInit) then
          write(str,"(A,F10.2)") "total memory allocated [MB] = ", GV%MB
          call mywrite(str,verb)
          call mywrite("just initializing", verb)
          call mywrite("",verb)
          stop
       end if

       
       if (GV%DoInitialOutput) then
          GV%OutputIndx = 0
          call output_total_snap(psys)      
          GV%OutputIndx = 1
       end if
       

       ! begin ray tracing 
       !------------------------- 
       src_rays: do rayn = one, PLAN%snap(snapn)%SrcRays
          
          GV%rayn                = GV%rayn + 1
          GV%src_rayn            = GV%src_rayn + 1
          GV%TotalSourceRaysCast = GV%TotalSourceRaysCast + 1                
          
          !  select a source randomly (weighted by their luminosity)
          rn = genrand_real1() * psys%src(size(psys%src))%Lcdf
          srcn=1
          do while(psys%src(srcn)%Lcdf.LT.rn)
             srcn=srcn+1
             if(srcn.GT.size(psys%src)) then
                write(*,*) srcn, rn, psys%src(size(psys%src))%Lcdf, size(psys%src)
                stop "src num > number of sources in mainloop.f90"
             endif
          enddo
                    
          !  create a source ray and calc the impacts
          call src_ray_make( ray, psys%src(srcn), GV%rayn, GV%dt_s, GV%Lunit, psys%box )
          
          GV%itime = GV%itime + 1
          call set_time_elapsed_from_itime( GV )
          GV%IonizingPhotonsPerSec = GV%TotalPhotonsCast / GV%time_elapsed_s

          globalraylist%ray = ray
          call trace_ray(globalraylist%ray, globalraylist, psys, tree) 
          
          GV%TotalPhotonsCast = GV%TotalPhotonsCast + globalraylist%ray%pini
          
          srcray = .true.
          call update_raylist(globalraylist,psys%par,psys%box,srcray)
                    
          
                              
          
          !        output routines
          !------------------------
          
          !        check if this time step requires a small ionization frac output
          !        these are small outputs done often to monitor certain quantites
          if( mod(GV%rayn,GV%IonFracOutRays)==0 ) then
             call ion_frac_out(psys, tree )
          end if
          
          
          ! check if this time step requires a full output
          if ( GV%OutputIndx <= GV%NumTotOuts ) then
             
             ! set correct time marker unit
             if ( trim(GV%OutputTiming) == "standard" ) then
                
                outmark = GV%start_time_code + GV%time_elapsed_code
                
             else if ( trim(GV%OutputTiming) == "forced" ) then
                
                if (trim(GV%ForcedUnits) == "mwionfrac") then
                   outmark = GV%mwionfrac
                else 
                   outmark = GV%time_elapsed_code
                end if
                
             else
                
                write(*,*) "output type ", trim(GV%OutputTiming), "not recognized"
                stop 
                
             end if


             
             ! check outmark against tabulated output "times"
             if ( outmark >= PLAN%OutputTimes(GV%OutputIndx) ) then
                call output_total_snap(psys)
                GV%OutputIndx = GV%OutputIndx + 1 
             end if
             
          end if
          
          
          ! if we are on the last ray and we havent gotten to the last 
          ! output, do a full output.
          if ( snapn == GV%EndSnapNum ) then
             if ( GV%OutputIndx <= GV%NumTotOuts ) then
                if ( GV%src_rayn==PLAN%snap(snapn)%SrcRays ) then
                   write(*,*) "doing an output on the last ray"
                   call output_total_snap(psys)
                end if
             end if
          end if
          
          
          
          
       end do src_rays


       
       ! free up the memory from the globalraylist.
       call kill_raylist(globalraylist)
       
    end do snaps
    
    close(GV%ionlun)
    
    
    if (GV%raystats) then
       close(GV%raystatlun)
    end if
    
    
  end subroutine mainloop
  
end module mainloop_mod

!> \file hdf5_io.f90

!> \brief Wrappers for HDF5 I/O 
!!
!! 
!< 

module hdf5_io_mod
use myf03_mod
use hdf5
implicit none
private


public :: rw_attr


interface rw_attr
   module procedure rw_attr_int,  rw_attr_int_arr, &
                    rw_attr_real, rw_attr_real_arr
end interface


integer, parameter :: hdf5_id_t = HID_T
integer, parameter :: hdf5_size_t = HSIZE_T

contains



! read/write a scalar, integer, group attribute
!------------------------------------------------------------------
subroutine rw_attr_int(grp_id, attr_name, attr_mem_type, buf, rorw)

  integer(HID_T) :: grp_id
  character(*) :: attr_name
  integer(HID_T) :: attr_mem_type
  integer(i4b) :: buf
  character(1) :: rorw
 
  integer(HSIZE_T), dimension(1), parameter :: dims = [1]
  integer(i4b) :: ierr
  integer(HID_T) :: attr_id
  integer(HID_T) :: space_id
  
  if (rorw == 'r') then 
     call h5aopen_f(grp_id, attr_name, attr_id, ierr)
     call h5aread_f(attr_id, attr_mem_type, buf, dims, ierr)
     call h5aclose_f(attr_id, ierr)
  else if (rorw == 'w') then
     call h5screate_f(H5S_SCALAR_F, space_id, ierr) 
     call h5acreate_f(grp_id, attr_name, attr_mem_type, space_id, attr_id, ierr)
     call h5awrite_f(attr_id, attr_mem_type, buf, dims, ierr)
     call h5sclose_f(space_id, ierr)
     call h5aclose_f(attr_id, ierr)
  else
     write(*,*) 
     write(*,*) ' ** Error ** '
     write(*,*) 'Routine: rw_attr_int'
     write(*,*) 'rorw variable not "r" or "w" '
     write(*,*) 
     stop     
  endif

end subroutine rw_attr_int


! read/write a vector, integer, group attribute
!------------------------------------------------------------------
subroutine rw_attr_int_arr(grp_id, attr_name, attr_mem_type, buf, rorw)

  integer(HID_T) :: grp_id
  character(*) :: attr_name
  integer(HID_T) :: attr_mem_type
  integer(i4b) :: buf(0:5)
  character(1) :: rorw

  integer(HSIZE_T), dimension(1), parameter :: dims = [6]
  integer(i4b), parameter :: rank = 1
  integer(i4b) :: ierr
  integer(HID_T) :: attr_id
  integer(HID_T) :: space_id
  
  if (rorw == 'r') then 
     call h5aopen_f(grp_id, attr_name, attr_id, ierr)
     call h5aread_f(attr_id, attr_mem_type, buf, dims, ierr)
     call h5aclose_f(attr_id, ierr)
  else if (rorw == 'w') then
     call h5screate_simple_f(rank, dims, space_id, ierr)
     call h5acreate_f(grp_id, attr_name, attr_mem_type, space_id, attr_id, ierr)
     call h5awrite_f(attr_id, attr_mem_type, buf, dims, ierr)
     call h5sclose_f(space_id, ierr)
     call h5aclose_f(attr_id, ierr)
  else
     write(*,*) 
     write(*,*) ' ** Error ** '
     write(*,*) 'Routine: rw_attr_int_arr'
     write(*,*) 'rorw variable not "r" or "w" '
     write(*,*) 
     stop     
  endif

end subroutine rw_attr_int_arr



! read/write a scalar, real, group attribute
!------------------------------------------------------------------
subroutine rw_attr_real(grp_id, attr_name, attr_mem_type, buf, rorw)

  integer(HID_T) :: grp_id
  character(*) :: attr_name
  integer(HID_T) :: attr_mem_type
  real(r8b) :: buf
  character(1) :: rorw
 
  integer(HSIZE_T), dimension(1), parameter :: dims = [1]
  integer(i4b) :: ierr
  integer(HID_T) :: attr_id
  integer(HID_T) :: space_id
  
  if (rorw == 'r') then 
     call h5aopen_f(grp_id, attr_name, attr_id, ierr)
     call h5aread_f(attr_id, attr_mem_type, buf, dims, ierr)
     call h5aclose_f(attr_id, ierr)
  else if (rorw == 'w') then
     call h5screate_f(H5S_SCALAR_F, space_id, ierr) 
     call h5acreate_f(grp_id, attr_name, attr_mem_type, space_id, attr_id, ierr)
     call h5awrite_f(attr_id, attr_mem_type, buf, dims, ierr)
     call h5sclose_f(space_id, ierr)
     call h5aclose_f(attr_id, ierr)
  else
     write(*,*) 
     write(*,*) ' ** Error ** '
     write(*,*) 'Routine: rw_attr_real'
     write(*,*) 'rorw variable not "r" or "w" '
     write(*,*) 
     stop     
  endif

end subroutine rw_attr_real


! read/write a vector, real, group attribute
!------------------------------------------------------------------
subroutine rw_attr_real_arr(grp_id, attr_name, attr_mem_type, buf, rorw)

  integer(HID_T) :: grp_id
  character(*) :: attr_name
  integer(HID_T) :: attr_mem_type
  real(r8b) :: buf(0:5)
  character(1) :: rorw

  integer(HSIZE_T), dimension(1), parameter :: dims = [6]
  integer(i4b), parameter :: rank = 1
  integer(i4b) :: ierr
  integer(HID_T) :: attr_id
  integer(HID_T) :: space_id
  
  if (rorw == 'r') then 
     call h5aopen_f(grp_id, attr_name, attr_id, ierr)
     call h5aread_f(attr_id, attr_mem_type, buf, dims, ierr)
     call h5aclose_f(attr_id, ierr)
  else if (rorw == 'w') then
     call h5screate_simple_f(rank, dims, space_id, ierr)
     call h5acreate_f(grp_id, attr_name, attr_mem_type, space_id, attr_id, ierr)
     call h5awrite_f(attr_id, attr_mem_type, buf, dims, ierr)
     call h5sclose_f(space_id, ierr)
     call h5aclose_f(attr_id, ierr)
  else
     write(*,*) 
     write(*,*) ' ** Error ** '
     write(*,*) 'Routine: rw_attr_real_arr'
     write(*,*) 'rorw variable not "r" or "w" '
     write(*,*) 
     stop     
  endif

end subroutine rw_attr_real_arr


end module hdf5_io_mod

!> \file ionpar.F90

!> \brief the module that handles ionization particles
!<

module ionpar_mod
use myf03_mod
use gadget_general_class
use physical_constants_mod, only: HI_th_Hz, HI_th_erg, HeI_th_erg, HeII_th_erg
use atomic_rates_mod, only: atomic_rates_type
use particle_system_mod, only: particle_type
use ray_mod
use raylist_mod
use b2cd_mod, only: b2cdfac
use cen_atomic_rates_mod, only: Verner_HI_photo_cs
use cen_atomic_rates_mod, only: Osterbrok_HeI_photo_cs
use cen_atomic_rates_mod, only: Osterbrok_HeII_photo_cs
use cen_atomic_rates_mod, only: Haiman_Bremss_cool_H, Haiman_Bremss_cool_He
use cen_atomic_rates_mod, only: Haiman_Comp_Heol
use global_mod, only: GV
use hui_gnedin_atomic_rates_mod
implicit none


!> ionization particle type. 
!---------------------------
type ionpart_type

   ! quantities taken from standard particle
   !---------------------------------------------------------------------
   real(r8b) :: pos(3)       !< x,y,z coordinates
   real(r8b) :: vel(3)       !< x,y,z velocities
   integer(i8b) :: id        !< particle id
   real(r8b) :: mass         !< particle mass
   real(r8b) :: T            !< temperature in K       
   real(r8b) :: rho          !< density
   real(r8b) :: hsml         !< smoothing length

   real(r8b) :: H_mf         !< Hydrogen mass fraction
   real(r8b) :: He_mf        !< Helium mass fraction

   real(r8b) :: xHI          !< nHI  / nH
   real(r8b) :: xHII         !< nHII / nH
   real(r8b) :: xHeI         !< nHeI   / nHe 
   real(r8b) :: xHeII        !< nHeII  / nHe 
   real(r8b) :: xHeIII       !< nHeIII / nHe

   integer(i8b) :: lasthit   !< last ray to cross this particle
   integer(i8b) :: index     !< index of the particle in the psys


   ! quantities initialized before solver is called 
   !---------------------------------------------------------------------
   real(r8b) :: xHI_in       !< initial xHI
   real(r8b) :: xHII_in      !< initial xHII
   real(r8b) :: xHeI_in      !< initial xHeI
   real(r8b) :: xHeII_in     !< initial xHeII
   real(r8b) :: xHeIII_in    !< initial xHeIII
   real(r8b) :: T_in         !< initial T

   integer(i8b) :: iter      !< number of the iteration in the solver
   integer(i8b) :: rayn      !< ray number that impacted

   real(r8b) :: NeBckgnd     !< number density of metallic electrons
   real(r8b) :: Tcmb         !< background radiation field temperature
   real(r8b) :: dinternalEdt !< constant external heating rate (per unit mass - units cgs_vel**2)

   real(r8b) :: gpercm3      !< density in cgs
   real(r8b) :: cm3          !< volume in cgs

   real(r8b) :: nH           !< number density of H
   real(r8b) :: nHe          !< number density of He
   real(r8b) :: Hcnt         !< number of H nuclei
   real(r8b) :: Hecnt        !< number of He nuclei

   real(r8b) :: dl           !< path length for particle


   ! ray/photo quantities initialied before solver is called
   !---------------------------------------------------------------------
   integer(i8b) :: impact    !< index of the particle in the raylist
   real(r8b) :: d            !< distance along ray (code)
   real(r8b) :: b            !< impact parameter (code)
   real(r8b) :: bnorm        !< impact parameter normalized to smoothing length
   real(r8b) :: cdfac        !< column depth conversion factor

   real(r8b) :: dt_code      !< time step for this par (code)
   real(r8b) :: dt_s         !< time step for this par (s)

   real(r8b) :: penrg        !< energy of one photon in the ray (ergs)
   real(r8b) :: pflux        !< photons per second arriving at the particle
   real(r8b) :: pdeps        !< total photons deposited into particle
   real(r8b) :: pmntm(3)     !< total momentum deposited by photons
   real(r8b) :: pvel(3)      !< velocity due to photon momentum transfer
   real(r8b) :: pdeps_eq     !< photons deposited in equilibrium conditions

   real(r8b) :: DH(2,2)      !< dxH/dt array
   real(r8b) :: DHe(3,3)     !< dxHe/dt array

   real(r8b) :: sigmaHI      !< HI photo cross-section
   real(r8b) :: sigmaHeI     !< HeI photo cross-section
   real(r8b) :: sigmaHeII    !< HeII photo cross-section

   real(r8b) :: fracabsorb   !< fraction of all photons absorbed
   real(r8b) :: pdepr        !< photons per second deposited in particle

   real(r8b) :: ne           !< number density of electrons
   real(r8b) :: dnedt        !< time rate of change of ne

   real(r8b) :: nHI          !< number density of HI
   real(r8b) :: nHII         !< number density of HII
   real(r8b) :: nHeI         !< number density of HeI
   real(r8b) :: nHeII        !< number density of HeII
   real(r8b) :: nHeIII       !< number density of HeIII

   real(r8b) :: HIcnt        !< number of HI atoms
   real(r8b) :: HIIcnt       !< number of HII atoms
   real(r8b) :: HeIcnt       !< number of HeI atoms
   real(r8b) :: HeIIcnt      !< number of HeII atoms
   real(r8b) :: HeIIIcnt     !< number of HeIII atoms
   real(r8b) :: Allcnt       !< number of all photo absorbing species (HI,HeI,HeII)

   real(r8b) :: tauHI        !< HI optical depth
   real(r8b) :: tauHeI       !< HeI optical depth
   real(r8b) :: tauHeII      !< HeII optical depth
   real(r8b) :: tausum       !< sum of all optical depths

   real(r8b) :: HItaufac     !< 1-exp(-tauHI)
   real(r8b) :: HeItaufac    !< 1-exp(-tauHeI)
   real(r8b) :: HeIItaufac   !< 1-exp(-tauHeII)
   real(r8b) :: taufacsum    !< sum of all tau factors

   real(r8b) :: HIfrac       !< fraction of photons absorbed by HI
   real(r8b) :: HeIfrac      !< fraction of photons absorbed by HeI
   real(r8b) :: HeIIfrac     !< fraction of photons absorbed by HeII

   real(r8b) :: gammaHI      !< HI   photoionization rate
   real(r8b) :: gammaHeI     !< HeI  photoionization rate
   real(r8b) :: gammaHeII    !< HeII photoionization rate
   real(r8b) :: gammasum     !< sum of all photoionization rates

   real(r8b) :: GG           !< HIci * ne
   real(r8b) :: GGp          !< HI photoionization rate + HIci * ne
   real(r8b) :: RRa          !< HII recombination rate case A * ne
   real(r8b) :: RRb          !< HII recombination rate case B * ne

   real(r8b) :: GGI          !< HeIci * ne
   real(r8b) :: GGII         !< HeIIci * ne
   real(r8b) :: GGIp         !< HeI photoionization rate + HeIci * ne
   real(r8b) :: GGIIp        !< HeII photoionization rate + HeIIci * ne
   real(r8b) :: RRIIa        !< HeII recombination rate case A * ne
   real(r8b) :: RRIIIa       !< HeIII recombination rate case A * ne
   real(r8b) :: RRIIb        !< HeII recombination rate case B * ne
   real(r8b) :: RRIIIb       !< HeIII recombination rate case B * ne

   real(r8b) :: CIC          !< collisional ionization cooling rate
   real(r8b) :: CEC          !< collisional excitation cooling rate
   real(r8b) :: RCC          !< recombination cooling rate
   real(r8b) :: PH           !< photo heating rate
   real(r8b) :: BREM         !< bremsstrahlung cooling rate
   real(r8b) :: COMP         !< compton heating/cooling rate
   real(r8b) :: COOL         !< total cooling function w/o photo heating
   real(r8b) :: COOLp        !< total cooling function w photo heating

   real(r8b) :: tion         !< ionization time (s)
   real(r8b) :: tcool        !< cooling time (s)
   real(r8b) :: u            !< energy per unit mass of particle (ergs)
   real(r8b) :: dudt         !< time rate of change of energy
   real(r8b) :: dTdt         !< time rate of change of temperature
   
   character(200) :: strtag  !< labels code landmarks for debugging 

end type ionpart_type

 
!> particle type for solving the analytic ionization equations
!---------------------------------------------------------------
type bckgnd_particle_type
   real(r8b) :: H_mf
   real(r8b) :: T
   real(r8b) :: rho_cgs
   real(r8b) :: nH
   real(r8b) :: RC
   real(r8b) :: CI
   real(r8b) :: gammaHI
   real(r8b) :: y
   real(r8b) :: R
   real(r8b) :: Q
   real(r8b) :: P
   real(r8b) :: d
   real(r8b) :: xHI
   real(r8b) :: xHII
end type bckgnd_particle_type


!> particle type for calculating optical depth
!---------------------------------------------------------------
type tau_particle_type
   real(r8b) :: H_mf
   real(r8b) :: xHI
   real(r8b) :: xHII
   real(r8b) :: hsml
   real(r8b) :: mass_cgs
   real(r8b) :: Hcnt
   real(r8b) :: HIcnt
   real(r8b) :: d
   real(r8b) :: b
   real(r8b) :: bnorm
   real(r8b) :: cdfac
   real(r8b) :: tauHI_th
end type tau_particle_type




real(r8b), parameter, private :: zero = 0.0d0
real(r8b), parameter, private :: one = 1.0d0
real(r8b), parameter, private :: two = 2.0d0
real(r8b), parameter, private :: four = 4.0d0


contains


!> initializes a particle used just for calculating the optical depth
!-----------------------------------------------------------------------
function initialize_tau_particle( par, intersection ) result( tpar )
  type(particle_type), intent(in) :: par
  type(intersection_type), intent(in) :: intersection
  type(tau_particle_type) :: tpar
  
  type(gadget_constants_type) :: gconst
  logical, save :: first = .true.
  real(r8b), save :: sigmaHI_th

  if (first) then
     sigmaHI_th = Verner_HI_photo_cs(one)    
  endif

#ifdef incHmf
  tpar%H_mf   = par%Hmf
#else
  tpar%H_mf   = GV%H_mf
#endif

  tpar%xHI  = par%xHI
  tpar%xHII = par%xHII
  tpar%hsml = par%hsml

  tpar%mass_cgs = par%mass * GV%cgs_mass
  tpar%Hcnt     = tpar%mass_cgs * tpar%H_mf / gconst%PROTONMASS
  tpar%HIcnt    = tpar%Hcnt * tpar%xHI       

  tpar%d = intersection%d   ! distance along ray
  tpar%b = intersection%b   ! impact parameter
      
  tpar%bnorm = tpar%b / tpar%hsml
  tpar%cdfac = b2cdfac(tpar%bnorm, tpar%hsml, GV%cgs_len)

  if (tpar%xHI > zero) then
     tpar%tauHI_th = tpar%cdfac * tpar%HIcnt * sigmaHI_th
  else
     tpar%tauHI_th = zero
  end if
  
  first = .false.
  
end function initialize_tau_particle



!> initializes a particle used just for calculating the xH's
!-----------------------------------------------------------------------
function initialize_bckgnd_particle( par, gammaHI ) result( bpar )
  type(particle_type), intent(in) :: par
  real(r8b), intent(in) :: gammaHI
  type(bckgnd_particle_type) :: bpar
  type(gadget_constants_type) :: gconst

#ifdef incHmf
  bpar%H_mf   = par%Hmf
#else
  bpar%H_mf   = GV%H_mf
#endif

  bpar%gammaHI = gammaHI


  bpar%rho_cgs = par%rho * GV%cgs_rho
  bpar%nH      = bpar%rho_cgs * bpar%H_mf / gconst%PROTONMASS

  bpar%T = par%T
  bpar%RC   = Hui_HII_recombA( bpar%T )
  bpar%CI   = Hui_HI_col_ion( bpar%T )
  bpar%xHI  = par%xHI
  bpar%xHII = par%xHII
  
end function initialize_bckgnd_particle


!> implements analytic solution for xH's in background particles
!-----------------------------------------------------------------------
function set_bckgnd_particle_xH_eq( bpar ) result(err)
  type(bckgnd_particle_type) :: bpar
  integer(i4b) :: err

  bpar%y = 0.0d0

  bpar%R = -( bpar%CI + bpar%RC ) * bpar%nH
  bpar%Q = bpar%CI * bpar%nH - bpar%gammaHI - (bpar%CI + bpar%RC) * bpar%nH * bpar%y
  bpar%P = bpar%gammaHI + bpar%CI * bpar%nH * bpar%y

  bpar%d = bpar%Q * bpar%Q - four * bpar%R * bpar%P

  bpar%xHII = ( -bpar%Q - sqrt(bpar%D) ) / (two * bpar%R)
  bpar%xHI  = one - bpar%xHII

  if (bpar%xHII > one .or. bpar%xHII < zero) then
     err = -1
  else
     err = 0
  endif

end function set_bckgnd_particle_xH_eq



!> implements analytic solution for xH's in ion particles
!-----------------------------------------------------------------------
subroutine set_ionpar_xH_eq( ipar )
  type(ionpart_type), intent(inout) :: ipar  !< output ionization particle

  real(r8b) :: R, Q, P, D
  real(r8b) :: CI, RC
  real(r8b) :: y

  ipar%strtag = "in set_ionpar_xH_eq_enter"
  call check_x(ipar)

  y = 0.0d0
  CI = Hui_HI_col_ion( ipar%T )
  RC = Hui_HII_recombA( ipar%T )
  
  R = -( CI + RC ) * ipar%nH
  Q = CI * ipar%nH - ipar%gammaHI - (CI + RC) * ipar%nH * y
  P = ipar%gammaHI + CI * ipar%nH * y

  D = Q*Q - 4.0d0 * R * P

  ipar%xHII = ( - Q - sqrt(D)) / (2.0d0 * R)
  if (ipar%xHII > 1.0d0 .or. ipar%xHII < 0.0d0) then
     write(*,*) 'shit'
     stop
  endif

  ipar%xHI = 1.0d0 - ipar%xHII

  ipar%strtag = "in set_ionpar_xH_eq_exit"
  call check_x(ipar)

end subroutine set_ionpar_xH_eq




!> copies the basic particle data into an ionization particle
!-----------------------------------------------------------------------
subroutine par2ionpar(par,ipar,index)
 type(particle_type), intent(in) :: par     !< input particle
 type(ionpart_type), intent(inout) :: ipar  !< output ionization particle
 integer(i8b) :: index                      !< par = psys%par(index)

 ipar%pos     = par%pos

#ifdef incVel
 ipar%vel     = par%vel
#else
 ipar%vel     = 0.0
#endif

 ipar%id      = par%id
 ipar%mass    = par%mass
 ipar%T       = par%T
 ipar%rho     = par%rho

 ipar%xHI     = par%xHI
 ipar%xHII    = par%xHII

 ipar%hsml    = par%hsml

#ifdef incHmf
  ipar%H_mf   = par%Hmf
#else
  ipar%H_mf   = GV%H_mf
#endif

#ifdef incHemf
  ipar%He_mf  = par%Hemf
#else
  ipar%He_mf  = GV%He_mf
#endif

#ifdef incHe
 ipar%xHeI    = par%xHeI
 ipar%xHeII   = par%xHeII
 ipar%xHeIII  = par%xHeIII
#else
 ipar%xHeI    = 0.0d0
 ipar%xHeII   = 0.0d0
 ipar%xHeIII  = 0.0d0
#endif

#ifdef incHeat
 ipar%dinternalEdt = par%dinternalEdt
#else
 ipar%dinternalEdt =0.0d0
#endif

 ipar%lasthit = par%lasthit
 ipar%index   = index

end subroutine par2ionpar


!> copies the ionization particle data into a basic particle 
!-----------------------------------------------------------------------
subroutine ionpar2par(ipar,par)
 type(ionpart_type), intent(in) :: ipar    !< input ionization particle
 type(particle_type), intent(inout) :: par !< output particle

 par%T       = ipar%T

 par%xHI     = ipar%xHI
 par%xHII    = ipar%xHII

#ifdef incHe
 par%xHeI    = ipar%xHeI
 par%xHeII   = ipar%xHeII
 par%xHeIII  = ipar%xHeIII
#endif

 par%lasthit = ipar%lasthit

#ifdef incVel
 par%vel     = ipar%vel
#endif

#ifdef incHeat
 par%dinternalEdt = ipar%dinternalEdt
#endif

end subroutine ionpar2par


!> initializes the ionization particle values
!-----------------------------------------------------------------------
subroutine initialize_ionpar(ipar,par,index,srcray,He,raylist,impact)

  type(ionpart_type), intent(inout) :: ipar           !< ionization particle
  type(particle_type), intent(in) :: par              !< standard particle
  integer(i8b) :: index                               !< par = psys%par(index)
  logical, intent(in) :: srcray                       !< source ray update ?
  logical, intent(in) :: He                           !< update Helium ?
  type(raylist_type), intent(in), optional :: raylist !< optional raylist
  integer(i8b), intent(in), optional :: impact        !< optional impact number

  type(gadget_constants_type) :: gconst  
  real(r8b) :: mass_cgs
  real(r8b) :: rho_cgs


  call par2ionpar(par,ipar,index)

  ! store initial values
  !-------------------------
  ipar%xHI_in  = ipar%xHI
  ipar%xHII_in = ipar%xHII
  if (He) then
     ipar%xHeI_in   = ipar%xHeI
     ipar%xHeII_in  = ipar%xHeII
     ipar%xHeIII_in = ipar%xHeIII
  else
     ipar%xHeI_in   = 0.0d0
     ipar%xHeII_in  = 0.0d0
     ipar%xHeIII_in = 0.0d0
  end if
  ipar%T_in = ipar%T

  ! set values that are static during the update
  !-----------------------------------------------
  ipar%rayn     = GV%rayn

  ipar%NeBckgnd = GV%NeBackground
  ipar%Tcmb     = GV%Tcmb_cur

  mass_cgs      = ipar%mass * GV%cgs_mass 
  rho_cgs       = ipar%rho *  GV%cgs_rho 

  ipar%gpercm3  = rho_cgs
  ipar%cm3      = mass_cgs / rho_cgs

  ipar%nH       = rho_cgs  * ipar%H_mf / gconst%PROTONMASS
  ipar%Hcnt     = mass_cgs * ipar%H_mf / gconst%PROTONMASS

  if (He) then
     ipar%nHe   = rho_cgs  * ipar%He_mf / (4 * gconst%PROTONMASS)
     ipar%Hecnt = mass_cgs * ipar%He_mf / (4 * gconst%PROTONMASS)
  else
     ipar%nHe   = 0.0d0
     ipar%Hecnt = 0.0d0
  end if

  ! initialize solver iteration counter to zero
  !---------------------------------------------
  ipar%iter = 0


  ! set ray specific quantities 
  !---------------------------------------------
  if (present(raylist)) then

     if (.not. present(impact)) then
        stop "raylist but no impact in initialize_ionpar"
     endif

     ipar%impact = impact  ! which impact in the raylist

     ipar%d = raylist%intersection(impact)%d   ! distance along ray
     ipar%b = raylist%intersection(impact)%b   ! impact parameter
      
     ipar%bnorm = ipar%b / ipar%hsml
     ipar%cdfac = b2cdfac(ipar%bnorm,ipar%hsml,GV%cgs_len)

     ipar%dt_code = (GV%itime - ipar%lasthit) * GV%dt_code
     ipar%dt_s    = (GV%itime - ipar%lasthit) * GV%dt_s
     
     ipar%pdeps    = 0.0d0
     ipar%pdeps_eq = 0.0d0

     ipar%penrg = raylist%ray%enrg

     ipar%sigmaHI = Verner_HI_photo_cs(raylist%ray%freq)    
     if (He) then
        ipar%sigmaHeI = Osterbrok_HeI_photo_cs(raylist%ray%freq * HI_th_Hz)    
        ipar%sigmaHeII = Osterbrok_HeII_photo_cs(raylist%ray%freq * HI_th_Hz)
     else
        ipar%sigmaHeI = 0.0d0
        ipar%sigmaHeII = 0.0d0
     end if
     
     if (srcray) then        
        ipar%pflux = raylist%ray%pcnt / ipar%dt_s 
     else
        ipar%pflux = raylist%ray%pcnt 
     end if

  end if


  ipar%strtag = "in initialize_ionpar"
  call check_x(ipar)
     
end subroutine initialize_ionpar






!> initializes a non photo update particle
!-----------------------------------------------------------------------
subroutine initialize_non_photo_ionpar(ipar,par,index,He)

  type(ionpart_type), intent(inout) :: ipar           !< ionization particle
  type(particle_type), intent(in) :: par              !< standard particle
  integer(i8b) :: index                               !< par = psys%par(index)
  logical, intent(in) :: He                           !< update Helium ?

  type(gadget_constants_type) :: gconst  
  real(r8b) :: mass_cgs
  real(r8b) :: rho_cgs


  call par2ionpar(par,ipar,index)

  ! store initial values
  !-------------------------
  ipar%xHI_in  = ipar%xHI
  ipar%xHII_in = ipar%xHII
  if (He) then
     ipar%xHeI_in   = ipar%xHeI
     ipar%xHeII_in  = ipar%xHeII
     ipar%xHeIII_in = ipar%xHeIII
  else
     ipar%xHeI_in   = 0.0d0
     ipar%xHeII_in  = 0.0d0
     ipar%xHeIII_in = 0.0d0
  end if
  ipar%T_in = ipar%T

  ! set values that are static during the update
  !-----------------------------------------------

  ipar%NeBckgnd = GV%NeBackground
  ipar%Tcmb     = GV%Tcmb_cur

  mass_cgs      = ipar%mass * GV%cgs_mass 
  rho_cgs       = ipar%rho *  GV%cgs_rho 

  ipar%gpercm3  = rho_cgs
  ipar%cm3      = mass_cgs / rho_cgs

  ipar%nH       = rho_cgs  * ipar%H_mf / gconst%PROTONMASS
  ipar%Hcnt     = mass_cgs * ipar%H_mf / gconst%PROTONMASS

  if (He) then
     ipar%nHe   = rho_cgs  * ipar%He_mf / (4 * gconst%PROTONMASS)
     ipar%Hecnt = mass_cgs * ipar%He_mf / (4 * gconst%PROTONMASS)
  else
     ipar%nHe   = 0.0d0
     ipar%Hecnt = 0.0d0
  end if

  ! initialize solver iteration counter to zero
  !---------------------------------------------
  ipar%iter = 0

  ipar%dt_code = (GV%itime - ipar%lasthit) * GV%dt_code
  ipar%dt_s    = (GV%itime - ipar%lasthit) * GV%dt_s
     
  ipar%strtag = "in initialize_non_photo_ionpar"
  call check_x(ipar)
     
end subroutine initialize_non_photo_ionpar









!> sets the photoionization rate for an ionization particle
!================================================================
subroutine set_taus(ip,He)

  real(r8b), parameter :: zero = 0.0d0
  real(r8b), parameter :: one = 1.0d0
  real(r8b), parameter :: TAU_LOW = 1.0d-4
  real(r8b), parameter :: TAU_HIGH = 3.0d1
  type(ionpart_type), intent(inout) :: ip !< ionization particle  
  logical, intent(in) :: He

  logical :: HI,HeI,HeII


  ! check which species will be absorbing
  !---------------------------------------
  HI   = .false.
  HeI  = .false.
  HeII = .false.

  if (ip%xHI > zero) HI = .true.

  if (He) then
     if (ip%xHeI  > zero .and. ip%penrg > HeI_th_erg)  HeI = .true.
     if (ip%xHeII > zero .and. ip%penrg > HeII_th_erg) HeII = .true.
  end if


  ! calculate atom counts
  !---------------------------------------
  ip%HIcnt = ip%Hcnt * ip%xHI       
  if (He) then
     ip%HeIcnt  = ip%Hecnt * ip%xHeI        
     ip%HeIIcnt = ip%Hecnt * ip%xHeII          
  else
     ip%HeIcnt = zero
     ip%HeIIcnt = zero
  end if

  ip%Allcnt = ip%HIcnt + ip%HeIcnt + ip%HeIIcnt


  ! calculate taus
  !---------------------------------------
  if (HI) then
     ip%tauHI = ip%cdfac * ip%HIcnt * ip%sigmaHI
!     write(*,*) "tau int: ", ip%tauHI
!     ip%tauHI = ip%dl * GV%cgs_len * ip%nH * ip%xHI * ip%sigmaHI
!     write(*,*) "tau path:", ip%tauHI
!     write(*,*) 
  else
     ip%tauHI = zero
  end if

  !---------------------------------------
  if (HeI) then
     ip%tauHeI = ip%cdfac * ip%HeIcnt * ip%sigmaHeI
  else
     ip%tauHeI = zero
  end if
     
  !---------------------------------------
  if (HeII) then
     ip%tauHeII = ip%cdfac * ip%HeIIcnt * ip%sigmaHeII
  else 
     ip%tauHeII = zero
  end if
  
  ip%tausum = ip%tauHI + ip%tauHeI + ip%tauHeII


  ! calculate absorption ratios
  !--------------------------------
  if (HI) then

     if (ip%tauHI < TAU_LOW) then
        ip%HItaufac = ip%tauHI
     else if (ip%tauHI > TAU_HIGH) then
        ip%HItaufac = one
     else
        ip%HItaufac = one - exp(-ip%tauHI)
     end if

  else
     
     ip%HItaufac = zero

  end if

  !-------------------------------------
  if (HeI) then

     if (ip%tauHeI < TAU_LOW) then
        ip%HeItaufac = ip%tauHeI
     else if (ip%tauHeI > TAU_HIGH) then
        ip%HeItaufac = one
     else
        ip%HeItaufac = one - exp(-ip%tauHeI)
     end if

  else
     
     ip%HeItaufac = zero

  end if

  !-------------------------------------
  if (HeII) then

     if (ip%tauHeII < TAU_LOW) then
        ip%HeIItaufac = ip%tauHeII
     else if (ip%tauHeII > TAU_HIGH) then
        ip%HeIItaufac = one
     else
        ip%HeIItaufac = one - exp(-ip%tauHeII)
     end if

  else
     
     ip%HeIItaufac = zero

  end if

  ip%taufacsum = ip%HItaufac + ip%HeItaufac + ip%HeIItaufac

  if (ip%taufacsum > zero) then
  
     if (.not. He) then
        ip%HIfrac   = one
        ip%HeIfrac  = zero
        ip%HeIIfrac = zero
     else
        ip%HIfrac   = ip%HItaufac   / ip%taufacsum
        ip%HeIfrac  = ip%HeItaufac  / ip%taufacsum
        ip%HeIIfrac = ip%HeIItaufac / ip%taufacsum
     end if

  else

     ip%HIfrac   = zero
     ip%HeIfrac  = zero
     ip%HeIIfrac = zero
     
  end if

end subroutine set_taus


!> sets the photoionization rate for an ionization particle
!================================================================
subroutine set_gammas(ip,He)

  real(r8b), parameter :: zero = 0.0d0
  real(r8b), parameter :: one = 1.0d0
  real(r8b), parameter :: TAU_LOW = 1.0d-4
  real(r8b), parameter :: TAU_HIGH = 3.0d+1
  type(ionpart_type), intent(inout) :: ip !< ionization particle  
  logical, intent(in) :: He

  
  call set_taus(ip,He)

  ! photoionization rates
  !------------------------
  if (ip%tausum > zero) then

     if (ip%tausum < TAU_LOW) then
        ip%fracabsorb = ip%tausum
     else if (ip%tausum > TAU_HIGH) then
        ip%fracabsorb = one
     else
        ip%fracabsorb = one - exp(-ip%tausum)
     end if

     ip%pdepr    = ip%pflux * ip%fracabsorb
     ip%gammasum = ip%pdepr / ip%Allcnt

     ip%gammaHI = ip%gammasum * ip%HIfrac 
     if (He) then
        ip%gammaHeI  = ip%gammasum * ip%HeIfrac 
        ip%gammaHeII = ip%gammasum * ip%HeIIfrac 
     end if

  else

     ip%fracabsorb = zero
     ip%pdepr = zero
     ip%gammasum = zero
     ip%gammaHI = zero
     if (He) then
        ip%gammaHeI = zero
        ip%gammaHeII = zero
     end if
     return

  end if
  
end subroutine set_gammas




!> sets the time rate of change of the electron number density
!================================================================
subroutine set_dnedt(ip,photo,caseA,He)

  type(ionpart_type), intent(inout) :: ip   !< ionization particle
  logical, intent(in) :: photo
  logical, intent(in) :: caseA(2)
  logical, intent(in) :: He

  real(r8b) :: GG,RR
  real(r8b) :: GGI,GGII,RRII,RRIII
  
  if (photo) then
     GG = ip%GGp
  else
     GG = ip%GG
  end if

  if (caseA(1)) then
     RR = ip%RRa
  else
     RR = ip%RRb
  end if

  ip%dnedt = GG * ip%nHI - RR * ip%nHII

  if (He) then

     if (photo) then
        GGI  = ip%GGIp
        GGII = ip%GGIIp
     else
        GGI  = ip%GGI
        GGII = ip%GGII
     end if

     if (caseA(2)) then
        RRII  = ip%RRIIa
        RRIII = ip%RRIIIa
     else
        RRII  = ip%RRIIb
        RRIII = ip%RRIIIb
     end if

     ip%dnedt = ip%dnedt +  (GGI   * ip%nHeI ) + (GGII  * ip%nHeII )   &
                         -  (RRII  * ip%nHeII) - (RRIII * ip%nHeIII)

  end if

end subroutine set_dnedt
 
!> sets the GG's and RR's from the atomic rates, ne's and gammas
!=================================================================
subroutine set_ionization_func(ip,k,photo,caseA,He)

  type(ionpart_type), intent(inout) :: ip   !< ionization particle  
  type(atomic_rates_type), intent(in) :: k  !< rates
  logical, intent(in) :: photo
  logical, intent(in) :: caseA(2)
  logical, intent(in) :: He
 
  ip%GG  = k%HIci * ip%ne 
  if (photo) ip%GGp = ip%GG + ip%gammaHI
  
  ip%RRb = k%HIIrcB * ip%ne
  if (caseA(1)) ip%RRa = k%HIIrcA * ip%ne

  if (He) then
     ip%GGI    = k%HeIci  * ip%ne 
     ip%GGII   = k%HeIIci * ip%ne 
     if (photo) then
        ip%GGIp  = ip%GGI  + ip%gammaHeI  
        ip%GGIIp = ip%GGII + ip%gammaHeII  
     end if

     ip%RRIIb  = k%HeIIrcB  * ip%ne
     ip%RRIIIb = k%HeIIIrcB * ip%ne

     if (caseA(2)) then
        ip%RRIIa  = k%HeIIrcA  * ip%ne
        ip%RRIIIa = k%HeIIIrcA * ip%ne
     end if
  end if

end subroutine set_ionization_func

 
!> sets the global cooling rate for an ionization particle
!================================================================
subroutine set_cooling_func(ip,k,photo,caseA,He)

  type(ionpart_type), intent(inout) :: ip   !< ionization particle  
  type(atomic_rates_type), intent(in) :: k  !< rates
  logical, intent(in) :: photo
  logical, intent(in) :: caseA(2)
  logical, intent(in) :: He

  ! CIC  = collisional ionization cooling
  ! CEC  = collisional excitation cooling
  ! RCC  = recombination cooling 
  ! BREM = free free cooling
  ! COMP = compton cooling
  ! PH   = photo heating  

  ! cooling from Hydrogen
  !-----------------------
  ip%PH  = 0.0d0
  ip%CIC = ( k%HIcic * ip%nHI  ) * ip%ne 
  ip%CEC = ( k%HIcec * ip%nHI  ) * ip%ne

  if (caseA(1)) then
     ip%RCC = ( k%HIIrccA * ip%nHII ) * ip%ne
  else
     ip%RCC = ( k%HIIrccB * ip%nHII ) * ip%ne
  end if

  if (photo) then
     ip%PH = ip%pdepr * ip%HIfrac * (ip%penrg - HI_th_erg)
  end if

  ! cooling from Helium (yes there is an extra ne in He CEC)
  !----------------------------------------------------------
  if (He) then
     ip%CIC = ip%CIC + ( k%HeIcic  * ip%nHeI  + k%HeIIcic * ip%nHeII ) * ip%ne
     ip%CEC = ip%CEC + ( k%HeIcec  * ip%nHeII * ip%ne + k%HeIIcec * ip%nHeII ) * ip%ne

     if (caseA(2)) then
        ip%RCC = ip%RCC + ( k%HeIIrccA * ip%nHeII + k%HeIIIrccA * ip%nHeIII ) * ip%ne 
     else
        ip%RCC = ip%RCC + ( k%HeIIrccB * ip%nHeII + k%HeIIIrccB * ip%nHeIII ) * ip%ne 
     end if

     if (photo) then
        ip%PH = ip%PH + ip%pdepr * ip%HeIfrac  * (ip%penrg - HeI_th_erg ) 
        ip%PH = ip%PH + ip%pdepr * ip%HeIIfrac * (ip%penrg - HeII_th_erg) 
     end if

  end if

  if (He) then
     ip%BREM = Haiman_Bremss_cool_He(ip%T,ip%nHII,ip%nHeII,ip%nHeIII,ip%ne)
  else
     ip%BREM = Haiman_Bremss_cool_H(ip%T,ip%nHII,ip%ne)
  endif

  ip%PH = ip%PH / ip%cm3

  ip%COMP = Haiman_Comp_Heol(ip%T,ip%Tcmb,ip%ne)

  ip%COOL  = -( ip%CIC + ip%CEC + ip%RCC + ip%BREM + ip%COMP ) + (ip%rho*GV%cgs_rho*ip%dinternalEdt*GV%cgs_vel**2/GV%cgs_time)
  ip%COOLp = ip%PH + ip%COOL + (ip%rho*GV%cgs_rho*ip%dinternalEdt*GV%cgs_vel**2/GV%cgs_time)
 
end subroutine set_cooling_func 

!> sets the Hydrogen derivative matrix from the values in GGRR
!======================================================================
subroutine setDH(ip,photo,caseA)

  type(ionpart_type), intent(inout) :: ip   !< ionization particle  
  logical, intent(in) :: photo
  logical, intent(in) :: caseA
  real(r8b) :: GG,RR
 
  if (photo) then
     GG = ip%GGp
  else
     GG = ip%GG
  end if

  if (caseA) then
     RR = ip%RRa
  else
     RR = ip%RRb
  end if

  ip%DH(1,1) = -GG
  ip%DH(2,1) = GG

  ip%DH(1,2) = RR
  ip%DH(2,2) = -RR

end subroutine setDH


!> sets the Helium derivative matrix from the values in GGRR
!======================================================================
subroutine setDHe(ip,photo,caseA)

  real(r8b), parameter :: zero = 0.0d0
  type(ionpart_type), intent(inout) :: ip   !< ionization particle  
  logical, intent(in) :: photo
  logical, intent(in) :: caseA

  real(r8b) :: GGI,GGII,RRII,RRIII

  if (photo) then
     GGI  = ip%GGIp
     GGII = ip%GGIIp
  else
     GGI  = ip%GGI
     GGII = ip%GGII     
  end if

  if (caseA) then
     RRII  = ip%RRIIa
     RRIII = ip%RRIIIa
  else
     RRII  = ip%RRIIb
     RRIII = ip%RRIIIb
  end if

  ip%DHe(1,1) = -GGI
  ip%DHe(2,1) = GGI
  ip%DHe(3,1) = zero

  ip%DHe(1,2) = RRII
  ip%DHe(2,2) = -(GGII + RRII)
  ip%DHe(3,2) = GGII

  ip%DHe(1,3) = zero
  ip%DHe(2,3) = RRIII
  ip%DHe(3,3) = -RRII

  
end subroutine setDHe



!> prints ionization particle information to screen
!-----------------------------------------------------
subroutine ionpar2screen(ipar)

  type(ionpart_type), intent(inout) :: ipar  !< ionization particle
  
   95 format(A,T25,I15)
   100 format(A,T25,3F12.4)
   102 format(A,T25,2F12.4)
   105 format(A,T25,1F12.4)
   110 format(A,T25,3ES18.9)
   115 format(A,T25,2ES18.9)
   write(*,*) 
   write(*,*) "ID", ipar%id
   write(*,*) "pos", ipar%pos
   write(*,*) "vel", ipar%vel
   write(*,*) "hsml", ipar%hsml
   write(*,*) "rho", ipar%rho
   write(*,*) "mass", ipar%mass
   write(*,*) "T", ipar%T
   write(*,*) "lasthit", ipar%lasthit
   write(*,*) 
   write(*,*) "ray num", ipar%rayn
   write(*,*) "psys index", ipar%index
   write(*,*) "impact", ipar%impact
   write(*,*) "iteration", ipar%iter
   write(*,*) "raydist", ipar%d
   write(*,*) 
   write(*,*) "string tag = ", trim(ipar%strtag)
   write(*,*) "xHI+xHII", ipar%xHI + ipar%xHII
   write(*,*) "xHeI+xHeII+xHeIII", ipar%xHeI + ipar%xHeII + ipar%xHeIII
   write(*,'(A,T25,ES18.9)') "T_in", ipar%T_in
   write(*,110) "b, hsml, bnorm",ipar%b, ipar%hsml, ipar%bnorm
   write(*,*) 
   write(*,*) "penrg/(HIth,HeIth,HeIIth)"
   write(*,*) ipar%penrg / HI_th_erg, ipar%penrg / HeI_th_erg, &
              ipar%penrg / HeII_th_erg
   write(*,*) 
   write(*,*) "input(xHI,xHII / xHeI,xHeII,xHeIII)"
   write(*,*) ipar%xHI_in, ipar%xHII_in
   write(*,*) ipar%xHeI_in, ipar%xHeII_in, ipar%xHeIII_in
   write(*,*) 
   write(*,*) "current(xHI,xHII / xHeI,xHeII,xHeIII)"
   write(*,*) ipar%xHI, ipar%xHII
   write(*,*) ipar%xHeI, ipar%xHeII, ipar%xHeIII
   write(*,*) 
   write(*,*) "current(nHI,nHII / nHeI,nHeII,nHeIII)"
   write(*,*) ipar%nHI, ipar%nHII
   write(*,*) ipar%nHeI, ipar%nHeII, ipar%nHeIII
   write(*,*) 
   write(*,*) "optical depths / tau facs (HI,HeI,HeII)"
   write(*,*) ipar%tauHI, ipar%tauHeI, ipar%tauHeII
   write(*,*) ipar%HItaufac, ipar%HeItaufac, ipar%HeIItaufac
   write(*,*) 
   write(*,*) "nH,nHe,ne / Hcnt,Hecnt,dnedt"
   write(*,*)  ipar%nH, ipar%nHe, ipar%ne
   write(*,*)  ipar%Hcnt, ipar%Hecnt, ipar%dnedt
   write(*,*) 
   write(*,*) "HIcnt,HeIcnt,HeIIcnt / HIfrac,HeIfrac,HeIIfrac"
   write(*,*) ipar%HIcnt, ipar%HeIcnt, ipar%HeIIcnt 
   write(*,*) ipar%HIfrac,ipar%HeIfrac,ipar%HeIIfrac
   write(*,*)
   write(*,*) "sigmas (HI,HeI,HeII) / Gammas (HI,HeI,HeII)"
   write(*,*) ipar%sigmaHI, ipar%sigmaHeI, ipar%sigmaHeII
   write(*,*) ipar%gammaHI, ipar%gammaHeI, ipar%gammaHeII
   write(*,*)
   write(*,*) "GGp (HI,HeI,HeII) / RRb (HII,HeII,HeIII)"
   write(*,*) ipar%GGp, ipar%GGIp, ipar%GGIIp
   write(*,*) ipar%RRb, ipar%RRIIb, ipar%RRIIIb
   write(*,*)
   write(*,*) "CIC,CEC,RCC / PH,BREM,COMP / COOLp, COOL"
   write(*,*) ipar%CIC, ipar%CEC, ipar%RCC
   write(*,*) ipar%PH, ipar%BREM, ipar%COMP
   write(*,*) ipar%COOLp, ipar%COOL
   write(*,*) 
   write(*,*) "pflux, fracabsorb, pdepr"
   write(*,*) ipar%pflux, ipar%fracabsorb, ipar%pdepr
   write(*,*) 
   write(*,110) "pdepr,penrg,pdeps", ipar%pdepr, ipar%penrg, ipar%pdeps

   write(*,*)
   write(*,115) "cdfac,d", ipar%cdfac,  ipar%d
   write(*,*) 
   write(*,115) "gpercm3,cm3", ipar%gpercm3, ipar%cm3

   write(*,*) 
   write(*,115) "u,dudt", ipar%u, ipar%dudt 
   write(*,115) "t,dTdt", ipar%T, ipar%dTdt
   write(*,*) 
   write(*,115) "Allcnt,GammaSum", ipar%Allcnt,ipar%gammasum
   write(*,115) "tausum,taufacsum",ipar%tausum, ipar%taufacsum
   write(*,*) 
   write(*,115) "tion,tcool", ipar%tion, ipar%tcool
   write(*,115) "dt_code, dt_s", ipar%dt_code, ipar%dt_s

   write(*,'(A,T25,ES18.9)') "pdeps_eq", ipar%pdeps_eq

   ipar%strtag = ""

 end subroutine ionpar2screen


!================================================================
!> dummy checks the bounds on HII, HeII, HeIII, and T
subroutine check_x(ip) 

  real(r8b), parameter :: zero = 0.0d0
  real(r8b), parameter :: one = 1.0d0

  real(r8b), parameter :: TOL = 0.0d+0
  type(ionpart_type), intent(inout) :: ip  !< ionization particle
  logical :: bad

  100 format(A,I2,A)
  101 format(A,I2,A,F15.8)
  102 format(A,I15)
  103 format(A,2F15.8)

  bad = .false.
 
  if ( ip%xHI .LT. zero - TOL ) then
     bad = .true.
     write(*,100) "xHI < zero in check_x"
  end if
     
  if ( ip%xHI > one + TOL ) then
     bad = .true.
     write(*,*) "xHI = ", ip%xHI
     write(*,100) "xHI > one in check_x"
  end if

  if ( ip%xHII .LT. zero - TOL ) then
     bad = .true.
     write(*,100) "xHII < zero in check_x"
  end if
     
  if ( ip%xHII .GT. one + TOL ) then
     bad = .true.
     write(*,100) "xHII > one in check_x"
  end if
     

  if ( ip%xHeI .LT. zero - TOL ) then
     bad = .true.
     write(*,100) "xHeI < zero in check_x"
  end if
     
  if ( ip%xHeI .GT. one + TOL ) then
     bad = .true.
     write(*,100) "xHeI > one in check_x"
  end if

  if ( ip%xHeII .LT. zero - TOL ) then
     bad = .true.
     write(*,100) "xHeII < zero in check_x"
  end if
     
  if ( ip%xHeII .GT. one + TOL ) then
     bad = .true.
     write(*,100) "xHeII > one in check_x"
  end if

  if ( ip%xHeIII .LT. zero - TOL ) then
     bad = .true.
     write(*,100) "xHeIII < zero in check_x"
  end if
     
  if ( ip%xHeIII .GT. one + TOL ) then
     bad = .true.
     write(*,100) "xHeIII > one in check_x"
  end if

  if ( ip%T .LE. zero ) then
     bad = .true.
     write(*,*) "T <= zero in check_x"
  end if


  if (bad) then
     call ionpar2screen(ip)
     stop
  end if

end subroutine check_x


end module ionpar_mod

!> \file spectra.F90

!> \brief spectra handling
!<

module spectra_mod
use myf03_mod
implicit none
private

  public :: rn2freq, read_spectra_file

  integer(i8b), parameter :: maxfreqbins = 1000  !< maximum frequency bins

  integer(i8b) :: Nspectra      !< number of user defined spectra
  integer(i8b) :: Nfreqs        !< number of entries

  real(r8b), allocatable :: nus(:,:)  !< frequency in HI ionizing units (SpecNum,freq)
  real(r8b), allocatable :: cdf(:,:)  !< cumulative distribution function (SpecNum,cdf)

contains


!>   reads all user defined spectra 
!---------------------------------------
  subroutine read_spectra_file(spectra_file)

    character(clen), intent(in) :: spectra_file  !< file containing spectra

    character(clen), parameter :: myname = 'read_spectra_file'
    logical, parameter :: crash = .true.
    integer, parameter :: verb = 1
    character(clen) :: str

    real(r8b) :: Numin, Numax
    integer(i4b) :: lun, err, i, j
    logical :: fthere


    write(str,'(A,A)') 'using spectra file:       ', trim(spectra_file) 
    call mywrite(str, verb) 

    inquire(file=spectra_file,exist=fthere)
    if (.not. fthere) then
       call myerr('cant find spectra file: ' // trim(spectra_file), myname, crash)
    end if

    call open_formatted_file_r(spectra_file,lun)
    read(lun,*) Nspectra
    if (Nspectra<=0) Nspectra=1  ! just to make sure spectra is allocated

    write(str,'(A,I5)') '  number of user defined spectra = ', Nspectra 
    call mywrite('', verb+1)
    call mywrite(str, verb+1) 

    do i = 1,Nspectra

       read(lun,*) Nfreqs, Numin, Numax

       write(str,'(A,I5,A,I5,A)') '  user defined spectrum ',i,' has ', &
                                  Nfreqs,' entries'
       call mywrite(str, verb+1) 

       if (i == 1) then
          allocate ( nus(Nfreqs,Nspectra), cdf(Nfreqs,Nspectra), stat=err )
          if(err/=0) then
             call myerr('cant allocate nus and cdf', myname, crash) 
          end if
       end if

       do j = 1,Nfreqs
          read(lun,*) nus(j,i), cdf(j,i)
       end do

    end do

    close(lun)

    call mywrite('', verb+1) 


  end subroutine read_spectra_file


  !> returns a frequency given a spectral type
  !-------------------------------------------
  function rn2freq(spectype) result(freq)
  use mt19937_mod, only: genrand_real1

    character(clen), parameter :: myname = 'rn2freq'
    logical, parameter :: crash = .true.

    real(r4b) :: spectype  !< spectral user defined type
    real(r4b) :: freq      !< returned frequency

    real(r8b) :: rn
    integer(i8b) :: specbin
    integer(i8b) :: specnum

    if (spectype <= 0.0) then
       freq = abs(spectype)
       return
    else
       specnum = int(spectype)
       rn = genrand_real1()
       do specbin = 1,Nfreqs
          if ( rn <= cdf(specbin,specnum) ) then
             freq = nus(specbin,specnum)
             return
          end if
       end do

       call myerr("went through loop w/o finding frequency", myname, crash)

    end if

   end function rn2freq

end module spectra_mod

function initialize_code() result(ret)
  use amuse_sphrayMod
  integer :: ret
  call sphray_init
  ret=0
end function

function cleanup_code() result(ret)
  use amuse_sphrayMod
  integer :: ret
  call sphray_end
  ret=0
end function

function commit_particles() result(ret)
  use amuse_sphrayMod
  integer :: ret
  call sphray_commit_particles
  ret=0
end function

function recommit_particles() result(ret)
  use amuse_sphrayMod
  integer :: ret
  call sphray_commit_particles
  ret=0
end function


function commit_parameters() result(ret)
  use amuse_sphrayMod
  integer :: ret
  call sphray_commit_parameters
  ret=0
end function

function recommit_parameters() result(ret)
  use amuse_sphrayMod
  integer :: ret
  ret=-1
end function

function get_number_of_gas_particles(n) result(ret)
  use amuse_sphrayMod
  integer n,ret
  ret=-1
end function

function new_gas_particle(id,mass,hsml,x,y,z,rho,xe,u,vx,vy,vz) result(ret)
  use amuse_sphrayMod
  integer(i4b) :: ret,id
  real(r8b) :: mass,hsml,x,y,z,rho,xe,u,vx,vy,vz
  real(r4b) :: t_mass,t_hsml,t_x,t_y,t_z,t_rho,t_xe,t_u,t_vx,t_vy,t_vz
  t_mass=mass;t_hsml=hsml;t_x=x;t_y=y;t_z=z;t_rho=rho;t_xe=xe;t_u=u
  t_vx=vx;t_vy=vy;t_vz=vz
  call sphray_add_gas_particle(id,t_mass,t_hsml,t_x,t_y,t_z,t_rho,t_xe,t_u,t_vx,t_vy,t_vz)
  ret=0
end function

function new_src_particle(id,L,x,y,z,SpcType) result(ret)
  use amuse_sphrayMod
  integer :: ret,id
  real(r8b) :: L,x,y,z,SpcType
  real(r4b) :: t_L,t_x,t_y,t_z,t_SpcType
  t_L=L;t_x=x;t_y=y;t_z=z;t_SpcType=SpcType
  call sphray_add_src_particle(id,t_L,t_x,t_y,t_z,t_SpcType)
  ret=0
end function

function get_state_gas(id,mass,hsml,x,y,z,rho,xe,u) result(ret)
  use amuse_sphrayMod
  integer :: ret,id
  real(r8b) :: mass,hsml,x,y,z,rho,xe,u
  real(r4b) :: t_mass,t_hsml,t_x,t_y,t_z,t_rho,t_xe,t_u
  ret= sphray_get_gas_particle_state(id,t_mass,t_hsml,t_x,t_y,t_z,t_rho,t_xe,t_u)
  mass=t_mass;hsml=t_hsml;x=t_x;y=t_y;z=t_z;rho=t_rho;xe=t_xe;u=t_u;
end function

function set_state_gas(id,mass,hsml,x,y,z,rho,xe,u) result(ret)
  use amuse_sphrayMod
  integer(i4b) :: ret,id
  real(r8b) :: mass,hsml,x,y,z,rho,xe,u
  real(r4b) :: t_mass,t_hsml,t_x,t_y,t_z,t_rho,t_xe,t_u
  t_mass=mass;t_hsml=hsml;t_x=x;t_y=y;t_z=z;t_rho=rho;t_xe=xe;t_u=u
  ret=sphray_set_gas_particle_state(id,t_mass,t_hsml,t_x,t_y,t_z,t_rho,t_xe,t_u)
end function

function set_pos_gas(id,x,y,z) result(ret)
  use amuse_sphrayMod
  integer(i4b) :: ret,id
  real(r8b) :: x,y,z
  real(r4b) ::t_x,t_y,t_z
  t_x=x;t_y=y;t_z=z
  ret=sphray_set_gas_particle_pos(id,t_x,t_y,t_z)
end function
function set_hsml_gas(id,hsml) result(ret)
  use amuse_sphrayMod
  integer(i4b) :: ret,id
  real(r8b) :: hsml
  real(r4b) :: t_hsml
  t_hsml=hsml
  ret=sphray_set_gas_particle_hsml(id,t_hsml)
end function
function set_rho_gas(id,rho) result(ret)
  use amuse_sphrayMod
  integer(i4b) :: ret,id
  real(r8b) :: rho
  real(r4b) :: t_rho
  t_rho=rho
  ret=sphray_set_gas_particle_rho(id,t_rho)
end function
function set_u_gas(id,u) result(ret)
  use amuse_sphrayMod
  integer(i4b) :: ret,id
  real(r8b) :: u
  real(r4b) :: t_u
  t_u=u
  ret=sphray_set_gas_particle_u(id,t_u)
end function

function set_dudt_gas(id,u) result(ret)
  use amuse_sphrayMod
  integer(i4b) :: ret,id
  real(r8b) :: u
  real(r4b) :: t_u
  t_u=u
  ret=sphray_set_gas_particle_dudt(id,t_u)
end function

function set_vel_gas(id,vx,vy,vz) result(ret)
  use amuse_sphrayMod
  integer(i4b) :: ret,id
  real(r8b) :: vx,vy,vz
  real(r4b) :: t_vx,t_vy,t_vz
  t_vx=vx;t_vy=vy;t_vz=vz
  ret=sphray_set_gas_particle_vel(id,t_vx,t_vy,t_vz)
end function

function get_vel_gas(id,vx,vy,vz) result(ret)
  use amuse_sphrayMod
  integer(i4b) :: ret,id
  real(r8b) :: vx,vy,vz
  real(r4b) :: t_vx,t_vy,t_vz
  ret=sphray_get_gas_particle_vel(id,t_vx,t_vy,t_vz)
  vx=t_vx;vy=t_vy;vz=t_vz
end function

function get_dudt_gas(id,u) result(ret)
  use amuse_sphrayMod
  integer(i4b) :: ret,id
  real(r8b) :: u
  real(r4b) :: t_u
  ret=sphray_get_gas_particle_dudt(id,t_u)
  u=t_u
end function

function get_state_src(id,L,x,y,z,spctype) result(ret)
  use amuse_sphrayMod
  integer(i4b) :: id,ret
  real(r8b) :: L,x,y,z,spctype
  real(r4b) :: t_L,t_x,t_y,t_z,t_spctype
  ret=sphray_get_src_particle_state(id,t_L,t_x,t_y,t_z,t_spctype)
  L=t_L;x=t_x;y=t_y;z=t_z;spctype=t_spctype
end function

function set_state_src(id,L,x,y,z,spctype) result(ret)
  use amuse_sphrayMod
  integer(i4b) :: id,ret
  real(r8b) :: L,x,y,z,spctype
  real(r4b) :: t_L,t_x,t_y,t_z,t_SpcType
  t_L=L;t_x=x;t_y=y;t_z=z;t_SpcType=SpcType
  ret=sphray_set_src_particle_state(id,t_L,t_x,t_y,t_z,t_spctype)
end function

function set_luminosity_src(id,L) result(ret)
  use amuse_sphrayMod
  integer(i4b) :: id,ret
  real(r8b) :: L
  real(r4b) :: t_L
  t_L=L
  ret=sphray_set_src_particle_luminosity(id,t_L)
end function

function evolve_model(tend) result(ret)
  use amuse_sphrayMod
  integer :: ret
  real(r8b) :: tend
  call sphray_evolve(tend)
  ret=0
end function

function set_spectra_file(x) result(ret)
  use amuse_sphrayMod
  integer :: ret
  character(len=512) :: x
  call sphray_set_spectra_file(x)
  ret=0
end function

function get_spectra_file(x) result(ret)
  use amuse_sphrayMod
  integer :: ret
  character(len=512) :: x
  call sphray_get_spectra_file(x)
  ret=0
end function

function set_sphray_data_directory(x) result(ret)
  use amuse_sphrayMod
  integer :: ret
  character(len=512) :: x
  call sphray_set_data_directory(x)
  ret=0
end function

function get_sphray_data_directory(x) result(ret)
  use amuse_sphrayMod
  integer :: ret
  character(len=512) :: x
  call sphray_get_data_directory(x)
  ret=0
end function

function set_sphray_output_directory(x) result(ret)
  use amuse_sphrayMod
  integer :: ret
  character(len=512) :: x
  call sphray_set_output_directory(x)
  ret=0
end function

function get_sphray_output_directory(x) result(ret)
  use amuse_sphrayMod
  integer :: ret
  character(len=512) :: x
  call sphray_get_output_directory(x)
  ret=0
end function

function remove_gas_particle(id) result(ret)
  use amuse_sphrayMod
  integer(i4b) :: ret,id
  ret=sphray_remove_gas_particle(id)
end function

function remove_src_particle(id) result(ret)
  use amuse_sphrayMod
  integer(i4b) :: ret,id
  ret=sphray_remove_src_particle(id)
end function

function set_isothermal(flag) result(ret)
  use amuse_sphrayMod
  integer flag,ret
  if(flag.NE.0) call sphray_set_isothermal(.TRUE.)
  if(flag.EQ.0) call sphray_set_isothermal(.FALSE.)
  ret=0
end function

function get_isothermal(flag) result(ret)
  use amuse_sphrayMod
  integer :: ret,flag
  logical :: x
  flag=0
  call sphray_get_isothermal(x)
  if(x) flag=1
  ret=0
end function

function set_momentum_kicks(flag) result(ret)
  use amuse_sphrayMod
  integer flag,ret
  if(flag.NE.0) call sphray_set_momentum_kicks(.TRUE.)
  if(flag.EQ.0) call sphray_set_momentum_kicks(.FALSE.)
  ret=0
end function

function get_momentum_kicks(flag) result(ret)
  use amuse_sphrayMod
  integer :: ret,flag
  logical :: x
  flag=0
  call sphray_get_momentum_kicks(x)
  if(x) flag=1
  ret=0
end function


function set_H_caseA(flag) result(ret)
  use amuse_sphrayMod
  integer flag,ret
  if(flag.NE.0) call sphray_set_H_caseA(.TRUE.)
  if(flag.EQ.0) call sphray_set_H_caseA(.FALSE.)
  ret=0
end function

function get_H_caseA(flag) result(ret)
  use amuse_sphrayMod
  integer :: ret,flag
  logical :: x
  flag=0
  call sphray_get_H_caseA(x)
  if(x) flag=1
  ret=0
end function

function set_He_caseA(flag) result(ret)
  use amuse_sphrayMod
  integer flag,ret
  if(flag.NE.0) call sphray_set_He_caseA(.TRUE.)
  if(flag.EQ.0) call sphray_set_He_caseA(.FALSE.)
  ret=0
end function

function get_He_caseA(flag) result(ret)
  use amuse_sphrayMod
  integer :: ret,flag
  logical :: x
  flag=0
  call sphray_get_He_caseA(x)
  if(x) flag=1
  ret=0
end function

function get_time(time) result(ret)
  use amuse_sphrayMod
  integer :: ret
  real(r8b) :: time
  time=sphray_model_time()
  ret=0
end function

function set_time(time) result(ret)
  use amuse_sphrayMod
  integer :: ret
  real(r8b) :: time
  call sphray_set_model_time(time)
  ret=-1
end function


function get_raynumber(x) result(ret)
  use amuse_sphrayMod
  integer :: ret
  real(r8b) :: x  
  call sphray_get_raynumber(x)
  ret=0
end function

function set_raynumber(x) result(ret)
  use amuse_sphrayMod
  integer :: ret
  real(r8b) :: x  
  call sphray_set_raynumber(x)
  ret=0
end function

function get_defaultspectype(x) result(ret)
  use amuse_sphrayMod
  integer :: ret
  real(r8b) :: x
  call sphray_get_defaultspectype(x)
  ret=0
end function

function set_defaultspectype(x) result(ret)
  use amuse_sphrayMod
  integer :: ret
  real(r8b) :: x
  call sphray_set_defaultspectype(x)
  ret=0
end function


function get_iontempsolver(N) result(ret)
  use amuse_sphrayMod
  integer :: ret
  integer(i4b) :: N
  call sphray_get_iontempsolver(N)
  ret=0
end function

function set_iontempsolver(N) result(ret)
  use amuse_sphrayMod
  integer :: ret
  integer(i4b) :: N
  call sphray_set_iontempsolver(N)
  ret=0
end function

function get_boundary(N) result(ret)
  use amuse_sphrayMod
  integer :: ret
  integer(i4b) :: N
  call sphray_get_boundary(N)
  ret=0
end function

function set_boundary(N) result(ret)
  use amuse_sphrayMod
  integer :: ret
  integer(i4b) :: N
  call sphray_set_boundary(N)
  ret=0
end function

function get_boxsize(x) result(ret)
  use amuse_sphrayMod
  integer :: ret
  real(r8b) :: x
  call sphray_get_boxsize(x)
  ret=0
end function

function set_boxsize(x) result(ret)
  use amuse_sphrayMod
  integer :: ret
  real(r8b) :: x
  call sphray_set_boxsize(x)
  ret=0
end function

function set_globalHefraction(x) result(ret)
  use amuse_sphrayMod
  integer :: ret
  real(r8b) :: x
  ret=sphray_set_he_mass_frac(x)
end function

function get_globalHefraction(x) result(ret)
  use amuse_sphrayMod
  integer :: ret
  real(r8b) :: x
  ret=sphray_get_he_mass_frac(x)
end function

!> \file gadget_vbromm_input.F90

!> \brief Handles readin of GADGET 2.0 raw binary formatted files
!! from Volker Bromm's group
!<

module gadget_vbromm_input_mod
use myf03_mod
use gadget_general_class
use gadget_public_header_class
use gadget_sphray_header_class
use particle_system_mod, only: particle_system_type

use global_mod, only: psys, PLAN, GV
use global_mod, only: saved_gheads
implicit none
private

public :: get_planning_data_gadget_vbromm
public :: read_Gvbromm_particles
public :: set_temp_from_u_vbromm



contains


!>  gets run planning data from Gadget VBromm Headers
!======================================================
subroutine get_planning_data_gadget_vbromm()

  type(gadget_public_header_type) :: ghead
  type(gadget_units_type) :: gunits
  type(gadget_constants_type) :: gconst

  integer(i4b) :: iSnap, fSnap    ! initial and final snapshot numbers
  integer(i4b) :: pfiles          ! files/snap for particles    
  integer(i4b) :: i,j             ! counters
  character(clen) :: snapfile     ! snapshot file name

  integer(i4b) :: loglun
  character(clen) :: logfile

  ! open up the planning data log file
  !======================================================
  logfile = trim(GV%OutputDir) // "/" // "particle_headers.log"
  call open_formatted_file_w(logfile,loglun)

  ! these global variables are read from the config file
  !======================================================
  iSnap  = GV%StartSnapNum
  fSnap  = GV%EndSnapNum
  pfiles = GV%ParFilesPerSnap

  if ( allocated(saved_gheads) ) deallocate(saved_gheads)
  allocate( saved_gheads(iSnap:fSnap, 0:pfiles-1) )

  ! set global units
  !===================================================
  GV%cgs_len  = gunits%cgs_length
  GV%cgs_mass = gunits%cgs_mass
  GV%cgs_vel  = gunits%cgs_velocity
  GV%cgs_time = gunits%cgs_time
  GV%cgs_rho  = gunits%cgs_density
  GV%cgs_prs  = gunits%cgs_pressure
  GV%cgs_enrg = gunits%cgs_energy  

  ! read all particle headers and write to log file
  !===================================================
  write(loglun,'(A)') "reading all GADGET Vbromm particle header(s) ... "
  do i = iSnap,fSnap
     do j = 0,pfiles-1

        call form_gadget_snapshot_file_name(GV%SnapPath, GV%ParFileBase, i, j, snapfile, hdf5bool=.false.)
        write(loglun,'(I3,"  ",A)') i, trim(snapfile)

        call gadget_public_header_read_file( ghead, snapfile )
        call gadget_public_header_print_lun( ghead, loglun )
        call gadget_sphray_header_copy_public( saved_gheads(i,j), ghead )

!        call ghead%read_Gpublic_header_file(snapfile)
!        call ghead%print_Gpublic_header_lun(loglun)
!        call saved_gheads(i,j)%copy_Gpublic_header(ghead)

        saved_gheads(i,j)%OmegaB = 0.045 ! this should be moved to the config file
                                         ! but its not used in the code now

        saved_gheads(i,j)%time_gyr = gadget_public_header_return_gyr(ghead) 
!        saved_gheads(i,j)%time_gyr = ghead%return_gyr()

        ! make sure there is gas in this snapshot
        !-------------------------------------------
        if (.not. ghead%npar_all(0) > 0) then
           write(*,*) "Gadget snapshot does not contain any gas particles"
           write(*,*) "Sphray cannot read dark matter particles directly, "
           write(*,*) "please calculate smoothing lengths for these particles"
           write(*,*) "and write them as gas particles. "
           stop
        end if

        if (GV%Comoving) then
           PLAN%snap(i)%ScalefacAt = ghead%a
           PLAN%snap(i)%TimeAt = gadget_public_header_return_gyr(ghead) * (gconst%SEC_PER_MEGAYEAR * 1.0d3) ! in seconds
           PLAN%snap(i)%TimeAt = PLAN%snap(i)%TimeAt * GV%LittleH / GV%cgs_time ! in code units
        else
           PLAN%snap(i)%ScalefacAt = 1.0d0 / (1.0d0 + ghead%z)
           PLAN%snap(i)%TimeAt = ghead%a
        end if

     end do
  end do

  ! close headers log file
  !========================
  close(loglun)

  ! use one header to set global variables
  !--------------------------------------------
  GV%BoxLwrs(:) = 0.0d0
  GV%BoxUprs(:) = saved_gheads(iSnap,0)%boxlen
  
  GV%OmegaM = saved_gheads(iSnap,0)%OmegaM
  GV%OmegaL = saved_gheads(iSnap,0)%OmegaL
  GV%OmegaB = saved_gheads(iSnap,0)%OmegaB 
  
  GV%LittleH = saved_gheads(iSnap,0)%h
  
 

  ! write units to log file
  !===================================================

  logfile = trim(GV%OutputDir) // "/" // "code_units.log"
  call open_formatted_file_w(logfile,loglun)
  call gadget_units_print_lun( gunits, loglun, saved_gheads(iSnap,0)%h )
  close(loglun)

end subroutine get_planning_data_gadget_vbromm


!> reads a Gadget snapshot from Volker Bromm's group
!=================================================================
subroutine read_Gvbromm_particles()

  character(clen), parameter :: myname="read_Gvbromm_particles"
  logical, parameter :: crash=.true.
  integer, parameter :: verb=2
  character(clen) :: str,fmt 

  real(r4b), allocatable :: rblck(:)
  real(r4b), allocatable :: rblck3(:,:)
  integer(i4b), allocatable :: iblck(:)
  integer(i8b) :: ngasread

  type(gadget_public_header_type) :: ghead
  type(gadget_sphray_header_type) :: shead
  character(clen) :: snapfile
  integer(i4b) :: lun,i
  integer(i4b) :: err

  integer(i8b) :: npar, ngas, nmass
  integer(i8b) :: npar1, ngas1, nmass1
  logical :: varmass(0:5)
  integer(i4b) :: fn

  real(r8b) :: meanweight
  logical :: caseA(2)
  real(r8b) :: xvec(5)
  real(r8b) :: Tdum
  real(r8b) :: MB 
  real(r8b) :: nH_over_nHe

  logical :: hdf5bool

  ! set hdf5 boolean
  !======================================================
  hdf5bool = .false.

  ! set local particle numbers
  !============================
  shead = saved_gheads( GV%CurSnapNum, 0 )
  varmass = (shead%npar_all > 0 .and. shead%mass == 0)
  npar = sum(shead%npar_all)
  ngas = shead%npar_all(0)
  nmass = sum(shead%npar_all, mask=varmass)

  ! do Gadget dummy checks
  !============================
  if (ngas .EQ. 0) call myerr("snapshot has no gas particles",myname,crash)

  ! calculate bytes per particle and allocate particle array
  !===========================================================
  MB = GV%bytesperpar * real(ngas) / 2.0d0**20
  GV%MB = GV%MB + MB

  fmt="(A,F10.4,A,I10,A)"
  write(str,fmt) "allocating ", MB, " MB for ", ngas, " particles"
  call mywrite(str,verb)

  allocate (psys%par(ngas), stat=err)
  if (err /= 0) call myerr("failed to allocate par",myname,crash)



  ! now read all snapshot files
  !==============================          
  ngasread = 0
  files: do fn = 0, shead%nfiles-1

     ! recall the header info
     !-----------------------------------------------------------!  
     shead   = saved_gheads( GV%CurSnapNum, fn )
     varmass = (shead%npar_file > 0 .and. shead%mass == 0)
     npar1   = sum(shead%npar_file)
     ngas1   = shead%npar_file(0)
     nmass1  = sum(shead%npar_file, mask=varmass)
     if (ngas1 == 0) cycle

     ! begin read
     !-----------------------------------------------------------!  
     call form_gadget_snapshot_file_name(GV%SnapPath,GV%ParFileBase,GV%CurSnapNum,fn,snapfile,hdf5bool)
     call mywrite("reading vbromm gadget snapshot file "//trim(snapfile), verb)
     call open_unformatted_file_r( snapfile, lun )
     call gadget_public_header_read_lun( ghead, lun )



     ! read positions 
     !-----------------------------------------------------------!  
     allocate(rblck3(3,ngas1), stat=err)
     if(err/=0) call myerr("allocating rblck3 for pos",myname,crash)
     read(lun, iostat=err) rblck3
     if (err/=0) call myerr("reading rblk3 for pos",myname,crash) 
     forall(i=1:ngas1) psys%par(ngasread+i)%pos(1) = rblck3(1,i)
     forall(i=1:ngas1) psys%par(ngasread+i)%pos(2) = rblck3(2,i)
     forall(i=1:ngas1) psys%par(ngasread+i)%pos(3) = rblck3(3,i)
     deallocate(rblck3)

     ! read velocities 
     !-----------------------------------------------------------!  
#ifdef incVel
     allocate(rblck3(3,ngas1), stat=err)
     if(err/=0) call myerr("allocating rblck3 for vel",myname,crash)
     read(lun, iostat=err) rblck3
     if (err/=0) call myerr("reading rblk3 for vel",myname,crash) 
     forall(i=1:ngas1) psys%par(ngasread+i)%vel(1) = rblck3(1,i)
     forall(i=1:ngas1) psys%par(ngasread+i)%vel(2) = rblck3(2,i)
     forall(i=1:ngas1) psys%par(ngasread+i)%vel(3) = rblck3(3,i)
     deallocate(rblck3)
#else
     read(lun, iostat=err)
     if (err/=0) call myerr("dummy reading vel",myname,crash) 
#endif


     ! read id's 
     !-----------------------------------------------------------!  
     allocate(iblck(ngas1), stat=err )
     if(err/=0) call myerr("allocating iblck for ID",myname,crash)
     read(lun, iostat=err) iblck  
     if (err/=0) call myerr("reading iblk for ID",myname,crash) 
     forall(i=1:ngas1) psys%par(ngasread+i)%id = iblck(i)
     deallocate(iblck)

     ! read masses 
     !-----------------------------------------------------------!  

     ! if there are variable mass particles of any type
     if (nmass1 > 0) then  

        ! if there are variable mass gas particles
        if (varmass(1)) then  
           allocate(rblck(ngas1), stat=err)
           if(err/=0) call myerr("allocating rblck for mass",myname,crash)
           read(lun, iostat=err) rblck 
           if (err/=0) call myerr("reading rblk for mass",myname,crash) 
           forall(i=1:ngas1) psys%par(ngasread+i)%mass = rblck(i)
           deallocate(rblck)

        ! just dummy read non gas particles
        else 
           read(lun)  
           psys%par(ngasread+1:ngasread+ngas1)%mass = ghead%mass(1)
        end if

     ! if none of the particles are variable mass
     else  
        psys%par(ngasread+1:ngasread+ngas1)%mass = ghead%mass(1)
     end if


     ! read temperature (internal energy / unit mass for now)
     !-----------------------------------------------------------!  
     allocate(rblck(ngas1), stat=err)
     if(err/=0) call myerr("allocating rblck for u",myname,crash)
     read(lun, iostat=err) rblck
     if (err/=0) call myerr("reading rblk for u",myname,crash) 
     forall(i=1:ngas1) psys%par(ngasread+i)%T = rblck(i) 
     deallocate(rblck)


     ! read density 
     !-----------------------------------------------------------!  
     allocate(rblck(ngas1), stat=err)
     if(err/=0) call myerr("allocating rblck for rho",myname,crash)
     read(lun, iostat=err) rblck
     if (err/=0) call myerr("reading rblk for rho",myname,crash) 
     forall(i=1:ngas1) psys%par(ngasread+i)%rho = rblck(i)
     deallocate(rblck)


     ! read smoothing lengths 
     !-----------------------------------------------------------!  
     allocate(rblck(ngas1), stat=err)
     if(err/=0) call myerr("allocating rblck for hsml",myname,crash)
     read(lun, iostat=err) rblck
     if (err/=0) call myerr("reading rblk for hsml",myname,crash) 
     forall(i=1:ngas1) psys%par(ngasread+i)%hsml = rblck(i)
     deallocate(rblck)

     ! read ionization fractions
     !-----------------------------------------------------------!  
     
     ! CAFG: First, big array containing all the abundances.
     allocate(rblck(10*ngas1), stat=err)
     if(err/=0) call myerr("allocating rblck for all abundances",myname,crash)
     read(lun, iostat=err) rblck
     if (err/=0) call myerr("reading rblk for all abundances",myname,crash) 
     
     ! CAFG: Here is where we should assign the desired abundances to the
     ! relevant particle data.
     forall(i=1:ngas1) psys%par(ngasread+i)%xHII = rblck(10*(i-1)+2)
     
 
#ifdef incHe
     ! read HeII = nHeII / nH
     !-----------------------------------------------------------!  
     forall(i=1:ngas1) psys%par(ngasread+i)%xHeII = rblck(10*(i-1)+9)


     ! read HeIII = nHeIII / nH
     !-----------------------------------------------------------!  
     forall(i=1:ngas1) psys%par(ngasread+i)%xHeIII = rblck(10*(i-1)+10)

#endif
     
     deallocate(rblck)

     ngasread = ngasread + ngas1
     close(lun)

  end do files



  ! set xHI from xHII 
  !----------------------------------------------------------------!  
  psys%par(:)%xHI = 1.0d0 - psys%par(:)%xHII


  ! use Hydrogen and Helium mass fractions from config file to
  ! set the Helium ionization fractions
  !----------------------------------------------------------------!  
#ifdef incHe
  nH_over_nHe = 4 * GV%H_mf / GV%He_mf
  psys%par(:)%xHeII  = psys%par(:)%xHeII  * nH_over_nHe
  psys%par(:)%xHeIII = psys%par(:)%xHeIII * nH_over_nHe
  psys%par(:)%xHeI   = 1.0d0 - psys%par(:)%xHeII - psys%par(:)%xHeIII
#endif 

  ! set ye from ionization fractions
  !----------------------------------------------------------------!  
  psys%par(:)%ye = psys%par(:)%xHII
#ifdef incHe
  psys%par(:)%ye = psys%par(:)%ye + psys%par(:)%xHeII + 2 * psys%par(:)%xHeIII
#endif

  ! convert the internal energy to temperature using ye 
  !----------------------------------------------------------------!  
  
  call set_temp_from_u_vbromm(psys, GV%H_mf, GV%cgs_enrg, GV%cgs_mass)


  ! shrink particles with negative IDs to 
  !----------------------------------------------------------------!  
  where( psys%par(:)%id < 0 ) psys%par(:)%hsml = 0.0




end subroutine read_Gvbromm_particles


!> converts internal energies / unit mass to temperature K using Hmf and ye = ne/nH
!=======================================================================================
subroutine set_temp_from_u_vbromm(psys, dfltH_mf, cgs_enrg, cgs_mass)

  type(particle_system_type) :: psys
  real(r8b), intent(in) :: dfltH_mf
  real(r8b), intent(in) :: cgs_enrg
  real(r8b), intent(in) :: cgs_mass
  integer(i8b) :: i
  real(r8b) :: Hmf
  real(r8b) :: mu
  real(r8b) :: Tdum
  type(gadget_constants_type) :: gconst

  do i = 1,size(psys%par)

#ifdef incHmf
     Hmf = psys%par(i)%Hmf
#else
     
     Hmf = dfltH_mf    

#endif

     mu = 4.0d0 / (3.0d0 * Hmf + 1.0d0 + 4.0d0 * Hmf * psys%par(i)%ye)

     ! CAFG: artificially 'correct' abnormally large values, which are
     ! producing floating overflow
     if (psys%par(i)%T .GT. 1000000000.0d0) psys%par(i)%T = 1000.0d0

     Tdum = mu * gconst%PROTONMASS / gconst%BOLTZMANN * (gconst%GAMMA - 1.0d0) * psys%par(i)%T
     psys%par(i)%T = Tdum * cgs_enrg / cgs_mass

  end do


end subroutine set_temp_from_u_vbromm


end module gadget_vbromm_input_mod

! subroutine to start thread in fortran
! arguments: actie: action to be taken,
! 	    
!
! pt_setup is a setup routine (eg to copy data to buffer)
! viewbodies is the actual sub-program
!
! needs pt lib
	subroutine fthread(actie)
	implicit none
	character(len=5),intent(in) ::  actie
	external pipeline_init__,pipeline_done__,pipeline_execute__
	external pt_setup, viewbodies

	select case( actie)

	case('setup')
	call pipeline_init_(pt_setup, viewbodies)
	write(*,*) 
	write(*,*), 'setup thread'
	write(*,*) 

	case('execu')
	call pipeline_execute_()
	write(*,*) 
	write(*,*), 'execute thread'
	write(*,*) 

	case('tstop')
	call pipeline_done_()
	write(*,*) 
	write(*,*) 'stop thread'
	write(*,*) 

	case default
	write(*,*) '<fthread> input error'
	
	end select

	return

	end
	
	SUBROUTINE viewer
	LOGICAL initcall
	DATA initcall/.TRUE./
	SAVE initcall
	
	IF(initcall) THEN
!	CALL fthread('setup',viewbodies)
!	CALL fthread('execu',viewbodies)
	CALL fthread('setup')
	CALL fthread('execu')
	initcall=.FALSE.
	ELSE
!	call fthread('tstop',viewbodies)
	call fthread('tstop')
	ENDIF
	
	END

!> \file ion_temperature_update.F90

!> \brief Module that is the starting point for ionization
!! and temperature updates.  It calls a runge kutta or a 
!! backwards difference formula (depending on the Makefile
!! flags)  
!<
module ion_temperature_update
use myf03_mod
use physical_constants_mod
use ray_mod
use raylist_mod



! routines
use ionpar_mod, only: initialize_ionpar, initialize_non_photo_ionpar, &
                      ionpar2par, ionpar2screen, check_x




! types
use ionpar_mod, only: ionpart_type

use particle_system_mod, only: particle_system_type
use particle_system_mod, only: particle_type
use particle_system_mod, only: box_type
use oct_tree_mod, only: oct_tree_type
use spectra_mod, only: rn2freq
use euler_mod, only: eulerint, recombeulerint
use bdf_mod, only: bdfint
use atomic_rates_mod, only: get_atomic_rates
use global_mod, only: GV, saved_gheads, rtable
implicit none

private
public :: update_raylist
public :: non_photo_update_all
 
contains


!> sets the logicals that can be determined from global variables
!!-----------------------------------------------------------------
subroutine set_bools( He, caseA, isoT, fixT )
  logical, intent(out) :: He
  logical, intent(out) :: caseA(2)
  logical, intent(out) :: isoT
  logical, intent(out) :: fixT

#ifdef incHe
  He = .true.
#else
  He = .false.
#endif

  caseA = .false.
  if (GV%HydrogenCaseA) caseA(1) = .true.
  if (GV%HeliumCaseA)   caseA(2) = .true.

  if (GV%IsoTemp > 0.0) then
     isoT = .true.
  else
     isoT = .false.
  end if

  if (GV%FixSnapTemp) then
     fixT = .true.
  else
     fixT = .false.
  end if

end subroutine set_bools



!> updates the particles intersected by a ray 
!!-----------------------------------------------------------------
subroutine update_raylist(raylist, pars, box, srcray)

  type(raylist_type), intent(inout) :: raylist !< ray/particle intersections
  type(particle_type), intent(inout) :: pars(:)  !< particle system
  type(box_type), intent(in) :: box  !< particle system
  logical, intent(in) :: srcray !< is this update for a source ray?

  type(particle_type) :: par
  type(ionpart_type) :: ipar
  integer(i8b) :: impact  
  integer(i8b) :: scalls  ! number of calls to solver
  logical :: photo
  logical :: He
  logical :: caseA(2)
  logical :: isoT
  logical :: fixT
  integer(i8b) :: index


  ! set booleans
  !-------------------------------------------------------
  call set_bools( He, caseA, isoT, fixT )
  photo = .true.

  
  ! loop through the ray particle intersections
  !-------------------------------------------------------
  impact_loop: do impact = 1,raylist%nnb

     GV%ParticleCrossings = GV%ParticleCrossings + 1     
     index = raylist%intersection(impact)%pindx
     par = pars(index)


     ! check we dont have double intersections when we shouldn't
     !-------------------------------------------------------------
     if (srcray) then
        if (box%tbound(1)==1 .and. GV%itime == par%lasthit) then
           ! here we have periodic BCs and a particle has been hit
           ! twice by the same ray so we stop tracing 
           GV%PhotonsLeavingBox = GV%PhotonsLeavingBox + raylist%ray%pcnt
           raylist%lastnnb = impact-1
           exit
        else if (box%tbound(1)==0 .and. GV%itime == par%lasthit) then
           ! here we have transmissive BCs and a particle has been hit
           ! twice by the same ray so something is wrong
           write(*,*) "transmissive BCs and particle hit twice in one ray!"
           write(*,*) "impact  = ", impact
           ipar%strtag = "check boundary conditions"
           call ionpar2screen(ipar)
           stop
        end if
     end if


     ! transfer psys par into an ionization par
     !-------------------------------------------------------------
     call initialize_ionpar(ipar,par,index,srcray,He,raylist,impact)


     ! send through the correct solver
     !-------------------------------------------------------------
     if (srcray) then
        if (GV%IonTempSolver==1) then
           call eulerint(ipar,scalls,photo,caseA,He,isoT,fixT)
           ipar%strtag = "on_eulerint_output"
        else if (GV%IonTempSolver==2) then
           call bdfint(ipar,scalls,photo,caseA,He,isoT,fixT)
           ipar%strtag = "on_bdfint_output"
        end if
     else
        call recombeulerint(ipar,scalls)
        ipar%strtag = "on_recombeulerint_output"
     end if
     call check_x(ipar)


     ! update some tracking variables
     !-------------------------------------------------------------
     raylist%lastnnb = impact

     GV%TotalDerivativeCalls = GV%TotalDerivativeCalls + scalls
     if (scalls .GT. GV%PeakUpdates) GV%PeakUpdates = scalls


     !  calculate momentum transfer
     !=================================================
#ifdef incVel
     if(GV%DoMomentumKicks) then
       ipar%vel =  ipar%vel + (ipar%pdeps* (ipar%penrg / c) / ( ipar%mass * GV%cgs_mass ) * &
                  raylist%ray%dir ) / GV%cgs_vel
     endif

#endif

     !  put the updated particle data into the particle system
     !===========================================================
     call ionpar2par(ipar,par)
     if ( par%T < GV%Tfloor ) par%T = GV%Tfloor

#ifdef outGammaHI
     par%gammaHI = pars(ipar%index)%gammaHI + ipar%gammaHI * ipar%dt_s
     par%time    = pars(ipar%index)%time + ipar%dt_s
#endif

     pars(ipar%index) = par

     if (srcray) then
        pars(ipar%index)%lasthit = GV%itime 
     end if


     !  use the solution to set some global variables
     !=================================================
     GV%TotalPhotonsAbsorbed = GV%TotalPhotonsAbsorbed + ipar%pdeps
     GV%TotalIonizations     = GV%TotalIonizations + &
                               (ipar%xHII - ipar%xHII_in) * ipar%Hcnt
#ifdef incHe
     GV%TotalIonizations     = GV%TotalIonizations + &
                               (ipar%xHeII - ipar%xHeII_in) * ipar%Hecnt     
     GV%TotalIonizations     = GV%TotalIonizations + &
                               (ipar%xHeIII - ipar%xHeIII_in) * ipar%Hecnt     
#endif





     ! if the particle satisfies the rec ray tol put it on the recomb list
     !=====================================================================
#ifdef incHrec
     if (srcray) then
        if (.not. pars(ipar%indx)%OnRecList) then
           if (pars(ipar%indx)%xHIIrc > GV%RecRayTol) then
              pars(ipar%indx)%OnRecList = .true.
              GV%recpt = GV%recpt + 1
              reclist(GV%recpt) = ipar%indx
           end if
        end if
     end if
#endif
     
     
     
     !  determine if we move to the next particle and track some ray stats
     !=====================================================================

     if (GV%RayDepletion) then
        raylist%ray%pcnt = raylist%ray%pcnt - ipar%pdeps
     endif
     
     
     ! if photons are exhausted
     !-------------------------------
     if (raylist%ray%pini > 0.0) then
        if (raylist%ray%pcnt / raylist%ray%pini < GV%RayPhotonTol) then
           exit
        end if
     end if
     
     ! if vacuum BCs and exiting box
     !-------------------------------
     if(box%tbound(1)==0) then
        if(impact==raylist%nnb) then
           GV%PhotonsLeavingBox = GV%PhotonsLeavingBox + raylist%ray%pcnt
        end if
     end if

     
  end do impact_loop

!  stop "finished impact loop"

end subroutine update_raylist






!> updates all particles not hit by a ray 
!!-----------------------------------------------------------------
subroutine non_photo_update_all(pars)

  type(particle_type), intent(inout) :: pars(:)  !< particle system

  type(particle_type) :: par
  type(ionpart_type) :: ipar
  integer(i8b) :: ipart  
  integer(i8b) :: scalls  ! number of calls to solver
  logical :: photo
  logical :: He
  logical :: caseA(2)
  logical :: isoT
  logical :: fixT
  integer(i8b) :: index


  ! set booleans
  !-------------------------------------------------------
  call set_bools( He, caseA, isoT, fixT )
  photo = .false.

  
  ! loop through all particles
  !-------------------------------------------------------
  particle_loop: do ipart = 1, size(pars)

     index = ipart
     par = pars(index)

     call initialize_non_photo_ionpar(ipar,par,index,He)

     if (GV%IonTempSolver==1) then
        call eulerint(ipar,scalls,photo,caseA,He,isoT,fixT)
        ipar%strtag = "on_eulerint_output"
     else if (GV%IonTempSolver==2) then
        call bdfint(ipar,scalls,photo,caseA,He,isoT,fixT)
        ipar%strtag = "on_bdfint_output"
     end if
     call check_x(ipar)

     GV%TotalDerivativeCalls = GV%TotalDerivativeCalls + scalls
     if (scalls .GT. GV%PeakUpdates) GV%PeakUpdates = scalls


     !  put the updated particle data into the particle system
     !===========================================================
     call ionpar2par(ipar,par)
     if (par%T < GV%Tfloor) par%T = GV%Tfloor

     pars(ipar%index) = par

     pars(ipar%index)%lasthit = GV%itime 
    


     !  use the solution to set some global variables
     !=================================================
     GV%TotalIonizations     = GV%TotalIonizations + &
                               (ipar%xHII - ipar%xHII_in) * ipar%Hcnt
#ifdef incHe
     GV%TotalIonizations     = GV%TotalIonizations + &
                               (ipar%xHeII - ipar%xHeII_in) * ipar%Hecnt     
     GV%TotalIonizations     = GV%TotalIonizations + &
                               (ipar%xHeIII - ipar%xHeIII_in) * ipar%Hecnt     
#endif


     ! if the particle satisfies the rec ray tol put it on the recomb list
     !=====================================================================
#ifdef incHrec
     if (.not. pars(ipar%indx)%OnRecList) then
        if (pars(ipar%indx)%xHIIrc > GV%RecRayTol) then
           pars(ipar%indx)%OnRecList = .true.
           GV%recpt = GV%recpt + 1
           reclist(GV%recpt) = ipar%indx
        end if
     end if
#endif
     
     
         
  end do particle_loop

!  stop "finished impact loop"

end subroutine non_photo_update_all









end module ion_temperature_update

MODULE OpenGL_kinds
USE, INTRINSIC :: ISO_C_BINDING
IMPLICIT NONE
PUBLIC

! Kind parameters
! Integer types:
INTEGER, PARAMETER :: GLbyte=C_SIGNED_CHAR, GLshort=C_SHORT,            &
    GLint=C_INT, GLsizei=C_INT, GLboolean=C_SIGNED_CHAR, GLenum=C_INT,  &
    GLbitfield=C_INT, GLcint=C_INT, GLubyte=C_SIGNED_CHAR, &
    GLushort=C_SHORT, GLuint=C_INT
! Real types:
INTEGER, PARAMETER :: GLdouble=C_DOUBLE, GLfloat=C_FLOAT, GLclampf=C_FLOAT, &
    GLclampd=C_DOUBLE

END MODULE OpenGL_kinds
MODULE OpenGL_GL
USE, INTRINSIC :: ISO_C_BINDING
USE OpenGL_kinds
IMPLICIT NONE
PUBLIC


!  Version values
INTEGER(GLenum), PARAMETER :: GL_VERSION_1_1=1
INTEGER(GLenum), PARAMETER :: GL_VERSION_1_2=1

!  AccumOp values
INTEGER(GLenum), PARAMETER :: GL_ACCUM                 = z'0100' ! 0x0100
INTEGER(GLenum), PARAMETER :: GL_LOAD                  = z'0101' ! 0x0101
INTEGER(GLenum), PARAMETER :: GL_RETURN                = z'0102' ! 0x0102
INTEGER(GLenum), PARAMETER :: GL_MULT                  = z'0103' ! 0x0103
INTEGER(GLenum), PARAMETER :: GL_ADD                   = z'0104' ! 0x0104
!  AlphaFunction values
INTEGER(GLenum), PARAMETER :: GL_NEVER                 = z'0200' ! 0x0200
INTEGER(GLenum), PARAMETER :: GL_LESS                  = z'0201' ! 0x0201
INTEGER(GLenum), PARAMETER :: GL_EQUAL                 = z'0202' ! 0x0202
INTEGER(GLenum), PARAMETER :: GL_LEQUAL                = z'0203' ! 0x0203
INTEGER(GLenum), PARAMETER :: GL_GREATER               = z'0204' ! 0x0204
INTEGER(GLenum), PARAMETER :: GL_NOTEQUAL              = z'0205' ! 0x0205
INTEGER(GLenum), PARAMETER :: GL_GEQUAL                = z'0206' ! 0x0206
INTEGER(GLenum), PARAMETER :: GL_ALWAYS                = z'0207' ! 0x0207
!  AttribMask values
INTEGER(GLbitfield), PARAMETER :: GL_CURRENT_BIT           = z'00000001' ! 0x00000001
INTEGER(GLbitfield), PARAMETER :: GL_POINT_BIT             = z'00000002' ! 0x00000002
INTEGER(GLbitfield), PARAMETER :: GL_LINE_BIT              = z'00000004' ! 0x00000004
INTEGER(GLbitfield), PARAMETER :: GL_POLYGON_BIT           = z'00000008' ! 0x00000008
INTEGER(GLbitfield), PARAMETER :: GL_POLYGON_STIPPLE_BIT   = z'00000010' ! 0x00000010
INTEGER(GLbitfield), PARAMETER :: GL_PIXEL_MODE_BIT        = z'00000020' ! 0x00000020
INTEGER(GLbitfield), PARAMETER :: GL_LIGHTING_BIT          = z'00000040' ! 0x00000040
INTEGER(GLbitfield), PARAMETER :: GL_FOG_BIT               = z'00000080' ! 0x00000080
INTEGER(GLbitfield), PARAMETER :: GL_DEPTH_BUFFER_BIT      = z'00000100' ! 0x00000100
INTEGER(GLbitfield), PARAMETER :: GL_ACCUM_BUFFER_BIT      = z'00000200' ! 0x00000200
INTEGER(GLbitfield), PARAMETER :: GL_STENCIL_BUFFER_BIT    = z'00000400' ! 0x00000400
INTEGER(GLbitfield), PARAMETER :: GL_VIEWPORT_BIT          = z'00000800' ! 0x00000800
INTEGER(GLbitfield), PARAMETER :: GL_TRANSFORM_BIT         = z'00001000' ! 0x00001000
INTEGER(GLbitfield), PARAMETER :: GL_ENABLE_BIT            = z'00002000' ! 0x00002000
INTEGER(GLbitfield), PARAMETER :: GL_COLOR_BUFFER_BIT      = z'00004000' ! 0x00004000
INTEGER(GLbitfield), PARAMETER :: GL_HINT_BIT              = z'00008000' ! 0x00008000
INTEGER(GLbitfield), PARAMETER :: GL_EVAL_BIT              = z'00010000' ! 0x00010000
INTEGER(GLbitfield), PARAMETER :: GL_LIST_BIT              = z'00020000' ! 0x00020000
INTEGER(GLbitfield), PARAMETER :: GL_TEXTURE_BIT           = z'00040000' ! 0x00040000
INTEGER(GLbitfield), PARAMETER :: GL_SCISSOR_BIT           = z'00080000' ! 0x00080000
INTEGER(GLbitfield), PARAMETER :: GL_ALL_ATTRIB_BITS       = z'000fffff' ! 0x000fffff
!  BeginMode values
INTEGER(GLenum), PARAMETER :: GL_POINTS                = z'0000' ! 0x0000
INTEGER(GLenum), PARAMETER :: GL_LINES                 = z'0001' ! 0x0001
INTEGER(GLenum), PARAMETER :: GL_LINE_LOOP             = z'0002' ! 0x0002
INTEGER(GLenum), PARAMETER :: GL_LINE_STRIP            = z'0003' ! 0x0003
INTEGER(GLenum), PARAMETER :: GL_TRIANGLES             = z'0004' ! 0x0004
INTEGER(GLenum), PARAMETER :: GL_TRIANGLE_STRIP        = z'0005' ! 0x0005
INTEGER(GLenum), PARAMETER :: GL_TRIANGLE_FAN          = z'0006' ! 0x0006
INTEGER(GLenum), PARAMETER :: GL_QUADS                 = z'0007' ! 0x0007
INTEGER(GLenum), PARAMETER :: GL_QUAD_STRIP            = z'0008' ! 0x0008
INTEGER(GLenum), PARAMETER :: GL_POLYGON               = z'0009' ! 0x0009
!  BlendEquationMode values
!  BlendingFactorDest values
INTEGER(GLenum), PARAMETER :: GL_ZERO                  = 0 ! 0
INTEGER(GLenum), PARAMETER :: GL_ONE                   = 1 ! 1
INTEGER(GLenum), PARAMETER :: GL_SRC_COLOR             = z'0300' ! 0x0300
INTEGER(GLenum), PARAMETER :: GL_ONE_MINUS_SRC_COLOR   = z'0301' ! 0x0301
INTEGER(GLenum), PARAMETER :: GL_SRC_ALPHA             = z'0302' ! 0x0302
INTEGER(GLenum), PARAMETER :: GL_ONE_MINUS_SRC_ALPHA   = z'0303' ! 0x0303
INTEGER(GLenum), PARAMETER :: GL_DST_ALPHA             = z'0304' ! 0x0304
INTEGER(GLenum), PARAMETER :: GL_ONE_MINUS_DST_ALPHA   = z'0305' ! 0x0305
!  BlendingFactorSrc values
INTEGER(GLenum), PARAMETER :: GL_DST_COLOR             = z'0306' ! 0x0306
INTEGER(GLenum), PARAMETER :: GL_ONE_MINUS_DST_COLOR   = z'0307' ! 0x0307
INTEGER(GLenum), PARAMETER :: GL_SRC_ALPHA_SATURATE    = z'0308' ! 0x0308
!  Boolean values
INTEGER(GLboolean), PARAMETER :: GL_TRUE                  = 1 ! 1
INTEGER(GLboolean), PARAMETER :: GL_FALSE                 = 0 ! 0
!  ClearBufferMask values
!  ClientArrayType values
!  ClipPlaneName values
INTEGER(GLenum), PARAMETER :: GL_CLIP_PLANE0           = z'3000' ! 0x3000
INTEGER(GLenum), PARAMETER :: GL_CLIP_PLANE1           = z'3001' ! 0x3001
INTEGER(GLenum), PARAMETER :: GL_CLIP_PLANE2           = z'3002' ! 0x3002
INTEGER(GLenum), PARAMETER :: GL_CLIP_PLANE3           = z'3003' ! 0x3003
INTEGER(GLenum), PARAMETER :: GL_CLIP_PLANE4           = z'3004' ! 0x3004
INTEGER(GLenum), PARAMETER :: GL_CLIP_PLANE5           = z'3005' ! 0x3005
!  ColorMaterialFace values
!  ColorMaterialParameter values
!  ColorPointerType values
!  ColorTableParameterPName values
!  ColorTableTarget values
!  ConvolutionBorderMode values
!  ConvolutionParameter values
!  ConvolutionTarget values
!  CullFaceMode values
!  DataType values
INTEGER(GLenum), PARAMETER :: GL_BYTE                  = z'1400' ! 0x1400
INTEGER(GLenum), PARAMETER :: GL_UNSIGNED_BYTE         = z'1401' ! 0x1401
INTEGER(GLenum), PARAMETER :: GL_SHORT                 = z'1402' ! 0x1402
INTEGER(GLenum), PARAMETER :: GL_UNSIGNED_SHORT        = z'1403' ! 0x1403
INTEGER(GLenum), PARAMETER :: GL_INT                   = z'1404' ! 0x1404
INTEGER(GLenum), PARAMETER :: GL_UNSIGNED_INT          = z'1405' ! 0x1405
INTEGER(GLenum), PARAMETER :: GL_FLOAT                 = z'1406' ! 0x1406
INTEGER(GLenum), PARAMETER :: GL_2_BYTES               = z'1407' ! 0x1407
INTEGER(GLenum), PARAMETER :: GL_3_BYTES               = z'1408' ! 0x1408
INTEGER(GLenum), PARAMETER :: GL_4_BYTES               = z'1409' ! 0x1409
INTEGER(GLenum), PARAMETER :: GL_DOUBLE                = z'140A' ! 0x140A
!  DepthFunction values
!  DrawBufferMode values
INTEGER(GLenum), PARAMETER :: GL_NONE                  = 0 ! 0
INTEGER(GLenum), PARAMETER :: GL_FRONT_LEFT            = z'0400' ! 0x0400
INTEGER(GLenum), PARAMETER :: GL_FRONT_RIGHT           = z'0401' ! 0x0401
INTEGER(GLenum), PARAMETER :: GL_BACK_LEFT             = z'0402' ! 0x0402
INTEGER(GLenum), PARAMETER :: GL_BACK_RIGHT            = z'0403' ! 0x0403
INTEGER(GLenum), PARAMETER :: GL_FRONT                 = z'0404' ! 0x0404
INTEGER(GLenum), PARAMETER :: GL_BACK                  = z'0405' ! 0x0405
INTEGER(GLenum), PARAMETER :: GL_LEFT                  = z'0406' ! 0x0406
INTEGER(GLenum), PARAMETER :: GL_RIGHT                 = z'0407' ! 0x0407
INTEGER(GLenum), PARAMETER :: GL_FRONT_AND_BACK        = z'0408' ! 0x0408
INTEGER(GLenum), PARAMETER :: GL_AUX0                  = z'0409' ! 0x0409
INTEGER(GLenum), PARAMETER :: GL_AUX1                  = z'040A' ! 0x040A
INTEGER(GLenum), PARAMETER :: GL_AUX2                  = z'040B' ! 0x040B
INTEGER(GLenum), PARAMETER :: GL_AUX3                  = z'040C' ! 0x040C
!  Enable values
!  ErrorCode values
INTEGER(GLenum), PARAMETER :: GL_NO_ERROR              = 0 ! 0
INTEGER(GLenum), PARAMETER :: GL_INVALID_ENUM          = z'0500' ! 0x0500
INTEGER(GLenum), PARAMETER :: GL_INVALID_VALUE         = z'0501' ! 0x0501
INTEGER(GLenum), PARAMETER :: GL_INVALID_OPERATION     = z'0502' ! 0x0502
INTEGER(GLenum), PARAMETER :: GL_STACK_OVERFLOW        = z'0503' ! 0x0503
INTEGER(GLenum), PARAMETER :: GL_STACK_UNDERFLOW       = z'0504' ! 0x0504
INTEGER(GLenum), PARAMETER :: GL_OUT_OF_MEMORY         = z'0505' ! 0x0505
!  FeedBackMode values
INTEGER(GLenum), PARAMETER :: GL_2D                    = z'0600' ! 0x0600
INTEGER(GLenum), PARAMETER :: GL_3D                    = z'0601' ! 0x0601
INTEGER(GLenum), PARAMETER :: GL_3D_COLOR              = z'0602' ! 0x0602
INTEGER(GLenum), PARAMETER :: GL_3D_COLOR_TEXTURE      = z'0603' ! 0x0603
INTEGER(GLenum), PARAMETER :: GL_4D_COLOR_TEXTURE      = z'0604' ! 0x0604
!  FeedBackToken values
REAL(GLfloat), PARAMETER :: GL_PASS_THROUGH_TOKEN    = transfer(1792,1.0) ! 0x0700
REAL(GLfloat), PARAMETER :: GL_POINT_TOKEN           = transfer(1793,1.0) ! 0x0701
REAL(GLfloat), PARAMETER :: GL_LINE_TOKEN            = transfer(1794,1.0) ! 0x0702
REAL(GLfloat), PARAMETER :: GL_POLYGON_TOKEN         = transfer(1795,1.0) ! 0x0703
REAL(GLfloat), PARAMETER :: GL_BITMAP_TOKEN          = transfer(1796,1.0) ! 0x0704
REAL(GLfloat), PARAMETER :: GL_DRAW_PIXEL_TOKEN      = transfer(1797,1.0) ! 0x0705
REAL(GLfloat), PARAMETER :: GL_COPY_PIXEL_TOKEN      = transfer(1798,1.0) ! 0x0706
REAL(GLfloat), PARAMETER :: GL_LINE_RESET_TOKEN      = transfer(1799,1.0) ! 0x0707
!  FogMode values
INTEGER(GLenum), PARAMETER :: GL_EXP                   = z'0800' ! 0x0800
INTEGER(GLenum), PARAMETER :: GL_EXP2                  = z'0801' ! 0x0801
!  FogParameter values
!  FrontFaceDirection values
INTEGER(GLenum), PARAMETER :: GL_CW                    = z'0900' ! 0x0900
INTEGER(GLenum), PARAMETER :: GL_CCW                   = z'0901' ! 0x0901
!  GetColorTableParameterPName values
!  GetConvolutionParameterPName values
!  GetHistogramParameterPName values
!  GetMapTarget values
INTEGER(GLenum), PARAMETER :: GL_COEFF                 = z'0A00' ! 0x0A00
INTEGER(GLenum), PARAMETER :: GL_ORDER                 = z'0A01' ! 0x0A01
INTEGER(GLenum), PARAMETER :: GL_DOMAIN                = z'0A02' ! 0x0A02
!  GetMinmaxParameterPName values
!  GetPixelMap values
!  GetPointerTarget values
!  GetTarget values
INTEGER(GLenum), PARAMETER :: GL_CURRENT_COLOR         = z'0B00' ! 0x0B00
INTEGER(GLenum), PARAMETER :: GL_CURRENT_INDEX         = z'0B01' ! 0x0B01
INTEGER(GLenum), PARAMETER :: GL_CURRENT_NORMAL        = z'0B02' ! 0x0B02
INTEGER(GLenum), PARAMETER :: GL_CURRENT_TEXTURE_COORDS = z'0B03' ! 0x0B03
INTEGER(GLenum), PARAMETER :: GL_CURRENT_RASTER_COLOR  = z'0B04' ! 0x0B04
INTEGER(GLenum), PARAMETER :: GL_CURRENT_RASTER_INDEX  = z'0B05' ! 0x0B05
INTEGER(GLenum), PARAMETER :: GL_CURRENT_RASTER_TEXTURE_COORDS = z'0B06' ! 0x0B06
INTEGER(GLenum), PARAMETER :: GL_CURRENT_RASTER_POSITION = z'0B07' ! 0x0B07
INTEGER(GLenum), PARAMETER :: GL_CURRENT_RASTER_POSITION_VALID = z'0B08' ! 0x0B08
INTEGER(GLenum), PARAMETER :: GL_CURRENT_RASTER_DISTANCE = z'0B09' ! 0x0B09
INTEGER(GLenum), PARAMETER :: GL_POINT_SMOOTH          = z'0B10' ! 0x0B10
INTEGER(GLenum), PARAMETER :: GL_POINT_SIZE            = z'0B11' ! 0x0B11
INTEGER(GLenum), PARAMETER :: GL_POINT_SIZE_RANGE      = z'0B12' ! 0x0B12
INTEGER(GLenum), PARAMETER :: GL_POINT_SIZE_GRANULARITY = z'0B13' ! 0x0B13
INTEGER(GLenum), PARAMETER :: GL_LINE_SMOOTH           = z'0B20' ! 0x0B20
INTEGER(GLenum), PARAMETER :: GL_LINE_WIDTH            = z'0B21' ! 0x0B21
INTEGER(GLenum), PARAMETER :: GL_LINE_WIDTH_RANGE      = z'0B22' ! 0x0B22
INTEGER(GLenum), PARAMETER :: GL_LINE_WIDTH_GRANULARITY = z'0B23' ! 0x0B23
INTEGER(GLenum), PARAMETER :: GL_LINE_STIPPLE          = z'0B24' ! 0x0B24
INTEGER(GLenum), PARAMETER :: GL_LINE_STIPPLE_PATTERN  = z'0B25' ! 0x0B25
INTEGER(GLenum), PARAMETER :: GL_LINE_STIPPLE_REPEAT   = z'0B26' ! 0x0B26
INTEGER(GLenum), PARAMETER :: GL_LIST_MODE             = z'0B30' ! 0x0B30
INTEGER(GLenum), PARAMETER :: GL_MAX_LIST_NESTING      = z'0B31' ! 0x0B31
INTEGER(GLenum), PARAMETER :: GL_LIST_BASE             = z'0B32' ! 0x0B32
INTEGER(GLenum), PARAMETER :: GL_LIST_INDEX            = z'0B33' ! 0x0B33
INTEGER(GLenum), PARAMETER :: GL_POLYGON_MODE          = z'0B40' ! 0x0B40
INTEGER(GLenum), PARAMETER :: GL_POLYGON_SMOOTH        = z'0B41' ! 0x0B41
INTEGER(GLenum), PARAMETER :: GL_POLYGON_STIPPLE       = z'0B42' ! 0x0B42
INTEGER(GLenum), PARAMETER :: GL_EDGE_FLAG             = z'0B43' ! 0x0B43
INTEGER(GLenum), PARAMETER :: GL_CULL_FACE             = z'0B44' ! 0x0B44
INTEGER(GLenum), PARAMETER :: GL_CULL_FACE_MODE        = z'0B45' ! 0x0B45
INTEGER(GLenum), PARAMETER :: GL_FRONT_FACE            = z'0B46' ! 0x0B46
INTEGER(GLenum), PARAMETER :: GL_LIGHTING              = z'0B50' ! 0x0B50
INTEGER(GLenum), PARAMETER :: GL_LIGHT_MODEL_LOCAL_VIEWER = z'0B51' ! 0x0B51
INTEGER(GLenum), PARAMETER :: GL_LIGHT_MODEL_TWO_SIDE  = z'0B52' ! 0x0B52
INTEGER(GLenum), PARAMETER :: GL_LIGHT_MODEL_AMBIENT   = z'0B53' ! 0x0B53
INTEGER(GLenum), PARAMETER :: GL_SHADE_MODEL           = z'0B54' ! 0x0B54
INTEGER(GLenum), PARAMETER :: GL_COLOR_MATERIAL_FACE   = z'0B55' ! 0x0B55
INTEGER(GLenum), PARAMETER :: GL_COLOR_MATERIAL_PARAMETER = z'0B56' ! 0x0B56
INTEGER(GLenum), PARAMETER :: GL_COLOR_MATERIAL        = z'0B57' ! 0x0B57
INTEGER(GLenum), PARAMETER :: GL_FOG                   = z'0B60' ! 0x0B60
INTEGER(GLenum), PARAMETER :: GL_FOG_INDEX             = z'0B61' ! 0x0B61
INTEGER(GLenum), PARAMETER :: GL_FOG_DENSITY           = z'0B62' ! 0x0B62
INTEGER(GLenum), PARAMETER :: GL_FOG_START             = z'0B63' ! 0x0B63
INTEGER(GLenum), PARAMETER :: GL_FOG_END               = z'0B64' ! 0x0B64
INTEGER(GLenum), PARAMETER :: GL_FOG_MODE              = z'0B65' ! 0x0B65
INTEGER(GLenum), PARAMETER :: GL_FOG_COLOR             = z'0B66' ! 0x0B66
INTEGER(GLenum), PARAMETER :: GL_DEPTH_RANGE           = z'0B70' ! 0x0B70
INTEGER(GLenum), PARAMETER :: GL_DEPTH_TEST            = z'0B71' ! 0x0B71
INTEGER(GLenum), PARAMETER :: GL_DEPTH_WRITEMASK       = z'0B72' ! 0x0B72
INTEGER(GLenum), PARAMETER :: GL_DEPTH_CLEAR_VALUE     = z'0B73' ! 0x0B73
INTEGER(GLenum), PARAMETER :: GL_DEPTH_FUNC            = z'0B74' ! 0x0B74
INTEGER(GLenum), PARAMETER :: GL_ACCUM_CLEAR_VALUE     = z'0B80' ! 0x0B80
INTEGER(GLenum), PARAMETER :: GL_STENCIL_TEST          = z'0B90' ! 0x0B90
INTEGER(GLenum), PARAMETER :: GL_STENCIL_CLEAR_VALUE   = z'0B91' ! 0x0B91
INTEGER(GLenum), PARAMETER :: GL_STENCIL_FUNC          = z'0B92' ! 0x0B92
INTEGER(GLenum), PARAMETER :: GL_STENCIL_VALUE_MASK    = z'0B93' ! 0x0B93
INTEGER(GLenum), PARAMETER :: GL_STENCIL_FAIL          = z'0B94' ! 0x0B94
INTEGER(GLenum), PARAMETER :: GL_STENCIL_PASS_DEPTH_FAIL = z'0B95' ! 0x0B95
INTEGER(GLenum), PARAMETER :: GL_STENCIL_PASS_DEPTH_PASS = z'0B96' ! 0x0B96
INTEGER(GLenum), PARAMETER :: GL_STENCIL_REF           = z'0B97' ! 0x0B97
INTEGER(GLenum), PARAMETER :: GL_STENCIL_WRITEMASK     = z'0B98' ! 0x0B98
INTEGER(GLenum), PARAMETER :: GL_MATRIX_MODE           = z'0BA0' ! 0x0BA0
INTEGER(GLenum), PARAMETER :: GL_NORMALIZE             = z'0BA1' ! 0x0BA1
INTEGER(GLenum), PARAMETER :: GL_VIEWPORT              = z'0BA2' ! 0x0BA2
INTEGER(GLenum), PARAMETER :: GL_MODELVIEW_STACK_DEPTH = z'0BA3' ! 0x0BA3
INTEGER(GLenum), PARAMETER :: GL_PROJECTION_STACK_DEPTH = z'0BA4' ! 0x0BA4
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_STACK_DEPTH   = z'0BA5' ! 0x0BA5
INTEGER(GLenum), PARAMETER :: GL_MODELVIEW_MATRIX      = z'0BA6' ! 0x0BA6
INTEGER(GLenum), PARAMETER :: GL_PROJECTION_MATRIX     = z'0BA7' ! 0x0BA7
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_MATRIX        = z'0BA8' ! 0x0BA8
INTEGER(GLenum), PARAMETER :: GL_ATTRIB_STACK_DEPTH    = z'0BB0' ! 0x0BB0
INTEGER(GLenum), PARAMETER :: GL_CLIENT_ATTRIB_STACK_DEPTH = z'0BB1' ! 0x0BB1
INTEGER(GLenum), PARAMETER :: GL_ALPHA_TEST            = z'0BC0' ! 0x0BC0
INTEGER(GLenum), PARAMETER :: GL_ALPHA_TEST_FUNC       = z'0BC1' ! 0x0BC1
INTEGER(GLenum), PARAMETER :: GL_ALPHA_TEST_REF        = z'0BC2' ! 0x0BC2
INTEGER(GLenum), PARAMETER :: GL_DITHER                = z'0BD0' ! 0x0BD0
INTEGER(GLenum), PARAMETER :: GL_BLEND_DST             = z'0BE0' ! 0x0BE0
INTEGER(GLenum), PARAMETER :: GL_BLEND_SRC             = z'0BE1' ! 0x0BE1
INTEGER(GLenum), PARAMETER :: GL_BLEND                 = z'0BE2' ! 0x0BE2
INTEGER(GLenum), PARAMETER :: GL_LOGIC_OP_MODE         = z'0BF0' ! 0x0BF0
INTEGER(GLenum), PARAMETER :: GL_INDEX_LOGIC_OP        = z'0BF1' ! 0x0BF1
INTEGER(GLenum), PARAMETER :: GL_COLOR_LOGIC_OP        = z'0BF2' ! 0x0BF2
INTEGER(GLenum), PARAMETER :: GL_AUX_BUFFERS           = z'0C00' ! 0x0C00
INTEGER(GLenum), PARAMETER :: GL_DRAW_BUFFER           = z'0C01' ! 0x0C01
INTEGER(GLenum), PARAMETER :: GL_READ_BUFFER           = z'0C02' ! 0x0C02
INTEGER(GLenum), PARAMETER :: GL_SCISSOR_BOX           = z'0C10' ! 0x0C10
INTEGER(GLenum), PARAMETER :: GL_SCISSOR_TEST          = z'0C11' ! 0x0C11
INTEGER(GLenum), PARAMETER :: GL_INDEX_CLEAR_VALUE     = z'0C20' ! 0x0C20
INTEGER(GLenum), PARAMETER :: GL_INDEX_WRITEMASK       = z'0C21' ! 0x0C21
INTEGER(GLenum), PARAMETER :: GL_COLOR_CLEAR_VALUE     = z'0C22' ! 0x0C22
INTEGER(GLenum), PARAMETER :: GL_COLOR_WRITEMASK       = z'0C23' ! 0x0C23
INTEGER(GLenum), PARAMETER :: GL_INDEX_MODE            = z'0C30' ! 0x0C30
INTEGER(GLenum), PARAMETER :: GL_RGBA_MODE             = z'0C31' ! 0x0C31
INTEGER(GLenum), PARAMETER :: GL_DOUBLEBUFFER          = z'0C32' ! 0x0C32
INTEGER(GLenum), PARAMETER :: GL_STEREO                = z'0C33' ! 0x0C33
INTEGER(GLenum), PARAMETER :: GL_RENDER_MODE           = z'0C40' ! 0x0C40
INTEGER(GLenum), PARAMETER :: GL_PERSPECTIVE_CORRECTION_HINT = z'0C50' ! 0x0C50
INTEGER(GLenum), PARAMETER :: GL_POINT_SMOOTH_HINT     = z'0C51' ! 0x0C51
INTEGER(GLenum), PARAMETER :: GL_LINE_SMOOTH_HINT      = z'0C52' ! 0x0C52
INTEGER(GLenum), PARAMETER :: GL_POLYGON_SMOOTH_HINT   = z'0C53' ! 0x0C53
INTEGER(GLenum), PARAMETER :: GL_FOG_HINT              = z'0C54' ! 0x0C54
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_GEN_S         = z'0C60' ! 0x0C60
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_GEN_T         = z'0C61' ! 0x0C61
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_GEN_R         = z'0C62' ! 0x0C62
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_GEN_Q         = z'0C63' ! 0x0C63
INTEGER(GLenum), PARAMETER :: GL_PIXEL_MAP_I_TO_I      = z'0C70' ! 0x0C70
INTEGER(GLenum), PARAMETER :: GL_PIXEL_MAP_S_TO_S      = z'0C71' ! 0x0C71
INTEGER(GLenum), PARAMETER :: GL_PIXEL_MAP_I_TO_R      = z'0C72' ! 0x0C72
INTEGER(GLenum), PARAMETER :: GL_PIXEL_MAP_I_TO_G      = z'0C73' ! 0x0C73
INTEGER(GLenum), PARAMETER :: GL_PIXEL_MAP_I_TO_B      = z'0C74' ! 0x0C74
INTEGER(GLenum), PARAMETER :: GL_PIXEL_MAP_I_TO_A      = z'0C75' ! 0x0C75
INTEGER(GLenum), PARAMETER :: GL_PIXEL_MAP_R_TO_R      = z'0C76' ! 0x0C76
INTEGER(GLenum), PARAMETER :: GL_PIXEL_MAP_G_TO_G      = z'0C77' ! 0x0C77
INTEGER(GLenum), PARAMETER :: GL_PIXEL_MAP_B_TO_B      = z'0C78' ! 0x0C78
INTEGER(GLenum), PARAMETER :: GL_PIXEL_MAP_A_TO_A      = z'0C79' ! 0x0C79
INTEGER(GLenum), PARAMETER :: GL_PIXEL_MAP_I_TO_I_SIZE = z'0CB0' ! 0x0CB0
INTEGER(GLenum), PARAMETER :: GL_PIXEL_MAP_S_TO_S_SIZE = z'0CB1' ! 0x0CB1
INTEGER(GLenum), PARAMETER :: GL_PIXEL_MAP_I_TO_R_SIZE = z'0CB2' ! 0x0CB2
INTEGER(GLenum), PARAMETER :: GL_PIXEL_MAP_I_TO_G_SIZE = z'0CB3' ! 0x0CB3
INTEGER(GLenum), PARAMETER :: GL_PIXEL_MAP_I_TO_B_SIZE = z'0CB4' ! 0x0CB4
INTEGER(GLenum), PARAMETER :: GL_PIXEL_MAP_I_TO_A_SIZE = z'0CB5' ! 0x0CB5
INTEGER(GLenum), PARAMETER :: GL_PIXEL_MAP_R_TO_R_SIZE = z'0CB6' ! 0x0CB6
INTEGER(GLenum), PARAMETER :: GL_PIXEL_MAP_G_TO_G_SIZE = z'0CB7' ! 0x0CB7
INTEGER(GLenum), PARAMETER :: GL_PIXEL_MAP_B_TO_B_SIZE = z'0CB8' ! 0x0CB8
INTEGER(GLenum), PARAMETER :: GL_PIXEL_MAP_A_TO_A_SIZE = z'0CB9' ! 0x0CB9
INTEGER(GLenum), PARAMETER :: GL_UNPACK_SWAP_BYTES     = z'0CF0' ! 0x0CF0
INTEGER(GLenum), PARAMETER :: GL_UNPACK_LSB_FIRST      = z'0CF1' ! 0x0CF1
INTEGER(GLenum), PARAMETER :: GL_UNPACK_ROW_LENGTH     = z'0CF2' ! 0x0CF2
INTEGER(GLenum), PARAMETER :: GL_UNPACK_SKIP_ROWS      = z'0CF3' ! 0x0CF3
INTEGER(GLenum), PARAMETER :: GL_UNPACK_SKIP_PIXELS    = z'0CF4' ! 0x0CF4
INTEGER(GLenum), PARAMETER :: GL_UNPACK_ALIGNMENT      = z'0CF5' ! 0x0CF5
INTEGER(GLenum), PARAMETER :: GL_PACK_SWAP_BYTES       = z'0D00' ! 0x0D00
INTEGER(GLenum), PARAMETER :: GL_PACK_LSB_FIRST        = z'0D01' ! 0x0D01
INTEGER(GLenum), PARAMETER :: GL_PACK_ROW_LENGTH       = z'0D02' ! 0x0D02
INTEGER(GLenum), PARAMETER :: GL_PACK_SKIP_ROWS        = z'0D03' ! 0x0D03
INTEGER(GLenum), PARAMETER :: GL_PACK_SKIP_PIXELS      = z'0D04' ! 0x0D04
INTEGER(GLenum), PARAMETER :: GL_PACK_ALIGNMENT        = z'0D05' ! 0x0D05
INTEGER(GLenum), PARAMETER :: GL_MAP_COLOR             = z'0D10' ! 0x0D10
INTEGER(GLenum), PARAMETER :: GL_MAP_STENCIL           = z'0D11' ! 0x0D11
INTEGER(GLenum), PARAMETER :: GL_INDEX_SHIFT           = z'0D12' ! 0x0D12
INTEGER(GLenum), PARAMETER :: GL_INDEX_OFFSET          = z'0D13' ! 0x0D13
INTEGER(GLenum), PARAMETER :: GL_RED_SCALE             = z'0D14' ! 0x0D14
INTEGER(GLenum), PARAMETER :: GL_RED_BIAS              = z'0D15' ! 0x0D15
INTEGER(GLenum), PARAMETER :: GL_ZOOM_X                = z'0D16' ! 0x0D16
INTEGER(GLenum), PARAMETER :: GL_ZOOM_Y                = z'0D17' ! 0x0D17
INTEGER(GLenum), PARAMETER :: GL_GREEN_SCALE           = z'0D18' ! 0x0D18
INTEGER(GLenum), PARAMETER :: GL_GREEN_BIAS            = z'0D19' ! 0x0D19
INTEGER(GLenum), PARAMETER :: GL_BLUE_SCALE            = z'0D1A' ! 0x0D1A
INTEGER(GLenum), PARAMETER :: GL_BLUE_BIAS             = z'0D1B' ! 0x0D1B
INTEGER(GLenum), PARAMETER :: GL_ALPHA_SCALE           = z'0D1C' ! 0x0D1C
INTEGER(GLenum), PARAMETER :: GL_ALPHA_BIAS            = z'0D1D' ! 0x0D1D
INTEGER(GLenum), PARAMETER :: GL_DEPTH_SCALE           = z'0D1E' ! 0x0D1E
INTEGER(GLenum), PARAMETER :: GL_DEPTH_BIAS            = z'0D1F' ! 0x0D1F
INTEGER(GLenum), PARAMETER :: GL_MAX_EVAL_ORDER        = z'0D30' ! 0x0D30
INTEGER(GLenum), PARAMETER :: GL_MAX_LIGHTS            = z'0D31' ! 0x0D31
INTEGER(GLenum), PARAMETER :: GL_MAX_CLIP_PLANES       = z'0D32' ! 0x0D32
INTEGER(GLenum), PARAMETER :: GL_MAX_TEXTURE_SIZE      = z'0D33' ! 0x0D33
INTEGER(GLenum), PARAMETER :: GL_MAX_PIXEL_MAP_TABLE   = z'0D34' ! 0x0D34
INTEGER(GLenum), PARAMETER :: GL_MAX_ATTRIB_STACK_DEPTH = z'0D35' ! 0x0D35
INTEGER(GLenum), PARAMETER :: GL_MAX_MODELVIEW_STACK_DEPTH = z'0D36' ! 0x0D36
INTEGER(GLenum), PARAMETER :: GL_MAX_NAME_STACK_DEPTH  = z'0D37' ! 0x0D37
INTEGER(GLenum), PARAMETER :: GL_MAX_PROJECTION_STACK_DEPTH = z'0D38' ! 0x0D38
INTEGER(GLenum), PARAMETER :: GL_MAX_TEXTURE_STACK_DEPTH = z'0D39' ! 0x0D39
INTEGER(GLenum), PARAMETER :: GL_MAX_VIEWPORT_DIMS     = z'0D3A' ! 0x0D3A
INTEGER(GLenum), PARAMETER :: GL_MAX_CLIENT_ATTRIB_STACK_DEPTH = z'0D3B' ! 0x0D3B
INTEGER(GLenum), PARAMETER :: GL_SUBPIXEL_BITS         = z'0D50' ! 0x0D50
INTEGER(GLenum), PARAMETER :: GL_INDEX_BITS            = z'0D51' ! 0x0D51
INTEGER(GLenum), PARAMETER :: GL_RED_BITS              = z'0D52' ! 0x0D52
INTEGER(GLenum), PARAMETER :: GL_GREEN_BITS            = z'0D53' ! 0x0D53
INTEGER(GLenum), PARAMETER :: GL_BLUE_BITS             = z'0D54' ! 0x0D54
INTEGER(GLenum), PARAMETER :: GL_ALPHA_BITS            = z'0D55' ! 0x0D55
INTEGER(GLenum), PARAMETER :: GL_DEPTH_BITS            = z'0D56' ! 0x0D56
INTEGER(GLenum), PARAMETER :: GL_STENCIL_BITS          = z'0D57' ! 0x0D57
INTEGER(GLenum), PARAMETER :: GL_ACCUM_RED_BITS        = z'0D58' ! 0x0D58
INTEGER(GLenum), PARAMETER :: GL_ACCUM_GREEN_BITS      = z'0D59' ! 0x0D59
INTEGER(GLenum), PARAMETER :: GL_ACCUM_BLUE_BITS       = z'0D5A' ! 0x0D5A
INTEGER(GLenum), PARAMETER :: GL_ACCUM_ALPHA_BITS      = z'0D5B' ! 0x0D5B
INTEGER(GLenum), PARAMETER :: GL_NAME_STACK_DEPTH      = z'0D70' ! 0x0D70
INTEGER(GLenum), PARAMETER :: GL_AUTO_NORMAL           = z'0D80' ! 0x0D80
INTEGER(GLenum), PARAMETER :: GL_MAP1_COLOR_4          = z'0D90' ! 0x0D90
INTEGER(GLenum), PARAMETER :: GL_MAP1_INDEX            = z'0D91' ! 0x0D91
INTEGER(GLenum), PARAMETER :: GL_MAP1_NORMAL           = z'0D92' ! 0x0D92
INTEGER(GLenum), PARAMETER :: GL_MAP1_TEXTURE_COORD_1  = z'0D93' ! 0x0D93
INTEGER(GLenum), PARAMETER :: GL_MAP1_TEXTURE_COORD_2  = z'0D94' ! 0x0D94
INTEGER(GLenum), PARAMETER :: GL_MAP1_TEXTURE_COORD_3  = z'0D95' ! 0x0D95
INTEGER(GLenum), PARAMETER :: GL_MAP1_TEXTURE_COORD_4  = z'0D96' ! 0x0D96
INTEGER(GLenum), PARAMETER :: GL_MAP1_VERTEX_3         = z'0D97' ! 0x0D97
INTEGER(GLenum), PARAMETER :: GL_MAP1_VERTEX_4         = z'0D98' ! 0x0D98
INTEGER(GLenum), PARAMETER :: GL_MAP2_COLOR_4          = z'0DB0' ! 0x0DB0
INTEGER(GLenum), PARAMETER :: GL_MAP2_INDEX            = z'0DB1' ! 0x0DB1
INTEGER(GLenum), PARAMETER :: GL_MAP2_NORMAL           = z'0DB2' ! 0x0DB2
INTEGER(GLenum), PARAMETER :: GL_MAP2_TEXTURE_COORD_1  = z'0DB3' ! 0x0DB3
INTEGER(GLenum), PARAMETER :: GL_MAP2_TEXTURE_COORD_2  = z'0DB4' ! 0x0DB4
INTEGER(GLenum), PARAMETER :: GL_MAP2_TEXTURE_COORD_3  = z'0DB5' ! 0x0DB5
INTEGER(GLenum), PARAMETER :: GL_MAP2_TEXTURE_COORD_4  = z'0DB6' ! 0x0DB6
INTEGER(GLenum), PARAMETER :: GL_MAP2_VERTEX_3         = z'0DB7' ! 0x0DB7
INTEGER(GLenum), PARAMETER :: GL_MAP2_VERTEX_4         = z'0DB8' ! 0x0DB8
INTEGER(GLenum), PARAMETER :: GL_MAP1_GRID_DOMAIN      = z'0DD0' ! 0x0DD0
INTEGER(GLenum), PARAMETER :: GL_MAP1_GRID_SEGMENTS    = z'0DD1' ! 0x0DD1
INTEGER(GLenum), PARAMETER :: GL_MAP2_GRID_DOMAIN      = z'0DD2' ! 0x0DD2
INTEGER(GLenum), PARAMETER :: GL_MAP2_GRID_SEGMENTS    = z'0DD3' ! 0x0DD3
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_1D            = z'0DE0' ! 0x0DE0
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_2D            = z'0DE1' ! 0x0DE1
INTEGER(GLenum), PARAMETER :: GL_FEEDBACK_BUFFER_POINTER = z'0DF0' ! 0x0DF0
INTEGER(GLenum), PARAMETER :: GL_FEEDBACK_BUFFER_SIZE  = z'0DF1' ! 0x0DF1
INTEGER(GLenum), PARAMETER :: GL_FEEDBACK_BUFFER_TYPE  = z'0DF2' ! 0x0DF2
INTEGER(GLenum), PARAMETER :: GL_SELECTION_BUFFER_POINTER = z'0DF3' ! 0x0DF3
INTEGER(GLenum), PARAMETER :: GL_SELECTION_BUFFER_SIZE = z'0DF4' ! 0x0DF4
!  GetTextureParameter values
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_WIDTH         = z'1000' ! 0x1000
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_HEIGHT        = z'1001' ! 0x1001
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_INTERNAL_FORMAT = z'1003' ! 0x1003
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_BORDER_COLOR  = z'1004' ! 0x1004
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_BORDER        = z'1005' ! 0x1005
!  HintMode values
INTEGER(GLenum), PARAMETER :: GL_DONT_CARE             = z'1100' ! 0x1100
INTEGER(GLenum), PARAMETER :: GL_FASTEST               = z'1101' ! 0x1101
INTEGER(GLenum), PARAMETER :: GL_NICEST                = z'1102' ! 0x1102
!  HintTarget values
!  HistogramTarget values
!  IndexPointerType values
!  LightModelColorControl values
!  LightModelParameter values
!  LightName values
INTEGER(GLenum), PARAMETER :: GL_LIGHT0                = z'4000' ! 0x4000
INTEGER(GLenum), PARAMETER :: GL_LIGHT1                = z'4001' ! 0x4001
INTEGER(GLenum), PARAMETER :: GL_LIGHT2                = z'4002' ! 0x4002
INTEGER(GLenum), PARAMETER :: GL_LIGHT3                = z'4003' ! 0x4003
INTEGER(GLenum), PARAMETER :: GL_LIGHT4                = z'4004' ! 0x4004
INTEGER(GLenum), PARAMETER :: GL_LIGHT5                = z'4005' ! 0x4005
INTEGER(GLenum), PARAMETER :: GL_LIGHT6                = z'4006' ! 0x4006
INTEGER(GLenum), PARAMETER :: GL_LIGHT7                = z'4007' ! 0x4007
!  LightParameter values
INTEGER(GLenum), PARAMETER :: GL_AMBIENT               = z'1200' ! 0x1200
INTEGER(GLenum), PARAMETER :: GL_DIFFUSE               = z'1201' ! 0x1201
INTEGER(GLenum), PARAMETER :: GL_SPECULAR              = z'1202' ! 0x1202
INTEGER(GLenum), PARAMETER :: GL_POSITION              = z'1203' ! 0x1203
INTEGER(GLenum), PARAMETER :: GL_SPOT_DIRECTION        = z'1204' ! 0x1204
INTEGER(GLenum), PARAMETER :: GL_SPOT_EXPONENT         = z'1205' ! 0x1205
INTEGER(GLenum), PARAMETER :: GL_SPOT_CUTOFF           = z'1206' ! 0x1206
INTEGER(GLenum), PARAMETER :: GL_CONSTANT_ATTENUATION  = z'1207' ! 0x1207
INTEGER(GLenum), PARAMETER :: GL_LINEAR_ATTENUATION    = z'1208' ! 0x1208
INTEGER(GLenum), PARAMETER :: GL_QUADRATIC_ATTENUATION = z'1209' ! 0x1209
!  InterleavedArrays values
!  ListMode values
INTEGER(GLenum), PARAMETER :: GL_COMPILE               = z'1300' ! 0x1300
INTEGER(GLenum), PARAMETER :: GL_COMPILE_AND_EXECUTE   = z'1301' ! 0x1301
!  ListNameType values
!  LogicOp values
INTEGER(GLenum), PARAMETER :: GL_CLEAR                 = z'1500' ! 0x1500
INTEGER(GLenum), PARAMETER :: GL_AND                   = z'1501' ! 0x1501
INTEGER(GLenum), PARAMETER :: GL_AND_REVERSE           = z'1502' ! 0x1502
INTEGER(GLenum), PARAMETER :: GL_COPY                  = z'1503' ! 0x1503
INTEGER(GLenum), PARAMETER :: GL_AND_INVERTED          = z'1504' ! 0x1504
INTEGER(GLenum), PARAMETER :: GL_NOOP                  = z'1505' ! 0x1505
INTEGER(GLenum), PARAMETER :: GL_XOR                   = z'1506' ! 0x1506
INTEGER(GLenum), PARAMETER :: GL_OR                    = z'1507' ! 0x1507
INTEGER(GLenum), PARAMETER :: GL_NOR                   = z'1508' ! 0x1508
INTEGER(GLenum), PARAMETER :: GL_EQUIV                 = z'1509' ! 0x1509
INTEGER(GLenum), PARAMETER :: GL_INVERT                = z'150A' ! 0x150A
INTEGER(GLenum), PARAMETER :: GL_OR_REVERSE            = z'150B' ! 0x150B
INTEGER(GLenum), PARAMETER :: GL_COPY_INVERTED         = z'150C' ! 0x150C
INTEGER(GLenum), PARAMETER :: GL_OR_INVERTED           = z'150D' ! 0x150D
INTEGER(GLenum), PARAMETER :: GL_NAND                  = z'150E' ! 0x150E
INTEGER(GLenum), PARAMETER :: GL_SET                   = z'150F' ! 0x150F
!  MapTarget values
!  MaterialFace values
!  MaterialParameter values
INTEGER(GLenum), PARAMETER :: GL_EMISSION              = z'1600' ! 0x1600
INTEGER(GLenum), PARAMETER :: GL_SHININESS             = z'1601' ! 0x1601
INTEGER(GLenum), PARAMETER :: GL_AMBIENT_AND_DIFFUSE   = z'1602' ! 0x1602
INTEGER(GLenum), PARAMETER :: GL_COLOR_INDEXES         = z'1603' ! 0x1603
!  MatrixMode values
INTEGER(GLenum), PARAMETER :: GL_MODELVIEW             = z'1700' ! 0x1700
INTEGER(GLenum), PARAMETER :: GL_PROJECTION            = z'1701' ! 0x1701
INTEGER(GLenum), PARAMETER :: GL_TEXTURE               = z'1702' ! 0x1702
!  MeshMode1 values
!  MeshMode2 values
!  MinmaxTarget values
!  NormalPointerType values
!  PixelCopyType values
INTEGER(GLenum), PARAMETER :: GL_COLOR                 = z'1800' ! 0x1800
INTEGER(GLenum), PARAMETER :: GL_DEPTH                 = z'1801' ! 0x1801
INTEGER(GLenum), PARAMETER :: GL_STENCIL               = z'1802' ! 0x1802
!  PixelFormat values
INTEGER(GLenum), PARAMETER :: GL_COLOR_INDEX           = z'1900' ! 0x1900
INTEGER(GLenum), PARAMETER :: GL_STENCIL_INDEX         = z'1901' ! 0x1901
INTEGER(GLenum), PARAMETER :: GL_DEPTH_COMPONENT       = z'1902' ! 0x1902
INTEGER(GLenum), PARAMETER :: GL_RED                   = z'1903' ! 0x1903
INTEGER(GLenum), PARAMETER :: GL_GREEN                 = z'1904' ! 0x1904
INTEGER(GLenum), PARAMETER :: GL_BLUE                  = z'1905' ! 0x1905
INTEGER(GLenum), PARAMETER :: GL_ALPHA                 = z'1906' ! 0x1906
INTEGER(GLenum), PARAMETER :: GL_RGB                   = z'1907' ! 0x1907
INTEGER(GLenum), PARAMETER :: GL_RGBA                  = z'1908' ! 0x1908
INTEGER(GLenum), PARAMETER :: GL_LUMINANCE             = z'1909' ! 0x1909
INTEGER(GLenum), PARAMETER :: GL_LUMINANCE_ALPHA       = z'190A' ! 0x190A
!  PixelInternalFormat values
!  PixelMap values
!  PixelStore values
!  PixelTransfer values
!  PixelType values
INTEGER(GLenum), PARAMETER :: GL_BITMAP                = z'1A00' ! 0x1A00
!  PolygonMode values
INTEGER(GLenum), PARAMETER :: GL_POINT                 = z'1B00' ! 0x1B00
INTEGER(GLenum), PARAMETER :: GL_LINE                  = z'1B01' ! 0x1B01
INTEGER(GLenum), PARAMETER :: GL_FILL                  = z'1B02' ! 0x1B02
!  ReadBufferMode values
!  RenderingMode values
INTEGER(GLenum), PARAMETER :: GL_RENDER                = z'1C00' ! 0x1C00
INTEGER(GLenum), PARAMETER :: GL_FEEDBACK              = z'1C01' ! 0x1C01
INTEGER(GLenum), PARAMETER :: GL_SELECT                = z'1C02' ! 0x1C02
!  SeparableTarget values
!  ShadingModel values
INTEGER(GLenum), PARAMETER :: GL_FLAT                  = z'1D00' ! 0x1D00
INTEGER(GLenum), PARAMETER :: GL_SMOOTH                = z'1D01' ! 0x1D01
!  StencilFunction values
!  StencilOp values
INTEGER(GLenum), PARAMETER :: GL_KEEP                  = z'1E00' ! 0x1E00
INTEGER(GLenum), PARAMETER :: GL_REPLACE               = z'1E01' ! 0x1E01
INTEGER(GLenum), PARAMETER :: GL_INCR                  = z'1E02' ! 0x1E02
INTEGER(GLenum), PARAMETER :: GL_DECR                  = z'1E03' ! 0x1E03
!  StringName values
INTEGER(GLenum), PARAMETER :: GL_VENDOR                = z'1F00' ! 0x1F00
INTEGER(GLenum), PARAMETER :: GL_RENDERER              = z'1F01' ! 0x1F01
INTEGER(GLenum), PARAMETER :: GL_VERSION               = z'1F02' ! 0x1F02
INTEGER(GLenum), PARAMETER :: GL_EXTENSIONS            = z'1F03' ! 0x1F03
!  TextureCoordName values
INTEGER(GLenum), PARAMETER :: GL_S                     = z'2000' ! 0x2000
INTEGER(GLenum), PARAMETER :: GL_T                     = z'2001' ! 0x2001
INTEGER(GLenum), PARAMETER :: GL_R                     = z'2002' ! 0x2002
INTEGER(GLenum), PARAMETER :: GL_Q                     = z'2003' ! 0x2003
!  TexCoordPointerType values
!  TextureEnvMode values
INTEGER(GLenum), PARAMETER :: GL_MODULATE              = z'2100' ! 0x2100
INTEGER(GLenum), PARAMETER :: GL_DECAL                 = z'2101' ! 0x2101
!  TextureEnvParameter values
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_ENV_MODE      = z'2200' ! 0x2200
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_ENV_COLOR     = z'2201' ! 0x2201
!  TextureEnvTarget values
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_ENV           = z'2300' ! 0x2300
!  TextureGenMode values
INTEGER(GLenum), PARAMETER :: GL_EYE_LINEAR            = z'2400' ! 0x2400
INTEGER(GLenum), PARAMETER :: GL_OBJECT_LINEAR         = z'2401' ! 0x2401
INTEGER(GLenum), PARAMETER :: GL_SPHERE_MAP            = z'2402' ! 0x2402
!  TextureGenParameter values
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_GEN_MODE      = z'2500' ! 0x2500
INTEGER(GLenum), PARAMETER :: GL_OBJECT_PLANE          = z'2501' ! 0x2501
INTEGER(GLenum), PARAMETER :: GL_EYE_PLANE             = z'2502' ! 0x2502
!  TextureMagFilter values
INTEGER(GLenum), PARAMETER :: GL_NEAREST               = z'2600' ! 0x2600
INTEGER(GLenum), PARAMETER :: GL_LINEAR                = z'2601' ! 0x2601
!  TextureMinFilter values
INTEGER(GLenum), PARAMETER :: GL_NEAREST_MIPMAP_NEAREST = z'2700' ! 0x2700
INTEGER(GLenum), PARAMETER :: GL_LINEAR_MIPMAP_NEAREST = z'2701' ! 0x2701
INTEGER(GLenum), PARAMETER :: GL_NEAREST_MIPMAP_LINEAR = z'2702' ! 0x2702
INTEGER(GLenum), PARAMETER :: GL_LINEAR_MIPMAP_LINEAR  = z'2703' ! 0x2703
!  TextureParameterName values
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_MAG_FILTER    = z'2800' ! 0x2800
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_MIN_FILTER    = z'2801' ! 0x2801
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_WRAP_S        = z'2802' ! 0x2802
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_WRAP_T        = z'2803' ! 0x2803
!  TextureTarget values
!  TextureUnit values
!  TextureWrapMode values
INTEGER(GLenum), PARAMETER :: GL_CLAMP                 = z'2900' ! 0x2900
INTEGER(GLenum), PARAMETER :: GL_REPEAT                = z'2901' ! 0x2901
!  VertexPointerType values
!  ClientAttribMask values
INTEGER(GLbitfield), PARAMETER :: GL_CLIENT_PIXEL_STORE_BIT = z'00000001' ! 0x00000001
INTEGER(GLbitfield), PARAMETER :: GL_CLIENT_VERTEX_ARRAY_BIT = z'00000002' ! 0x00000002
INTEGER(GLbitfield), PARAMETER :: GL_CLIENT_ALL_ATTRIB_BITS = z'ffffffff' ! 0xffffffff
!  polygon_offset values
INTEGER(GLenum), PARAMETER :: GL_POLYGON_OFFSET_FACTOR = z'8038' ! 0x8038
INTEGER(GLenum), PARAMETER :: GL_POLYGON_OFFSET_UNITS  = z'2A00' ! 0x2A00
INTEGER(GLenum), PARAMETER :: GL_POLYGON_OFFSET_POINT  = z'2A01' ! 0x2A01
INTEGER(GLenum), PARAMETER :: GL_POLYGON_OFFSET_LINE   = z'2A02' ! 0x2A02
INTEGER(GLenum), PARAMETER :: GL_POLYGON_OFFSET_FILL   = z'8037' ! 0x8037
!  texture values
INTEGER(GLenum), PARAMETER :: GL_ALPHA4                = z'803B' ! 0x803B
INTEGER(GLenum), PARAMETER :: GL_ALPHA8                = z'803C' ! 0x803C
INTEGER(GLenum), PARAMETER :: GL_ALPHA12               = z'803D' ! 0x803D
INTEGER(GLenum), PARAMETER :: GL_ALPHA16               = z'803E' ! 0x803E
INTEGER(GLenum), PARAMETER :: GL_LUMINANCE4            = z'803F' ! 0x803F
INTEGER(GLenum), PARAMETER :: GL_LUMINANCE8            = z'8040' ! 0x8040
INTEGER(GLenum), PARAMETER :: GL_LUMINANCE12           = z'8041' ! 0x8041
INTEGER(GLenum), PARAMETER :: GL_LUMINANCE16           = z'8042' ! 0x8042
INTEGER(GLenum), PARAMETER :: GL_LUMINANCE4_ALPHA4     = z'8043' ! 0x8043
INTEGER(GLenum), PARAMETER :: GL_LUMINANCE6_ALPHA2     = z'8044' ! 0x8044
INTEGER(GLenum), PARAMETER :: GL_LUMINANCE8_ALPHA8     = z'8045' ! 0x8045
INTEGER(GLenum), PARAMETER :: GL_LUMINANCE12_ALPHA4    = z'8046' ! 0x8046
INTEGER(GLenum), PARAMETER :: GL_LUMINANCE12_ALPHA12   = z'8047' ! 0x8047
INTEGER(GLenum), PARAMETER :: GL_LUMINANCE16_ALPHA16   = z'8048' ! 0x8048
INTEGER(GLenum), PARAMETER :: GL_INTENSITY             = z'8049' ! 0x8049
INTEGER(GLenum), PARAMETER :: GL_INTENSITY4            = z'804A' ! 0x804A
INTEGER(GLenum), PARAMETER :: GL_INTENSITY8            = z'804B' ! 0x804B
INTEGER(GLenum), PARAMETER :: GL_INTENSITY12           = z'804C' ! 0x804C
INTEGER(GLenum), PARAMETER :: GL_INTENSITY16           = z'804D' ! 0x804D
INTEGER(GLenum), PARAMETER :: GL_R3_G3_B2              = z'2A10' ! 0x2A10
INTEGER(GLenum), PARAMETER :: GL_RGB4                  = z'804F' ! 0x804F
INTEGER(GLenum), PARAMETER :: GL_RGB5                  = z'8050' ! 0x8050
INTEGER(GLenum), PARAMETER :: GL_RGB8                  = z'8051' ! 0x8051
INTEGER(GLenum), PARAMETER :: GL_RGB10                 = z'8052' ! 0x8052
INTEGER(GLenum), PARAMETER :: GL_RGB12                 = z'8053' ! 0x8053
INTEGER(GLenum), PARAMETER :: GL_RGB16                 = z'8054' ! 0x8054
INTEGER(GLenum), PARAMETER :: GL_RGBA2                 = z'8055' ! 0x8055
INTEGER(GLenum), PARAMETER :: GL_RGBA4                 = z'8056' ! 0x8056
INTEGER(GLenum), PARAMETER :: GL_RGB5_A1               = z'8057' ! 0x8057
INTEGER(GLenum), PARAMETER :: GL_RGBA8                 = z'8058' ! 0x8058
INTEGER(GLenum), PARAMETER :: GL_RGB10_A2              = z'8059' ! 0x8059
INTEGER(GLenum), PARAMETER :: GL_RGBA12                = z'805A' ! 0x805A
INTEGER(GLenum), PARAMETER :: GL_RGBA16                = z'805B' ! 0x805B
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_RED_SIZE      = z'805C' ! 0x805C
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_GREEN_SIZE    = z'805D' ! 0x805D
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_BLUE_SIZE     = z'805E' ! 0x805E
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_ALPHA_SIZE    = z'805F' ! 0x805F
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_LUMINANCE_SIZE = z'8060' ! 0x8060
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_INTENSITY_SIZE = z'8061' ! 0x8061
INTEGER(GLenum), PARAMETER :: GL_PROXY_TEXTURE_1D      = z'8063' ! 0x8063
INTEGER(GLenum), PARAMETER :: GL_PROXY_TEXTURE_2D      = z'8064' ! 0x8064
!  texture_object values
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_PRIORITY      = z'8066' ! 0x8066
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_RESIDENT      = z'8067' ! 0x8067
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_BINDING_1D    = z'8068' ! 0x8068
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_BINDING_2D    = z'8069' ! 0x8069
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_BINDING_3D    = z'806A' ! 0x806A
!  vertex_array values
INTEGER(GLenum), PARAMETER :: GL_VERTEX_ARRAY          = z'8074' ! 0x8074
INTEGER(GLenum), PARAMETER :: GL_NORMAL_ARRAY          = z'8075' ! 0x8075
INTEGER(GLenum), PARAMETER :: GL_COLOR_ARRAY           = z'8076' ! 0x8076
INTEGER(GLenum), PARAMETER :: GL_INDEX_ARRAY           = z'8077' ! 0x8077
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_COORD_ARRAY   = z'8078' ! 0x8078
INTEGER(GLenum), PARAMETER :: GL_EDGE_FLAG_ARRAY       = z'8079' ! 0x8079
INTEGER(GLenum), PARAMETER :: GL_VERTEX_ARRAY_SIZE     = z'807A' ! 0x807A
INTEGER(GLenum), PARAMETER :: GL_VERTEX_ARRAY_TYPE     = z'807B' ! 0x807B
INTEGER(GLenum), PARAMETER :: GL_VERTEX_ARRAY_STRIDE   = z'807C' ! 0x807C
INTEGER(GLenum), PARAMETER :: GL_NORMAL_ARRAY_TYPE     = z'807E' ! 0x807E
INTEGER(GLenum), PARAMETER :: GL_NORMAL_ARRAY_STRIDE   = z'807F' ! 0x807F
INTEGER(GLenum), PARAMETER :: GL_COLOR_ARRAY_SIZE      = z'8081' ! 0x8081
INTEGER(GLenum), PARAMETER :: GL_COLOR_ARRAY_TYPE      = z'8082' ! 0x8082
INTEGER(GLenum), PARAMETER :: GL_COLOR_ARRAY_STRIDE    = z'8083' ! 0x8083
INTEGER(GLenum), PARAMETER :: GL_INDEX_ARRAY_TYPE      = z'8085' ! 0x8085
INTEGER(GLenum), PARAMETER :: GL_INDEX_ARRAY_STRIDE    = z'8086' ! 0x8086
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_COORD_ARRAY_SIZE = z'8088' ! 0x8088
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_COORD_ARRAY_TYPE = z'8089' ! 0x8089
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_COORD_ARRAY_STRIDE = z'808A' ! 0x808A
INTEGER(GLenum), PARAMETER :: GL_EDGE_FLAG_ARRAY_STRIDE = z'808C' ! 0x808C
INTEGER(GLenum), PARAMETER :: GL_VERTEX_ARRAY_POINTER  = z'808E' ! 0x808E
INTEGER(GLenum), PARAMETER :: GL_NORMAL_ARRAY_POINTER  = z'808F' ! 0x808F
INTEGER(GLenum), PARAMETER :: GL_COLOR_ARRAY_POINTER   = z'8090' ! 0x8090
INTEGER(GLenum), PARAMETER :: GL_INDEX_ARRAY_POINTER   = z'8091' ! 0x8091
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_COORD_ARRAY_POINTER = z'8092' ! 0x8092
INTEGER(GLenum), PARAMETER :: GL_EDGE_FLAG_ARRAY_POINTER = z'8093' ! 0x8093
INTEGER(GLenum), PARAMETER :: GL_V2F                   = z'2A20' ! 0x2A20
INTEGER(GLenum), PARAMETER :: GL_V3F                   = z'2A21' ! 0x2A21
INTEGER(GLenum), PARAMETER :: GL_C4UB_V2F              = z'2A22' ! 0x2A22
INTEGER(GLenum), PARAMETER :: GL_C4UB_V3F              = z'2A23' ! 0x2A23
INTEGER(GLenum), PARAMETER :: GL_C3F_V3F               = z'2A24' ! 0x2A24
INTEGER(GLenum), PARAMETER :: GL_N3F_V3F               = z'2A25' ! 0x2A25
INTEGER(GLenum), PARAMETER :: GL_C4F_N3F_V3F           = z'2A26' ! 0x2A26
INTEGER(GLenum), PARAMETER :: GL_T2F_V3F               = z'2A27' ! 0x2A27
INTEGER(GLenum), PARAMETER :: GL_T4F_V4F               = z'2A28' ! 0x2A28
INTEGER(GLenum), PARAMETER :: GL_T2F_C4UB_V3F          = z'2A29' ! 0x2A29
INTEGER(GLenum), PARAMETER :: GL_T2F_C3F_V3F           = z'2A2A' ! 0x2A2A
INTEGER(GLenum), PARAMETER :: GL_T2F_N3F_V3F           = z'2A2B' ! 0x2A2B
INTEGER(GLenum), PARAMETER :: GL_T2F_C4F_N3F_V3F       = z'2A2C' ! 0x2A2C
INTEGER(GLenum), PARAMETER :: GL_T4F_C4F_N3F_V4F       = z'2A2D' ! 0x2A2D
!  bgra values
INTEGER(GLenum), PARAMETER :: GL_BGR                   = z'80E0' ! 0x80E0
INTEGER(GLenum), PARAMETER :: GL_BGRA                  = z'80E1' ! 0x80E1
!  blend_color values
INTEGER(GLenum), PARAMETER :: GL_CONSTANT_COLOR        = z'8001' ! 0x8001
INTEGER(GLenum), PARAMETER :: GL_ONE_MINUS_CONSTANT_COLOR = z'8002' ! 0x8002
INTEGER(GLenum), PARAMETER :: GL_CONSTANT_ALPHA        = z'8003' ! 0x8003
INTEGER(GLenum), PARAMETER :: GL_ONE_MINUS_CONSTANT_ALPHA = z'8004' ! 0x8004
INTEGER(GLenum), PARAMETER :: GL_BLEND_COLOR           = z'8005' ! 0x8005
!  blend_minmax values
INTEGER(GLenum), PARAMETER :: GL_FUNC_ADD              = z'8006' ! 0x8006
INTEGER(GLenum), PARAMETER :: GL_MIN                   = z'8007' ! 0x8007
INTEGER(GLenum), PARAMETER :: GL_MAX                   = z'8008' ! 0x8008
INTEGER(GLenum), PARAMETER :: GL_BLEND_EQUATION        = z'8009' ! 0x8009
!  blend_subtract values
INTEGER(GLenum), PARAMETER :: GL_FUNC_SUBTRACT         = z'800A' ! 0x800A
INTEGER(GLenum), PARAMETER :: GL_FUNC_REVERSE_SUBTRACT = z'800B' ! 0x800B
!  color_matrix values
INTEGER(GLenum), PARAMETER :: GL_COLOR_MATRIX          = z'80B1' ! 0x80B1
INTEGER(GLenum), PARAMETER :: GL_COLOR_MATRIX_STACK_DEPTH = z'80B2' ! 0x80B2
INTEGER(GLenum), PARAMETER :: GL_MAX_COLOR_MATRIX_STACK_DEPTH = z'80B3' ! 0x80B3
INTEGER(GLenum), PARAMETER :: GL_POST_COLOR_MATRIX_RED_SCALE = z'80B4' ! 0x80B4
INTEGER(GLenum), PARAMETER :: GL_POST_COLOR_MATRIX_GREEN_SCALE = z'80B5' ! 0x80B5
INTEGER(GLenum), PARAMETER :: GL_POST_COLOR_MATRIX_BLUE_SCALE = z'80B6' ! 0x80B6
INTEGER(GLenum), PARAMETER :: GL_POST_COLOR_MATRIX_ALPHA_SCALE = z'80B7' ! 0x80B7
INTEGER(GLenum), PARAMETER :: GL_POST_COLOR_MATRIX_RED_BIAS = z'80B8' ! 0x80B8
INTEGER(GLenum), PARAMETER :: GL_POST_COLOR_MATRIX_GREEN_BIAS = z'80B9' ! 0x80B9
INTEGER(GLenum), PARAMETER :: GL_POST_COLOR_MATRIX_BLUE_BIAS = z'80BA' ! 0x80BA
INTEGER(GLenum), PARAMETER :: GL_POST_COLOR_MATRIX_ALPHA_BIAS = z'80BB' ! 0x80BB
!  color_table values
INTEGER(GLenum), PARAMETER :: GL_COLOR_TABLE           = z'80D0' ! 0x80D0
INTEGER(GLenum), PARAMETER :: GL_POST_CONVOLUTION_COLOR_TABLE = z'80D1' ! 0x80D1
INTEGER(GLenum), PARAMETER :: GL_POST_COLOR_MATRIX_COLOR_TABLE = z'80D2' ! 0x80D2
INTEGER(GLenum), PARAMETER :: GL_PROXY_COLOR_TABLE     = z'80D3' ! 0x80D3
INTEGER(GLenum), PARAMETER :: GL_PROXY_POST_CONVOLUTION_COLOR_TABLE = z'80D4' ! 0x80D4
INTEGER(GLenum), PARAMETER :: GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE = z'80D5' ! 0x80D5
INTEGER(GLenum), PARAMETER :: GL_COLOR_TABLE_SCALE     = z'80D6' ! 0x80D6
INTEGER(GLenum), PARAMETER :: GL_COLOR_TABLE_BIAS      = z'80D7' ! 0x80D7
INTEGER(GLenum), PARAMETER :: GL_COLOR_TABLE_FORMAT    = z'80D8' ! 0x80D8
INTEGER(GLenum), PARAMETER :: GL_COLOR_TABLE_WIDTH     = z'80D9' ! 0x80D9
INTEGER(GLenum), PARAMETER :: GL_COLOR_TABLE_RED_SIZE  = z'80DA' ! 0x80DA
INTEGER(GLenum), PARAMETER :: GL_COLOR_TABLE_GREEN_SIZE = z'80DB' ! 0x80DB
INTEGER(GLenum), PARAMETER :: GL_COLOR_TABLE_BLUE_SIZE = z'80DC' ! 0x80DC
INTEGER(GLenum), PARAMETER :: GL_COLOR_TABLE_ALPHA_SIZE = z'80DD' ! 0x80DD
INTEGER(GLenum), PARAMETER :: GL_COLOR_TABLE_LUMINANCE_SIZE = z'80DE' ! 0x80DE
INTEGER(GLenum), PARAMETER :: GL_COLOR_TABLE_INTENSITY_SIZE = z'80DF' ! 0x80DF
!  convolution values
INTEGER(GLenum), PARAMETER :: GL_CONVOLUTION_1D        = z'8010' ! 0x8010
INTEGER(GLenum), PARAMETER :: GL_CONVOLUTION_2D        = z'8011' ! 0x8011
INTEGER(GLenum), PARAMETER :: GL_SEPARABLE_2D          = z'8012' ! 0x8012
INTEGER(GLenum), PARAMETER :: GL_CONVOLUTION_BORDER_MODE = z'8013' ! 0x8013
INTEGER(GLenum), PARAMETER :: GL_CONVOLUTION_FILTER_SCALE = z'8014' ! 0x8014
INTEGER(GLenum), PARAMETER :: GL_CONVOLUTION_FILTER_BIAS = z'8015' ! 0x8015
INTEGER(GLenum), PARAMETER :: GL_REDUCE                = z'8016' ! 0x8016
INTEGER(GLenum), PARAMETER :: GL_CONVOLUTION_FORMAT    = z'8017' ! 0x8017
INTEGER(GLenum), PARAMETER :: GL_CONVOLUTION_WIDTH     = z'8018' ! 0x8018
INTEGER(GLenum), PARAMETER :: GL_CONVOLUTION_HEIGHT    = z'8019' ! 0x8019
INTEGER(GLenum), PARAMETER :: GL_MAX_CONVOLUTION_WIDTH = z'801A' ! 0x801A
INTEGER(GLenum), PARAMETER :: GL_MAX_CONVOLUTION_HEIGHT = z'801B' ! 0x801B
INTEGER(GLenum), PARAMETER :: GL_POST_CONVOLUTION_RED_SCALE = z'801C' ! 0x801C
INTEGER(GLenum), PARAMETER :: GL_POST_CONVOLUTION_GREEN_SCALE = z'801D' ! 0x801D
INTEGER(GLenum), PARAMETER :: GL_POST_CONVOLUTION_BLUE_SCALE = z'801E' ! 0x801E
INTEGER(GLenum), PARAMETER :: GL_POST_CONVOLUTION_ALPHA_SCALE = z'801F' ! 0x801F
INTEGER(GLenum), PARAMETER :: GL_POST_CONVOLUTION_RED_BIAS = z'8020' ! 0x8020
INTEGER(GLenum), PARAMETER :: GL_POST_CONVOLUTION_GREEN_BIAS = z'8021' ! 0x8021
INTEGER(GLenum), PARAMETER :: GL_POST_CONVOLUTION_BLUE_BIAS = z'8022' ! 0x8022
INTEGER(GLenum), PARAMETER :: GL_POST_CONVOLUTION_ALPHA_BIAS = z'8023' ! 0x8023
INTEGER(GLenum), PARAMETER :: GL_CONSTANT_BORDER       = z'8151' ! 0x8151
INTEGER(GLenum), PARAMETER :: GL_REPLICATE_BORDER      = z'8153' ! 0x8153
INTEGER(GLenum), PARAMETER :: GL_CONVOLUTION_BORDER_COLOR = z'8154' ! 0x8154
!  draw_range_elements values
INTEGER(GLenum), PARAMETER :: GL_MAX_ELEMENTS_VERTICES = z'80E8' ! 0x80E8
INTEGER(GLenum), PARAMETER :: GL_MAX_ELEMENTS_INDICES  = z'80E9' ! 0x80E9
!  histogram values
INTEGER(GLenum), PARAMETER :: GL_HISTOGRAM             = z'8024' ! 0x8024
INTEGER(GLenum), PARAMETER :: GL_PROXY_HISTOGRAM       = z'8025' ! 0x8025
INTEGER(GLenum), PARAMETER :: GL_HISTOGRAM_WIDTH       = z'8026' ! 0x8026
INTEGER(GLenum), PARAMETER :: GL_HISTOGRAM_FORMAT      = z'8027' ! 0x8027
INTEGER(GLenum), PARAMETER :: GL_HISTOGRAM_RED_SIZE    = z'8028' ! 0x8028
INTEGER(GLenum), PARAMETER :: GL_HISTOGRAM_GREEN_SIZE  = z'8029' ! 0x8029
INTEGER(GLenum), PARAMETER :: GL_HISTOGRAM_BLUE_SIZE   = z'802A' ! 0x802A
INTEGER(GLenum), PARAMETER :: GL_HISTOGRAM_ALPHA_SIZE  = z'802B' ! 0x802B
INTEGER(GLenum), PARAMETER :: GL_HISTOGRAM_LUMINANCE_SIZE = z'802C' ! 0x802C
INTEGER(GLenum), PARAMETER :: GL_HISTOGRAM_SINK        = z'802D' ! 0x802D
INTEGER(GLenum), PARAMETER :: GL_MINMAX                = z'802E' ! 0x802E
INTEGER(GLenum), PARAMETER :: GL_MINMAX_FORMAT         = z'802F' ! 0x802F
INTEGER(GLenum), PARAMETER :: GL_MINMAX_SINK           = z'8030' ! 0x8030
INTEGER(GLenum), PARAMETER :: GL_TABLE_TOO_LARGE       = z'8031' ! 0x8031
!  packed_pixels values
INTEGER(GLenum), PARAMETER :: GL_UNSIGNED_BYTE_3_3_2   = z'8032' ! 0x8032
INTEGER(GLenum), PARAMETER :: GL_UNSIGNED_SHORT_4_4_4_4 = z'8033' ! 0x8033
INTEGER(GLenum), PARAMETER :: GL_UNSIGNED_SHORT_5_5_5_1 = z'8034' ! 0x8034
INTEGER(GLenum), PARAMETER :: GL_UNSIGNED_INT_8_8_8_8  = z'8035' ! 0x8035
INTEGER(GLenum), PARAMETER :: GL_UNSIGNED_INT_10_10_10_2 = z'8036' ! 0x8036
INTEGER(GLenum), PARAMETER :: GL_UNSIGNED_BYTE_2_3_3_REV = z'8362' ! 0x8362
INTEGER(GLenum), PARAMETER :: GL_UNSIGNED_SHORT_5_6_5  = z'8363' ! 0x8363
INTEGER(GLenum), PARAMETER :: GL_UNSIGNED_SHORT_5_6_5_REV = z'8364' ! 0x8364
INTEGER(GLenum), PARAMETER :: GL_UNSIGNED_SHORT_4_4_4_4_REV = z'8365' ! 0x8365
INTEGER(GLenum), PARAMETER :: GL_UNSIGNED_SHORT_1_5_5_5_REV = z'8366' ! 0x8366
INTEGER(GLenum), PARAMETER :: GL_UNSIGNED_INT_8_8_8_8_REV = z'8367' ! 0x8367
INTEGER(GLenum), PARAMETER :: GL_UNSIGNED_INT_2_10_10_10_REV = z'8368' ! 0x8368
!  rescale_normal values
INTEGER(GLenum), PARAMETER :: GL_RESCALE_NORMAL        = z'803A' ! 0x803A
!  separate_specular_color values
INTEGER(GLenum), PARAMETER :: GL_LIGHT_MODEL_COLOR_CONTROL = z'81F8' ! 0x81F8
INTEGER(GLenum), PARAMETER :: GL_SINGLE_COLOR          = z'81F9' ! 0x81F9
INTEGER(GLenum), PARAMETER :: GL_SEPARATE_SPECULAR_COLOR = z'81FA' ! 0x81FA
!  texture3D values
INTEGER(GLenum), PARAMETER :: GL_PACK_SKIP_IMAGES      = z'806B' ! 0x806B
INTEGER(GLenum), PARAMETER :: GL_PACK_IMAGE_HEIGHT     = z'806C' ! 0x806C
INTEGER(GLenum), PARAMETER :: GL_UNPACK_SKIP_IMAGES    = z'806D' ! 0x806D
INTEGER(GLenum), PARAMETER :: GL_UNPACK_IMAGE_HEIGHT   = z'806E' ! 0x806E
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_3D            = z'806F' ! 0x806F
INTEGER(GLenum), PARAMETER :: GL_PROXY_TEXTURE_3D      = z'8070' ! 0x8070
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_DEPTH         = z'8071' ! 0x8071
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_WRAP_R        = z'8072' ! 0x8072
INTEGER(GLenum), PARAMETER :: GL_MAX_3D_TEXTURE_SIZE   = z'8073' ! 0x8073
!  texture_edge_clamp values
INTEGER(GLenum), PARAMETER :: GL_CLAMP_TO_EDGE         = z'812F' ! 0x812F
!  texture_lod values
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_MIN_LOD       = z'813A' ! 0x813A
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_MAX_LOD       = z'813B' ! 0x813B
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_BASE_LEVEL    = z'813C' ! 0x813C
INTEGER(GLenum), PARAMETER :: GL_TEXTURE_MAX_LEVEL     = z'813D' ! 0x813D
!  GetTarget1_2 values
INTEGER(GLenum), PARAMETER :: GL_SMOOTH_POINT_SIZE_RANGE = z'0B12' ! 0x0B12
INTEGER(GLenum), PARAMETER :: GL_SMOOTH_POINT_SIZE_GRANULARITY = z'0B13' ! 0x0B13
INTEGER(GLenum), PARAMETER :: GL_SMOOTH_LINE_WIDTH_RANGE = z'0B22' ! 0x0B22
INTEGER(GLenum), PARAMETER :: GL_SMOOTH_LINE_WIDTH_GRANULARITY = z'0B23' ! 0x0B23
INTEGER(GLenum), PARAMETER :: GL_ALIASED_POINT_SIZE_RANGE = z'846D' ! 0x846D
INTEGER(GLenum), PARAMETER :: GL_ALIASED_LINE_WIDTH_RANGE = z'846E' ! 0x846E
!  multitexture values
INTEGER(GLenum), PARAMETER :: GL_TEXTURE0_ARB          = z'84C0' ! 0x84C0
INTEGER(GLenum), PARAMETER :: GL_TEXTURE1_ARB          = z'84C1' ! 0x84C1
INTEGER(GLenum), PARAMETER :: GL_TEXTURE2_ARB          = z'84C2' ! 0x84C2
INTEGER(GLenum), PARAMETER :: GL_TEXTURE3_ARB          = z'84C3' ! 0x84C3
INTEGER(GLenum), PARAMETER :: GL_TEXTURE4_ARB          = z'84C4' ! 0x84C4
INTEGER(GLenum), PARAMETER :: GL_TEXTURE5_ARB          = z'84C5' ! 0x84C5
INTEGER(GLenum), PARAMETER :: GL_TEXTURE6_ARB          = z'84C6' ! 0x84C6
INTEGER(GLenum), PARAMETER :: GL_TEXTURE7_ARB          = z'84C7' ! 0x84C7
INTEGER(GLenum), PARAMETER :: GL_TEXTURE8_ARB          = z'84C8' ! 0x84C8
INTEGER(GLenum), PARAMETER :: GL_TEXTURE9_ARB          = z'84C9' ! 0x84C9
INTEGER(GLenum), PARAMETER :: GL_TEXTURE10_ARB         = z'84CA' ! 0x84CA
INTEGER(GLenum), PARAMETER :: GL_TEXTURE11_ARB         = z'84CB' ! 0x84CB
INTEGER(GLenum), PARAMETER :: GL_TEXTURE12_ARB         = z'84CC' ! 0x84CC
INTEGER(GLenum), PARAMETER :: GL_TEXTURE13_ARB         = z'84CD' ! 0x84CD
INTEGER(GLenum), PARAMETER :: GL_TEXTURE14_ARB         = z'84CE' ! 0x84CE
INTEGER(GLenum), PARAMETER :: GL_TEXTURE15_ARB         = z'84CF' ! 0x84CF
INTEGER(GLenum), PARAMETER :: GL_TEXTURE16_ARB         = z'84D0' ! 0x84D0
INTEGER(GLenum), PARAMETER :: GL_TEXTURE17_ARB         = z'84D1' ! 0x84D1
INTEGER(GLenum), PARAMETER :: GL_TEXTURE18_ARB         = z'84D2' ! 0x84D2
INTEGER(GLenum), PARAMETER :: GL_TEXTURE19_ARB         = z'84D3' ! 0x84D3
INTEGER(GLenum), PARAMETER :: GL_TEXTURE20_ARB         = z'84D4' ! 0x84D4
INTEGER(GLenum), PARAMETER :: GL_TEXTURE21_ARB         = z'84D5' ! 0x84D5
INTEGER(GLenum), PARAMETER :: GL_TEXTURE22_ARB         = z'84D6' ! 0x84D6
INTEGER(GLenum), PARAMETER :: GL_TEXTURE23_ARB         = z'84D7' ! 0x84D7
INTEGER(GLenum), PARAMETER :: GL_TEXTURE24_ARB         = z'84D8' ! 0x84D8
INTEGER(GLenum), PARAMETER :: GL_TEXTURE25_ARB         = z'84D9' ! 0x84D9
INTEGER(GLenum), PARAMETER :: GL_TEXTURE26_ARB         = z'84DA' ! 0x84DA
INTEGER(GLenum), PARAMETER :: GL_TEXTURE27_ARB         = z'84DB' ! 0x84DB
INTEGER(GLenum), PARAMETER :: GL_TEXTURE28_ARB         = z'84DC' ! 0x84DC
INTEGER(GLenum), PARAMETER :: GL_TEXTURE29_ARB         = z'84DD' ! 0x84DD
INTEGER(GLenum), PARAMETER :: GL_TEXTURE30_ARB         = z'84DE' ! 0x84DE
INTEGER(GLenum), PARAMETER :: GL_TEXTURE31_ARB         = z'84DF' ! 0x84DF
INTEGER(GLenum), PARAMETER :: GL_ACTIVE_TEXTURE_ARB    = z'84E0' ! 0x84E0
INTEGER(GLenum), PARAMETER :: GL_CLIENT_ACTIVE_TEXTURE_ARB = z'84E1' ! 0x84E1
INTEGER(GLenum), PARAMETER :: GL_MAX_TEXTURE_UNITS_ARB = z'84E2' ! 0x84E2
!  EXT_abgr values
INTEGER(GLenum), PARAMETER :: GL_ABGR_EXT              = z'8000' ! 0x8000
!  EXT_blend_color values
INTEGER(GLenum), PARAMETER :: GL_CONSTANT_COLOR_EXT    = z'8001' ! 0x8001
INTEGER(GLenum), PARAMETER :: GL_ONE_MINUS_CONSTANT_COLOR_EXT = z'8002' ! 0x8002
INTEGER(GLenum), PARAMETER :: GL_CONSTANT_ALPHA_EXT    = z'8003' ! 0x8003
INTEGER(GLenum), PARAMETER :: GL_ONE_MINUS_CONSTANT_ALPHA_EXT = z'8004' ! 0x8004
INTEGER(GLenum), PARAMETER :: GL_BLEND_COLOR_EXT       = z'8005' ! 0x8005
!  EXT_blend_minmax values
INTEGER(GLenum), PARAMETER :: GL_FUNC_ADD_EXT          = z'8006' ! 0x8006
INTEGER(GLenum), PARAMETER :: GL_MIN_EXT               = z'8007' ! 0x8007
INTEGER(GLenum), PARAMETER :: GL_MAX_EXT               = z'8008' ! 0x8008
INTEGER(GLenum), PARAMETER :: GL_BLEND_EQUATION_EXT    = z'8009' ! 0x8009
!  EXT_blend_subtract values
INTEGER(GLenum), PARAMETER :: GL_FUNC_SUBTRACT_EXT     = z'800A' ! 0x800A
INTEGER(GLenum), PARAMETER :: GL_FUNC_REVERSE_SUBTRACT_EXT = z'800B' ! 0x800B
!  EXT_texture_env_combine values
INTEGER(GLenum), PARAMETER :: GL_COMBINE_EXT           = z'8570' ! 0x8570
INTEGER(GLenum), PARAMETER :: GL_COMBINE_RGB_EXT       = z'8571' ! 0x8571
INTEGER(GLenum), PARAMETER :: GL_COMBINE_ALPHA_EXT     = z'8572' ! 0x8572
INTEGER(GLenum), PARAMETER :: GL_RGB_SCALE_EXT         = z'8573' ! 0x8573
INTEGER(GLenum), PARAMETER :: GL_ADD_SIGNED_EXT        = z'8574' ! 0x8574
INTEGER(GLenum), PARAMETER :: GL_INTERPOLATE_EXT       = z'8575' ! 0x8575
INTEGER(GLenum), PARAMETER :: GL_CONSTANT_EXT          = z'8576' ! 0x8576
INTEGER(GLenum), PARAMETER :: GL_PRIMARY_COLOR_EXT     = z'8577' ! 0x8577
INTEGER(GLenum), PARAMETER :: GL_PREVIOUS_EXT          = z'8578' ! 0x8578
INTEGER(GLenum), PARAMETER :: GL_SOURCE0_RGB_EXT       = z'8580' ! 0x8580
INTEGER(GLenum), PARAMETER :: GL_SOURCE1_RGB_EXT       = z'8581' ! 0x8581
INTEGER(GLenum), PARAMETER :: GL_SOURCE2_RGB_EXT       = z'8582' ! 0x8582
INTEGER(GLenum), PARAMETER :: GL_SOURCE0_ALPHA_EXT     = z'8588' ! 0x8588
INTEGER(GLenum), PARAMETER :: GL_SOURCE1_ALPHA_EXT     = z'8589' ! 0x8589
INTEGER(GLenum), PARAMETER :: GL_SOURCE2_ALPHA_EXT     = z'858A' ! 0x858A
INTEGER(GLenum), PARAMETER :: GL_OPERAND0_RGB_EXT      = z'8590' ! 0x8590
INTEGER(GLenum), PARAMETER :: GL_OPERAND1_RGB_EXT      = z'8591' ! 0x8591
INTEGER(GLenum), PARAMETER :: GL_OPERAND2_RGB_EXT      = z'8592' ! 0x8592
INTEGER(GLenum), PARAMETER :: GL_OPERAND0_ALPHA_EXT    = z'8598' ! 0x8598
INTEGER(GLenum), PARAMETER :: GL_OPERAND1_ALPHA_EXT    = z'8599' ! 0x8599
INTEGER(GLenum), PARAMETER :: GL_OPERAND2_ALPHA_EXT    = z'859A' ! 0x859A


INTERFACE
!  display-list  commands

!  NewList(list, mode)
!  return  void
!  param   list		List in value
!  param   mode		ListMode in value
SUBROUTINE glNewList(list, mode) BIND(C,NAME="glNewList")
IMPORT
INTEGER(GLenum), VALUE :: mode
INTEGER(GLint), VALUE :: list
END SUBROUTINE glNewList

!  EndList()
!  return  void
SUBROUTINE glEndList() BIND(C,NAME="glEndList")
IMPORT
END SUBROUTINE glEndList

!  CallList(list)
!  return  void
!  param   list		List in value
SUBROUTINE glCallList(list) BIND(C,NAME="glCallList")
IMPORT
INTEGER(GLint), VALUE :: list
END SUBROUTINE glCallList

!  CallLists(n, type, lists)
!  return  void
!  param   n		SizeI in value
!  param   type		ListNameType in value
!  param   lists		Void in array [COMPSIZE(n/type)]
SUBROUTINE glCallLists(n, type, lists) BIND(C,NAME="glCallLists")
IMPORT
INTEGER(GLenum), VALUE :: type
INTEGER(GLsizei), VALUE :: n
TYPE(C_PTR), VALUE :: lists
END SUBROUTINE glCallLists

!  DeleteLists(list, range)
!  return  void
!  param   list		List in value
!  param   range		SizeI in value
SUBROUTINE glDeleteLists(list, range) BIND(C,NAME="glDeleteLists")
IMPORT
INTEGER(GLint), VALUE :: list
INTEGER(GLsizei), VALUE :: range
END SUBROUTINE glDeleteLists

!  GenLists(range)
!  return  List
!  param   range		SizeI in value
FUNCTION glGenLists(range) BIND(C,NAME="glGenLists")
IMPORT
INTEGER(GLint) :: glGenLists
INTEGER(GLsizei), VALUE :: range
END FUNCTION glGenLists

!  ListBase(base)
!  return  void
!  param   base		List in value
SUBROUTINE glListBase(base) BIND(C,NAME="glListBase")
IMPORT
INTEGER(GLint), VALUE :: base
END SUBROUTINE glListBase

!  drawing  commands

!  Begin(mode)
!  return  void
!  param   mode		BeginMode in value
SUBROUTINE glBegin(mode) BIND(C,NAME="glBegin")
IMPORT
INTEGER(GLenum), VALUE :: mode
END SUBROUTINE glBegin

!  Bitmap(width, height, xorig, yorig, xmove, ymove, bitmap)
!  return  void
!  param   width		SizeI in value
!  param   height		SizeI in value
!  param   xorig		CoordF in value
!  param   yorig		CoordF in value
!  param   xmove		CoordF in value
!  param   ymove		CoordF in value
!  param   bitmap		UInt8 in array [COMPSIZE(width/height)]
SUBROUTINE glBitmap(width, height, xorig, yorig, xmove, ymove, bitmap)        &
    BIND(C,NAME="glBitmap")
IMPORT
INTEGER(GLsizei), VALUE :: width, height
REAL(GLfloat), VALUE :: xorig, yorig, xmove, ymove
INTEGER(GLbyte), DIMENSION(*), INTENT(IN) :: bitmap
END SUBROUTINE glBitmap

!  Color3b(red, green, blue)
!  return  void
!  param   red		ColorB in value
!  param   green		ColorB in value
!  param   blue		ColorB in value
SUBROUTINE glColor3b(red, green, blue) BIND(C,NAME="glColor3b")
IMPORT
INTEGER(GLbyte), VALUE :: red, green, blue
END SUBROUTINE glColor3b

!  Color3bv(v)
!  return  void
!  param   v		ColorB in array [3]
SUBROUTINE glColor3bv(v) BIND(C,NAME="glColor3bv")
IMPORT
INTEGER(GLbyte), DIMENSION(3), INTENT(IN) :: v
END SUBROUTINE glColor3bv

!  Color3d(red, green, blue)
!  return  void
!  param   red		ColorD in value
!  param   green		ColorD in value
!  param   blue		ColorD in value
SUBROUTINE glColor3d(red, green, blue) BIND(C,NAME="glColor3d")
IMPORT
REAL(GLdouble), VALUE :: red, green, blue
END SUBROUTINE glColor3d

!  Color3dv(v)
!  return  void
!  param   v		ColorD in array [3]
SUBROUTINE glColor3dv(v) BIND(C,NAME="glColor3dv")
IMPORT
REAL(GLdouble), DIMENSION(3), INTENT(IN) :: v
END SUBROUTINE glColor3dv

!  Color3f(red, green, blue)
!  return  void
!  param   red		ColorF in value
!  param   green		ColorF in value
!  param   blue		ColorF in value
SUBROUTINE glColor3f(red, green, blue) BIND(C,NAME="glColor3f")
IMPORT
REAL(GLfloat), VALUE :: red, green, blue
END SUBROUTINE glColor3f

!  Color3fv(v)
!  return  void
!  param   v		ColorF in array [3]
SUBROUTINE glColor3fv(v) BIND(C,NAME="glColor3fv")
IMPORT
REAL(GLfloat), DIMENSION(3), INTENT(IN) :: v
END SUBROUTINE glColor3fv

!  Color3i(red, green, blue)
!  return  void
!  param   red		ColorI in value
!  param   green		ColorI in value
!  param   blue		ColorI in value
SUBROUTINE glColor3i(red, green, blue) BIND(C,NAME="glColor3i")
IMPORT
INTEGER(GLint), VALUE :: red, green, blue
END SUBROUTINE glColor3i

!  Color3iv(v)
!  return  void
!  param   v		ColorI in array [3]
SUBROUTINE glColor3iv(v) BIND(C,NAME="glColor3iv")
IMPORT
INTEGER(GLint), DIMENSION(3), INTENT(IN) :: v
END SUBROUTINE glColor3iv

!  Color3s(red, green, blue)
!  return  void
!  param   red		ColorS in value
!  param   green		ColorS in value
!  param   blue		ColorS in value
SUBROUTINE glColor3s(red, green, blue) BIND(C,NAME="glColor3s")
IMPORT
INTEGER(GLshort), VALUE :: red, green, blue
END SUBROUTINE glColor3s

!  Color3sv(v)
!  return  void
!  param   v		ColorS in array [3]
SUBROUTINE glColor3sv(v) BIND(C,NAME="glColor3sv")
IMPORT
INTEGER(GLshort), DIMENSION(3), INTENT(IN) :: v
END SUBROUTINE glColor3sv

!  Color3ub(red, green, blue)
!  return  void
!  param   red		ColorUB in value
!  param   green		ColorUB in value
!  param   blue		ColorUB in value
SUBROUTINE glColor3ub(red, green, blue) BIND(C,NAME="glColor3ub")
IMPORT
INTEGER(GLbyte), VALUE :: red, green, blue
END SUBROUTINE glColor3ub

!  Color3ubv(v)
!  return  void
!  param   v		ColorUB in array [3]
SUBROUTINE glColor3ubv(v) BIND(C,NAME="glColor3ubv")
IMPORT
INTEGER(GLbyte), DIMENSION(3), INTENT(IN) :: v
END SUBROUTINE glColor3ubv

!  Color3ui(red, green, blue)
!  return  void
!  param   red		ColorUI in value
!  param   green		ColorUI in value
!  param   blue		ColorUI in value
SUBROUTINE glColor3ui(red, green, blue) BIND(C,NAME="glColor3ui")
IMPORT
INTEGER(GLint), VALUE :: red, green, blue
END SUBROUTINE glColor3ui

!  Color3uiv(v)
!  return  void
!  param   v		ColorUI in array [3]
SUBROUTINE glColor3uiv(v) BIND(C,NAME="glColor3uiv")
IMPORT
INTEGER(GLint), DIMENSION(3), INTENT(IN) :: v
END SUBROUTINE glColor3uiv

!  Color3us(red, green, blue)
!  return  void
!  param   red		ColorUS in value
!  param   green		ColorUS in value
!  param   blue		ColorUS in value
SUBROUTINE glColor3us(red, green, blue) BIND(C,NAME="glColor3us")
IMPORT
INTEGER(GLshort), VALUE :: red, green, blue
END SUBROUTINE glColor3us

!  Color3usv(v)
!  return  void
!  param   v		ColorUS in array [3]
SUBROUTINE glColor3usv(v) BIND(C,NAME="glColor3usv")
IMPORT
INTEGER(GLshort), DIMENSION(3), INTENT(IN) :: v
END SUBROUTINE glColor3usv

!  Color4b(red, green, blue, alpha)
!  return  void
!  param   red		ColorB in value
!  param   green		ColorB in value
!  param   blue		ColorB in value
!  param   alpha		ColorB in value
SUBROUTINE glColor4b(red, green, blue, alpha) BIND(C,NAME="glColor4b")
IMPORT
INTEGER(GLbyte), VALUE :: red, green, blue, alpha
END SUBROUTINE glColor4b

!  Color4bv(v)
!  return  void
!  param   v		ColorB in array [4]
SUBROUTINE glColor4bv(v) BIND(C,NAME="glColor4bv")
IMPORT
INTEGER(GLbyte), DIMENSION(4), INTENT(IN) :: v
END SUBROUTINE glColor4bv

!  Color4d(red, green, blue, alpha)
!  return  void
!  param   red		ColorD in value
!  param   green		ColorD in value
!  param   blue		ColorD in value
!  param   alpha		ColorD in value
SUBROUTINE glColor4d(red, green, blue, alpha) BIND(C,NAME="glColor4d")
IMPORT
REAL(GLdouble), VALUE :: red, green, blue, alpha
END SUBROUTINE glColor4d

!  Color4dv(v)
!  return  void
!  param   v		ColorD in array [4]
SUBROUTINE glColor4dv(v) BIND(C,NAME="glColor4dv")
IMPORT
REAL(GLdouble), DIMENSION(4), INTENT(IN) :: v
END SUBROUTINE glColor4dv

!  Color4f(red, green, blue, alpha)
!  return  void
!  param   red		ColorF in value
!  param   green		ColorF in value
!  param   blue		ColorF in value
!  param   alpha		ColorF in value
SUBROUTINE glColor4f(red, green, blue, alpha) BIND(C,NAME="glColor4f")
IMPORT
REAL(GLfloat), VALUE :: red, green, blue, alpha
END SUBROUTINE glColor4f

!  Color4fv(v)
!  return  void
!  param   v		ColorF in array [4]
SUBROUTINE glColor4fv(v) BIND(C,NAME="glColor4fv")
IMPORT
REAL(GLfloat), DIMENSION(4), INTENT(IN) :: v
END SUBROUTINE glColor4fv

!  Color4i(red, green, blue, alpha)
!  return  void
!  param   red		ColorI in value
!  param   green		ColorI in value
!  param   blue		ColorI in value
!  param   alpha		ColorI in value
SUBROUTINE glColor4i(red, green, blue, alpha) BIND(C,NAME="glColor4i")
IMPORT
INTEGER(GLint), VALUE :: red, green, blue, alpha
END SUBROUTINE glColor4i

!  Color4iv(v)
!  return  void
!  param   v		ColorI in array [4]
SUBROUTINE glColor4iv(v) BIND(C,NAME="glColor4iv")
IMPORT
INTEGER(GLint), DIMENSION(4), INTENT(IN) :: v
END SUBROUTINE glColor4iv

!  Color4s(red, green, blue, alpha)
!  return  void
!  param   red		ColorS in value
!  param   green		ColorS in value
!  param   blue		ColorS in value
!  param   alpha		ColorS in value
SUBROUTINE glColor4s(red, green, blue, alpha) BIND(C,NAME="glColor4s")
IMPORT
INTEGER(GLshort), VALUE :: red, green, blue, alpha
END SUBROUTINE glColor4s

!  Color4sv(v)
!  return  void
!  param   v		ColorS in array [4]
SUBROUTINE glColor4sv(v) BIND(C,NAME="glColor4sv")
IMPORT
INTEGER(GLshort), DIMENSION(4), INTENT(IN) :: v
END SUBROUTINE glColor4sv

!  Color4ub(red, green, blue, alpha)
!  return  void
!  param   red		ColorUB in value
!  param   green		ColorUB in value
!  param   blue		ColorUB in value
!  param   alpha		ColorUB in value
SUBROUTINE glColor4ub(red, green, blue, alpha) BIND(C,NAME="glColor4ub")
IMPORT
INTEGER(GLbyte), VALUE :: red, green, blue, alpha
END SUBROUTINE glColor4ub

!  Color4ubv(v)
!  return  void
!  param   v		ColorUB in array [4]
SUBROUTINE glColor4ubv(v) BIND(C,NAME="glColor4ubv")
IMPORT
INTEGER(GLbyte), DIMENSION(4), INTENT(IN) :: v
END SUBROUTINE glColor4ubv

!  Color4ui(red, green, blue, alpha)
!  return  void
!  param   red		ColorUI in value
!  param   green		ColorUI in value
!  param   blue		ColorUI in value
!  param   alpha		ColorUI in value
SUBROUTINE glColor4ui(red, green, blue, alpha) BIND(C,NAME="glColor4ui")
IMPORT
INTEGER(GLint), VALUE :: red, green, blue, alpha
END SUBROUTINE glColor4ui

!  Color4uiv(v)
!  return  void
!  param   v		ColorUI in array [4]
SUBROUTINE glColor4uiv(v) BIND(C,NAME="glColor4uiv")
IMPORT
INTEGER(GLint), DIMENSION(4), INTENT(IN) :: v
END SUBROUTINE glColor4uiv

!  Color4us(red, green, blue, alpha)
!  return  void
!  param   red		ColorUS in value
!  param   green		ColorUS in value
!  param   blue		ColorUS in value
!  param   alpha		ColorUS in value
SUBROUTINE glColor4us(red, green, blue, alpha) BIND(C,NAME="glColor4us")
IMPORT
INTEGER(GLshort), VALUE :: red, green, blue, alpha
END SUBROUTINE glColor4us

!  Color4usv(v)
!  return  void
!  param   v		ColorUS in array [4]
SUBROUTINE glColor4usv(v) BIND(C,NAME="glColor4usv")
IMPORT
INTEGER(GLshort), DIMENSION(4), INTENT(IN) :: v
END SUBROUTINE glColor4usv

!  EdgeFlag(flag)
!  return  void
!  param   flag		Boolean in value
SUBROUTINE glEdgeFlag(flag) BIND(C,NAME="glEdgeFlag")
IMPORT
INTEGER(GLboolean), VALUE :: flag
END SUBROUTINE glEdgeFlag

!  EdgeFlagv(flag)
!  return  void
!  param   flag		Boolean in array [1]
SUBROUTINE glEdgeFlagv(flag) BIND(C,NAME="glEdgeFlagv")
IMPORT
INTEGER(GLboolean), INTENT(IN) :: flag
END SUBROUTINE glEdgeFlagv

!  End()
!  return  void
SUBROUTINE glEnd() BIND(C,NAME="glEnd")
IMPORT
END SUBROUTINE glEnd

!  Indexd(c)
!  return  void
!  param   c		ColorIndexValueD in value
SUBROUTINE glIndexd(c) BIND(C,NAME="glIndexd")
IMPORT
REAL(GLdouble), VALUE :: c
END SUBROUTINE glIndexd

!  Indexdv(c)
!  return  void
!  param   c		ColorIndexValueD in array [1]
SUBROUTINE glIndexdv(c) BIND(C,NAME="glIndexdv")
IMPORT
REAL(GLdouble), INTENT(IN) :: c
END SUBROUTINE glIndexdv

!  Indexf(c)
!  return  void
!  param   c		ColorIndexValueF in value
SUBROUTINE glIndexf(c) BIND(C,NAME="glIndexf")
IMPORT
REAL(GLfloat), VALUE :: c
END SUBROUTINE glIndexf

!  Indexfv(c)
!  return  void
!  param   c		ColorIndexValueF in array [1]
SUBROUTINE glIndexfv(c) BIND(C,NAME="glIndexfv")
IMPORT
REAL(GLfloat), INTENT(IN) :: c
END SUBROUTINE glIndexfv

!  Indexi(c)
!  return  void
!  param   c		ColorIndexValueI in value
SUBROUTINE glIndexi(c) BIND(C,NAME="glIndexi")
IMPORT
INTEGER(GLint), VALUE :: c
END SUBROUTINE glIndexi

!  Indexiv(c)
!  return  void
!  param   c		ColorIndexValueI in array [1]
SUBROUTINE glIndexiv(c) BIND(C,NAME="glIndexiv")
IMPORT
INTEGER(GLint), INTENT(IN) :: c
END SUBROUTINE glIndexiv

!  Indexs(c)
!  return  void
!  param   c		ColorIndexValueS in value
SUBROUTINE glIndexs(c) BIND(C,NAME="glIndexs")
IMPORT
INTEGER(GLshort), VALUE :: c
END SUBROUTINE glIndexs

!  Indexsv(c)
!  return  void
!  param   c		ColorIndexValueS in array [1]
SUBROUTINE glIndexsv(c) BIND(C,NAME="glIndexsv")
IMPORT
INTEGER(GLshort), INTENT(IN) :: c
END SUBROUTINE glIndexsv

!  Normal3b(nx, ny, nz)
!  return  void
!  param   nx		Int8 in value
!  param   ny		Int8 in value
!  param   nz		Int8 in value
SUBROUTINE glNormal3b(nx, ny, nz) BIND(C,NAME="glNormal3b")
IMPORT
INTEGER(GLbyte), VALUE :: nx, ny, nz
END SUBROUTINE glNormal3b

!  Normal3bv(v)
!  return  void
!  param   v		Int8 in array [3]
SUBROUTINE glNormal3bv(v) BIND(C,NAME="glNormal3bv")
IMPORT
INTEGER(GLbyte), DIMENSION(3), INTENT(IN) :: v
END SUBROUTINE glNormal3bv

!  Normal3d(nx, ny, nz)
!  return  void
!  param   nx		CoordD in value
!  param   ny		CoordD in value
!  param   nz		CoordD in value
SUBROUTINE glNormal3d(nx, ny, nz) BIND(C,NAME="glNormal3d")
IMPORT
REAL(GLdouble), VALUE :: nx, ny, nz
END SUBROUTINE glNormal3d

!  Normal3dv(v)
!  return  void
!  param   v		CoordD in array [3]
SUBROUTINE glNormal3dv(v) BIND(C,NAME="glNormal3dv")
IMPORT
REAL(GLdouble), DIMENSION(3), INTENT(IN) :: v
END SUBROUTINE glNormal3dv

!  Normal3f(nx, ny, nz)
!  return  void
!  param   nx		CoordF in value
!  param   ny		CoordF in value
!  param   nz		CoordF in value
SUBROUTINE glNormal3f(nx, ny, nz) BIND(C,NAME="glNormal3f")
IMPORT
REAL(GLfloat), VALUE :: nx, ny, nz
END SUBROUTINE glNormal3f

!  Normal3fv(v)
!  return  void
!  param   v		CoordF in array [3]
SUBROUTINE glNormal3fv(v) BIND(C,NAME="glNormal3fv")
IMPORT
REAL(GLfloat), DIMENSION(3), INTENT(IN) :: v
END SUBROUTINE glNormal3fv

!  Normal3i(nx, ny, nz)
!  return  void
!  param   nx		Int32 in value
!  param   ny		Int32 in value
!  param   nz		Int32 in value
SUBROUTINE glNormal3i(nx, ny, nz) BIND(C,NAME="glNormal3i")
IMPORT
INTEGER(GLint), VALUE :: nx, ny, nz
END SUBROUTINE glNormal3i

!  Normal3iv(v)
!  return  void
!  param   v		Int32 in array [3]
SUBROUTINE glNormal3iv(v) BIND(C,NAME="glNormal3iv")
IMPORT
INTEGER(GLint), DIMENSION(3), INTENT(IN) :: v
END SUBROUTINE glNormal3iv

!  Normal3s(nx, ny, nz)
!  return  void
!  param   nx		Int16 in value
!  param   ny		Int16 in value
!  param   nz		Int16 in value
SUBROUTINE glNormal3s(nx, ny, nz) BIND(C,NAME="glNormal3s")
IMPORT
INTEGER(GLshort), VALUE :: nx, ny, nz
END SUBROUTINE glNormal3s

!  Normal3sv(v)
!  return  void
!  param   v		Int16 in array [3]
SUBROUTINE glNormal3sv(v) BIND(C,NAME="glNormal3sv")
IMPORT
INTEGER(GLshort), DIMENSION(3), INTENT(IN) :: v
END SUBROUTINE glNormal3sv

!  RasterPos2d(x, y)
!  return  void
!  param   x		CoordD in value
!  param   y		CoordD in value
SUBROUTINE glRasterPos2d(x, y) BIND(C,NAME="glRasterPos2d")
IMPORT
REAL(GLdouble), VALUE :: x, y
END SUBROUTINE glRasterPos2d

!  RasterPos2dv(v)
!  return  void
!  param   v		CoordD in array [2]
SUBROUTINE glRasterPos2dv(v) BIND(C,NAME="glRasterPos2dv")
IMPORT
REAL(GLdouble), DIMENSION(2), INTENT(IN) :: v
END SUBROUTINE glRasterPos2dv

!  RasterPos2f(x, y)
!  return  void
!  param   x		CoordF in value
!  param   y		CoordF in value
SUBROUTINE glRasterPos2f(x, y) BIND(C,NAME="glRasterPos2f")
IMPORT
REAL(GLfloat), VALUE :: x, y
END SUBROUTINE glRasterPos2f

!  RasterPos2fv(v)
!  return  void
!  param   v		CoordF in array [2]
SUBROUTINE glRasterPos2fv(v) BIND(C,NAME="glRasterPos2fv")
IMPORT
REAL(GLfloat), DIMENSION(2), INTENT(IN) :: v
END SUBROUTINE glRasterPos2fv

!  RasterPos2i(x, y)
!  return  void
!  param   x		CoordI in value
!  param   y		CoordI in value
SUBROUTINE glRasterPos2i(x, y) BIND(C,NAME="glRasterPos2i")
IMPORT
INTEGER(GLint), VALUE :: x, y
END SUBROUTINE glRasterPos2i

!  RasterPos2iv(v)
!  return  void
!  param   v		CoordI in array [2]
SUBROUTINE glRasterPos2iv(v) BIND(C,NAME="glRasterPos2iv")
IMPORT
INTEGER(GLint), DIMENSION(2), INTENT(IN) :: v
END SUBROUTINE glRasterPos2iv

!  RasterPos2s(x, y)
!  return  void
!  param   x		CoordS in value
!  param   y		CoordS in value
SUBROUTINE glRasterPos2s(x, y) BIND(C,NAME="glRasterPos2s")
IMPORT
INTEGER(GLshort), VALUE :: x, y
END SUBROUTINE glRasterPos2s

!  RasterPos2sv(v)
!  return  void
!  param   v		CoordS in array [2]
SUBROUTINE glRasterPos2sv(v) BIND(C,NAME="glRasterPos2sv")
IMPORT
INTEGER(GLshort), DIMENSION(2), INTENT(IN) :: v
END SUBROUTINE glRasterPos2sv

!  RasterPos3d(x, y, z)
!  return  void
!  param   x		CoordD in value
!  param   y		CoordD in value
!  param   z		CoordD in value
SUBROUTINE glRasterPos3d(x, y, z) BIND(C,NAME="glRasterPos3d")
IMPORT
REAL(GLdouble), VALUE :: x, y, z
END SUBROUTINE glRasterPos3d

!  RasterPos3dv(v)
!  return  void
!  param   v		CoordD in array [3]
SUBROUTINE glRasterPos3dv(v) BIND(C,NAME="glRasterPos3dv")
IMPORT
REAL(GLdouble), DIMENSION(3), INTENT(IN) :: v
END SUBROUTINE glRasterPos3dv

!  RasterPos3f(x, y, z)
!  return  void
!  param   x		CoordF in value
!  param   y		CoordF in value
!  param   z		CoordF in value
SUBROUTINE glRasterPos3f(x, y, z) BIND(C,NAME="glRasterPos3f")
IMPORT
REAL(GLfloat), VALUE :: x, y, z
END SUBROUTINE glRasterPos3f

!  RasterPos3fv(v)
!  return  void
!  param   v		CoordF in array [3]
SUBROUTINE glRasterPos3fv(v) BIND(C,NAME="glRasterPos3fv")
IMPORT
REAL(GLfloat), DIMENSION(3), INTENT(IN) :: v
END SUBROUTINE glRasterPos3fv

!  RasterPos3i(x, y, z)
!  return  void
!  param   x		CoordI in value
!  param   y		CoordI in value
!  param   z		CoordI in value
SUBROUTINE glRasterPos3i(x, y, z) BIND(C,NAME="glRasterPos3i")
IMPORT
INTEGER(GLint), VALUE :: x, y, z
END SUBROUTINE glRasterPos3i

!  RasterPos3iv(v)
!  return  void
!  param   v		CoordI in array [3]
SUBROUTINE glRasterPos3iv(v) BIND(C,NAME="glRasterPos3iv")
IMPORT
INTEGER(GLint), DIMENSION(3), INTENT(IN) :: v
END SUBROUTINE glRasterPos3iv

!  RasterPos3s(x, y, z)
!  return  void
!  param   x		CoordS in value
!  param   y		CoordS in value
!  param   z		CoordS in value
SUBROUTINE glRasterPos3s(x, y, z) BIND(C,NAME="glRasterPos3s")
IMPORT
INTEGER(GLshort), VALUE :: x, y, z
END SUBROUTINE glRasterPos3s

!  RasterPos3sv(v)
!  return  void
!  param   v		CoordS in array [3]
SUBROUTINE glRasterPos3sv(v) BIND(C,NAME="glRasterPos3sv")
IMPORT
INTEGER(GLshort), DIMENSION(3), INTENT(IN) :: v
END SUBROUTINE glRasterPos3sv

!  RasterPos4d(x, y, z, w)
!  return  void
!  param   x		CoordD in value
!  param   y		CoordD in value
!  param   z		CoordD in value
!  param   w		CoordD in value
SUBROUTINE glRasterPos4d(x, y, z, w) BIND(C,NAME="glRasterPos4d")
IMPORT
REAL(GLdouble), VALUE :: x, y, z, w
END SUBROUTINE glRasterPos4d

!  RasterPos4dv(v)
!  return  void
!  param   v		CoordD in array [4]
SUBROUTINE glRasterPos4dv(v) BIND(C,NAME="glRasterPos4dv")
IMPORT
REAL(GLdouble), DIMENSION(4), INTENT(IN) :: v
END SUBROUTINE glRasterPos4dv

!  RasterPos4f(x, y, z, w)
!  return  void
!  param   x		CoordF in value
!  param   y		CoordF in value
!  param   z		CoordF in value
!  param   w		CoordF in value
SUBROUTINE glRasterPos4f(x, y, z, w) BIND(C,NAME="glRasterPos4f")
IMPORT
REAL(GLfloat), VALUE :: x, y, z, w
END SUBROUTINE glRasterPos4f

!  RasterPos4fv(v)
!  return  void
!  param   v		CoordF in array [4]
SUBROUTINE glRasterPos4fv(v) BIND(C,NAME="glRasterPos4fv")
IMPORT
REAL(GLfloat), DIMENSION(4), INTENT(IN) :: v
END SUBROUTINE glRasterPos4fv

!  RasterPos4i(x, y, z, w)
!  return  void
!  param   x		CoordI in value
!  param   y		CoordI in value
!  param   z		CoordI in value
!  param   w		CoordI in value
SUBROUTINE glRasterPos4i(x, y, z, w) BIND(C,NAME="glRasterPos4i")
IMPORT
INTEGER(GLint), VALUE :: x, y, z, w
END SUBROUTINE glRasterPos4i

!  RasterPos4iv(v)
!  return  void
!  param   v		CoordI in array [4]
SUBROUTINE glRasterPos4iv(v) BIND(C,NAME="glRasterPos4iv")
IMPORT
INTEGER(GLint), DIMENSION(4), INTENT(IN) :: v
END SUBROUTINE glRasterPos4iv

!  RasterPos4s(x, y, z, w)
!  return  void
!  param   x		CoordS in value
!  param   y		CoordS in value
!  param   z		CoordS in value
!  param   w		CoordS in value
SUBROUTINE glRasterPos4s(x, y, z, w) BIND(C,NAME="glRasterPos4s")
IMPORT
INTEGER(GLshort), VALUE :: x, y, z, w
END SUBROUTINE glRasterPos4s

!  RasterPos4sv(v)
!  return  void
!  param   v		CoordS in array [4]
SUBROUTINE glRasterPos4sv(v) BIND(C,NAME="glRasterPos4sv")
IMPORT
INTEGER(GLshort), DIMENSION(4), INTENT(IN) :: v
END SUBROUTINE glRasterPos4sv

!  Rectd(x1, y1, x2, y2)
!  return  void
!  param   x1		CoordD in value
!  param   y1		CoordD in value
!  param   x2		CoordD in value
!  param   y2		CoordD in value
SUBROUTINE glRectd(x1, y1, x2, y2) BIND(C,NAME="glRectd")
IMPORT
REAL(GLdouble), VALUE :: x1, y1, x2, y2
END SUBROUTINE glRectd

!  Rectdv(v1, v2)
!  return  void
!  param   v1		CoordD in array [2]
!  param   v2		CoordD in array [2]
SUBROUTINE glRectdv(v1, v2) BIND(C,NAME="glRectdv")
IMPORT
REAL(GLdouble), DIMENSION(2), INTENT(IN) :: v1, v2
END SUBROUTINE glRectdv

!  Rectf(x1, y1, x2, y2)
!  return  void
!  param   x1		CoordF in value
!  param   y1		CoordF in value
!  param   x2		CoordF in value
!  param   y2		CoordF in value
SUBROUTINE glRectf(x1, y1, x2, y2) BIND(C,NAME="glRectf")
IMPORT
REAL(GLfloat), VALUE :: x1, y1, x2, y2
END SUBROUTINE glRectf

!  Rectfv(v1, v2)
!  return  void
!  param   v1		CoordF in array [2]
!  param   v2		CoordF in array [2]
SUBROUTINE glRectfv(v1, v2) BIND(C,NAME="glRectfv")
IMPORT
REAL(GLfloat), DIMENSION(2), INTENT(IN) :: v1, v2
END SUBROUTINE glRectfv

!  Recti(x1, y1, x2, y2)
!  return  void
!  param   x1		CoordI in value
!  param   y1		CoordI in value
!  param   x2		CoordI in value
!  param   y2		CoordI in value
SUBROUTINE glRecti(x1, y1, x2, y2) BIND(C,NAME="glRecti")
IMPORT
INTEGER(GLint), VALUE :: x1, y1, x2, y2
END SUBROUTINE glRecti

!  Rectiv(v1, v2)
!  return  void
!  param   v1		CoordI in array [2]
!  param   v2		CoordI in array [2]
SUBROUTINE glRectiv(v1, v2) BIND(C,NAME="glRectiv")
IMPORT
INTEGER(GLint), DIMENSION(2), INTENT(IN) :: v1, v2
END SUBROUTINE glRectiv

!  Rects(x1, y1, x2, y2)
!  return  void
!  param   x1		CoordS in value
!  param   y1		CoordS in value
!  param   x2		CoordS in value
!  param   y2		CoordS in value
SUBROUTINE glRects(x1, y1, x2, y2) BIND(C,NAME="glRects")
IMPORT
INTEGER(GLshort), VALUE :: x1, y1, x2, y2
END SUBROUTINE glRects

!  Rectsv(v1, v2)
!  return  void
!  param   v1		CoordS in array [2]
!  param   v2		CoordS in array [2]
SUBROUTINE glRectsv(v1, v2) BIND(C,NAME="glRectsv")
IMPORT
INTEGER(GLshort), DIMENSION(2), INTENT(IN) :: v1, v2
END SUBROUTINE glRectsv

!  TexCoord1d(s)
!  return  void
!  param   s		CoordD in value
SUBROUTINE glTexCoord1d(s) BIND(C,NAME="glTexCoord1d")
IMPORT
REAL(GLdouble), VALUE :: s
END SUBROUTINE glTexCoord1d

!  TexCoord1dv(v)
!  return  void
!  param   v		CoordD in array [1]
SUBROUTINE glTexCoord1dv(v) BIND(C,NAME="glTexCoord1dv")
IMPORT
REAL(GLdouble), INTENT(IN) :: v
END SUBROUTINE glTexCoord1dv

!  TexCoord1f(s)
!  return  void
!  param   s		CoordF in value
SUBROUTINE glTexCoord1f(s) BIND(C,NAME="glTexCoord1f")
IMPORT
REAL(GLfloat), VALUE :: s
END SUBROUTINE glTexCoord1f

!  TexCoord1fv(v)
!  return  void
!  param   v		CoordF in array [1]
SUBROUTINE glTexCoord1fv(v) BIND(C,NAME="glTexCoord1fv")
IMPORT
REAL(GLfloat), INTENT(IN) :: v
END SUBROUTINE glTexCoord1fv

!  TexCoord1i(s)
!  return  void
!  param   s		CoordI in value
SUBROUTINE glTexCoord1i(s) BIND(C,NAME="glTexCoord1i")
IMPORT
INTEGER(GLint), VALUE :: s
END SUBROUTINE glTexCoord1i

!  TexCoord1iv(v)
!  return  void
!  param   v		CoordI in array [1]
SUBROUTINE glTexCoord1iv(v) BIND(C,NAME="glTexCoord1iv")
IMPORT
INTEGER(GLint), INTENT(IN) :: v
END SUBROUTINE glTexCoord1iv

!  TexCoord1s(s)
!  return  void
!  param   s		CoordS in value
SUBROUTINE glTexCoord1s(s) BIND(C,NAME="glTexCoord1s")
IMPORT
INTEGER(GLshort), VALUE :: s
END SUBROUTINE glTexCoord1s

!  TexCoord1sv(v)
!  return  void
!  param   v		CoordS in array [1]
SUBROUTINE glTexCoord1sv(v) BIND(C,NAME="glTexCoord1sv")
IMPORT
INTEGER(GLshort), INTENT(IN) :: v
END SUBROUTINE glTexCoord1sv

!  TexCoord2d(s, t)
!  return  void
!  param   s		CoordD in value
!  param   t		CoordD in value
SUBROUTINE glTexCoord2d(s, t) BIND(C,NAME="glTexCoord2d")
IMPORT
REAL(GLdouble), VALUE :: s, t
END SUBROUTINE glTexCoord2d

!  TexCoord2dv(v)
!  return  void
!  param   v		CoordD in array [2]
SUBROUTINE glTexCoord2dv(v) BIND(C,NAME="glTexCoord2dv")
IMPORT
REAL(GLdouble), DIMENSION(2), INTENT(IN) :: v
END SUBROUTINE glTexCoord2dv

!  TexCoord2f(s, t)
!  return  void
!  param   s		CoordF in value
!  param   t		CoordF in value
SUBROUTINE glTexCoord2f(s, t) BIND(C,NAME="glTexCoord2f")
IMPORT
REAL(GLfloat), VALUE :: s, t
END SUBROUTINE glTexCoord2f

!  TexCoord2fv(v)
!  return  void
!  param   v		CoordF in array [2]
SUBROUTINE glTexCoord2fv(v) BIND(C,NAME="glTexCoord2fv")
IMPORT
REAL(GLfloat), DIMENSION(2), INTENT(IN) :: v
END SUBROUTINE glTexCoord2fv

!  TexCoord2i(s, t)
!  return  void
!  param   s		CoordI in value
!  param   t		CoordI in value
SUBROUTINE glTexCoord2i(s, t) BIND(C,NAME="glTexCoord2i")
IMPORT
INTEGER(GLint), VALUE :: s, t
END SUBROUTINE glTexCoord2i

!  TexCoord2iv(v)
!  return  void
!  param   v		CoordI in array [2]
SUBROUTINE glTexCoord2iv(v) BIND(C,NAME="glTexCoord2iv")
IMPORT
INTEGER(GLint), DIMENSION(2), INTENT(IN) :: v
END SUBROUTINE glTexCoord2iv

!  TexCoord2s(s, t)
!  return  void
!  param   s		CoordS in value
!  param   t		CoordS in value
SUBROUTINE glTexCoord2s(s, t) BIND(C,NAME="glTexCoord2s")
IMPORT
INTEGER(GLshort), VALUE :: s, t
END SUBROUTINE glTexCoord2s

!  TexCoord2sv(v)
!  return  void
!  param   v		CoordS in array [2]
SUBROUTINE glTexCoord2sv(v) BIND(C,NAME="glTexCoord2sv")
IMPORT
INTEGER(GLshort), DIMENSION(2), INTENT(IN) :: v
END SUBROUTINE glTexCoord2sv

!  TexCoord3d(s, t, r)
!  return  void
!  param   s		CoordD in value
!  param   t		CoordD in value
!  param   r		CoordD in value
SUBROUTINE glTexCoord3d(s, t, r) BIND(C,NAME="glTexCoord3d")
IMPORT
REAL(GLdouble), VALUE :: s, t, r
END SUBROUTINE glTexCoord3d

!  TexCoord3dv(v)
!  return  void
!  param   v		CoordD in array [3]
SUBROUTINE glTexCoord3dv(v) BIND(C,NAME="glTexCoord3dv")
IMPORT
REAL(GLdouble), DIMENSION(3), INTENT(IN) :: v
END SUBROUTINE glTexCoord3dv

!  TexCoord3f(s, t, r)
!  return  void
!  param   s		CoordF in value
!  param   t		CoordF in value
!  param   r		CoordF in value
SUBROUTINE glTexCoord3f(s, t, r) BIND(C,NAME="glTexCoord3f")
IMPORT
REAL(GLfloat), VALUE :: s, t, r
END SUBROUTINE glTexCoord3f

!  TexCoord3fv(v)
!  return  void
!  param   v		CoordF in array [3]
SUBROUTINE glTexCoord3fv(v) BIND(C,NAME="glTexCoord3fv")
IMPORT
REAL(GLfloat), DIMENSION(3), INTENT(IN) :: v
END SUBROUTINE glTexCoord3fv

!  TexCoord3i(s, t, r)
!  return  void
!  param   s		CoordI in value
!  param   t		CoordI in value
!  param   r		CoordI in value
SUBROUTINE glTexCoord3i(s, t, r) BIND(C,NAME="glTexCoord3i")
IMPORT
INTEGER(GLint), VALUE :: s, t, r
END SUBROUTINE glTexCoord3i

!  TexCoord3iv(v)
!  return  void
!  param   v		CoordI in array [3]
SUBROUTINE glTexCoord3iv(v) BIND(C,NAME="glTexCoord3iv")
IMPORT
INTEGER(GLint), DIMENSION(3), INTENT(IN) :: v
END SUBROUTINE glTexCoord3iv

!  TexCoord3s(s, t, r)
!  return  void
!  param   s		CoordS in value
!  param   t		CoordS in value
!  param   r		CoordS in value
SUBROUTINE glTexCoord3s(s, t, r) BIND(C,NAME="glTexCoord3s")
IMPORT
INTEGER(GLshort), VALUE :: s, t, r
END SUBROUTINE glTexCoord3s

!  TexCoord3sv(v)
!  return  void
!  param   v		CoordS in array [3]
SUBROUTINE glTexCoord3sv(v) BIND(C,NAME="glTexCoord3sv")
IMPORT
INTEGER(GLshort), DIMENSION(3), INTENT(IN) :: v
END SUBROUTINE glTexCoord3sv

!  TexCoord4d(s, t, r, q)
!  return  void
!  param   s		CoordD in value
!  param   t		CoordD in value
!  param   r		CoordD in value
!  param   q		CoordD in value
SUBROUTINE glTexCoord4d(s, t, r, q) BIND(C,NAME="glTexCoord4d")
IMPORT
REAL(GLdouble), VALUE :: s, t, r, q
END SUBROUTINE glTexCoord4d

!  TexCoord4dv(v)
!  return  void
!  param   v		CoordD in array [4]
SUBROUTINE glTexCoord4dv(v) BIND(C,NAME="glTexCoord4dv")
IMPORT
REAL(GLdouble), DIMENSION(4), INTENT(IN) :: v
END SUBROUTINE glTexCoord4dv

!  TexCoord4f(s, t, r, q)
!  return  void
!  param   s		CoordF in value
!  param   t		CoordF in value
!  param   r		CoordF in value
!  param   q		CoordF in value
SUBROUTINE glTexCoord4f(s, t, r, q) BIND(C,NAME="glTexCoord4f")
IMPORT
REAL(GLfloat), VALUE :: s, t, r, q
END SUBROUTINE glTexCoord4f

!  TexCoord4fv(v)
!  return  void
!  param   v		CoordF in array [4]
SUBROUTINE glTexCoord4fv(v) BIND(C,NAME="glTexCoord4fv")
IMPORT
REAL(GLfloat), DIMENSION(4), INTENT(IN) :: v
END SUBROUTINE glTexCoord4fv

!  TexCoord4i(s, t, r, q)
!  return  void
!  param   s		CoordI in value
!  param   t		CoordI in value
!  param   r		CoordI in value
!  param   q		CoordI in value
SUBROUTINE glTexCoord4i(s, t, r, q) BIND(C,NAME="glTexCoord4i")
IMPORT
INTEGER(GLint), VALUE :: s, t, r, q
END SUBROUTINE glTexCoord4i

!  TexCoord4iv(v)
!  return  void
!  param   v		CoordI in array [4]
SUBROUTINE glTexCoord4iv(v) BIND(C,NAME="glTexCoord4iv")
IMPORT
INTEGER(GLint), DIMENSION(4), INTENT(IN) :: v
END SUBROUTINE glTexCoord4iv

!  TexCoord4s(s, t, r, q)
!  return  void
!  param   s		CoordS in value
!  param   t		CoordS in value
!  param   r		CoordS in value
!  param   q		CoordS in value
SUBROUTINE glTexCoord4s(s, t, r, q) BIND(C,NAME="glTexCoord4s")
IMPORT
INTEGER(GLshort), VALUE :: s, t, r, q
END SUBROUTINE glTexCoord4s

!  TexCoord4sv(v)
!  return  void
!  param   v		CoordS in array [4]
SUBROUTINE glTexCoord4sv(v) BIND(C,NAME="glTexCoord4sv")
IMPORT
INTEGER(GLshort), DIMENSION(4), INTENT(IN) :: v
END SUBROUTINE glTexCoord4sv

!  Vertex2d(x, y)
!  return  void
!  param   x		CoordD in value
!  param   y		CoordD in value
SUBROUTINE glVertex2d(x, y) BIND(C,NAME="glVertex2d")
IMPORT
REAL(GLdouble), VALUE :: x, y
END SUBROUTINE glVertex2d

!  Vertex2dv(v)
!  return  void
!  param   v		CoordD in array [2]
SUBROUTINE glVertex2dv(v) BIND(C,NAME="glVertex2dv")
IMPORT
REAL(GLdouble), DIMENSION(2), INTENT(IN) :: v
END SUBROUTINE glVertex2dv

!  Vertex2f(x, y)
!  return  void
!  param   x		CoordF in value
!  param   y		CoordF in value
SUBROUTINE glVertex2f(x, y) BIND(C,NAME="glVertex2f")
IMPORT
REAL(GLfloat), VALUE :: x, y
END SUBROUTINE glVertex2f

!  Vertex2fv(v)
!  return  void
!  param   v		CoordF in array [2]
SUBROUTINE glVertex2fv(v) BIND(C,NAME="glVertex2fv")
IMPORT
REAL(GLfloat), DIMENSION(2), INTENT(IN) :: v
END SUBROUTINE glVertex2fv

!  Vertex2i(x, y)
!  return  void
!  param   x		CoordI in value
!  param   y		CoordI in value
SUBROUTINE glVertex2i(x, y) BIND(C,NAME="glVertex2i")
IMPORT
INTEGER(GLint), VALUE :: x, y
END SUBROUTINE glVertex2i

!  Vertex2iv(v)
!  return  void
!  param   v		CoordI in array [2]
SUBROUTINE glVertex2iv(v) BIND(C,NAME="glVertex2iv")
IMPORT
INTEGER(GLint), DIMENSION(2), INTENT(IN) :: v
END SUBROUTINE glVertex2iv

!  Vertex2s(x, y)
!  return  void
!  param   x		CoordS in value
!  param   y		CoordS in value
SUBROUTINE glVertex2s(x, y) BIND(C,NAME="glVertex2s")
IMPORT
INTEGER(GLshort), VALUE :: x, y
END SUBROUTINE glVertex2s

!  Vertex2sv(v)
!  return  void
!  param   v		CoordS in array [2]
SUBROUTINE glVertex2sv(v) BIND(C,NAME="glVertex2sv")
IMPORT
INTEGER(GLshort), DIMENSION(2), INTENT(IN) :: v
END SUBROUTINE glVertex2sv

!  Vertex3d(x, y, z)
!  return  void
!  param   x		CoordD in value
!  param   y		CoordD in value
!  param   z		CoordD in value
SUBROUTINE glVertex3d(x, y, z) BIND(C,NAME="glVertex3d")
IMPORT
REAL(GLdouble), VALUE :: x, y, z
END SUBROUTINE glVertex3d

!  Vertex3dv(v)
!  return  void
!  param   v		CoordD in array [3]
SUBROUTINE glVertex3dv(v) BIND(C,NAME="glVertex3dv")
IMPORT
REAL(GLdouble), DIMENSION(3), INTENT(IN) :: v
END SUBROUTINE glVertex3dv

!  Vertex3f(x, y, z)
!  return  void
!  param   x		CoordF in value
!  param   y		CoordF in value
!  param   z		CoordF in value
SUBROUTINE glVertex3f(x, y, z) BIND(C,NAME="glVertex3f")
IMPORT
REAL(GLfloat), VALUE :: x, y, z
END SUBROUTINE glVertex3f

!  Vertex3fv(v)
!  return  void
!  param   v		CoordF in array [3]
SUBROUTINE glVertex3fv(v) BIND(C,NAME="glVertex3fv")
IMPORT
REAL(GLfloat), DIMENSION(3), INTENT(IN) :: v
END SUBROUTINE glVertex3fv

!  Vertex3i(x, y, z)
!  return  void
!  param   x		CoordI in value
!  param   y		CoordI in value
!  param   z		CoordI in value
SUBROUTINE glVertex3i(x, y, z) BIND(C,NAME="glVertex3i")
IMPORT
INTEGER(GLint), VALUE :: x, y, z
END SUBROUTINE glVertex3i

!  Vertex3iv(v)
!  return  void
!  param   v		CoordI in array [3]
SUBROUTINE glVertex3iv(v) BIND(C,NAME="glVertex3iv")
IMPORT
INTEGER(GLint), DIMENSION(3), INTENT(IN) :: v
END SUBROUTINE glVertex3iv

!  Vertex3s(x, y, z)
!  return  void
!  param   x		CoordS in value
!  param   y		CoordS in value
!  param   z		CoordS in value
SUBROUTINE glVertex3s(x, y, z) BIND(C,NAME="glVertex3s")
IMPORT
INTEGER(GLshort), VALUE :: x, y, z
END SUBROUTINE glVertex3s

!  Vertex3sv(v)
!  return  void
!  param   v		CoordS in array [3]
SUBROUTINE glVertex3sv(v) BIND(C,NAME="glVertex3sv")
IMPORT
INTEGER(GLshort), DIMENSION(3), INTENT(IN) :: v
END SUBROUTINE glVertex3sv

!  Vertex4d(x, y, z, w)
!  return  void
!  param   x		CoordD in value
!  param   y		CoordD in value
!  param   z		CoordD in value
!  param   w		CoordD in value
SUBROUTINE glVertex4d(x, y, z, w) BIND(C,NAME="glVertex4d")
IMPORT
REAL(GLdouble), VALUE :: x, y, z, w
END SUBROUTINE glVertex4d

!  Vertex4dv(v)
!  return  void
!  param   v		CoordD in array [4]
SUBROUTINE glVertex4dv(v) BIND(C,NAME="glVertex4dv")
IMPORT
REAL(GLdouble), DIMENSION(4), INTENT(IN) :: v
END SUBROUTINE glVertex4dv

!  Vertex4f(x, y, z, w)
!  return  void
!  param   x		CoordF in value
!  param   y		CoordF in value
!  param   z		CoordF in value
!  param   w		CoordF in value
SUBROUTINE glVertex4f(x, y, z, w) BIND(C,NAME="glVertex4f")
IMPORT
REAL(GLfloat), VALUE :: x, y, z, w
END SUBROUTINE glVertex4f

!  Vertex4fv(v)
!  return  void
!  param   v		CoordF in array [4]
SUBROUTINE glVertex4fv(v) BIND(C,NAME="glVertex4fv")
IMPORT
REAL(GLfloat), DIMENSION(4), INTENT(IN) :: v
END SUBROUTINE glVertex4fv

!  Vertex4i(x, y, z, w)
!  return  void
!  param   x		CoordI in value
!  param   y		CoordI in value
!  param   z		CoordI in value
!  param   w		CoordI in value
SUBROUTINE glVertex4i(x, y, z, w) BIND(C,NAME="glVertex4i")
IMPORT
INTEGER(GLint), VALUE :: x, y, z, w
END SUBROUTINE glVertex4i

!  Vertex4iv(v)
!  return  void
!  param   v		CoordI in array [4]
SUBROUTINE glVertex4iv(v) BIND(C,NAME="glVertex4iv")
IMPORT
INTEGER(GLint), DIMENSION(4), INTENT(IN) :: v
END SUBROUTINE glVertex4iv

!  Vertex4s(x, y, z, w)
!  return  void
!  param   x		CoordS in value
!  param   y		CoordS in value
!  param   z		CoordS in value
!  param   w		CoordS in value
SUBROUTINE glVertex4s(x, y, z, w) BIND(C,NAME="glVertex4s")
IMPORT
INTEGER(GLshort), VALUE :: x, y, z, w
END SUBROUTINE glVertex4s

!  Vertex4sv(v)
!  return  void
!  param   v		CoordS in array [4]
SUBROUTINE glVertex4sv(v) BIND(C,NAME="glVertex4sv")
IMPORT
INTEGER(GLshort), DIMENSION(4), INTENT(IN) :: v
END SUBROUTINE glVertex4sv

!  drawing-control  commands

!  ClipPlane(plane, equation)
!  return  void
!  param   plane		ClipPlaneName in value
!  param   equation	Float64 in array [4]
SUBROUTINE glClipPlane(plane, equation) BIND(C,NAME="glClipPlane")
IMPORT
INTEGER(GLenum), VALUE :: plane
REAL(GLdouble), DIMENSION(4), INTENT(IN) :: equation
END SUBROUTINE glClipPlane

!  ColorMaterial(face, mode)
!  return  void
!  param   face		MaterialFace in value
!  param   mode		ColorMaterialParameter in value
SUBROUTINE glColorMaterial(face, mode) BIND(C,NAME="glColorMaterial")
IMPORT
INTEGER(GLenum), VALUE :: face, mode
END SUBROUTINE glColorMaterial

!  CullFace(mode)
!  return  void
!  param   mode		CullFaceMode in value
SUBROUTINE glCullFace(mode) BIND(C,NAME="glCullFace")
IMPORT
INTEGER(GLenum), VALUE :: mode
END SUBROUTINE glCullFace

!  Fogf(pname, param)
!  return  void
!  param   pname		FogParameter in value
!  param   param		CheckedFloat32 in value
SUBROUTINE glFogf(pname, param) BIND(C,NAME="glFogf")
IMPORT
INTEGER(GLenum), VALUE :: pname
REAL(GLfloat), VALUE :: param
END SUBROUTINE glFogf

!  Fogfv(pname, params)
!  return  void
!  param   pname		FogParameter in value
!  param   params		CheckedFloat32 in array [COMPSIZE(pname)]
SUBROUTINE glFogfv(pname, params) BIND(C,NAME="glFogfv")
IMPORT
INTEGER(GLenum), VALUE :: pname
REAL(GLfloat), DIMENSION(*), INTENT(IN) :: params
END SUBROUTINE glFogfv

!  Fogi(pname, param)
!  return  void
!  param   pname		FogParameter in value
!  param   param		CheckedInt32 in value
SUBROUTINE glFogi(pname, param) BIND(C,NAME="glFogi")
IMPORT
INTEGER(GLenum), VALUE :: pname
INTEGER(GLint), VALUE :: param
END SUBROUTINE glFogi

!  Fogiv(pname, params)
!  return  void
!  param   pname		FogParameter in value
!  param   params		CheckedInt32 in array [COMPSIZE(pname)]
SUBROUTINE glFogiv(pname, params) BIND(C,NAME="glFogiv")
IMPORT
INTEGER(GLenum), VALUE :: pname
INTEGER(GLint), DIMENSION(*), INTENT(IN) :: params
END SUBROUTINE glFogiv

!  FrontFace(mode)
!  return  void
!  param   mode		FrontFaceDirection in value
SUBROUTINE glFrontFace(mode) BIND(C,NAME="glFrontFace")
IMPORT
INTEGER(GLenum), VALUE :: mode
END SUBROUTINE glFrontFace

!  Hint(target, mode)
!  return  void
!  param   target		HintTarget in value
!  param   mode		HintMode in value
SUBROUTINE glHint(target, mode) BIND(C,NAME="glHint")
IMPORT
INTEGER(GLenum), VALUE :: target, mode
END SUBROUTINE glHint

!  Lightf(light, pname, param)
!  return  void
!  param   light		LightName in value
!  param   pname		LightParameter in value
!  param   param		CheckedFloat32 in value
SUBROUTINE glLightf(light, pname, param) BIND(C,NAME="glLightf")
IMPORT
INTEGER(GLenum), VALUE :: light, pname
REAL(GLfloat), VALUE :: param
END SUBROUTINE glLightf

!  Lightfv(light, pname, params)
!  return  void
!  param   light		LightName in value
!  param   pname		LightParameter in value
!  param   params		CheckedFloat32 in array [COMPSIZE(pname)]
SUBROUTINE glLightfv(light, pname, params) BIND(C,NAME="glLightfv")
IMPORT
INTEGER(GLenum), VALUE :: light, pname
REAL(GLfloat), DIMENSION(*), INTENT(IN) :: params
END SUBROUTINE glLightfv

!  Lighti(light, pname, param)
!  return  void
!  param   light		LightName in value
!  param   pname		LightParameter in value
!  param   param		CheckedInt32 in value
SUBROUTINE glLighti(light, pname, param) BIND(C,NAME="glLighti")
IMPORT
INTEGER(GLenum), VALUE :: light, pname
INTEGER(GLint), VALUE :: param
END SUBROUTINE glLighti

!  Lightiv(light, pname, params)
!  return  void
!  param   light		LightName in value
!  param   pname		LightParameter in value
!  param   params		CheckedInt32 in array [COMPSIZE(pname)]
SUBROUTINE glLightiv(light, pname, params) BIND(C,NAME="glLightiv")
IMPORT
INTEGER(GLenum), VALUE :: light, pname
INTEGER(GLint), DIMENSION(*), INTENT(IN) :: params
END SUBROUTINE glLightiv

!  LightModelf(pname, param)
!  return  void
!  param   pname		LightModelParameter in value
!  param   param		Float32 in value
SUBROUTINE glLightModelf(pname, param) BIND(C,NAME="glLightModelf")
IMPORT
INTEGER(GLenum), VALUE :: pname
REAL(GLfloat), VALUE :: param
END SUBROUTINE glLightModelf

!  LightModelfv(pname, params)
!  return  void
!  param   pname		LightModelParameter in value
!  param   params		Float32 in array [COMPSIZE(pname)]
SUBROUTINE glLightModelfv(pname, params) BIND(C,NAME="glLightModelfv")
IMPORT
INTEGER(GLenum), VALUE :: pname
REAL(GLfloat), DIMENSION(*), INTENT(IN) :: params
END SUBROUTINE glLightModelfv

!  LightModeli(pname, param)
!  return  void
!  param   pname		LightModelParameter in value
!  param   param		Int32 in value
SUBROUTINE glLightModeli(pname, param) BIND(C,NAME="glLightModeli")
IMPORT
INTEGER(GLenum), VALUE :: pname
INTEGER(GLint), VALUE :: param
END SUBROUTINE glLightModeli

!  LightModeliv(pname, params)
!  return  void
!  param   pname		LightModelParameter in value
!  param   params		Int32 in array [COMPSIZE(pname)]
SUBROUTINE glLightModeliv(pname, params) BIND(C,NAME="glLightModeliv")
IMPORT
INTEGER(GLenum), VALUE :: pname
INTEGER(GLint), DIMENSION(*), INTENT(IN) :: params
END SUBROUTINE glLightModeliv

!  LineStipple(factor, pattern)
!  return  void
!  param   factor		CheckedInt32 in value
!  param   pattern		LineStipple in value
SUBROUTINE glLineStipple(factor, pattern) BIND(C,NAME="glLineStipple")
IMPORT
INTEGER(GLint), VALUE :: factor
INTEGER(GLushort), VALUE :: pattern
END SUBROUTINE glLineStipple

!  LineWidth(width)
!  return  void
!  param   width		CheckedFloat32 in value
SUBROUTINE glLineWidth(width) BIND(C,NAME="glLineWidth")
IMPORT
REAL(GLfloat), VALUE :: width
END SUBROUTINE glLineWidth

!  Materialf(face, pname, param)
!  return  void
!  param   face		MaterialFace in value
!  param   pname		MaterialParameter in value
!  param   param		CheckedFloat32 in value
SUBROUTINE glMaterialf(face, pname, param) BIND(C,NAME="glMaterialf")
IMPORT
INTEGER(GLenum), VALUE :: face, pname
REAL(GLfloat), VALUE :: param
END SUBROUTINE glMaterialf

!  Materialfv(face, pname, params)
!  return  void
!  param   face		MaterialFace in value
!  param   pname		MaterialParameter in value
!  param   params		CheckedFloat32 in array [COMPSIZE(pname)]
SUBROUTINE glMaterialfv(face, pname, params) BIND(C,NAME="glMaterialfv")
IMPORT
INTEGER(GLenum), VALUE :: face, pname
REAL(GLfloat), DIMENSION(*), INTENT(IN) :: params
END SUBROUTINE glMaterialfv

!  Materiali(face, pname, param)
!  return  void
!  param   face		MaterialFace in value
!  param   pname		MaterialParameter in value
!  param   param		CheckedInt32 in value
SUBROUTINE glMateriali(face, pname, param) BIND(C,NAME="glMateriali")
IMPORT
INTEGER(GLenum), VALUE :: face, pname
INTEGER(GLint), VALUE :: param
END SUBROUTINE glMateriali

!  Materialiv(face, pname, params)
!  return  void
!  param   face		MaterialFace in value
!  param   pname		MaterialParameter in value
!  param   params		CheckedInt32 in array [COMPSIZE(pname)]
SUBROUTINE glMaterialiv(face, pname, params) BIND(C,NAME="glMaterialiv")
IMPORT
INTEGER(GLenum), VALUE :: face, pname
INTEGER(GLint), DIMENSION(*), INTENT(IN) :: params
END SUBROUTINE glMaterialiv

!  PointSize(size)
!  return  void
!  param   size		CheckedFloat32 in value
SUBROUTINE glPointSize(size) BIND(C,NAME="glPointSize")
IMPORT
REAL(GLfloat), VALUE :: size
END SUBROUTINE glPointSize

!  PolygonMode(face, mode)
!  return  void
!  param   face		MaterialFace in value
!  param   mode		PolygonMode in value
SUBROUTINE glPolygonMode(face, mode) BIND(C,NAME="glPolygonMode")
IMPORT
INTEGER(GLenum), VALUE :: face, mode
END SUBROUTINE glPolygonMode

!  PolygonStipple(mask)
!  return  void
!  param   mask		UInt8 in array [COMPSIZE()]
SUBROUTINE glPolygonStipple(mask) BIND(C,NAME="glPolygonStipple")
IMPORT
INTEGER(GLbyte), DIMENSION(*), INTENT(IN) :: mask
END SUBROUTINE glPolygonStipple

!  Scissor(x, y, width, height)
!  return  void
!  param   x		WinCoord in value
!  param   y		WinCoord in value
!  param   width		SizeI in value
!  param   height		SizeI in value
SUBROUTINE glScissor(x, y, width, height) BIND(C,NAME="glScissor")
IMPORT
INTEGER(GLint), VALUE :: x, y
INTEGER(GLsizei), VALUE :: width, height
END SUBROUTINE glScissor

!  ShadeModel(mode)
!  return  void
!  param   mode		ShadingModel in value
SUBROUTINE glShadeModel(mode) BIND(C,NAME="glShadeModel")
IMPORT
INTEGER(GLenum), VALUE :: mode
END SUBROUTINE glShadeModel

!  TexParameterf(target, pname, param)
!  return  void
!  param   target		TextureTarget in value
!  param   pname		TextureParameterName in value
!  param   param		CheckedFloat32 in value
SUBROUTINE glTexParameterf(target, pname, param)                              &
    BIND(C,NAME="glTexParameterf")
IMPORT
INTEGER(GLenum), VALUE :: target, pname
REAL(GLfloat), VALUE :: param
END SUBROUTINE glTexParameterf

!  TexParameterfv(target, pname, params)
!  return  void
!  param   target		TextureTarget in value
!  param   pname		TextureParameterName in value
!  param   params		CheckedFloat32 in array [COMPSIZE(pname)]
SUBROUTINE glTexParameterfv(target, pname, params)                            &
    BIND(C,NAME="glTexParameterfv")
IMPORT
INTEGER(GLenum), VALUE :: target, pname
REAL(GLfloat), DIMENSION(*), INTENT(IN) :: params
END SUBROUTINE glTexParameterfv

!  TexParameteri(target, pname, param)
!  return  void
!  param   target		TextureTarget in value
!  param   pname		TextureParameterName in value
!  param   param		CheckedInt32 in value
SUBROUTINE glTexParameteri(target, pname, param)                              &
    BIND(C,NAME="glTexParameteri")
IMPORT
INTEGER(GLenum), VALUE :: target, pname
INTEGER(GLint), VALUE :: param
END SUBROUTINE glTexParameteri

!  TexParameteriv(target, pname, params)
!  return  void
!  param   target		TextureTarget in value
!  param   pname		TextureParameterName in value
!  param   params		CheckedInt32 in array [COMPSIZE(pname)]
SUBROUTINE glTexParameteriv(target, pname, params)                            &
    BIND(C,NAME="glTexParameteriv")
IMPORT
INTEGER(GLenum), VALUE :: target, pname
INTEGER(GLint), DIMENSION(*), INTENT(IN) :: params
END SUBROUTINE glTexParameteriv

!  TexImage1D(target, level, internalformat, width, border, format, type, pixels)
!  return  void
!  param   target		TextureTarget in value
!  param   level		CheckedInt32 in value
!  param   internalformat	TextureComponentCount in value
!  param   width		SizeI in value
!  param   border		CheckedInt32 in value
!  param   format		PixelFormat in value
!  param   type		PixelType in value
!  param   pixels		Void in array [COMPSIZE(format/type/width)]
SUBROUTINE glTexImage1D(target, level, internalformat, width, border,         &
    format, type, pixels) BIND(C,NAME="glTexImage1D")
IMPORT
INTEGER(GLenum), VALUE :: target, format, type
INTEGER(GLint), VALUE :: level, internalformat, border
INTEGER(GLsizei), VALUE :: width
TYPE(C_PTR), VALUE :: pixels
END SUBROUTINE glTexImage1D

!  TexImage2D(target, level, internalformat, width, height, border, format, type, pixels)
!  return  void
!  param   target		TextureTarget in value
!  param   level		CheckedInt32 in value
!  param   internalformat	TextureComponentCount in value
!  param   width		SizeI in value
!  param   height		SizeI in value
!  param   border		CheckedInt32 in value
!  param   format		PixelFormat in value
!  param   type		PixelType in value
!  param   pixels		Void in array [COMPSIZE(format/type/width/height)]
SUBROUTINE glTexImage2D(target, level, internalformat, width, height,         &
    border, format, type, pixels) BIND(C,NAME="glTexImage2D")
IMPORT
INTEGER(GLenum), VALUE :: target, format, type
INTEGER(GLint), VALUE :: level, internalformat, border
INTEGER(GLsizei), VALUE :: width, height
TYPE(C_PTR), VALUE :: pixels
END SUBROUTINE glTexImage2D

!  TexEnvf(target, pname, param)
!  return  void
!  param   target		TextureEnvTarget in value
!  param   pname		TextureEnvParameter in value
!  param   param		CheckedFloat32 in value
SUBROUTINE glTexEnvf(target, pname, param) BIND(C,NAME="glTexEnvf")
IMPORT
INTEGER(GLenum), VALUE :: target, pname
REAL(GLfloat), VALUE :: param
END SUBROUTINE glTexEnvf

!  TexEnvfv(target, pname, params)
!  return  void
!  param   target		TextureEnvTarget in value
!  param   pname		TextureEnvParameter in value
!  param   params		CheckedFloat32 in array [COMPSIZE(pname)]
SUBROUTINE glTexEnvfv(target, pname, params) BIND(C,NAME="glTexEnvfv")
IMPORT
INTEGER(GLenum), VALUE :: target, pname
REAL(GLfloat), DIMENSION(*), INTENT(IN) :: params
END SUBROUTINE glTexEnvfv

!  TexEnvi(target, pname, param)
!  return  void
!  param   target		TextureEnvTarget in value
!  param   pname		TextureEnvParameter in value
!  param   param		CheckedInt32 in value
SUBROUTINE glTexEnvi(target, pname, param) BIND(C,NAME="glTexEnvi")
IMPORT
INTEGER(GLenum), VALUE :: target, pname
INTEGER(GLint), VALUE :: param
END SUBROUTINE glTexEnvi

!  TexEnviv(target, pname, params)
!  return  void
!  param   target		TextureEnvTarget in value
!  param   pname		TextureEnvParameter in value
!  param   params		CheckedInt32 in array [COMPSIZE(pname)]
SUBROUTINE glTexEnviv(target, pname, params) BIND(C,NAME="glTexEnviv")
IMPORT
INTEGER(GLenum), VALUE :: target, pname
INTEGER(GLint), DIMENSION(*), INTENT(IN) :: params
END SUBROUTINE glTexEnviv

!  TexGend(coord, pname, param)
!  return  void
!  param   coord		TextureCoordName in value
!  param   pname		TextureGenParameter in value
!  param   param		Float64 in value
SUBROUTINE glTexGend(coord, pname, param) BIND(C,NAME="glTexGend")
IMPORT
INTEGER(GLenum), VALUE :: coord, pname
REAL(GLdouble), VALUE :: param
END SUBROUTINE glTexGend

!  TexGendv(coord, pname, params)
!  return  void
!  param   coord		TextureCoordName in value
!  param   pname		TextureGenParameter in value
!  param   params		Float64 in array [COMPSIZE(pname)]
SUBROUTINE glTexGendv(coord, pname, params) BIND(C,NAME="glTexGendv")
IMPORT
INTEGER(GLenum), VALUE :: coord, pname
REAL(GLdouble), DIMENSION(*), INTENT(IN) :: params
END SUBROUTINE glTexGendv

!  TexGenf(coord, pname, param)
!  return  void
!  param   coord		TextureCoordName in value
!  param   pname		TextureGenParameter in value
!  param   param		CheckedFloat32 in value
SUBROUTINE glTexGenf(coord, pname, param) BIND(C,NAME="glTexGenf")
IMPORT
INTEGER(GLenum), VALUE :: coord, pname
REAL(GLfloat), VALUE :: param
END SUBROUTINE glTexGenf

!  TexGenfv(coord, pname, params)
!  return  void
!  param   coord		TextureCoordName in value
!  param   pname		TextureGenParameter in value
!  param   params		CheckedFloat32 in array [COMPSIZE(pname)]
SUBROUTINE glTexGenfv(coord, pname, params) BIND(C,NAME="glTexGenfv")
IMPORT
INTEGER(GLenum), VALUE :: coord, pname
REAL(GLfloat), DIMENSION(*), INTENT(IN) :: params
END SUBROUTINE glTexGenfv

!  TexGeni(coord, pname, param)
!  return  void
!  param   coord		TextureCoordName in value
!  param   pname		TextureGenParameter in value
!  param   param		CheckedInt32 in value
SUBROUTINE glTexGeni(coord, pname, param) BIND(C,NAME="glTexGeni")
IMPORT
INTEGER(GLenum), VALUE :: coord, pname
INTEGER(GLint), VALUE :: param
END SUBROUTINE glTexGeni

!  TexGeniv(coord, pname, params)
!  return  void
!  param   coord		TextureCoordName in value
!  param   pname		TextureGenParameter in value
!  param   params		CheckedInt32 in array [COMPSIZE(pname)]
SUBROUTINE glTexGeniv(coord, pname, params) BIND(C,NAME="glTexGeniv")
IMPORT
INTEGER(GLenum), VALUE :: coord, pname
INTEGER(GLint), DIMENSION(*), INTENT(IN) :: params
END SUBROUTINE glTexGeniv

!  feedback  commands

!  FeedbackBuffer(size, type, buffer)
!  return  void
!  param   size		SizeI in value
!  param   type		FeedbackType in value
!  param   buffer		FeedbackElement out array [size] retained
SUBROUTINE glFeedbackBuffer(size, type, buffer)                               &
    BIND(C,NAME="glFeedbackBuffer")
IMPORT
INTEGER(GLenum), VALUE :: type
INTEGER(GLsizei), VALUE :: size
TYPE(C_PTR), VALUE :: buffer
END SUBROUTINE glFeedbackBuffer

!  SelectBuffer(size, buffer)
!  return  void
!  param   size		SizeI in value
!  param   buffer		SelectName out array [size] retained
SUBROUTINE glSelectBuffer(size, buffer) BIND(C,NAME="glSelectBuffer")
IMPORT
INTEGER(GLsizei), VALUE :: size
TYPE(C_PTR), VALUE :: buffer
END SUBROUTINE glSelectBuffer

!  RenderMode(mode)
!  return  Int32
!  param   mode		RenderingMode in value
FUNCTION glRenderMode(mode) BIND(C,NAME="glRenderMode")
IMPORT
INTEGER(GLint) :: glRenderMode
INTEGER(GLenum), VALUE :: mode
END FUNCTION glRenderMode

!  InitNames()
!  return  void
SUBROUTINE glInitNames() BIND(C,NAME="glInitNames")
IMPORT
END SUBROUTINE glInitNames

!  LoadName(name)
!  return  void
!  param   name		SelectName in value
SUBROUTINE glLoadName(name) BIND(C,NAME="glLoadName")
IMPORT
INTEGER(GLuint), VALUE :: name
END SUBROUTINE glLoadName

!  PassThrough(token)
!  return  void
!  param   token		FeedbackElement in value
SUBROUTINE glPassThrough(token) BIND(C,NAME="glPassThrough")
IMPORT
REAL(GLfloat), VALUE :: token
END SUBROUTINE glPassThrough

!  PopName()
!  return  void
SUBROUTINE glPopName() BIND(C,NAME="glPopName")
IMPORT
END SUBROUTINE glPopName

!  PushName(name)
!  return  void
!  param   name		SelectName in value
SUBROUTINE glPushName(name) BIND(C,NAME="glPushName")
IMPORT
INTEGER(GLuint), VALUE :: name
END SUBROUTINE glPushName

!  framebuf  commands

!  DrawBuffer(mode)
!  return  void
!  param   mode		DrawBufferMode in value
SUBROUTINE glDrawBuffer(mode) BIND(C,NAME="glDrawBuffer")
IMPORT
INTEGER(GLenum), VALUE :: mode
END SUBROUTINE glDrawBuffer

!  Clear(mask)
!  return  void
!  param   mask		ClearBufferMask in value
SUBROUTINE glClear(mask) BIND(C,NAME="glClear")
IMPORT
INTEGER(GLbitfield), VALUE :: mask
END SUBROUTINE glClear

!  ClearAccum(red, green, blue, alpha)
!  return  void
!  param   red		Float32 in value
!  param   green		Float32 in value
!  param   blue		Float32 in value
!  param   alpha		Float32 in value
SUBROUTINE glClearAccum(red, green, blue, alpha)                              &
    BIND(C,NAME="glClearAccum")
IMPORT
REAL(GLfloat), VALUE :: red, green, blue, alpha
END SUBROUTINE glClearAccum

!  ClearIndex(c)
!  return  void
!  param   c		MaskedColorIndexValueF in value
SUBROUTINE glClearIndex(c) BIND(C,NAME="glClearIndex")
IMPORT
REAL(GLfloat), VALUE :: c
END SUBROUTINE glClearIndex

!  ClearColor(red, green, blue, alpha)
!  return  void
!  param   red		ClampedColorF in value
!  param   green		ClampedColorF in value
!  param   blue		ClampedColorF in value
!  param   alpha		ClampedColorF in value
SUBROUTINE glClearColor(red, green, blue, alpha)                              &
    BIND(C,NAME="glClearColor")
IMPORT
REAL(GLclampf), VALUE :: red, green, blue, alpha
END SUBROUTINE glClearColor

!  ClearStencil(s)
!  return  void
!  param   s		StencilValue in value
SUBROUTINE glClearStencil(s) BIND(C,NAME="glClearStencil")
IMPORT
INTEGER(GLint), VALUE :: s
END SUBROUTINE glClearStencil

!  ClearDepth(depth)
!  return  void
!  param   depth		ClampedFloat64 in value
SUBROUTINE glClearDepth(depth) BIND(C,NAME="glClearDepth")
IMPORT
REAL(GLclampd), VALUE :: depth
END SUBROUTINE glClearDepth

!  StencilMask(mask)
!  return  void
!  param   mask		MaskedStencilValue in value
SUBROUTINE glStencilMask(mask) BIND(C,NAME="glStencilMask")
IMPORT
INTEGER(GLuint), VALUE :: mask
END SUBROUTINE glStencilMask

!  ColorMask(red, green, blue, alpha)
!  return  void
!  param   red		Boolean in value
!  param   green		Boolean in value
!  param   blue		Boolean in value
!  param   alpha		Boolean in value
SUBROUTINE glColorMask(red, green, blue, alpha) BIND(C,NAME="glColorMask")
IMPORT
INTEGER(GLboolean), VALUE :: red, green, blue, alpha
END SUBROUTINE glColorMask

!  DepthMask(flag)
!  return  void
!  param   flag		Boolean in value
SUBROUTINE glDepthMask(flag) BIND(C,NAME="glDepthMask")
IMPORT
INTEGER(GLboolean), VALUE :: flag
END SUBROUTINE glDepthMask

!  IndexMask(mask)
!  return  void
!  param   mask		MaskedColorIndexValueI in value
SUBROUTINE glIndexMask(mask) BIND(C,NAME="glIndexMask")
IMPORT
INTEGER(GLuint), VALUE :: mask
END SUBROUTINE glIndexMask

!  misc  commands

!  Accum(op, value)
!  return  void
!  param   op		AccumOp in value
!  param   value		CoordF in value
SUBROUTINE glAccum(op, value) BIND(C,NAME="glAccum")
IMPORT
INTEGER(GLenum), VALUE :: op
REAL(GLfloat), VALUE :: value
END SUBROUTINE glAccum

!  Disable(cap)
!  return  void
!  param   cap		EnableCap in value
SUBROUTINE glDisable(cap) BIND(C,NAME="glDisable")
IMPORT
INTEGER(GLenum), VALUE :: cap
END SUBROUTINE glDisable

!  Enable(cap)
!  return  void
!  param   cap		EnableCap in value
SUBROUTINE glEnable(cap) BIND(C,NAME="glEnable")
IMPORT
INTEGER(GLenum), VALUE :: cap
END SUBROUTINE glEnable

!  Finish()
!  return  void
SUBROUTINE glFinish() BIND(C,NAME="glFinish")
IMPORT
END SUBROUTINE glFinish

!  Flush()
!  return  void
SUBROUTINE glFlush() BIND(C,NAME="glFlush")
IMPORT
END SUBROUTINE glFlush

!  PopAttrib()
!  return  void
SUBROUTINE glPopAttrib() BIND(C,NAME="glPopAttrib")
IMPORT
END SUBROUTINE glPopAttrib

!  PushAttrib(mask)
!  return  void
!  param   mask		AttribMask in value
SUBROUTINE glPushAttrib(mask) BIND(C,NAME="glPushAttrib")
IMPORT
INTEGER(GLbitfield), VALUE :: mask
END SUBROUTINE glPushAttrib

!  modeling  commands

!  Map1d(target, u1, u2, stride, order, points)
!  return  void
!  param   target		MapTarget in value
!  param   u1		CoordD in value
!  param   u2		CoordD in value
!  param   stride		Int32 in value
!  param   order		CheckedInt32 in value
!  param   points		CoordD in array [COMPSIZE(target/stride/order)]
SUBROUTINE glMap1d(target, u1, u2, stride, order, points)                     &
    BIND(C,NAME="glMap1d")
IMPORT
INTEGER(GLenum), VALUE :: target
INTEGER(GLint), VALUE :: stride, order
REAL(GLdouble), VALUE :: u1, u2
REAL(GLdouble), DIMENSION(*), INTENT(IN) :: points
END SUBROUTINE glMap1d

!  Map1f(target, u1, u2, stride, order, points)
!  return  void
!  param   target		MapTarget in value
!  param   u1		CoordF in value
!  param   u2		CoordF in value
!  param   stride		Int32 in value
!  param   order		CheckedInt32 in value
!  param   points		CoordF in array [COMPSIZE(target/stride/order)]
SUBROUTINE glMap1f(target, u1, u2, stride, order, points)                     &
    BIND(C,NAME="glMap1f")
IMPORT
INTEGER(GLenum), VALUE :: target
INTEGER(GLint), VALUE :: stride, order
REAL(GLfloat), VALUE :: u1, u2
REAL(GLfloat), DIMENSION(*), INTENT(IN) :: points
END SUBROUTINE glMap1f

!  Map2d(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points)
!  return  void
!  param   target		MapTarget in value
!  param   u1		CoordD in value
!  param   u2		CoordD in value
!  param   ustride		Int32 in value
!  param   uorder		CheckedInt32 in value
!  param   v1		CoordD in value
!  param   v2		CoordD in value
!  param   vstride		Int32 in value
!  param   vorder		CheckedInt32 in value
!  param   points		CoordD in array [COMPSIZE(target/ustride/uorder/vstride/vorder)]
SUBROUTINE glMap2d(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder,  &
    points) BIND(C,NAME="glMap2d")
IMPORT
INTEGER(GLenum), VALUE :: target
INTEGER(GLint), VALUE :: ustride, uorder, vstride, vorder
REAL(GLdouble), VALUE :: u1, u2, v1, v2
REAL(GLdouble), DIMENSION(*), INTENT(IN) :: points
END SUBROUTINE glMap2d

!  Map2f(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points)
!  return  void
!  param   target		MapTarget in value
!  param   u1		CoordF in value
!  param   u2		CoordF in value
!  param   ustride		Int32 in value
!  param   uorder		CheckedInt32 in value
!  param   v1		CoordF in value
!  param   v2		CoordF in value
!  param   vstride		Int32 in value
!  param   vorder		CheckedInt32 in value
!  param   points		CoordF in array [COMPSIZE(target/ustride/uorder/vstride/vorder)]
SUBROUTINE glMap2f(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder,  &
    points) BIND(C,NAME="glMap2f")
IMPORT
INTEGER(GLenum), VALUE :: target
INTEGER(GLint), VALUE :: ustride, uorder, vstride, vorder
REAL(GLfloat), VALUE :: u1, u2, v1, v2
REAL(GLfloat), DIMENSION(*), INTENT(IN) :: points
END SUBROUTINE glMap2f

!  MapGrid1d(un, u1, u2)
!  return  void
!  param   un		Int32 in value
!  param   u1		CoordD in value
!  param   u2		CoordD in value
SUBROUTINE glMapGrid1d(un, u1, u2) BIND(C,NAME="glMapGrid1d")
IMPORT
INTEGER(GLint), VALUE :: un
REAL(GLdouble), VALUE :: u1, u2
END SUBROUTINE glMapGrid1d

!  MapGrid1f(un, u1, u2)
!  return  void
!  param   un		Int32 in value
!  param   u1		CoordF in value
!  param   u2		CoordF in value
SUBROUTINE glMapGrid1f(un, u1, u2) BIND(C,NAME="glMapGrid1f")
IMPORT
INTEGER(GLint), VALUE :: un
REAL(GLfloat), VALUE :: u1, u2
END SUBROUTINE glMapGrid1f

!  MapGrid2d(un, u1, u2, vn, v1, v2)
!  return  void
!  param   un		Int32 in value
!  param   u1		CoordD in value
!  param   u2		CoordD in value
!  param   vn		Int32 in value
!  param   v1		CoordD in value
!  param   v2		CoordD in value
SUBROUTINE glMapGrid2d(un, u1, u2, vn, v1, v2) BIND(C,NAME="glMapGrid2d")
IMPORT
INTEGER(GLint), VALUE :: un, vn
REAL(GLdouble), VALUE :: u1, u2, v1, v2
END SUBROUTINE glMapGrid2d

!  MapGrid2f(un, u1, u2, vn, v1, v2)
!  return  void
!  param   un		Int32 in value
!  param   u1		CoordF in value
!  param   u2		CoordF in value
!  param   vn		Int32 in value
!  param   v1		CoordF in value
!  param   v2		CoordF in value
SUBROUTINE glMapGrid2f(un, u1, u2, vn, v1, v2) BIND(C,NAME="glMapGrid2f")
IMPORT
INTEGER(GLint), VALUE :: un, vn
REAL(GLfloat), VALUE :: u1, u2, v1, v2
END SUBROUTINE glMapGrid2f

!  EvalCoord1d(u)
!  return  void
!  param   u		CoordD in value
SUBROUTINE glEvalCoord1d(u) BIND(C,NAME="glEvalCoord1d")
IMPORT
REAL(GLdouble), VALUE :: u
END SUBROUTINE glEvalCoord1d

!  EvalCoord1dv(u)
!  return  void
!  param   u		CoordD in array [1]
SUBROUTINE glEvalCoord1dv(u) BIND(C,NAME="glEvalCoord1dv")
IMPORT
REAL(GLdouble), INTENT(IN) :: u
END SUBROUTINE glEvalCoord1dv

!  EvalCoord1f(u)
!  return  void
!  param   u		CoordF in value
SUBROUTINE glEvalCoord1f(u) BIND(C,NAME="glEvalCoord1f")
IMPORT
REAL(GLfloat), VALUE :: u
END SUBROUTINE glEvalCoord1f

!  EvalCoord1fv(u)
!  return  void
!  param   u		CoordF in array [1]
SUBROUTINE glEvalCoord1fv(u) BIND(C,NAME="glEvalCoord1fv")
IMPORT
REAL(GLfloat), INTENT(IN) :: u
END SUBROUTINE glEvalCoord1fv

!  EvalCoord2d(u, v)
!  return  void
!  param   u		CoordD in value
!  param   v		CoordD in value
SUBROUTINE glEvalCoord2d(u, v) BIND(C,NAME="glEvalCoord2d")
IMPORT
REAL(GLdouble), VALUE :: u, v
END SUBROUTINE glEvalCoord2d

!  EvalCoord2dv(u)
!  return  void
!  param   u		CoordD in array [2]
SUBROUTINE glEvalCoord2dv(u) BIND(C,NAME="glEvalCoord2dv")
IMPORT
REAL(GLdouble), DIMENSION(2), INTENT(IN) :: u
END SUBROUTINE glEvalCoord2dv

!  EvalCoord2f(u, v)
!  return  void
!  param   u		CoordF in value
!  param   v		CoordF in value
SUBROUTINE glEvalCoord2f(u, v) BIND(C,NAME="glEvalCoord2f")
IMPORT
REAL(GLfloat), VALUE :: u, v
END SUBROUTINE glEvalCoord2f

!  EvalCoord2fv(u)
!  return  void
!  param   u		CoordF in array [2]
SUBROUTINE glEvalCoord2fv(u) BIND(C,NAME="glEvalCoord2fv")
IMPORT
REAL(GLfloat), DIMENSION(2), INTENT(IN) :: u
END SUBROUTINE glEvalCoord2fv

!  EvalMesh1(mode, i1, i2)
!  return  void
!  param   mode		MeshMode1 in value
!  param   i1		CheckedInt32 in value
!  param   i2		CheckedInt32 in value
SUBROUTINE glEvalMesh1(mode, i1, i2) BIND(C,NAME="glEvalMesh1")
IMPORT
INTEGER(GLenum), VALUE :: mode
INTEGER(GLint), VALUE :: i1, i2
END SUBROUTINE glEvalMesh1

!  EvalPoint1(i)
!  return  void
!  param   i		Int32 in value
SUBROUTINE glEvalPoint1(i) BIND(C,NAME="glEvalPoint1")
IMPORT
INTEGER(GLint), VALUE :: i
END SUBROUTINE glEvalPoint1

!  EvalMesh2(mode, i1, i2, j1, j2)
!  return  void
!  param   mode		MeshMode2 in value
!  param   i1		CheckedInt32 in value
!  param   i2		CheckedInt32 in value
!  param   j1		CheckedInt32 in value
!  param   j2		CheckedInt32 in value
SUBROUTINE glEvalMesh2(mode, i1, i2, j1, j2) BIND(C,NAME="glEvalMesh2")
IMPORT
INTEGER(GLenum), VALUE :: mode
INTEGER(GLint), VALUE :: i1, i2, j1, j2
END SUBROUTINE glEvalMesh2

!  EvalPoint2(i, j)
!  return  void
!  param   i		CheckedInt32 in value
!  param   j		CheckedInt32 in value
SUBROUTINE glEvalPoint2(i, j) BIND(C,NAME="glEvalPoint2")
IMPORT
INTEGER(GLint), VALUE :: i, j
END SUBROUTINE glEvalPoint2

!  pixel-op  commands

!  AlphaFunc(func, ref)
!  return  void
!  param   func		AlphaFunction in value
!  param   ref		ClampedFloat32 in value
SUBROUTINE glAlphaFunc(func, ref) BIND(C,NAME="glAlphaFunc")
IMPORT
INTEGER(GLenum), VALUE :: func
REAL(GLclampf), VALUE :: ref
END SUBROUTINE glAlphaFunc

!  BlendFunc(sfactor, dfactor)
!  return  void
!  param   sfactor		BlendingFactorSrc in value
!  param   dfactor		BlendingFactorDest in value
SUBROUTINE glBlendFunc(sfactor, dfactor) BIND(C,NAME="glBlendFunc")
IMPORT
INTEGER(GLenum), VALUE :: sfactor, dfactor
END SUBROUTINE glBlendFunc

!  LogicOp(opcode)
!  return  void
!  param   opcode		LogicOp in value
SUBROUTINE glLogicOp(opcode) BIND(C,NAME="glLogicOp")
IMPORT
INTEGER(GLenum), VALUE :: opcode
END SUBROUTINE glLogicOp

!  StencilFunc(func, ref, mask)
!  return  void
!  param   func		StencilFunction in value
!  param   ref		ClampedStencilValue in value
!  param   mask		MaskedStencilValue in value
SUBROUTINE glStencilFunc(func, ref, mask) BIND(C,NAME="glStencilFunc")
IMPORT
INTEGER(GLenum), VALUE :: func
INTEGER(GLint), VALUE :: ref
INTEGER(GLuint), VALUE :: mask
END SUBROUTINE glStencilFunc

!  StencilOp(fail, zfail, zpass)
!  return  void
!  param   fail		StencilOp in value
!  param   zfail		StencilOp in value
!  param   zpass		StencilOp in value
SUBROUTINE glStencilOp(fail, zfail, zpass) BIND(C,NAME="glStencilOp")
IMPORT
INTEGER(GLenum), VALUE :: fail, zfail, zpass
END SUBROUTINE glStencilOp

!  DepthFunc(func)
!  return  void
!  param   func		DepthFunction in value
SUBROUTINE glDepthFunc(func) BIND(C,NAME="glDepthFunc")
IMPORT
INTEGER(GLenum), VALUE :: func
END SUBROUTINE glDepthFunc

!  pixel-rw  commands

!  PixelZoom(xfactor, yfactor)
!  return  void
!  param   xfactor		Float32 in value
!  param   yfactor		Float32 in value
SUBROUTINE glPixelZoom(xfactor, yfactor) BIND(C,NAME="glPixelZoom")
IMPORT
REAL(GLfloat), VALUE :: xfactor, yfactor
END SUBROUTINE glPixelZoom

!  PixelTransferf(pname, param)
!  return  void
!  param   pname		PixelTransferParameter in value
!  param   param		CheckedFloat32 in value
SUBROUTINE glPixelTransferf(pname, param) BIND(C,NAME="glPixelTransferf")
IMPORT
INTEGER(GLenum), VALUE :: pname
REAL(GLfloat), VALUE :: param
END SUBROUTINE glPixelTransferf

!  PixelTransferi(pname, param)
!  return  void
!  param   pname		PixelTransferParameter in value
!  param   param		CheckedInt32 in value
SUBROUTINE glPixelTransferi(pname, param) BIND(C,NAME="glPixelTransferi")
IMPORT
INTEGER(GLenum), VALUE :: pname
INTEGER(GLint), VALUE :: param
END SUBROUTINE glPixelTransferi

!  PixelStoref(pname, param)
!  return  void
!  param   pname		PixelStoreParameter in value
!  param   param		CheckedFloat32 in value
SUBROUTINE glPixelStoref(pname, param) BIND(C,NAME="glPixelStoref")
IMPORT
INTEGER(GLenum), VALUE :: pname
REAL(GLfloat), VALUE :: param
END SUBROUTINE glPixelStoref

!  PixelStorei(pname, param)
!  return  void
!  param   pname		PixelStoreParameter in value
!  param   param		CheckedInt32 in value
SUBROUTINE glPixelStorei(pname, param) BIND(C,NAME="glPixelStorei")
IMPORT
INTEGER(GLenum), VALUE :: pname
INTEGER(GLint), VALUE :: param
END SUBROUTINE glPixelStorei

!  PixelMapfv(map, mapsize, values)
!  return  void
!  param   map		PixelMap in value
!  param   mapsize		CheckedInt32 in value
!  param   values		Float32 in array [mapsize]
SUBROUTINE glPixelMapfv(map, mapsize, values) BIND(C,NAME="glPixelMapfv")
IMPORT
INTEGER(GLenum), VALUE :: map
INTEGER(GLint), VALUE :: mapsize
REAL(GLfloat), DIMENSION(mapsize), INTENT(IN) :: values
END SUBROUTINE glPixelMapfv

!  PixelMapuiv(map, mapsize, values)
!  return  void
!  param   map		PixelMap in value
!  param   mapsize		CheckedInt32 in value
!  param   values		UInt32 in array [mapsize]
SUBROUTINE glPixelMapuiv(map, mapsize, values) BIND(C,NAME="glPixelMapuiv")
IMPORT
INTEGER(GLenum), VALUE :: map
INTEGER(GLint), VALUE :: mapsize
INTEGER(GLint), DIMENSION(mapsize), INTENT(IN) :: values
END SUBROUTINE glPixelMapuiv

!  PixelMapusv(map, mapsize, values)
!  return  void
!  param   map		PixelMap in value
!  param   mapsize		CheckedInt32 in value
!  param   values		UInt16 in array [mapsize]
SUBROUTINE glPixelMapusv(map, mapsize, values) BIND(C,NAME="glPixelMapusv")
IMPORT
INTEGER(GLenum), VALUE :: map
INTEGER(GLint), VALUE :: mapsize
INTEGER(GLshort), DIMENSION(mapsize), INTENT(IN) :: values
END SUBROUTINE glPixelMapusv

!  ReadBuffer(mode)
!  return  void
!  param   mode		ReadBufferMode in value
SUBROUTINE glReadBuffer(mode) BIND(C,NAME="glReadBuffer")
IMPORT
INTEGER(GLenum), VALUE :: mode
END SUBROUTINE glReadBuffer

!  CopyPixels(x, y, width, height, type)
!  return  void
!  param   x		WinCoord in value
!  param   y		WinCoord in value
!  param   width		SizeI in value
!  param   height		SizeI in value
!  param   type		PixelCopyType in value
SUBROUTINE glCopyPixels(x, y, width, height, type)                            &
    BIND(C,NAME="glCopyPixels")
IMPORT
INTEGER(GLenum), VALUE :: type
INTEGER(GLint), VALUE :: x, y
INTEGER(GLsizei), VALUE :: width, height
END SUBROUTINE glCopyPixels

!  ReadPixels(x, y, width, height, format, type, pixels)
!  return  void
!  param   x		WinCoord in value
!  param   y		WinCoord in value
!  param   width		SizeI in value
!  param   height		SizeI in value
!  param   format		PixelFormat in value
!  param   type		PixelType in value
!  param   pixels		Void out array [COMPSIZE(format/type/width/height)]
SUBROUTINE glReadPixels(x, y, width, height, format, type, pixels)            &
    BIND(C,NAME="glReadPixels")
IMPORT
INTEGER(GLenum), VALUE :: format, type
INTEGER(GLint), VALUE :: x, y
INTEGER(GLsizei), VALUE :: width, height
TYPE(C_PTR), VALUE :: pixels
END SUBROUTINE glReadPixels

!  DrawPixels(width, height, format, type, pixels)
!  return  void
!  param   width		SizeI in value
!  param   height		SizeI in value
!  param   format		PixelFormat in value
!  param   type		PixelType in value
!  param   pixels		Void in array [COMPSIZE(format/type/width/height)]
SUBROUTINE glDrawPixels(width, height, format, type, pixels)                  &
    BIND(C,NAME="glDrawPixels")
IMPORT
INTEGER(GLenum), VALUE :: format, type
INTEGER(GLsizei), VALUE :: width, height
TYPE(C_PTR), VALUE :: pixels
END SUBROUTINE glDrawPixels

!  state-req  commands

!  GetBooleanv(pname, params)
!  return  void
!  param   pname		GetPName in value
!  param   params		Boolean out array [COMPSIZE(pname)]
SUBROUTINE glGetBooleanv(pname, params) BIND(C,NAME="glGetBooleanv")
IMPORT
INTEGER(GLenum), VALUE :: pname
INTEGER(GLboolean), DIMENSION(*), INTENT(OUT) :: params
END SUBROUTINE glGetBooleanv

!  GetClipPlane(plane, equation)
!  return  void
!  param   plane		ClipPlaneName in value
!  param   equation	Float64 out array [4]
SUBROUTINE glGetClipPlane(plane, equation) BIND(C,NAME="glGetClipPlane")
IMPORT
INTEGER(GLenum), VALUE :: plane
REAL(GLdouble), DIMENSION(4), INTENT(OUT) :: equation
END SUBROUTINE glGetClipPlane

!  GetDoublev(pname, params)
!  return  void
!  param   pname		GetPName in value
!  param   params		Float64 out array [COMPSIZE(pname)]
SUBROUTINE glGetDoublev(pname, params) BIND(C,NAME="glGetDoublev")
IMPORT
INTEGER(GLenum), VALUE :: pname
REAL(GLdouble), DIMENSION(*), INTENT(OUT) :: params
END SUBROUTINE glGetDoublev

!  GetError()
!  return  ErrorCode
FUNCTION glGetError() BIND(C,NAME="glGetError")
IMPORT
INTEGER(GLenum) :: glGetError
END FUNCTION glGetError

!  GetFloatv(pname, params)
!  return  void
!  param   pname		GetPName in value
!  param   params		Float32 out array [COMPSIZE(pname)]
SUBROUTINE glGetFloatv(pname, params) BIND(C,NAME="glGetFloatv")
IMPORT
INTEGER(GLenum), VALUE :: pname
REAL(GLfloat), DIMENSION(*), INTENT(OUT) :: params
END SUBROUTINE glGetFloatv

!  GetIntegerv(pname, params)
!  return  void
!  param   pname		GetPName in value
!  param   params		Int32 out array [COMPSIZE(pname)]
SUBROUTINE glGetIntegerv(pname, params) BIND(C,NAME="glGetIntegerv")
IMPORT
INTEGER(GLenum), VALUE :: pname
INTEGER(GLint), DIMENSION(*), INTENT(OUT) :: params
END SUBROUTINE glGetIntegerv

!  GetLightfv(light, pname, params)
!  return  void
!  param   light		LightName in value
!  param   pname		LightParameter in value
!  param   params		Float32 out array [COMPSIZE(pname)]
SUBROUTINE glGetLightfv(light, pname, params) BIND(C,NAME="glGetLightfv")
IMPORT
INTEGER(GLenum), VALUE :: light, pname
REAL(GLfloat), DIMENSION(*), INTENT(OUT) :: params
END SUBROUTINE glGetLightfv

!  GetLightiv(light, pname, params)
!  return  void
!  param   light		LightName in value
!  param   pname		LightParameter in value
!  param   params		Int32 out array [COMPSIZE(pname)]
SUBROUTINE glGetLightiv(light, pname, params) BIND(C,NAME="glGetLightiv")
IMPORT
INTEGER(GLenum), VALUE :: light, pname
INTEGER(GLint), DIMENSION(*), INTENT(OUT) :: params
END SUBROUTINE glGetLightiv

!  GetMapdv(target, query, v)
!  return  void
!  param   target		MapTarget in value
!  param   query		GetMapQuery in value
!  param   v		Float64 out array [COMPSIZE(target/query)]
SUBROUTINE glGetMapdv(target, query, v) BIND(C,NAME="glGetMapdv")
IMPORT
INTEGER(GLenum), VALUE :: target, query
REAL(GLdouble), DIMENSION(*), INTENT(OUT) :: v
END SUBROUTINE glGetMapdv

!  GetMapfv(target, query, v)
!  return  void
!  param   target		MapTarget in value
!  param   query		GetMapQuery in value
!  param   v		Float32 out array [COMPSIZE(target/query)]
SUBROUTINE glGetMapfv(target, query, v) BIND(C,NAME="glGetMapfv")
IMPORT
INTEGER(GLenum), VALUE :: target, query
REAL(GLfloat), DIMENSION(*), INTENT(OUT) :: v
END SUBROUTINE glGetMapfv

!  GetMapiv(target, query, v)
!  return  void
!  param   target		MapTarget in value
!  param   query		GetMapQuery in value
!  param   v		Int32 out array [COMPSIZE(target/query)]
SUBROUTINE glGetMapiv(target, query, v) BIND(C,NAME="glGetMapiv")
IMPORT
INTEGER(GLenum), VALUE :: target, query
INTEGER(GLint), DIMENSION(*), INTENT(OUT) :: v
END SUBROUTINE glGetMapiv

!  GetMaterialfv(face, pname, params)
!  return  void
!  param   face		MaterialFace in value
!  param   pname		MaterialParameter in value
!  param   params		Float32 out array [COMPSIZE(pname)]
SUBROUTINE glGetMaterialfv(face, pname, params)                               &
    BIND(C,NAME="glGetMaterialfv")
IMPORT
INTEGER(GLenum), VALUE :: face, pname
REAL(GLfloat), DIMENSION(*), INTENT(OUT) :: params
END SUBROUTINE glGetMaterialfv

!  GetMaterialiv(face, pname, params)
!  return  void
!  param   face		MaterialFace in value
!  param   pname		MaterialParameter in value
!  param   params		Int32 out array [COMPSIZE(pname)]
SUBROUTINE glGetMaterialiv(face, pname, params)                               &
    BIND(C,NAME="glGetMaterialiv")
IMPORT
INTEGER(GLenum), VALUE :: face, pname
INTEGER(GLint), DIMENSION(*), INTENT(OUT) :: params
END SUBROUTINE glGetMaterialiv

!  GetPixelMapfv(map, values)
!  return  void
!  param   map		PixelMap in value
!  param   values		Float32 out array [COMPSIZE(map)]
SUBROUTINE glGetPixelMapfv(map, values) BIND(C,NAME="glGetPixelMapfv")
IMPORT
INTEGER(GLenum), VALUE :: map
REAL(GLfloat), DIMENSION(*), INTENT(OUT) :: values
END SUBROUTINE glGetPixelMapfv

!  GetPixelMapuiv(map, values)
!  return  void
!  param   map		PixelMap in value
!  param   values		UInt32 out array [COMPSIZE(map)]
SUBROUTINE glGetPixelMapuiv(map, values) BIND(C,NAME="glGetPixelMapuiv")
IMPORT
INTEGER(GLenum), VALUE :: map
INTEGER(GLint), DIMENSION(*), INTENT(OUT) :: values
END SUBROUTINE glGetPixelMapuiv

!  GetPixelMapusv(map, values)
!  return  void
!  param   map		PixelMap in value
!  param   values		UInt16 out array [COMPSIZE(map)]
SUBROUTINE glGetPixelMapusv(map, values) BIND(C,NAME="glGetPixelMapusv")
IMPORT
INTEGER(GLenum), VALUE :: map
INTEGER(GLshort), DIMENSION(*), INTENT(OUT) :: values
END SUBROUTINE glGetPixelMapusv

!  GetPolygonStipple(mask)
!  return  void
!  param   mask		UInt8 out array [COMPSIZE()]
SUBROUTINE glGetPolygonStipple(mask) BIND(C,NAME="glGetPolygonStipple")
IMPORT
INTEGER(GLbyte), DIMENSION(*), INTENT(OUT) :: mask
END SUBROUTINE glGetPolygonStipple

!  GetString(name)
!  return  String
!  param   name		StringName in value
FUNCTION glGetString(name) BIND(C,NAME="glGetString")
IMPORT
TYPE(C_PTR) :: glGetString
INTEGER(GLenum), VALUE :: name
END FUNCTION glGetString

!  GetTexEnvfv(target, pname, params)
!  return  void
!  param   target		TextureEnvTarget in value
!  param   pname		TextureEnvParameter in value
!  param   params		Float32 out array [COMPSIZE(pname)]
SUBROUTINE glGetTexEnvfv(target, pname, params)                               &
    BIND(C,NAME="glGetTexEnvfv")
IMPORT
INTEGER(GLenum), VALUE :: target, pname
REAL(GLfloat), DIMENSION(*), INTENT(OUT) :: params
END SUBROUTINE glGetTexEnvfv

!  GetTexEnviv(target, pname, params)
!  return  void
!  param   target		TextureEnvTarget in value
!  param   pname		TextureEnvParameter in value
!  param   params		Int32 out array [COMPSIZE(pname)]
SUBROUTINE glGetTexEnviv(target, pname, params)                               &
    BIND(C,NAME="glGetTexEnviv")
IMPORT
INTEGER(GLenum), VALUE :: target, pname
INTEGER(GLint), DIMENSION(*), INTENT(OUT) :: params
END SUBROUTINE glGetTexEnviv

!  GetTexGendv(coord, pname, params)
!  return  void
!  param   coord		TextureCoordName in value
!  param   pname		TextureGenParameter in value
!  param   params		Float64 out array [COMPSIZE(pname)]
SUBROUTINE glGetTexGendv(coord, pname, params) BIND(C,NAME="glGetTexGendv")
IMPORT
INTEGER(GLenum), VALUE :: coord, pname
REAL(GLdouble), DIMENSION(*), INTENT(OUT) :: params
END SUBROUTINE glGetTexGendv

!  GetTexGenfv(coord, pname, params)
!  return  void
!  param   coord		TextureCoordName in value
!  param   pname		TextureGenParameter in value
!  param   params		Float32 out array [COMPSIZE(pname)]
SUBROUTINE glGetTexGenfv(coord, pname, params) BIND(C,NAME="glGetTexGenfv")
IMPORT
INTEGER(GLenum), VALUE :: coord, pname
REAL(GLfloat), DIMENSION(*), INTENT(OUT) :: params
END SUBROUTINE glGetTexGenfv

!  GetTexGeniv(coord, pname, params)
!  return  void
!  param   coord		TextureCoordName in value
!  param   pname		TextureGenParameter in value
!  param   params		Int32 out array [COMPSIZE(pname)]
SUBROUTINE glGetTexGeniv(coord, pname, params) BIND(C,NAME="glGetTexGeniv")
IMPORT
INTEGER(GLenum), VALUE :: coord, pname
INTEGER(GLint), DIMENSION(*), INTENT(OUT) :: params
END SUBROUTINE glGetTexGeniv

!  GetTexImage(target, level, format, type, pixels)
!  return  void
!  param   target		TextureTarget in value
!  param   level		CheckedInt32 in value
!  param   format		PixelFormat in value
!  param   type		PixelType in value
!  param   pixels		Void out array [COMPSIZE(target/level/format/type)]
SUBROUTINE glGetTexImage(target, level, format, type, pixels)                 &
    BIND(C,NAME="glGetTexImage")
IMPORT
INTEGER(GLenum), VALUE :: target, format, type
INTEGER(GLint), VALUE :: level
TYPE(C_PTR), VALUE :: pixels
END SUBROUTINE glGetTexImage

!  GetTexParameterfv(target, pname, params)
!  return  void
!  param   target		TextureTarget in value
!  param   pname		GetTextureParameter in value
!  param   params		Float32 out array [COMPSIZE(pname)]
SUBROUTINE glGetTexParameterfv(target, pname, params)                         &
    BIND(C,NAME="glGetTexParameterfv")
IMPORT
INTEGER(GLenum), VALUE :: target, pname
REAL(GLfloat), DIMENSION(*), INTENT(OUT) :: params
END SUBROUTINE glGetTexParameterfv

!  GetTexParameteriv(target, pname, params)
!  return  void
!  param   target		TextureTarget in value
!  param   pname		GetTextureParameter in value
!  param   params		Int32 out array [COMPSIZE(pname)]
SUBROUTINE glGetTexParameteriv(target, pname, params)                         &
    BIND(C,NAME="glGetTexParameteriv")
IMPORT
INTEGER(GLenum), VALUE :: target, pname
INTEGER(GLint), DIMENSION(*), INTENT(OUT) :: params
END SUBROUTINE glGetTexParameteriv

!  GetTexLevelParameterfv(target, level, pname, params)
!  return  void
!  param   target		TextureTarget in value
!  param   level		CheckedInt32 in value
!  param   pname		GetTextureParameter in value
!  param   params		Float32 out array [COMPSIZE(pname)]
SUBROUTINE glGetTexLevelParameterfv(target, level, pname, params)             &
    BIND(C,NAME="glGetTexLevelParameterfv")
IMPORT
INTEGER(GLenum), VALUE :: target, pname
INTEGER(GLint), VALUE :: level
REAL(GLfloat), DIMENSION(*), INTENT(OUT) :: params
END SUBROUTINE glGetTexLevelParameterfv

!  GetTexLevelParameteriv(target, level, pname, params)
!  return  void
!  param   target		TextureTarget in value
!  param   level		CheckedInt32 in value
!  param   pname		GetTextureParameter in value
!  param   params		Int32 out array [COMPSIZE(pname)]
SUBROUTINE glGetTexLevelParameteriv(target, level, pname, params)             &
    BIND(C,NAME="glGetTexLevelParameteriv")
IMPORT
INTEGER(GLenum), VALUE :: target, pname
INTEGER(GLint), VALUE :: level
INTEGER(GLint), DIMENSION(*), INTENT(OUT) :: params
END SUBROUTINE glGetTexLevelParameteriv

!  IsEnabled(cap)
!  return  Boolean
!  param   cap		EnableCap in value
FUNCTION glIsEnabled(cap) BIND(C,NAME="glIsEnabled")
IMPORT
INTEGER(GLboolean) :: glIsEnabled
INTEGER(GLenum), VALUE :: cap
END FUNCTION glIsEnabled

!  IsList(list)
!  return  Boolean
!  param   list		List in value
FUNCTION glIsList(list) BIND(C,NAME="glIsList")
IMPORT
INTEGER(GLboolean) :: glIsList
INTEGER(GLint), VALUE :: list
END FUNCTION glIsList

!  xform  commands

!  DepthRange(zNear, zFar)
!  return  void
!  param   zNear		ClampedFloat64 in value
!  param   zFar		ClampedFloat64 in value
SUBROUTINE glDepthRange(zNear, zFar) BIND(C,NAME="glDepthRange")
IMPORT
REAL(GLclampd), VALUE :: zNear, zFar
END SUBROUTINE glDepthRange

!  Frustum(left, right, bottom, top, zNear, zFar)
!  return  void
!  param   left		Float64 in value
!  param   right		Float64 in value
!  param   bottom		Float64 in value
!  param   top		Float64 in value
!  param   zNear		Float64 in value
!  param   zFar		Float64 in value
SUBROUTINE glFrustum(left, right, bottom, top, zNear, zFar)                   &
    BIND(C,NAME="glFrustum")
IMPORT
REAL(GLdouble), VALUE :: left, right, bottom, top, zNear, zFar
END SUBROUTINE glFrustum

!  LoadIdentity()
!  return  void
SUBROUTINE glLoadIdentity() BIND(C,NAME="glLoadIdentity")
IMPORT
END SUBROUTINE glLoadIdentity

!  LoadMatrixf(m)
!  return  void
!  param   m		Float32 in array [16]
SUBROUTINE glLoadMatrixf(m) BIND(C,NAME="glLoadMatrixf")
IMPORT
REAL(GLfloat), DIMENSION(16), INTENT(IN) :: m
END SUBROUTINE glLoadMatrixf

!  LoadMatrixd(m)
!  return  void
!  param   m		Float64 in array [16]
SUBROUTINE glLoadMatrixd(m) BIND(C,NAME="glLoadMatrixd")
IMPORT
REAL(GLdouble), DIMENSION(16), INTENT(IN) :: m
END SUBROUTINE glLoadMatrixd

!  MatrixMode(mode)
!  return  void
!  param   mode		MatrixMode in value
SUBROUTINE glMatrixMode(mode) BIND(C,NAME="glMatrixMode")
IMPORT
INTEGER(GLenum), VALUE :: mode
END SUBROUTINE glMatrixMode

!  MultMatrixf(m)
!  return  void
!  param   m		Float32 in array [16]
SUBROUTINE glMultMatrixf(m) BIND(C,NAME="glMultMatrixf")
IMPORT
REAL(GLfloat), DIMENSION(16), INTENT(IN) :: m
END SUBROUTINE glMultMatrixf

!  MultMatrixd(m)
!  return  void
!  param   m		Float64 in array [16]
SUBROUTINE glMultMatrixd(m) BIND(C,NAME="glMultMatrixd")
IMPORT
REAL(GLdouble), DIMENSION(16), INTENT(IN) :: m
END SUBROUTINE glMultMatrixd

!  Ortho(left, right, bottom, top, zNear, zFar)
!  return  void
!  param   left		Float64 in value
!  param   right		Float64 in value
!  param   bottom		Float64 in value
!  param   top		Float64 in value
!  param   zNear		Float64 in value
!  param   zFar		Float64 in value
SUBROUTINE glOrtho(left, right, bottom, top, zNear, zFar)                     &
    BIND(C,NAME="glOrtho")
IMPORT
REAL(GLdouble), VALUE :: left, right, bottom, top, zNear, zFar
END SUBROUTINE glOrtho

!  PopMatrix()
!  return  void
SUBROUTINE glPopMatrix() BIND(C,NAME="glPopMatrix")
IMPORT
END SUBROUTINE glPopMatrix

!  PushMatrix()
!  return  void
SUBROUTINE glPushMatrix() BIND(C,NAME="glPushMatrix")
IMPORT
END SUBROUTINE glPushMatrix

!  Rotated(angle, x, y, z)
!  return  void
!  param   angle		Float64 in value
!  param   x		Float64 in value
!  param   y		Float64 in value
!  param   z		Float64 in value
SUBROUTINE glRotated(angle, x, y, z) BIND(C,NAME="glRotated")
IMPORT
REAL(GLdouble), VALUE :: angle, x, y, z
END SUBROUTINE glRotated

!  Rotatef(angle, x, y, z)
!  return  void
!  param   angle		Float32 in value
!  param   x		Float32 in value
!  param   y		Float32 in value
!  param   z		Float32 in value
SUBROUTINE glRotatef(angle, x, y, z) BIND(C,NAME="glRotatef")
IMPORT
REAL(GLfloat), VALUE :: angle, x, y, z
END SUBROUTINE glRotatef

!  Scaled(x, y, z)
!  return  void
!  param   x		Float64 in value
!  param   y		Float64 in value
!  param   z		Float64 in value
SUBROUTINE glScaled(x, y, z) BIND(C,NAME="glScaled")
IMPORT
REAL(GLdouble), VALUE :: x, y, z
END SUBROUTINE glScaled

!  Scalef(x, y, z)
!  return  void
!  param   x		Float32 in value
!  param   y		Float32 in value
!  param   z		Float32 in value
SUBROUTINE glScalef(x, y, z) BIND(C,NAME="glScalef")
IMPORT
REAL(GLfloat), VALUE :: x, y, z
END SUBROUTINE glScalef

!  Translated(x, y, z)
!  return  void
!  param   x		Float64 in value
!  param   y		Float64 in value
!  param   z		Float64 in value
SUBROUTINE glTranslated(x, y, z) BIND(C,NAME="glTranslated")
IMPORT
REAL(GLdouble), VALUE :: x, y, z
END SUBROUTINE glTranslated

!  Translatef(x, y, z)
!  return  void
!  param   x		Float32 in value
!  param   y		Float32 in value
!  param   z		Float32 in value
SUBROUTINE glTranslatef(x, y, z) BIND(C,NAME="glTranslatef")
IMPORT
REAL(GLfloat), VALUE :: x, y, z
END SUBROUTINE glTranslatef

!  Viewport(x, y, width, height)
!  return  void
!  param   x		WinCoord in value
!  param   y		WinCoord in value
!  param   width		SizeI in value
!  param   height		SizeI in value
SUBROUTINE glViewport(x, y, width, height) BIND(C,NAME="glViewport")
IMPORT
INTEGER(GLint), VALUE :: x, y
INTEGER(GLsizei), VALUE :: width, height
END SUBROUTINE glViewport

!  OpenGL 1.1  commands

!  ArrayElement(i)
!  return  void
!  param   i		Int32 in value
SUBROUTINE glArrayElement(i) BIND(C,NAME="glArrayElement")
IMPORT
INTEGER(GLint), VALUE :: i
END SUBROUTINE glArrayElement

!  ColorPointer(size, type, stride, pointer)
!  return  void
!  param   size		Int32 in value
!  param   type		ColorPointerType in value
!  param   stride		SizeI in value
!  param   pointer		Void in array [COMPSIZE(size/type/stride)] retained
SUBROUTINE glColorPointer(size, type, stride, pointer)                        &
    BIND(C,NAME="glColorPointer")
IMPORT
INTEGER(GLenum), VALUE :: type
INTEGER(GLint), VALUE :: size
INTEGER(GLsizei), VALUE :: stride
TYPE(C_PTR), VALUE :: pointer
END SUBROUTINE glColorPointer

!  DisableClientState(array)
!  return  void
!  param   array		EnableCap in value
SUBROUTINE glDisableClientState(array) BIND(C,NAME="glDisableClientState")
IMPORT
INTEGER(GLenum), VALUE :: array
END SUBROUTINE glDisableClientState

!  DrawArrays(mode, first, count)
!  return  void
!  param   mode		BeginMode in value
!  param   first		Int32 in value
!  param   count		SizeI in value
SUBROUTINE glDrawArrays(mode, first, count) BIND(C,NAME="glDrawArrays")
IMPORT
INTEGER(GLenum), VALUE :: mode
INTEGER(GLint), VALUE :: first
INTEGER(GLsizei), VALUE :: count
END SUBROUTINE glDrawArrays

!  DrawElements(mode, count, type, indices)
!  return  void
!  param   mode		BeginMode in value
!  param   count		SizeI in value
!  param   type		DrawElementsType in value
!  param   indices		Void in array [COMPSIZE(count/type)]
SUBROUTINE glDrawElements(mode, count, type, indices)                         &
    BIND(C,NAME="glDrawElements")
IMPORT
INTEGER(GLenum), VALUE :: mode, type
INTEGER(GLsizei), VALUE :: count
TYPE(C_PTR), VALUE :: indices
END SUBROUTINE glDrawElements

!  EdgeFlagPointer(stride, pointer)
!  return  void
!  param   stride		SizeI in value
!  param   pointer		Boolean in array [COMPSIZE(stride)] retained
SUBROUTINE glEdgeFlagPointer(stride, pointer)                                 &
    BIND(C,NAME="glEdgeFlagPointer")
IMPORT
INTEGER(GLsizei), VALUE :: stride
TYPE(C_PTR), VALUE :: pointer
END SUBROUTINE glEdgeFlagPointer

!  EnableClientState(array)
!  return  void
!  param   array		EnableCap in value
SUBROUTINE glEnableClientState(array) BIND(C,NAME="glEnableClientState")
IMPORT
INTEGER(GLenum), VALUE :: array
END SUBROUTINE glEnableClientState

!  GetPointerv(pname, params)
!  return  void
!  param   pname		GetPointervPName in value
!  param   params		VoidPointer out array [1]
SUBROUTINE glGetPointerv(pname, params) BIND(C,NAME="glGetPointerv")
IMPORT
INTEGER(GLenum), VALUE :: pname
TYPE(C_PTR), INTENT(OUT) :: params
END SUBROUTINE glGetPointerv

!  IndexPointer(type, stride, pointer)
!  return  void
!  param   type		IndexPointerType in value
!  param   stride		SizeI in value
!  param   pointer		Void in array [COMPSIZE(type/stride)] retained
SUBROUTINE glIndexPointer(type, stride, pointer)                              &
    BIND(C,NAME="glIndexPointer")
IMPORT
INTEGER(GLenum), VALUE :: type
INTEGER(GLsizei), VALUE :: stride
TYPE(C_PTR), VALUE :: pointer
END SUBROUTINE glIndexPointer

!  InterleavedArrays(format, stride, pointer)
!  return  void
!  param   format		InterleavedArrayFormat in value
!  param   stride		SizeI in value
!  param   pointer		Void in array [COMPSIZE(format/stride)] retained
SUBROUTINE glInterleavedArrays(format, stride, pointer)                       &
    BIND(C,NAME="glInterleavedArrays")
IMPORT
INTEGER(GLenum), VALUE :: format
INTEGER(GLsizei), VALUE :: stride
TYPE(C_PTR), VALUE :: pointer
END SUBROUTINE glInterleavedArrays

!  NormalPointer(type, stride, pointer)
!  return  void
!  param   type		NormalPointerType in value
!  param   stride		SizeI in value
!  param   pointer		Void in array [COMPSIZE(type/stride)] retained
SUBROUTINE glNormalPointer(type, stride, pointer)                             &
    BIND(C,NAME="glNormalPointer")
IMPORT
INTEGER(GLenum), VALUE :: type
INTEGER(GLsizei), VALUE :: stride
TYPE(C_PTR), VALUE :: pointer
END SUBROUTINE glNormalPointer

!  TexCoordPointer(size, type, stride, pointer)
!  return  void
!  param   size		Int32 in value
!  param   type		TexCoordPointerType in value
!  param   stride		SizeI in value
!  param   pointer		Void in array [COMPSIZE(size/type/stride)] retained
SUBROUTINE glTexCoordPointer(size, type, stride, pointer)                     &
    BIND(C,NAME="glTexCoordPointer")
IMPORT
INTEGER(GLenum), VALUE :: type
INTEGER(GLint), VALUE :: size
INTEGER(GLsizei), VALUE :: stride
TYPE(C_PTR), VALUE :: pointer
END SUBROUTINE glTexCoordPointer

!  VertexPointer(size, type, stride, pointer)
!  return  void
!  param   size		Int32 in value
!  param   type		VertexPointerType in value
!  param   stride		SizeI in value
!  param   pointer		Void in array [COMPSIZE(size/type/stride)] retained
SUBROUTINE glVertexPointer(size, type, stride, pointer)                       &
    BIND(C,NAME="glVertexPointer")
IMPORT
INTEGER(GLenum), VALUE :: type
INTEGER(GLint), VALUE :: size
INTEGER(GLsizei), VALUE :: stride
TYPE(C_PTR), VALUE :: pointer
END SUBROUTINE glVertexPointer

!  PolygonOffset(factor, units)
!  return  void
!  param   factor		Float32 in value
!  param   units		Float32 in value
SUBROUTINE glPolygonOffset(factor, units) BIND(C,NAME="glPolygonOffset")
IMPORT
REAL(GLfloat), VALUE :: factor, units
END SUBROUTINE glPolygonOffset

!  CopyTexImage1D(target, level, internalformat, x, y, width, border)
!  return  void
!  param   target		TextureTarget in value
!  param   level		CheckedInt32 in value
!  param   internalformat	PixelInternalFormat in value
!  param   x		WinCoord in value
!  param   y		WinCoord in value
!  param   width		SizeI in value
!  param   border		CheckedInt32 in value
SUBROUTINE glCopyTexImage1D(target, level, internalformat, x, y, width,       &
    border) BIND(C,NAME="glCopyTexImage1D")
IMPORT
INTEGER(GLenum), VALUE :: target
INTEGER(GLint), VALUE :: level, internalformat, x, y, border
INTEGER(GLsizei), VALUE :: width
END SUBROUTINE glCopyTexImage1D

!  CopyTexImage2D(target, level, internalformat, x, y, width, height, border)
!  return  void
!  param   target		TextureTarget in value
!  param   level		CheckedInt32 in value
!  param   internalformat	PixelInternalFormat in value
!  param   x		WinCoord in value
!  param   y		WinCoord in value
!  param   width		SizeI in value
!  param   height		SizeI in value
!  param   border		CheckedInt32 in value
SUBROUTINE glCopyTexImage2D(target, level, internalformat, x, y, width,       &
    height, border) BIND(C,NAME="glCopyTexImage2D")
IMPORT
INTEGER(GLenum), VALUE :: target
INTEGER(GLint), VALUE :: level, internalformat, x, y, border
INTEGER(GLsizei), VALUE :: width, height
END SUBROUTINE glCopyTexImage2D

!  CopyTexSubImage1D(target, level, xoffset, x, y, width)
!  return  void
!  param   target		TextureTarget in value
!  param   level		CheckedInt32 in value
!  param   xoffset		CheckedInt32 in value
!  param   x		WinCoord in value
!  param   y		WinCoord in value
!  param   width		SizeI in value
SUBROUTINE glCopyTexSubImage1D(target, level, xoffset, x, y, width)           &
    BIND(C,NAME="glCopyTexSubImage1D")
IMPORT
INTEGER(GLenum), VALUE :: target
INTEGER(GLint), VALUE :: level, xoffset, x, y
INTEGER(GLsizei), VALUE :: width
END SUBROUTINE glCopyTexSubImage1D

!  CopyTexSubImage2D(target, level, xoffset, yoffset, x, y, width, height)
!  return  void
!  param   target		TextureTarget in value
!  param   level		CheckedInt32 in value
!  param   xoffset		CheckedInt32 in value
!  param   yoffset		CheckedInt32 in value
!  param   x		WinCoord in value
!  param   y		WinCoord in value
!  param   width		SizeI in value
!  param   height		SizeI in value
SUBROUTINE glCopyTexSubImage2D(target, level, xoffset, yoffset, x, y, width,  &
    height) BIND(C,NAME="glCopyTexSubImage2D")
IMPORT
INTEGER(GLenum), VALUE :: target
INTEGER(GLint), VALUE :: level, xoffset, yoffset, x, y
INTEGER(GLsizei), VALUE :: width, height
END SUBROUTINE glCopyTexSubImage2D

!  TexSubImage1D(target, level, xoffset, width, format, type, pixels)
!  return  void
!  param   target		TextureTarget in value
!  param   level		CheckedInt32 in value
!  param   xoffset		CheckedInt32 in value
!  param   width		SizeI in value
!  param   format		PixelFormat in value
!  param   type		PixelType in value
!  param   pixels		Void in array [COMPSIZE(format/type/width)]
SUBROUTINE glTexSubImage1D(target, level, xoffset, width, format, type,       &
    pixels) BIND(C,NAME="glTexSubImage1D")
IMPORT
INTEGER(GLenum), VALUE :: target, format, type
INTEGER(GLint), VALUE :: level, xoffset
INTEGER(GLsizei), VALUE :: width
TYPE(C_PTR), VALUE :: pixels
END SUBROUTINE glTexSubImage1D

!  TexSubImage2D(target, level, xoffset, yoffset, width, height, format, type, pixels)
!  return  void
!  param   target		TextureTarget in value
!  param   level		CheckedInt32 in value
!  param   xoffset		CheckedInt32 in value
!  param   yoffset		CheckedInt32 in value
!  param   width		SizeI in value
!  param   height		SizeI in value
!  param   format		PixelFormat in value
!  param   type		PixelType in value
!  param   pixels		Void in array [COMPSIZE(format/type/width/height)]
SUBROUTINE glTexSubImage2D(target, level, xoffset, yoffset, width, height,    &
    format, type, pixels) BIND(C,NAME="glTexSubImage2D")
IMPORT
INTEGER(GLenum), VALUE :: target, format, type
INTEGER(GLint), VALUE :: level, xoffset, yoffset
INTEGER(GLsizei), VALUE :: width, height
TYPE(C_PTR), VALUE :: pixels
END SUBROUTINE glTexSubImage2D

!  AreTexturesResident(n, textures, residences)
!  return  Boolean
!  param   n		SizeI in value
!  param   textures	Texture in array [n]
!  param   residences	Boolean out array [n]
FUNCTION glAreTexturesResident(n, textures, residences)                       &
    BIND(C,NAME="glAreTexturesResident")
IMPORT
INTEGER(GLboolean) :: glAreTexturesResident
INTEGER(GLsizei), VALUE :: n
INTEGER(GLboolean), DIMENSION(n), INTENT(OUT) :: residences
INTEGER(GLuint), DIMENSION(n), INTENT(IN) :: textures
END FUNCTION glAreTexturesResident

!  BindTexture(target, texture)
!  return  void
!  param   target		TextureTarget in value
!  param   texture		Texture in value
SUBROUTINE glBindTexture(target, texture) BIND(C,NAME="glBindTexture")
IMPORT
INTEGER(GLenum), VALUE :: target
INTEGER(GLuint), VALUE :: texture
END SUBROUTINE glBindTexture

!  DeleteTextures(n, textures)
!  return  void
!  param   n		SizeI in value
!  param   textures	Texture in array [n]
SUBROUTINE glDeleteTextures(n, textures) BIND(C,NAME="glDeleteTextures")
IMPORT
INTEGER(GLsizei), VALUE :: n
INTEGER(GLuint), DIMENSION(n), INTENT(IN) :: textures
END SUBROUTINE glDeleteTextures

!  GenTextures(n, textures)
!  return  void
!  param   n		SizeI in value
!  param   textures	Texture out array [n]
SUBROUTINE glGenTextures(n, textures) BIND(C,NAME="glGenTextures")
IMPORT
INTEGER(GLsizei), VALUE :: n
INTEGER(GLuint), DIMENSION(n), INTENT(OUT) :: textures
END SUBROUTINE glGenTextures

!  IsTexture(texture)
!  return  Boolean
!  param   texture		Texture in value
FUNCTION glIsTexture(texture) BIND(C,NAME="glIsTexture")
IMPORT
INTEGER(GLboolean) :: glIsTexture
INTEGER(GLuint), VALUE :: texture
END FUNCTION glIsTexture

!  PrioritizeTextures(n, textures, priorities)
!  return  void
!  param   n		SizeI in value
!  param   textures	Texture in array [n]
!  param   priorities	ClampedFloat32 in array [n]
SUBROUTINE glPrioritizeTextures(n, textures, priorities)                      &
    BIND(C,NAME="glPrioritizeTextures")
IMPORT
INTEGER(GLsizei), VALUE :: n
INTEGER(GLuint), DIMENSION(n), INTENT(IN) :: textures
REAL(GLclampf), DIMENSION(n), INTENT(IN) :: priorities
END SUBROUTINE glPrioritizeTextures

!  Indexub(c)
!  return  void
!  param   c		ColorIndexValueUB in value
SUBROUTINE glIndexub(c) BIND(C,NAME="glIndexub")
IMPORT
INTEGER(GLubyte), VALUE :: c
END SUBROUTINE glIndexub

!  Indexubv(c)
!  return  void
!  param   c		ColorIndexValueUB in array [1]
SUBROUTINE glIndexubv(c) BIND(C,NAME="glIndexubv")
IMPORT
INTEGER(GLubyte), INTENT(IN) :: c
END SUBROUTINE glIndexubv

!  PopClientAttrib()
!  return  void
SUBROUTINE glPopClientAttrib() BIND(C,NAME="glPopClientAttrib")
IMPORT
END SUBROUTINE glPopClientAttrib

!  PushClientAttrib(mask)
!  return  void
!  param   mask		ClientAttribMask in value
SUBROUTINE glPushClientAttrib(mask) BIND(C,NAME="glPushClientAttrib")
IMPORT
INTEGER(GLbitfield), VALUE :: mask
END SUBROUTINE glPushClientAttrib

!  OpenGL 1.2  commands

!  BlendColor(red, green, blue, alpha)
!  return  void
!  param   red		ClampedColorF in value
!  param   green		ClampedColorF in value
!  param   blue		ClampedColorF in value
!  param   alpha		ClampedColorF in value
SUBROUTINE glBlendColor(red, green, blue, alpha)                              &
    BIND(C,NAME="glBlendColor")
IMPORT
REAL(GLclampf), VALUE :: red, green, blue, alpha
END SUBROUTINE glBlendColor

!  BlendEquation(mode)
!  return  void
!  param   mode		BlendEquationMode in value
SUBROUTINE glBlendEquation(mode) BIND(C,NAME="glBlendEquation")
IMPORT
INTEGER(GLenum), VALUE :: mode
END SUBROUTINE glBlendEquation

!  DrawRangeElements(mode, start, end, count, type, indices)
!  return  void
!  param   mode		BeginMode in value
!  param   start		UInt32 in value
!  param   end		UInt32 in value
!  param   count		SizeI in value
!  param   type		DrawElementsType in value
!  param   indices		Void in array [COMPSIZE(count/type)]
SUBROUTINE glDrawRangeElements(mode, start, end, count, type, indices)        &
    BIND(C,NAME="glDrawRangeElements")
IMPORT
INTEGER(GLenum), VALUE :: mode, type
INTEGER(GLint), VALUE :: start, end
INTEGER(GLsizei), VALUE :: count
TYPE(C_PTR), VALUE :: indices
END SUBROUTINE glDrawRangeElements

!  color_table extension  commands

!  ColorTable(target, internalformat, width, format, type, table)
!  return  void
!  param   target		ColorTableTarget in value
!  param   internalformat	PixelInternalFormat in value
!  param   width		SizeI in value
!  param   format		PixelFormat in value
!  param   type		PixelType in value
!  param   table		Void in array [COMPSIZE(format/type/width)]
SUBROUTINE glColorTable(target, internalformat, width, format, type, table)   &
    BIND(C,NAME="glColorTable")
IMPORT
INTEGER(GLenum), VALUE :: target, format, type
INTEGER(GLint), VALUE :: internalformat
INTEGER(GLsizei), VALUE :: width
TYPE(C_PTR), VALUE :: table
END SUBROUTINE glColorTable

!  ColorTableParameterfv(target, pname, params)
!  return  void
!  param   target		ColorTableTarget in value
!  param   pname		ColorTableParameterPName in value
!  param   params		CheckedFloat32 in array [COMPSIZE(pname)]
SUBROUTINE glColorTableParameterfv(target, pname, params)                     &
    BIND(C,NAME="glColorTableParameterfv")
IMPORT
INTEGER(GLenum), VALUE :: target, pname
REAL(GLfloat), DIMENSION(*), INTENT(IN) :: params
END SUBROUTINE glColorTableParameterfv

!  ColorTableParameteriv(target, pname, params)
!  return  void
!  param   target		ColorTableTarget in value
!  param   pname		ColorTableParameterPName in value
!  param   params		CheckedInt32 in array [COMPSIZE(pname)]
SUBROUTINE glColorTableParameteriv(target, pname, params)                     &
    BIND(C,NAME="glColorTableParameteriv")
IMPORT
INTEGER(GLenum), VALUE :: target, pname
INTEGER(GLint), DIMENSION(*), INTENT(IN) :: params
END SUBROUTINE glColorTableParameteriv

!  CopyColorTable(target, internalformat, x, y, width)
!  return  void
!  param   target		ColorTableTarget in value
!  param   internalformat	PixelInternalFormat in value
!  param   x		WinCoord in value
!  param   y		WinCoord in value
!  param   width		SizeI in value
SUBROUTINE glCopyColorTable(target, internalformat, x, y, width)              &
    BIND(C,NAME="glCopyColorTable")
IMPORT
INTEGER(GLenum), VALUE :: target
INTEGER(GLint), VALUE :: internalformat, x, y
INTEGER(GLsizei), VALUE :: width
END SUBROUTINE glCopyColorTable

!  GetColorTable(target, format, type, table)
!  return  void
!  param   target		ColorTableTarget in value
!  param   format		PixelFormat in value
!  param   type		PixelType in value
!  param   table		Void out array [COMPSIZE(target/format/type)]
SUBROUTINE glGetColorTable(target, format, type, table)                       &
    BIND(C,NAME="glGetColorTable")
IMPORT
INTEGER(GLenum), VALUE :: target, format, type
TYPE(C_PTR), VALUE :: table
END SUBROUTINE glGetColorTable

!  GetColorTableParameterfv(target, pname, params)
!  return  void
!  param   target		ColorTableTarget in value
!  param   pname		GetColorTableParameterPName in value
!  param   params		Float32 out array [COMPSIZE(pname)]
SUBROUTINE glGetColorTableParameterfv(target, pname, params)                  &
    BIND(C,NAME="glGetColorTableParameterfv")
IMPORT
INTEGER(GLenum), VALUE :: target, pname
REAL(GLfloat), DIMENSION(*), INTENT(OUT) :: params
END SUBROUTINE glGetColorTableParameterfv

!  GetColorTableParameteriv(target, pname, params)
!  return  void
!  param   target		ColorTableTarget in value
!  param   pname		GetColorTableParameterPName in value
!  param   params		Int32 out array [COMPSIZE(pname)]
SUBROUTINE glGetColorTableParameteriv(target, pname, params)                  &
    BIND(C,NAME="glGetColorTableParameteriv")
IMPORT
INTEGER(GLenum), VALUE :: target, pname
INTEGER(GLint), DIMENSION(*), INTENT(OUT) :: params
END SUBROUTINE glGetColorTableParameteriv

!  color_subtable extension  commands

!  ColorSubTable(target, start, count, format, type, data)
!  return  void
!  param   target		ColorTableTarget in value
!  param   start		SizeI in value
!  param   count		SizeI in value
!  param   format		PixelFormat in value
!  param   type		PixelType in value
!  param   data		Void in array [COMPSIZE(format/type/count)]
SUBROUTINE glColorSubTable(target, start, count, format, type, data)          &
    BIND(C,NAME="glColorSubTable")
IMPORT
INTEGER(GLenum), VALUE :: target, format, type
INTEGER(GLsizei), VALUE :: start, count
TYPE(C_PTR), VALUE :: data
END SUBROUTINE glColorSubTable

!  CopyColorSubTable(target, start, x, y, width)
!  return  void
!  param   target		ColorTableTarget in value
!  param   start		SizeI in value
!  param   x		WinCoord in value
!  param   y		WinCoord in value
!  param   width		SizeI in value
SUBROUTINE glCopyColorSubTable(target, start, x, y, width)                    &
    BIND(C,NAME="glCopyColorSubTable")
IMPORT
INTEGER(GLenum), VALUE :: target
INTEGER(GLint), VALUE :: x, y
INTEGER(GLsizei), VALUE :: start, width
END SUBROUTINE glCopyColorSubTable

!  convolution extension  commands

!  ConvolutionFilter1D(target, internalformat, width, format, type, image)
!  return  void
!  param   target		ConvolutionTarget in value
!  param   internalformat	PixelInternalFormat in value
!  param   width		SizeI in value
!  param   format		PixelFormat in value
!  param   type		PixelType in value
!  param   image		Void in array [COMPSIZE(format/type/width)]
SUBROUTINE glConvolutionFilter1D(target, internalformat, width, format,       &
    type, image) BIND(C,NAME="glConvolutionFilter1D")
IMPORT
INTEGER(GLenum), VALUE :: target, format, type
INTEGER(GLint), VALUE :: internalformat
INTEGER(GLsizei), VALUE :: width
TYPE(C_PTR), VALUE :: image
END SUBROUTINE glConvolutionFilter1D

!  ConvolutionFilter2D(target, internalformat, width, height, format, type, image)
!  return  void
!  param   target		ConvolutionTarget in value
!  param   internalformat	PixelInternalFormat in value
!  param   width		SizeI in value
!  param   height		SizeI in value
!  param   format		PixelFormat in value
!  param   type		PixelType in value
!  param   image		Void in array [COMPSIZE(format/type/width/height)]
SUBROUTINE glConvolutionFilter2D(target, internalformat, width, height,       &
    format, type, image) BIND(C,NAME="glConvolutionFilter2D")
IMPORT
INTEGER(GLenum), VALUE :: target, format, type
INTEGER(GLint), VALUE :: internalformat
INTEGER(GLsizei), VALUE :: width, height
TYPE(C_PTR), VALUE :: image
END SUBROUTINE glConvolutionFilter2D

!  ConvolutionParameterf(target, pname, params)
!  return  void
!  param   target		ConvolutionTarget in value
!  param   pname		ConvolutionParameter in value
!  param   params		CheckedFloat32 in value
SUBROUTINE glConvolutionParameterf(target, pname, params)                     &
    BIND(C,NAME="glConvolutionParameterf")
IMPORT
INTEGER(GLenum), VALUE :: target, pname
REAL(GLfloat), VALUE :: params
END SUBROUTINE glConvolutionParameterf

!  ConvolutionParameterfv(target, pname, params)
!  return  void
!  param   target		ConvolutionTarget in value
!  param   pname		ConvolutionParameter in value
!  param   params		CheckedFloat32 in array [COMPSIZE(pname)]
SUBROUTINE glConvolutionParameterfv(target, pname, params)                    &
    BIND(C,NAME="glConvolutionParameterfv")
IMPORT
INTEGER(GLenum), VALUE :: target, pname
REAL(GLfloat), DIMENSION(*), INTENT(IN) :: params
END SUBROUTINE glConvolutionParameterfv

!  ConvolutionParameteri(target, pname, params)
!  return  void
!  param   target		ConvolutionTarget in value
!  param   pname		ConvolutionParameter in value
!  param   params		CheckedInt32 in value
SUBROUTINE glConvolutionParameteri(target, pname, params)                     &
    BIND(C,NAME="glConvolutionParameteri")
IMPORT
INTEGER(GLenum), VALUE :: target, pname
INTEGER(GLint), VALUE :: params
END SUBROUTINE glConvolutionParameteri

!  ConvolutionParameteriv(target, pname, params)
!  return  void
!  param   target		ConvolutionTarget in value
!  param   pname		ConvolutionParameter in value
!  param   params		CheckedInt32 in array [COMPSIZE(pname)]
SUBROUTINE glConvolutionParameteriv(target, pname, params)                    &
    BIND(C,NAME="glConvolutionParameteriv")
IMPORT
INTEGER(GLenum), VALUE :: target, pname
INTEGER(GLint), DIMENSION(*), INTENT(IN) :: params
END SUBROUTINE glConvolutionParameteriv

!  CopyConvolutionFilter1D(target, internalformat, x, y, width)
!  return  void
!  param   target		ConvolutionTarget in value
!  param   internalformat	PixelInternalFormat in value
!  param   x		WinCoord in value
!  param   y		WinCoord in value
!  param   width		SizeI in value
SUBROUTINE glCopyConvolutionFilter1D(target, internalformat, x, y, width)     &
    BIND(C,NAME="glCopyConvolutionFilter1D")
IMPORT
INTEGER(GLenum), VALUE :: target
INTEGER(GLint), VALUE :: internalformat, x, y
INTEGER(GLsizei), VALUE :: width
END SUBROUTINE glCopyConvolutionFilter1D

!  CopyConvolutionFilter2D(target, internalformat, x, y, width, height)
!  return  void
!  param   target		ConvolutionTarget in value
!  param   internalformat	PixelInternalFormat in value
!  param   x		WinCoord in value
!  param   y		WinCoord in value
!  param   width		SizeI in value
!  param   height		SizeI in value
SUBROUTINE glCopyConvolutionFilter2D(target, internalformat, x, y, width,     &
    height) BIND(C,NAME="glCopyConvolutionFilter2D")
IMPORT
INTEGER(GLenum), VALUE :: target
INTEGER(GLint), VALUE :: internalformat, x, y
INTEGER(GLsizei), VALUE :: width, height
END SUBROUTINE glCopyConvolutionFilter2D

!  GetConvolutionFilter(target, format, type, image)
!  return  void
!  param   target		ConvolutionTarget in value
!  param   format		PixelFormat in value
!  param   type		PixelType in value
!  param   image		Void out array [COMPSIZE(target/format/type)]
SUBROUTINE glGetConvolutionFilter(target, format, type, image)                &
    BIND(C,NAME="glGetConvolutionFilter")
IMPORT
INTEGER(GLenum), VALUE :: target, format, type
TYPE(C_PTR), VALUE :: image
END SUBROUTINE glGetConvolutionFilter

!  GetConvolutionParameterfv(target, pname, params)
!  return  void
!  param   target		ConvolutionTarget in value
!  param   pname		GetConvolutionParameterPName in value
!  param   params		Float32 out array [COMPSIZE(pname)]
SUBROUTINE glGetConvolutionParameterfv(target, pname, params)                 &
    BIND(C,NAME="glGetConvolutionParameterfv")
IMPORT
INTEGER(GLenum), VALUE :: target, pname
REAL(GLfloat), DIMENSION(*), INTENT(OUT) :: params
END SUBROUTINE glGetConvolutionParameterfv

!  GetConvolutionParameteriv(target, pname, params)
!  return  void
!  param   target		ConvolutionTarget in value
!  param   pname		GetConvolutionParameterPName in value
!  param   params		Int32 out array [COMPSIZE(pname)]
SUBROUTINE glGetConvolutionParameteriv(target, pname, params)                 &
    BIND(C,NAME="glGetConvolutionParameteriv")
IMPORT
INTEGER(GLenum), VALUE :: target, pname
INTEGER(GLint), DIMENSION(*), INTENT(OUT) :: params
END SUBROUTINE glGetConvolutionParameteriv

!  GetSeparableFilter(target, format, type, row, column, span)
!  return  void
!  param   target		SeparableTarget in value
!  param   format		PixelFormat in value
!  param   type		PixelType in value
!  param   row		Void out array [COMPSIZE(target/format/type)]
!  param   column		Void out array [COMPSIZE(target/format/type)]
!  param   span		Void out array [COMPSIZE(target/format/type)]
SUBROUTINE glGetSeparableFilter(target, format, type, row, column, span)      &
    BIND(C,NAME="glGetSeparableFilter")
IMPORT
INTEGER(GLenum), VALUE :: target, format, type
TYPE(C_PTR), VALUE :: row, column, span
END SUBROUTINE glGetSeparableFilter

!  SeparableFilter2D(target, internalformat, width, height, format, type, row, column)
!  return  void
!  param   target		SeparableTarget in value
!  param   internalformat	PixelInternalFormat in value
!  param   width		SizeI in value
!  param   height		SizeI in value
!  param   format		PixelFormat in value
!  param   type		PixelType in value
!  param   row		Void in array [COMPSIZE(target/format/type/width)]
!  param   column		Void in array [COMPSIZE(target/format/type/height)]
SUBROUTINE glSeparableFilter2D(target, internalformat, width, height,         &
    format, type, row, column) BIND(C,NAME="glSeparableFilter2D")
IMPORT
INTEGER(GLenum), VALUE :: target, format, type
INTEGER(GLint), VALUE :: internalformat
INTEGER(GLsizei), VALUE :: width, height
TYPE(C_PTR), VALUE :: row, column
END SUBROUTINE glSeparableFilter2D

!  histogram extension  commands

!  GetHistogram(target, reset, format, type, values)
!  return  void
!  param   target		HistogramTarget in value
!  param   reset		Boolean in value
!  param   format		PixelFormat in value
!  param   type		PixelType in value
!  param   values		Void out array [COMPSIZE(target/format/type)]
SUBROUTINE glGetHistogram(target, reset, format, type, values)                &
    BIND(C,NAME="glGetHistogram")
IMPORT
INTEGER(GLboolean), VALUE :: reset
INTEGER(GLenum), VALUE :: target, format, type
TYPE(C_PTR), VALUE :: values
END SUBROUTINE glGetHistogram

!  GetHistogramParameterfv(target, pname, params)
!  return  void
!  param   target		HistogramTarget in value
!  param   pname		GetHistogramParameterPName in value
!  param   params		Float32 out array [COMPSIZE(pname)]
SUBROUTINE glGetHistogramParameterfv(target, pname, params)                   &
    BIND(C,NAME="glGetHistogramParameterfv")
IMPORT
INTEGER(GLenum), VALUE :: target, pname
REAL(GLfloat), DIMENSION(*), INTENT(OUT) :: params
END SUBROUTINE glGetHistogramParameterfv

!  GetHistogramParameteriv(target, pname, params)
!  return  void
!  param   target		HistogramTarget in value
!  param   pname		GetHistogramParameterPName in value
!  param   params		Int32 out array [COMPSIZE(pname)]
SUBROUTINE glGetHistogramParameteriv(target, pname, params)                   &
    BIND(C,NAME="glGetHistogramParameteriv")
IMPORT
INTEGER(GLenum), VALUE :: target, pname
INTEGER(GLint), DIMENSION(*), INTENT(OUT) :: params
END SUBROUTINE glGetHistogramParameteriv

!  GetMinmax(target, reset, format, type, values)
!  return  void
!  param   target		MinmaxTarget in value
!  param   reset		Boolean in value
!  param   format		PixelFormat in value
!  param   type		PixelType in value
!  param   values		Void out array [COMPSIZE(target/format/type)]
SUBROUTINE glGetMinmax(target, reset, format, type, values)                   &
    BIND(C,NAME="glGetMinmax")
IMPORT
INTEGER(GLboolean), VALUE :: reset
INTEGER(GLenum), VALUE :: target, format, type
TYPE(C_PTR), VALUE :: values
END SUBROUTINE glGetMinmax

!  GetMinmaxParameterfv(target, pname, params)
!  return  void
!  param   target		MinmaxTarget in value
!  param   pname		GetMinmaxParameterPName in value
!  param   params		Float32 out array [COMPSIZE(pname)]
SUBROUTINE glGetMinmaxParameterfv(target, pname, params)                      &
    BIND(C,NAME="glGetMinmaxParameterfv")
IMPORT
INTEGER(GLenum), VALUE :: target, pname
REAL(GLfloat), DIMENSION(*), INTENT(OUT) :: params
END SUBROUTINE glGetMinmaxParameterfv

!  GetMinmaxParameteriv(target, pname, params)
!  return  void
!  param   target		MinmaxTarget in value
!  param   pname		GetMinmaxParameterPName in value
!  param   params		Int32 out array [COMPSIZE(pname)]
SUBROUTINE glGetMinmaxParameteriv(target, pname, params)                      &
    BIND(C,NAME="glGetMinmaxParameteriv")
IMPORT
INTEGER(GLenum), VALUE :: target, pname
INTEGER(GLint), DIMENSION(*), INTENT(OUT) :: params
END SUBROUTINE glGetMinmaxParameteriv

!  Histogram(target, width, internalformat, sink)
!  return  void
!  param   target		HistogramTarget in value
!  param   width		SizeI in value
!  param   internalformat	PixelInternalFormat in value
!  param   sink		Boolean in value
SUBROUTINE glHistogram(target, width, internalformat, sink)                   &
    BIND(C,NAME="glHistogram")
IMPORT
INTEGER(GLboolean), VALUE :: sink
INTEGER(GLenum), VALUE :: target
INTEGER(GLint), VALUE :: internalformat
INTEGER(GLsizei), VALUE :: width
END SUBROUTINE glHistogram

!  Minmax(target, internalformat, sink)
!  return  void
!  param   target		MinmaxTarget in value
!  param   internalformat	PixelInternalFormat in value
!  param   sink		Boolean in value
SUBROUTINE glMinmax(target, internalformat, sink) BIND(C,NAME="glMinmax")
IMPORT
INTEGER(GLboolean), VALUE :: sink
INTEGER(GLenum), VALUE :: target
INTEGER(GLint), VALUE :: internalformat
END SUBROUTINE glMinmax

!  ResetHistogram(target)
!  return  void
!  param   target		HistogramTarget in value
SUBROUTINE glResetHistogram(target) BIND(C,NAME="glResetHistogram")
IMPORT
INTEGER(GLenum), VALUE :: target
END SUBROUTINE glResetHistogram

!  ResetMinmax(target)
!  return  void
!  param   target		MinmaxTarget in value
SUBROUTINE glResetMinmax(target) BIND(C,NAME="glResetMinmax")
IMPORT
INTEGER(GLenum), VALUE :: target
END SUBROUTINE glResetMinmax

!  texture3D extension  commands

!  TexImage3D(target, level, internalformat, width, height, depth, border, format, type, pixels)
!  return  void
!  param   target		TextureTarget in value
!  param   level		CheckedInt32 in value
!  param   internalformat	PixelInternalFormat in value
!  param   width		SizeI in value
!  param   height		SizeI in value
!  param   depth		SizeI in value
!  param   border		CheckedInt32 in value
!  param   format		PixelFormat in value
!  param   type		PixelType in value
!  param   pixels		Void in array [COMPSIZE(format/type/width/height/depth)]
SUBROUTINE glTexImage3D(target, level, internalformat, width, height, depth,  &
    border, format, type, pixels) BIND(C,NAME="glTexImage3D")
IMPORT
INTEGER(GLenum), VALUE :: target, format, type
INTEGER(GLint), VALUE :: level, internalformat, border
INTEGER(GLsizei), VALUE :: width, height, depth
TYPE(C_PTR), VALUE :: pixels
END SUBROUTINE glTexImage3D

!  TexSubImage3D(target, level, xoffset, yoffset, zoffset, width, height, depth, format, type, pixels)
!  return  void
!  param   target		TextureTarget in value
!  param   level		CheckedInt32 in value
!  param   xoffset		CheckedInt32 in value
!  param   yoffset		CheckedInt32 in value
!  param   zoffset		CheckedInt32 in value
!  param   width		SizeI in value
!  param   height		SizeI in value
!  param   depth		SizeI in value
!  param   format		PixelFormat in value
!  param   type		PixelType in value
!  param   pixels		Void in array [COMPSIZE(format/type/width/height/depth)]
SUBROUTINE glTexSubImage3D(target, level, xoffset, yoffset, zoffset, width,   &
    height, depth, format, type, pixels) BIND(C,NAME="glTexSubImage3D")
IMPORT
INTEGER(GLenum), VALUE :: target, format, type
INTEGER(GLint), VALUE :: level, xoffset, yoffset, zoffset
INTEGER(GLsizei), VALUE :: width, height, depth
TYPE(C_PTR), VALUE :: pixels
END SUBROUTINE glTexSubImage3D

!  CopyTexSubImage3D(target, level, xoffset, yoffset, zoffset, x, y, width, height)
!  return  void
!  param   target		TextureTarget in value
!  param   level		CheckedInt32 in value
!  param   xoffset		CheckedInt32 in value
!  param   yoffset		CheckedInt32 in value
!  param   zoffset		CheckedInt32 in value
!  param   x		WinCoord in value
!  param   y		WinCoord in value
!  param   width		SizeI in value
!  param   height		SizeI in value
SUBROUTINE glCopyTexSubImage3D(target, level, xoffset, yoffset, zoffset, x,   &
    y, width, height) BIND(C,NAME="glCopyTexSubImage3D")
IMPORT
INTEGER(GLenum), VALUE :: target
INTEGER(GLint), VALUE :: level, xoffset, yoffset, zoffset, x, y
INTEGER(GLsizei), VALUE :: width, height
END SUBROUTINE glCopyTexSubImage3D

!  ActiveTextureARB(texture)
!  return  void
!  param   texture		TextureUnit in value
SUBROUTINE glActiveTextureARB(texture) BIND(C,NAME="glActiveTextureARB")
IMPORT
INTEGER(GLenum), VALUE :: texture
END SUBROUTINE glActiveTextureARB

!  ClientActiveTextureARB(texture)
!  return  void
!  param   texture		TextureUnit in value
SUBROUTINE glClientActiveTextureARB(texture)                                  &
    BIND(C,NAME="glClientActiveTextureARB")
IMPORT
INTEGER(GLenum), VALUE :: texture
END SUBROUTINE glClientActiveTextureARB

!  MultiTexCoord1dARB(target, s)
!  return  void
!  param   target		TextureUnit in value
!  param   s		CoordD in value
SUBROUTINE glMultiTexCoord1dARB(target, s)                                    &
    BIND(C,NAME="glMultiTexCoord1dARB")
IMPORT
INTEGER(GLenum), VALUE :: target
REAL(GLdouble), VALUE :: s
END SUBROUTINE glMultiTexCoord1dARB

!  MultiTexCoord1dvARB(target, v)
!  return  void
!  param   target		TextureUnit in value
!  param   v		CoordD in array [1]
SUBROUTINE glMultiTexCoord1dvARB(target, v)                                   &
    BIND(C,NAME="glMultiTexCoord1dvARB")
IMPORT
INTEGER(GLenum), VALUE :: target
REAL(GLdouble), INTENT(IN) :: v
END SUBROUTINE glMultiTexCoord1dvARB

!  MultiTexCoord1fARB(target, s)
!  return  void
!  param   target		TextureUnit in value
!  param   s		CoordF in value
SUBROUTINE glMultiTexCoord1fARB(target, s)                                    &
    BIND(C,NAME="glMultiTexCoord1fARB")
IMPORT
INTEGER(GLenum), VALUE :: target
REAL(GLfloat), VALUE :: s
END SUBROUTINE glMultiTexCoord1fARB

!  MultiTexCoord1fvARB(target, v)
!  return  void
!  param   target		TextureUnit in value
!  param   v		CoordF in array [1]
SUBROUTINE glMultiTexCoord1fvARB(target, v)                                   &
    BIND(C,NAME="glMultiTexCoord1fvARB")
IMPORT
INTEGER(GLenum), VALUE :: target
REAL(GLfloat), INTENT(IN) :: v
END SUBROUTINE glMultiTexCoord1fvARB

!  MultiTexCoord1iARB(target, s)
!  return  void
!  param   target		TextureUnit in value
!  param   s		CoordI in value
SUBROUTINE glMultiTexCoord1iARB(target, s)                                    &
    BIND(C,NAME="glMultiTexCoord1iARB")
IMPORT
INTEGER(GLenum), VALUE :: target
INTEGER(GLint), VALUE :: s
END SUBROUTINE glMultiTexCoord1iARB

!  MultiTexCoord1ivARB(target, v)
!  return  void
!  param   target		TextureUnit in value
!  param   v		CoordI in array [1]
SUBROUTINE glMultiTexCoord1ivARB(target, v)                                   &
    BIND(C,NAME="glMultiTexCoord1ivARB")
IMPORT
INTEGER(GLenum), VALUE :: target
INTEGER(GLint), INTENT(IN) :: v
END SUBROUTINE glMultiTexCoord1ivARB

!  MultiTexCoord1sARB(target, s)
!  return  void
!  param   target		TextureUnit in value
!  param   s		CoordS in value
SUBROUTINE glMultiTexCoord1sARB(target, s)                                    &
    BIND(C,NAME="glMultiTexCoord1sARB")
IMPORT
INTEGER(GLenum), VALUE :: target
INTEGER(GLshort), VALUE :: s
END SUBROUTINE glMultiTexCoord1sARB

!  MultiTexCoord1svARB(target, v)
!  return  void
!  param   target		TextureUnit in value
!  param   v		CoordS in array [1]
SUBROUTINE glMultiTexCoord1svARB(target, v)                                   &
    BIND(C,NAME="glMultiTexCoord1svARB")
IMPORT
INTEGER(GLenum), VALUE :: target
INTEGER(GLshort), INTENT(IN) :: v
END SUBROUTINE glMultiTexCoord1svARB

!  MultiTexCoord2dARB(target, s, t)
!  return  void
!  param   target		TextureUnit in value
!  param   s		CoordD in value
!  param   t		CoordD in value
SUBROUTINE glMultiTexCoord2dARB(target, s, t)                                 &
    BIND(C,NAME="glMultiTexCoord2dARB")
IMPORT
INTEGER(GLenum), VALUE :: target
REAL(GLdouble), VALUE :: s, t
END SUBROUTINE glMultiTexCoord2dARB

!  MultiTexCoord2dvARB(target, v)
!  return  void
!  param   target		TextureUnit in value
!  param   v		CoordD in array [2]
SUBROUTINE glMultiTexCoord2dvARB(target, v)                                   &
    BIND(C,NAME="glMultiTexCoord2dvARB")
IMPORT
INTEGER(GLenum), VALUE :: target
REAL(GLdouble), DIMENSION(2), INTENT(IN) :: v
END SUBROUTINE glMultiTexCoord2dvARB

!  MultiTexCoord2fARB(target, s, t)
!  return  void
!  param   target		TextureUnit in value
!  param   s		CoordF in value
!  param   t		CoordF in value
SUBROUTINE glMultiTexCoord2fARB(target, s, t)                                 &
    BIND(C,NAME="glMultiTexCoord2fARB")
IMPORT
INTEGER(GLenum), VALUE :: target
REAL(GLfloat), VALUE :: s, t
END SUBROUTINE glMultiTexCoord2fARB

!  MultiTexCoord2fvARB(target, v)
!  return  void
!  param   target		TextureUnit in value
!  param   v		CoordF in array [2]
SUBROUTINE glMultiTexCoord2fvARB(target, v)                                   &
    BIND(C,NAME="glMultiTexCoord2fvARB")
IMPORT
INTEGER(GLenum), VALUE :: target
REAL(GLfloat), DIMENSION(2), INTENT(IN) :: v
END SUBROUTINE glMultiTexCoord2fvARB

!  MultiTexCoord2iARB(target, s, t)
!  return  void
!  param   target		TextureUnit in value
!  param   s		CoordI in value
!  param   t		CoordI in value
SUBROUTINE glMultiTexCoord2iARB(target, s, t)                                 &
    BIND(C,NAME="glMultiTexCoord2iARB")
IMPORT
INTEGER(GLenum), VALUE :: target
INTEGER(GLint), VALUE :: s, t
END SUBROUTINE glMultiTexCoord2iARB

!  MultiTexCoord2ivARB(target, v)
!  return  void
!  param   target		TextureUnit in value
!  param   v		CoordI in array [2]
SUBROUTINE glMultiTexCoord2ivARB(target, v)                                   &
    BIND(C,NAME="glMultiTexCoord2ivARB")
IMPORT
INTEGER(GLenum), VALUE :: target
INTEGER(GLint), DIMENSION(2), INTENT(IN) :: v
END SUBROUTINE glMultiTexCoord2ivARB

!  MultiTexCoord2sARB(target, s, t)
!  return  void
!  param   target		TextureUnit in value
!  param   s		CoordS in value
!  param   t		CoordS in value
SUBROUTINE glMultiTexCoord2sARB(target, s, t)                                 &
    BIND(C,NAME="glMultiTexCoord2sARB")
IMPORT
INTEGER(GLenum), VALUE :: target
INTEGER(GLshort), VALUE :: s, t
END SUBROUTINE glMultiTexCoord2sARB

!  MultiTexCoord2svARB(target, v)
!  return  void
!  param   target		TextureUnit in value
!  param   v		CoordS in array [2]
SUBROUTINE glMultiTexCoord2svARB(target, v)                                   &
    BIND(C,NAME="glMultiTexCoord2svARB")
IMPORT
INTEGER(GLenum), VALUE :: target
INTEGER(GLshort), DIMENSION(2), INTENT(IN) :: v
END SUBROUTINE glMultiTexCoord2svARB

!  MultiTexCoord3dARB(target, s, t, r)
!  return  void
!  param   target		TextureUnit in value
!  param   s		CoordD in value
!  param   t		CoordD in value
!  param   r		CoordD in value
SUBROUTINE glMultiTexCoord3dARB(target, s, t, r)                              &
    BIND(C,NAME="glMultiTexCoord3dARB")
IMPORT
INTEGER(GLenum), VALUE :: target
REAL(GLdouble), VALUE :: s, t, r
END SUBROUTINE glMultiTexCoord3dARB

!  MultiTexCoord3dvARB(target, v)
!  return  void
!  param   target		TextureUnit in value
!  param   v		CoordD in array [3]
SUBROUTINE glMultiTexCoord3dvARB(target, v)                                   &
    BIND(C,NAME="glMultiTexCoord3dvARB")
IMPORT
INTEGER(GLenum), VALUE :: target
REAL(GLdouble), DIMENSION(3), INTENT(IN) :: v
END SUBROUTINE glMultiTexCoord3dvARB

!  MultiTexCoord3fARB(target, s, t, r)
!  return  void
!  param   target		TextureUnit in value
!  param   s		CoordF in value
!  param   t		CoordF in value
!  param   r		CoordF in value
SUBROUTINE glMultiTexCoord3fARB(target, s, t, r)                              &
    BIND(C,NAME="glMultiTexCoord3fARB")
IMPORT
INTEGER(GLenum), VALUE :: target
REAL(GLfloat), VALUE :: s, t, r
END SUBROUTINE glMultiTexCoord3fARB

!  MultiTexCoord3fvARB(target, v)
!  return  void
!  param   target		TextureUnit in value
!  param   v		CoordF in array [3]
SUBROUTINE glMultiTexCoord3fvARB(target, v)                                   &
    BIND(C,NAME="glMultiTexCoord3fvARB")
IMPORT
INTEGER(GLenum), VALUE :: target
REAL(GLfloat), DIMENSION(3), INTENT(IN) :: v
END SUBROUTINE glMultiTexCoord3fvARB

!  MultiTexCoord3iARB(target, s, t, r)
!  return  void
!  param   target		TextureUnit in value
!  param   s		CoordI in value
!  param   t		CoordI in value
!  param   r		CoordI in value
SUBROUTINE glMultiTexCoord3iARB(target, s, t, r)                              &
    BIND(C,NAME="glMultiTexCoord3iARB")
IMPORT
INTEGER(GLenum), VALUE :: target
INTEGER(GLint), VALUE :: s, t, r
END SUBROUTINE glMultiTexCoord3iARB

!  MultiTexCoord3ivARB(target, v)
!  return  void
!  param   target		TextureUnit in value
!  param   v		CoordI in array [3]
SUBROUTINE glMultiTexCoord3ivARB(target, v)                                   &
    BIND(C,NAME="glMultiTexCoord3ivARB")
IMPORT
INTEGER(GLenum), VALUE :: target
INTEGER(GLint), DIMENSION(3), INTENT(IN) :: v
END SUBROUTINE glMultiTexCoord3ivARB

!  MultiTexCoord3sARB(target, s, t, r)
!  return  void
!  param   target		TextureUnit in value
!  param   s		CoordS in value
!  param   t		CoordS in value
!  param   r		CoordS in value
SUBROUTINE glMultiTexCoord3sARB(target, s, t, r)                              &
    BIND(C,NAME="glMultiTexCoord3sARB")
IMPORT
INTEGER(GLenum), VALUE :: target
INTEGER(GLshort), VALUE :: s, t, r
END SUBROUTINE glMultiTexCoord3sARB

!  MultiTexCoord3svARB(target, v)
!  return  void
!  param   target		TextureUnit in value
!  param   v		CoordS in array [3]
SUBROUTINE glMultiTexCoord3svARB(target, v)                                   &
    BIND(C,NAME="glMultiTexCoord3svARB")
IMPORT
INTEGER(GLenum), VALUE :: target
INTEGER(GLshort), DIMENSION(3), INTENT(IN) :: v
END SUBROUTINE glMultiTexCoord3svARB

!  MultiTexCoord4dARB(target, s, t, r, q)
!  return  void
!  param   target		TextureUnit in value
!  param   s		CoordD in value
!  param   t		CoordD in value
!  param   r		CoordD in value
!  param   q		CoordD in value
SUBROUTINE glMultiTexCoord4dARB(target, s, t, r, q)                           &
    BIND(C,NAME="glMultiTexCoord4dARB")
IMPORT
INTEGER(GLenum), VALUE :: target
REAL(GLdouble), VALUE :: s, t, r, q
END SUBROUTINE glMultiTexCoord4dARB

!  MultiTexCoord4dvARB(target, v)
!  return  void
!  param   target		TextureUnit in value
!  param   v		CoordD in array [4]
SUBROUTINE glMultiTexCoord4dvARB(target, v)                                   &
    BIND(C,NAME="glMultiTexCoord4dvARB")
IMPORT
INTEGER(GLenum), VALUE :: target
REAL(GLdouble), DIMENSION(4), INTENT(IN) :: v
END SUBROUTINE glMultiTexCoord4dvARB

!  MultiTexCoord4fARB(target, s, t, r, q)
!  return  void
!  param   target		TextureUnit in value
!  param   s		CoordF in value
!  param   t		CoordF in value
!  param   r		CoordF in value
!  param   q		CoordF in value
SUBROUTINE glMultiTexCoord4fARB(target, s, t, r, q)                           &
    BIND(C,NAME="glMultiTexCoord4fARB")
IMPORT
INTEGER(GLenum), VALUE :: target
REAL(GLfloat), VALUE :: s, t, r, q
END SUBROUTINE glMultiTexCoord4fARB

!  MultiTexCoord4fvARB(target, v)
!  return  void
!  param   target		TextureUnit in value
!  param   v		CoordF in array [4]
SUBROUTINE glMultiTexCoord4fvARB(target, v)                                   &
    BIND(C,NAME="glMultiTexCoord4fvARB")
IMPORT
INTEGER(GLenum), VALUE :: target
REAL(GLfloat), DIMENSION(4), INTENT(IN) :: v
END SUBROUTINE glMultiTexCoord4fvARB

!  MultiTexCoord4iARB(target, s, t, r, q)
!  return  void
!  param   target		TextureUnit in value
!  param   s		CoordI in value
!  param   t		CoordI in value
!  param   r		CoordI in value
!  param   q		CoordI in value
SUBROUTINE glMultiTexCoord4iARB(target, s, t, r, q)                           &
    BIND(C,NAME="glMultiTexCoord4iARB")
IMPORT
INTEGER(GLenum), VALUE :: target
INTEGER(GLint), VALUE :: s, t, r, q
END SUBROUTINE glMultiTexCoord4iARB

!  MultiTexCoord4ivARB(target, v)
!  return  void
!  param   target		TextureUnit in value
!  param   v		CoordI in array [4]
SUBROUTINE glMultiTexCoord4ivARB(target, v)                                   &
    BIND(C,NAME="glMultiTexCoord4ivARB")
IMPORT
INTEGER(GLenum), VALUE :: target
INTEGER(GLint), DIMENSION(4), INTENT(IN) :: v
END SUBROUTINE glMultiTexCoord4ivARB

!  MultiTexCoord4sARB(target, s, t, r, q)
!  return  void
!  param   target		TextureUnit in value
!  param   s		CoordS in value
!  param   t		CoordS in value
!  param   r		CoordS in value
!  param   q		CoordS in value
SUBROUTINE glMultiTexCoord4sARB(target, s, t, r, q)                           &
    BIND(C,NAME="glMultiTexCoord4sARB")
IMPORT
INTEGER(GLenum), VALUE :: target
INTEGER(GLshort), VALUE :: s, t, r, q
END SUBROUTINE glMultiTexCoord4sARB

!  MultiTexCoord4svARB(target, v)
!  return  void
!  param   target		TextureUnit in value
!  param   v		CoordS in array [4]
SUBROUTINE glMultiTexCoord4svARB(target, v)                                   &
    BIND(C,NAME="glMultiTexCoord4svARB")
IMPORT
INTEGER(GLenum), VALUE :: target
INTEGER(GLshort), DIMENSION(4), INTENT(IN) :: v
END SUBROUTINE glMultiTexCoord4svARB

!  EXT_compiled_vertex_array extension  commands

!  LockArraysEXT(first, count)
!  return  void
!  param   first		Int32 in value
!  param   count		SizeI in value
SUBROUTINE glLockArraysEXT(first, count) BIND(C,NAME="glLockArraysEXT")
IMPORT
INTEGER(GLint), VALUE :: first
INTEGER(GLsizei), VALUE :: count
END SUBROUTINE glLockArraysEXT

!  UnlockArraysEXT()
!  return  void
SUBROUTINE glUnlockArraysEXT() BIND(C,NAME="glUnlockArraysEXT")
IMPORT
END SUBROUTINE glUnlockArraysEXT

!  EXT_vertex_array extension  commands

!  ArrayElementEXT(i)
!  return  void
!  param   i		Int32 in value
SUBROUTINE glArrayElementEXT(i) BIND(C,NAME="glArrayElementEXT")
IMPORT
INTEGER(GLint), VALUE :: i
END SUBROUTINE glArrayElementEXT

!  ColorPointerEXT(size, type, stride, count, pointer)
!  return  void
!  param   size		Int32 in value
!  param   type		ColorPointerType in value
!  param   stride		SizeI in value
!  param   count		SizeI in value
!  param   pointer		Void in array [COMPSIZE(size/type/stride/count)] retained
SUBROUTINE glColorPointerEXT(size, type, stride, count, pointer)              &
    BIND(C,NAME="glColorPointerEXT")
IMPORT
INTEGER(GLenum), VALUE :: type
INTEGER(GLint), VALUE :: size
INTEGER(GLsizei), VALUE :: stride, count
TYPE(C_PTR), VALUE :: pointer
END SUBROUTINE glColorPointerEXT

!  EdgeFlagPointerEXT(stride, count, pointer)
!  return  void
!  param   stride		SizeI in value
!  param   count		SizeI in value
!  param   pointer		Boolean in array [COMPSIZE(stride/count)] retained
SUBROUTINE glEdgeFlagPointerEXT(stride, count, pointer)                       &
    BIND(C,NAME="glEdgeFlagPointerEXT")
IMPORT
INTEGER(GLsizei), VALUE :: stride, count
TYPE(C_PTR), VALUE :: pointer
END SUBROUTINE glEdgeFlagPointerEXT

!  GetPointervEXT(pname, params)
!  return  void
!  param   pname		GetPointervPName in value
!  param   params		VoidPointer out array [1]
SUBROUTINE glGetPointervEXT(pname, params) BIND(C,NAME="glGetPointervEXT")
IMPORT
INTEGER(GLenum), VALUE :: pname
TYPE(C_PTR), INTENT(OUT) :: params
END SUBROUTINE glGetPointervEXT

!  IndexPointerEXT(type, stride, count, pointer)
!  return  void
!  param   type		IndexPointerType in value
!  param   stride		SizeI in value
!  param   count		SizeI in value
!  param   pointer		Void in array [COMPSIZE(type/stride/count)] retained
SUBROUTINE glIndexPointerEXT(type, stride, count, pointer)                    &
    BIND(C,NAME="glIndexPointerEXT")
IMPORT
INTEGER(GLenum), VALUE :: type
INTEGER(GLsizei), VALUE :: stride, count
TYPE(C_PTR), VALUE :: pointer
END SUBROUTINE glIndexPointerEXT

!  NormalPointerEXT(type, stride, count, pointer)
!  return  void
!  param   type		NormalPointerType in value
!  param   stride		SizeI in value
!  param   count		SizeI in value
!  param   pointer		Void in array [COMPSIZE(type/stride/count)] retained
SUBROUTINE glNormalPointerEXT(type, stride, count, pointer)                   &
    BIND(C,NAME="glNormalPointerEXT")
IMPORT
INTEGER(GLenum), VALUE :: type
INTEGER(GLsizei), VALUE :: stride, count
TYPE(C_PTR), VALUE :: pointer
END SUBROUTINE glNormalPointerEXT

!  TexCoordPointerEXT(size, type, stride, count, pointer)
!  return  void
!  param   size		Int32 in value
!  param   type		TexCoordPointerType in value
!  param   stride		SizeI in value
!  param   count		SizeI in value
!  param   pointer		Void in array [COMPSIZE(size/type/stride/count)] retained
SUBROUTINE glTexCoordPointerEXT(size, type, stride, count, pointer)           &
    BIND(C,NAME="glTexCoordPointerEXT")
IMPORT
INTEGER(GLenum), VALUE :: type
INTEGER(GLint), VALUE :: size
INTEGER(GLsizei), VALUE :: stride, count
TYPE(C_PTR), VALUE :: pointer
END SUBROUTINE glTexCoordPointerEXT

!  VertexPointerEXT(size, type, stride, count, pointer)
!  return  void
!  param   size		Int32 in value
!  param   type		VertexPointerType in value
!  param   stride		SizeI in value
!  param   count		SizeI in value
!  param   pointer		Void in array [COMPSIZE(size/type/stride/count)] retained
SUBROUTINE glVertexPointerEXT(size, type, stride, count, pointer)             &
    BIND(C,NAME="glVertexPointerEXT")
IMPORT
INTEGER(GLenum), VALUE :: type
INTEGER(GLint), VALUE :: size
INTEGER(GLsizei), VALUE :: stride, count
TYPE(C_PTR), VALUE :: pointer
END SUBROUTINE glVertexPointerEXT

!  DrawArraysEXT(mode, first, count)
!  return  void
!  param   mode		BeginMode in value
!  param   first		Int32 in value
!  param   count		SizeI in value
SUBROUTINE glDrawArraysEXT(mode, first, count)                                &
    BIND(C,NAME="glDrawArraysEXT")
IMPORT
INTEGER(GLenum), VALUE :: mode
INTEGER(GLint), VALUE :: first
INTEGER(GLsizei), VALUE :: count
END SUBROUTINE glDrawArraysEXT

!  AreTexturesResidentEXT(n, textures, residences)
!  return  Boolean
!  param   n		SizeI in value
!  param   textures	Texture in array [n]
!  param   residences	Boolean out array [n]
FUNCTION glAreTexturesResidentEXT(n, textures, residences)                    &
    BIND(C,NAME="glAreTexturesResidentEXT")
IMPORT
INTEGER(GLboolean) :: glAreTexturesResidentEXT
INTEGER(GLsizei), VALUE :: n
INTEGER(GLboolean), DIMENSION(n), INTENT(OUT) :: residences
INTEGER(GLuint), DIMENSION(n), INTENT(IN) :: textures
END FUNCTION glAreTexturesResidentEXT

!  DeleteTexturesEXT(n, textures)
!  return  void
!  param   n		SizeI in value
!  param   textures	Texture in array [n]
SUBROUTINE glDeleteTexturesEXT(n, textures)                                   &
    BIND(C,NAME="glDeleteTexturesEXT")
IMPORT
INTEGER(GLsizei), VALUE :: n
INTEGER(GLuint), DIMENSION(n), INTENT(IN) :: textures
END SUBROUTINE glDeleteTexturesEXT

!  GenTexturesEXT(n, textures)
!  return  void
!  param   n		SizeI in value
!  param   textures	Texture out array [n]
SUBROUTINE glGenTexturesEXT(n, textures) BIND(C,NAME="glGenTexturesEXT")
IMPORT
INTEGER(GLsizei), VALUE :: n
INTEGER(GLuint), DIMENSION(n), INTENT(OUT) :: textures
END SUBROUTINE glGenTexturesEXT

!  IsTextureEXT(texture)
!  return  Boolean
!  param   texture		Texture in value
FUNCTION glIsTextureEXT(texture) BIND(C,NAME="glIsTextureEXT")
IMPORT
INTEGER(GLboolean) :: glIsTextureEXT
INTEGER(GLuint), VALUE :: texture
END FUNCTION glIsTextureEXT

END INTERFACE

END MODULE  OpenGL_gl

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2010 Krzysztof M. Gorski, Eric Hivon, 
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.jpl.nasa.gov
!
!-----------------------------------------------------------------------------
MODULE healpix_types
  implicit none
  ! This module sets the types used in the Fortran 90 modules
  ! of the HEALPIX distribution and follows the example of Numerical Recipes
  !
  ! Benjamin D. Wandelt October 1997
  ! Eric Hivon June 1998
  ! Eric Hivon Oct  2001, edited to be compatible with 'F' compiler
  ! Eric Hivon July 2002, addition of i8b, i2b, i1b
  !                       addition of max_i8b, max_i2b and max_i1b
  !            Jan 2005, explicit form of max_i1b because of ifc 8.1.021
  !            June 2005, redefine i8b as 16 digit integer because of Nec f90 compiler
  !            Mars 2008: i8b same as i4b on machines not supporting 64 bits (NO64BITS flag set)
  !            Feb  2009: introduce healpix_version
  !
  character(len=*), PARAMETER, public :: healpix_version = '2.14a'
  INTEGER, PARAMETER, public :: i4b = SELECTED_INT_KIND(9)
  INTEGER, PARAMETER, public :: i8b = SELECTED_INT_KIND(16)

  INTEGER, PARAMETER, public :: i2b = SELECTED_INT_KIND(4)
  INTEGER, PARAMETER, public :: i1b = SELECTED_INT_KIND(2)
  INTEGER, PARAMETER, public :: sp  = SELECTED_REAL_KIND(5,30)
  INTEGER, PARAMETER, public :: dp  = SELECTED_REAL_KIND(12,200)
  INTEGER, PARAMETER, public :: lgt = KIND(.TRUE.)
  INTEGER, PARAMETER, public :: spc = KIND((1.0_sp, 1.0_sp))
  INTEGER, PARAMETER, public :: dpc = KIND((1.0_dp, 1.0_dp))
  !
  INTEGER(I8B),  PARAMETER, public :: max_i8b = HUGE(1_i8b)
  INTEGER,       PARAMETER, public :: max_i4b = HUGE(1_i4b)
  INTEGER,       PARAMETER, public :: max_i2b = HUGE(1_i2b)
  INTEGER,       PARAMETER, public :: max_i1b = 127
  REAL(kind=sp), PARAMETER, public :: max_sp  = HUGE(1.0_sp)
  REAL(kind=dp), PARAMETER, public :: max_dp  = HUGE(1.0_dp)

  ! Numerical Constant (Double precision)
  REAL(kind=dp), PARAMETER, public :: QUARTPI=0.785398163397448309615660845819875721049_dp
  REAL(kind=dp), PARAMETER, public :: HALFPI= 1.570796326794896619231321691639751442099_dp
  REAL(kind=dp), PARAMETER, public :: PI    = 3.141592653589793238462643383279502884197_dp
  REAL(kind=dp), PARAMETER, public :: TWOPI = 6.283185307179586476925286766559005768394_dp
  REAL(kind=dp), PARAMETER, public :: FOURPI=12.56637061435917295385057353311801153679_dp
  REAL(kind=dp), PARAMETER, public :: SQRT2 = 1.41421356237309504880168872420969807856967_dp
  REAL(kind=dp), PARAMETER, public :: EULER = 0.5772156649015328606065120900824024310422_dp
  REAL(kind=dp), PARAMETER, public :: SQ4PI_INV = 0.2820947917738781434740397257803862929220_dp
  REAL(kind=dp), PARAMETER, public :: TWOTHIRD = 0.6666666666666666666666666666666666666666_dp

  real(kind=DP), parameter, public :: RAD2DEG = 180.0_DP / PI
  real(kind=DP), parameter, public :: DEG2RAD = PI / 180.0_DP
  real(kind=SP), parameter, public :: hpx_sbadval = -1.6375e30_sp
  real(kind=DP), parameter, public :: hpx_dbadval = -1.6375e30_dp

  ! Maximum length of filenames
  integer, parameter :: filenamelen = 1024


!   ! ---- Normalisation and convention ----
   ! normalisation of spin weighted functions
   real(kind=dp), parameter, public ::  KvS = 1.0_dp ! 1.0 : CMBFAST (Healpix 1.2)
!   ! sign of Q
!   real(kind=dp), parameter, public :: sgQ = -1.0_dp ! -1 : CMBFAST (Healpix 1.2)
!   ! sign of spin weighted function !
!   real(kind=dp), parameter, public :: SW1 = -1.0_dp ! -1 : Healpix 1.2, bug correction

! !  ! normalisation of spin weighted functions
! !  real(kind=dp), parameter, public ::  KvS = 2.0_dp ! 2.0 : KKS  (Healpix 1.1)
! !  ! sign of Q
! !  real(kind=dp), parameter, public :: sgQ = +1.0_dp ! +1 : KKS (Healpix 1.1)
! !  ! sign of spin weighted function !
! !  real(kind=dp), parameter, public :: SW1 = +1.0_dp ! +1 : Healpix 1.1

!   real(kind=dp), parameter, public :: iKvS = 1.0_dp / KvS  ! inverse of KvS

END MODULE healpix_types

!> \file gadget_general_class.f90

!> \brief Handles universal GADGET stuff.  
!!
!! Provides types to handle units and constants in a 
!! standard way.  Note that where 6 element arrays are needed that
!! correspond to particle types, we have indexed them from 0-5 as 
!! opposed to the default Fortran 1-6. 
!< 

module gadget_general_class
use myf03_mod

#ifdef useMPI
  use mpi
#endif

#ifdef useHDF5
  use hdf5_wrapper
#endif

implicit none
private


public :: gadget_ptype_names

public :: gadget_units_type
public :: gadget_units_set
public :: gadget_units_print_lun
public :: gadget_units_read_lun
public :: gadget_units_read_file
public :: gadget_units_write_lun
public :: gadget_units_broadcast

public :: gadget_constants_type
public :: gadget_constants_read_lun
public :: gadget_constants_read_file
public :: gadget_constants_write_lun

public :: gadget_data_attributes_type
public :: gadget_data_attributes_set
public :: gadget_data_attributes_read_lun
public :: gadget_data_attributes_write_lun

public :: form_gadget_snapshot_file_name




!> Particle type names
!-----------------------------------------
character(5), parameter :: gadget_ptype_names(0:5) = &
     (/"gas  ","halo ","disk ","bulge","stars","bndry"/)


!> Units type (default= kpc/h, 1.0e10 Msolar/h, km/s)
!-----------------------------------------------------
type gadget_units_type
   real(r8b) :: cgs_length   = 3.0856780d21  !<  [cm h^-1]
   real(r8b) :: cgs_mass     = 1.989d43      !<  [g h^-1]
   real(r8b) :: cgs_velocity = 1.0d5         !<  [cm s^-1]
   real(r8b) :: cgs_time     = 3.085678d16   !<  [s h^-1]
   real(r8b) :: cgs_density  = 6.769911d-22  !<  [g cm^-3 h^2]
   real(r8b) :: cgs_pressure = 6.769911d-12  !<  [ba = g cm^-1 s^-2 h^2]
   real(r8b) :: cgs_energy   = 1.989d53      !<  [erg = g cm^2 s^-2 h^-1] 
end type gadget_units_type


!> Constants type ( 23 doubles )
!-----------------------------------------
type gadget_constants_type
   real(r8b) :: PI = 3.1415927d0                 !< [pure]                  
   real(r8b) :: GAMMA = 1.6666667d0              !< [pure]
   real(r8b) :: GRAVITY = 6.6720000d-08          !< [cm^3 g^-1s^-2]    
   real(r8b) :: SOLAR_MASS = 1.9890000d+33       !< [g]                        
   real(r8b) :: SOLAR_LUM = 3.8260000d+33        !< [erg/s]
   real(r8b) :: RAD_CONST = 7.5650000d-15        !< [erg cm^-3 K^-4]  
   real(r8b) :: AVOGADRO = 6.0222000d+23         !< [pure] 
   real(r8b) :: BOLTZMANN = 1.3806000d-16        !< [cm^2 g s^-2 K^-1] 
   real(r8b) :: GAS_CONST = 83142500.d0          !< [erg K^-1 mol^-1]  
   real(r8b) :: C = 2.9979000d+10                !< [cm/s]   
   real(r8b) :: PLANCK = 6.6262000d-27           !< [cm^2 g s^-1]  
   real(r8b) :: CM_PER_MPC = 3.0856780d+24       !< [pure]    
   real(r8b) :: PROTONMASS = 1.6726000d-24       !< [g]
   real(r8b) :: ELECTRONMASS = 9.1095300d-28     !< [g] 
   real(r8b) :: ELECTRONCHARGE = 4.8032000d-10   !< [esu]
   real(r8b) :: HUBBLE = 3.2407789d-18           !< [s^-1 h]
   real(r8b) :: T_CMB0 = 2.7280000d0             !< [K]
   real(r8b) :: SEC_PER_MEGAYEAR = 3.1550000d+13 !< [pure]
   real(r8b) :: SEC_PER_YEAR = 31550000.d0       !< [pure]
   real(r8b) :: STEFAN = 7.5657000d-15     !< = rad. const. [erg cm^-3 K^-4]  
   real(r8b) :: THOMPSON = 6.6524587d-25   !< [cm^2]
   real(r8b) :: EV_TO_ERG = 1.6021765d-12  !< [pure]
   real(r8b) :: Z_SOLAR = 0.012663729d0    !< [Mass Fraction] 
end type gadget_constants_type


!> Attributes for data in HDF5 files.
!-----------------------------------------------------
type gadget_data_attributes_type
   real(r8b) :: CGSConversionFactor 
   real(r4b) :: h_scale_exponent
   real(r4b) :: aexp_scale_exponent
   character(200) :: VarDescription
end type gadget_data_attributes_type



type(gadget_data_attributes_type), public :: pos_attrs
type(gadget_data_attributes_type), public :: id_attrs
type(gadget_data_attributes_type), public :: mass_attrs
type(gadget_data_attributes_type), public :: T_attrs
type(gadget_data_attributes_type), public :: rho_attrs
type(gadget_data_attributes_type), public :: ye_attrs
type(gadget_data_attributes_type), public :: xHI_attrs
type(gadget_data_attributes_type), public :: hsml_attrs
type(gadget_data_attributes_type), public :: lasthit_attrs

type(gadget_data_attributes_type), public :: vel_attrs
type(gadget_data_attributes_type), public :: xHI_cloudy_attrs
type(gadget_data_attributes_type), public :: Hmf_attrs
type(gadget_data_attributes_type), public :: xHeI_attrs
type(gadget_data_attributes_type), public :: xHeII_attrs
type(gadget_data_attributes_type), public :: Hemf_attrs
type(gadget_data_attributes_type), public :: gammaHI_attrs
type(gadget_data_attributes_type), public :: eos_attrs
type(gadget_data_attributes_type), public :: sfr_attrs


contains


!!============================================
!!
!!    UNITS    
!!
!!============================================



!> sets user supplied units
!--------------------------------------------------------------
subroutine gadget_units_set(this, cgs_length, cgs_mass, cgs_velocity)
  type(gadget_units_type) :: this
  real(r8b) :: cgs_length
  real(r8b) :: cgs_mass
  real(r8b) :: cgs_velocity

  this%cgs_length   = cgs_length
  this%cgs_mass     = cgs_mass
  this%cgs_velocity = cgs_velocity

  this%cgs_density  = this%cgs_mass / this%cgs_length**3
  this%cgs_energy   = this%cgs_mass * this%cgs_velocity**2
  this%cgs_time     = this%cgs_length / this%cgs_velocity
  this%cgs_pressure = this%cgs_mass / &
       (this%cgs_length**3 / this%cgs_velocity**2)

end subroutine gadget_units_set


!> formatted print of units to lun (including standard out)
!---------------------------------------------------------------
subroutine gadget_units_print_lun(this, lun, h)
  type(gadget_units_type), intent(in) :: this 
  integer(i4b), intent(in) :: lun
  real(r8b), intent(in) :: h

  type(gadget_constants_type) :: gconst

  character(clen) :: n1
  character(clen) :: star_fmt
  character(clen) :: unit_fmt
  character(clen) :: line_fmt

  real(r8b), parameter :: cm_per_km = 1.0d5

  ! binding energy of 1.0d8 [Msolar/h] halo @ z=0 
  ! Delta_c = 18 pi^2, units = erg/h
  ! http://arxiv.org/pdf/astro-ph/0010468v3
  real(r8b), parameter :: E8 = 5.45d53 * 1.0d-1

  real(r8b) :: rho_crit_0

  rho_crit_0 = 3.0d0 * gconst%hubble**2 / (8.0d0 * gconst%pi * gconst%gravity)

  star_fmt = "(78('='))"
  line_fmt = "(78('-'))"
  unit_fmt = "(A,T30,A)"

  write(lun,*)
  write(lun,star_fmt)
  write(lun,*) "   Units"
  write(lun,line_fmt)
  write(lun,*) "  h = ", h, " = H0[km/s/Mpc] / 100 "
  write(n1,'(ES20.6)') this%cgs_length
  write(lun,unit_fmt) "length [cm/h]:", trim(adjustl(n1)) 

  write(n1,'(ES20.6)') this%cgs_mass
  write(lun,unit_fmt) "mass [g/h]:", trim(adjustl(n1)) 

  write(n1,'(ES20.6)') this%cgs_velocity
  write(lun,unit_fmt) "velocity [cm/s]:", trim(adjustl(n1)) 

  write(n1,'(ES20.6)') this%cgs_density
  write(lun,unit_fmt) "density [g/cm^3 h^2]:", trim(adjustl(n1)) 

  write(n1,'(ES20.6)') this%cgs_energy
  write(lun,unit_fmt) "energy [erg/h]:", trim(adjustl(n1)) 

  write(n1,'(ES20.6)') this%cgs_time
  write(lun,unit_fmt) "time [s/h]:", trim(adjustl(n1)) 

  write(n1,'(ES20.6)') this%cgs_pressure
  write(lun,unit_fmt) "pressure [ba h^2]:", trim(adjustl(n1)) 

  write(lun,*) 

  write(n1,'(ES20.6)') rho_crit_0
  write(lun,unit_fmt) "rho_crit_0 [g/cm^3 h^2]:", trim(adjustl(n1))
  write(n1,'(ES20.6)') E8
  write(lun,unit_fmt) "E8 [erg/h]:", trim(adjustl(n1))

  write(lun,*)

  write(n1,'(ES20.6)') this%cgs_length / gconst%cm_per_mpc
  write(lun,unit_fmt) "length [Mpc/h]:", trim(adjustl(n1)) 

  write(n1,'(ES20.6)') this%cgs_mass / gconst%solar_mass
  write(lun,unit_fmt) "mass [Msolar/h]:", trim(adjustl(n1)) 

  write(n1,'(ES20.6)') this%cgs_velocity / cm_per_km
  write(lun,unit_fmt) "velocity [km/s]:", trim(adjustl(n1)) 

  write(n1,'(ES20.6)') this%cgs_density / rho_crit_0
  write(lun,unit_fmt) "density [rho_crit_0 h^2]:", trim(adjustl(n1)) 

  write(n1,'(ES20.6)') this%cgs_energy / E8
  write(lun,unit_fmt) "energy [E8]:", trim(adjustl(n1)) 

  write(n1,'(ES20.6)') this%cgs_time / gconst%sec_per_megayear
  write(lun,unit_fmt) "time [Myr/h]:", trim(adjustl(n1)) 

  write(n1,'(ES20.6)') this%cgs_pressure / gconst%boltzmann 
  write(lun,unit_fmt) "pressure/k_b [cm^-3 K h^2]:", trim(adjustl(n1)) 

  write(lun,star_fmt)

end subroutine gadget_units_print_lun


!> reads units from an open hdf5 file
!--------------------------------------------------------------
subroutine gadget_units_read_lun(this, fh)
  type(gadget_units_type), intent(out) :: this
  integer, intent(in) :: fh
  
#ifdef useHDF5
  call hdf5_read_attribute(fh, 'Units/UnitLength_in_cm', this%cgs_length)
  call hdf5_read_attribute(fh, 'Units/UnitMass_in_g', this%cgs_mass)
  call hdf5_read_attribute(fh, 'Units/UnitVelocity_in_cm_per_s', this%cgs_velocity)
  call hdf5_read_attribute(fh, 'Units/UnitDensity_in_cgs', this%cgs_density)
  call hdf5_read_attribute(fh, 'Units/UnitEnergy_in_cgs', this%cgs_energy)
  call hdf5_read_attribute(fh, 'Units/UnitPressure_in_cgs', this%cgs_pressure)
  call hdf5_read_attribute(fh, 'Units/UnitTime_in_s', this%cgs_time)
#else
  write(*,*) 'useHDF5 macro not defined in Makefile'
  stop
#endif
  
end subroutine gadget_units_read_lun


!> reads units from an hdf5 file
!--------------------------------------------------------------
subroutine gadget_units_read_file(this, snapfile)
  type(gadget_units_type), intent(out) :: this
  character(*), intent(in) :: snapfile
  integer :: fh
  
#ifdef useHDF5
  call hdf5_open_file( fh, snapfile, readonly=.true. )
  call gadget_units_read_lun(this, fh)
  call hdf5_close_file( fh )
#else
  write(*,*) 'useHDF5 macro not defined in Makefile'
  stop
#endif

end subroutine gadget_units_read_file


!> writes units to an open hdf5 file
!--------------------------------------------------------------
subroutine gadget_units_write_lun(this, fh)
  type(gadget_units_type), intent(in) :: this
  integer, intent(in) :: fh

#ifdef useHDF5
  call hdf5_write_attribute(fh, 'Units/UnitLength_in_cm', this%cgs_length)
  call hdf5_write_attribute(fh, 'Units/UnitMass_in_g', this%cgs_mass)
  call hdf5_write_attribute(fh, 'Units/UnitVelocity_in_cm_per_s', this%cgs_velocity)
  call hdf5_write_attribute(fh, 'Units/UnitDensity_in_cgs', this%cgs_density)
  call hdf5_write_attribute(fh, 'Units/UnitEnergy_in_cgs', this%cgs_energy)
  call hdf5_write_attribute(fh, 'Units/UnitPressure_in_cgs', this%cgs_pressure)
  call hdf5_write_attribute(fh, 'Units/UnitTime_in_s', this%cgs_time)
#endif

end subroutine gadget_units_write_lun


!> broadcasts units
!-----------------------------------------
subroutine gadget_units_broadcast( units )
  type(gadget_units_type) :: units
  integer :: count
  integer :: root
  integer :: ierr

#ifdef useMPI
  count = 7
  root = 0
  call mpi_bcast( units, count, mpi_double_precision, root, mpi_comm_world, ierr )
  if (ierr /= 0) then
     call mpi_barrier(mpi_comm_world, ierr)
     call mpi_finalize(ierr)
  endif
#else 
  write(*,*) 'useMPI macro not defined in Makefile'
  stop
#endif

end subroutine gadget_units_broadcast




!!============================================
!!
!!    CONSTANTS
!!
!!============================================


!> reads constants from an open hdf5 file
!--------------------------------------------------------------
subroutine gadget_constants_read_lun(this, fh)
  type(gadget_constants_type), intent(out) :: this
  integer, intent(in) :: fh
  
#ifdef useHDF5
  call hdf5_read_attribute(fh,'Constants/PI',this%pi)
  call hdf5_read_attribute(fh,'Constants/GAMMA',this%gamma)
  call hdf5_read_attribute(fh,'Constants/GRAVITY',this%gravity)
  call hdf5_read_attribute(fh,'Constants/SOLAR_MASS',this%solar_mass)
  call hdf5_read_attribute(fh,'Constants/SOLAR_LUM',this%solar_lum)
  call hdf5_read_attribute(fh,'Constants/RAD_CONST',this%rad_const)
  call hdf5_read_attribute(fh,'Constants/AVOGADRO',this%avogadro)
  call hdf5_read_attribute(fh,'Constants/BOLTZMANN',this%boltzmann)
  call hdf5_read_attribute(fh,'Constants/GAS_CONST',this%gas_const)
  call hdf5_read_attribute(fh,'Constants/C',this%c)
  call hdf5_read_attribute(fh,'Constants/PLANCK',this%planck)
  call hdf5_read_attribute(fh,'Constants/CM_PER_MPC',this%cm_per_mpc)
  call hdf5_read_attribute(fh,'Constants/PROTONMASS',this%protonmass)
  call hdf5_read_attribute(fh,'Constants/ELECTRONMASS',this%electronmass)
  call hdf5_read_attribute(fh,'Constants/ELECTRONCHARGE',this%electroncharge)
  call hdf5_read_attribute(fh,'Constants/HUBBLE',this%hubble)
  call hdf5_read_attribute(fh,'Constants/T_CMB0',this%t_cmb0)
  call hdf5_read_attribute(fh,'Constants/SEC_PER_MEGAYEAR',this%sec_per_megayear)
  call hdf5_read_attribute(fh,'Constants/SEC_PER_YEAR',this%sec_per_year)
  call hdf5_read_attribute(fh,'Constants/STEFAN',this%stefan)
  call hdf5_read_attribute(fh,'Constants/THOMPSON',this%thompson)
  call hdf5_read_attribute(fh,'Constants/EV_TO_ERG',this%ev_to_erg)
  call hdf5_read_attribute(fh,'Constants/Z_Solar',this%z_solar)
#else 
  write(*,*) 'useHDF5 macro not defined in Makefile' 
  stop
#endif  

end subroutine gadget_constants_read_lun

  
!> reads constants from an hdf5 file
!--------------------------------------------------------------
subroutine gadget_constants_read_file(this, snapfile)
  type(gadget_constants_type), intent(out) :: this
  character(*), intent(in) :: snapfile
  integer :: fh

#ifdef useHDF5
  call hdf5_open_file( fh, snapfile, readonly=.true. )
  call gadget_constants_read_lun(this, fh)
  call hdf5_close_file( fh )
#else 
  write(*,*) 'useHDF5 macro not defined in Makefile' 
  stop
#endif  

end subroutine gadget_constants_read_file


!> writes constants to an open hdf5 file
!--------------------------------------------------------------
subroutine gadget_constants_write_lun(this, fh)
  type(gadget_constants_type), intent(in) :: this
  integer, intent(in) :: fh

#ifdef useHDF5
  call hdf5_write_attribute(fh,'Constants/PI',this%pi)
  call hdf5_write_attribute(fh,'Constants/GAMMA',this%gamma)
  call hdf5_write_attribute(fh,'Constants/GRAVITY',this%gravity)
  call hdf5_write_attribute(fh,'Constants/SOLAR_MASS',this%solar_mass)
  call hdf5_write_attribute(fh,'Constants/SOLAR_LUM',this%solar_lum)
  call hdf5_write_attribute(fh,'Constants/RAD_CONST',this%rad_const)
  call hdf5_write_attribute(fh,'Constants/AVOGADRO',this%avogadro)
  call hdf5_write_attribute(fh,'Constants/BOLTZMANN',this%boltzmann)
  call hdf5_write_attribute(fh,'Constants/GAS_CONST',this%gas_const)
  call hdf5_write_attribute(fh,'Constants/C',this%c)
  call hdf5_write_attribute(fh,'Constants/PLANCK',this%planck)
  call hdf5_write_attribute(fh,'Constants/CM_PER_MPC',this%cm_per_mpc)
  call hdf5_write_attribute(fh,'Constants/PROTONMASS',this%protonmass)
  call hdf5_write_attribute(fh,'Constants/ELECTRONMASS',this%electronmass)
  call hdf5_write_attribute(fh,'Constants/ELECTRONCHARGE',this%electroncharge)
  call hdf5_write_attribute(fh,'Constants/HUBBLE',this%hubble)
  call hdf5_write_attribute(fh,'Constants/T_CMB0',this%t_cmb0)
  call hdf5_write_attribute(fh,'Constants/SEC_PER_MEGAYEAR',this%sec_per_megayear)
  call hdf5_write_attribute(fh,'Constants/SEC_PER_YEAR',this%sec_per_year)
  call hdf5_write_attribute(fh,'Constants/STEFAN',this%stefan)
  call hdf5_write_attribute(fh,'Constants/THOMPSON',this%thompson)
  call hdf5_write_attribute(fh,'Constants/EV_TO_ERG',this%ev_to_erg)
  call hdf5_write_attribute(fh,'Constants/Z_Solar',this%z_solar)
#else 
  write(*,*) 'useHDF5 macro not defined in Makefile' 
  stop
#endif

end subroutine gadget_constants_write_lun





!!============================================
!!
!!    DATA ATTRIBUTES
!!
!!============================================



!> writes data attributes to an hdf5 file  
!------------------------------------------------    
subroutine gadget_data_attributes_write_lun( attr, fh, grp_tag, dat_tag  )
  type(gadget_data_attributes_type) :: attr
  integer(i4b) :: fh
  character(*) :: grp_tag
  character(*) :: dat_tag

  character(clen) :: tag

#ifdef useHDF5

  tag = trim(grp_tag) // trim(dat_tag) // '/CGSConversionFactor'
  call hdf5_write_attribute( fh, tag, attr%CGSConversionFactor )

  tag = trim(grp_tag) // trim(dat_tag) // '/h-scale-exponent'
  call hdf5_write_attribute( fh, tag, attr%h_scale_exponent )

  tag = trim(grp_tag) // trim(dat_tag) // '/aexp-scale-exponent'
  call hdf5_write_attribute( fh, tag, attr%aexp_scale_exponent )

  tag = trim(grp_tag) // trim(dat_tag) // '/VarDescription'
  call hdf5_write_attribute( fh, tag, attr%VarDescription )

#else

  stop " *** called write_data_attr_lun w/o defining useHDF5 *** "

#endif

end subroutine gadget_data_attributes_write_lun



!> reads data attributes from an hdf5 file  
!------------------------------------------------    
subroutine gadget_data_attributes_read_lun( attr, fh, grp_tag, dat_tag  )
  type(gadget_data_attributes_type) :: attr
  integer(i4b) :: fh
  character(*) :: grp_tag
  character(*) :: dat_tag

  character(clen) :: tag

#ifdef useHDF5

  tag = trim(grp_tag) // trim(dat_tag) // '/CGSConversionFactor'
  call hdf5_read_attribute( fh, tag, attr%CGSConversionFactor )

  tag = trim(grp_tag) // trim(dat_tag) // '/h-scale-exponent'
  call hdf5_read_attribute( fh, tag, attr%h_scale_exponent )

  tag = trim(grp_tag) // trim(dat_tag) // '/aexp-scale-exponent'
  call hdf5_read_attribute( fh, tag, attr%aexp_scale_exponent )

  tag = trim(grp_tag) // trim(dat_tag) // '/VarDescription'
  call hdf5_read_attribute( fh, tag, attr%VarDescription )

#else

  stop " *** called read_data_attr_lun w/o defining useHDF5 *** "

#endif

end subroutine gadget_data_attributes_read_lun





!> sets data attributes using supplied units
!------------------------------------------------    
subroutine gadget_data_attributes_set(gunits)
  type(gadget_units_type), intent(in) :: gunits

  pos_attrs%CGSConversionFactor = gunits%cgs_length
  vel_attrs%CGSConversionFactor = gunits%cgs_velocity
  id_attrs%CGSConversionFactor = 1.0d0
  mass_attrs%CGSConversionFactor = gunits%cgs_mass
  T_attrs%CGSConversionFactor = 1.0d0
  rho_attrs%CGSConversionFactor = gunits%cgs_density
  ye_attrs%CGSConversionFactor = 1.0d0
  xHI_attrs%CGSConversionFactor = 1.0d0
  hsml_attrs%CGSConversionFactor = gunits%cgs_length
  lasthit_attrs%CGSConversionFactor = 1.0d0

  xHI_cloudy_attrs%CGSConversionFactor = 1.0d0
  Hmf_attrs%CGSConversionFactor = 1.0d0
  xHeI_attrs%CGSConversionFactor = 1.0d0
  xHeII_attrs%CGSConversionFactor = 1.0d0
  Hemf_attrs%CGSConversionFactor = 1.0d0
  gammaHI_attrs%CGSConversionFactor = 1.0d0
  eos_attrs%CGSConversionFactor = 1.0d0
  sfr_attrs%CGSConversionFactor = 1.0d0



  pos_attrs%VarDescription = "Co-moving coordinates. Physical: r = a x = Coordinates h^-1 a U_L [cm]"
  vel_attrs%VarDescription = "Co-moving velocities. Physical v_p = a dx/dt  = Velocities a^1/2 U_V [cm/s]"
  id_attrs%VarDescription = "Unique particle identifier"
  mass_attrs%VarDescription = "Particle mass. Physical m = Mass h^-1 U_M [g]"
  T_attrs%VarDescription = "Temperature [K]"
  rho_attrs%VarDescription = "Co-moving mass densities. Physical rho = Densities h^2 a^-3 U_M U_L^-3 [g/cm^3]"
  ye_attrs%VarDescription = "Electron abundance = n_e / n_H"
  xHI_attrs%VarDescription = "Hydrogen neutral fraction = n_HI / n_H"
  hsml_attrs%VarDescription = "Co-moving smoothing length. Physical h = SmoothingLength h^-1 a U_L [cm]"
  lasthit_attrs%VarDescription = "Index of last ray to cross this particle"

  xHI_cloudy_attrs%VarDescription = "Hydrogen neutral fraction from Cloudy Tables xHI = n_HI / n_H"
  Hmf_attrs%VarDescription = "Hydrogen mass fraction = mass in atomic Hydrogen / particle mass"
  xHeI_attrs%VarDescription = "Helium I fraction = n_HeI / n_He"
  xHeII_attrs%VarDescription = "Helium II fraction = n_HeII / n_He"
  Hemf_attrs%VarDescription = "Helium mass fraction = mass in atomic Helium / particle mass"
  gammaHI_attrs%VarDescription = "Hydrogen photoionization rate [1/s]"
  eos_attrs%VarDescription = "Flag for effective equation os state. 1 if currently on EoS" // &
       ", 0 if has never been on EoS, -ExpansionFactor if left the EoS at ExpansionFactor"
  sfr_attrs%VarDescription = "Star formation rate. Physical sfr = StarformationRate SOLAR_MASS SEC_PER_YEAR^-1 [g/s]"



  pos_attrs%h_scale_exponent = -1.0d0
  vel_attrs%h_scale_exponent = 0.0d0
  id_attrs%h_scale_exponent = 0.0d0
  mass_attrs%h_scale_exponent = -1.0d0
  T_attrs%h_scale_exponent = 0.0d0
  rho_attrs%h_scale_exponent = 2.0d0
  ye_attrs%h_scale_exponent = 0.0d0
  xHI_attrs%h_scale_exponent = 0.0d0
  hsml_attrs%h_scale_exponent = -1.0d0
  lasthit_attrs%h_scale_exponent = 0.0d0

  xHI_cloudy_attrs%h_scale_exponent = 0.0d0
  Hmf_attrs%h_scale_exponent = 0.0d0
  xHeI_attrs%h_scale_exponent = 0.0d0
  xHeII_attrs%h_scale_exponent = 0.0d0
  Hemf_attrs%h_scale_exponent = 0.0d0
  gammaHI_attrs%h_scale_exponent = 0.0d0
  eos_attrs%h_scale_exponent = 0.0d0
  sfr_attrs%h_scale_exponent = 0.0d0



  pos_attrs%aexp_scale_exponent = 1.0d0
  vel_attrs%aexp_scale_exponent = 0.5d0
  id_attrs%aexp_scale_exponent = 0.0d0
  mass_attrs%aexp_scale_exponent = 0.0d0
  T_attrs%aexp_scale_exponent = 0.0d0
  rho_attrs%aexp_scale_exponent = -3.0d0
  ye_attrs%aexp_scale_exponent = 0.0d0
  xHI_attrs%aexp_scale_exponent = 0.0d0
  hsml_attrs%aexp_scale_exponent = 1.0d0
  lasthit_attrs%aexp_scale_exponent = 0.0d0

  xHI_cloudy_attrs%aexp_scale_exponent = 0.0d0
  Hmf_attrs%aexp_scale_exponent = 0.0d0
  xHeI_attrs%aexp_scale_exponent = 0.0d0
  xHeII_attrs%aexp_scale_exponent = 0.0d0
  Hemf_attrs%aexp_scale_exponent = 0.0d0
  gammaHI_attrs%aexp_scale_exponent = 0.0d0
  eos_attrs%aexp_scale_exponent = 0.0d0
  sfr_attrs%aexp_scale_exponent = 0.0d0


end subroutine gadget_data_attributes_set











!> forms a snapshot file name from, path, base, SnapNum, and FileNum.
!! For example, path = "/home/galtay/data/snapshots", base = "snap",
!! SnapNum = 2 and FileNum = 15 would return in SnapFile, 
!! "/home/galtay/data/snapshots/snap_002.15".  Setting the hdf5bool to 
!! true appends ".hdf5" to the file. 
!------------------------------------------------------------------------
subroutine form_gadget_snapshot_file_name(path, base, SnapNum, FileNum, &
     SnapFile, hdf5bool)

  character(*), intent(in)     :: path        !< path to snapshot dir
  character(*), intent(in)     :: base        !< base snapshot name
  integer(i4b), intent(in)     :: SnapNum     !< snapshot number
  integer(i4b), intent(in)     :: FileNum     !< file number of snapshot
  character(clen), intent(out) :: SnapFile    !< snapshot filename
  logical, intent(in)          :: hdf5bool    !< hdf5 file? 

  character(clen) :: SnapFileTmp
  character(10) :: FileNumChar
  character(clen) :: fmt
  logical :: Fthere

  write(FileNumChar,"(I6)") FileNum
  fmt = "(A,'/',A,'_',I3.3)"

  ! first write a file with no extension
  !--------------------------------------
  write(SnapFileTmp,fmt) trim(path), trim(base), SnapNum
  SnapFile = trim(SnapFileTmp)
  if (hdf5bool) SnapFile = trim(SnapFile) // ".hdf5"
  inquire( file=SnapFile, exist=Fthere )


  ! if the file number is 0 and a file with no extension exists then return
  ! otherwise append the FileNum to the file name
  !-------------------------------------------------------------------------
  if (FileNum == 0 .and. Fthere) then
     return
  else
     SnapFile = trim(SnapFileTmp) // "." // trim(adjustl(FileNumChar))
     if (hdf5bool) SnapFile = trim(SnapFile) // ".hdf5"
  end if


end subroutine form_gadget_snapshot_file_name










end module gadget_general_class

!> \file mt19937.f90

!> A C-program for MT19937, with initialization improved 2002/1/26.
!! Coded by Takuji Nishimura and Makoto Matsumoto.
!! Code converted to Fortran 95 by Josi Rui Faustino de Sousa
!! Date: 2002-02-01
!! Before using, initialize the state by using init_genrand(seed)
!< or init_by_array(init_key, key_length).

! This library is free software.
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
! Copyright (C) 1997, 2002 Makoto Matsumoto and Takuji Nishimura.
! Any feedback is very welcome.
! http://www.math.keio.ac.jp/matumoto/emt.html
! email: matumoto@math.keio.ac.jp

module mt19937_mod

  implicit none

  intrinsic :: bit_size

  private
  public  :: init_mersenne_twister, init_by_array
  public  :: genrand_int32, genrand_int31
  public  :: genrand_real1, genrand_real2, genrand_real3, genrand_res53

  integer,  parameter  :: intg = selected_int_kind( 9 )  !< 4 byte integer
  integer,  parameter  :: long = selected_int_kind( 18 ) !< 8 byte integer
  integer,  parameter  :: flot = selected_real_kind( 6, 37 ) !< 4 byte real
  integer,  parameter  :: dobl = selected_real_kind( 15, 307 )  !< 8 byte real


  integer, parameter :: wl = long  !< wl type
!  integer, parameter :: wi = intg  !< wi type
  integer, parameter :: wi = wl  !< wi type
  integer, parameter :: wr = dobl  !< wr type

  ! Period parameters
  integer( kind = wi ), parameter :: n = 624_wi  !< length of state vector
  integer( kind = wi ), parameter :: m = 397_wi  !< m
  integer( kind = wi ), parameter :: hbs = bit_size( n ) / 2_wi !< bitsize(n)/2
  integer( kind = wi ), parameter :: qbs = hbs / 2_wi           !< bitsize(n)/4
  integer( kind = wi ), parameter :: tbs = 3_wi * qbs    !< bitsize(n)*3/4

  integer( kind = wi )  :: mt(n)               !< array for the state vector
  logical( kind = wi )  :: mtinit = .false._wi !< means mt[N] initialized ?
  integer( kind = wi )  :: mti = n + 1_wi      !< length of state vector + 1

  contains

  !> bit based add
  function uiadd( a, b ) result(c)

    implicit none

    intrinsic :: ibits, ior, ishft

    integer( kind = wi ), intent( in )  :: a !< first thing in sum 
    integer( kind = wi ), intent( in )  :: b !< second thing in sum

    integer( kind = wi )  :: c !< sum

    integer( kind = wi )  :: a1, a2, b1, b2, s1, s2

    a1 = ibits( a, 0, hbs )
    a2 = ibits( a, hbs, hbs )
    b1 = ibits( b, 0, hbs )
    b2 = ibits( b, hbs, hbs )
    s1 = a1 + b1
    s2 = a2 + b2 + ibits( s1, hbs, hbs )
    c  = ior( ishft( s2, hbs ), ibits( s1, 0, hbs ) )

  end function uiadd

  !> bit based subtraction
  function uisub( a, b ) result( c )

    implicit none

    intrinsic :: ibits, ior, ishft

    integer( kind = wi ), intent( in )  :: a !< first thing in difference
    integer( kind = wi ), intent( in )  :: b !< first thing in difference

    integer( kind = wi )  :: c  !< difference

    integer( kind = wi )  :: a1, a2, b1, b2, s1, s2

    a1 = ibits( a, 0, hbs )
    a2 = ibits( a, hbs, hbs )
    b1 = ibits( b, 0, hbs )
    b2 = ibits( b, hbs, hbs )
    s1 = a1 - b1
    s2 = a2 - b2 + ibits( s1, hbs, hbs )
    c  = ior( ishft( s2, hbs ), ibits( s1, 0, hbs ) )

  end function uisub

  !> bit based multiply
  function uimlt( a, b ) result( c )

    implicit none

    intrinsic :: ibits, ior, ishft

    integer( kind = wi ), intent( in )  :: a !< first thing in product
    integer( kind = wi ), intent( in )  :: b !< second thing in product

    integer( kind = wi )  :: c  !< product

    integer( kind = wi )  :: a0, a1, a2, a3
    integer( kind = wi )  :: b0, b1, b2, b3
    integer( kind = wi )  :: p0, p1, p2, p3

    a0 = ibits( a, 0, qbs )
    a1 = ibits( a, qbs, qbs )
    a2 = ibits( a, hbs, qbs )
    a3 = ibits( a, tbs, qbs )
    b0 = ibits( b, 0, qbs )
    b1 = ibits( b, qbs, qbs )
    b2 = ibits( b, hbs, qbs )
    b3 = ibits( b, tbs, qbs )
    p0 = a0 * b0
    p1 = a1 * b0 + a0 * b1 + ibits( p0, qbs, tbs )
    p2 = a2 * b0 + a1 * b1 + a0 * b2 + ibits( p1, qbs, tbs )
    p3 = a3 * b0 + a2 * b1 + a1 * b2 + a0 * b3 + ibits( p2, qbs, tbs )
    c  = ior( ishft( p1, qbs ), ibits( p0, 0, qbs ) )
    c  = ior( ishft( p2, hbs ), ibits( c, 0, hbs ) )
    c  = ior( ishft( p3, tbs ), ibits( c, 0, tbs ) )

  end function uimlt

  !> initializes mt[N] with a seed
  subroutine init_mersenne_twister( s )

    implicit none

    intrinsic :: iand, ishft, ieor, ibits

    integer( kind = wl ), intent( in )  :: s !< scalar integer seed

    integer( kind = wi )  :: i, mult_a

    data mult_a /z'6C078965'/

    mtinit = .true._wi
    mt(1) = ibits( s, 0, 32 )
    do i = 2, n, 1
      mt(i) = ieor( mt(i-1), ishft( mt(i-1), -30 ) )
      mt(i) = uimlt( mt(i), mult_a )
      mt(i) = uiadd( mt(i), uisub( i, 1_wi ) )
      ! See Knuth TAOCP Vol2. 3rd Ed. P.106 for multiplier.
      ! In the previous versions, MSBs of the seed affect
      ! only MSBs of the array mt[].
      ! 2002/01/09 modified by Makoto Matsumoto
      mt(i) = ibits( mt(i), 0, 32 )
      ! for >32 bit machines
    end do

  end subroutine init_mersenne_twister

  !> initialize by an array with array-length
  !! init_key is the array for initializing keys
  !! key_length is its length
  subroutine init_by_array( init_key )

    implicit none

    intrinsic :: iand, ishft, ieor

    integer( kind = wi ), intent( in )  :: init_key(:) !< array integer seed

    integer( kind = wi )  :: i, j, k, tp, key_length
    integer( kind = wi )  :: mult_a, mult_b, msb1_d

    integer( kind = wl ) :: seed_d

    data seed_d /z'12BD6AA'/
    data mult_a /z'19660D'/
    data mult_b /z'5D588B65'/
    data msb1_d /z'80000000'/

    key_length = size( init_key, dim = 1 )
    call init_mersenne_twister( seed_d )
    i = 2_wi
    j = 1_wi
    do k = max( n, key_length ), 1, -1
       tp = ieor( mt(i-1), ishft( mt(i-1), -30 ) )
       tp = uimlt( tp, mult_a )
       mt(i) = ieor( mt(i), tp )
       mt(i) = uiadd( mt(i), uiadd( init_key(j), uisub( j, 1_wi ) ) )!nonlinear
       mt(i) = ibits( mt(i), 0, 32 ) ! for WORDSIZE > 32 machines
       i = i + 1_wi
       j = j + 1_wi
       if ( i > n ) then
          mt(1) = mt(n)
          i = 2_wi
       end if
       if ( j > key_length) j = 1_wi
    end do
    do k = n-1, 1, -1
       tp = ieor( mt(i-1), ishft( mt(i-1), -30 ) )
       tp = uimlt( tp, mult_b )
       mt(i) = ieor( mt(i), tp )
       mt(i) = uisub( mt(i), uisub( i, 1_wi ) ) ! non linear
       mt(i) = ibits( mt(i), 0, 32 ) ! for WORDSIZE > 32 machines
       i = i + 1_wi
       if ( i > n ) then
          mt(1) = mt(n)
          i = 2_wi
       end if
    end do
    mt(1) = msb1_d ! MSB is 1 assuring non-zero initial array
  end subroutine init_by_array

  !> generates a random number on [0,0xffffffff]-interval
  function genrand_int32( ) result( y )

    implicit none

    intrinsic :: iand, ishft, ior, ieor, btest, ibset, mvbits

!    real :: x !< x
    integer( kind = wi )  :: y !< random number

    integer( kind = wi )  :: kk
    integer( kind = wi )  :: matrix_a, matrix_b, temper_a, temper_b
    integer( kind = wl )  :: seed_d

    data seed_d   /z'5489'/
    data matrix_a /z'9908B0DF'/
    data matrix_b /z'0'/
    data temper_a /z'9D2C5680'/
    data temper_b /z'EFC60000'/

    if ( mti > n ) then ! generate N words at one time
      if ( .not. mtinit ) call init_mersenne_twister( seed_d ) 
! if init_genrand() has not been called, a default initial seed is used
      do kk = 1, n-m, 1
         y = ibits( mt(kk+1), 0, 31 )
         call mvbits( mt(kk), 31, 1, y, 31 )
         if ( btest( y, 0 ) ) then
            mt(kk) = ieor( ieor( mt(kk+m), ishft( y, -1 ) ), matrix_a )
         else
            mt(kk) = ieor( ieor( mt(kk+m), ishft( y, -1 ) ), matrix_b )
         end if
      end do
      do kk = n-m+1, n-1, 1
         y = ibits( mt(kk+1), 0, 31 )
         call mvbits( mt(kk), 31, 1, y, 31 )
         if ( btest( y, 0 ) ) then
            mt(kk) = ieor( ieor( mt(kk+m-n), ishft( y, -1 ) ), matrix_a )
         else
            mt(kk) = ieor( ieor( mt(kk+m-n), ishft( y, -1 ) ), matrix_b )
         end if
      end do
      y = ibits( mt(1), 0, 31 )
      call mvbits( mt(n), 31, 1, y, 31 )
      if ( btest( y, 0 ) ) then
         mt(kk) = ieor( ieor( mt(m), ishft( y, -1 ) ), matrix_a )
      else
         mt(kk) = ieor( ieor( mt(m), ishft( y, -1 ) ), matrix_b )
      end if
      mti = 1_wi
   end if
   y = mt(mti)
   mti = mti + 1_wi
   ! Tempering
   y = ieor( y, ishft( y, -11) )
   y = ieor( y, iand( ishft( y, 7 ), temper_a ) )
   y = ieor( y, iand( ishft( y, 15 ), temper_b ) )
   y = ieor( y, ishft( y, -18 ) )

  end function genrand_int32

  !> generates a random number on [0,0x7fffffff]-interval
  function genrand_int31( ) result(i)

    implicit none

    intrinsic :: ishft

    integer( kind = wi )  :: i  !< random number

    i = ishft( genrand_int32( ), -1 )

  end function genrand_int31

  !> generates a random number on [0,1]-real-interval
  function genrand_real1( ) result( r )

    implicit none

    real( kind = wr )  :: r !< real number [0.0,1.0]

    integer( kind = wi )  :: a, a1, a0

    a = genrand_int32( )
    a0 = ibits( a, 0, hbs )
    a1 = ibits( a, hbs, hbs )
    r = real( a0, kind = wr ) / 4294967295.0_wr
    r = real( a1, kind = wr ) * ( 65536.0_wr / 4294967295.0_wr ) + r
    ! divided by 2^32-1

  end function genrand_real1

  !> generates a random number on [0,1)-real-interval
  function genrand_real2( ) result( r )

    implicit none

    intrinsic :: ibits

    real( kind = wr )  :: r  !< real number [0.0,1.0)

    integer( kind = wi )  :: a, a1, a0

    a = genrand_int32( )
    a0 = ibits( a, 0, hbs )
    a1 = ibits( a, hbs, hbs )
    r = real( a0, kind = wr ) / 4294967296.0_wr
    r = real( a1, kind = wr ) / 65536.0_wr + r
    ! divided by 2^32

  end function genrand_real2

  !> generates a random number on (0,1)-real-interval
  function genrand_real3( ) result( r )

    implicit none

    real( kind = wr )  :: r  !< real number (0.0,1.0)

    integer( kind = wi )  :: a, a1, a0

    a = genrand_int32( )
    a0 = ibits( a, 0, hbs )
    a1 = ibits( a, hbs, hbs )
    r = ( real( a0, kind = wr ) + 0.5_wr ) / 4294967296.0_wr
    r = real( a1, kind = wr ) / 65536.0_wr + r
    ! divided by 2^32

  end function genrand_real3

  !> generates a random number on [0,1) with 53-bit resolution
  function genrand_res53( )  result( r )

    implicit none

    intrinsic :: ishft

    real( kind = wr )  :: r  !< real number [0.0,1.0) 53-bit resolution

    integer( kind = wi )  :: a, a0, a1
    integer( kind = wi )  :: b, b0, b1

    a = ishft( genrand_int32( ), -5 )
    a0 = ibits( a, 0, hbs )
    a1 = ibits( a, hbs, hbs )
    b = ishft( genrand_int32( ), -6 )
    b0 = ibits( b, 0, hbs )
    b1 = ibits( b, hbs, hbs )
    r = real( a1, kind = wr ) / 2048.0_wr
    r = real( a0, kind = wr ) / 134217728.0_wr + r
    r = real( b1, kind = wr ) / 137438953472.0_wr + r
    r = real( b0, kind = wr ) / 9007199254740992.0_wr + r

  end function genrand_res53
  ! These real versions are due to Isaku Wada, 2002/01/09 added

end module mt19937_mod

!> \file hummer_atomic_rates.F90

!> \brief Module that stores the rate table from  
!! http://adsabs.harvard.edu/abs/1994MNRAS.268..109H
!<
module hummer_atomic_rates_mod
use myf03_mod
implicit none
private

public :: Hum_HII_recombA, Hum_HII_recombB
public :: Hum_HII_recomb_coolA, Hum_HII_recomb_coolB

real(r8b), parameter :: k_erg_K = 1.3806d-16    !< Boltzman's (erg/K)

real(r8b), parameter :: logTmin = 1.0d0
real(r8b), parameter :: logTmax = 7.0d0

real(r8b), parameter :: Tmin = 10.0d0**(int(logTmin))
real(r8b), parameter :: Tmax = 10.0d0**(int(logTmax))

real(r8b), parameter :: dlogT = 0.2d0
integer(i8b), parameter :: Ntable = 31

real(r8b), parameter :: LogTemp_table(Ntable) =              &
  (/                                                         &
  1.0d0, 1.2d0, 1.4d0, 1.6d0, 1.8d0,      &
  2.0d0, 2.2d0, 2.4d0, 2.6d0, 2.8d0,      &
  3.0d0, 3.2d0, 3.4d0, 3.6d0, 3.8d0,      &
  4.0d0, 4.2d0, 4.4d0, 4.6d0, 4.8d0,      &
  5.0d0, 5.2d0, 5.4d0, 5.6d0, 5.8d0,      &
  6.0d0, 6.2d0, 6.4d0, 6.6d0, 6.8d0,      &
  7.0d0 /)

real(r8b), parameter :: HIIrc1_table(Ntable) =               &
  (/                                                         &
  1.646d-11, 1.646d-11, 1.646d-11, 1.646d-11, 1.646d-11,     &
  1.646d-11, 1.645d-11, 1.645d-11, 1.644d-11, 1.642d-11,     &
  1.640d-11, 1.636d-11, 1.629d-11, 1.620d-11, 1.605d-11,     &
  1.582d-11, 1.548d-11, 1.499d-11, 1.431d-11, 1.341d-11,     &
  1.227d-11, 1.093d-11, 9.454d-12, 7.920d-12, 6.427d-12,     &
  5.058d-12, 3.866d-12, 2.877d-12, 2.089d-12, 1.485d-12,     &
  1.036d-12 /)


real(r8b), parameter :: HIIrcB_table(Ntable) =                &  
  (/                                                          &
  9.283d-11,  8.823d-11,  8.361d-11,  7.898d-11,  7.435d-11,  &
  6.973d-11,  6.512d-11,  6.054d-11,  5.599d-11,  5.147d-11,  &
  4.700d-11,  4.258d-11,  3.823d-11,  3.397d-11,  2.983d-11,  &
  2.584d-11,  2.204d-11,  1.847d-11,  1.520d-11,  1.226d-11,  &
  9.696d-12,  7.514d-12,  5.710d-12,  4.257d-12,  3.117d-12,  &
  2.244d-12,  1.590d-12,  1.110d-12,  7.642d-13,  5.199d-13,  &
  3.498d-13  /)      

real(r8b), parameter :: HIIrcA_table(Ntable) = HIIrc1_table + HIIrcB_table


real(r8b), parameter :: HIIrcc1_table(Ntable) =               &
  (/                                                          &
  1.646d-11,  1.646d-11,  1.646d-11,  1.646d-11,  1.646d-11,  &
  1.645d-11,  1.644d-11,  1.643d-11,  1.641d-11,  1.638d-11,  &
  1.633d-11,  1.625d-11,  1.613d-11,  1.594d-11,  1.565d-11,  &
  1.522d-11,  1.460d-11,  1.374d-11,  1.260d-11,  1.119d-11,  &
  9.571d-12,  7.844d-12,  6.146d-12,  4.601d-12,  3.295d-12,  &
  2.262d-12,  1.494d-12,  9.520d-13,  5.878d-13,  3.528d-13,  &
  2.066d-13   /)

real(r8b), parameter :: HIIrccB_table(Ntable) =               &
  (/                                                          &
  8.287d-11,  7.821d-11,  7.356d-11,  6.892d-11,  6.430d-11,  &
  5.971d-11,  5.515d-11,  5.062d-11,  4.614d-11,  4.170d-11,  &
  3.734d-11,  3.306d-11,  2.888d-11,  2.484d-11,  2.098d-11,  &
  1.736d-11,  1.402d-11,  1.103d-11,  8.442d-12,  6.279d-12,  &
  4.539d-12,  3.192d-12,  2.185d-12,  1.458d-12,  9.484d-13,  &
  6.023d-13,  3.738d-13,  2.268d-13,  1.348d-13,  7.859d-14,  &
  4.499d-14 /)

real(r8b), parameter :: HIIrccA_table(Ntable) = HIIrcc1_table + HIIrccB_table

contains

!---------------------------------------
!> HII recombination case A [cm^3 s^-1] 
    function Hum_HII_recombA(T) result(rate)
        real(r8b)  :: T    !< temperature [K]
        real(r8b)  :: rate !< rate

        real(r8b) :: Tnum, Tremain, rdif
        integer(i8b) :: Tindx

        
        if (T < Tmin) stop "T < Tmin in hummer_atomic_rates_mod.f90"
    
        Tnum = ( log10(T) - logTmin ) / dlogT
        Tindx = ceiling(Tnum)
    
        if (Tindx == 0) then
           Tindx = 1
           Tremain = 0.0d0
        end if
        Tremain = Tnum - (Tindx-1)
    
        if(Tindx < 1)        stop "Tindx < 1 in hummer_atomic_rates_mod.f90 "
        if(Tindx > Ntable-1) stop "Tindx > Ntable-1 in hummer_atomic_rates_mod.f90 "

        rdif = (HIIrcA_table(Tindx+1) - HIIrcA_table(Tindx)) * Tremain
        rate = (HIIrcA_table(Tindx) + rdif) / sqrt(T)

    end function Hum_HII_recombA


!---------------------------------------
!> HII recombination case B [cm^3 s^-1] 
    function Hum_HII_recombB(T) result(rate)
        real(r8b)  :: T    !< temperature [K]
        real(r8b)  :: rate !< rate

        real(r8b) :: Tnum, Tremain, rdif
        integer(i8b) :: Tindx

        
        if (T < Tmin) stop "T < Tmin in hummer_atomic_rates_mod.f90"
    
        Tnum = ( log10(T) - logTmin ) / dlogT
        Tindx = ceiling(Tnum)
    
        if (Tindx == 0) then
           Tindx = 1
           Tremain = 0.0d0
        end if
        Tremain = Tnum - (Tindx-1)
    
        if(Tindx < 1)        stop "Tindx < 1 in hummer_atomic_rates_mod.f90 "
        if(Tindx > Ntable-1) stop "Tindx > Ntable-1 in hummer_atomic_rates_mod.f90 "

        rdif = (HIIrcB_table(Tindx+1) - HIIrcB_table(Tindx)) * Tremain
        rate = (HIIrcB_table(Tindx) + rdif) / sqrt(T)

    end function Hum_HII_recombB


!---------------------------------------
!> HII recombination cool case A [cm^3 s^-1] 
    function Hum_HII_recomb_coolA(T) result(rate)
        real(r8b)  :: T    !< temperature [K]
        real(r8b)  :: rate !< rate

        real(r8b) :: Tnum, Tremain, rdif
        integer(i8b) :: Tindx

        
        if (T < Tmin) stop "T < Tmin in hummer_atomic_rates_mod.f90"
    
        Tnum = ( log10(T) - logTmin ) / dlogT
        Tindx = ceiling(Tnum)
    
        if (Tindx == 0) then
           Tindx = 1
           Tremain = 0.0d0
        end if
        Tremain = Tnum - (Tindx-1)
    
        if(Tindx < 1)        stop "Tindx < 1 in hummer_atomic_rates_mod.f90 "
        if(Tindx > Ntable-1) stop "Tindx > Ntable-1 in hummer_atomic_rates_mod.f90 "

        rdif = (HIIrccA_table(Tindx+1) - HIIrccA_table(Tindx)) * Tremain
        rate = (HIIrccA_table(Tindx) + rdif) * sqrt(T) * k_erg_K

    end function Hum_HII_recomb_coolA


!---------------------------------------
!> HII recombination cool case B [cm^3 s^-1] 
    function Hum_HII_recomb_coolB(T) result(rate)
        real(r8b)  :: T    !< temperature [K]
        real(r8b)  :: rate !< rate

        real(r8b) :: Tnum, Tremain, rdif
        integer(i8b) :: Tindx

        
        if (T < Tmin) stop "T < Tmin in hummer_atomic_rates_mod.f90"
    
        Tnum = ( log10(T) - logTmin ) / dlogT
        Tindx = ceiling(Tnum)
    
        if (Tindx == 0) then
           Tindx = 1
           Tremain = 0.0d0
        end if
        Tremain = Tnum - (Tindx-1)
    
        if(Tindx < 1)        stop "Tindx < 1 in hummer_atomic_rates_mod.f90 "
        if(Tindx > Ntable-1) stop "Tindx > Ntable-1 in hummer_atomic_rates_mod.f90 "

        rdif = (HIIrccB_table(Tindx+1) - HIIrccB_table(Tindx)) * Tremain
        rate = (HIIrccB_table(Tindx) + rdif) * sqrt(T) * k_erg_K 

    end function Hum_HII_recomb_coolB

end module hummer_atomic_rates_mod
